# @(#)bsc.mk	6.6

LIBNAME = 	../lib7
INCRT =		..
#CFLAGS = 	-O -DKERNEL -DBSC_DEBUG
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(bsc.o) \
	$(LIBNAME)(bscm.o) \
	$(LIBNAME)(bscpsm.o) \
	$(LIBNAME)(bscll.o) \
	$(LIBNAME)(bsctr.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp bsc.mk bsc.mk.bak
	@ed - bsc.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(bsc.o): \
	$(INCRT)/sys/bsc/local.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h \
	$(INCRT)/sys/bsc/bscdebug.h 

$(LIBNAME)(bscm.o): \
	$(INCRT)/sys/bsc/local.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h \
	$(INCRT)/sys/bsc/bscdebug.h 

$(LIBNAME)(bscpsm.o): \
	$(INCRT)/sys/bsc/local.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h \
	$(INCRT)/sys/bsc/bscdebug.h 

$(LIBNAME)(bscll.o): \
	$(INCRT)/sys/bsc/local.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h \
	$(INCRT)/sys/bsc/bscdebug.h 

$(LIBNAME)(bsctr.o): \
	$(INCRT)/sys/bsc/local.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h \
	$(INCRT)/sys/bsc/bsctr.h 
