/*	conf.c	6.1	83/07/29	*/

#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/buf.h"
#include "../sys/tty.h"
#include "../sys/conf.h"
#include "../cf/config.h"

int	nulldev();
int	nodev();


/*
 * First, block devices.
 */

#if NUD > 0
int	udopen(),
	dstrategy(),
	udread(),
	udwrite(),
	uddump(),
	udioctl(),
	udsize();
#else
#define	udopen		nodev
#define	udstrategy	nodev
#define	udread		nodev
#define	udwrite		nodev
#define	uddump		nodev
#define	udioctl		nodev
#define	udsize		0
#endif


#if NHD > 0
int	hdopen(),
	hdstrategy(),
	hdread(),
	hdwrite(),
  	hdioctl(),
	hddump(),
	hdsize();
#else
#define	hdopen		nodev
#define	hdstrategy	nodev
#define	hdread		nodev
#define	hdwrite		nodev
#define	hdioctl		nodev
#define	hddump		nodev
#define	hdsize		0
#endif


#if NVD > 0
int	vdopen(),
	vdstrategy(),
	vdread(),
	vdwrite(),
  	vdioctl(),
	vddump(),
	vdsize();
#else
#define	vdopen		nodev
#define	vdstrategy	nodev
#define	vdread		nodev
#define	vdwrite		nodev
#define	vdioctl		nodev
#define	vddump		nodev
#define	vdsize		0
#endif


#if NXP > 0
int	xpopen(),
	xpstrategy(),
	xpread(),
	xpwrite(),
	xpdump(),
	xpioctl(),
	xpsize();
#else
#define	xpopen		nodev
#define	xpstrategy	nodev
#define	xpread		nodev
#define	xpwrite		nodev
#define	xpdump		nodev
#define	xpioctl		nodev
#define	xpsize		0
#endif


#if NCY > 0
int	cyopen(),
	cyclose(),
	cystrategy(),
	cyread(),
	cywrite(),
	cydump(),
	cyioctl(),
	cyreset();
#else
#define	cyopen		nodev
#define	cyclose		nodev
#define	cystrategy	nodev
#define	cyread		nodev
#define	cywrite		nodev
#define	cydump		nodev
#define	cyioctl		nodev
#define	cyreset		nulldev
#endif


#if NXY > 0
int	xyopen(),
	xyclose(),
	xystrategy(),
	xyread(),
	xywrite(),
	xydump(),
	xyioctl(),
	xyreset();
#else
#define	xyopen		nodev
#define	xyclose		nodev
#define	xystrategy	nodev
#define	xyread		nodev
#define	xywrite		nodev
#define	xydump		nodev
#define	xyioctl		nodev
#define	xyreset		nulldev
#endif



int	swstrategy(),
	swread(),
	swwrite();


struct bdevsw	bdevsw[] = {
	{ udopen, nulldev, udstrategy, uddump, udsize, 0 },		/* 0 */
	{ vdopen, nulldev, vdstrategy, vddump, vdsize, 0 },		/* 1 */
	{ xpopen, nulldev, xpstrategy, xpdump, xpsize, 0 },		/* 2 */
	{ cyopen, cyclose, cystrategy, cydump, 0,      B_TAPE },	/* 3 */
#define SWAPMAJORNUM 4
	{ nodev,  nodev,   swstrategy, nodev,  0,      0 },		/* 4 */
	{ xyopen, xyclose, xystrategy, xydump, 0,      B_TAPE },	/* 5 */
	{ hdopen, nulldev, hdstrategy, hddump, hdsize, 0 },		/* 6 */
};
int	nblkdev = sizeof (bdevsw) / sizeof (bdevsw[0]);


/*
 * Now, character devices.
 */

#if NVX > 0
int	vxopen(),
	vxclose(),
	vxread(),
	vxwrite(),
	vxioctl(),
	vxstop(),
	vxreset();
struct	tty vx_tty[];
#else
#define	vxopen	nodev
#define	vxclose	nodev
#define	vxread	nodev
#define	vxwrite	nodev
#define	vxioctl	nodev
#define	vxstop	nodev
#define	vxreset	nulldev
#define	vx_tty	0
#endif


#if NPTY > 0
int	ptsopen(),
	ptsclose(),
	ptsread(),
	ptswrite(),
	ptsstop();
int	ptcopen(),
	ptcclose(),
	ptcread(),
	ptcwrite(),
	ptcselect();
int	ptyioctl();
struct	tty pt_tty[];
#else
#define ptsopen		nodev
#define ptsclose	nodev
#define ptsread		nodev
#define ptswrite	nodev
#define	ptsstop		nulldev
#define ptcopen		nodev
#define ptcclose	nodev
#define ptcread		nodev
#define ptcwrite	nodev
#define	ptcselect	nodev
#define ptyioctl	nodev
#define	pt_tty		0
#endif


#if NSXT > 0
int 	sxtopen(),
	sxtclose(),
	sxtread(), 
	sxtwrite(),
	sxtioctl();
#else
#define sxtopen		nodev
#define sxtclose	nodev
#define sxtread		nodev
#define sxtwrite	nodev
#define sxtioctl	nodev
#endif

int	cnopen(),
	cnclose(),
	cnread(),
	cnwrite(),
	cnioctl();
struct tty cons[];


int	prfread(),
	prfwrite(),
	prfioctl();

int 	erropen(),
	errclose(),
	errread();

int	ttselect(),
	seltrue();


int	syopen(),
	syread(),
	sywrite(),
	syioctl(),
	syselect();


int 	mmread(),
	mmwrite();
#define	mmselect	seltrue


#if NVBSC > 0
int	bscopen(), bscclose(), bscread(), bscwrite(), bscioctl();
int	bsmopen(),bsmclose(),bsmread(),bsmwrite(),bsmioctl();
int	bstopen(),bstclose(),bstread(),bstioctl();
#else
#define bscopen		nodev
#define bscclose	nodev
#define bscread		nodev
#define bscwrite	nodev
#define bscioctl	nodev
#define bsmopen		nodev
#define bsmclose	nodev
#define bsmread		nodev
#define bsmwrite	nodev
#define bsmioctl	nodev
#define bstopen		nodev
#define bstclose	nodev
#define bstread		nodev
#define bstwrite	nodev
#define bstioctl	nodev
#endif

struct cdevsw	cdevsw[] = {
	cnopen,		cnclose,	cnread,		cnwrite,	/*0*/
	cnioctl,	nulldev,	cons,
	ttselect,	nodev,
	vxopen,		vxclose,	vxread,		vxwrite,	/*1*/
	vxioctl,	vxreset,	vx_tty,
	ttselect,	nodev,
	syopen,		nulldev,	syread,		sywrite,	/*2*/
	syioctl,	nulldev,	0,
	syselect,	nodev,
	nulldev,	nulldev,	mmread,		mmwrite,	/*3*/
	nodev,		nulldev,	0,
	mmselect,	nodev,
	udopen,		nulldev,	udread,		udwrite,	/*4*/
	udioctl,	nulldev,	0,
	seltrue,	nodev,
	vdopen,		nulldev,	vdread,		vdwrite,	/*5*/
  	vdioctl,	nulldev,	0,
	seltrue,	nodev,
	xpopen,		nulldev,	xpread,		xpwrite,	/*6*/
	xpioctl,	nulldev,	0,
	seltrue,	nodev,
	cyopen,		cyclose,	cyread,		cywrite,	/*7*/
	cyioctl,	cyreset,	0,
	seltrue,	nodev,
	nulldev,	nulldev,	swread,		swwrite,	/*8*/
	nodev,		nulldev,	0,
	nodev,		nodev,
	ptsopen,	ptsclose,	ptsread,	ptswrite,	/*9*/
	ptyioctl,	nodev,		0,
	ttselect,	nodev,
	ptcopen,	ptcclose,	ptcread,	ptcwrite,	/*10*/
	ptyioctl,	nodev,		0,
	ptcselect,	nodev,
      	sxtopen,	sxtclose,	sxtread,	sxtwrite,	/*11*/
	sxtioctl,	nodev,		0,
	nodev,		nodev,
	nulldev,	nulldev,	prfread,	prfwrite,	/*12*/
	prfioctl,	nulldev,	0,
	seltrue, 	nodev,
	bscopen,	bscclose,	bscread,	bscwrite,	/*13*/
	bscioctl,	nulldev,	0,
	nodev,		nodev,
	bsmopen,	bsmclose,	bsmread,	bsmwrite,	/*14*/
	bsmioctl,	nulldev,	0,
	nodev,		nodev,
	bstopen,	bstclose,	bstread,	nodev,		/*15*/
	bstioctl,	nulldev,	0,
	nodev,		nodev,
	erropen,	errclose,	errread,	nodev,		/*16*/
	nodev,		nulldev,	0,
	seltrue, 	nodev,
	xyopen,		xyclose,	xyread,		xywrite,	/*17*/
	xyioctl,	xyreset,	0, 
	nodev,		nodev,
	hdopen,		nulldev,	hdread,		hdwrite,	/*18*/
  	hdioctl,	nulldev,	0,
	seltrue,	nodev,
};

int	nchrdev = sizeof (cdevsw) / sizeof (cdevsw[0]);
int	mem_no = 3; 	/* major device number of memory special file */

/*
 * Swapdev is a fake device implemented
 * in sw.c used only internally to get to swstrategy.
 * It cannot be provided to the users, because the
 * swstrategy routine munches the b_dev and b_blkno entries
 * before calling the appropriate driver.  This would horribly
 * confuse, e.g. the hashing routines. Instead, /dev/drum is
 * provided as a character (raw) device.
 */
dev_t	swapdev = makedev(SWAPMAJORNUM, 0);
