
/*
 * Defines for Message Limits
 */

#define MSGMAP		100		/* # of entries in msg map */
#define MSGMAX		8192		/* max message size */
#define MSGMNB		16384		/* max # bytes on queue */
#define MSGMNI		50		/* # of message queue identifiers */
#define MSGSSZ		8		/* msg segment size (word multiple) */
#define MSGTQL		40		/* # of system message headers */
#define MSGSEG		1024		/* # of msg segments (MUST BE < 32768)*/

#define MSGMAPPTE	1024		/* # of pages for message buffer */
					/* MUST BE >= clrnd(btoc(MSGSEG*MSGSSZ)) */

/*
 * Defines for Semaphore Limits
 */

#define SEMMAP	10		/* # of entries in semaphore map */
#define SEMMNI 	10		/* # of semaphore identifiers */
#define SEMMNS	60		/* # of semaphores in system */
#define SEMMNU	30		/* # of undo structures in system */
#define SEMMSL	25		/* max # of semaphores per id */
#define SEMOPM	10		/* max # of operations per semop call */
#define SEMUME	10		/* max # of undo entries per process */
#define SEMVMX	32767		/* semaphore maximum value */
#define SEMAEM	16384		/* adjust on exit max value */

/* 
 * 	Defines for shared memory limits
 */

#define SHMMAX	(128*NBPG) 	/* max. shared memory segment size */
#define SHMMIN	1		/* min. shared memory segment size */
#define SHMMNI	100		/* max. no. shared memory identifers */
#define SHMBRK 	16		/* gap (clicks) between data and shared mem */
#define SHMALL 	1024		/* max shared memory clicks system wide */
