# @(#)hcxif.mk	6.6

LIBNAME = 	../lib_hcxif
INCRT =		..
CFLAGS = 	-DKERNEL -DINET $(CFL)

FILES = \
	$(LIBNAME)(if_en.o) \
	$(LIBNAME)(if_ex.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp hcxif.mk hcxif.mk.bak
	@ed - hcxif.mk < eddep
	@rm eddep makedep
 
# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(if_en.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/vmmac.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/netisr.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/if_ether.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/stdabv.h \
	$(INCRT)/hcxif/if_com.h \
	$(INCRT)/hcxif/if_en.h 

$(LIBNAME)(if_ex.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/vmmac.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/netisr.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/if_ether.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/stdabv.h \
	$(INCRT)/hcxif/if_com.h \
	$(INCRT)/hcxif/if_ex.h \
	$(INCRT)/sys/reboot.h 
