# @(#)io.mk	6.6

LIBNAME = 	../lib_io
INCRT =		..
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(iosubr.o) \
	$(LIBNAME)(dsort.o) \
	$(LIBNAME)(cy.o) \
	$(LIBNAME)(xylogics.o) \
	$(LIBNAME)(drivename.o) \
	$(LIBNAME)(vcc.o) \
	$(LIBNAME)(vcm.o) \
	$(LIBNAME)(vcx.o) \
	$(LIBNAME)(vddc.o) \
	$(LIBNAME)(hdc.o) \
	$(LIBNAME)(tty.o) \
	$(LIBNAME)(tt1.o) \
	$(LIBNAME)(clist.o) \
	$(LIBNAME)(tty_pty.o) \
	$(LIBNAME)(sys.o) \
	$(LIBNAME)(err.o) \
	$(LIBNAME)(sxt.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp io.mk io.mk.bak
	@ed - io.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(iosubr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h 

$(LIBNAME)(dsort.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h 

$(LIBNAME)(cy.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/mtio.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/cipher.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME)(xylogics.o): \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/mtio.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/xymacro.h \
	$(INCRT)/sys/xydata.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME)(vcc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vioc.h \
	$(INCRT)/sys/errno.h 

$(LIBNAME)(vcm.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/vioc.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h 

$(LIBNAME)(vcx.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vioc.h \
	$(INCRT)/sys/bsc/bscio.h \
	$(INCRT)/sys/bsc/bsc.h 

$(LIBNAME)(vddc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vmmac.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/dsk.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/dskio.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vddc.h 

$(LIBNAME)(hdc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vmmac.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/dsk.h \
	$(INCRT)/sys/dskio.h \
	$(INCRT)/sys/hdc.h 

$(LIBNAME)(tty.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/sysinfo.h 

$(LIBNAME)(tt1.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/sysinfo.h 

$(LIBNAME)(clist.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tty.h 

$(LIBNAME)(tty_pty.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/tty_pty.h 

$(LIBNAME)(sys.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(err.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h 

$(LIBNAME)(sxt.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/ttold.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/sxt.h 
