# @(#)ml.mk	6.6

LIBNAME1 = 	../lib0
LIBNAME2 = 	../lib9
INCRT =		..
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME1)(autoconf.o) \
	$(LIBNAME1)(cons.o) \
	$(LIBNAME1)(dkbad.o) \
	$(LIBNAME1)(machdep.o) \
	$(LIBNAME1)(mem.o) \
	$(LIBNAME1)(trap.o) \
	$(LIBNAME1)(vm_machdep.o) \
	$(LIBNAME1)(swapgeneric.o)

FPFILES = \
	$(LIBNAME2)(Kaddd.o) \
	$(LIBNAME2)(Kaddf.o) \
	$(LIBNAME2)(Katanf.o) \
	$(LIBNAME2)(Kcvtdl.o) \
	$(LIBNAME2)(Kcvtfl.o) \
	$(LIBNAME2)(Kcvtld.o) \
	$(LIBNAME2)(Kcvtlf.o) \
	$(LIBNAME2)(Kdivd.o) \
	$(LIBNAME2)(Kdivf.o) \
	$(LIBNAME2)(Kexpf.o) \
	$(LIBNAME2)(Kfnorm.o) \
	$(LIBNAME2)(Kfp_exp.o) \
	$(LIBNAME2)(Kfp_mvtoacc.o) \
	$(LIBNAME2)(Kfrexpd.o) \
	$(LIBNAME2)(Kfrexpf.o) \
	$(LIBNAME2)(Kldexpf.o) \
	$(LIBNAME2)(Klogf.o) \
	$(LIBNAME2)(Kmodf.o) \
	$(LIBNAME2)(Kmuld.o) \
	$(LIBNAME2)(Kmulf.o) \
	$(LIBNAME2)(Knegd.o) \
	$(LIBNAME2)(Knegf.o) \
	$(LIBNAME2)(Ksfnorm.o) \
	$(LIBNAME2)(Ksfp_exp.o) \
	$(LIBNAME2)(Ksinfcosf.o) \
	$(LIBNAME2)(Ksqrtf.o) \
	$(LIBNAME2)(Ksubd.o) \
	$(LIBNAME2)(Ksubf.o) \
	$(LIBNAME2)(addd.o) \
	$(LIBNAME2)(cmpd.o) \
	$(LIBNAME2)(cmpf.o) \
	$(LIBNAME2)(cvtdl.o) \
	$(LIBNAME2)(cvtld.o) \
	$(LIBNAME2)(cvtlf.o) \
	$(LIBNAME2)(cvtfl.o) \
	$(LIBNAME2)(divd.o) \
	$(LIBNAME2)(udiv.o) \
	$(LIBNAME2)(fp_exp.o) \
	$(LIBNAME2)(fnorm.o) \
	$(LIBNAME2)(muld.o) \
	$(LIBNAME2)(negd.o) \
	$(LIBNAME2)(subd.o) 

all:	$(LIBNAME1) $(LIBNAME2)  ../locore.o

.PRECIOUS:	$(LIBNAME1) $(LIBNAME2)

$(LIBNAME1):	$(FILES)

$(LIBNAME2):	$(FPFILES)

install:
	-chmod 664 $(LIBNAME1)
	-chgrp bin $(LIBNAME1)
	-chown bin $(LIBNAME1)
	-chmod 664 $(LIBNAME2)
	-chgrp bin $(LIBNAME2)
	-chown bin $(LIBNAME2)
	-chmod 664 ../locore.o
	-chgrp bin ../locore.o
	-chown bin ../locore.o

../locore.o: \
	locore.s \
	assym.s \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/trap.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/cp.h \
	$(INCRT)/ml/mem.h
	@echo "          "locore.s
	@cat assym.s locore.s > locore.c
	@${CC} -E -I. -DLOCORE ${CFLAGS} locore.c > locore.i
	@${AS} -o ../locore.o locore.i
	@rm locore.i locore.c

assym.s: \
	genassym.c \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vmparam.h \
	$(INCRT)/sys/vmmeter.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/msg.h \
	$(INCRT)/ml/pte.h 
	@echo "          "genassym.c
	@${CC} $(CFLAGS) genassym.c
	@./a.out >assym.s
	@rm -f a.out

.c.a:
	@echo "          "$*.c
	@-case $@ in \
	$(LIBNAME2)) \
		/lib/cpp $*.c > $*.s ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		$(AS) -o $*.o $*.s ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		$(LD) -x -r $*.o ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		mv a.out $*.o ; \
		ar r $@ $*.o ; \
		;; \
	*)\
		$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		../inline/inline $*.s $*.i ; \
		if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
			if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
				$(C2) $*.i $*.s ; \
				if [ $$? != 0 ] ; then \
					exit 1 ; \
				fi ; \
				mv $*.s $*.i ; \
			fi ; \
		fi ; \
		$(AS) -o $*.o $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		ar r $@ $*.o ; \
		rm $*.i ; \
		;; \
	esac
	@-rm -f $*.o $*.s

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME1) $(LIBNAME2) ../locore.o

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.[csx]/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME1)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp ml.mk ml.mk.bak
	@ed - ml.mk < eddep
	@rm eddep makedep
	@grep '^#include' `echo ' $(FPFILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.[cx]/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME2)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp ml.mk ml.mk.bak
	@ed - ml.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME1)(autoconf.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/dmap.h \
	$(INCRT)/ml/mem.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/vbavar.h \
	$(INCRT)/sys/reboot.h 

$(LIBNAME1)(cons.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/callout.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ml/cp.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(dkbad.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/dkbad.h 

$(LIBNAME1)(machdep.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/callout.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/msg.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/ml/mem.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/cp.h \
	$(INCRT)/sys/vbavar.h 

$(LIBNAME1)(mem.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(trap.o): \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/ml/trap.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME1)(vm_machdep.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(swapgeneric.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/stdabv.h \
	$(INCRT)/ml/cp.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/vbavar.h 


$(LIBNAME2)(Kaddd.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(Kaddf.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(Kcvtdl.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kcvtfl.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(Kcvtld.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kcvtlf.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kdivd.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kdivf.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kfnorm.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kfp_exp.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kfp_mvtoacc.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(Kldexpf.o): \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kmodf.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(Kmuld.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Kmulf.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Knegd.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Knegf.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Ksfnorm.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(Ksfp_exp.o): \
	$(INCRT)/ml/fp.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME2)(addd.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(cvtdl.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(cvtld.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(cvtlf.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(cvtfl.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(divd.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(fp_exp.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(fnorm.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(muld.o): \
	$(INCRT)/ml/fp.h 

$(LIBNAME2)(negd.o): \
	$(INCRT)/ml/fp.h 
