/*	param.h	6.1	83/07/29	*/

/*
 * Machine dependent constants for HCX.
 */
#define	NBPG	1024		/* bytes/page */
#define	PGOFSET	(NBPG-1)	/* byte offset into page */
#define	PGSHIFT	10		/* LOG2(NBPG) */
#define	MAXCKEY	255		/* Maximal allowed code key */
#define	MAXDKEY	255		/* Maximal allowed data key */
#define	NOFCKEY	(MAXCKEY+1)	/* Includes 0 which is reserved */
#define	NOFDKEY	(MAXDKEY+1)

#define	CLSIZE		1
#define	CLSIZELOG2	0

#define	SSIZE	2		/* initial stack size/NBPG */
#define	SINCR	2		/* increment of stack/NBPG */

#define	UPAGES	6		/* pages of u-area
	=sizeof struct user + page of red zone and 2 pages of kernel stack */
#define PRIMARY_IOBASE		0xff000000	/* Fourth megabyte of 4 giga */
#define SECONDARY_IOBASE	0xbf000000	/* Third  megabyte of 4 giga */
				/* corresponds to Versabus addresses */
/*
 * Some macros for units conversion
 */
/* Core clicks (1024 bytes) to segments and vice versa */
#define	ctos(x)	(x)
#define	stoc(x)	(x)

/* Core clicks (1024 bytes) to disk blocks */
#define	ctod(x)	(x)
#define	dtoc(x)	(x)
#define	dtob(x)	((x)<<PGSHIFT)

/* clicks to bytes */
#define	ctob(x)	((x)<<PGSHIFT)

/* bytes to clicks */
#define	btoc(x)	((((unsigned)(x)+NBPG-1) >> PGSHIFT))

/*
 * Macros to decode processor status word.
 */
#define	USERMODE(ps)	(((ps) & PSL_CURMOD) == PSL_CURMOD)
#define	BASEPRI(ps)	(((ps) & PSL_IPL) == 0)

#define	DELAY(n)	{ register int N = 3*(n); while (--N > 0); }
