#include "../ml/mtpr.h"
#include "../ml/trap.h"
#include "../ml/psl.h"
#include "../ml/pte.h"
#include "../ml/cp.h"
#include "../ml/mem.h"

#include "../sys/errno.h"
#include "../cf/config.h"
#include "../cf/ipcconfig.h"
#include "../sys/xymacro.h"

#define SYSPTSIZE 	((128*256/2)+(MAXUSERS*256/16)+100)

	.set SYSTEM,0xC0000000 # virtual address of system start
/*
 * System page table
 */ 
#define	vaddr(x)	((x/4)*NBPG+SYSTEM)
#define	SYSMAP(mname, vname, npte)			\
_/**/mname:	.globl	_/**/mname;		\
	.space	npte*4;				\
	.globl	_/**/vname;			\
	.set	./**/vname, _/**/mname-_Sysmap; \
	.set	_/**/vname,vaddr(./**/vname)

	.data
	.align	4
	SYSMAP(Sysmap	,Sysbase	,SYSPTSIZE	)
	SYSMAP(VMEMbeg  ,vmembeg        ,0              )
	SYSMAP(PRIMmap	,Pmem		,IOSIZE 	)
	SYSMAP(VMEMend  ,vmemend        ,0              )
	SYSMAP(Usrptmap	,usrpt		,USRPTSIZE	)
	SYSMAP(Forkmap	,forkutl	,UPAGES		)
	SYSMAP(Xswapmap	,xswaputl	,UPAGES		)
	SYSMAP(Xswap2map,xswap2utl	,UPAGES		)
	SYSMAP(Swapmap	,swaputl	,UPAGES		)
	SYSMAP(Pushmap	,pushutl	,UPAGES		)
	SYSMAP(Vfmap	,vfutl		,UPAGES		)
	SYSMAP(VD0map	,vd0utl		,(MAXBPTE+1)	)
	SYSMAP(VD1map	,vd1utl		,(MAXBPTE+1)	)
	SYSMAP(VD2map	,vd2utl		,(MAXBPTE+1)	)
	SYSMAP(VD3map	,vd3utl		,(MAXBPTE+1)	)
	SYSMAP(CY0map	,cy0utl		,(TBUFSIZ+1)	)
	SYSMAP(CY1map	,cy1utl		,(TBUFSIZ+1)	)
	SYSMAP(XYmap	,xybuf		,(NXYD*XYASYNCBUFSZ))
	SYSMAP(CMAP1	,CADDR1		,1		)
	SYSMAP(CMAP2	,CADDR2		,1		)
	SYSMAP(mmap	,vmmap		,1		)
	SYSMAP(Mbmap	,mbutl		,NMBCLUSTERS*CLSIZE)
	SYSMAP(Msgmap	,msgutl		,MSGMAPPTE)
eSysmap:
	.globl	_Syssize
	.set	.Syssize,eSysmap-_Sysmap
	.set	_Syssize,.Syssize/4
	.text
