#include "../ml/psl.h"
#include "../cf/config.h"


#define	SCBVEC(name) \
	.align 4; \
	.globl _X/**/name; \
_X/**/name

#define	PUSHR		pushl r0; pushl r1;

#define	POPR		movl (sp)+, r1; movl (sp)+, r0;

/* Keep address of psl if coming from user mode */
#define CHECK_SFE(_delta,name) \
	bitl	$PSL_CURMOD,_delta(sp); \
	jeql	name; \
	moval	_delta(sp),_user_psl; \
name:

#define SAVE_FPSTAT(_delta,name1,name2,name3)\
				bitl	$PSL_DBL,_delta(sp); \
				beql	name1; \
				pushl	$1; \
				pushd; \
				jmp	name2; \
			name1:	pushl	$0; \
				pushl	$0; \
				stf	-(sp); \
			name2:	tstl	_u+PCB_SAVACC; \
				bneq	name3; \
				moval	0(sp),_u+PCB_SAVACC; \
				orl2	$2,8(sp);\
			name3:	pushl	$0;

#define REST_FPSTAT(name1,name2,name3)\
				tstl	(sp)+; \
				bitl	$2,8(sp);\
				beql	name1;\
				movl	$0,_u+PCB_SAVACC; \
			name1:	bitl	$1,8(sp); \
				beql	name2; \
				ldd	(sp); \
				jmp	name3; \
			name2:	ldf	(sp); \
			name3:	moval	12(sp),sp;

SCBVEC(vdintr0):
	CHECK_SFE(4,.vdintr0)
	SAVE_FPSTAT(4,vdi0a,vdi0b,vdi0c)
	PUSHR;
#if NVD > 0
	pushl	$0
	callf	$8,_vdintr
#else
	pushab vdint0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vdi0a,_vdi0b,_vdi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(vdintr1):
	CHECK_SFE(4,.vdintr1)
	SAVE_FPSTAT(4,vdi1a,vdi1b,vdi1c)
	PUSHR;
#if NVD > 1
	pushl	$1
	callf	$8,_vdintr
#else
	pushab vdint1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vdi1a,_vdi1b,_vdi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(vdintr2):
	CHECK_SFE(4,.vdintr2)
	SAVE_FPSTAT(4,vdi2a,vdi2b,vdi2c)
	PUSHR;
#if NVD > 2
	pushl	$2
	callf	$8,_vdintr
#else
	pushab vdint2
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vdi2a,_vdi2b,_vdi2c)
	incl _cnt+V_INTR
	rei

SCBVEC(vdintr3):
	CHECK_SFE(4,.vdintr3)
	SAVE_FPSTAT(4,vdi3a,vdi3b,vdi3c)
	PUSHR;
#if NVD > 3
	pushl	$3
	callf	$8,_vdintr
#else
	pushab vdint3
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vdi3a,_vdi3b,_vdi3c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr0):
	CHECK_SFE(4,.hdintr0)
	SAVE_FPSTAT(4,hdi0a,hdi0b,hdi0c)
	PUSHR;
#if NHD > 0
	pushl	$0
	callf	$8,_hdintr
#else
	pushab hdint0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi0a,_hdi0b,_hdi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr1):
	CHECK_SFE(4,.hdintr1)
	SAVE_FPSTAT(4,hdi1a,hdi1b,hdi1c)
	PUSHR;
#if NHD > 1
	pushl	$1
	callf	$8,_hdintr
#else
	pushab hdint1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi1a,_hdi1b,_hdi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr2):
	CHECK_SFE(4,.hdintr2)
	SAVE_FPSTAT(4,hdi2a,hdi2b,hdi2c)
	PUSHR;
#if NHD > 2
	pushl	$2
	callf	$8,_hdintr
#else
	pushab hdint2
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi2a,_hdi2b,_hdi2c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr3):
	CHECK_SFE(4,.hdintr3)
	SAVE_FPSTAT(4,hdi3a,hdi3b,hdi3c)
	PUSHR;
#if NHD > 3
	pushl	$3
	callf	$8,_hdintr
#else
	pushab hdint3
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi3a,_hdi3b,_hdi3c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr4):
	CHECK_SFE(4,.hdintr4)
	SAVE_FPSTAT(4,hdi4a,hdi4b,hdi4c)
	PUSHR;
#if NHD > 4
	pushl	$4
	callf	$8,_hdintr
#else
	pushab hdint4
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi4a,_hdi4b,_hdi4c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr5):
	CHECK_SFE(4,.hdintr5)
	SAVE_FPSTAT(4,hdi5a,hdi5b,hdi5c)
	PUSHR;
#if NHD > 5
	pushl	$5
	callf	$8,_hdintr
#else
	pushab hdint5
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi5a,_hdi5b,_hdi5c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr6):
	CHECK_SFE(4,.hdintr6)
	SAVE_FPSTAT(4,hdi6a,hdi6b,hdi6c)
	PUSHR;
#if NHD > 6
	pushl	$6
	callf	$8,_hdintr
#else
	pushab hdint6
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi6a,_hdi6b,_hdi6c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr7):
	CHECK_SFE(4,.hdintr7)
	SAVE_FPSTAT(4,hdi7a,hdi7b,hdi7c)
	PUSHR;
#if NHD > 7
	pushl	$7
	callf	$8,_hdintr
#else
	pushab hdint7
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi7a,_hdi7b,_hdi7c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr8):
	CHECK_SFE(4,.hdintr8)
	SAVE_FPSTAT(4,hdi8a,hdi8b,hdi8c)
	PUSHR;
#if NHD > 8
	pushl	$8
	callf	$8,_hdintr
#else
	pushab hdint8
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi8a,_hdi8b,_hdi8c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr9):
	CHECK_SFE(4,.hdintr9)
	SAVE_FPSTAT(4,hdi9a,hdi9b,hdi9c)
	PUSHR;
#if NHD > 9
	pushl	$9
	callf	$8,_hdintr
#else
	pushab hdint9
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi9a,_hdi9b,_hdi9c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr10):
	CHECK_SFE(4,.hdintr10)
	SAVE_FPSTAT(4,hdi10a,hdi10b,hdi10c)
	PUSHR;
#if NHD > 10
	pushl	$10
	callf	$8,_hdintr
#else
	pushab hdint10
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi10a,_hdi10b,_hdi10c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr11):
	CHECK_SFE(4,.hdintr11)
	SAVE_FPSTAT(4,hdi11a,hdi11b,hdi11c)
	PUSHR;
#if NHD > 11
	pushl	$11
	callf	$8,_hdintr
#else
	pushab hdint11
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi11a,_hdi11b,_hdi11c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr12):
	CHECK_SFE(4,.hdintr12)
	SAVE_FPSTAT(4,hdi12a,hdi12b,hdi12c)
	PUSHR;
#if NHD > 12
	pushl	$12
	callf	$8,_hdintr
#else
	pushab hdint12
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi12a,_hdi12b,_hdi12c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr13):
	CHECK_SFE(4,.hdintr13)
	SAVE_FPSTAT(4,hdi13a,hdi13b,hdi13c)
	PUSHR;
#if NHD > 13
	pushl	$13
	callf	$8,_hdintr
#else
	pushab hdint13
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi13a,_hdi13b,_hdi13c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr14):
	CHECK_SFE(4,.hdintr14)
	SAVE_FPSTAT(4,hdi14a,hdi14b,hdi14c)
	PUSHR;
#if NHD > 14
	pushl	$14
	callf	$8,_hdintr
#else
	pushab hdint14
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi14a,_hdi14b,_hdi14c)
	incl _cnt+V_INTR
	rei

SCBVEC(hdintr15):
	CHECK_SFE(4,.hdintr15)
	SAVE_FPSTAT(4,hdi15a,hdi15b,hdi15c)
	PUSHR;
#if NHD > 15
	pushl	$15
	callf	$8,_hdintr
#else
	pushab hdint15
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_hdi15a,_hdi15b,_hdi15c)
	incl _cnt+V_INTR
	rei

SCBVEC(cyintr0):
	CHECK_SFE(4,.cyintr0)
	SAVE_FPSTAT(4,cyi0a,cyi0b,cyi0c)
	PUSHR;
#if NCY > 0
	pushl	$0
	callf	$8,_cyintr
#else
	pushab cyint0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_cyi0a,_cyi0b,_cyi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(cyintr1):
	CHECK_SFE(4,.cyintr1)
	SAVE_FPSTAT(4,cyi1a,cyi1b,cyi1c)
	PUSHR;
#if NCY > 1
	pushl	$1
	callf	$8,_cyintr
#else
	pushab cyint1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_cyi1a,_cyi1b,_cyi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(xyintr0):
	CHECK_SFE(4,.xyintr0)
	SAVE_FPSTAT(4,xyi0a,xyi0b,xyi0c)
	PUSHR;
#if NXY > 0
	pushl	$0
	callf	$8,_xyintr
#else
	pushab xyint0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_xyi0a,_xyi0b,_xyi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(xyintr1):
	CHECK_SFE(4,.xyintr1)
	SAVE_FPSTAT(4,xyi1a,xyi1b,xyi1c)
	PUSHR;
#if NXY > 1
	pushl	$1
	callf	$8,_xyintr
#else
	pushab xyint1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_xyi1a,_xyi1b,_xyi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint0):
	CHECK_SFE(4,.vackint0)
	SAVE_FPSTAT(4,vacki0a,vacki0b,vacki0c)
	PUSHR;
#if NVX > 0
	pushl	$0
	callf	$8,_vackint
#else
	pushab  vack0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki0a,_vacki0b,_vacki0c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp0):
	CHECK_SFE(4,.vcmdrsp0)
	SAVE_FPSTAT(4,vcmdi0a,vcmdi0b,vcmdi0c)
	PUSHR;
#if NVX > 0
	pushl	$0
	callf	$8,_vcmdrsp
#else
	pushab vcmd0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi0a,_vcmdi0b,_vcmdi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol0):
	CHECK_SFE(4,.vunsol0)
	SAVE_FPSTAT(4,vunsi0a,vunsi0b,vunsi0c)
	PUSHR;
#if NVX > 0
	pushl	$0
	callf	$8,_vunsol
#else
	pushab vuns0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi0a,_vunsi0b,_vunsi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint1):
	CHECK_SFE(4,.vackint1)
	SAVE_FPSTAT(4,vacki1a,vacki1b,vacki1c)
	PUSHR;
#if NVX > 1
	pushl	$1
	callf	$8,_vackint
#else
	pushab  vack1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki1a,_vacki1b,_vacki1c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp1):
	CHECK_SFE(4,.vcmdrsp1)
	SAVE_FPSTAT(4,vcmdi1a,vcmdi1b,vcmdi1c)
	PUSHR;
#if NVX > 1
	pushl	$1
	callf	$8,_vcmdrsp
#else
	pushab vcmd1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi1a,_vcmdi1b,_vcmdi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol1):
	CHECK_SFE(4,.vunsol1)
	SAVE_FPSTAT(4,vunsi1a,vunsi1b,vunsi1c)
	PUSHR;
#if NVX > 1
	pushl	$1
	callf	$8,_vunsol
#else
	pushab vuns1
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi1a,_vunsi1b,_vunsi1c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint2):
	CHECK_SFE(4,.vackint2)
	SAVE_FPSTAT(4,vacki2a,vacki2b,vacki2c)
	PUSHR;
#if NVX > 2
	pushl	$2
	callf	$8,_vackint
#else
	pushab  vack2
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki2a,_vacki2b,_vacki2c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp2):
	CHECK_SFE(4,.vcmdrsp2)
	SAVE_FPSTAT(4,vcmdi2a,vcmdi2b,vcmdi2c)
	PUSHR;
#if NVX > 2
	pushl	$2
	callf	$8,_vcmdrsp
#else
	pushab vcmd2
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi2a,_vcmdi2b,_vcmdi2c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol2):
	CHECK_SFE(4,.vunsol2)
	SAVE_FPSTAT(4,vunsi2a,vunsi2b,vunsi2c)
	PUSHR;
#if NVX > 2
	pushl	$2
	callf	$8,_vunsol
#else
	pushab vuns2
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi2a,_vunsi2b,_vunsi2c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint3):
	CHECK_SFE(4,.vackint3)
	SAVE_FPSTAT(4,vacki3a,vacki3b,vacki3c)
	PUSHR;
#if NVX > 3
	pushl	$3
	callf	$8,_vackint
#else
	pushab  vack3
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki3a,_vacki3b,_vacki3c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp3):
	CHECK_SFE(4,.vcmdrsp3)
	SAVE_FPSTAT(4,vcmdi3a,vcmdi3b,vcmdi3c)
	PUSHR;
#if NVX > 3
	pushl	$3
	callf	$8,_vcmdrsp
#else
	pushab vcmd3
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi3a,_vcmdi3b,_vcmdi3c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol3):
	CHECK_SFE(4,.vunsol3)
	SAVE_FPSTAT(4,vunsi3a,vunsi3b,vunsi3c)
	PUSHR;
#if NVX > 3
	pushl	$3
	callf	$8,_vunsol
#else
	pushab vuns3
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi3a,_vunsi3b,_vunsi3c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint4):
	CHECK_SFE(4,.vackint4)
	SAVE_FPSTAT(4,vacki4a,vacki4b,vacki4c)
	PUSHR;
#if NVX > 4
	pushl	$4
	callf	$8,_vackint
#else
	pushab  vack4
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki4a,_vacki4b,_vacki4c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp4):
	CHECK_SFE(4,.vcmdrsp4)
	SAVE_FPSTAT(4,vcmdi4a,vcmdi4b,vcmdi4c)
	PUSHR;
#if NVX > 4
	pushl	$4
	callf	$8,_vcmdrsp
#else
	pushab vcmd4
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi4a,_vcmdi4b,_vcmdi4c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol4):
	CHECK_SFE(4,.vunsol4)
	SAVE_FPSTAT(4,vunsi4a,vunsi4b,vunsi4c)
	PUSHR;
#if NVX > 4
	pushl	$4
	callf	$8,_vunsol
#else
	pushab vuns4
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi4a,_vunsi4b,_vunsi4c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint5):
	CHECK_SFE(4,.vackint5)
	SAVE_FPSTAT(4,vacki5a,vacki5b,vacki5c)
	PUSHR;
#if NVX > 5
	pushl	$5
	callf	$8,_vackint
#else
	pushab  vack5
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki5a,_vacki5b,_vacki5c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp5):
	CHECK_SFE(4,.vcmdrsp5)
	SAVE_FPSTAT(4,vcmdi5a,vcmdi5b,vcmdi5c)
	PUSHR;
#if NVX > 5
	pushl	$5
	callf	$8,_vcmdrsp
#else
	pushab vcmd5
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi5a,_vcmdi5b,_vcmdi5c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol5):
	CHECK_SFE(4,.vunsol5)
	SAVE_FPSTAT(4,vunsi5a,vunsi5b,vunsi5c)
	PUSHR;
#if NVX > 5
	pushl	$5
	callf	$8,_vunsol
#else
	pushab vuns5
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi5a,_vunsi5b,_vunsi5c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint6):
	CHECK_SFE(4,.vackint6)
	SAVE_FPSTAT(4,vacki6a,vacki6b,vacki6c)
	PUSHR;
#if NVX > 6
	pushl	$6
	callf	$8,_vackint
#else
	pushab  vack6
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki6a,_vacki6b,_vacki6c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp6):
	CHECK_SFE(4,.vcmdrsp6)
	SAVE_FPSTAT(4,vcmdi6a,vcmdi6b,vcmdi6c)
	PUSHR;
#if NVX > 6
	pushl	$6
	callf	$8,_vcmdrsp
#else
	pushab vcmd6
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi6a,_vcmdi6b,_vcmdi6c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol6):
	CHECK_SFE(4,.vunsol6)
	SAVE_FPSTAT(4,vunsi6a,vunsi6b,vunsi6c)
	PUSHR;
#if NVX > 6
	pushl	$6
	callf	$8,_vunsol
#else
	pushab vuns6
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi6a,_vunsi6b,_vunsi6c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint7):
	CHECK_SFE(4,.vackint7)
	SAVE_FPSTAT(4,vacki7a,vacki7b,vacki7c)
	PUSHR;
#if NVX > 7
	pushl	$7
	callf	$8,_vackint
#else
	pushab  vack7
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki7a,_vacki7b,_vacki7c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp7):
	CHECK_SFE(4,.vcmdrsp7)
	SAVE_FPSTAT(4,vcmdi7a,vcmdi7b,vcmdi7c)
	PUSHR;
#if NVX > 7
	pushl	$7
	callf	$8,_vcmdrsp
#else
	pushab vcmd7
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi7a,_vcmdi7b,_vcmdi7c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol7):
	CHECK_SFE(4,.vunsol7)
	SAVE_FPSTAT(4,vunsi7a,vunsi7b,vunsi7c)
	PUSHR;
#if NVX > 7
	pushl	$7
	callf	$8,_vunsol
#else
	pushab vuns7
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi7a,_vunsi7b,_vunsi7c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint8):
	CHECK_SFE(4,.vackint8)
	SAVE_FPSTAT(4,vacki8a,vacki8b,vacki8c)
	PUSHR;
#if NVX > 8
	pushl	$8
	callf	$8,_vackint
#else
	pushab  vack8
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki8a,_vacki8b,_vacki8c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp8):
	CHECK_SFE(4,.vcmdrsp8)
	SAVE_FPSTAT(4,vcmdi8a,vcmdi8b,vcmdi8c)
	PUSHR;
#if NVX > 8
	pushl	$8
	callf	$8,_vcmdrsp
#else
	pushab vcmd8
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi8a,_vcmdi8b,_vcmdi8c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol8):
	CHECK_SFE(4,.vunsol8)
	SAVE_FPSTAT(4,vunsi8a,vunsi8b,vunsi8c)
	PUSHR;
#if NVX > 8
	pushl	$8
	callf	$8,_vunsol
#else
	pushab vuns8
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi8a,_vunsi8b,_vunsi8c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint9):
	CHECK_SFE(4,.vackint9)
	SAVE_FPSTAT(4,vacki9a,vacki9b,vacki9c)
	PUSHR;
#if NVX > 9
	pushl	$9
	callf	$8,_vackint
#else
	pushab  vack9
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki9a,_vacki9b,_vacki9c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp9):
	CHECK_SFE(4,.vcmdrsp9)
	SAVE_FPSTAT(4,vcmdi9a,vcmdi9b,vcmdi9c)
	PUSHR;
#if NVX > 9
	pushl	$9
	callf	$8,_vcmdrsp
#else
	pushab vcmd9
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi9a,_vcmdi9b,_vcmdi9c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol9):
	CHECK_SFE(4,.vunsol9)
	SAVE_FPSTAT(4,vunsi9a,vunsi9b,vunsi9c)
	PUSHR;
#if NVX > 9
	pushl	$9
	callf	$8,_vunsol
#else
	pushab vuns9
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi9a,_vunsi9b,_vunsi9c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint10):
	CHECK_SFE(4,.vackint10)
	SAVE_FPSTAT(4,vacki10a,vacki10b,vacki10c)
	PUSHR;
#if NVX > 10
	pushl	$10
	callf	$8,_vackint
#else
	pushab  vack10
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki10a,_vacki10b,_vacki10c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp10):
	CHECK_SFE(4,.vcmdrsp10)
	SAVE_FPSTAT(4,vcmdi10a,vcmdi10b,vcmdi10c)
	PUSHR;
#if NVX > 10
	pushl	$10
	callf	$8,_vcmdrsp
#else
	pushab vcmd10
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi10a,_vcmdi10b,_vcmdi10c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol10):
	CHECK_SFE(4,.vunsol10)
	SAVE_FPSTAT(4,vunsi10a,vunsi10b,vunsi10c)
	PUSHR;
#if NVX > 10
	pushl	$10
	callf	$8,_vunsol
#else
	pushab vuns10
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi10a,_vunsi10b,_vunsi10c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint11):
	CHECK_SFE(4,.vackint11)
	SAVE_FPSTAT(4,vacki11a,vacki11b,vacki11c)
	PUSHR;
#if NVX > 11
	pushl	$11
	callf	$8,_vackint
#else
	pushab  vack11
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki11a,_vacki11b,_vacki11c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp11):
	CHECK_SFE(4,.vcmdrsp11)
	SAVE_FPSTAT(4,vcmdi11a,vcmdi11b,vcmdi11c)
	PUSHR;
#if NVX > 11
	pushl	$11
	callf	$8,_vcmdrsp
#else
	pushab vcmd11
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi11a,_vcmdi11b,_vcmdi11c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol11):
	CHECK_SFE(4,.vunsol11)
	SAVE_FPSTAT(4,vunsi11a,vunsi11b,vunsi11c)
	PUSHR;
#if NVX > 11
	pushl	$11
	callf	$8,_vunsol
#else
	pushab vuns11
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi11a,_vunsi11b,_vunsi11c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint12):
	CHECK_SFE(4,.vackint12)
	SAVE_FPSTAT(4,vacki12a,vacki12b,vacki12c)
	PUSHR;
#if NVX > 12
	pushl	$12
	callf	$8,_vackint
#else
	pushab  vack12
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki12a,_vacki12b,_vacki12c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp12):
	CHECK_SFE(4,.vcmdrsp12)
	SAVE_FPSTAT(4,vcmdi12a,vcmdi12b,vcmdi12c)
	PUSHR;
#if NVX > 12
	pushl	$12
	callf	$8,_vcmdrsp
#else
	pushab vcmd12
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi12a,_vcmdi12b,_vcmdi12c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol12):
	CHECK_SFE(4,.vunsol12)
	SAVE_FPSTAT(4,vunsi12a,vunsi12b,vunsi12c)
	PUSHR;
#if NVX > 12
	pushl	$12
	callf	$8,_vunsol
#else
	pushab vuns12
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi12a,_vunsi12b,_vunsi12c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint13):
	CHECK_SFE(4,.vackint13)
	SAVE_FPSTAT(4,vacki13a,vacki13b,vacki13c)
	PUSHR;
#if NVX > 13
	pushl	$13
	callf	$8,_vackint
#else
	pushab  vack13
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki13a,_vacki13b,_vacki13c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp13):
	CHECK_SFE(4,.vcmdrsp13)
	SAVE_FPSTAT(4,vcmdi13a,vcmdi13b,vcmdi13c)
	PUSHR;
#if NVX > 13
	pushl	$13
	callf	$8,_vcmdrsp
#else
	pushab vcmd13
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi13a,_vcmdi13b,_vcmdi13c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol13):
	CHECK_SFE(4,.vunsol13)
	SAVE_FPSTAT(4,vunsi13a,vunsi13b,vunsi13c)
	PUSHR;
#if NVX > 13
	pushl	$13
	callf	$8,_vunsol
#else
	pushab vuns13
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi13a,_vunsi13b,_vunsi13c)
	incl _cnt+V_INTR
	rei

SCBVEC(vackint14):
	CHECK_SFE(4,.vackint14)
	SAVE_FPSTAT(4,vacki14a,vacki14b,vacki14c)
	PUSHR;
#if NVX > 14
	pushl	$14
	callf	$8,_vackint
#else
	pushab  vack14
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vacki14a,_vacki14b,_vacki14c)
	incl _cnt+V_INTR
	rei

SCBVEC(vcmdrsp14):
	CHECK_SFE(4,.vcmdrsp14)
	SAVE_FPSTAT(4,vcmdi14a,vcmdi14b,vcmdi14c)
	PUSHR;
#if NVX > 14
	pushl	$14
	callf	$8,_vcmdrsp
#else
	pushab vcmd14
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vcmdi14a,_vcmdi14b,_vcmdi14c)
	incl _cnt+V_INTR
	rei

SCBVEC(vunsol14):
	CHECK_SFE(4,.vunsol14)
	SAVE_FPSTAT(4,vunsi14a,vunsi14b,vunsi14c)
	PUSHR;
#if NVX > 14
	pushl	$14
	callf	$8,_vunsol
#else
	pushab vuns14
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_vunsi14a,_vunsi14b,_vunsi14c)
	incl _cnt+V_INTR
	rei

SCBVEC(udintr0):
	CHECK_SFE(4,.udintr0)
	SAVE_FPSTAT(4,udi0a,udi0b,udi0c)
	PUSHR;
#if NUD > 0
	pushl	$0
	callf	$8,_udintr
#else
	pushab udint0
	callf	$8, _printf
#endif
	POPR;
	REST_FPSTAT(_udi0a,_udi0b,_udi0c)
	incl _cnt+V_INTR
	rei

SCBVEC(xpintr0):
	CHECK_SFE(4,.xpintr0)
	SAVE_FPSTAT(4,xpi0a,xpi0b,xpi0c)
	PUSHR;
#if NXP > 0
	pushl	$0
	callf	$8,_xpintr
#else
	pushab	xpint0
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_xpi0a,_xpi0b,_xpi0c)
	incl _cnt+V_INTR
	rei

#if INET > 0
#include "../net/netisr.h"
	.globl	_netisr
SCBVEC(netintr):
	CHECK_SFE(4, netintr0)
	SAVE_FPSTAT(4, netintr1, netintr2, netintr3)
	PUSHR;

#include "../netinet/in_systm.h"
	bbc	$NETISR_IP,_netisr,netisr0
	andl2	$(0~(1<NETISR_IP)),_netisr
	callf	$4,_ipintr	
netisr0:
	bbc	$NETISR_RAW,_netisr,netisr1
	andl2	$(0~(1<NETISR_RAW)),_netisr	
	callf	$4,_rawintr	
netisr1:
#ifdef NS
	bbc	$NETISR_NS,_netisr,netisr2
	andl2	$(0~(1<NETISR_NS)),_netisr
	callf	$4,_nsintr	
netisr2:
#endif NS
	POPR; 
	REST_FPSTAT(_netintr1, _netintr2, _netintr3)
	rei
#else INET
SCBVEC(netintr):
	PUSHR
	pushab .FFFF
	callf	$8, _printf
	.data
.FFFF:	.byte	'*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'d,'e,'f,'i,'n,'e,'d,' ,'S,'o,'f,'t,'w,'a,'r,'e,' ,'I,'n,'t,'e,'r,'r,'u,'p,'t,' ,'*,'*,'*,'*,'*,'*,'*,012,0
	.text
	POPR
	rei
#endif INET

SCBVEC(enxintr0):
	CHECK_SFE(4,.enxintr0)
	SAVE_FPSTAT(4,enxintr0a,enxintr0b,enxintr0c)
	PUSHR;
#if NEN > 0
	pushl	$0
	callf	$8,_enxintr
#else 
	pushab	scint0
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_enxintr0a,_enxintr0b,_enxintr0c)
	rei

SCBVEC(enrintr0):
	CHECK_SFE(4,.enrintr0)
	SAVE_FPSTAT(4,enrintr0a,enrintr0b,enrintr0c)
	PUSHR;
#if NEN > 0
	pushl	$0
	callf	$8,_enrintr
#else 
	pushab	srint0
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_enrintr0a,_enrintr0b,_enrintr0c)
	rei

SCBVEC(enxintr1):
	CHECK_SFE(4,.enxintr1)
	SAVE_FPSTAT(4,enxintr1a,enxintr1b,enxintr1c)
	PUSHR;
#if NEN > 1
	pushl	$1
	callf	$8,_enxintr
#else 
	pushab	scint1
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_enxintr1a,_enxintr1b,_enxintr1c)
	rei

SCBVEC(enrintr1):
	CHECK_SFE(4,.enrintr1)
	SAVE_FPSTAT(4,enrintr1a,enrintr1b,enrintr1c)
	PUSHR;
#if NEN > 1
	pushl	$1
	callf	$8,_enrintr
#else 
	pushab	srint1
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_enrintr1a,_enrintr1b,_enrintr1c)
	rei

SCBVEC(exintr0):
	CHECK_SFE(4,.exintr0)
	SAVE_FPSTAT(4,exintr0a,exintr0b,exintr0c)
	PUSHR;
#if NEX > 0
	pushl	$0
	callf	$8,_exintr
#else 
	pushab	exint0
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_exintr0a,_exintr0b,_exintr0c)
	rei

SCBVEC(exintr1):
	CHECK_SFE(4,.exintr1)
	SAVE_FPSTAT(4,exintr1a,exintr1b,exintr1c)
	PUSHR;
#if NEX > 1
	pushl	$1
	callf	$8,_exintr
#else 
	pushab  exint1
	callf	$8,_printf
#endif
	POPR;
	REST_FPSTAT(_exintr1a,_exintr1b,_exintr1c)
	rei

	.data
vdint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'d,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vdint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'d,'i,'n,'t,'r,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vdint2:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'d,'i,'n,'t,'r,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vdint3:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'d,'i,'n,'t,'r,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint2:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint3:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint4:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint5:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'5,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint6:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'6,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint7:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'7,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint8:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'8,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint9:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'9,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint10:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'a,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint11:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'b,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint12:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'c,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint13:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'d,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint14:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'e,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
hdint15:.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'h,'d,'i,'n,'t,'r,'f,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
cyint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'c,'y,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
cyint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'c,'y,'i,'n,'t,'r,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
xyint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'x,'y,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
xyint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'x,'y,'i,'n,'t,'r,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack2:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd2:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns2:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack3:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd3:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns3:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack4:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd4:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns4:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack5:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'5,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd5:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'5,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns5:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'5,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack6:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'6,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd6:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'6,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns6:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'6,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack7:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'7,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd7:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'7,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns7:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'7,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack8:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'8,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd8:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'8,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns8:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'8,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack9:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'9,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd9:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'9,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns9:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'9,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack10:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd10:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns10:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack11:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd11:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns11:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack12:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd12:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns12:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,'2,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack13:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd13:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns13:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,'3,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vack14:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'a,'c,'k,'i,'n,'t,'1,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vcmd14:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'c,'m,'d,'r,'s,'p,'1,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
vuns14:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'v,'u,'n,'s,'o,'l,'1,'4,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0

xpint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'x,'p,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
udint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'u,'d,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0

scint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'n,'x,'m,'i,'t,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
srint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'n,'r,'e,'c,'v,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
scint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'n,'x,'m,'i,'t,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
srint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'n,'r,'e,'c,'v,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
exint0:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'x,'i,'n,'t,'r,'0,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
exint1:	.byte '*,'*,'*,'*,'*,'*,'*,' ,'U,'n,'i,'m,'p,'l,'e,'m,'e,'n,'t,'e,'d
	.byte ' ,'i,'n,'t,'e,'r,'r,'u,'p,'t,' ,'(,'e,'x,'i,'n,'t,'r,'1,')
	.byte ' ,'*,'*,'*,'*,'*,'*,'*,'*,012,0
	.text
