# @(#)netinet.mk	6.6

LIBNAME = 	../lib_netinet
INCRT =		..
CFLAGS = 	-DKERNEL -DINET $(CFL)
FILES = \
	$(LIBNAME)(ip_output.o) \
	$(LIBNAME)(tcp_usrreq.o) \
	$(LIBNAME)(if_ether.o) \
	$(LIBNAME)(tcp_input.o) \
	$(LIBNAME)(tcp_output.o) \
	$(LIBNAME)(if_loop.o) \
	$(LIBNAME)(raw_ip.o) \
	$(LIBNAME)(in.o) \
	$(LIBNAME)(ip_icmp.o) \
	$(LIBNAME)(tcp_subr.o) \
	$(LIBNAME)(udp_usrreq.o) \
	$(LIBNAME)(tcp_debug.o) \
	$(LIBNAME)(tcp_timer.o) \
	$(LIBNAME)(in_pcb.o) \
	$(LIBNAME)(ip_input.o) \
	$(LIBNAME)(in_cksum.o) \
	$(LIBNAME)(in_proto.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp netinet.mk netinet.mk.bak
	@ed - netinet.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(ip_output.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME)(tcp_usrreq.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h \
	$(INCRT)/netinet/tcp_debug.h 

$(LIBNAME)(if_ether.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/if_ether.h 

$(LIBNAME)(tcp_input.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h \
	$(INCRT)/netinet/tcp_debug.h 

$(LIBNAME)(tcp_output.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h \
	$(INCRT)/netinet/tcp_debug.h 

$(LIBNAME)(if_loop.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/netisr.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME)(raw_ip.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/net/raw_cb.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h 

$(LIBNAME)(in.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/domain.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/net/af.h 

$(LIBNAME)(ip_icmp.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_icmp.h \
	$(INCRT)/netinet/icmp_var.h 

$(LIBNAME)(tcp_subr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/route.h \
	$(INCRT)/net/if.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/ip_icmp.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h 

$(LIBNAME)(udp_usrreq.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/ip_icmp.h \
	$(INCRT)/netinet/udp.h \
	$(INCRT)/netinet/udp_var.h 

$(LIBNAME)(tcp_debug.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/route.h \
	$(INCRT)/net/if.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h \
	$(INCRT)/netinet/tcp_debug.h 

$(LIBNAME)(tcp_timer.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/tcp.h \
	$(INCRT)/netinet/tcp_fsm.h \
	$(INCRT)/netinet/tcp_seq.h \
	$(INCRT)/netinet/tcp_timer.h \
	$(INCRT)/netinet/tcp_var.h \
	$(INCRT)/netinet/tcpip.h 

$(LIBNAME)(in_pcb.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/sys/protosw.h 

$(LIBNAME)(ip_input.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/domain.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/netisr.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/ip_icmp.h \
	$(INCRT)/netinet/tcp.h 

$(LIBNAME)(in_cksum.o): \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h 

$(LIBNAME)(in_proto.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/domain.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_systm.h 
