# @(#)nfs.mk	6.6

LIBNAME = 	../lib_nfs
INCRT =		..
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(nfs_server.o) \
	$(LIBNAME)(nfs_subr.o) \
	$(LIBNAME)(nfs_vfsops.o) \
	$(LIBNAME)(nfs_vnodeops.o) \
	$(LIBNAME)(nfs_xdr.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp nfs.mk nfs.mk.bak
	@ed - nfs.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(nfs_server.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/ufs/fsdir.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/auth_unix.h \
	$(INCRT)/rpc/svc.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/nfs/nfs.h \
	$(INCRT)/sys/mbuf.h 

$(LIBNAME)(nfs_subr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/nfs/nfs.h \
	$(INCRT)/nfs/nfs_clnt.h \
	$(INCRT)/nfs/rnode.h 

$(LIBNAME)(nfs_vfsops.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/nfs/nfs.h \
	$(INCRT)/nfs/nfs_clnt.h \
	$(INCRT)/nfs/rnode.h 

$(LIBNAME)(nfs_vnodeops.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/nfs/nfs.h \
	$(INCRT)/nfs/nfs_clnt.h \
	$(INCRT)/nfs/rnode.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/ml/pte.h 

$(LIBNAME)(nfs_xdr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/nfs/nfs.h \
	$(INCRT)/netinet/in.h 
