# @(#)os.mk	6.6

LIBNAME1 = 	../lib_os1
LIBNAME2 = 	../lib_os2
LIBNAME3 = 	../lib_os3
INCRT =		..
CFLAGS = 	-DKERNEL -XT5000 $(CFL)
MCFLAGS = 	-DKERNEL $(CFLMCOUNT)

FILES1 = \
	$(LIBNAME1)(audit_sys.o) \
	$(LIBNAME1)(heap_kmem.o) \
	$(LIBNAME1)(init_main.o) \
	$(LIBNAME1)(init_sysent.o) \
	$(LIBNAME1)(kern_acct.o) \
	$(LIBNAME1)(kern_clock.o) \
	$(LIBNAME1)(kern_descrip.o) \
	$(LIBNAME1)(kern_exec.o) \
	$(LIBNAME1)(kern_exit.o) \
	$(LIBNAME1)(kern_fork.o) \
	$(LIBNAME1)(kern_mman.o) \
	$(LIBNAME1)(kern_proc.o) \
	$(LIBNAME1)(kern_prot.o) \
	$(LIBNAME1)(kern_resourc.o) \
	$(LIBNAME1)(kern_sig.o) \
	$(LIBNAME1)(kern_subr.o) \
	$(LIBNAME1)(kern_synch.o) \
	$(LIBNAME1)(kern_time.o) \
	$(LIBNAME1)(kern_xxx.o) \
	$(LIBNAME1)(subr_mcount.o) \
	$(LIBNAME1)(subr_prf.o) \
	$(LIBNAME1)(subr_rmap.o) \
	$(LIBNAME1)(subr_xxx.o)

FILES2 = \
	$(LIBNAME2)(sys_errlog.o) \
	$(LIBNAME2)(sys_flock.o) \
	$(LIBNAME2)(sys_ipc.o) \
	$(LIBNAME2)(sys_lock.o) \
	$(LIBNAME2)(sys_msg.o) \
	$(LIBNAME2)(sys_prof.o) \
	$(LIBNAME2)(sys_sem.o) \
	$(LIBNAME2)(sys_shm.o) \
	$(LIBNAME2)(sys_uts.o) \
	$(LIBNAME2)(sys_generic.o) \
	$(LIBNAME2)(sys_process.o) \
	$(LIBNAME2)(sys_socket.o) \
	$(LIBNAME2)(sys_machdep.o) \
	$(LIBNAME2)(vfs.o) \
	$(LIBNAME2)(vfs_bio.o) \
	$(LIBNAME2)(vfs_dev.o) \
	$(LIBNAME2)(vfs_dnlc.o) \
	$(LIBNAME2)(vfs_io.o) \
	$(LIBNAME2)(vfs_lookup.o) \
	$(LIBNAME2)(vfs_machdep.o) \
	$(LIBNAME2)(vfs_pathname.o) \
	$(LIBNAME2)(vfs_syscalls.o) \
	$(LIBNAME2)(vfs_vnode.o) \
	$(LIBNAME2)(vfs_xxx.o)

FILES3 = \
	$(LIBNAME3)(uipc_domain.o) \
	$(LIBNAME3)(uipc_mbuf.o) \
	$(LIBNAME3)(uipc_pipe.o) \
	$(LIBNAME3)(uipc_proto.o) \
	$(LIBNAME3)(uipc_socket.o) \
	$(LIBNAME3)(uipc_socket2.o) \
	$(LIBNAME3)(uipc_syscall.o) \
	$(LIBNAME3)(uipc_usrreq.o) \
	$(LIBNAME3)(vm_drum.o) \
	$(LIBNAME3)(vm_fast.o) \
	$(LIBNAME3)(vm_mem.o) \
	$(LIBNAME3)(vm_mon.o) \
	$(LIBNAME3)(vm_page.o) \
	$(LIBNAME3)(vm_proc.o) \
	$(LIBNAME3)(vm_pt.o) \
	$(LIBNAME3)(vm_sched.o) \
	$(LIBNAME3)(vm_subr.o) \
	$(LIBNAME3)(vm_sw.o) \
	$(LIBNAME3)(vm_swap.o) \
	$(LIBNAME3)(vm_swp.o) \
	$(LIBNAME3)(vm_text.o)

all:	$(LIBNAME1) $(LIBNAME2) $(LIBNAME3)

.PRECIOUS:	$(LIBNAME1) $(LIBNAME2) $(LIBNAME3)

$(LIBNAME1):	$(FILES1)

$(LIBNAME2):	$(FILES2)

$(LIBNAME3):	$(FILES3)

install:
	-chmod 664 $(LIBNAME1)
	-chgrp bin $(LIBNAME1)
	-chown bin $(LIBNAME1)
	-chmod 664 $(LIBNAME2)
	-chgrp bin $(LIBNAME2)
	-chown bin $(LIBNAME2)
	-chmod 664 $(LIBNAME3)
	-chgrp bin $(LIBNAME3)
	-chown bin $(LIBNAME3)

.c.a:
	@-case $< in \
	subr_mcount.c) \
		if ( expr "$(MCFLAGS)" : '.*-DGPROF' ) > /dev/null ; then \
			echo "        "$< ; \
			$(CC) -S `echo $(MCFLAGS) | sed 's/-O//'` $*.c ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			ex - $*.s < mon.ex ; \
			../inline/inline $*.s $*.i ; \
			if ( expr "$(MCFLAGS)" : '.*-O' ) > /dev/null ; then \
				if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
					$(C2) $*.i $*.s ; \
					if [ $$? != 0 ] ; then \
						exit 1 ; \
					fi ; \
					mv $*.s $*.i ; \
				fi; \
			fi ; \
			$(AS) -o $*.o $*.i ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			ar r $@ $*.o ; \
		fi ; \
		;; \
	*) \
		echo "        "$< ; \
		$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		../inline/inline $*.s $*.i ; \
		if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
			if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
				$(C2) $*.i $*.s ; \
				if [ $$? != 0 ] ; then \
					exit 1 ; \
				fi ; \
				mv $*.s $*.i ; \
			fi ; \
		fi ; \
		$(AS) -o $*.o $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		ar r $@ $*.o ; \
		;; \
	esac
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME1)
	-rm -f $(LIBNAME2)
	-rm -f $(LIBNAME3)

lint:
	@echo ' $(FILES1) $(FILES2) $(FILES3)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES1)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME1)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp os.mk os.mk.bak
	@ed - os.mk < eddep
	@rm eddep makedep
	@grep '^#include' `echo ' $(FILES2)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME2)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp os.mk os.mk.bak
	@ed - os.mk < eddep
	@rm eddep makedep
	@grep '^#include' `echo ' $(FILES3)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME3)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp os.mk os.mk.bak
	@ed - os.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME1)(audit_sys.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/audit.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/ufs/inode.h 

$(LIBNAME1)(heap_kmem.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/param.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vm.h 

$(LIBNAME1)(init_main.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/termio.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/ml/reg.h 

$(LIBNAME1)(init_sysent.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h 

$(LIBNAME1)(kern_acct.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME1)(kern_clock.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/callout.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/clock.h \
	$(INCRT)/sys/gprof.h 

$(LIBNAME1)(kern_descrip.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/flock.h \
	$(INCRT)/sys/ioctl.h 

$(LIBNAME1)(kern_exec.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/audit.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME1)(kern_exit.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/wait.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME1)(kern_fork.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/sysinfo.h 

$(LIBNAME1)(kern_mman.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/wait.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vadvise.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/trace.h \
	$(INCRT)/sys/mman.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(kern_proc.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/wait.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/mbuf.h 

$(LIBNAME1)(kern_prot.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/timeb.h \
	$(INCRT)/sys/times.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/acct.h 

$(LIBNAME1)(kern_resourc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME1)(kern_sig.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/timeb.h \
	$(INCRT)/sys/times.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/acct.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(kern_subr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME1)(kern_synch.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/tty.h 

$(LIBNAME1)(kern_time.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/ml/clock.h 

$(LIBNAME1)(kern_xxx.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/times.h \
	$(INCRT)/sys/vtimes.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/reg.h 

$(LIBNAME1)(subr_mcount.o): \
	$(INCRT)/sys/gprof.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h 

$(LIBNAME1)(subr_prf.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/prf.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME1)(subr_rmap.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME1)(subr_xxx.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/uio.h 


$(LIBNAME2)(sys_errlog.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/err.h \
	$(INCRT)/sys/elog.h \
	$(INCRT)/sys/erec.h \
	$(INCRT)/sys/iobuf.h \
	$(INCRT)/ml/mem.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME2)(sys_flock.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/flock.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/ufs/inode.h 

$(LIBNAME2)(sys_ipc.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h 

$(LIBNAME2)(sys_lock.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/lock.h 

$(LIBNAME2)(sys_msg.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/msg.h 

$(LIBNAME2)(sys_prof.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h 

$(LIBNAME2)(sys_sem.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME2)(sys_shm.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME2)(sys_uts.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/utsname.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ml/vmparam.h 

$(LIBNAME2)(sys_generic.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/dk.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/sys/sysinfo.h 

$(LIBNAME2)(sys_process.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/psl.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/acct.h 

$(LIBNAME2)(sys_socket.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/net/route.h 

$(LIBNAME2)(sys_machdep.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/mtio.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/ml/dkio.h \
	$(INCRT)/ml/pte.h 

$(LIBNAME2)(vfs.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/vnode.h 

$(LIBNAME2)(vfs_bio.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/trace.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/vnode.h 

$(LIBNAME2)(vfs_dev.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h 

$(LIBNAME2)(vfs_dnlc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/types.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/dnlc.h 

$(LIBNAME2)(vfs_io.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/sys/ioctl.h 

$(LIBNAME2)(vfs_lookup.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/pathname.h 

$(LIBNAME2)(vfs_machdep.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h 

$(LIBNAME2)(vfs_pathname.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/dir.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/errno.h \
	$(INCRT)/sys/pathname.h 

$(LIBNAME2)(vfs_syscalls.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/audit.h \
	$(INCRT)/ufs/inode.h 

$(LIBNAME2)(vfs_vnode.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/audit.h \
	$(INCRT)/ufs/inode.h 

$(LIBNAME2)(vfs_xxx.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/attstat.h 


$(LIBNAME3)(uipc_domain.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/domain.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME3)(uipc_mbuf.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME3)(uipc_pipe.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/unpcb.h \
	$(INCRT)/sys/audit.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/fs.h 

$(LIBNAME3)(uipc_proto.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/domain.h \
	$(INCRT)/sys/mbuf.h 

$(LIBNAME3)(uipc_socket.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/un.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/ucbstat.h \
	$(INCRT)/sys/ioctl.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h 

$(LIBNAME3)(uipc_socket2.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/param.h 

$(LIBNAME3)(uipc_syscall.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME3)(uipc_usrreq.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/protosw.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/unpcb.h \
	$(INCRT)/sys/un.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/pathname.h 

$(LIBNAME3)(vm_drum.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME3)(vm_fast.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/ml/pte.h 

$(LIBNAME3)(vm_mem.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/trace.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/ufs/mount.h 

$(LIBNAME3)(vm_mon.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vmmeter.h \
	$(INCRT)/sys/trace.h 

$(LIBNAME3)(vm_page.o): \
	$(INCRT)/ml/reg.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/trace.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME3)(vm_proc.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/mtpr.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/ml/fp_in_krnl.h 

$(LIBNAME3)(vm_pt.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/ml/pte.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME3)(vm_sched.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/kernel.h 

$(LIBNAME3)(vm_subr.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME3)(vm_sw.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/reboot.h \
	$(INCRT)/sys/vnode.h 

$(LIBNAME3)(vm_swap.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/ml/mtpr.h 

$(LIBNAME3)(vm_swp.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/trace.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/vnode.h 

$(LIBNAME3)(vm_text.o): \
	$(INCRT)/ml/pte.h \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/map.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/text.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/seg.h \
	$(INCRT)/sys/vm.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h 
