# @(#)rpc.mk	6.6

LIBNAME = 	../lib_rpc
INCRT =		..
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(auth_none.o) \
	$(LIBNAME)(auth_kern.o) \
	$(LIBNAME)(authunix_prot.o) \
	$(LIBNAME)(clnt_kudp.o) \
	$(LIBNAME)(kudp_fastsend.o) \
	$(LIBNAME)(rpc_prot.o) \
	$(LIBNAME)(subr_kudp.o) \
	$(LIBNAME)(svc.o) \
	$(LIBNAME)(svc_auth.o) \
	$(LIBNAME)(svc_auth_unix.o) \
	$(LIBNAME)(svc_kudp.o) \
	$(LIBNAME)(xdr.o) \
	$(LIBNAME)(xdr_reference.o) \
	$(LIBNAME)(xdr_array.o) \
	$(LIBNAME)(xdr_mbuf.o) \
	$(LIBNAME)(xdr_mem.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp rpc.mk rpc.mk.bak
	@ed - rpc.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(auth_none.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h 

$(LIBNAME)(auth_kern.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/auth_unix.h \
	$(INCRT)/netinet/in.h 

$(LIBNAME)(authunix_prot.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/auth_unix.h 

$(LIBNAME)(clnt_kudp.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h 

$(LIBNAME)(kudp_fastsend.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/if_ether.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/netinet/in_systm.h \
	$(INCRT)/netinet/ip.h \
	$(INCRT)/netinet/ip_var.h \
	$(INCRT)/netinet/udp.h 

$(LIBNAME)(rpc_prot.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h 

$(LIBNAME)(subr_kudp.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/net/if.h \
	$(INCRT)/net/route.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/netinet/in_pcb.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h 

$(LIBNAME)(svc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h \
	$(INCRT)/rpc/svc.h \
	$(INCRT)/rpc/svc_auth.h \
	$(INCRT)/sys/time.h 

$(LIBNAME)(svc_auth.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h \
	$(INCRT)/rpc/svc.h \
	$(INCRT)/rpc/svc_auth.h 

$(LIBNAME)(svc_auth_unix.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/time.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h \
	$(INCRT)/rpc/svc.h \
	$(INCRT)/rpc/auth_unix.h \
	$(INCRT)/rpc/svc_auth.h 

$(LIBNAME)(svc_kudp.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/rpc/auth.h \
	$(INCRT)/rpc/clnt.h \
	$(INCRT)/rpc/rpc_msg.h \
	$(INCRT)/rpc/svc.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/mbuf.h 

$(LIBNAME)(xdr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h 

$(LIBNAME)(xdr_reference.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h 

$(LIBNAME)(xdr_array.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h 

$(LIBNAME)(xdr_mbuf.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/mbuf.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/netinet/in.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(xdr_mem.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/rpc/types.h \
	$(INCRT)/rpc/xdr.h \
	$(INCRT)/netinet/in.h 
