/*	acct.h	6.1	83/07/29	*/

/*
 * Accounting structures;
 * these use a comp_t type which is a 3 bits base 8
 * exponent, 13 bit fraction ``floating point'' number.
 */
typedef	u_short comp_t;

struct	acct
{
	char	ac_flag;	/* Accounting flag */
	char	ac_stat;	/* exit status */
	ushort	ac_uid;		/* Accounting user ID */
	ushort	ac_gid;		/* Accounting group ID */
	dev_t	ac_tty;		/* control typewriter */
	time_t	ac_btime;	/* Beginning time */
	comp_t	ac_utime;	/* Accounting user time in clock ticks */
	comp_t	ac_stime;	/* Accounting system time in clock ticks */
	comp_t	ac_etime;	/* Accounting elapsed time in clock ticks */
	comp_t	ac_mem;		/* average memory usage in clock ticks */
	comp_t	ac_io;		/* characters transferred */
	comp_t	ac_rw;		/* blocks read and written */
	char	ac_comm[8];	/* Accounting command name */
};

#define	AFORK	0001		/* has executed fork, but no exec */
#define	ASU	0002		/* used super-user privileges */
#define	ACOMPAT	0004		/* used compatibility mode */
#define	ACORE	0010		/* dumped core */
#define	AXSIG	0020		/* killed by a signal */
#define	ACCTF	0300		/* record type: 00 = acct */

#ifdef KERNEL
struct	acct	acctbuf;
struct	vnode	*acctp;
#endif
