#ifndef MAXPATHLEN
#ifdef KERNEL
#include "../sys/param.h"
#else
#include <sys/param.h>
#endif
#endif

/*
 * Record written to audit file.
 */
struct aud_rec
{
	unsigned short a_flag;		/* flag bits +0 */
	unsigned short a_uid;		/* effective user-id */
	long	a_time;			/* date and time */
	char	a_comm[MAXPATHLEN+1];	/* command name */
	char	a_path[MAXPATHLEN+1];	/* path name */
};

/* a_flag values */
#define	AUDSUCCESS	0x01		/* file accessed successfully */
#define	AUDREAD 	0x02		/* file opened for reading */
#define	AUDWRITE	0x04		/* file opened for writing */
#define	AUDEXEC		0x08		/* file executed */
#define	AUDUNLINK	0x10		/* file removed */
#define	AUDOFFTON	0x20		/* status changed to sensitive */
#define	AUDONTOFF	0x40		/* status changed to non-sensitive */

/*
 * Audit system call flags.
 */
#define	UNSECURE	0		/* turn audit trail security off */
#define	SECURE		1		/* turn audit trail security on */
#define	QUERY		2		/* request audit trail security */
#define	MASK		3		/* set audit status with umask */
#define	AUDMASK	010000		/* flag bit in the umask to turn on auditing */

#ifdef KERNEL

#define	SUCCESS		0
#define	FAILURE		1

#define	AUDPRI	26				/* Sleeping on audbuf priority */

struct vnode *audvp;

#endif
