/* @(#)bscio.h	1.7 REL */
struct bscio {
	unsigned short b_blks;	/* max blksize | #sent/rcvd */
	unsigned short b_flags;	/* see description to follow */
	char b_termid[20];	/* our terminal id */
	char b_hostid[20];	/* host id */
	char b_nbid;		/* bid limit   | count */
	char b_nnak;		/* nak limit   | count */
	char b_nretry;		/* retry limit | count */
	char b_nttd;		/* ttd limit   | count */
	char b_nwack;		/* wack limit  | count */
	short b_nor;		/* initial read timeout |
				   overrun count */
};
#define	BSCGET		_IOR(b,1,struct bscio)	/* get current bscio block */
#define BSCSET		_IOW(b,2,struct bscio)	/* set new bscio parameters */
#define BSCTRNSP	_IO(b,3)	/* set transparent mode */
#define BSCNTRNS	_IO(b,4)	/* reset transparent mode */
#define BSCSOH		_IO(b,5)	/* start next block with SOH */
#define BSCLAST		_IO(b,6)	/* Last block in series to send */
#define BSCNSOH		_IO(b,7)	/* Negate effect of BSCSOH */
#define BSCID		_IOR(b,8,int)	/* Terminal identification */
#define	BSCNDLY		_IO(b,9)	/* Don't delay on read */
#define BSCFACK		_IO(b,10)	/* Fast ack mode for read -> write */
#define BSWAK		_IO(b,11)	/* Send WAK out */

/* important information: */
#define BSCMBLK	4096		/* max. for b_blks on set (max block size) */

/* b_flags on SET: */
#define BSCASCII	0x0001	/* transmission code is ascii */
#define BSCFDX		0x0002	/* full duplex modems being used */
#define BSCIUS		0x0004	/* unit separators in use */
#define BSCRVIABT	0x0008	/* abort on RVI */
#define BSCPRIM		0x0010	/* we are primary node */
#define BSCCKHOST	0x0020	/* chk host id, abort if wrong */
#define BSCMPT		0x0040	/* multi-point protocol */
#define BSC_UFLAGS	0x007f	/* mask for user-defined flags */

/* b_flags on GET: */
#define BSCPROTO	1	/* protocol error by remote host */
#define BSCRVI		2	/* RVI abort */
#define BSCNBID		3	/* NBID limit exceeded */
#define BSCNNAK		4	/* NNAK limit exceeded */
#define BSCNRETR	5	/* NRETRY limit exceeded */
#define BSCNTTD		6	/* NTTD limit exceeded */
#define BSCNWACK	7	/* NWACK limit exceeded */
#define BSCNDSR		8	/* no DSR indication from modem */
#define BSCTXTO		9	/* transmit timeout */
#define BSCRXTO		10	/* idle receive timeout */
#define BSCDSC		11	/* remote end sent DISC (DLE-EOT) */
#define BSCRABT		12	/* remote end aborted our sending */
#define BSCEEOF		13	/* remote end aborted their sending */
#define BSCWHI		14	/* wrong host id */
#define BSCTXP		15	/* block received in transparent mode */
				/* (not an error) */
#define BSCBSOH		16	/* block began with SOH */
				/* (not an error) */
#define	BSCONTND	17	/* line contention (not an error) */
#define	BSC2BIG		18	/* Received block exceeded BSCMBLK bytes */
