/*	errno.h	6.1	83/07/29	*/

/*
 * Error codes
 */

#define	EPERM		1		/* Not owner */
#define	ENOENT		2		/* No such file or directory */
#define	ESRCH		3		/* No such process */
#define	EINTR		4		/* Interrupted system call */
#define	EIO		5		/* I/O error */
#define	ENXIO		6		/* No such device or address */
#define	E2BIG		7		/* Arg list too long */
#define	ENOEXEC		8		/* Exec format error */
#define	EBADF		9		/* Bad file number */
#define	ECHILD		10		/* No children */
#define	EAGAIN		11		/* No more processes */
#define	ENOMEM		12		/* Not enough core */
#define	EACCES		13		/* Permission denied */
#define	EFAULT		14		/* Bad address */
#define	ENOTBLK		15		/* Block device required */
#define	EBUSY		16		/* Mount device busy */
#define	EEXIST		17		/* File exists */
#define	EXDEV		18		/* Cross-device link */
#define	ENODEV		19		/* No such device */
#define	ENOTDIR		20		/* Not a directory*/
#define	EISDIR		21		/* Is a directory */
#define	EINVAL		22		/* Invalid argument */
#define	ENFILE		23		/* File table overflow */
#define	EMFILE		24		/* Too many open files */
#define	ENOTTY		25		/* Not a typewriter */
#define	ETXTBSY		26		/* Text file busy */
#define	EFBIG		27		/* File too large */
#define	ENOSPC		28		/* No space left on device */
#define	ESPIPE		29		/* Illegal seek */
#define	EROFS		30		/* Read-only file system */
#define	EMLINK		31		/* Too many links */
#define	EPIPE		32		/* Broken pipe */

/* math software */
#define	EDOM		33		/* Argument too large */
#define	ERANGE		34		/* Result too large */

/* sys5 ipc */
#define ENOMSG		35		/* No message of desired type */
#define EIDRM		36		/* Identifier removed */

/* non-blocking and interrupt i/o */
#define	EWOULDBLOCK	37		/* Operation would block */
#define	EINPROGRESS	38		/* Operation now in progress */
#define	EALREADY	39		/* Operation already in progress */
/* ipc/network software */

	/* argument errors */
#define	ENOTSOCK	40		/* Socket operation on non-socket */
#define	EDESTADDRREQ	41		/* Destination address required */
#define	EMSGSIZE	42		/* Message too long */
#define	EPROTOTYPE	43		/* Protocol wrong type for socket */
#define	ENOPROTOOPT	44		/* Protocol not available */
#define	EPROTONOSUPPORT	45		/* Protocol not supported */
#define	ESOCKTNOSUPPORT	46		/* Socket type not supported */
#define	EOPNOTSUPP	47		/* Operation not supported on socket */
#define	EPFNOSUPPORT	48		/* Protocol family not supported */
#define	EAFNOSUPPORT	49		/* Address family not supported by protocol family */
#define	EADDRINUSE	50		/* Address already in use */
#define	EADDRNOTAVAIL	51		/* Can't assign requested address */

	/* operational errors */
#define	ENETDOWN	52		/* Network is down */
#define	ENETUNREACH	53		/* Network is unreachable */
#define	ENETRESET	54		/* Network dropped connection on reset */
#define	ECONNABORTED	55		/* Software caused connection abort */
#define	ECONNRESET	56		/* Connection reset by peer */
#define	ENOBUFS		57		/* No buffer space available */
#define	EISCONN		58		/* Socket is already connected */
#define	ENOTCONN	59		/* Socket is not connected */
#define	ESHUTDOWN	60		/* Can't send after socket shutdown */
#define	ETOOMANYREFS	61		/* Too many references: can't splice */
#define	ETIMEDOUT	62		/* Connection timed out */
#define	ECONNREFUSED	63		/* Connection refused */

	/* */
#define	ELOOP		64		/* Too many levels of symbolic links */
#define	ENAMETOOLONG	65		/* File name too long */

/* should be rearranged */
#define	EHOSTDOWN	66		/* Host is down */
#define	EHOSTUNREACH	67		/* No route to host */
#define	ENOTEMPTY	68		/* Directory not empty */

/* quotas & mush */
#define	EPROCLIM	69		/* Too many processes */
#define	EUSERS		70		/* Too many users */
#define	EDQUOT		71		/* Disc quota exceeded */

/* for lockf */
#define EDEADLK 	72		/* Record locking deadlock */

/*
 * the following have been added for X.25 & VIOC-BOP board
 */

#define ECHNRST		79	/* channel is reset		*/
#define EXLNERR		80	/* Link error 			*/
#define EXNFST		81	/* fast select incorrectly used */
#define EXFORBID	82	/* no read/write on channel # 0 */
#define EXCANCEL	83  	/* get next call request is cancelled */
#define EXCOLLIN	84	/* call collision		*/
#define EXNONE		85	/* circuit not exist		*/
#define EXARATT 	86 	/* the circuit is already attached */
#define EXBADCOM 	87 	/* level 2 is not operational	*/
#define EXBADPAC 	88 	/* bad packet size specified in the facility */
#define EXBADPAR 	89	/* bad parameters	  	*/
#define EXBADSTATE 	90 	/* the x25 in the wrong state	*/
#define EXBADWIN 	91  	/* bad window size specified in the facility */
#define EXDWAS 		92 	/* the circuit is already detached */
#define EXEXMAX 	93 	/* circuit not available 	*/
#define EXLNCON 	94 	/* link is not configured	*/
#define EXLNOP 		95 	/* link is not opened		*/
#define EXLOBND 	96 	/* link # is out of bond	*/
#define EXMULRQ 	97	/* multiple requests for same pid */
#define EXNATT 		98 	/* circuit is not attached	*/
#define EXNOFAC 	99 	/* invalid facility		*/
#define EXNRES 		100 	/* buffer resources are not available */
#define EXRDEXCD 	101 	/* read threash hold exceeds maximum */
#define EXTMOUT 	102 	/* the command is timed out	*/
#define EXWOVER 	103	/* window overfolw 		*/
#define EXCACLR 	104	/* NOT AN ERROR: the circuit is being 
				   cleared there is no circuit being 
				   set up */
#define EXRANGE 	105	/* the index number is out of range   */
#define ELNKDWN		106 	/* vioc-bop link is down */ 
#define EREOPEN		107 	/* to open an already opened port */
#define ERECLOS		108 	/* to close an already closed port */
#define ERTRYEX		109 	/* retry exceed			*/
#define ELNKRST		110 	/* link being reset or circuit being reset*/
#define ELIDLE		111	/* link idle			*/
#define EIDLESTOP	112	/* Link is no more idle 	*/
#define EBUFOK		113	/* buffer congestion relieved	*/
#define XNERST		114	/* X.25 release buffer (reset)	*/
#define XNIL2E		115	/* X.25 level 2 error detected	*/
#define EREMBSY		116	/* remote station busy 		*/
#define EXNOACT		117	/* link or channel not active	*/

#define EXBADFAC	118	/* bad facility specified */
#define EBUFLOW		119	/* VIOC-BOP low on buffers      */
#define EVERR  		120	/* VIOC-BOP is broken           */
#define EXMIT  		121	/* VIOC-BOP xmit error 		*/
#define EVOVRFL 	122	/* VIOC-BOP overflow		*/
#define EBADCMP 	123	/* bad component		*/

/* Network File System */
#define	ESTALE		124	/* Stale NFS file handle */
#define	EREMOTE	      	125	/* Too many levels of remote in path */
