/* @(#)ipc.h	6.1 */
/* Common IPC Access Structure */

struct ipc_perm {
	u_short	uid;	/* owner's user id */
	u_short	gid;	/* owner's group id */
	u_short	cuid;	/* creator's user id */
	u_short	cgid;	/* creator's group id */
	u_short	mode;	/* access modes */
	u_short	seq;	/* slot usage sequence number */
	key_t	key;	/* key */
	u_char 	flag;	/* status flag */
};

/* Common IPC Definitions. */
/* Mode bits. */
#define	IPC_ALLOC	0x8000		/* entry currently allocated */
#define	IPC_CREAT	0x0200		/* create entry if key doesn't exist */
#define	IPC_EXCL	0x0400		/* fail if key exists */
#define	IPC_NOWAIT	0x0800		/* error if request must wait */

/* Keys. */
#define	IPC_PRIVATE	(key_t)0	/* private key */

/* Control Commands. */
#define	IPC_RMID	0	/* remove identifier */
#define	IPC_SET		1	/* set options */
#define	IPC_STAT	2	/* get options */

/* Defines for locking */

#define IPC_LOCK	0x01	/* ipc_perm structure is locked */
#define IPC_WANT	0x02	/* want to lock ipc_perm structure */
