/*	mtio.h	6.1	83/07/29	*/

/*
 * Structures and definitions for mag tape io control commands
 */

/* structure for MTIOCTOP - mag tape op command */
struct	mtop	{
	short	mt_op;		/* operations defined below */
	daddr_t	mt_count;	/* how many of them */
};
#define mt_drivetype	mt_count	/* used only by SETTYPE ioctl */
#define MAX_BLOCKSIZE	(TBUFSIZ*NBPG)

/* operations */
#define MTWEOF	0	/* write an end-of-file record */
#define DO_W_FM MTWEOF
#define MTFSF	1	/* forward space file */
#define DO_SFMF MTFSF
#define MTBSF	2	/* backward space file */
#define DO_SFMB MTBSF
#define MTFSR	3	/* forward space record */
#define DO_SPF MTFSR
#define MTBSR	4	/* backward space record */
#define DO_SPB MTBSR
#define MTREW	5	/* rewind */
#define DO_RWTA MTREW
#define MTOFFL	6	/* rewind and put the drive offline */
#define DO_RWUN MTOFFL
#define MTNOP	7	/* no operation, sets status only */
#define DO_STAT MTNOP
#define MTSTAT MTNOP
#define MTSYNC	8	/* wait for all pending xylogics iopbs to complete */
#define DO_SYNC		MTSYNC
#define MTSETTYPE	9
#define DO_SETTYPE	MTSETTYPE
#define XYIOCTL 10
#define	DO_RWOV		10
#define DO_WAIT 	11
#define DO_WEOV		12
#define DO_RRD		13
#define DO_RWT		14
#define DO_BRD		15
#define DO_BWT		16

#define MTNUMCMDS	17
#define MTIOCTLS	13
#define MTRDWR		17
#define USER_PERMITTED_IOCTLS 8
/* All ioctls <= USER_PERMITTED_IOCTLS can be issued by a user.
   DO_SETTYPE can be issued by root (when changing drive types).
   All others are for internal use only. */

/* structure for MTIOCGET - mag tape get status command */

struct	mtget	{
	short	mt_type;	/* type of magtape device */
/* the following two registers are grossly device dependent */
	short	mt_dsreg;	/* ``drive status'' register */
	short	mt_erreg;	/* ``error'' register */
/* end device-dependent registers */
	short	mt_resid;	/* residual count */
/* the following two are not yet implemented */
	daddr_t	mt_fileno;	/* file number of current position */
	daddr_t	mt_blkno;	/* block number of current position */
/* end not yet implemented */
};

/*
 * Constants for mt_type byte
 */
#define	MT_ISTS		0x01
#define	MT_ISHT		0x02
#define	MT_ISTM		0x03
#define	MT_ISMT		0x04
#define	MT_ISUT		0x05
#define	MT_ISCPC	0x06
#define	MT_ISAR		0x07
#define	MT_ISCY		0x08
#define MT_ISXYLOGICS 	0x09

/*
** ----DRIVE TYPES---- 
** These names correspond to ascii strings in drivename.c.
**
**	constant				string name (for mt command)
**	========				============================
*/
#define CIPHERF880 	0			/* cipherf880 */
#define CIPHER880 CIPHERF880			/* cipher880 */
#define CIPHER CIPHERF880			/* cipher */
#define CIPHERF890	1 			/* cipherf890 */
#define CIPHER890 CIPHERF890			/* cipher890 */
#define CIPHERM990	2			/* cipherm990 */
#define CIPHER990 CIPHERM990			/* cipher990 */
#define CDC92181	3			/* cdc92181 */
#define CDC92185	4			/* cdc92185 */
#define FUJI2242	5			/* fuji2242 */
#define KENNEDY9400	6			/* kennedy9400 */
#define KENNEDY9600	7			/* kennedy9600 */
#define PERTECFS1000	8			/* pertecfs1000 */
#define PERTECFS2000	9			/* pertecfs2000 */
#define STC2920		10			/* stc2920 */
#define STC STC2920				/* stc */
#define TELEXSHAMROCK	11			/* telexshamrock */
#define THORN9800	12			/* thorn9800 */
#define THORN9900	13			/* thorn9900 */
#define HARRIS6330	14			/* 6330 */
#define HARRIS6331	15			/* 6331 */
#define HARRIS6350	16			/* 6350 */
#define HARRIS6351	17			/* 6351 */
#define HARRIS6740	18			/* 6740 */
#define CIPHER891	19			/* cipher891 */
#define NUMDRIVETYPE	20


/* mag tape io control commands */
#define	MTIOCTOP	_IOW(m, 1, struct mtop)		/* do a mag tape op */
#define	MTIOCGET	_IOR(m, 2, struct mtget)	/* get tape status */


#ifndef KERNEL
#define	DEFTAPE	"/dev/rmt/0ms"
#endif
