/*	reboot.h	6.1	83/07/29	*/

/*
 * Arguments to reboot system call.
 * These are passed to boot program in r11,
 * and on to init.
 */
#define	RB_AUTOBOOT	0	/* flags for system auto-booting itself */

#define RB_USR_MASK     0xffff  /* This is the operator settable portion */
                                /* of this register */

#define RB_SYS_MASK     0xffff0000  /* This is the system settable portion */
                                /* of this register */

#define RB_PRIMARY_IO( _x )     ((( _x ) & 0x30000) >> 16)
#define RB_SECONDARY_IO( _x )   ((( _x ) & 0xC0000) >> 18)
#define RB_NO_BUS       0x00
#define RB_VERSA_BUS    0x01
#define RB_VME_BUS      0x02
#define RB_RESERVED     0x03

#define	RB_ASKNAME	0x001	/* ask for file name to reboot from */
#define	RB_SINGLE	0x002	/* reboot to single user only */
#define	RB_NOSYNC	0x004	/* dont sync before reboot */
#define	RB_DCOFF	0x004	/* dont enable data cache before starting */
#define	RB_HALT		0x008	/* don't reboot, just halt */
#define	RB_INITNAME	0x010	/* name given for /etc/init */
#define RB_RESET_SYSCON 0x020	/* Reset system console */
#define RB_GENERIC      0x040	/* If set this is a generic boot. */
#define RB_DEBUG        0x080	/* This is the debugging option.  */
#define RB_LOAD_ONLY    0x100	/* Load then halt before executing. */

#define	RB_PANIC	0	/* reboot due to panic */
#define	RB_BOOT		1	/* reboot due to boot() */
