/*	ttychars.h	6.1	83/07/29	*/

#ifndef _TTYCHARS_
#define	_TTYCHARS_

/*
 * User visible structures and constants
 * related to terminal handling.
 */
struct ttychars {
	char	tc_erase;	/* erase last character */
	char	tc_kill;	/* erase entire line */

	char	tc_intrc;	/* interrupt */
	char	tc_quitc;	/* quit */
	char	tc_startc;	/* start output */
	char	tc_stopc;	/* stop output */
	char	tc_eofc;	/* end-of-file */
	char	tc_brkc;	/* input delimiter (like nl) */
	char	tc_fill1;	/* to fill up to sizeof struct tchars */
	char	tc_fill2;       /* tchars is long word aligned */

	char	tc_suspc;	/* stop process signal */
	char	tc_dsuspc;	/* delayed stop process signal */
	char	tc_rprntc;	/* reprint line */
	char	tc_flushc;	/* flush output (toggles) */
	char	tc_werasc;	/* word erase */
	char	tc_lnextc;	/* literal next character */
	char	tc_fill3;	/* to fill up to sizeof struct ltchars */
	char	tc_fill4;       /* ltchars is also long word aligned */
};

#define	CTRL(c)	('c'&037)

/* default special characters */

/*
 * If _TERMIO_ is defined, let its default values take precedence.
 * In the KERNEL, make sure TERMIO's default values are the ones
 * used instead of making it dependent on the order the files are
 * included.
 */

#if !defined(KERNEL) && !defined(_TERMIO_)
#define	CERASE	0177
#define	CKILL	CTRL(u)
#define	CINTR	CTRL(c)
#define	CQUIT	CTRL(\\)
#define	CSTART	CTRL(q)
#define	CSTOP	CTRL(s)
#define	CEOF	CTRL(d)
#define	CEOT	CEOF
#define	CBRK	0377
#endif	!defined(KERNEL) && !defined(_TERMIO_)

#define	CSUSP	CTRL(z)
#define	CDSUSP	CTRL(y)
#define	CRPRNT	CTRL(r)
#define	CFLUSH	CTRL(o)
#define	CWERASE	CTRL(w)
#define	CLNEXT	CTRL(v)

#endif _TTYCHARS_
