/* Definitions */

#define	XYMAXCONTROLLERS	4
#define XYMAXDRIVES		32

#define	TRUE		1
#define	FALSE		0

#define	b_command	b_resid

#define	b_cmd	av_back		/* unused word in request */


/* ----XYLOGICS COMMANDS---- */
#define XYNOP				0
#define XYWRITE				1
#define XYREAD				2
#define XYPOSITION			3
#define XYDRIVE_RESET			4
#define XYWRITE_PARAMS			5
#define XYREAD_PARAMS			6
#define XYEXTENDED_WRITE		7
#define XYEXTENDED_READ			8
#define XYDIAGNOSTICS			9
#define XYABORT				0xa
#define XYSET_DRIVE_PARAMS		0xb
#define XYCMD_PASS			0xc
#define XYHANDLER			0xd

/* ----XYLOGICS SUBCOMMANDS---- */
#define XYNOSUBCODE			0x00
#define XYSPACE_FORWARD			0x20
#define XYSPACE_REVERSE			0x21
#define XYFILE_SEARCH_FORWARD		0x40
#define XYFILE_SEARCH_REVERSE		0x41
#define XYREWIND			0x21
#define XYUNLOAD_OFF_LINE		0x22
#define XYWRITE_CTLR_PARMS		0x00
#define XYWRITE_DRIVE_PARMS		0x20
#define XYWRITE_FILE_MARK		0x20
#define XYDRIVE_NOP			0x40
#define XYSET800			0x44
#define XYSET1600			0x45
#define XYSET3200			0x46
#define XYSET6250			0x47

#define DENSITY_DEFAULT			0x00


/* States used by system activity and error logging */
#define	SSEEK		1		/* seeking */
#define	SIO		2		/* doing seq i/o */
#define	SCOM		3		/* sending control command */
#define	SREW		4		/* sending a drive rewind */



#define virt_to_phys(virtual_address) \
((unsigned int)virtual_address & 0x3fffffff)

#define phys_to_virt(physical_address) \
((unsigned int)physical_address | 0xc0000000)

#define SET_IOPB_ADDRS(addrs,value) \
{ \
unsigned int physvalue = (unsigned int)virt_to_phys(value) ; \
((struct xylogics_registers *)addrs)->addrs0_reg=(unsigned char)(physvalue>>24);  \
((struct xylogics_registers *)addrs)->addrs1_reg=(unsigned char)((physvalue>>16)&0xff);  \
((struct xylogics_registers *)addrs)->addrs2_reg=(unsigned char)((physvalue>>8)&0xff);\
((struct xylogics_registers *)addrs)->addrs3_reg=(unsigned char)(physvalue&0xff); \
}

#define UNCACHE_IOPB_ADDRS(addrs) \
( \
uncache(&((struct xylogics_registers *)addrs)->addrs0_reg), \
uncache(&((struct xylogics_registers *)addrs)->addrs1_reg), \
uncache(&((struct xylogics_registers *)addrs)->addrs2_reg), \
uncache(&((struct xylogics_registers *)addrs)->addrs3_reg) \
)

#define GET_IOPB_ADDRS(addrs) \
( \
(caddr_t)phys_to_virt( \
(unsigned int)(((struct xylogics_registers *)addrs)->addrs0_reg<<24) + \
(unsigned int)(((struct xylogics_registers *)addrs)->addrs1_reg<<16) + \
(unsigned int)(((struct xylogics_registers *)addrs)->addrs2_reg<<8)  + \
(unsigned int)(((struct xylogics_registers *)addrs)->addrs3_reg))  \
)


#define SET_IOPB_ADDRS_MOD(addrs,value) \
((struct xylogics_registers *)addrs)->addrs_mod_reg=value 

#define UNCACHE_IOPB_ADDRS_MOD(addrs) \
uncache(&((struct xylogics_registers *)addrs)->mod_reg)

#define GET_IOPB_ADDRS_MOD(addrs) \
(unsigned char)(( struct xylogics_registers *)addrs)->mod_reg \

#define SET_CONTROL_REG(addrs,value) \
((struct xylogics_registers *)addrs)->csr_reg=value 


#define UNCACHE_STATUS_REG(addrs) \
uncache(&((struct xylogics_registers *)addrs)->csr_reg)

#define GET_STATUS_REG(addrs) \
((unsigned char)((struct xylogics_registers *)addrs)->csr_reg) 

#define GET_ERROR_CODE(addrs) \
(unsigned char)(xylogics_registers *)addrs->error_reg


#define XYSLAVE(device) \
(xy_unit_info[XYUNIT(device)].vba_unit->ui_slave)

#define XYCTLRNUM(device) \
(xy_unit_info[XYUNIT(device)].vba_unit->ui_ctlr)

#define XYDRIVETYPE(device) \
(xy_unit_info[XYUNIT(device)].vba_unit->ui_type)

#define XYCTLRADDRS(device) \
(xy_unit_info[XYUNIT(device)].vba_unit->ui_addr)

#define REWINDING_VARIETY(device) \
(minor(device) & 0x1)

#define XYSPEED(device) \
((unsigned char)(minor(device) & 0x2)>>1)

#define XYDENSITY(device) \
(unsigned char)((minor(device) & 0xc)>>2)

#define XYUNIT(device) \
(unsigned char)(minor(device) >> 4) 

#define WRITEREQUEST(request) \
(((int)request->b_cmd==DO_RWT) || \
((int)request->b_cmd==DO_BWT))

#define READREQUEST(request) \
(((int)request->b_cmd==DO_RRD) || \
((int)request->b_cmd==DO_BRD))

#define back_movement( command ) \
(( command == MTBSF ) || \
( command == MTBSR ) || \
( command == MTREW ) || \
( command == MTOFFL ) ) 

/* ----MISCELLANEOUS DEFINITIONS---- */

#define XYASYNCBUFSZ 100 /* pages */

/*
	The maximum blocksize is determined by the controller.  Each
	iopb can point to at most 32 scatter/gather iopbs, and each of these
	must reference a block of physically contiguous bytes.  We take the
	simplifying approach of allowing each s/g iopb to point to up to
	one page of data; therefore, the maximum single transfer that can
	be guaranteed (even when data is not page-aligned) is 31k).
*/
#define XYMAX_BLOCKSIZE 31*NBPG 

#define XYSUPERVISORY_MODE 0x0d
#define XYNON_PRIVILEGED_MODE 0x29
#define XYADDRS_MOD XYSUPERVISORY_MODE
#define B_RETRY 0x800000
#define DATA_BUSY_TIMEOUT 0xff /* about 60 seconds */
#define INTERRUPT_LEVEL 0x5 /* if change this -> change spl's in xylogics.c */
#define XYTHROTTLE 16
#define VECTOR_BASE 0x94
#define WAITCOUNT 0xff
#define POLLEDWAITCOUNT 0xffffff /* ??? THIS VALUE IS A TOTAL GUESS ??? */
#define SLEEP_RESET &xydriver
#define DO_POLL 1
#define DO_NOT_POLL 0


/* ----RECOVERY CODES---- */
#define XYNOACTION 			0x00
#define XYPROG_ERR 			0x10
#define XYRECOVERED 			0x30
#define XYRETRY 			0x40
#define XYRESET_RETRY 			0x60
#define XYNORETRY 			0x70
#define XYMISC 				0x80
#define XYMANUAL 			0x90
#define XYLOST 				0xa0
#define RECOVERY_CODE 0xf0

/* ----CONTROL/STATUS BITS---- */
#define XYREG_BUSY_SEM 			0x1
#define XYREMOVE_IOPB 			0x2
#define XYAIO	 		 	0x4
#define XYCONTROLLER_RESET	 	0x8
#define XYMAINT_MODE			0x20
#define XYFATAL_ERROR			0x40
#define XYBUSY				0x80

/* ----CURRENT STATE (IOPB BYTE2) BITS---- */
#define STATE_WRITE_PROTECT			0x1
#define STATE_HIT_EOT				0x2
#define STATE_HIT_FM				0x8
#define STATE_LONG_RECORD			0x10
#define STATE_SHORT_RECORD			0x20
#define STATE_CORRECTED_ERROR			0x40
#define STATE_HARD_TAPE_ERROR			0x80

/* ----CURRENT STATE (IOPB BYTE3) BITS---- */
#define STATE_ONLINE				0x1
#define STATE_READY				0x2
#define STATE_ONLINEANDREADY			0x3
#define STATE_FORMATTER_BUSY			0x4
#define STATE_TRANSFERING			0x8
#define STATE_REWINDING				0x10
#define STATE_HIT_BOT				0x20
#define STATE_HIGH_SPEED			0x40

/* ----ERRORS---- */
#define SUCCESS				0x00
#define ILL_DENSITY_CHG			0x10
#define ILL_PARM_COMBO			0x11
#define BYTE_COUNT_ERROR		0x12
#define COUNT_ZERO			0x13
#define ILL_COMMAND			0x14
#define ILL_SG_LENGTH			0x1c
#define NEXT_IOPB_ALIGN_ERR		0x1e
#define CORRECTED_DATA			0x30
#define HARD_TAPE_ERROR			0x40
#define EOT_DETECTED			0x41
#define FM_WRITE_FAULT			0x42
#define OPERATION_TIMEOUT		0x43
#define DMAC_TIMEOUT			0x44
#define TAPE_PAR_ERR			0x45
#define BUFFER_PAR_ERR			0x46
#define LONG_RECORD			0x47
#define SHORT_RECORD			0x48
#define DATA_LATE			0x49
#define FATAL_DMAC_ERR			0x4a
#define VME_BUS_ERR			0x4b
#define CONT_RELOAD_ERR			0x4c
#define DRIVE_FAULT			0x60
#define DRIVE_NOT_READY			0x61
#define FIRMWARE_FAILURE		0x71
#define IRAM_CKSUM_ERR			0x81
#define IOPB_ABORT_CMD			0x82
#define IOPB_ABORT_ERR			0x83
#define REEL_WRITE_PROTECTED		0x90
#define DRIVE_OFF_LINE			0x91
#define REVERSE_INTO_BOT		0xa0
#define FM_ON_READ			0xa1

#define XYTOOLARGE 0xb0
#define XYNOTREADY 0xb1
#define XYWAIT_TIMEOUT 0xb2
#define XYOUTOFORDER 0xb3
#define XYUNCORRECTABLE 0xb4
#define XYNOERROR 0xb5
#define XYNUMERRORS 39


#ifndef LOCORE


/* PER CONTROLLER STRUCTURE */
struct ctlr_tab
{
	struct unit_tab *unit_list ;
	unsigned int	interrupt_vector ;
	unsigned int	wanted ;
		/* count of number of processes sleeping on this controller */
} ;


/* PER DRIVE STRUCTURE */
struct unit_tab 
{
	int			open_flags ;
		/*copy of flags used on open call*/
	int			block_num ;
		/*current block number, relative to beginning (end) 
		of current file*/
	unsigned long		file_num ;
		/*file number, relative to beginning of tape*/
	unsigned short		last_op ;
		/*last operation on this unit*/
	unsigned short 		last_resid ;
		/*copy of b_resid from last request processed on this drive*/
	unsigned short		last_status ;
		/*status from last completed command (iopb bytes 2 and 3)*/
	unsigned short		last_err ;
		/*iopb byte 1 from last completed command. */
	struct unit_tab		*next_drive ;
		/*pointer to next drive on this controller*/
	unsigned		open : 1 ;
		/*drive is currently open*/
	unsigned		eof : 1 ;
		/*tape is currently positioned at end of a file*/
	unsigned		bot : 1 ;
		/*tape is currently at beginning of tape*/
	unsigned		eot : 1 ;
		/*tape is currently at end of tape*/
	unsigned		async : 1 ;
		/*drive is opened for async writes*/
	unsigned		can_read : 1;
		/*boolean indicates fm's have been written since last write*/
	int			settype : 1 ;
		/*boolean indiactes that this drive is opened for setting type*/
	int			aborting : 1 ;
		/*boolean indicates whether abort is in progress*/
	int			doingretry ;
		/*boolean indicates whether retries are occuring*/
	int			doingsync ;
		/*boolean indicates whether synchronize is occuring*/
	caddr_t			inuse ;
		/*pointer to proc which is currently using this drive*/
	unsigned		wanted ;
		/*count of number of processes sleeping on this drive */
	struct vba_device	*vba_unit ;
		/*pointer to corresponding vba_device structure*/
	struct buf		*xy_wait_buffer_list ;
		/*list of requests waiting for buffer [async writes]*/
	struct iopb		*asynchead ;
		/*start of list of async write iopbs on this drive*/
	char			*asyncstart ;
		/*start location of async buffer for this drive*/
	char			*asyncend ;
		/*end location of async buffer for this drive*/
	struct iopb		*ondrivehead ;
		/*head of list of iopbs outstanding on this drive*/
	struct iopb		*ondrivetail ;
		/*tail of list of iopbs outstanding on this drive*/
	struct iopb		*retryhead ;
		/*head of list of iopbs awaiting retry after abort*/
	struct iopb		*retrytail ;
		/*tail of list of iopbs awaiting retry after abort*/
	short			device ;
		/*major/minor numbers of this device*/
	char			*message ;
		/*error message from last command*/
} ;



/*STANDARD XYLOGICS IOPB*/
struct iopb
{
	unsigned	error_detect : 1 ;
		/*1, if controller detected errors*/
	unsigned	done : 1 ;
		/*1, if this iopb has been completed (set by controller)*/
	unsigned	chain : 1 ;
		/*1, if this iopb is part of a larger chain (unused)*/
	unsigned	scat_gath : 1 ;
		/*1, if this iopb points to a scatter/gather list*/
	unsigned	cmd : 4 ;
		/*controller command*/
	unsigned char	completion_code ;
		/*controller completion code (controller status byte 1)*/
	unsigned char	status ;
		/*controller status byte two */
	unsigned char	current_state ;
		/*controller status byte three*/
	unsigned char	subfunction ;
		/*controller subfunction code*/
	unsigned	unused1 : 5 ;
	unsigned	slave_num : 3 ;
		/*unit number on this controller*/
	unsigned	list_length : 5 ;
		/*length of scatter/gather linked list, in 8 byte units*/
#define NUM_SGIOPB_PER_IOPB 32
	unsigned	interrupt_level : 3 ;
		/*level at which controller will interrupt when done*/
	unsigned char	interrupt_vector ;
		/*interrupt vector controller will use on command completion*/
	unsigned short	byte_count ;
		/*number of bytes desired to transfer*/
	unsigned char	last_error ;
		/*code of last recovered or ignored error on this iopb*/
	unsigned char	error_count ;
		/*number of retries needed to recover an error*/
	unsigned short	actual_count ;
		/*number of bytes actually transfered*/
	unsigned	unused2 : 2 ;
	unsigned	data_addrs_mod : 6 ;
		/*if scat_gath is set, the link list address modifier; 
		otherwise, the data address modifier*/
	unsigned	priority : 1 ;
	unsigned	unused3 : 1 ;
	unsigned	next_iopb_addrs_mod : 6 ;
		/*address modifier of next iopb in chain (unused)*/
	unsigned	data_addrs ;
		/*if scat_gath is set, address of scatter/gather linked list;
		otherwise, address of data buffer*/
	unsigned	next_iopb_addrs ;
		/*address of next iopb in chain (unused)*/
	unsigned short	iopb_chksum ;
		/*checksum (unused)*/

	/* software extension */
	union{
	struct buf	*request ;
		/*pointer to request which generated this IOPB*/
	struct iopb	*iopb_next ;
		/*pointer to next_iopb on free list*/
	}  iopb_ptr ;
	unsigned	async : 1 ;
		/*boolean indicates that this iopb is done asynchronously*/
	int		retried : 1 ;
		/*boolean indicates that this iopb aborted once*/
	int		frompool : 1 ;
		/*boolean indcates that this iopb is from general-purpose pool*/
	int		user_cmd ;
		/* user-level command, as in mtio.h (MTxxx) */
	int		unit_num ;
		/* unit number this iopb is queued on */
	char		*asyncstart ;
		/*start location of buffer for this async command*/
	char		*asyncend ;
		/*end location of buffer for this async command*/
	struct iopb	*asyncnext ;
		/*forward thread of pending async commands on this drive*/
	struct iopb	*asynclast ;
		/*backward thread of pending async commands on this drive*/
	struct iopb	*ondrivenext ;
		/*next iopb queued for this drive*/
	struct sg_block	*scat_gath_block ;
		/* used during scatter/gather operations: pointer to
		   scatter/gather block in use by this iopb */
	struct iopb	*retrynext ;
		/*forward thread of iopbs awaiting retry*/
	short		orig_byte_count ;
		/*copy of byte_count, in case retry is needed*/
	char		orig_list_length ;
		/*copy of list_length, in case retry is needed*/
	unsigned	orig_data_addrs ;
		/*copy of data_addrs, in case retry is needed*/
} ;


/* SCATTER/GATHER XYLOGICS IOPB*/
struct scat_gath_iopb
{
	unsigned short	byte_count ;
		/*number of bytes to transfer pointed to by this scatter/gather
		block*/
	unsigned char	unused4 ;
	unsigned char	data_addrs_mod ;
		/*address modifier of data buffer*/
	unsigned	data_addrs ;
		/*address of data buffer*/
} ;


/* SCATTER/GATHER BLOCK (PHYSICALLY CONTIGUOUS PAGE OF S/G IOPBS) */
struct sg_block
{
	struct scat_gath_iopb sg_iopb[NUM_SGIOPB_PER_IOPB] ; /*Must Be First!*/
	caddr_t uncache_address[NUM_SGIOPB_PER_IOPB] ;
	struct sg_block *sg_next_block ;
} ;

/* CONTROLLER SETUP XYLOGICS IOPB*/
struct ctlr_parms_iopb
{
	unsigned	error_detect : 1 ;
	unsigned	done : 1 ;
	unsigned	chain : 1 ;
	unsigned	scat_gath : 1 ;
	unsigned	cmd : 4 ;
	unsigned char	completion_code ;
	unsigned char	status ;
	unsigned char	current_state ;
	unsigned char	subfunction ;
	unsigned char	unused5  ;
	unsigned	unused6 : 5 ;
	unsigned	interrupt_level : 3 ;
	unsigned char	interrupt_vector ;
	unsigned	auto_update : 1 ;
	unsigned	transfer_mode : 1 ;
	unsigned	unused7 : 1 ;
	unsigned	iopb_cksum : 1 ;
	unsigned	unused8 : 1 ;
	unsigned	non_priv_reg : 1 ;
	unsigned	AIO_response_time : 2 ;
	unsigned	throttle_dead_time : 2 ;
	unsigned	unused10 : 1 ;
	unsigned	release_on_request : 1 ;
	unsigned	unused9 : 4 ;
	unsigned	overlapped_rewind : 1 ;
	unsigned	write_wait_dma : 1 ;
	unsigned	unused11 : 6 ;
	unsigned char	throttle ;
	unsigned short	unused12 ;
	unsigned char	controller_type ;
	unsigned	priority : 1 ;
	unsigned	unused13 : 1 ;
	unsigned	next_iopb_addrs_mod : 6 ;
	unsigned short	eprom_part_number ;
	unsigned char	eprom_revision_level ;
	unsigned char	eprom_subrevision_level ;
	unsigned 	next_iopb_addrs ;
	unsigned short	iopb_chksum ;
	/* software extension */
	struct buf	*request ;
} ;


/* DRIVE SETUP XYLOGICS IOPB*/
struct drive_parms_iopb
{
	unsigned	error_detect : 1 ;
	unsigned	done : 1 ;
	unsigned	chain : 1 ;
	unsigned	scat_gath : 1 ;
	unsigned	cmd : 4 ;
	unsigned char	completion_code ;
	unsigned char	status ;
	unsigned char	current_state ;
	unsigned char	subfunction ;
	unsigned	unused1 : 5 ;
	unsigned	slave_num : 3 ;
	unsigned	unused2 : 5 ;
	unsigned	interrupt_level : 3 ;
	unsigned char	interrupt_vector ;
	unsigned	ignore_read_error : 1 ;
	unsigned	ignore_write_error : 1 ;
	unsigned	read_retry : 1 ;
	unsigned	write_retry : 1 ;
	unsigned	gap_retry : 1 ;
	unsigned	density_select : 1 ;
	unsigned	swap_words : 1 ;
	unsigned	swap_bytes : 1 ;
	unsigned	extended_gap : 1 ;
	unsigned	inhibit_parity_on_write : 1 ;
	unsigned	speed : 1 ;
	unsigned	unused3 : 2 ;
	unsigned	density : 3 ;
#define NUMDENSITYS 4 /* 800,1600,3200,6250 */
	unsigned char	density_command[NUMDENSITYS] ;
	unsigned char	variable_gaps ;
	unsigned	priority : 1 ;
	unsigned	unused4 : 1 ;
	unsigned 	next_iopb_addrs_mod : 6 ;
	unsigned char	data_busy_timeout ;
	unsigned char	unused5 ;
	unsigned char	unused6 ;
	unsigned char	unused7 ;
	unsigned 	next_iopb_addrs ;
	unsigned short	iopb_chksum ;
	/* software extension */
	struct buf	*request ;
} ;



struct xyerror
{
	unsigned char errnum ;
	char *errmsg ;
} ;


/*COMMUNICATION REGISTERS*/
struct xylogics_registers
{
	unsigned char	unused1 ;
	unsigned char	addrs3_reg ;
	unsigned char	unused2 ;
	unsigned char	addrs2_reg ;
	unsigned char	unused3 ;
	unsigned char	addrs1_reg ;
	unsigned char	unused4 ;
	unsigned char	addrs0_reg ;
	unsigned char	unused5 ;
	unsigned char	addrs_mod_reg ;
	unsigned char	unused6 ;
	unsigned char	csr_reg ;
	unsigned char	unused7 ;
	unsigned char	error_reg ;
} ;



#ifdef KERNEL

struct iopb *xy_free_iopb_list ;
struct sg_block *xy_free_sg_list ;
struct buf *xy_free_buf_list ;
struct buf *xy_wait_iopb_list ;
unsigned int xy_want_buf ; 
	/* count of processes sleeping in handler for buf structures */
#endif KERNEL
#endif LOCORE
