# @(#)ufs.mk	6.6

LIBNAME = 	../lib_ufs
INCRT =		..
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(quota_kern.o) \
	$(LIBNAME)(quota_subr.o) \
	$(LIBNAME)(quota_sys.o) \
	$(LIBNAME)(quota_ufs.o) \
	$(LIBNAME)(ufs_alloc.o) \
	$(LIBNAME)(ufs_bmap.o) \
	$(LIBNAME)(ufs_dir.o) \
	$(LIBNAME)(ufs_inode.o) \
	$(LIBNAME)(ufs_subr.o) \
	$(LIBNAME)(ufs_tables.o) \
	$(LIBNAME)(ufs_vfsops.o) \
	$(LIBNAME)(ufs_vnodeops.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@grep '^#include' `echo ' $(FILES)' | sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g'`|\
	grep -v '<' | \
	sed -e 's/:[^"]*"\([^"]*\)".*/ \1/' \
	    -e 's/\.c/.o/' \
	    -e 's,../,,' | \
	awk ' { \
		if ($$1 != prev) { \
			print rec2; \
			prev = $$1; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
			rec1 = "\n$$(LIBNAME)("$$1"): \\"; \
			print rec1; \
		} else { \
			rec2 = rec2 "\\"; \
			print rec2; \
			rec2 =  "	$$(INCRT)/"$$2" "; \
		} \
	} END { print rec2 } ' > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp ufs.mk ufs.mk.bak
	@ed - ufs.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it


$(LIBNAME)(quota_kern.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(quota_subr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(quota_sys.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(quota_ufs.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/uio.h 

$(LIBNAME)(ufs_alloc.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/mount.h 

$(LIBNAME)(ufs_bmap.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/fs.h 

$(LIBNAME)(ufs_dir.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/fsdir.h \
	$(INCRT)/sys/dnlc.h 

$(LIBNAME)(ufs_inode.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/sysinfo.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/fs.h 

$(LIBNAME)(ufs_subr.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/quota.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/fs.h 

$(LIBNAME)(ufs_tables.o): \
	$(INCRT)/sys/param.h 

$(LIBNAME)(ufs_vfsops.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/pathname.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/inode.h 

$(LIBNAME)(ufs_vnodeops.o): \
	$(INCRT)/sys/param.h \
	$(INCRT)/sys/systm.h \
	$(INCRT)/sys/user.h \
	$(INCRT)/sys/buf.h \
	$(INCRT)/sys/vfs.h \
	$(INCRT)/sys/vnode.h \
	$(INCRT)/sys/proc.h \
	$(INCRT)/sys/socket.h \
	$(INCRT)/sys/socketvar.h \
	$(INCRT)/sys/file.h \
	$(INCRT)/sys/uio.h \
	$(INCRT)/sys/conf.h \
	$(INCRT)/sys/kernel.h \
	$(INCRT)/sys/cmap.h \
	$(INCRT)/sys/tty.h \
	$(INCRT)/ufs/fs.h \
	$(INCRT)/ufs/inode.h \
	$(INCRT)/ufs/mount.h \
	$(INCRT)/ufs/fsdir.h 
