

b
     (break) set a breakpoint at a line or beginning of a
     subprogram

Format
     b [line|subprogram] [of task] [begin commands end]

     b [line|subprogram] [of task] when expression

     b [line|subprogram] [of task] if expression then [commands]
     [else [commands]] end [if]

     b [line|subprogram] [of task] if expression else [commands]
     end [if]

Description
     The basic form of the command to set a breakpoint is the
     first one shown above. This sets a breakpoint at a specified
     line in the current file or at the beginning of a specified
     subprogram. line is typically typed in as a decimal number;
     however, all the options specified in the line number
     section of this reference manual are supported. To set a
     breakpoint at line 537 of the current source file, use the
     following command.

          b 537

     subprogram is the name of an Ada subprogram, task body, or
     package. It is not necessary for the subprogram name to be
     directly visible. (See visibility rules.) The name is first
     looked up as a normal Ada (or C) name. If it is not directly
     visible, all subprogram names in the program are searched.
     Expanded names (Ada RM 4.1.3(13)) as well as simple
     identifiers may also be used (starting with STANDARD if
     desired). To set a breakpoint at the procedure SORT_STAMPS,
     the following command is used.

          b SORT_STAMPS

     If the subprogram name is overloaded within the context in
     which it is looked up, the debugger prints a diagnostic
     showing all the alternatives. Retype the b command, using a
     '1, '2, ... suffix (matching an alternative shown in the
     diagnostic), on the subprogram name to disambiguate or use
     an expanded name to disambiguate. (See overloading.)

     If subprogram or line is not specified, a breakpoint is set
     at the current position by using the line part of the
     current position three-part identifier (file, line number,
     and instruction address). In line mode, the current position
     is marked with <. (See current position.)

     When the of task clause is used, the breakpoint is announced
     only for the specified task. task is a task number, obtained
     using the lt command.

     Execute commands automatically when the breakpoint is
     reached by following the breakpoint with a command of the
     following format.

          begin commands end

     Conditional Breakpoints

     The breakpoint can be made conditional by appending the when
     expression clause. expression is checked for correctness at
     the time the breakpoint is set. This check takes place in
     the environment of the location of the breakpoint. (See
     visibility rules.)

     expression is evaluated each time the breakpoint is reached.
     If the expression is false (0), the breakpoint is not
     announced and the program continues. If the expression is
     true (non-zero), the breakpoint is announced.

     Use the if statement to set a conditional breakpoint that
     also conditionally executes debugger commands when the
     breakpoint is reached. expression is evaluated each time the
     breakpoint is reached. If it is true, the breakpoint is
     announced to the user and any commands in the then clause
     (if present in the then clause) are executed. If the
     expression is false, commands in the else clause (if present
     in the else clause) are executed and then the program
     continues on its way (it is not breakpointed).

     commands is a sequence of one or more debugger commands.
     These can be entered on the same line separated by
     semicolons, or each command can be entered on its own line
     as long as the first begin, then, or else is on the same
     line as the b keyword.

     The second method is recommended. As each command of
     commands is entered on its own line, the debugger prompts
     with ?? for each new command until the sequence is
     terminated with end (or an else in the case of an if-then-
     else).

     Each breakpoint set with a b, bd, or bi command is given a
     number. This number is displayed with the lb command and is
     used with the d command to delete the breakpoint.

In Screen Mode
     In screen mode, the current position is the line in the
     source window that contains the cursor. When the cursor is
     located in the source window, typing b is the same as a line
     mode b command without any parameters. That is, a breakpoint
     is set on the line containing the cursor. The screen-mode b
     command is immediately acknowledged by the appearance of =
     to the left of the line on which the breakpoint is set.

     To set a breakpoint at the beginning of a subprogram while
     in screen mode, position the cursor on top of any letter of
     any occurrence of the name of a subprogram and press B. An
     acknowledgement message is displayed at the bottom of the
     screen to indicate that the breakpoint has been set.

     To set a conditional breakpoint in screen mode, type : and
     enter a line-mode command.
