

p
     (print) give the value of a variable or expression

Format
     p expression

Description
     p is the debugger's command for displaying the value of
     program variables and for calling subprograms. It also
     evaluates arithmetic expressions that may contain program
     variables and/or function calls. If the displayed result is
     an integer, it is printed in the current output base (which
     defaults to 10). This default can be changed with the set
     output command.

Name Expressions
     For Ada variables, the debugger currently supports simple
     variable names (e.g., a, foo) selected components and
     expanded names (e.g., a.b, foo.gorn.baz), and indexed
     components (x(y), z(1,2)). These may also be used in
     combination (e.g., x(m.z), b.x(1)). Entry calls and slices
     are not yet supported.

     Ada procedures and functions may be called. The results of a
     function may be further used in the expression. There are
     some restrictions: only parameters of mode IN are supported.
     IN OUT or OUT parameters are not supported. Default
     parameter values are not yet supported. The debugger will
     not call a function that returns an array or a record
     (functions returning access values are supported). A
     parameterless function must be called using empty
     parentheses: p foo(). When referencing an Ada procedure, it
     may be necessary to resolve overloading. (See overloading.)

     The debugger uses visibility rules similar - but not
     identical - to Ada for looking up variable names. (See
     visibility rules.) The current frame determines what names
     are visible. The visible names are the same names that would
     be visible if you were adding a statement to the program at
     the point in the source text corresponding to the current
     frame.

Expressions
     The p command also calculates the value of an expression and
     prints the result. (See expressions.)

In Screen Mode
     The p command has additional support in screen mode. To
     print the value of a variable on the screen (either window),
     position the cursor on top of any letter of a variable name
     and press p. In response to the p, the name of the variable
     is displayed in the command window followed by the
     variable's value. This is handy when single stepping since
     the cursor is usually near an instance of variables of
     interest.

     To display an entire name expression (e.g., foo(i).link),
     position the cursor on top of foo and press P. This moves
     the cursor to the f of foo and overwrites the last letter of
     foo with @. The cursor and the @ delimit the expression.
     Type P again to move the @ right again to the last character
     of the next part of the name expression, the right
     parenthesis of (i). Continue typing P in this way until the
     entire expression to be displayed is delimited by the cursor
     and the @. At this point, a p displays the value of the
     delimited expression.
