      PROGRAM TX0177
C
C     ***** DI-3000 EXTENDED TEST PROGRAM NUMBER 1
C
C     ***** DI-3000 EXTENDED TEST PROGRAM ... WILL NOT RUN WITH LEVEL-A
C
C     ***** TESTS .....
C
C     *****    CREATION OF RETAINED SEGMENTS, BATCH OF UPDATES,
C     *****    VISIBILITY CHANGES, PURGING SEGMENTS
C
C     ***** THIS PROGRAM IS SIMILAR TO EXAMPLE PROGRAM 5 IN
C     ***** APPENDIX 'B' OF THE DI-3000 USER'S GUIDE
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
      OUTDEV = 1
      INPDEV = 1
C
      CALL JBEGIN
      CALL JDINIT (OUTDEV)
      CALL JDEVON (OUTDEV)
C
      CALL JDGAP (0.4)
      CALL JDPINT (1)
      CALL JDJUST (2,2)
      CALL JDSIZE (14.,14.)
      CALL JDINTE (32767)
C
      CALL JWINDO (-100.,100.,-100.,100.)
C
C     ***** DEFINE UPPER LEFT VIEWPORT FOR FIRST TWO SEGMENTS
C
      CALL JVPORT (-0.9,-0.1,0.1,0.9)
C
C     ***** DEFINE TWO CONCENTRIC SQUARES AS SEPARATE RETAINED SEGMENTS
C
      CALL JROPEN (1)
         CALL JPIDEX (2,21)
         CALL JRECT  (-90.,-90.,90.,90.)
      CALL JRCLOS
C
      CALL JROPEN (2)
         CALL JPIDEX (3,22)
         CALL JRECT  (-40.,-40.,40.,40.)
      CALL JRCLOS
C
C     ***** DEFINE THE UPPER RIGHT VIEWPORT FOR THE THIRD SEGMENT
C
      CALL JVPORT (0.1,0.9,0.1,0.9)
C
C     ***** DEFINE A CIRCLE AS A RETAINED SEGMENT
C
      CALL JROPEN (3)
         CALL JPIDEX (6,23)
         CALL JCIRCL (0.,0.,0.,90.,0)
      CALL JRCLOS
C
C     ***** DEFINE THE LOWER RIGHT VIEWPORT FOR 8 SECTORS
C
      CALL JVPORT (0.1,0.9,-0.9,-0.1)
C
      START = 0.0
C
      DO 1000 I = 4,11
C
         CALL JROPEN (I)
C
            A0 = START
            A1 = START + 45.
            START = START + 45.
            CALL JPIDEX (I-3,I+27)
            CALL JSECTR (0.,0.,0.,90.,0,A0,A1)
         CALL JRCLOS
C
 1000 CONTINUE
C
C     ***** DEFINE THE LOWER LEFT VIEWPORT FOR STRING AND CHARACTER
C     ***** QUALITY TEXT STRINGS
C
      CALL JVPORT (-0.9,-0.1,-0.9,-0.1)
C
C     ***** DEFINE FOUR TEXT STRINGS AS SEPARATE SEGMENTS
C
      CALL JROPEN (12)
         CALL JCOLOR (1)
         CALL JMOVE (0.,60.)
         CALL J1STRG ('TEXT STRING 1')
      CALL JRCLOS
C
      CALL JROPEN (13)
         CALL JCOLOR (2)
         CALL JMOVE (0.,20.)
         CALL J1STRG ('TEXT STRING 2')
      CALL JRCLOS
C
      CALL JROPEN (14)
         CALL JCOLOR (3)
         CALL JMOVE (0.,-20.)
         CALL J2STRG ('TEXT STRING 3')
      CALL JRCLOS
C
      CALL JROPEN (15)
         CALL JCOLOR (4)
         CALL JMOVE (0.,-60.)
         CALL J2STRG ('TEXT STRING 4')
      CALL JRCLOS
C
C     ***** DEFINE THE ENTIRE VIEWSPACE AS THE CURRENT VIEWPORT
C
      CALL JVPORT (-1.0,1.0,-1.0,1.0)
C
C     ***** OPEN A TEMPORARY SEGMENT TO OUTPUT A ROW OF HORIZONTAL
C     ***** MARKERS ('O') AND A ROW OF VERTICAL MARKERS ('X')
C
      CALL JOPEN
         X0 = -95.
         DO 2000 I = 1,20
            CALL JCOLOR (I)
            CALL JCMARK (4)
            CALL JMARK (X0,0.)
            CALL JCMARK (5)
            CALL JMARK (0.,X0)
            X0 = X0 + 10.
 2000    CONTINUE
      CALL JCLOSE
C
C     ***** THE DISPLAY SHOULD SHOW ALL SEGMENTS ... PAUSE
C
      CALL JPAUSE (OUTDEV)
C
C     ***** OPEN A BATCH OF UPDATES ... MAKE ALL ODD RETAINED SEGMENTS
C     ***** INVISIBLE.
C
      CALL JBGBAT (0)
         DO 3000 I = 1,15,2
            CALL JVISBL (I,0)
 3000    CONTINUE
      CALL JENBAT
C
C     ***** AN IMPLICIT NEW FRAME ACTION WILL OCCUR ON THE DISPLAY
C     ***** DEVICE.  ALL EVEN RETAINED SEGMENTS WILL BE VISIBLE.  THE
C     ***** TEMPORARY SEGMENT OF MARKERS WILL BE GONE.
C
      CALL JPAUSE (OUTDEV)
C
C     ***** OPEN ANOTHER BATCH OF UPDATES
C     ***** MAKE ALL EVEN RETAINED SEGMENTS
C     ***** INVISIBLE ... AT THE END OF THE BATCH ONLY THE ODD SEGMENTS
C     ***** WILL BE VISIBLE.
C
      CALL JBGBAT (0)
C
C        ***** MAKE ALL EVEN SEGMENTS INVISIBLE ... NOTHING WILL HAPPEN
C        ***** UNTIL THE END OF THE BATCH
C
         DO 4000 I = 2,14,2
            CALL JVISBL (I,0)
 4000    CONTINUE
C
      CALL JENBAT
C
C     ***** NOW MAKE ALL ODD RETAINED SEGMENTS VISIBLE
C
      DO 4500 I = 1,15,2
         CALL JVISBL (I,1)
 4500 CONTINUE
C
C     ***** AN IMPLICIT NEW FRAME ACTION WILL OCCUR.  THE ODD SEGMENTS
C     ***** WILL BE VISIBLE ON THE DISPLAY DEVICE.
C
      CALL JPAUSE (OUTDEV)
C
C     ***** OPEN ANOTHER BATCH OF UPDATES
C     ***** PURGE THE SECTOR SEGMENTS
C
      CALL JBGBAT (0)
         DO 5000 I = 4,11
            CALL JPURGE (I)
 5000    CONTINUE
      CALL JENBAT
C
C     ***** MAKE SELECTED EVEN SEGMENTS VISIBLE
C     ***** ODD SEGMENTS ARE ALREADY VISIBLE
C
      CALL JVISBL ( 2,1)
      CALL JVISBL (12,1)
      CALL JVISBL (14,1)
C
      CALL JPAUSE (OUTDEV)
C
      CALL JEND
      STOP
      END
