      PROGRAM TSTX02
C
C     ***** DI-3000 EXTENDED TEST PROGRAM NUMBER 2
C
C     ***** TESTS .....
C
C     *****    PICK INPUT, LOCATOR INPUT, BATCH OF UPDATES,
C     *****    DETECTABILITY CHANGES, AND PURGING RETAINED SEGMENTS
C
C     ***** DRAW, "FURNISH", AND "LANDSCAPE" A HOUSE
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      INTEGER   PIKARR,     SEGON,     SAVARR,     AARRAY
      DIMENSION PIKARR(50), SEGON(50), SAVARR(50), AARRAY(12)
C
      INTEGER ARRLEN, PICKID, SAVLEN, SEGMAX, SEGNUM
C
      OUTDEV = 1
      INPDEV = 1
      ARRLEN = 0
      SEGMAX = 50
      SAVLEN = 0
C
C     ***** INITIALIZE ALL FLAGS TO TRUE.
C
      FLAG1 = .TRUE.
      FLAG2 = .TRUE.
      FLAG3 = .TRUE.
      FLAG4 = .TRUE.
      FLAG5 = .TRUE.
      FLAG6 = .TRUE.
      FLAG7 = .TRUE.
      FLAG8 = .TRUE.
      FLAG9 = .TRUE.
C
C     ***** INITIALIZE SEGON ARRAY
C
      DO 100 I = 1, SEGMAX
         SEGON(I) = 0
  100 CONTINUE
C
      CALL JBEGIN
      CALL JDINIT (OUTDEV)
      CALL JDEVON (OUTDEV)
C
      CALL JVSPAC (-1.0,1.0,-0.75,0.75)
      CALL JWINDO (-133.,133.,-100.,100.)
      CALL JWCLIP (.TRUE.)
C
C     ***** MAKE ALL RETAINED SEGMENTS PICK-DETECTABLE BY SETTING
C     ***** THE DEFAULT PICK PRIORITY ABOVE ZERO.
C
      CALL JDDETE (1000)
      CALL JDSIZE (2.0, 4.0)
      CALL JDINTE (32767)
C
C     ***** Set default polygon attributes to filled with edge.
C
      CALL JDPINT (1)
C
C     ***** DRAW MENU AT BOTTOM FROM WHICH TO PICK NEXT PICTURE
C     ***** ELEMENT TO DRAW.  MENU IS CREATED AS ONE RETAINED
C     ***** SEGMENT.  EACH PICTURE ELEMENT NAME IS ASSIGNED A
C     ***** UNIQUE PICK-ID TO MAKE IT DISTINGUISHABLE IN PICK
C     ***** INPUT.
C
      CALL GENMEN
C
C     ***** DRAW THE BACKGROUND HOUSE AS A RETAINED SEGMENT
C
      CALL HOUSE
C
C     ***** INITIALIZE A COUNTER FOR CREATING SUBSEQUENT RETAINED
C     ***** SEGMENTS.
C
      NXTSEG = 3
C
C     ***** ENABLE PICK AND LOCATOR INPUT FROM DISPLAY DEVICE.
C     ***** ASSOCIATE BOTH INPUT FUNCTIONS WITH SAME PHYSICAL
C     ***** INPUT DEVICE ON DISPLAY DEVICE.
C
      CALL JIENAB (OUTDEV, 2, INPDEV)
      CALL JIENAB (OUTDEV, 5, INPDEV)
C
C     ***** REDEFINE THE PICK APERTURE TO BE 1 PERCENT OF THE
C     ***** SCREEN WIDTH AND HEIGHT
C
      CALL JPKAPR (OUTDEV, INPDEV, 0.01, 0.01)
C
 1000 CONTINUE
C
C     ***** ENTER BATCH OF UPDATES - SEVERAL PICTURE ELEMENTS CAN
C     ***** BE ADDED OR DELETED BEFORE A NEW FRAME ACTION.
C
      CALL JBGBAT (0)
C
 2000 CONTINUE
C
C     ***** SET THE PICK ECHO POSITION TO THE MIDDLE OF THE MENU
C
      CALL JPECHO (OUTDEV, 5, INPDEV, 0.0, -0.65)
C
C     ***** PICK FROM THE MENU (AND ONLY THE MENU)
C
      CALL JPICK (OUTDEV, INPDEV, 1, IBUTTN, NAMSEG, PICKID)
C
C     ***** IF A MENU ITEM WAS NOT PICKED ... TRY AGAIN
C
      IF (IBUTTN .LT. 0 .OR. NAMSEG .NE. 2) GO TO 2000
      IF (PICKID .NE. 7) GO TO 3000
C
C        ***** SCREEN UPDATE DETECTED ... END BATCH
C
         CALL JENBAT
         GO TO 1000
C
 3000 CONTINUE
C
      IF (PICKID .NE. 8) GO TO 4000
C
C        ***** 'DELETE' DETECTED ... ENABLE ONLY THE HOUSE
C        ***** ENHANCEMENTS AS PICKABLE SEGMENTS
C
         ARRLEN = 0
C
      DO 200 I = 1, NXTSEG
         IF (SEGON(I) .LE. 0) GO TO 200
         ARRLEN = ARRLEN + 1
         PIKARR(ARRLEN) = I
  200 CONTINUE
C
      CALL JEPSEG (1, PIKARR, ARRLEN, 1)
C
C        ***** DELETE AN ELEMENT FROM THE DISPLAY AREA
C        ***** SET THE PICK ECHO POSITION TO THE MIDDLE OF THE
C        ***** DISPLAY
C
         CALL JPECHO (OUTDEV, 5, INPDEV, 0.0, 0.0)
C
         CALL JPICK (OUTDEV, INPDEV, 1, IBUTTN, NAMSEG, PICKID)
         IF (IBUTTN .LT. 0  .OR.  NAMSEG .LE. 0) GO TO 3500
         CALL JPURGE (NAMSEG)
         SEGON(NAMSEG) = 0
C
C        ***** DISABLE THE HOUSE ENHANCEMENTS FOR PICKING.
C
      DO 300 I = 1, NXTSEG
         PIKARR(I) = 0
  300 CONTINUE
C
      ARRLEN = 0
C
      DO 400 I = 1, NXTSEG
         IF (SEGON(I) .LE. 0) GO TO 400
         ARRLEN = ARRLEN + 1
         PIKARR(ARRLEN) = I
  400 CONTINUE
C
C     ***** IF THERE ARE NO SEGMENTS LEFT IN THE PICK LIST THEN
C     ***** PASS A ONE ELEMENT ARRAY CONTAINING THE VALUE '0' TO
C     ***** THE CALL TO JEPSEG.  THIS WILL DELETE THE PICK LIST
C     ***** ASSOCIATED WITH THE DEVICE.
C
      IF (ARRLEN .GT. 0) GO TO 3500
         PIKARR(1) = 0
         ARRLEN = 1
 3500 CONTINUE
         CALL JEPSEG (1, PIKARR, ARRLEN, 2)
C
         GO TO 2000
C
 4000 CONTINUE
C
C     ***** CHECK IF THE USER WANTS TO SAVE SEGMENT STORAGE ....
C
      IF (PICKID .NE. 5) GOTO 5000
C
C     ***** SAVE THE CURRENT SEGMENT STORAGE DATA STRUCTURE IN
C     ***** A DI-3000 INTERNAL FILE.
C
      CALL JPECHO (OUTDEV, 2, INPDEV, 0.0, -0.65)
      CALL JFSOPN (5, 1, 0, 'house')
C
C          ***** KEEP TRACK OF ALL SEGMENTS THAT ARE BEING SAVED
C
           DO 500 I = 1, NXTSEG
              IF (SEGON(I) .LE. 0) GOTO 500
              SAVLEN = SAVLEN + 1
              SAVARR(SAVLEN) = I
  500      CONTINUE
C
      CALL JSSAVE
      GOTO 2000
C
 5000 CONTINUE
C
C     ***** CHECK IF THE USER WANTS TO RESTORE SEGMENT STORAGE FROM A FI
C
      IF (PICKID .NE. 6) GOTO 6000
C
C     ***** RESTORE SEGMENT STORAGE FROM A FILE.
C
      CALL JPECHO (OUTDEV, 2, INPDEV, 0.0, -0.65)
      CALL JFSOPN (6, 1, 0, 'house')
      CALL JSAPND (2, 1)
C
C          ***** THE SAVED SEGMENTS HAVE BEEN RESTORED
C          ***** ADD THESE SEGMENTS TO THE PICK LIST
C
           DO 600 I = 1, SAVLEN
              SEGNUM = SAVARR(I)
              SEGON(SEGNUM) = 1
  600 CONTINUE
C
      SAVLEN = 0
C
      GO TO 2000
C
 6000 CONTINUE
C
C     ***** CHECK IF THE USER WANTS TO END ....
C
      IF (PICKID .EQ. 9) GO TO 90000
C
C     ***** A NEW ENHANCEMENT IS TO BE ADDED TO THE DISPLAY
C     ***** CENTER THE ENHANCEMENT ON THE DISPLAY AREA
C     ***** USING THE LOCATOR
C     ***** POSITION THE LOCATOR ECHO IN THE MIDDLE OF THE SCREEN
C
      CALL JPECHO (OUTDEV, 2, INPDEV, 0.0, 0.0)
C
      CALL JLOCAT (OUTDEV, INPDEV, 1, IBUTTN, VX, VY)
      IF (IBUTTN .LT. 0) GO TO 2000
C
C        ***** CONVERT THE LOCATOR POINT TO WORLD COORDINATES
C
         CALL JCONVW (VX, VY, WX, WY, WZ)
C
C     ***** DRAW THE APPROPRIATE ENHANCEMENT AS A RETAINED SEGMENT
C
      SEGON(NXTSEG) = 1
      IF (PICKID .EQ. 1) CALL DOOR  (WX, WY, NXTSEG)
      IF (PICKID .EQ. 2) CALL WINDO (WX, WY, NXTSEG)
      IF (PICKID .EQ. 3) CALL TREE  (WX, WY, NXTSEG)
      IF (PICKID .EQ. 4) CALL BUSH  (WX, WY, NXTSEG)
C
C     ***** SAVE SEGMENT NUMBERS OF ENHANCEMENTS IN AN ARRAY TO BE
C     ***** USED AS A PICK LIST
C
      NXTSEG = NXTSEG + 1
      GO TO 2000
C
90000 CONTINUE
C
C     ***** END PROGRAM ... FIRST MUST END BATCH OF UPDATES
C
      CALL JENBAT
      CALL JDEVOF (OUTDEV)
      CALL JDEND (OUTDEV)
      CALL JEND
      STOP
      END
      SUBROUTINE GENMEN
C
C     ***** DEFINE THE MENU AT THE BOTTOM OF THE SCREEN AS RETAINED
C     ***** SEGMENT NUMBER 2.  THE MENU IS PICK SENSITIVE BY DEFAULT.
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      CALL JDSGPR (500)
      CALL JROPEN (2)
         CALL JCOLOR (3)
         CALL JPKID (1)
         CALL JMOVE (-126.0, -85.0)
         CALL J1STRG ('DOOR')
         CALL JMOVE (-98.0, -85.0)
         CALL JPKID (2)
         CALL J1STRG ('WINDOW')
         CALL JMOVE (-70.0, -85.0)
         CALL JPKID (3)
         CALL J1STRG ('TREE')
         CALL JMOVE (-42.0, -85.0)
         CALL JPKID (4)
         CALL J1STRG ('BUSH')
         CALL JMOVE (-14.0, -85.0)
         CALL JPKID (5)
         CALL J1STRG ('SAVE')
         CALL JMOVE (14.0, -85.0)
         CALL JPKID (6)
         CALL J1STRG ('RESTORE')
         CALL JMOVE (42.0, -85.0)
         CALL JPKID (7)
         CALL J1STRG ('UPDATE')
         CALL JMOVE (70.0, -85.0)
         CALL JPKID (8)
         CALL J1STRG ('DELETE')
         CALL JMOVE (98.0, -85.0)
         CALL JPKID (9)
         CALL J1STRG ('END')
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE DOOR (X, Y, N)
C
C     ***** OUTPUT DOOR CENTERED AT WORLD POINT (X,Y) AS A
C     ***** RETAINED SEGMENT WITH NAME 'N'.
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      CALL JDSGPR (200)
      CALL JROPEN (N)
      IF (.NOT. FLAG1) GOTO 10
         CALL JCOLOR (3)
         CALL JPIDEX (3, 0)
         CALL JASAVE (DOOR1)
         FLAG1 = .FALSE.
         GOTO 20
   10 CALL JALOAD (DOOR1)
   20 CONTINUE
C
         CALL JRECT  (X - 10.0, Y - 25.0, X + 10.0, Y + 25.0)
C
C        ***** Set no fill for door panels.
C
      IF (.NOT. FLAG2) GOTO 30
         CALL JPINTR (0)
         CALL JCOLOR (8)
         CALL JASAVE (DOOR2)
         FLAG2 = .FALSE.
         GOTO 40
   30 CALL JALOAD (DOOR2)
   40 CONTINUE
         CALL JRECT  (X -  8.0, Y +  9.0, X -  2.0, Y + 22.0)
         CALL JRECT  (X +  2.0, Y +  9.0, X +  8.0, Y + 22.0)
         CALL JRECT  (X -  8.0, Y -  7.0, X -  2.0, Y +  7.0)
         CALL JRECT  (X +  2.0, Y -  7.0, X +  8.0, Y +  7.0)
         CALL JRECT  (X -  8.0, Y - 22.0, X -  2.0, Y -  9.0)
         CALL JRECT  (X +  2.0, Y - 22.0, X +  8.0, Y -  9.0)
C
C        ***** Set solid fill for door knob.
C
      IF (.NOT. FLAG3) GOTO 50
         CALL JPINTR (1)
         CALL JPIDEX (8, 0)
         CALL JASAVE (DOOR3)
         FLAG3 = .FALSE.
         GOTO 60
   50 CALL JALOAD (DOOR3)
   60 CONTINUE
         CALL JCIRCL (X - 8.5, Y, 0.0, 1.0, 15)
      CALL JRCLOS
      RETURN
      END
      SUBROUTINE WINDO (X, Y, N)
C
C     ***** OUTPUT A WINDOW AS A RETAINED SEGMENT WITH NAME OF N.
C     ***** CENTER THE HOUSE WINDOW AT (X,Y)
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      CALL JDSGPR (200)
      CALL JROPEN (N)
      IF (.NOT. FLAG4) GOTO 10
         CALL JCOLOR (4)
         CALL JPIDEX (8,0)
         CALL JASAVE (WINDO1)
         FLAG4 = .FALSE.
         GOTO 20
   10 CALL JALOAD (WINDO1)
   20 CONTINUE
         CALL JRECT (X - 6.0, Y - 6.0, X + 6.0, Y + 6.0)
         CALL JMOVE (X, Y + 6.0)
         CALL JDRAW (X, Y - 6.0)
         CALL JMOVE (X - 6.0, Y)
         CALL JDRAW (X + 6.0, Y)
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE TREE (X, Y, N)
C
C     ***** DRAW A TREE WITH FOLIAGE CENTERED AT (X,Y).
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      CALL JDSGPR (400)
      CALL JROPEN (N)
      IF (.NOT. FLAG5) GOTO 10
         CALL JCOLOR (2)
         CALL JPIDEX (2, 0)
         CALL JASAVE (TREE1)
         FLAG5 = .FALSE.
         GOTO 20
   10 CALL JALOAD (TREE1)
   20 CONTINUE
C
         CALL JCIRCL (X, Y, 0.0, 30.0, 12)
C
      IF (.NOT. FLAG6) GOTO 30
         CALL JCOLOR (4)
         CALL JPIDEX (4, 0)
         CALL JASAVE (TREE2)
         FLAG6 = .FALSE.
         GOTO 40
   30 CALL JALOAD (TREE2)
   40 CONTINUE
         CALL JRECT (X - 5.0, Y - 70.0, X + 5.0, Y - 29.0)
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE BUSH (X, Y, N)
C
C     ***** OUTPUT A BUSH AT (X,Y) WITH NAME N.
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      CALL JDSGPR (300)
      CALL JROPEN (N)
      IF (.NOT. FLAG7) GOTO 10
         CALL JCOLOR (2)
         CALL JPIDEX (2, 0)
         CALL JASAVE (BUSH1)
         FLAG7 = .FALSE.
         GOTO 20
   10 CALL JALOAD (BUSH1)
   20 CONTINUE
         CALL JCIRCL (X, Y + 5.0, 0.0, 5.0, 10)
         CALL JCIRCL (X - 5.0, Y, 0.0, 5.0, 10)
         CALL JCIRCL (X + 5.0, Y, 0.0, 5.0, 10)
         CALL JCOLOR (0)
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE HOUSE
C
C     ***** DRAW THE BACKGROUND HOUSE AS A RETAINED SEGMENT
C     ***** THAT IS NOT PICK-SENSITIVE
C
      COMMON/ARRAYS/DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      INTEGER       DOOR1,     DOOR2,     DOOR3,     WINDO1,   TREE1,
     +              TREE2,     BUSH1,     HOUSE1
      DIMENSION     DOOR1(11), DOOR2(11), DOOR3(11), WINDO1(11),
     +              TREE1(11), TREE2(11), BUSH1(11), HOUSE1(11)
C
      COMMON /FLAGS/ FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
      LOGICAL        FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7,
     +               FLAG8, FLAG9
C
      REAL      X,    Y
      DIMENSION X(7), Y(7)
C
      DATA X(1), X(2), X(3), X(4), X(5), X(6), X(7)
     +     /-50.0, -50.0,  50.0, 50.0, 60.0,  0.0, -60.0/
      DATA Y(1), Y(2), Y(3), Y(4), Y(5), Y(6), Y(7)
     +     / 50.0, -50.0, -50.0, 50.0, 50.0, 75.0,  50.0/
C
      CALL JDSGPR (100)
      CALL JROPEN (1)
      IF (.NOT. FLAG8) GOTO 10
         CALL JPIDEX (1,0)
         CALL JCOLOR (1)
         CALL JASAVE (HOUSE1)
         FLAG8 = .FALSE.
         GOTO 20
   10 CALL JALOAD (HOUSE1)
   20 CONTINUE
         CALL JPOLGN (X, Y, 7)
         CALL JMOVE  (-40.0, 59.0)
         CALL JDRAW  (-40.0, 80.0)
         CALL JDRAW  (-30.0, 80.0)
         CALL JDRAW  (-30.0, 64.0)
         CALL JCOLOR (0)
         CALL JPIDEX (0,0)
         CALL JCIRCL (-35.0, 85.0, 0.0, 2.0, 10)
         CALL JCIRCL (-37.0, 90.0, 0.0, 3.0, 12)
         CALL JCIRCL (-45.0, 95.0, 0.0, 5.0, 15)
      CALL JRCLOS
C
C     ***** TURN OFF SEGMENT PICK DETECTABILITY FOR THE HOUSE.
C
      CALL JDETEC (1, 0)
C
      RETURN
      END
