      PROGRAM TX0377
C
C     ***** DI-3000 EXTENDED TEST PROGRAM NUMBER 3
C
C     ***** DI-3000 EXTENDED TEST PROGRAM ... WILL NOT RUN WITH LEVEL-A
C
C     ***** TESTS .....
C
C     *****    PICK INPUT, 3D VIEWING, STRING TEXT, POLYGONS AND
C     *****    POLYGON CLIPPING, MULTIPLE WINDOWS AND VIEWPORTS,
C     *****    SAVING AND RESTORING THE VIEWING TRANSFORMATION.
C
C     ***** THIS PROGRAM WILL ONLY RUN ON DEVICES THAT SUPPORT PICK
C     ***** INPUT.  THE PROGRAM ASKS THE DRIVER IF IT HAS A PICK DEVICE
C     ***** NO PICK ---> A MESSAGE AND TERMINATION.
C
C     ***** THIS PROGRAM IS EQUIVALENT TO PROGRAM NUMBER 12, EXCEPT
C     ***** THAT PICK IS USED INSTEAD OF LOCATOR TO DO MENU
C     ***** SELECTION.
C
      COMMON /VRATIO/ RATIO,  PLEFT, CRLF, CHXSIZ, CHYSIZ
C
      COMMON /STATUS/ ACTIVE, PASIVE, INFILE
      LOGICAL         ACTIVE, PASIVE
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
      OUTDEV = 1
      INPDEV = 1
C
C     ***** INITIALIZE DI-3000
C
      CALL JBEGIN
      CALL JDINIT (OUTDEV)
      CALL JDEVON (OUTDEV)
C
      RATIO =  0.7617
      PLEFT = -0.95
      CRLF  =  1.5
      CHYSIZ = RATIO / 25.
      CHXSIZ = CHYSIZ / 1.4
C
C     ***** ENABLE LEVEL-7 DEBUGGING IN CASE THE USER ENTERS ILLEGAL
C     ***** VIEWING VALUES.
C
      CALL JSETER (7)
C
C     ***** CHECK FOR THE AVAILABILITY OF A PICK
C
      CALL JIQDEV (OUTDEV, 46, IPICK)
      ACTIVE = IPICK .GT. 0
      PASIVE = .NOT. ACTIVE
C
      IF (PASIVE) GO TO 8000
C
C     ***** ALL INPUT WILL BE READ FROM FORTRAN LOGICAL UNIT NUMBER 5
C
      INFILE = 5
C
C     ***** SET VIEWSPACE, WINDOW, AND ATTRIBUTE DEFAULTS
C
      CALL JVSPAC (-1.0, 1.0, -RATIO, RATIO)
      CALL JWINDO (-1.0, 1.0, -1.0, 1.0)
C
      CALL JDLWID (0)
      CALL JDINTE (32767)
      CALL JDPINT (1)
      CALL JDINTE (32767)
C
C     ***** ENABLE PHYSICAL PICK NUMBER 1
C
      CALL JIENAB (OUTDEV, 5, INPDEV)
C
C     ***** BEGIN MAIN LOOP
C
      CALL LOOP
      GO TO 9000
C
 8000 CONTINUE
C
C     ***** PASSIVE DEVICE ---> MESSAGE AND END
C
      WRITE (6,00010)
00010 FORMAT (/28H PASSIVE DEVICE ... NO INPUT/)
C
 9000 CONTINUE
C
      CALL JEND
C
      STOP
      END
      SUBROUTINE LOOP
C
C     ***** MAIN LOOP TO PROMPT THE USER FOR INPUT AND REDRAW PICTURE
C     ***** RETURNS TO THE MAIN PROGRAM WHEN THE USER PICKS 'END'
C
      COMMON /VRATIO/ RATIO,  PLEFT, CRLF, CHXSIZ, CHYSIZ
      COMMON /STATUS/ ACTIVE, PASIVE, INFILE
      LOGICAL         ACTIVE, PASIVE
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
C     ***** DEFINE THE MENU AND BACKGROUND AS RETAINED SEGMENTS
C
      CALL GENMEN
  500 CONTINUE
C
C     ***** DRAW THE THE CURRENT VERSION OF THE CUBE
C
      CALL BUILD
C
C     ***** SET THE INITIAL PICK ECHO TO THE MIDDLE OF 'DRAW'
C
      YPOS = RATIO - RATIO/22. - CHYSIZ * (CRLF+1.0)
      CALL JPECHO (OUTDEV, 5, INPDEV, -0.85, YPOS)
C
C     ***** PROMPT THE USER TO CHANGE THE VIEWING TRANSFORMATION
C     ***** USING PICK INPUT FROM THE MENU
C
  600 CONTINUE
C
      CALL JPICK (OUTDEV, INPDEV, 1, IBUTTN, ISEG, IGOTO)
C
C     ***** WAS A MENU ITEM PICKED ... NO ... TRY AGAIN
C
      IF (ISEG .LE. 0) GO TO 600
C
C        ***** TEST FOR 'END'
C
         IF (IGOTO .EQ. 0) GO TO 99999
C
C        ***** COMPUTE THE BEAM ECHO POSITION HERE FOR READING
C        ***** FROM THE TERMINAL
C
         PYBEAM = RATIO - (CRLF + 1.0) * CHYSIZ
         CALL JBEAM (OUTDEV, PLEFT, PYBEAM)
C
C        ***** USE THIS POINT AS THE NEW PICK ECHO POSITION ALSO
C
         CALL JPECHO (OUTDEV, 5, INPDEV, -0.9, PYBEAM)
C
      GO TO ( 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000,
     +        9000,10000,11000,12000,13000,14000,15000,16000,
     +       17000,18000), IGOTO
C
 1000 CONTINUE
C
C     ***** DRAW USING THE ACTIVE TRANSFORMATION
C
      CALL JFRAME
      GO TO 500
C
 2000 CONTINUE
C
C     ***** REDEFINE WINDOW
C
      READ (INFILE,*) XMIN,XMAX,YMIN,YMAX
      CALL JWINDO (XMIN,XMAX,YMIN,YMAX)
      GO TO 600
C
 3000 CONTINUE
C
C     ***** SET THE VIEW PLANE NORMAL
C
      READ (INFILE,*) DX,DY,DZ
      CALL JNORML (DX,DY,DZ)
      GO TO 600
C
 4000 CONTINUE
C
C     ***** PERSPECTIVE PROJECTION
C
      READ (INFILE,*) DX,DY,DZ
      CALL JPEROB (DX,DY,DZ)
      GO TO 600
C
 5000 CONTINUE
C
C     ***** PARALLEL PROJECTION
C
      READ (INFILE,*) DX,DY,DZ
      CALL JPAROB (DX,DY,DZ)
      GO TO 600
C
 6000 CONTINUE
C
C     ***** SET THE VIEW SITE
C
      READ (INFILE,*) X,Y,Z
      CALL JVUPNT (X,Y,Z)
      GO TO 600
C
 7000 CONTINUE
C
C     ***** SET THE UP VECTOR
C
      READ (INFILE,*) DX,DY,DZ
      CALL JUPVEC (DX,DY,DZ)
      GO TO 600
C
 8000 CONTINUE
C
C     ***** SET THE VIEWPLANE DISTANCE
C
      READ (INFILE,*) D
      CALL JVUPLN (D)
      GO TO 600
C
 9000 CONTINUE
C
C     ***** SWITCH WINDOW CLIPPING ON
C
      CALL JWCLIP (.TRUE.)
      GO TO 600
C
10000 CONTINUE
C
C     ***** SWITCH HITHER CLIPPING ON
C
      CALL JHCLIP (.TRUE.)
      GO TO 600
C
11000 CONTINUE
C
C     ***** SWITCH YON CLIPPING ON
C
      CALL JYCLIP (.TRUE.)
      GO TO 600
C
12000 CONTINUE
C
C     ***** SWITCH WINDOW CLIPPING OFF
C
      CALL JWCLIP (.FALSE.)
      GO TO 600
C
13000 CONTINUE
C
C     ***** SWITCH HITHER CLIPPING OFF
C
      CALL JHCLIP (.FALSE.)
      GO TO 600
C
14000 CONTINUE
C
C     ***** SWITCH YON CLIPPING OFF
C
      CALL JYCLIP (.FALSE.)
      GO TO 600
C
15000 CONTINUE
C
C     ***** SET HITHER PLANE DISTANCE
C
      READ (INFILE,*)  D
      CALL JHITHR (D)
      GO TO 600
C
16000 CONTINUE
C
C     ***** SET YON PLANE DISTANCE
C
      READ (INFILE,*)  D
      CALL JYON (D)
      GO TO 600
C
17000 CONTINUE
C
C     ***** SET VIEW REFERENCE POINT AND EYEPOINT IN WORLD COORDINATES.
C
      READ (INFILE,*) XVRP, YVRP, ZVRP, XEYE, YEYE, ZEYE, VANGLE
      CALL JCVIEW (XVRP, YVRP, ZVRP, XEYE, YEYE, ZEYE, VANGLE)
      GO TO 600
C
18000 CONTINUE
C
C     ***** DEFINE EYEPOINT IN SPHERICAL COORDINATES WITH RESPECT TO THE
C     ***** VIEW REFERENCE POINT.
C
      READ (INFILE,*) XVRP, YVRP, ZVRP, DIST, YANGLE, XZANGL, VANGLE
      CALL JSVIEW (XVRP, YVRP, ZVRP, DIST, YANGLE, XZANGL, VANGLE)
      GO TO 600
C
99999 CONTINUE
C
C     ***** 'END' DETECTED ... RETURN
C
      RETURN
      END
      SUBROUTINE GENMEN
C
C     ***** FLOOD THE BACKGROUND OF THE DISPLAY AREA AND DRAW MENU
C
      COMMON /VRATIO/ RATIO,  PLEFT, CRLF, CHXSIZ, CHYSIZ
C
      COMMON /STATUS/ ACTIVE, PASIVE, INFILE
      LOGICAL         ACTIVE, PASIVE
C
      DIMENSION TRHOLD(85),WX(4),WY(4),WZ(4)
C
C     ***** SAVE THE CURRENT VIEWING TRANSFORMATION AND RESET THE
C     ***** VIEWING TRANSFORMATION TO ITS DEFAULT
C
      CALL JVSAVE (TRHOLD)
      CALL JRESET
      CALL JVPORT (-1.0, 1.0, -RATIO, RATIO)
      CALL JWINDO (-1.0, 1.0, -RATIO, RATIO)
C
C     ***** FLOOD THE BACKGROUND WITH BLUE AND DRAW A CYAN BORDER
C     ***** THIS WILL BE A RETAINED SEGMENT
C
      CALL JDSGPR (1)
      CALL JROPEN (999)
         CALL JCOLOR (6)
         CALL JLWIDE (200)
         CALL JIWIND (WX,WY,WZ)
         CALL JPIDEX (4,0)
         CALL J3PLGN (WX,WY,WZ,4)
      CALL JRCLOS
C
C     ***** DEFINE THE MENU ITEMS IN A RETAINED SEGMENT
C
      CALL JDSGPR (500)
      CALL JROPEN (1)
C
         CALL JSIZE (CHXSIZ,CHYSIZ)
C
         CALL JMARGN (PLEFT, RATIO - RATIO/20., 0.)
         CALL JCRLF (0.0)
         CALL JPKID (0)
         CALL J1STRG (' 0 - END')
         CALL JCRLF (CRLF)
         CALL JPKID (1)
         CALL J1STRG (' 1 - DRAW')
         CALL JCRLF (CRLF)
         CALL JPKID (2)
         CALL J1STRG (' 2 - WINDOW')
         CALL JCRLF (CRLF)
         CALL JPKID (3)
         CALL J1STRG (' 3 - NORMAL')
         CALL JCRLF (CRLF)
         CALL JPKID (4)
         CALL J1STRG (' 4 - PERSPECTIVE')
         CALL JCRLF (CRLF)
         CALL JPKID (5)
         CALL J1STRG (' 5 - PARALLEL')
         CALL JCRLF (CRLF)
         CALL JPKID (6)
         CALL J1STRG (' 6 - VIEW POINT')
         CALL JCRLF (CRLF)
         CALL JPKID (7)
         CALL J1STRG (' 7 - UP VECTOR')
         CALL JCRLF (CRLF)
         CALL JPKID (8)
         CALL J1STRG (' 8 - VIEWPLANE')
         CALL JCRLF (CRLF)
         CALL JPKID (9)
         CALL J1STRG (' 9 - W-CLIP ON')
         CALL JCRLF (CRLF)
         CALL JPKID (10)
         CALL J1STRG ('10 - H-CLIP ON')
         CALL JCRLF (CRLF)
         CALL JPKID (11)
         CALL J1STRG ('11 - Y-CLIP ON')
         CALL JCRLF (CRLF)
         CALL JPKID (12)
         CALL J1STRG ('12 - W-CLIP OFF')
         CALL JCRLF (CRLF)
         CALL JPKID (13)
         CALL J1STRG ('13 - H-CLIP OFF')
         CALL JCRLF (CRLF)
         CALL JPKID (14)
         CALL J1STRG ('14 - Y-CLIP OFF')
         CALL JCRLF (CRLF)
         CALL JPKID (15)
         CALL J1STRG ('15 - HITHER DIST')
         CALL JCRLF (CRLF)
         CALL JPKID (16)
         CALL J1STRG ('16 - YON DIST')
         CALL JCRLF (CRLF)
         CALL JPKID (17)
         CALL J1STRG ('17 - SET JCVIEW')
         CALL JCRLF (CRLF)
         CALL JPKID (18)
         CALL J1STRG ('18 - SET JSVIEW')
C
      CALL JRCLOS
C
C     ***** MAKE THE MENU PICK SENSITIVE
C
      CALL JDETEC (1,32767)
C
C     ***** RESTORE THE PREVIOUS VIEWING TRANSFORMATION
C
      CALL JVLOAD (TRHOLD)
C
      RETURN
      END
      SUBROUTINE BUILD
C
C     ***** BUILD A CUBE, 1 UNIT ON A SIDE, CENTERED AT THE ORIGIN
C     ***** EACH SIDE HAS A DIFFERENT COLOR. ONLY THE VISIBLE SIDES
C     ***** ARE DRAWN (AS A FUNCTION OF THE VIEWING TRANSFORMATION).
C
      COMMON /VRATIO/ RATIO,  PLEFT, CRLF, CHXSIZ, CHYSIZ
C
      DIMENSION       DX(4), DY(4), DZ(4), WX(4), WY(4), WZ(4)
      LOGICAL         VISBLE, DRAWIT
C
      DATA VPORTL /-0.30/
      DATA VPORTR / 0.97/
      DATA VPORTB /-0.55/
      DATA VPORTT / 0.73/
C
      DATA DX(1),DX(2),DX(3),DX(4) /-0.48, 0.00, 0.96, 0.00/
      DATA DY(1),DY(2),DY(3),DY(4) /-0.48, 0.96, 0.00,-0.96/
      DATA DZ(1),DZ(2),DZ(3),DZ(4) / 0.00, 0.00, 0.00, 0.00/
C
C     ***** DEFINE A SQUARE VIEWPORT AT THE RIGHT SIDE OF THE SCREEN
C
      CALL JVPORT (VPORTL, VPORTR, VPORTB, VPORTT)
C
      CALL JOPEN
C
C        ***** INQUIRE CURRENT WINDOW AND DRAW A BOX AS A POLYGON
C        ***** FILL THE POLYGON WITH GREEN
C
         CALL JIWIND (WX, WY, WZ)
         CALL JPIDEX (2,0)
         CALL J3PLGN (WX, WY, WZ, 4)
C
C        ***** DRAW CUBE USING POLYGONS
C
         CALL JLWIDE (200)
         CALL JCOLOR (0)
C
C        ***** FRONT
C
         DRAWIT = VISBLE (-.5,-.5,-.5,-.5,0.,-.5,0.,0.,-.5)
         IF (.NOT. DRAWIT) GO TO 2000
C
            CALL J3MOVE (0.,0.,-.5)
            CALL JPIDEX (1,13)
            CALL JR3PGN (DX, DY, DZ, 4)
C
 2000    CONTINUE
C
C        ***** RIGHT
C
         DRAWIT = VISBLE (.5,-.5,-.5,.5,0.,-.5,.5,0.,0.)
         IF (.NOT. DRAWIT) GO TO 3000
C
            CALL J3MOVE (.5,0.,0.)
            CALL JPIDEX (3,14)
            CALL JR3PGN (DZ, DY, DX, 4)
C
 3000    CONTINUE
C
C        ***** TOP
C
         DRAWIT = VISBLE (-.5,.5,-.5,-.5,.5,0.,0.,.5,0.)
         IF (.NOT. DRAWIT) GO TO 4000
C
            CALL J3MOVE (0.,.5,0.)
            CALL JPIDEX (4,15)
            CALL JR3PGN (DX, DZ, DY, 4)
C
 4000 CONTINUE
C
C        ***** LEFT
C
         DRAWIT = VISBLE (-.5,-.5,.5,-.5,0.,.5,-.5,0.,0.)
         IF (.NOT. DRAWIT) GO TO 5000
C
            CALL J3MOVE (-.5,0.,0.)
            CALL JPIDEX (5,16)
            CALL JR3PGN (DZ, DY, DX, 4)
C
 5000    CONTINUE
C
C        ***** BACK
C
         DRAWIT = VISBLE (.5,-.5,.5,.5,0.,.5,0.,0.,.5)
         IF (.NOT. DRAWIT) GO TO 6000
C
            CALL J3MOVE (0.,0.,.5)
            CALL JPIDEX (6,17)
            CALL JR3PGN (DX, DY, DZ, 4)
C
 6000    CONTINUE
C
C        ***** BOTTOM
C
         DRAWIT = VISBLE (-.5,-.5,.5,-.5,-.5,0.,0.,-.5,0.)
         IF (.NOT. DRAWIT) GO TO 7000
C
            CALL J3MOVE (0.,-.5,0.)
            CALL JPIDEX (8,18)
            CALL JR3PGN (DX, DZ, DY, 4)
C
 7000    CONTINUE
C
C        ***** DRAW A SET OF AXES TO IDENTIFY THE WORLD COORDINATE
C        ***** SYSTEM HANDEDNESS
C
         CALL JLSTYL  (2)
         CALL J3MOVE (0.0, 0.0, 0.0)
         CALL J3DRAW (0.9, 0.0, 0.0)
         CALL J3MOVE (0.0, 0.0, 0.0)
         CALL J3DRAW (0.0, 0.9, 0.0)
         CALL J3MOVE (0.0, 0.0, 0.0)
         CALL J3DRAW (0.0, 0.0, 0.9)
C
      CALL JCLOSE
C
      RETURN
      END
      LOGICAL FUNCTION VISBLE (X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3)
C
C     ***** SEE IF THE PLANE DEFINED BY THE THREE PASSED POINTS IS
C     ***** VISIBLE UNDER THE CURRENT VIEWING TRANSFORMATION
C
      CALL JCONWV (X1,Y1,Z1,VX1,VY1)
      CALL JCONWV (X2,Y2,Z2,VX2,VY2)
      CALL JCONWV (X3,Y3,Z3,VX3,VY3)
C
      DX1 = VX2 - VX1
      DY1 = VY2 - VY1
      DX2 = VX3 - VX2
      DY2 = VY3 - VY2
C
      VALUE = -DX1 * DY2  +  DX2 * DY1
      VISBLE = VALUE .GT. 0.00001
C
      RETURN
      END
