      PROGRAM TX0577
C
C     ***** DI-3000 EXTENDED TEST PROGRAM NUMBER 5
C
C     ***** DI-3000 EXTENDED TEST PROGRAM ... WILL NOT RUN WITH LEVEL-A
C
C     ***** TESTS .....
C
C     *****    MODELING, 3D VIEWING
C
C     ***** 5 PICTURES WILL BE GENERATED
C
      INTEGER Q1,Q2,Q3,Q4, INPDEV, OUTDEV
      DIMENSION XV(4),YV(4),ZV(4),JCODE(24),Q1(24),Q2(24)
      DIMENSION Q3(24),Q4(24)
C
C     ***** DEFINE THE VIEWING ACTION CODE AND PARAMETERS FOR THE
C     ***** FIVE PICTURES
C
C     ***** PICTURE-1 ... PERSPECTIVE VIEW FROM UPPER, RIGHT, FRONT
C     ***** PICTURE-2 ... PERSPECTIVE VIEW FROM LOWER, LEFT, BACK
C     ***** PICTURE-3 ... PERSPECTIVE VIEW WITH HITHER CLIPPING
C     ***** PICTURE-4 ... OBLIQUE PARALLEL PROJECTION
C     ***** PICTURE-5 ... OBLIQUE PARALLEL PROJECTION
C
      DATA JCODE( 1),Q1( 1),Q2( 1),Q3( 1),Q4( 1)/ 0,  0,  0,  0,  0/
      DATA JCODE( 2),Q1( 2),Q2( 2),Q3( 2),Q4( 2)/ 7,-25,  0,  0,  0/
      DATA JCODE( 3),Q1( 3),Q2( 3),Q3( 3),Q4( 3)/ 2,-10, 10,-10, 10/
      DATA JCODE( 4),Q1( 4),Q2( 4),Q3( 4),Q4( 4)/ 9, -3, -4,  5,  0/
      DATA JCODE( 5),Q1( 5),Q2( 5),Q3( 5),Q4( 5)/ 1,  0,  0,  0,  0/
      DATA JCODE( 6),Q1( 6),Q2( 6),Q3( 6),Q4( 6)/ 0,  0,  0,  0,  0/
      DATA JCODE( 7),Q1( 7),Q2( 7),Q3( 7),Q4( 7)/ 7,-25,  0,  0,  0/
      DATA JCODE( 8),Q1( 8),Q2( 8),Q3( 8),Q4( 8)/ 2,-10, 10,-10, 10/
      DATA JCODE( 9),Q1( 9),Q2( 9),Q3( 9),Q4( 9)/ 9,  3,  4, -5,  0/
      DATA JCODE(10),Q1(10),Q2(10),Q3(10),Q4(10)/ 1,  0,  0,  0,  0/
      DATA JCODE(11),Q1(11),Q2(11),Q3(11),Q4(11)/ 0,  0,  0,  0,  0/
      DATA JCODE(12),Q1(12),Q2(12),Q3(12),Q4(12)/ 9, -2, -3,  5,  0/
      DATA JCODE(13),Q1(13),Q2(13),Q3(13),Q4(13)/12, -6,  0,  0,  0/
      DATA JCODE(14),Q1(14),Q2(14),Q3(14),Q4(14)/14,  1,  0,  0,  0/
      DATA JCODE(15),Q1(15),Q2(15),Q3(15),Q4(15)/ 7,-25,  0,  0,  0/
      DATA JCODE(16),Q1(16),Q2(16),Q3(16),Q4(16)/ 1,  0,  0,  0,  0/
      DATA JCODE(17),Q1(17),Q2(17),Q3(17),Q4(17)/ 0,  0,  0,  0,  0/
      DATA JCODE(18),Q1(18),Q2(18),Q3(18),Q4(18)/ 9,  0,  0,  1,  0/
      DATA JCODE(19),Q1(19),Q2(19),Q3(19),Q4(19)/14,  0,  0,  0,  0/
      DATA JCODE(20),Q1(20),Q2(20),Q3(20),Q4(20)/ 6, -2, -3, -5,  0/
      DATA JCODE(21),Q1(21),Q2(21),Q3(21),Q4(21)/ 1,  0,  0,  0,  0/
      DATA JCODE(22),Q1(22),Q2(22),Q3(22),Q4(22)/ 6,  2,  3, -5,  0/
      DATA JCODE(23),Q1(23),Q2(23),Q3(23),Q4(23)/ 1,  0,  0,  0,  0/
      DATA JCODE(24),Q1(24),Q2(24),Q3(24),Q4(24)/16,  0,  0,  0,  0/
C
      OUTDEV = 1
      INPDEV = 1
C
C     ***** INITIALIZE DI-3000
C
      CALL JBEGIN
      CALL JDINIT (OUTDEV)
      CALL JDEVON (OUTDEV)
C
C     ***** SET RELEVANT PRIMITIVE ATTRIBUTE DEFAULTS
C
      CALL JDINTE (32767)
      CALL JDLWID (10000)
      CALL JDPINT (1)
C
C     ***** IGNORE ALL ERRORS
C
      CALL JSETER (7)
C
      CALL JWINDO (-10.,10.,-10.,10.)
      CALL JWCLIP (.TRUE.)
C
      KK = 0
C
  500 CONTINUE
C
C     ***** IMPLICIT PICTURE LOOP .....
C
C     ***** GET OPCODES AND PARAMETERS FROM THE DATA ARRAYS UNTIL
C     ***** AN 'END-OF-DATA' COMMAND ('16') IS DETECTED
C
C     ***** '0' OPCODES ARE IGNORED
C
      KK    = KK + 1
      ICODE = JCODE(KK)
      P1    = FLOAT (Q1(KK))
      P2    = FLOAT (Q2(KK))
      P3    = FLOAT (Q3(KK))
      P4    = FLOAT (Q4(KK))
C
      IF (ICODE .LT. 1  .OR.  ICODE .GT. 16) GO TO 500
C
      GO TO ( 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000,
     +       10000,11000,12000,13000,14000,15000,16000), ICODE
C
 1000 CONTINUE
C
C     ***** DRAW CUBE ON A RED BACKGROUND
C
      CALL JOPEN
         CALL JIWIND (XV,YV,ZV)
         CALL JPIDEX (1,0)
         CALL J3PLGN (XV,YV,ZV,4)
      CALL JCLOSE
C
      CALL CUBE
C
      CALL JPAUSE (OUTDEV)
      CALL JFRAME
      GO TO 500
C
 2000 CONTINUE
C
C     ***** WINDOW
C
      CALL JWINDO (P1,P2,P3,P4)
      GO TO 500
C
 3000 CONTINUE
C
C     ***** WINDOW CLIP CONTROL
C
      IF (P1 .EQ. 0.) CALL JWCLIP (.FALSE.)
      IF (P1 .EQ. 1.) CALL JWCLIP (.TRUE.)
      GO TO 500
C
 4000 CONTINUE
C
C     ***** UP VECTOR
C
      CALL JUPVEC (P1,P2,P3)
      GO TO 500
C
 5000 CONTINUE
C
C     ***** PARALLEL PROJECTION (ORTHOGRAPHIC)
C
      CALL JPARAL
      GO TO 500
C
 6000 CONTINUE
C
C     ***** PARALLEL PROJECTION (OBLIQUE)
C
      CALL JPAROB (P1,P2,P3)
      GO TO 500
C
 7000 CONTINUE
C
C     ***** PERSPECTIVE PROJECTION
C
      CALL JPERSP (P1)
      GO TO 500
C
 8000 CONTINUE
C
C     ***** PERSPECTIVE PROJECTION (OBLIQUE)
C
      CALL JPEROB (P1,P2,P3)
      GO TO 500
C
 9000 CONTINUE
C
C     ***** NORMAL VECTOR
C
      CALL JNORML (P1,P2,P3)
      GO TO 500
C
10000 CONTINUE
C
C     ***** VIEW PLANE DISTANCE
C
      CALL JVUPLN (P1)
      GO TO 500
C
11000 CONTINUE
C
C     ***** VIEW REFERENCE POINT
C
      CALL JVUPNT (P1,P2,P3)
      GO TO 500
C
12000 CONTINUE
C
C     ***** HITHER DISTANCE
C
      CALL JHITHR (P1)
      GO TO 500
C
13000 CONTINUE
C
C     ***** YON DISTANCE
C
      CALL JYON (P1)
      GO TO 500
C
14000 CONTINUE
C
C     ***** HITHER CLIPPING CONTROL
C
      IF (P1 .EQ. 0.) CALL JHCLIP (.FALSE.)
      IF (P1 .EQ. 1.) CALL JHCLIP (.TRUE.)
      GO TO 500
C
15000 CONTINUE
C
C     ***** YON CLIPPING CONTROL
C
      IF (P1 .EQ. 0.) CALL JYCLIP (.FALSE.)
      IF (P1 .EQ. 1.) CALL JYCLIP (.TRUE.)
      GO TO 500
C
16000 CONTINUE
C
C     ***** END THE PROGRAM
C
      CALL JEND
C
      STOP
      END
      SUBROUTINE CUBE
C
C     ***** DRAW A CUBE ....
C
C     ***** SIX FACES ARE ALL DERIVED FROM A SINGLE FACE USING MODELING
C     ***** TRANSFORMATIONS
C
      REAL XM(16)
      REAL X1(6),Y1(6),X2(6),Y2(6),X3(6),Y3(6),X4(6),Y4(6)
      INTEGER PINTEN(6),PCOLOR(6),TRCODE(6)
      INTEGER TCOUNT(6)
      CHARACTER * 8 TEXT,STRING
      DIMENSION     TEXT(6)
      REAL ROTANG(6)
C
      LOGICAL VISBLE
C
C     ***** DEFINE ONE PANEL OF ONE FACE ..... THE OTHER 4 PANELS WILL
C     ***** BE DERIVED FROM THIS ONE PANEL IN THE '1000' LOOP BELOW
C
      DATA X1 /-4.9,-4.9,-3.3,-3.3,-0.1,-0.1/
      DATA Y1 /-4.9,-0.1,-0.1,-0.95,-0.95,-4.9/
C
C     ***** DEFINE THE MODELING TRANSFORMATION CODES FOR THE SIX FACES.
C     ***** '1' IS IDENTITY TRANSFORM TO BE APPLIED TO FRONT FACE.
C     ***** SEE THE DI-3000 USER'S GUIDE ('JTRANS' OR 'JBUILD') FOR A
C     ***** DISCUSSION OF THE OTHER TRANSFORMATION CODES.
C
      DATA TRCODE /1,8,8,8,7,7/
C
C     ***** DEFINE ROTATION PARAMETERS FOR THE 5 FACES OTHER THAN THE
C     ***** FRONT FACE. THESE ROTATION VALUES GO WITH THE TRANSFORMATION
C     ***** CODES DEFINE ABOVE.
C
      DATA ROTANG /0.,180.,-90.,90.,-90.,90./
C
C     ***** DEFINE THE COLOR/INTENSITY OF THE PANELS IN A FACE
C
      DATA PCOLOR /2,3,4,5,6,3/
      DATA PINTEN /27,27,28,28,29,29/
C
C     ***** DEFINE TEXT IDENTIFIERS FOR THE FACES OF THE CUBE
C     ***** THESE DATA STATEMENTS ARE MACHINE DEPENDENT.
C     ***** YOU WILL HAVE TO CHANGE THEM FOR MACHINES THAT HAVE A WORD
C     ***** SIZE NOT EQUAL TO 4 CHARACTERS PER WORD.
C
      DATA TCOUNT /5,4,4,5,3,6/
      DATA TEXT /'FRONT   ',
     +           'BACK    ',
     +           'LEFT    ',
     +           'RIGHT   ',
     +           'TOP     ',
     +           'BOTTOM  '/
C
C     ***** BUILD THE COORDINATE VALUES FOR THE OTHER THREE PANELS
C     ***** IN A FACE FROM THE SINGLE PANEL DEFINED IN 'X1' AND 'Y1'
C
      DO 1000 I = 1,6
         X2(I) = -X1(I)
         Y2(I) = -Y1(I)
         X3(I) =  X1(I)
         Y3(I) = -Y1(I)
         X4(I) = -X1(I)
         Y4(I) =  Y1(I)
 1000 CONTINUE
C
C     ***** DEFINE EACH FACE AS A SEPARATE TEMPORARY SEGMENT.
C     ***** A MODELING TRANSFORMATION IS DEFINED FOR EACH FACE TO
C     ***** TRANSFORM THE PROTOTYPE FACE INTO ITS PROPER POSITION
C
      DO 5000 I = 1,6
         CALL JTRANS (XM,TRCODE(I),ROTANG(I),0.,0.,0.,0.,0.,0.)
         CALL JMODEL (XM)
         CALL JMODON (.TRUE.)
C
C        ***** OPEN A TEMPORARY SEGMENT FOR THE FACE
C
         CALL JOPEN
C
C           ***** TAKE THE CROSS PRODUCT OF A RIGHT ANGLE ON THE
C           ***** CURRENT FACE.  IF POSITIVE, THE FACE IS VISIBLE,
C           ***** IF NEGATIVE, THE FACE IS INVISIBLE.
C
C           ***** NOTE THAT BY USING MODELING TRANSFORMATIONS THE RIGHT
C           ***** ANGLE COMPUTATION CAN BE THE SAME FOR ALL FACES.
C
C           ***** THE RIGHT ANGLE IS MAPPED INTO VIRTUAL COORDINATES
C           ***** USING COMPOSITE MODELING AND VIEWING TRANSFORMATION.
C
            CALL JCONWV (-5.,-5.,-5.,VX1,VY1)
            CALL JCONWV (-5., 0.,-5.,VX2,VY2)
            CALL JCONWV ( 0., 0.,-5.,VX3,VY3)
            DX1 = VX2 - VX1
            DX2 = VX3 - VX2
            DY1 = VY2 - VY1
            DY2 = VY3 - VY2
            VALUE = -DX1 * DY2  +  DX2 * DY1
            IF (VALUE .LT. 0.00001) GO TO 4800
C
C              ***** THE FACE IS VISIBLE ..... DRAW TWO PANELS
C              ***** USING THE DESIGNATED COLOR FOR THE FACE .....
C              ***** THE OTHER TWO PANELS ARE ALWAYS DRAWN IN 'BLACK'
C              ***** (OR UNSHADED ON MONOCHROMATIC DEVICES).
C
               CALL JPIDEX (PCOLOR(I),PINTEN(I))
               CALL J3MOVE (0.,0.,-5.)
               CALL JPOLGN (X1,Y1,6)
               CALL JPOLGN (X2,Y2,6)
               CALL JPIDEX (8,0)
               CALL JPOLGN (X3,Y3,6)
               CALL JPOLGN (X4,Y4,6)
C
C              ***** LABEL THE CURRENT FACE USING GRAPHIC ARTS
C              ***** QUALITY TEXT (COMPLEX FONT).
C
               CALL JSIZE (1.,1.5)
               CALL JFONT (5)
               CALL JJUST (2,2)
               CALL J3MOVE (0.0, 0.0, -5.0)
               STRING = TEXT(I)
               NCHARS = TCOUNT(I)
               CALL JHSTRG (STRING(1:NCHARS))
 4800       CONTINUE
         CALL JCLOSE
 5000 CONTINUE
C
C     ***** DISABLE MODELING BEFORE RETURNING
C
      CALL JMODON (.FALSE.)
      RETURN
      END
