      PROGRAM TX0677
C
C     ***** DI-3000 EXTENDED TEST PROGRAM NUMBER 6
C
C     ***** DI-3000 EXTENDED TEST PROGRAM ... WILL NOT RUN WITH LEVEL-A
C
C     ***** TESTS .....
C
C     *****    RETAINED SEGMENTS, SEVERAL MENUS, IMAGE TRANSFORMATIONS
C     *****    DERIVED FROM LOCATOR/VALUATOR ECHOES, MODELING
C
C     ***** THIS PROGRAM WILL ONLY RUN ON INTERACTIVE DEVICES.
C     ***** IT IS TARGETED TOWARD 'LOW-PERFORMANCE' INTERACTIVE
C     ***** DISPLAYS (I.E., NON-REFRESH DEVICES).
C     ***** THE PROMPTING MECHANISM (SEE SUBROUTINES 'PRMPT..') IS
C     ***** TARGETED FOR RASTER DEVICES ... THE PROMPT IS WRITTEN IN
C     ***** A FOREGROUND COLOR AS A TEMPORARY SEGMENT, AND THEN
C     ***** 'ERASED' BY WRITING OVER IT IN THE BACKGROUND COLOR.
C     ***** THIS WILL NOT BE AS PLEASING ON STORAGE TUBES.
C
C     ***** TO RUN THE PROGRAM ON REFRESH DISPLAYS, YOU MAY WISH
C     ***** TO REVISE THE APPROACH TO PROMPTING.
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
      INTEGER DSPDEV
C
      LOGICAL PASIVE, ACTIVE
C
      INPDEV = 1
      OUTDEV = 1
C
      VXMIN = -0.95
      VXMAX =  0.5
      VYMIN = -0.6
      VYMAX =  0.66
C
      VXNMEN =  0.55
      VXXMEN =  0.95
      VYNMEN = -0.66
      VYXMEN =  0.54
C
      WXMIN =   0.0
      WXMAX = 108.75
      WYMIN =   0.0
      WYMAX =  94.5
C
C     ***** THE BACKGROUND COLOR IS DEFINED AS 'BLACK'
C     ***** THIS IS USUALLY THE DEFAULT ON MOST RASTER DISPLAYS
C     ***** CHANGING TO BLUE (4) MAY BE MORE PLEASING ON SOME
C     ***** RASTER DISPLAYS
C
      BAKCOL = 8
C
C     ***** DEFINE THE COLORS FOR THE DISPLAY AREA BOX, THE
C     ***** PROMPTING MESSAGES, AND THE MENUS
C
      BOXCOL = 4
      PCOLOR = 3
      MENCOL = 2
C
      SCOUNT = 0
C
C     ***** DEFINE SEGMENT NAMES FOR THE MENU SEGMENTS
C
      MENU1  = 991
      BOXNAM = 999
C
C     ***** DEFINE THE PROMPT MESSAGE LOCATION FOR THE MENU
C     ***** PROMPT AND ANOTHER PROMPT AT THE BOTTOM OF THE SCREEN
C
      PROMX  = 127.5
      PROMY  =  90.0
C
      PR1X = 54.375
      PR1Y = -3.0
C
      CALL JBEGIN
      CALL JDINIT (OUTDEV)
      CALL JDEVON (OUTDEV)
C
C
C     ***** CHECK FOR THE AVAILABILITY OF INPUT
C
      CALL JIQDEV (OUTDEV, 41, DSPDEV)
      ACTIVE = DSPDEV .GT. 0
      PASIVE = .NOT. ACTIVE
C
      IF (.NOT. PASIVE) GO TO 0001
C
C     ***** PASSIVE DEVICE ---> MESSAGE AND END
C
      WRITE (6,00010)
 0010 FORMAT (' PASSIVE DEVICE ... NO INPUT')
      GOTO 9999
C
 0001 CONTINUE
C
C     ***** NO ERRORS WILL BE FATAL
C
      CALL JSETER (7)
C
C     ***** USE A RECTANGULAR VIEWSPACE (USUALLY A BIGGER AREA)
C
      CALL JVSPAC (-1.,1.,-0.76,0.76)
      CALL JWCLIP (.TRUE.)
C
      CALL JDSIZE (1.,1.)
      CALL JDJUST (2,2)
      CALL JDPINT (1)
      CALL JDINTE (16384)
      CALL JDMARK (4)
C
C     ***** DEFINE THE BACKGROUND COLOR AND FORCE A NEW FRAME ACTION
C     ***** SO THE BACKGROUND COLOR WILL BE DISPLAYED
C
      CALL JBACKG (BAKCOL)
      CALL JFRAME
C
C     ***** DEFINE THE MENU VIEWPORT TO THE RIGHT OF THE DISPLAY AREA
C
      CALL JVPORT (VXNMEN, VXXMEN, VYNMEN, VYXMEN)
c
      CALL MEN1 (MENU1)
C
C     ***** DEFINE THE WINDOW AND VIEWPORT CORRESPONDING TO THE
C     ***** DISPLAY AREA
C
      CALL JWINDO (WXMIN, WXMAX, WYMIN, WYMAX)
      CALL JVPORT (VXMIN, VXMAX, VYMIN, VYMAX)
C
C     ***** DEFINE THE DISPLAY AREA BOX AS A RETAINED SEGMENT
C
      CALL BOX (BOXNAM)
C
C     ***** DRAW OBJECTS TO BE DRAGGED
C
      CALL POLYGN
C
C     ***** ENTER THE MAIN PROGRAM LOOP
C
      CALL PLOOP
C
 9999 CONTINUE
C
      CALL JEND
      STOP
      END
      SUBROUTINE MEN1 (NAME)
C
C     ***** DEFINE THE RETAINED SEGMENT FOR THE PRIMARY MENU
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
C     ***** DEFINE THE WINDOW FOR THIS MENU
C
      CALL JWINDO (-10., 10., -60., 0.)
C
      CALL JROPEN (NAME)
         CALL JCOLOR (MENCOL)
C
C        ***** DRAW A BOX AROUND THE MENU ... THIS BOX IS NOT A
C        ***** POLYGON SINCE WE DON'T WANT THE PICK CYCLE TO
C        ***** DETECT THE BOX ..... ONLY THE MENU ITEMS
C
         CALL JIWIND (XW,YW,ZW)
         CALL JINTEN (32767)
         CALL JMOVE (XW(4),YW(4))
         CALL JPOLY (XW,YW,4)
C
C        ***** DEFINE THE MENU ITEMS
C
         CALL JINTEN (16384)
         CALL JSIZE (3.,3.)
         CALL JPKID (1)
         CALL JMOVE (0., -5.)
         CALL J1STRG ('TRANS.')
         CALL JPKID (2)
         CALL JMOVE (0., -25.)
         CALL J1STRG ('UPDATE')
         CALL JPKID (3)
         CALL JMOVE (0.,-45.)
         CALL J1STRG ('END')
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE BOX (NAME)
C
C     ***** DEFINE THE BOX AROUND THE DISPLAY AREA AS A RETAINED SEGMENT
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      CALL JDSGPR (1)
      CALL JROPEN (NAME)
         CALL JPIDEX (BOXCOL,0)
         CALL JIWIND (XW,YW,ZW)
         CALL JINTEN (32767)
         CALL JPOLGN (XW,YW,4)
      CALL JRCLOS
C
      RETURN
      END
      SUBROUTINE POLYGN
C
C     ***** DRAW POLYGONS TO BE DRAGED
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      DIMENSION PX1(4),PY1(4),PX2(6),PY2(6)
C
      DATA PX1(1),PX1(2),PX1(3),PX1(4) /-6.0,0.0,12.0,0.0/
      DATA PY1(1),PY1(2),PY1(3),PY1(4) /0.0,6.0,0.0,-12.0/
      DATA PX2(1),PX2(2),PX2(3),PX2(4),PX2(5),PX2(6)
     +     /-12.0,4.0,16.0,4.0,-4.0,-16.0/
      DATA PY2(1),PY2(2),PY2(3),PY2(4),PY2(5),PY2(6)
     +     /0.0,6.0,0.0,-6.0,-6.0,0.0/
C
C
      KOLOR = 1
C
      CALL JTTYPE (2)
      CALL JDSGPR (10)
C
C     ***** DEFINE A DIAMOND (4-SIDED CIRCLE)
C
      CALL JROPEN (10)
         X = WXMAX/4.0
         Y = WYMAX/4.0
         CALL JPIDEX (KOLOR, 0)
         CALL JCIRCL (X,Y,0.0,6.0,4)
         CALL JMARK (X+6.0,Y)
         CALL JMARK (X-6.0,Y)
         CALL JMARK (X,Y+6.0)
         CALL JMARK (X,Y-6.0)
      CALL JRCLOS
      CALL JDETEC (10, 32767)
      SX(10) = X
      SY(10) = Y
C
C     ***** DEFINE A 'PRINT BOX'
C
      X = (WXMAX * 3.0)/4.0
      Y = (WYMAX * 3.0)/4.0
      CALL JROPEN (20)
         CALL JPIDEX (KOLOR,0)
         CALL JMOVE (X,Y)
         CALL JRPLGN (PX1,PY1,4)
         CALL JMARK (X+6.0,Y)
         CALL JMARK (X-6.0,Y)
         CALL JMARK (X,Y+6.0)
         CALL JMARK (X,Y-3.0)
      CALL JRCLOS
      CALL JDETEC (20, 32767)
      SX(20) = X
      SY(20) = Y
C
C     ***** DEFINE A CIRCLE
C
      X = WXMAX/4.0
      Y = (WYMAX * 3.0)/4.0
      CALL JROPEN (30)
         CALL JPIDEX (KOLOR, 0)
         CALL JCIRCL (X,Y,0.0,6.0,30)
         CALL JMARK (X+6.0,Y)
         CALL JMARK (X-6.0,Y)
         CALL JMARK (X,Y+6.0)
         CALL JMARK (X,Y-6.0)
      CALL JRCLOS
      CALL JDETEC (30, 32767)
      SX(30) = X
      SY(30) = Y
C
C     ***** DEFINE A HEXAGONAL POLYGON
C
      X = (WXMAX * 3.0)/4.0
      Y = WYMAX/4.0
      CALL JROPEN (40)
         CALL JPIDEX (KOLOR,0)
         CALL JMOVE (X,Y)
         CALL JRPLGN (PX2,PY2,6)
         CALL JMARK(X+12.0,Y)
         CALL JMARK(X-12.0,Y)
         CALL JMARK(X,Y+6.0)
         CALL JMARK(X,Y-6.0)
      CALL JRCLOS
      CALL JDETEC (40, 32767)
      SX(40) = X
      SY(40) = Y
C
      RETURN
      END
      SUBROUTINE PLOOP
C
C     ***** MAIN PROGRAM LOOP TO PROCESS MENUS
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
C     ***** ENABLE THE PICK AND LOCATOR INPUT DEVICES
C
      CALL JIENAB (OUTDEV, 5, INPDEV)
      CALL JIENAB (OUTDEV, 2, INPDEV)
C
C     ***** BEGIN MAIN LOOP
C
  500 CONTINUE
C
      CALL JBGBAT (0)
C
  550 CONTINUE
C
C     ***** ENABLE THE MAIN MENU AND MAKE IT DETECTABLE
C
      CALL JVISBL (MENU1,1)
      CALL JDETEC (MENU1,1)
C
C     ***** SET THE ECHO POSITION TO THE TOP OF THE MENU
C     ***** FOR THE PICK
C
      CALL JPECHO (OUTDEV, 5, INPDEV, 0.75, 0.58)
C
 1000 CONTINUE
C
C     ***** PROMPT THE USER TO PICK FROM THE MENU
C
      CALL PRMP1 (PCOLOR)
      CALL JPICK (OUTDEV, INPDEV, 1, IBUT, ISEG, IPKID)
C
C     ***** DISABLE THE PROMPT MESSAGE
C
      CALL PRMP1 (BAKCOL)
C
C     ***** THE USER MUST PICK THE MAIN MENU AND ONE OF THE MENU
C     ***** ITEMS (I.E., NOT THE BORDER)
C
      IF (ISEG .NE. MENU1) GO TO 1000
         IF (IPKID .LT. 1  .OR.  IPKID .GT. 3) GO TO 1000
C
C           ***** OPEN A BATCH OF UPDATES FOR WHATEVER WAS PICKED
C
            GO TO (1100, 1200, 9000), IPKID
C
 1100 CONTINUE
C
C     ***** TRANSFORM SELECTED OBJECTS
C
      CALL XFORM
      GO TO 550
C
 1200 CONTINUE
C
C     ***** UPDATE THE SCREEN
C
      CALL JENBAT
      GO TO 500
C
 9000 CONTINUE
C
C     ***** END THE PROGRAM
C
      CALL JENBAT
C
      RETURN
      END
      LOGICAL FUNCTION INSIDE (VX, VY)
C
C     ***** DETERMINE IF THE GIVEN POINT IS INSIDE THE DISPLAY AREA VIEWPORT
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      INSIDE = (VX .GT. VXMIN  .AND.
     +          VX .LT. VXMAX  .AND.
     +          VY .GT. VYMIN  .AND.
     +          VY .LT. VYMAX       )
C
      RETURN
      END

      SUBROUTINE PRMP1 (KOLOR)
C
C     ***** 'PICK FROM MENU' PROMPT MESSAGE WRITTEN IN 'KOLOR'
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      CALL JWCLIP (.FALSE.)
      CALL JOPEN
         CALL JCOLOR (KOLOR)
         CALL JMOVE (PROMX, PROMY)
         CALL J1STRG ('PICK FROM MENU')
      CALL JCLOSE
      CALL JWCLIP (.TRUE.)
C
      RETURN
      END
      SUBROUTINE PRMP2 (KOLOR)
C
C     ***** 'PICK SEGMENT TO TRANSLATE' PROMPT WRITTEN IN 'KOLOR'
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      CALL JWCLIP (.FALSE.)
      CALL JOPEN
         CALL JCOLOR (KOLOR)
         CALL JMOVE (PR1X, PR1Y)
         CALL J1STRG ('PICK SEGMENT TO TRANSLATE')
      CALL JCLOSE
      CALL JWCLIP (.TRUE.)
C
      RETURN
      END
      SUBROUTINE PRMP3 (KOLOR)
C
C     ***** ECHO TRANSLATION PROMPT
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      CALL JWCLIP (.FALSE.)
      CALL JOPEN
         CALL JCOLOR (KOLOR)
         CALL JMOVE (PR1X, PR1Y)
         CALL J1STRG ('SET TRANSLATION ECHO POSITION')
      CALL JCLOSE
      CALL JWCLIP (.TRUE.)
C
      RETURN
      END
      SUBROUTINE PRMP4 (KOLOR)
C
C     ***** TRANSLATION DISPLACEMENT PROMPT
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      CALL JWCLIP (.FALSE.)
      CALL JOPEN
         CALL JCOLOR (KOLOR)
         CALL JMOVE (PR1X, PR1Y)
         CALL J1STRG ('DEFINE TRANSLATION DISPLACEMENT')
      CALL JCLOSE
      CALL JWCLIP (.TRUE.)
C
      RETURN
      END
C
      SUBROUTINE XFORM
C
C     ***** APPLY IMAGE TRANSFORMATIONS TO MANIPULATE SEGMENTS
C
      COMMON /BLOCK/ VXMIN, VXMAX, VYMIN, VYMAX, WXMIN, WXMAX,
     +               WYMIN, WYMAX, VXNMEN, VXXMEN, VYNMEN, VYXMEN,
     +               BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +               SX, SY, SCOLOR, XW, YW, ZW, PROMX, PROMY,
     +               STYPE, PR1X, PR1Y, TX, TY
C
      INTEGER        BAKCOL, MENCOL, BOXCOL, PCOLOR, MENU1, MENU2,
     +               MENU3, MENU4, BOXNAM, SCOUNT, SEGON,
     +                       SCOLOR, STYPE
C
      DIMENSION      SEGON(100), SX(100), SY(100), SCOLOR(100),
     +               XW(4), YW(4), ZW(4), STYPE(100), TX(100), TY(100)
C
      INTEGER   ECHLST, TMPSEG
      LOGICAL   INSIDE
      DIMENSION ECHLST(100)
C
      COMMON /DEVICE/ OUTDEV, INPDEV
      INTEGER         OUTDEV, INPDEV
C
      TMPSEG = 9999
      WXRAT = (WXMAX - WXMIN) / (VXMAX - VXMIN)
      WYRAT = (WYMAX - WYMIN) / (VYMAX - VYMIN)
C
 2000 CONTINUE
C
C     ***** TRANSLATE IMAGE TRANSFORMATION
C
C     ***** PROMPT THE USER TO PICK ONE OR MORE SEGMENTS TO BE
C     ***** TRANSLATED AS A GROUP
C
      VX = VXMIN + (VXMAX - VXMIN) / 2.0
      VY = VYMIN + (VYMAX - VYMIN) / 2.0
      CALL JPECHO (OUTDEV, 5, INPDEV, VX, VY)
C
      CALL PRMP2 (PCOLOR)
      NLIST = 0
C
11500 CONTINUE
C
C     ***** SELECT SEGMENTS UNTIL EITHER BUTTON 9 IS HIT, A MENU
C     ***** ITEM IS SELECTED, OR THE PICK MISSES
C
      CALL JPICK (OUTDEV, INPDEV, 1, IBUT, ISEG, IPKID)
      IF (IBUT .EQ. 9) GO TO 11600
C
         IF (ISEG .EQ. MENU1  .OR.  ISEG .LE. 0) GO TO 11600
C
C           ***** ADD THE DETECTED SEGMENT TO THE DRAGGING LIST
C           ***** AS AN AID TO THE USER, PUT OUT A MARKER AT THE
C           ***** CENTER OF THE SEGMENT
C
            NLIST = NLIST + 1
            ECHLST(NLIST) = ISEG
            CALL JOPEN
               CALL JCMARK (4)
               DX = WXRAT * TX(ISEG)
               DY = WYRAT * TY(ISEG)
               SX(ISEG) = SX(ISEG) + DX
               SY(ISEG) = SY(ISEG) + DY
               CALL JMARK (SX(ISEG), SY(ISEG))
            CALL JCLOSE
C
C           ***** ASSOCIATE THE SEGMENT WITH THE LOCATOR ECHO
C
            CALL JELSEG (OUTDEV, INPDEV, ISEG, 1)
C
C           ***** UPDATE PICK ECHO TO CENTER OF PICKED OBJECT
C
            CALL JCONWV (SX(ISEG),SY(ISEG),0.0,VX,VY)
            CALL JPECHO (OUTDEV, 5, INPDEV, VX, VY)
            GO TO 11500
C
11600 CONTINUE
C
C     ***** FINISHED IDENTIFYING SEGMENTS ... DEFINE ECHO POSITION
C     ***** FOR THE DRAGGING
C     ***** DISABLE THE OLD PROMPT AND PROMPT THE USER TO
C     ***** DEFINE THE ECHO
C
      CALL PRMP2 (BAKCOL)
      CALL PRMP3 (PCOLOR)
C
C     ***** THE LOCATOR WILL COME UP IN THE MIDDLE OF THE SCREEN
C
      VX = VXMIN + (VXMAX - VXMIN) / 2.0
      VY = VYMIN + (VYMAX - VYMIN) / 2.0
      CALL JPECHO (OUTDEV, 2, INPDEV, VX, VY)
C
11700 CONTINUE
C
C     ***** USE THE LOCATOR TO DEFINE THE ECHO POSITION.
C     ***** THE ECHO POSITION MUST BE INSIDE THE DISPLAY AREA
C
      CALL JLOCAT (OUTDEV, INPDEV, 1, IBUT, VX, VY)
      IF (.NOT. INSIDE (VX,VY)) GO TO 11700
C
C     ***** SET THE DRAGGING ECHO POSITION AND OUTPUT A
C     ***** MARKER TO AID THE USER
C
      CALL JPECHO (OUTDEV, 2, INPDEV, VX, VY)
      CALL JOPEN
         CALL JCONVW (VX,VY,X,Y,Z)
         CALL JCMARK (3)
         CALL JMARK (X,Y)
      CALL JCLOSE
C
C     ***** DISABLE THE ECHO POSITION PROMPT AND ENABLE THE
C     ***** DISPLACEMENT SELECTION PROMPT
C
      CALL PRMP3 (BAKCOL)
      CALL PRMP4 (PCOLOR)
C
C     ***** USE THE LOCATOR TO DRAG THE SELECTED SEGMENTS
C     ***** ON REFRESH DEVICES THE OBJECTS WILL MOVE IN REAL TIME
C     ***** ON LESS INTELLIGENT DEVICES THE CURSOR ONLY WILL MOVE
C     ***** WHEN THE USER TRIGGERS THE CURSOR THE SELECTED OBJECTS
C     ***** WILL BE UPDATED TO THEIR NEW POSITIONS. THE OLD LOCATIONS
C     ***** OF THE OBJECTS WILL REMAIN ON THE SCREEN UNTIL THE END
C     ***** OF THE BATCH OF UPDATES.
C
      CALL JLOCAT (OUTDEV, INPDEV, 7, IBUT, VX, VY)
C
C     ***** SAVE THE TRANSFORMATIONS FOR THE SEGMENTS.
C
      DO 11900 I = 1, NLIST
         ISEG = ECHLST(I)
         CALL JIQ2TR (ISEG, TXX, TYY)
         TX(ISEG) = TXX
         TY(ISEG) = TYY
11900 CONTINUE
C
C     ***** DISABLE THE DISPLACEMENT PROMPT
C
      CALL PRMP4 (BAKCOL)
C
C     ***** DISASSOCIATE THE LOCATOR IMAGE TRANSFORMATION ECHO
C     ***** WITH THE SELECTED SEGMENTS
C
      IF (NLIST .EQ. 0) GO TO 2000
         DO 11950 I = 1,NLIST
            CALL JELSEG (OUTDEV, INPDEV, ECHLST(I), 0)
            CALL JSCOPY (ECHLST(I), TMPSEG, 1)
            CALL JDETEC (TMPSEG, 32767)
            CALL JPURGE (ECHLST(I))
            CALL JRENAM (TMPSEG, ECHLST(I))
11950    CONTINUE
C
C     ***** RETURN TO CALLING PROGRAM
C
      RETURN
      END
