/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	"@(#)make:rules.c	1.9.1.1"   */
#include "defs"
/* DEFAULT RULES FOR UNIX */

/*
 *	These are the internal rules that "make" trucks around with it at
 *	all times. One could completely delete this entire list and just
 *	conventionally define a global "include" makefile which had these
 *	rules in it. That would make the rules dynamically changeable
 *	without recompiling make. This file may be modified to local
 *	needs. 
 *
 *	The makefile for make (make.mk) is parameterized for a different
 *	rules file. The macro $(RULES) defined in "make.mk" can be set
 *	to another file and when "make" is "made" the procedure will
 *	use the new file. The recommended way to do this is on the
 *	command line as follows:
 *		"make -f make.mk RULES=pwbrules"
 */


CHARSTAR builtin[] = {

/* SUFFIX LIST */
	".SUFFIXES: .o .c .c~ .f .f~ .F .F~ .e .e~ .r .r~ .y .y~ .l .l~ .s .s~ .sh .sh~ .h .h~",

/* PRESET VARIABLES */
	"MAKE=make",
	"AR=ar",	"ARFLAGS=rv",
	"AS=as",	"ASFLAGS=",
	"CC=cc",	"CFLAGS=-O",
    "FC=f77",
	"F77=f77",	"F77FLAGS=",
	"GET=get",	"GFLAGS=",
	"LEX=lex",	"LFLAGS=",
	"LD=ld",	"LDFLAGS=",
	"YACC=yacc",	"YFLAGS=",

/* SINGLE SUFFIX RULES */
	".c:",
		"\t$(CC) $(CFLAGS) $(LDFLAGS) $< -o $@",
	".c~:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(CC) $(CFLAGS) $(LDFLAGS) $*.c -o $*",
		"\t-rm -f $*.c",
	".sh:",
		"\tcp $< $@; chmod 0777 $@",
	".sh~:",
		"\t$(GET) $(GFLAGS) $<",
		"\tcp $*.sh $*; chmod 0777 $@",
		"\t-rm -f $*.sh",
    ".f:",
        "\t$(FC) $(FFLAGS) $(LDFLAGS) $< -o $@",
    ".f~:",
        "\t$(GET) $(GFLAGS) $<",
        "\t$(FC) $(FFLAGS) $(LDFLAGS) $< -o $*",
        "\t-rm -f $*.f",
	".r:",
		"\t$(FC) $(FFLAGS) $(LDFLAGS) $< -o $@",
	".r~:",
		"\t$(GET) $(GFLAGS) -p $< > $*.r",
		"\t$(FC) -n $(FFLAGS) $*.r -o $*",
		"\t-rm -f $*.r",
	".e:",
		"\t$(FC) $(FFLAGS) $(LDFLAGS) $< -o $@",
	".e~:",
		"\t$(GET) $(GFLAGS) -p $< > $*.e",
		"\t$(FC) -n $(FFLAGS) $*.e -o $*",
		"\t-rm -f $*.e",
	".F:",
		"\t$(FC) $(FFLAGS) $(LDFLAGS) $< -o $@",
	".F~:",
		"\t$(GET) $(GFLAGS) -p $< > $*.F",
		"\t$(FC) -n $(FFLAGS) $*.F -o $*",
		"\t-rm -F $*.F",


/* DOUBLE SUFFIX RULES */
	".c.o:",
		"\t$(CC) $(CFLAGS) -c $<",
	".c~.o:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(CC) $(CFLAGS) -c $*.c",
		"\t-rm -f $*.c",
	".c.a:",
		"\t$(CC) -c $(CFLAGS) $<",
		"\tar rv $@ $*.o",
		"\trm -f $*.o",
	".c~.a:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(CC) -c $(CFLAGS) $*.c",
		"\t$(AR) $(ARFLAGS) $@ $*.o",
		"\trm -f $*.[co]",
	".c~.c:",
		"\t$(GET) $(GFLAGS) $<",
	".s.o:",
		"\t$(AS) $(ASFLAGS) -o $@ $<",
	".s~.o:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(AS) $(ASFLAGS) -o $*.o $*.s",
		"\t-rm -f $*.s",
	".s.a:",
		"\t$(AS) $(ASFLAGS) -o $*.o $<",
		"\tar rv $@ $*.o",
		"\t-rm -f $*.o",
	".s~.a:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(AS) $(ASFLAGS) -o $*.o $*.s",
		"\t$(AR) $(ARFLAGS) $@ $*.o",
		"\t-rm -f $*.[so]",
	".s~.s:",
		"\t$(GET) $(GFLAGS) $<",
	".sh~.sh:",
		"\t$(GET) $(GFLAGS) $<",
    ".f.o:",
        "\t$(FC) $(FFLAGS) -c $<",
    ".f~.o:",
        "\t$(GET) $(GFLAGS) $<",
        "\t$(FC) $(FFLAGS) -c $*.f",
        "\t-rm -f $*.f",
	".f.a:",
		"\t$(FC) -c $(FFLAGS) $<",
		"\tar rv $@ $*.o",
		"\trm -f $*.o",
	".f~.a:",
		"\t$(GET) $(GFLAGS) -p $< > $*.f",
		"\t$(FC) -c $(FFLAGS) $*.f",
		"\tar rv $@ $*.o",
		"\trm -f $*.[fo]",
	".f~.f:",
		"\t$(GET) $(GFLAGS) $<",
	".y.o:",
		"\t$(YACC) $(YFLAGS) $<",
		"\t$(CC) $(CFLAGS) -c y.tab.c",
		"\trm y.tab.c",
		"\tmv y.tab.o $@",
	".y~.o:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(YACC) $(YFLAGS) $*.y",
		"\t$(CC) $(CFLAGS) -c y.tab.c",
		"\trm -f y.tab.c $*.y",
		"\tmv y.tab.o $*.o",
	".y.c :",
		"\t$(YACC) $(YFLAGS) $<",
		"\tmv y.tab.c $@",
	".y~.c :",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(YACC) $(YFLAGS) $*.y",
		"\tmv y.tab.c $*.c",
		"\t-rm -f $*.y",
	".y~.y:",
		"\t$(GET) $(GFLAGS) $<",
	".l.o:",
		"\t$(LEX) $(LFLAGS) $<",
		"\t$(CC) $(CFLAGS) -c lex.yy.c",
		"\trm lex.yy.c",
		"\tmv lex.yy.o $@",
	".l~.c:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(LEX) $(LFLAGS) $*.l",
		"\tmv lex.yy.c $@",
		"\t-rm -f $*.l",
	".l~.l:",
		"\t$(GET) $(GFLAGS) $<",
	".l~.o:",
		"\t$(GET) $(GFLAGS) $<",
		"\t$(LEX) $(LFLAGS) $*.l",
		"\t$(CC) $(CFLAGS) -c lex.yy.c",
		"\trm -f lex.yy.c $*.l",
		"\tmv lex.yy.o $*.o",
	".l.c :",
		"\t$(LEX) $(LFLAGS) $<",
		"\tmv lex.yy.c $@",
	".h~.h:",
		"\t$(GET) $(GFLAGS) $<",
	".r.o:",
		"\t$(FC) $(FFLAGS) -c $<",
	".r~.o:",
		"\t$(GET) $(GFLAGS) -p $< > $*.r",
		"\t$(FC) $(FFLAGS) -c $*.r",
		"\t-rm -f $*.r",
	".r.a:",
		"\t$(FC) -c $(FFLAGS) $<",
		"\tar rv $@ $*.o",
		"\trm -f $*.o",
	".r~.a:",
		"\t$(GET) $(GFLAGS) -p $< > $*.r",
		"\t$(FC) -c $(FFLAGS) $*.r",
		"\tar rv $@ $*.o",
		"\trm -f $*.[ro]",
	".r~.r:",
		"\t$(GET) $(GFLAGS) -p $< > $*.r",
	".e.o:",
		"\t$(FC) $(FFLAGS) -c $<",
	".e~.o:",
		"\t$(GET) $(GFLAGS) -p $< > $*.e",
		"\t$(FC) $(FFLAGS) -c $*.e",
		"\t-rm -f $*.e",
	".e~.a:",
		"\t$(GET) $(GFLAGS) -p $< > $*.e",
		"\t$(FC) -c $(FFLAGS) $*.e",
		"\tar rv $@ $*.o",
		"\trm -f $*.[eo]",
	".e.a:",
		"\t$(FC) -c $(FFLAGS) $<",
		"\tar rv $@ $*.o",
		"\trm -f $*.o",
	".e~.e:",
		"\t$(GET) $(GFLAGS) -p $< > $*.e",
	".F.o:",
		"\t$(FC) $(FFLAGS) -c $<",
	".F~.o:",
		"\t$(GET) $(GFLAGS) -p $< > $*.F",
		"\t$(FC) $(FFLAGS) -c $*.F",
		"\t-rm -F $*.F",
	".F~.a:",
		"\t$(GET) $(GFLAGS) -p $< > $*.F",
		"\t$(FC) -c $(FFLAGS) $*.F",
		"\tar rv $@ $*.o",
		"\trm -f $*.[Fo]",
	".F.a:",
		"\t$(FC) -c $(FFLAGS) $<",
		"\tar rv $@ $*.o",
		"\trm -f $*.o",
	".F~.F:",
		"\t$(GET) $(GFLAGS) -p $< > $*.F",
	"markfile.o:	markfile",
		"\tA=@;echo \"static char _sccsid[] = \\042`grep $$A'(#)' markfile`\\042;\" > markfile.c",
		"\t$(CC) -c markfile.c",
		"\trm -f markfile.c",
	0 };
