#!/bin/sh
#  Build script for the whatis database.  This database is built from the man
#  page source files and is used by the apropos and whatis commands.
#
#  Clean up working directories:
#
rm -f ${ROOT}/usr/tmp/whatis$$

#
#  Process the man page source files building the whatis database from the
#  information.
#
for i in a_man/man1 a_man/man7 a_man/man8 p_man/man2 p_man/man3 p_man/man4 \
	p_man/man5 u_man/man1 u_man/man6 ; do 

	cd ${SL}/usr/man/$i
	${ROOT}/usr/ucb/getNAME *.*

done > ${ROOT}/usr/tmp/whatis$$

#
#  Edit the whatis file into a more useful format for data perusal.
#
sed -e 's/\\-/-/g' -e 's/\\\*-/-/g' \
	-e 's/.TH [^ ]* \([^ 	]*\).*	\([^-]*\)/\2(\1)	/' \
	-e 's/	 /	/g' ${ROOT}/usr/tmp/whatis$$ | \
${ROOT}/usr/ucb/expand \
-24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,96,100 \
| sort | ${ROOT}/usr/ucb/unexpand -a > ${ROOT}/usr/lib/whatis

#
#  Set the proper access and cleanup.
#
chmod 644 ${ROOT}/usr/lib/whatis
rm -f ${ROOT}/usr/tmp/whatis$$
