#!/bin/sh
# Catable manual entries printer
#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#     	@(#)man:man.sh	1.4

PATH=/usr/ucb:/bin:/usr/bin
export PATH

BASE=/usr
sec=\?
sub=\*
dir=
col=
cmd=
entries=
TTERM=
apropos=
whatis=
all=
post=

# Parse options

for i in $* ; do
	case $i in
		-c)		col=col ;;
		-d)		dir=. ;;
		-f)		whatis=option ;;
		-k)		apropos=option ;;
		-w)		cmd=w ;;
		-T*)		TERM="`echo $i | sed 's/-T//'`" ;;
		-12)		TTERM=-12 ;;
		[1-8])		sec=$i ;;
		[1-8][a-z])	sec=`expr $i : '\(.\).'` ; sub=`expr $i : '.\(.\)'` ;;
		*)		entries="$entries $i" ;;
	esac
done

# Examine options f and k in order to invoke the utilities apropos and whatis.

if [ "$apropos" = "option" ] ; then
	apropos $entries
        exit
fi

if [ "$whatis" = "option" ] ; then
	whatis $entries
        exit
fi

# Now find the named entries

for i in $entries ; do

	if [ "$dir" = "." ] ; then
		if [ ! -r "$i" ] ; then
			echo $0: $i not found >&2
			exit 1
		else
			all="$all $i"
		fi
	else
		cd $BASE/catman
		fil="`find */man$sec/$i.$sec$sub.z -print 2>/dev/null`"
		if [ -n "$fil" ] ; then
			all="$all $fil"
		else
			echo $0: $i not found >&2
			exit 1
		fi
	fi

done


# Fix up the terminal type option (make sure to use col, etc.)

case "$TERM$TTERM" in

	300|300s|450|37|300-12|\
	300s-12|450-12|4000a|\
	4000A|382|\
	1620|1620-12)	post="| greek -T$TERM$TTERM" ;;

	hp|2621|\
	2645|2640)	col="col"; post="| greek -T$TERM$TTERM" ;;

	4014|tek)	post="| greek -T$TERM$TTERM" ;;

	X97)		col="col"; post="| xerox" ;;

	*)		col="col -x" ;;

esac

if [ "`universe`" = "ucb" ] ; then
	post="$post | ${PAGER:-more}"
fi

if [ "$col" != "" ] ; then
	post="| $col $post"
fi

# Now print the pages

if [ "$cmd" = "w" ] ; then
	echo $all
else
	for i in $all ; do
		case $i in
			*.z)	eval "pcat $i $post" ;;
			*)	eval "cat $i $post" ;;
	   	esac
	done
fi
