#include <stdio.h>
#include <ctype.h>

/* external routines */
double drand48();
char random_alphabetic();
char random_numeric();
char random_alphanumeric();

static char alphabetic[] = { 
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z' };

static char numeric[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' };

static char alphanumeric[] = { 
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9' };

char passwd[9] = "        ";	/* storage for the null-terminated password */


/* main works as follows:  Six random alphanumeric characters are
   generated.  There is a constraint that at least two of the characters
   must be alphabetic, and at least one numeric.  */

main()
{
	int i;	/* for loop iteration variable */
	int j;	/* index into global array "passwd" */
	int numerics = 0;	/* number of numerics in first 3 chars */
	int alphabetics = 0;	/* number of alphabetics in first 3 chars */

	/* seed the random number generator */
	srand48(time((long *) 0));

	/* generate the first three characters */
	j = 0;	/* initial value */
	for (i = 0; i < 3; i++) {
		passwd[j] = random_alphanumeric();
		j++;
	}	/* end for */

	/* count numerics and alphabetics so far */
	for (i = 0; i < 3; i++) {
		if (isalpha(passwd[i])) alphabetics++;
		else numerics++;
	}

	/* generate a numeric (if necessary) */
	if (numerics == 0) {
		passwd[j] = random_numeric();
		j++;
	}

	/* generate up to two alphabetics (if necessary) */
	for (i = alphabetics; i < 2; i++) {
		passwd[j] = random_alphabetic();
		j++;
	}

	/* generate the remainder (if any) */
	for (i = j; i < 6; i++) {
		passwd[j] = random_alphanumeric();
		j++;
	}

	/* print the final value */
	printf("%s\n", passwd);
}	/* end main */


/* random_alphabetic returns a random alphabetic character.  Alphabetic
   in this instance means in the range ['A'..'Z', 'a'..'z'].  */

char random_alphabetic()
{
	int random;	/* index into the alphabetic characters */

	random = (int) (drand48() * 51.0 + 0.5);
	return(alphabetic[random]);
}	/* end random_alphabetic */


/* random_numeric returns a random numeric character.  Numeric
   in this instance means in the range ['0'..'9'].  */

char random_numeric()
{
	int random;	/* index into the numeric characters */

	random = (int) (drand48() * 9.0 + 0.5);
	return(numeric[random]);
}	/* end random_numeric */


/* random_alphanumeric returns a random alphanumeric character.  Alphanumeric
   in this instance means in the range ['0'..'9', 'A'..'Z', 'a'..'z'].  */

char random_alphanumeric()
{
	int random;	/* index into the alphanumeric characters */

	random = (int) (drand48() * 61.0 + 0.5);
	return(alphanumeric[random]);
}	/* end random_alphanumeric */
