/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*    	"@(#)passwd:passwd.c	1.4"    */
static	char sccsid[] = "@(#)passwd.c 1.1 85/05/30 SMI"; /* from UCB 4.4 82/07/10 */
/*
 * passwd
 *
 * Enter a password in the password file.
 * This program should be suid with the owner
 * having write permission on /etc
 */

#include <stdio.h>
#include <signal.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/param.h>
#include <ctype.h>         /* isalpha(c), isdigit(c), islower(c), toupper(c) */
#define TRUE 1
#define FALSE 0

char	*PASSWD = "/etc/passwd";
char    opasswd[MAXPATHLEN] = "/etc/opasswd";
char	*OPASSWD = opasswd;
char	temp[]	 = "/etc/ptmp";
struct	passwd *pwd, *yp_pwd, *getpw(), *getpwnam();
char	*crypt();
char	*getpass();
char    *strrchr();
char	*pw;
char	pwbuf[10];
char	hostname[256];
char	opwbuf[10];
char	buf[10];

time_t	when;
time_t	now;
time_t	maxweeks;
time_t	minweeks;
long	a64l();
char	*l64a();
long	time();
int	count; /* count verifications */
int     yp_reference; /* yellow pages reference flag */

#define WEEK (24L * 7 * 60 * 60) /* seconds per week */
#define MINLENGTH 6  /* for passwords */

main (argc, argv)
	int argc;
	char *argv[];
{
	char *p;
	int i;
	char saltc[2];
	long salt;
	int u;
	int insist;
	int ok, flags;
	int c;
	int j;                     /* for triviality checks */
	int k;                     /* for triviality checks */
	int flag;                  /* for triviality checks */
	int opwlen;                /* for triviality checks */
	int pwlen;
	FILE *tf;
	char *o;                   /* for triviality checks */
	char *uname, *getlogin();
	char *dirname;             /* for constructing OPASSWD */
 	int offset;

	insist = 0;
	count = 0;
	uname = NULL;
	while (argc > 1) {
		if (argv[1][0] == '-') {
			if (argv[1][1] != 'f' || argc < 3) {
				usage();
				goto bex;
			}
			PASSWD = argv[2];

			/* build different OPASSWD */
			/* OPASSWD = NULL; */
			if ((dirname = strrchr(PASSWD, '/')) != NULL) {
				offset = (int)(dirname-PASSWD+1);
			        strncpy(OPASSWD, PASSWD, offset);
			        OPASSWD[offset] = NULL;
			}
			strncat(OPASSWD, "o");
			strncat(OPASSWD, dirname+1);

			argc--;
			argv++;
		}
		else {
			if (uname) {
				usage();
				exit(1);
			}
			uname = argv[1];
		}
		argc--;
		argv++;
	}
	if (uname == NULL) {
		if ((uname = getlogin()) == NULL) {
			usage();
			goto bex;
		}
		gethostname(hostname, sizeof(hostname));
		fprintf(stderr,
		        "Changing password for %s on %s\n",
		        uname, hostname);
	}

	u = getuid();

/* the following complicated gibberish was written to do two things
 *  1) detect when someone has done a "passwd joeuser" and there
 *     exists an entry "+joeuser" in the /etc/passwd file
 *  2) allow joeuser to say "passwd +joeuser" and change his local
 *     over-ride passwd
 */
	while ((pwd = getpw()) != NULL) {

		if (strncmp(pwd->pw_name, uname, L_cuserid-1) == 0) {
			/* arg and passwd file match, check for yp-overide */
			if (yp_reference) {
				if ((yp_pwd = getpwnam((pwd->pw_name)+1)) == NULL)
					goto perm;
				else if (u != 0 && u != yp_pwd->pw_uid)
					goto perm;
				else
					break;  /* ok*/
			}
			/* arg and passwd file match, "normal" case */
			else if (u != 0 && u != pwd->pw_uid) {
perm:
				fprintf (stderr, "Permission denied.\n");
				exit(1);
			}
			else
			        break;          /* ok */
		}

		else if (yp_reference &&
		         strncmp((pwd->pw_name)+1, uname, L_cuserid-1) == 0) {
			/* prog invoked for yp entry, exit special (2) to tell
			 * /bin/login whot hoppened
			 */
			fprintf(stderr, "Passwd entry references yellow pages. See yppasswd(1).\n");
			exit(2);
		}

		else
			continue;      /* just keep looking */

	} /* end while */

	if (pwd == NULL) {
		fprintf(stderr, "Not in passwd file.\n");
		goto bex;
	}
	endpw();
	if (pwd->pw_passwd[0] && u != 0) {
		strcpy (opwbuf, getpass ("Old password:"));
		opwlen = strlen(opwbuf);       /* get length of old password */
		pw = crypt (opwbuf, pwd->pw_passwd);
		if (strcmp (pw, pwd->pw_passwd) != 0) {
			fprintf (stderr, "Sorry.\n");
			goto bex;
		}
	} else
		opwbuf[0] = '\0';
	if (*pwd->pw_age != NULL) {
		/* password age checking applies */
		when = (long) a64l (pwd->pw_age);
		/* max, min and week of last change are encoded in radix 64 */
		maxweeks = when & 077;
		minweeks = (when >> 6) & 077;
		when >>= 12;
		now  = time ((long *) 0)/WEEK;
		if (when <= now) {
			if (u != 0 && (now < when + minweeks)) {
				fprintf (stderr, "Sorry: < %ld weeks since the last change\n", minweeks);
				goto bex;
			}
			if (minweeks > maxweeks && u != 0) {
				fprintf (stderr, "You may not change this password.\n");
				goto bex;
			}
		}
	}
tryagn:
	if( insist >= 3) {      /* three chances to meet triviality standard */
		fprintf(stderr, "Too many failures - try later.\n");
		goto bex;
		}
	strcpy (pwbuf, getpass ("New password:"));
	pwlen = strlen (pwbuf);

	/* Make sure new password is long enough */

	if (u != 0 && (pwlen < MINLENGTH ) ) { 
		fprintf(stderr, "Password is too short - must be at least 6 digits\n");
		insist++;
		goto tryagn;
		}

	/* Check the circular shift of the logonid */
	 
	if( u != 0 && circ(uname, pwbuf) ) {
		fprintf(stderr, "Password cannot be circular shift of logonid\n");
		insist++;
		goto tryagn;
		}

	/* Insure passwords contain at least two alpha characters */
	/* and one numeric or special character */               

	flags = 0;
	flag = 0;
	p = pwbuf;
	if (u != 0) {
		while (c = *p++){
			if( isalpha(c) && flag ) flags |= 1;
				else if( isalpha(c) && !flag ){
					flags |= 2;
					flag = 1;
					}
				else if( isdigit(c) ) flags |= 4;
				else flags |= 8;
				}
		 
		/*		7 = lca,lca,num
		 *		7 = lca,uca,num
		 *		7 = uca,uca,num
		 *		11 = lca,lca,spec
		 *		11 = lca,uca,spec
		 *		11 = uca,uca,spec
		 *		15 = spec,num,alpha,alpha
		 */
		 
			if ( flags != 7 && flags != 11 && flags != 15  ) {
				fprintf(stderr,"Password must contain at least two alphabetic characters and\n");
				fprintf(stderr,"at least one numeric or special character.\n");
				insist++;
				goto tryagn;
				}
		}
	if ( u != 0 ) {
		p = pwbuf;
		o = opwbuf;
		if( pwlen >= opwlen) {
			i = pwlen;
			k = pwlen - opwlen;
			}
			else {
				i = opwlen;
				k = opwlen - pwlen;
				}
		for( j = 1; j  <= i; j++ ) if( *p++ != *o++ ) k++;
		if( k  <  3 ) {
			fprintf(stderr, "Passwords must differ by at least 3 positions\n");
			insist++;
			goto tryagn;
			}
	}

	/* Insure password was typed correctly, user gets three chances */

	strcpy (buf, getpass ("Re-enter new password:"));
	if (strcmp (buf, pwbuf)) {
		if (++count > 2) {
			fprintf (stderr, "Too many tries; try again later.\n");
			goto bex;
		} else
			fprintf (stderr, "They don't match; try again.\n");
		goto tryagn;
	}

	/* Construct salt, then encrypt the new password */

	time (&salt);
	salt += getpid();

	saltc[0] = salt & 077;
	saltc[1] = (salt >> 6) & 077;
	for (i=0; i<2; i++) {
		c = saltc[i] + '.';
		if (c>'9') c += 7;
		if (c>'Z') c += 6;
		saltc[i] = c;
	}
	pw = crypt (pwbuf, saltc);
	signal (SIGHUP, SIG_IGN);
	signal (SIGINT, SIG_IGN);
	signal (SIGQUIT, SIG_IGN);

	umask (0333);

	if (access (temp, 0) >= 0) {
		fprintf (stderr, "Temporary file busy; try again later.\n");
		goto bex;
	}

/*
 *	Between the time that the previous access completes
 *	and the following fopen completes, it is possible for
 *	some other user to sneak in and foul things up.
 *	It is not possible to solve this by using creat to
 *	create the file with mode 0444, because the creat will
 *	always succeed if our effective uid is 0.
 */

	if ((tf = fopen (temp, "w")) == NULL) {
		fprintf (stderr, "Cannot create temporary file\n");
		goto bex;
	}

/*
 *	copy passwd to temp, replacing matching lines
 *	with new password.
 */

	while ((pwd = getpw()) != NULL) {
		if (strncmp (pwd->pw_name, uname, L_cuserid-1) == 0) {
			u = getuid();
			if (u != 0 &&                 /* not super-user */
			    u != pwd->pw_uid &&       /* no normal match */
			    ! yp_reference &&         /* not reffing yellow pages */
			    u != yp_pwd->pw_uid) {    /* no yellow pages match */
				fprintf (stderr, "Permission denied.\n");
				goto out;
			}
			pwd->pw_passwd = pw;
			if (*pwd->pw_age != NULL) {
				if (maxweeks == 0) 
					*pwd->pw_age = '\0';
				else {
					when = maxweeks + (minweeks << 6) + (now << 12);
					pwd->pw_age = l64a (when);
				}
			}
		}
		putpwent(pwd, tf);
	}
	endpw();
	fclose(tf);

/*
 *	Rename temp file back to passwd file.
 */

	if (unlink (OPASSWD) && access (OPASSWD, 0) == 0) {
		fprintf (stderr, "cannot unlink %s\n", OPASSWD);
		goto out;
	}

	if (link (PASSWD, OPASSWD)) {
		fprintf (stderr, "cannot link %s to %s\n", PASSWD, OPASSWD);
		goto out;
	}

	if (unlink (PASSWD)) {
		fprintf (stderr, "cannot unlink %s\n", PASSWD);
		goto out;
	}

	if (link (temp, PASSWD)) {
		fprintf (stderr, "cannot link %s to %s\n", temp, PASSWD);
		if (link (OPASSWD, PASSWD)) {
			fprintf (stderr, "cannot recover %s\n", PASSWD);
			goto bex;
		}
		goto out;
	}

	if (unlink (temp)) {
		fprintf (stderr, "cannot unlink %s\n", temp);
		goto out;
	}

	exit (0);

out:
	unlink (temp);

bex:
	exit (1);
}
circ( s, t )
char *s, *t;
{
	char c, *p, *o, *r, buff[25], ubuff[25], pubuff[25];
	int i, j, k, l, m;
	 
	m = 2;
	i = strlen(s);
	o = &ubuff[0];
	for( p = s; c = *p++; *o++ = c ) if( islower(c) ) c = toupper(c);
	*o = '\0';
	o = &pubuff[0];
	for( p = t; c = *p++; *o++ = c ) if( islower(c) ) c = toupper(c);
	*o = '\0';
	 
	p = &ubuff[0];
	while( m-- ) {
		for( k = 0; k  <=  i; k++) {
			c = *p++;
			o = p;
			l = i;
			r = &buff[0];
			while(--l) *r++ = *o++;
			*r++ = c;
			*r = '\0';
			p = &buff[0];
			if( strcmp( p, pubuff ) == 0 ) return(1);
			}
		p = p + i;
		r = &ubuff[0];;
		j = i;
		while( j-- ) *--p = *r++;
	}
	return(0);
}

static char EMPTY[] = "";
static FILE *pwf = NULL;
static char line[BUFSIZ+1];
static struct passwd passwd;

int
endpw()
{
	if(pwf != NULL) {
		(void) fclose(pwf);
		pwf = NULL;
	}
}

static char *
pwskip(p)
register char *p;
{
	while(*p && *p != ':' && *p != '\n')
		++p;
	if(*p == '\n')
		*p = '\0';
	else if(*p)
		*p++ = '\0';
	return(p);
}

struct passwd *
getpw()
{
	extern struct passwd *fgetpw();

	if(pwf == NULL) {
		if((pwf = fopen(PASSWD, "r")) == NULL)
			return(NULL);
	}
	return (fgetpw(pwf));
}

struct passwd *
fgetpw(f)
FILE *f;
{
	register char *p;
	char *end;
	long	x, strtol();
	char *memchr();

	p = fgets(line, BUFSIZ, f);
	if(p == NULL)
		return(NULL);
	passwd.pw_name = p;
	p = pwskip(p);
	passwd.pw_passwd = p;
	p = pwskip(p);

	if ((line[0] != '+') && (line[0] != '-')) {
	        yp_reference = FALSE;
		if (p == NULL || *p == ':')
			/* check for non-null uid */
			return (NULL);
		x = strtol(p, &end, 10);	
		if (end != memchr(p, ':', strlen(p)))
			/* check for numeric value */
			return (NULL);
		p = pwskip(p);
		passwd.pw_uid = (x < 0 || x > MAXUID)? (MAXUID+1): x;
		if (p == NULL || *p == ':')
			/* check for non-null gid */
			return (NULL);
		x = strtol(p, &end, 10);	
		if (end != memchr(p, ':', strlen(p)))
			/* check for numeric value */
			return (NULL);
		p = pwskip(p);
		passwd.pw_gid = (x < 0 || x > MAXUID)? (MAXUID+1): x;
	} 
	else {
		yp_reference = TRUE;
		passwd.pw_uid = passwd.pw_gid = MAXUID;
		p = pwskip(p);
		p = pwskip(p);
	}

	passwd.pw_quota = 0;
	passwd.pw_comment = EMPTY;
	passwd.pw_gecos = p;
	p = pwskip(p);
	passwd.pw_dir = p;
	p = pwskip(p);
	passwd.pw_shell = p;
	(void) pwskip(p);

	p = passwd.pw_passwd;
	while(*p && *p != ',')
		p++;
	if(*p)
		*p++ = '\0';
	passwd.pw_age = p;
	return(&passwd);
}

int
putpwent(p, f)
register struct passwd *p;
register FILE *f;
{
	(void) fprintf(f, "%s:%s", p->pw_name, p->pw_passwd);
	if((*p->pw_age) != '\0')
		(void) fprintf(f, ",%s", p->pw_age);
	if (! yp_reference)
		(void) fprintf(f, ":%u:%u:%s:%s:%s",
			p->pw_uid,
			p->pw_gid,
			p->pw_gecos,
			p->pw_dir,
			p->pw_shell);
	else
		(void) fprintf(f, ":::%s:%s:%s",
		        p->pw_gecos,
		        p->pw_dir,
		        p->pw_shell);
	(void) putc('\n', f);
	return(ferror(f));
}

usage()
{
	fprintf(stderr, "Usage: passwd [-f file] [user]\n");
}
