/*
 * $Header: /usr/src/S3etc/profiler/RCS/prfstat.c,v 1.3 83/10/25 17:01:21 bin Exp $
 *
 * $Log:	prfstat.c,v $
 *Revision 1.3  83/10/25  17:01:21  bin
 *Added rcs headers
 *
 */
static char rcsid[] = "$Header: /usr/src/S3etc/profiler/RCS/prfstat.c,v 1.3 83/10/25 17:01:21 bin Exp $";

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*    	"@(#)profiler:prfstat.c	1.3"    */
/*
 *	prfstat - change and/or report profiler status
 */
#include	<stdio.h>
#include 	<sys/ioctl.h>

#define PRF_OFF  0
#define	PRF_ON	 1
#define	PRF_VAL	 2
#define SET	_IOW(p, 3, int)

main(argc, argv)
	char	**argv;
{
	register  int  prf;
	int on;

	if((prf = open("/dev/prf", 2)) < 0) {
		printf("cannot open /dev/prf\n");
		exit(1);
	}
	if(argc > 2) {
		printf("usage: prfstat  [ on ]  [ off ]\n");
		exit(1);
	}

	if(argc == 2) {
		if(strcmp("off", argv[1]) == 0) {
			on = PRF_OFF;
			if(ioctl(prf, SET, &on) < 0) {
				perror("prfstat: cannot turn profiler off");
				exit(1);
			}
		}
		else if(strcmp("on", argv[1]) == 0) {
			on = PRF_ON;
			if(ioctl(prf, SET, &on) < 0) {
			 	perror("prfstat: cannot turn profiler on\n");
				exit(1);
			}
		}
		else {
			printf("usage: prfstat  [ on ]  [ off ]\n");
			exit(1);
		}
	}
	ioctl(prf, (IOC_VOID | 1), 0);
	printf("profiling %s\n", ioctl(prf, (IOC_VOID | 1), 0) & PRF_ON ?
	    "enabled" : "disabled");
	if(ioctl(prf, (IOC_VOID | 1), 0) & PRF_VAL)
		printf("%d kernel text addresses\n", ioctl(prf, (IOC_VOID | 2), 0));
	exit(0);
}
