#ifndef lint
static	char sccsid[] = "@(#)ps.c 1.1 85/05/30 SMI"; /* from UCB 4.24 83/05/22 */
#endif
/*
 * ps
 */
#include <stdio.h>
#include <ctype.h>
#include <nlist.h>
#include <pwd.h>
#include <sys/param.h>
#include <sys/tty.h>
#include <sys/dir.h>
#include <sys/user.h>
#include <sys/proc.h>
#include <ml/pte.h>
#include <sys/vm.h>
#include <sys/text.h>
#include <sys/stat.h>
#include <sys/mbuf.h>
#include <math.h>

#define NTTYS	20
#define SIZ 	30
#define TSIZE	100
#define ARGSIZ	30

struct nlist nl[] = {
	{ "_proc" },
#define	X_PROC		0
	{ "_Usrptmap" },
#define	X_USRPTMA	1
	{ "_usrpt" },
#define	X_USRPT		2
	{ "_text" },
#define	X_TEXT		3
	{ "_nswap" },
#define	X_NSWAP		4
	{ "_maxslp" },
#define	X_MAXSLP	5
	{ "_ccpu" },
#define	X_CCPU		6
	{ "_ecmx" },
#define	X_ECMX		7
	{ "_nproc" },
#define	X_NPROC		8
	{ "_ntext" },
#define	X_NTEXT		9
	{ "_dmmin" },
#define	X_DMMIN		10
	{ "_dmmax" },
#define	X_DMMAX		11
	{ "_u" },
#define	X_UAREA		12
	{ "_Sysmap" },
#define	X_SYSMAP	13
	{ "_Syssize" },
#define	X_SYSSIZE	14
	{ "_selwait" },
#define	X_SELWAIT	15
        { "_lbolt" },
#define X_LBOLT         16
	{ "" },
};

struct	savcom {
	union {
		struct	lsav *lp;
		float	u_pctcpu;
		struct	vsav *vp;
		int	s_ssiz;
	} s_un;
	struct	asav *ap;
} *savcom;

struct	asav {
	char	*a_cmdp;
	int	a_flag;
	short	a_stat, a_uid, a_pid, a_ppid, a_nice;
	int	a_prior, a_eslptime, a_etime;
	int	a_interruptable;
	size_t	a_size, a_rss, a_tsiz, a_txtrss;
	short	a_xccount;
	char	a_tty[MAXNAMLEN+1];
	struct tty *a_ttyp;
	dev_t	a_ttyd;
	time_t	a_cpu, a_start;
	size_t	a_maxrss;
};

char	*lhdr, *lfhdr;
struct	lsav {
	char	l_cpu;
	int	l_addr;
	caddr_t	l_wchan;
	caddr_t	l_procaddr;
};

char	*uhdr;
char	*shdr, *sfhdr;

char	*vhdr;
struct	vsav {
	u_int	v_majflt;
	size_t	v_swrss, v_txtswrss;
	float	v_pctcpu;
};

struct	proc proc[8];		/* 8 = a few, for less syscalls */
struct	proc *mproc;
struct	text *text;

union {
	struct	user user;
	char	upages[UPAGES][NBPG];
} user;
#define u	user.user

int	Eflg, Sflg, Uflg, aflg, cflg, dflg, eflg, fflg, gflg, lflg,
	pflg, rflg, sflg, tflg, uflg, vflg;
char	*gettty(), *getcmd(), *getname(), *savestr(), *alloc(), *state();
char	*rindex(), *sbrk(), *strcpy(), *strcat(), *strncat();
char	*ttyname();
dev_t	maptty();
long	lseek();
double	pcpu(), pmem();
int	pscomp();
int	nswap, maxslp;
struct	text *atext;
double	ccpu;
long	kccpu;
int	ecmx;
struct	pte *Usrptma, *usrpt;
int	nproc, ntext;
int	dmmin, dmmax;
struct timeval now;
struct timezone tz;

struct	ttys {
	char	name[MAXNAMLEN+1];
	dev_t	ttyd;
	struct	ttys *next;
	struct	ttys *cand;
} *allttys, *cand[16];

int	npr;

int	cmdstart;
int	twidth;
char	*kmemf, *memf, *swapf, *nlistf;
int	kmem, mem, swap = -1;
int	rawcpu, sumcpu;

int	pcbpf;
int	argaddr;

#define	pgtok(a)	((a)*CLBYTES/1024)

char	*parg, *p1;

#define	NMAX	8
struct uidmap {
	short	uid_num;
	char	*uid_name;
} uidmap[TSIZE];
static	int uidn = 0;

int	uid_tbl[SIZ];	/* for u option */
int	nuids = 0;
dev_t	tty[NTTYS];	/* for t option */
int	ntty = 0;
int	pid[SIZ];	/* for p option */
int	npid = 0;
int	grpid[SIZ];	/* for g option */
int	ngrpid = 0;

char	argbuf[ARGSIZ];

main(argc, argv)
	char **argv;
{
	register dev_t *ttyp = tty;
	struct stat stb;
	register int i, j;
	int procread;
	off_t procp;
	char *p;
	int puid, ppid, ppgrp;
	int found;
	register int c;
	extern char *optarg;
	extern int optind;
	char *getstr;
	int errflg = 0;
	int eslptime;
	char *usage="ps [ -edarlwfvU ] [ -c corefile ] [ -s swapdev ] [ -n namelist ]";
	char *usage2="   [ -t tlist ] [ -p plist ] [ -u ulist ] [ -g glist ]";
	unsigned size;

	getstr = "CESUadeflrvwc:g:n:p:s:t:u:";
	nlistf = "/unix";
	kmemf = "/dev/kmem";
	memf = "/dev/mem";
	swapf = "/dev/drum";
	twidth = 80;
	while ((c = getopt(argc,argv,getstr)) != EOF)
		switch(c) {
		case 'C':
			rawcpu++;
			break;
		case 'E':
			Eflg++;
			break;
		case 'S':
			sumcpu++;
			break;
/*
		case 'S':
			Sflg++;
			break;
*/
		case 'U':
			Uflg++;
			break;
		case 'a':
			aflg++;
			break;
		case 'c':
			cflg++;
			kmemf = optarg;
			memf = kmemf;
			break;
		case 'd':
			dflg++;
			break;
		case 'e':
			eflg++;
			tflg = uflg = pflg = gflg = 0;
			break;
		case 'f':
			fflg++;
			break;
		case 'g':
			gflg++;
			p1 = optarg;
			parg = argbuf;
			do {
				if (ngrpid >= SIZ)
					break;
				getarg();
				grpid[ngrpid++] = atoi(parg);
			}
			while (*p1);
			break;
		case 'l':
			lflg++;
			break;
		case 'n':
			nlistf = optarg;
			break;
		case 'p':
			pflg++;
			p1 = optarg;
			parg = argbuf;
			do {
				if (npid >= SIZ)
					break;
				getarg();
				pid[npid++] = atoi(parg);
			}
			while (*p1);
			break;
		case 'r':
			rflg++;
			break;
		case 's':
			swapf = optarg;
			sflg++;
			if ((swap = open(optarg, 0)) < 0) {
				fprintf(stderr, "ps: cannot open %s\n",optarg);
				exit(1);
			}
			break;
		case 't':
			tflg++;
			p1 = optarg;
			do {
				parg = argbuf;
				if (ntty >= NTTYS)
					break;
				getarg();
				*ttyp++ = maptty(parg);
				ntty++;
			}
			while (*p1);
			break;
		case 'u':
			uflg++;
			p1 = optarg;
			parg = argbuf;
			do {
				getarg();
				uopt(parg);
			}
			while (*p1);
			break;
		case 'v':
			fflg = 0;
			vflg++;
			break;
		case 'w':
			if (twidth == 80)
				twidth = 132;
			else
				twidth = BUFSIZ;
			break;
		case '?':
			errflg++;
			break;
		}
	if (errflg || (optind < argc)) {
		fprintf(stderr,"usage: %s\n%s\n",usage,usage2);
		exit(1);
	}
	/* if specifying options not used, current terminal is default */
	if ( !(aflg || eflg || dflg || uflg || tflg || pflg || gflg )) {
		if (fstat(2, &stb) < 0 || (stb.st_mode&S_IFMT) != S_IFCHR)
			*ttyp = -1;
		else
			*ttyp = stb.st_rdev;
		ntty++;
		tflg++;
	}
	if (eflg)
		tflg = uflg = pflg = gflg = aflg = dflg = 0;
	if (aflg || dflg)
		tflg = 0;
	openfiles();
	getkvars();
	if (chdir("/dev") < 0) {
		perror("ps: /dev");
		exit(1);
	}
	getdev();
	printhdr();
	procp = getw(nl[X_PROC].n_value);
	nproc = getw(nl[X_NPROC].n_value);
	savcom = (struct savcom *)alloc(nproc*sizeof (*savcom));
	for (i=0; i<nproc; i += 8) {
		klseek(kmem, (long)procp, 0);
		procread = nproc - i;
		if (procread > 8)
			procread = 8;
		procread *= sizeof (struct proc);
		if (read(kmem, (char *)proc, procread) != procread) {
			cantread("proc table", kmemf);
			exit(1);
		}
		procread /= sizeof (struct proc);
		gettimeofday(&now, &tz);
		for (j = 0; j < procread - 1; j++, procp += sizeof(struct proc)) {
			found = 0;
			mproc = &proc[j];
			if (mproc->p_stat == 0)
				continue;
			puid = mproc->p_uid;
			ppid = mproc->p_pid;
			ppgrp = mproc->p_pgrp;
			if ((mproc->p_ppid == 1) && (dflg || aflg))
			/*if ((mproc->p_flag&SPGLDR) && (dflg || aflg))*/
				continue;
			if (eflg || dflg)
				found++;
			else if (pflg && search(pid, npid, ppid))
				found++;
			else if (uflg && ufind(puid))
				found++;
			else if (gflg && search(grpid, ngrpid, ppgrp))
				found++;
			if (!found && !tflg && !aflg)
				continue;
			if (vflg && eflg == 0 && aflg == 0) {
				if (mproc->p_stat == SZOMB ||
				    mproc->p_flag&SWEXIT)
					continue;
				if (mproc->p_eslptime)
					eslptime = now.tv_sec-mproc->p_eslptime;
				else
					eslptime = 0;
				if (eslptime > MAXSLP &&
				    (mproc->p_stat == SSLEEP ||
				     mproc->p_stat == SSTOP))
				continue;
			}
			if (rflg && ! (mproc->p_stat == SRUN
			    ||	! mproc->p_interruptable))
				continue;
			save(found, procp);
		}
	}
	qsort(savcom, npr, sizeof(savcom[0]), pscomp);
	uidget();
	for (i=0; i<npr; i++) {
		register struct savcom *sp = &savcom[i];
		if (lflg)
			lpr(sp);
		else if (vflg)
			vpr(sp);
		else if (Uflg)
			upr(sp);
		else
			spr(sp);
		if (sp->ap->a_flag & SWEXIT)
			p = "<exiting>";
		else if (sp->ap->a_stat == SZOMB)
			p = "<defunct>";
		else if (sp->ap->a_pid == 0)
			p = "swapper";
		else if (sp->ap->a_pid == 2)
			p = "pagedaemon";
		else if (sp->ap->a_pid == 3 && sp->ap->a_flag & SSYS)
			p = "softclock";
		else
			p = sp->ap->a_cmdp;
 		printf(" %.*s\n", twidth - cmdstart - 2, p);
	}
	exit(npr == 0);
}

getw(loc)
	unsigned long loc;
{
	long word;

	klseek(kmem, (long)loc, 0);
	if (read(kmem, (char *)&word, sizeof (word)) != sizeof (word))
		fprintf(stderr, "error reading kmem at %x\n", loc);
	return (word);
}

klseek(fd, loc, off)
	int fd;
	long loc;
	int off;
{

	/*
	 *  If this is a dump, then the kernel isn't doing the page mapping
	 *  for us.  Simulate it.
	 */
	if (cflg && (loc & 0xc0000000) != 0) {
		long v;
		long addr;
		struct pte pte;

		loc &= ~0xc0000000;
		v = btop(loc);
		if(v >= nl[X_SYSSIZE].n_value) {
			printf("address botch %x\n", loc);
			return;
		}
		addr = (long)((struct pte *)nl[X_SYSMAP].n_value + v);
		lseek(kmem, addr & ~0xc0000000, 0);
		if(read(kmem, (char *)&pte, sizeof(pte)) != sizeof(pte)) {
			printf("Error reading kmem for pte at %x\n", addr);
			return;
		}
		if (pte.pg_v == 0 && (pte.pg_fod || pte.pg_pfnum == 0)) {
			printf("pte bad for %x\n", addr);
			return;
		}
		loc = (long)ptob(pte.pg_pfnum) + (loc & PGOFSET);
	}
	(void) lseek(fd, (long)loc, off);
}

openfiles()
{

	kmem = open(kmemf, 0);
	if (kmem < 0) {
		perror(kmemf);
		exit(1);
	}
	mem = open(memf, 0);
	if (mem < 0) {
		perror(memf);
		exit(1);
	}
	if (cflg == 0 || sflg) {
		swap = open(swapf, 0);
		if (swap < 0) {
			perror(swapf);
			exit(1);
		}
	}
}

getkvars()
{
	register struct nlist *nlp;

	nlist(nlistf, nl);
	if (nl[0].n_value == 0) {
		fprintf(stderr, "%s: No namelist\n", nlistf);
		exit(1);
	}
	usrpt = (struct pte *)nl[X_USRPT].n_value;	/* don't clear!! */
	Usrptma = (struct pte *)nl[X_USRPTMA].n_value;
	klseek(kmem, (long)nl[X_NSWAP].n_value, 0);
	if (read(kmem, (char *)&nswap, sizeof (nswap)) != sizeof (nswap)) {
		cantread("nswap", kmemf);
		exit(1);
	}
	klseek(kmem, (long)nl[X_MAXSLP].n_value, 0);
	if (read(kmem, (char *)&maxslp, sizeof (maxslp)) != sizeof (maxslp)) {
		cantread("maxslp", kmemf);
		exit(1);
	}
	klseek(kmem, (long)nl[X_CCPU].n_value, 0);
	if (read(kmem, (char *)&kccpu, sizeof (kccpu)) != sizeof (kccpu)) {
		cantread("ccpu", kmemf);
		exit(1);
	}
	ccpu = (double)kccpu / FSCALE;
	klseek(kmem, (long)nl[X_ECMX].n_value, 0);
	if (read(kmem, (char *)&ecmx, sizeof (ecmx)) != sizeof (ecmx)) {
		cantread("ecmx", kmemf);
		exit(1);
	}
	if (Uflg || vflg) {
		ntext = getw(nl[X_NTEXT].n_value);
		text = (struct text *)alloc(ntext * sizeof (struct text));
		atext = (struct text *)getw(nl[X_TEXT].n_value);
		klseek(kmem, (long)atext, 0);
		if (read(kmem, (char *)text, ntext * sizeof (struct text))
		    != ntext * sizeof (struct text)) {
			cantread("text table", kmemf);
			exit(1);
		}
	}
	dmmin = getw(nl[X_DMMIN].n_value);
	dmmax = getw(nl[X_DMMAX].n_value);
}

printhdr()
{
	char *hdr;

	if (Sflg+lflg+vflg+Uflg > 1) {
		fprintf(stderr, "ps: specify only one of s,l,v and U\n");
		exit(1);
	}
	hdr = lflg ? (fflg? lfhdr : lhdr) :
			(vflg ? vhdr : 
				(Uflg ? uhdr : (fflg? sfhdr : shdr)));
	if (lflg+vflg+Uflg+Sflg == 0)
		hdr += strlen("SSIZ ");
	cmdstart = strlen(hdr);
	printf("%s %s\n", hdr, lflg ? "CMD" : "COMMAND");
	(void) fflush(stdout);
}

cantread(what, fromwhat)
	char *what, *fromwhat;
{

	fprintf(stderr, "ps: error reading %s from %s\n", what, fromwhat);
}

struct	direct *dbuf;
int	dialbase;

getdev()
{
	register DIR *df;

	dialbase = -1;
	if ((df = opendir(".")) == NULL) {
		fprintf(stderr, "Can't open . in /dev\n");
		exit(1);
	}
	while ((dbuf = readdir(df)) != NULL) 
		maybetty();
	closedir(df);
}

/*
 * Attempt to avoid stats by guessing minor device
 * numbers from tty names.  Console is known,
 * know that r(hp|up|mt) are unlikely as are different mem's,
 * floppy, null, tty, etc.
 */
maybetty()
{
	register char *cp = dbuf->d_name;
	register struct ttys *dp;
	int x;
	struct stat stb;

	switch (cp[0]) {

	case 'c':
		if (!strcmp(cp, "console")) {
			x = 0;
			goto donecand;
		}
		/* cu[la]? are possible!?! don't rule them out */
		/* cy[0-4][sf]? are possible!?! don't rule them out */
		break;

	case 'd':
		if (!strcmp(cp, "drum"))
			return;
		break;

	case 'f':
		if (!strncmp(cp, "fsd", 3))
		{
			cp += 3;
			if (isxdigit(*cp) && isalpha(cp[1]))
				return;
		}
		break;

	case 'x':
		if (!strncmp(cp, "xfd", 3))
		{
			cp += 3;
			if (isxdigit(*cp) && isalpha(cp[1]))
				return;
		}
		break;

	case 's':
		if (!strncmp(cp, "smd", 3))
		{
			cp += 3;
			if (isxdigit(*cp) && isalpha(cp[1]))
				return;
		}
		break;

	case 'k':
		cp++;
		if (*cp == 'U')
			cp++;
		goto trymem;

	case 'r':
		cp++;
		switch (cp[0])
		{
			case 'f':
				if (!strncmp(cp, "fsd", 3))
				{
					cp += 3;
					if (isxdigit(*cp) && isalpha(cp[1]))
						return;
				}
				break;
			case 'x':
				if (!strncmp(cp, "xfd", 3))
				{
					cp += 3;
					if (isxdigit(*cp) && isalpha(cp[1]))
						return;
				}
				break;
			case 's':
				if (!strncmp(cp, "smd", 3))
				{
					cp += 3;
					if (isxdigit(*cp) && isalpha(cp[1]))
						return;
				}
				break;
			case 'm':
				if (!strncmp(cp, "mt", 2))
				{
					cp += 2;
					if (isdigit(*cp))
						return;
				}
				break;
			case 'c':
				if (!strncmp(cp, "cy", 2))
				{
					cp += 2;
					if (isdigit(*cp) && (cp[1] == 'f' ||
						cp[1] == 's'))
						return;
				}
				break;
			}
		break;

	case 'm':
trymem:
		if (cp[0] == 'm' && cp[1] == 'e' && cp[2] == 'm' && cp[3] == 0)
			return;
		if (cp[0] == 'm' && cp[1] == 't')
			return;
		break;

	case 'n':
		if (!strcmp(cp, "null"))
			return;
		break;

	}
	cp = dbuf->d_name + dbuf->d_namlen - 1;
	x = 0;
	if (cp[-1] == 'd') {
		if (dialbase == -1) {
			if (stat("ttyd0", &stb) == 0)
				dialbase = stb.st_rdev & 017;
			else
				dialbase = -2;
		}
		if (dialbase == -2)
			x = 0;
		else
			x = 11;
	}
	if (cp > dbuf->d_name && isdigit(cp[-1]) && isdigit(*cp))
		x += 10 * (cp[-1] - ' ') + cp[0] - '0';
	else if (*cp >= 'a' && *cp <= 'f')
		x += 10 + *cp - 'a';
	else if (isdigit(*cp))
		x += *cp - '0';
	else
		x = -1;
donecand:
	dp = (struct ttys *)alloc(sizeof (struct ttys));
	(void) strcpy(dp->name, dbuf->d_name);
	dp->next = allttys;
	dp->ttyd = -1;
	allttys = dp;
	if (x == -1)
		return;
	x &= 017;
	dp->cand = cand[x];
	cand[x] = dp;
}

/* getarg finds next argument in list and copies arg into argbuf  */
/* p1 first pts to arg passed back from getopt routine.  p1 is then */
/* bumped to next character that is not a comma or blank - p1 null */
/* indicates end of list    */

getarg()
{
	char *parga;
	parga = argbuf;
	while(*p1 && *p1 != ',' && *p1 != ' ')
		*parga++ = *p1++;
	*parga = '\0';

	while( *p1 && ( *p1 == ',' || *p1 == ' ') )
		p1++;
}

dev_t
maptty(ttyn)
char *ttyn;
{
	char ttyfull[5+MAXNAMLEN+1];
	struct stat stb;
	register int i;
	extern int errno;

	if (strcmp(tty, "?") == 0)
		return(-1);
	strcpy(ttyfull, "/dev/");
	strncat(ttyfull, ttyn, MAXNAMLEN);
	if ((i = stat(ttyfull, &stb)) < 0 && errno != ENOENT)
		return(-1);
	if (i < 0 || (stb.st_mode&S_IFMT) != S_IFCHR) {
		strcpy(ttyfull, "/dev/tty");
		strcat(ttyfull, ttyn, MAXNAMLEN-3);
		if (stat(ttyfull, &stb) < 0 || (stb.st_mode&S_IFMT) != S_IFCHR)
			return(-1);
	}
	return(stb.st_rdev);
}

char *
gettty()
{
	register char *p;
	register struct ttys *dp;
	struct stat stb;
	int x;

	if (u.u_ttyp == 0)
		return("?");
	x = u.u_ttyd & 017;
	for (dp = cand[x]; dp; dp = dp->cand) {
		if (dp->ttyd == -1) {
			if (stat(dp->name, &stb) == 0 &&
			   (stb.st_mode&S_IFMT)==S_IFCHR)
				dp->ttyd = stb.st_rdev;
			else
				dp->ttyd = -2;
		}
		if (dp->ttyd == u.u_ttyd)
			goto found;
	}
	/* ick */
	for (dp = allttys; dp; dp = dp->next) {
		if (dp->ttyd == -1) {
			if (stat(dp->name, &stb) == 0 &&
			   (stb.st_mode&S_IFMT)==S_IFCHR)
				dp->ttyd = stb.st_rdev;
			else
				dp->ttyd = -2;
		}
		if (dp->ttyd == u.u_ttyd)
			goto found;
	}
	return ("?");
found:
	p = dp->name;
	if (p[0]=='t' && p[1]=='t' && p[2]=='y')
		p += 3;
	return (p);
}

save(found, procp)
int found;
caddr_t procp;
{
	register struct savcom *sp;
	register struct asav *ap;
	register char *cp;
	register struct text *xp;
	register char *ttyp;
	int match;
	register int i;
	char *cmdp;

	if (mproc->p_stat != SZOMB) {
		if (getu() == 0)
			return;
		/* get current terminal - if none (?) and aflg is set */
		/* then don't save info - if tflg is set, check if term */
		/* is in list of desired terminals and save if so */
		if ( aflg && (u.u_ttyp == 0 ))
			return;
		if(tflg && !found) {	/* the t option */
			for (i = 0, match = 0; i < ntty; i++) {
				if (u.u_ttyp == 0) {
					if (tty[i] == -1)
						match++;
				} else {
					if (u.u_ttyd == tty[i])
						match++;
				}
			}
			if(!match)
				return;
		}
		ttyp = gettty();
	} else {
		if (tflg && !found)
			return;
		ttyp = "";	/* zombies aren't attached to terminals */
	}
	sp = &savcom[npr];
	cmdp = getcmd();
	if (cmdp == 0)
		return;
	sp->ap = ap = (struct asav *)alloc(sizeof (struct asav));
	sp->ap->a_cmdp = cmdp;
#define e(a,b) ap->a = mproc->b
	e(a_flag, p_flag); e(a_stat, p_stat); e(a_nice, p_nice);
	e(a_interruptable, p_interruptable);
	e(a_uid, p_uid); e(a_pid, p_pid); e(a_ppid, p_ppid);
	e(a_prior, p_prior);
	if (mproc->p_eslptime)
		ap->a_eslptime = now.tv_sec - mproc->p_eslptime;
	else
		ap->a_eslptime = 0;
	if (mproc->p_etime)
		ap->a_etime = now.tv_sec;
	else
		ap->a_etime = 0;
	ap->a_tty[0] = ttyp[0];
	ap->a_tty[1] = ttyp[1] ? ttyp[1] : ' ';
	if (fflg || Uflg)
		uadd(mproc->p_uid);
	if (ap->a_stat == SZOMB) {
		if (mproc->p_ru != 0) {
			klseek(kmem, (long)mproc->p_ru, 0);
			if (read(kmem, (char *)&u.u_ru, sizeof (u.u_ru))
			    != sizeof (u.u_ru))
				fprintf(stderr, "error reading kmem at %x\n",
				    mproc->p_ru);
			ap->a_cpu = u.u_ru.ru_utime.tv_sec + u.u_ru.ru_stime.tv_sec;
		} else
			ap->a_cpu = 0;
	} else {
		ap->a_size = mproc->p_dsize + mproc->p_ssize;
		e(a_rss, p_rssize); 
		ap->a_ttyp = u.u_ttyp;
		ap->a_ttyd = u.u_ttyd;
		ap->a_cpu = u.u_ru.ru_utime.tv_sec + u.u_ru.ru_stime.tv_sec;
		if (sumcpu)
			ap->a_cpu += u.u_cru.ru_utime.tv_sec + u.u_cru.ru_stime.tv_sec;
		if (mproc->p_textp && text) {
			xp = &text[mproc->p_textp - atext];
			ap->a_tsiz = xp->x_size;
			ap->a_txtrss = xp->x_rssize;
			ap->a_xccount = xp->x_ccount;
		}
		ap->a_start = u.u_start.tv_sec;
	}
#undef e
	ap->a_maxrss = mproc->p_maxrss;
	if (lflg) {
		register struct lsav *lp;

		sp->s_un.lp = lp = (struct lsav *)alloc(sizeof (struct lsav));
#define e(a,b) lp->a = mproc->b
		lp->l_cpu = 0;
		if (ap->a_stat != SZOMB)
			e(l_wchan, p_wchan);
#undef e
		lp->l_addr = pcbpf;
		lp->l_procaddr = procp;
	} else if (vflg) {
		register struct vsav *vp;

		sp->s_un.vp = vp = (struct vsav *)alloc(sizeof (struct vsav));
#define e(a,b) vp->a = mproc->b
		if (ap->a_stat != SZOMB) {
			e(v_swrss, p_swrss);
			vp->v_majflt = u.u_ru.ru_majflt;
			if (mproc->p_textp)
				vp->v_txtswrss = xp->x_swrss;
		}
		vp->v_pctcpu = pcpu();
#undef e
	} else if (Uflg)
		sp->s_un.u_pctcpu = pcpu();
/*
	else if (Sflg) {
		if (ap->a_stat != SZOMB) {
			for (cp = (char *)u.u_stack;
			    cp < &user.upages[UPAGES][0]; )
				if (*cp++)
					break;
			sp->s_un.s_ssiz = (&user.upages[UPAGES][0] - cp);
		}
	}
*/

	npr++;
}

double
pmem(ap)
	register struct asav *ap;
{
	double fracmem;
	int szptudot;

	if ((ap->a_flag&SLOAD) == 0)
		fracmem = 0.0;
	else {
		szptudot = UPAGES + clrnd(ctopt(ap->a_size+ap->a_tsiz));
		fracmem = ((float)ap->a_rss+szptudot)/CLSIZE/ecmx;
		if (ap->a_xccount)
			fracmem += ((float)ap->a_txtrss)/CLSIZE/
			    ap->a_xccount/ecmx;
	}
	return (100.0 * fracmem);
}

double
pcpu()
{
	time_t time;
	double p;

	time = now.tv_sec - mproc->p_etime;
	if (time == 0 || (mproc->p_flag&SLOAD) == 0)
		return (0.0);
	p = (double)mproc->p_pctcpu / FSCALE;
	if (rawcpu)
		return (100.0 * p);
	return (100.0 * p / (1.0 - exp(time * log(ccpu))));
}

getu()
{
	struct pte *pteaddr, apte;
	struct pte arguutl[UPAGES+CLSIZE];
	register int i;
	int ncl, size;

	size = Sflg ? ctob(UPAGES) : roundup(sizeof (struct user), DEV_BSIZE);
	if ((mproc->p_flag & SLOAD) == 0) {
		if (swap < 0)
			return (0);
		(void) lseek(swap, (long)dtob(mproc->p_swaddr), 0);
		if (read(swap, (char *)&user.user, size) != size) {
			fprintf(stderr, "ps: can't read u for pid %d from %s\n",
			    mproc->p_pid, swapf);
			return (0);
		}
		pcbpf = mproc->p_swaddr;
		argaddr = 0;
		return (1);
	}
	pteaddr = &Usrptma[btokmx(mproc->p_p0br) + mproc->p_szpt - 1];
	klseek(kmem, (long)pteaddr, 0);
	if (read(kmem, (char *)&apte, sizeof(apte)) != sizeof(apte)) {
		fprintf(stderr, "ps: can't read indir pte to get u for pid %d from %s\n",
		    mproc->p_pid, kmemf);
		return (0);
	}
	klseek(mem,
	    (long)ctob(apte.pg_pfnum+1) - (UPAGES+CLSIZE) * sizeof (struct pte),
		0);
	if (read(mem, (char *)arguutl, sizeof(arguutl)) != sizeof(arguutl)) {
		fprintf(stderr, "ps: can't read page table for u of pid %d from %s\n",
		    mproc->p_pid, kmemf);
		return (0);
	}
	if (arguutl[0].pg_fod == 0 && arguutl[0].pg_pfnum)
		argaddr = ctob(arguutl[0].pg_pfnum);
	else
		argaddr = 0;
	pcbpf = arguutl[CLSIZE].pg_pfnum;
	ncl = (size + NBPG*CLSIZE - 1) / (NBPG*CLSIZE);
	while (--ncl >= 0) {
		i = ncl * CLSIZE;
		klseek(mem, (long)ctob(arguutl[CLSIZE+i].pg_pfnum), 0);
		if (read(mem, user.upages[i], CLSIZE*NBPG) != CLSIZE*NBPG) {
			fprintf(stderr, "ps: can't read page %d of u of pid %d from %s\n",
			    arguutl[CLSIZE+i].pg_pfnum, mproc->p_pid, memf);
			return(0);
		}
	}
	return (1);
}

char *
getcmd()
{
	char cmdbuf[CLSIZE*NBPG];
	union {
		char	argc[CLSIZE*NBPG];
		int	argi[CLSIZE*NBPG/sizeof (int)];
	} argspac;
	register char *cp;
	register int *ip;
	char c;
	int nbad;
	struct dblock db;
	char *file;

	if (mproc->p_stat == SZOMB || mproc->p_flag&(SSYS|SWEXIT))
		return ("");
	if (!fflg) {
		(void) strncpy(cmdbuf, u.u_comm, sizeof (u.u_comm));
		return (savestr(cmdbuf));
	}
	if (u.u_ssize == 0)
		goto retucomm;
	if ((mproc->p_flag & SLOAD) == 0 || argaddr == 0) {
		if (swap < 0)
			goto retucomm;
		vstodb(0, CLSIZE, &u.u_smap, &db, 1);
		(void) lseek(swap, (long)dtob(db.db_base), 0);
		if (read(swap, (char *)&argspac, sizeof(argspac))
		    != sizeof(argspac))
			goto bad;
		file = swapf;
	} else {
		klseek(mem, (long)argaddr, 0);
		if (read(mem, (char *)&argspac, sizeof (argspac))
		    != sizeof (argspac))
			goto bad;
		file = memf;
	}
	ip = &argspac.argi[CLSIZE*NBPG/sizeof (int)];
	ip -= 2;		/* last arg word and .long 0 */
	while (*--ip)
		if (ip == argspac.argi)
			goto retucomm;
	*(char *)ip = ' ';
	ip++;
	nbad = 0;
	for (cp = (char *)ip; cp < &argspac.argc[CLSIZE*NBPG]; cp++) {
		c = *cp & 0177;
		if (c == 0)
			*cp = ' ';
		else if (c < ' ' || c > 0176) {
			if (++nbad >= 5*(Eflg+1)) {
				*cp++ = ' ';
				break;
			}
			*cp = '?';
		} else if (Eflg == 0 && c == '=') {
			while (*--cp != ' ')
				if (cp <= (char *)ip)
					break;
			break;
		}
	}
	*cp = 0;
	while (*--cp == ' ')
		*cp = 0;
	cp = (char *)ip;
	if (nbad != 0)
		goto retucomm;
	(void) strncpy(cmdbuf, cp, &argspac.argc[CLSIZE*NBPG] - cp);
	return (savestr(cmdbuf));

bad:
	fprintf(stderr, "ps: error locating command name for pid %d from %s\n",
	    mproc->p_pid, file);
retucomm:
	(void) strcpy(cmdbuf, " [ ");
	(void) strncat(cmdbuf, u.u_comm, sizeof (u.u_comm));
	(void) strcat(cmdbuf, " ]");
	return (savestr(cmdbuf));
}

char	*lhdr =
"      F   UID   PID  PPID  C PRI NI ADDR  SZ  RSS  WCHAN STAT TT  TIME";
char	*lfhdr =
"      F    USER   PID  PPID  C PRI NI ADDR  SZ  WCHAN STAT   STIME  TT  TIME";
lpr(sp)
	struct savcom *sp;
{
	register struct asav *ap = sp->ap;
	register struct lsav *lp = sp->s_un.lp;

	printf("%7x", ap->a_flag);
	if (fflg)
		printf("%8s", getname(ap->a_uid));
	else
		printf(" %5u", ap->a_uid);
	printf(" %5u %5u%3d",
	    ap->a_pid, ap->a_ppid, lp->l_cpu&0377);
	printf("%4d%3d%5x%4d", ap->a_prior, ap->a_nice, lp->l_addr,
	    pgtok(ap->a_size));
	if (!fflg)
		printf("%5d", pgtok(ap->a_rss));

	if(lp->l_wchan == 0)
		printf("       ");
	else if(lp->l_wchan == (caddr_t)nl[X_UAREA].n_value)
		printf("  pause");
	else if(lp->l_wchan == (caddr_t)nl[X_LBOLT].n_value)
		printf("  lbolt");
	else if(lp->l_wchan == (caddr_t)nl[X_SELWAIT].n_value)
		printf(" select");
	else if(lp->l_wchan == lp->l_procaddr)
		printf("  child");
	else if(ap->a_ttyp != 0 && lp->l_wchan == (caddr_t)&ap->a_ttyp->t_rawq)
		printf("  ttyin");
	else if(ap->a_ttyp != 0 && lp->l_wchan == (caddr_t)&ap->a_ttyp->t_oflag)
		printf(" ttyout");
	else if(ap->a_ttyp != 0 && lp->l_wchan == (caddr_t)&ap->a_ttyp->t_outq)
		printf(" tthwat");
	else if(ap->a_ttyp != 0 && lp->l_wchan == (caddr_t)&ap->a_ttyp->t_canq)
		printf("   canq");
	else
		printf(" %6x", (int)lp->l_wchan&0xffffff);
	printf(" %4.4s", state(ap));
	if (fflg)
		prtim(ap);
	ptty(ap->a_tty);
	ptime(ap);
}

ptty(tp)
	char *tp;
{

	printf(" %-2.2s", tp);
}

ptime(ap)
	struct asav *ap;
{

	printf("%3ld:%02ld", ap->a_cpu / 60, ap->a_cpu % 60);
}

char	*uhdr =
"    USER   PID %CPU %MEM SIZE  RSS TT STAT  TIME";
upr(sp)
	struct savcom *sp;
{
	register struct asav *ap = sp->ap;
	int vmsize, rmsize;

	vmsize = pgtok((ap->a_size + ap->a_tsiz));
	rmsize = pgtok(ap->a_rss);
	if (ap->a_xccount)
		rmsize += pgtok(ap->a_txtrss/ap->a_xccount);
	else
		rmsize += pgtok(ap->a_txtrss);

	printf("%8s %5u%5.1f%5.1f%5d%5d",
	    getname(ap->a_uid), ap->a_pid, sp->s_un.u_pctcpu, pmem(ap),
	    vmsize, rmsize);
	ptty(ap->a_tty);
	printf(" %4.4s", state(ap));
	ptime(ap);
}

char *vhdr =
"  PID TT STAT  TIME SL RE PAGEIN   SZ  RSS  LIM TSIZ TRS %CPU %MEM";
vpr(sp)
	struct savcom *sp;
{
	register struct vsav *vp = sp->s_un.vp;
	register struct asav *ap = sp->ap;

	printf("%5u", ap->a_pid);
	ptty(ap->a_tty);
	printf(" %4.4s", state(ap));
	ptime(ap);
	printf("%3d%3d%7d%5d%5d",
	   ap->a_eslptime > 99 ? 99 : ap-> a_eslptime,
	   ap->a_etime > 99 ? 99 : ap->a_etime, vp->v_majflt,
	   pgtok(ap->a_size), pgtok(ap->a_rss));
	if (ap->a_maxrss == (RLIM_INFINITY/NBPG))
		printf("   xx");
	else
		printf("%5d", pgtok(ap->a_maxrss));
	printf("%5d%4d%5.1f%5.1f",
	   pgtok(ap->a_tsiz), pgtok(ap->a_txtrss), vp->v_pctcpu, pmem(ap));
}

char	*shdr =
"SSIZ   PID TT STAT  TIME";
char	*sfhdr =
"SSIZ     USER   PID  PPID  C   STIME  TT STAT  TIME";
spr(sp)
	struct savcom *sp;
{
	register struct asav *ap = sp->ap;

	if (Sflg)
		printf("%4d ", sp->s_un.s_ssiz);
	if (fflg)
		printf("%8s ", getname(ap->a_uid));
	printf("%5u", ap->a_pid);
	if (fflg) {
		printf(" %5u%3d", ap->a_ppid, ap->a_cpu&0377);
		prtim(ap);
	}
	ptty(ap->a_tty);
	printf(" %4.4s", state(ap));
	ptime(ap);
}

char *
state(ap)
	register struct asav *ap;
{
	char stat, load, nice, anom;
	static char res[5];

	switch (ap->a_stat) {

	case SSTOP:
		stat = 'T';
		break;

	case SSLEEP:
		if (ap->a_interruptable)
			if (ap->a_eslptime >= MAXSLP)
				stat = 'I';
			else
				stat = 'S';
		else if (ap->a_flag & SPAGE)
			stat = 'P';
		else
			stat = 'D';
		break;

	case SWAIT:
	case SRUN:
	case SIDL:
		stat = 'R';
		break;

	case SZOMB:
		stat = 'Z';
		break;

	default:
		stat = '?';
	}
	load = ap->a_flag & SLOAD ? (ap->a_rss>ap->a_maxrss ? '>' : ' ') : 'W';
	if (ap->a_nice < NZERO)
		nice = '<';
	else if (ap->a_nice > NZERO)
		nice = 'N';
	else
		nice = ' ';
	anom = (ap->a_flag&SUANOM) ? 'A' : ((ap->a_flag&SSEQL) ? 'S' : ' ');
	res[0] = stat; res[1] = load; res[2] = nice; res[3] = anom;
	return (res);
}

/*
 * Given a base/size pair in virtual swap area,
 * return a physical base/size pair which is the
 * (largest) initial, physically contiguous block.
 */
vstodb(vsbase, vssize, dmp, dbp, rev)
	register int vsbase;
	int vssize;
	struct dmap *dmp;
	register struct dblock *dbp;
{
	register int blk = dmmin;
	register swblk_t *ip = dmp->dm_map;

	vsbase = ctod(vsbase);
	vssize = ctod(vssize);
	if (vsbase < 0 || vsbase + vssize > dmp->dm_size)
		panic("vstodb");
	while (vsbase >= blk) {
		vsbase -= blk;
		if (blk < dmmax)
			blk *= 2;
		ip++;
	}
	if (*ip <= 0 || *ip + blk > nswap)
		panic("vstodb *ip");
	dbp->db_size = min(vssize, blk - vsbase);
	dbp->db_base = *ip + (rev ? blk - (vsbase + dbp->db_size) : vsbase);
}

/*ARGSUSED*/
panic(cp)
	char *cp;
{

#ifdef DEBUG
	printf("%s\n", cp);
#endif
}

min(a, b)
{

	return (a < b ? a : b);
}

pscomp(s1, s2)
	struct savcom *s1, *s2;
{
	register int i;

	if (Uflg)
		return (s2->s_un.u_pctcpu > s1->s_un.u_pctcpu ? 1 : -1);
	if (vflg)
		return (vsize(s2) - vsize(s1));
	i = s1->ap->a_ttyd - s2->ap->a_ttyd;
	if (i == 0)
		i = s1->ap->a_pid - s2->ap->a_pid;
	return (i);
}

vsize(sp)
	struct savcom *sp;
{
	register struct asav *ap = sp->ap;
	register struct vsav *vp = sp->s_un.vp;
	
	if (ap->a_flag & SLOAD)
		return (ap->a_rss +
		    ap->a_txtrss / (ap->a_xccount ? ap->a_xccount : 1));
	return (vp->v_swrss + (ap->a_xccount ? 0 : vp->v_txtswrss));
}

/* search returns 1 if arg is found in array arr */
/* which has length num, and returns 0 if not found */

search(arr, num, arg)
int arr[];
int num;
int arg;
{
	int i;
	for (i = 0; i < num; i++)
		if (arg == arr[i])
			return(1);
	return(0);
}

/* uopt is used for the fancy version of the u option where either */
/* user name or number may be an argument.  The arrays uid_name & */
/* uid_num store the associated names and numbers.  ( these arrays are */
/* later used for printing UID ). The array uid_tbl stores */
/* ptrs (index) into the name & number arrays for arguments */
/* after the u option */

uopt(oarg)
char *oarg;
{
	int found = -1;

	struct passwd *pwd, *getpwuid(), *getpwnam();
	char *pwname;
	char *p;
	unsigned size;
	int pwuid;
	int i;

	/* search thru name array for oarg */
	for (i=0; i<uidn; i++) {
		if (strcmp(oarg,uidmap[i].uid_name)==0) {
			found = uidmap[i].uid_num;
			break;
		}
	}
	/* if not found then search through number array */
	if (found < 0) {
		pwuid = atoi(oarg);
		for (i=0; i<uidn; i++) {
			if (pwuid == uidmap[i].uid_num) {
				found = pwuid;
				break;
			}
		}
	}
	/* if found then enter found index into tbl array */
	if ( found != -1 ) {
		if (nuids >= SIZ) return;
		uid_tbl[nuids++] = found;
		return;
	}
	/* oarg was not found in uid arrays so search through /etc/passwd */
	/* for name and number.  If found, enter name and number in arrays */
	/* and then put values in table */

	pwname = oarg;
	if(pwd = getpwnam(pwname)) {	/* not null so found */
		pwuid = pwd->pw_uid;
	}
	else {
		pwuid = atoi(oarg);
	/* rewrite an atoi - this is kludge */
		if (( pwuid == 0) && (strcmp(oarg,"0") != 0))
			return;
		if (pwd = getpwuid(pwuid)) {
			pwname = pwd->pw_name;
		}
		else {
		/* not found so name or number is invalid */
		return;
		}
	}

	/* put nuid name and number in table */
	if (( uidn >= TSIZE) || (nuids >= SIZ))
		return;
	uidmap[uidn].uid_num = pwuid;
	size = strlen(pwname);
	if (size > NMAX)
		size = NMAX;
	p = alloc(++size);
	(void) strncpy(p, pwname, size);
	uidmap[uidn++].uid_name = p;
	uid_tbl[nuids++] = pwuid;
	return;
}

/* add uid to list of uids we're going to see */
uadd(uid)
{
	int found = -1;
	int i;

	for (i=0; i<uidn; i++) {
		if (uid == uidmap[i].uid_num) {
			found = i;
			break;
		}
	}
	/* if found then no need to do anything else */
	if ( found != -1 )
		return;

	/* put nuid name and number in table */
	if (uidn >= TSIZE)
		return;
	uidmap[uidn].uid_num = uid;
	uidmap[uidn].uid_name = NULL;	/* not found yet */
	uidn++;
	return;
}

/* fill in UID table */
uidget()
{
	register int i;
	register int nundone;
	struct passwd *pw, *getpwent();
	register char *p;
	unsigned size;

	if (uidn == 0)
		return;	/* table is empty */

	setpwent();
	while (pw = getpwent()) {
		nundone = 0;
		for (i = 0; i < uidn; i++) {
			if (uidmap[i].uid_name == NULL) {
				if (uidmap[i].uid_num == pw->pw_uid) {
					size = strlen(pw->pw_name);
					if (size > NMAX)
						size = NMAX;
					p = alloc(++size);
					(void) strncpy(p, pw->pw_name, size);
					uidmap[i].uid_name = p;
				}
				nundone++;
			}
		}
		if (nundone == 0) {
			endpwent();
			return;	/* no more to fill in */
		}
	}
	endpwent();
}

char *
getname(uid)
int uid;
{
	int i;
	char uidbuf[5+1];

	for (i=0; i<uidn; i++)
		if (uidmap[i].uid_num == uid && uidmap[i].uid_name != NULL)
			return(uidmap[i].uid_name);
	sprintf(uidbuf, "%.5d", uid);
	return(uidbuf);

}

/* ufind will return 1 if puid is in table ; if not return 0 */
ufind(puid)
int puid;
{
int	i;
	for (i=0; i<nuids; i++){
		if (uid_tbl[i] == puid)
			return(1);
	}
	return(0);
}

/* print starting time of process unless process started more */
/* than 24 hours ago in which case date is printed   */

prtim(ap)
	register struct asav *ap;
{
	char *ctime();
	time_t time();
	time_t tim;
	char curtim[26];
	char *sttim;
	char *p1, *p2;
	char dayst[3], daycur[3];

	if (ap->a_stat == SZOMB) {
		printf("         ");
		return;
	}
	tim = time((time_t *)0);
	strcpy(curtim,ctime(&tim));
	sttim = ctime(&ap->a_start);
	if ( strncmp(curtim, sttim, 11) == 0) {
		p1 = sttim + 11;
		p2 = p1 + 8;
	}
	else {
		p1 = sttim + 4;
		p2 = p1 + 7;
		/* if time is < 24 hours different, then print time */
		if (strncmp(curtim+4, sttim+4, 3) == 0) {
			strncpy(dayst,sttim+8, 2);
			dayst[2] = '\0';
			strcat(dayst,"");
			strncpy(daycur,curtim+8,2);
			daycur[2] = '\0';
			strcat(daycur,"");
			if ((atoi(dayst) +1 == atoi(daycur)) &&
				 (strncmp(curtim+11,sttim+11,8)<=0)) {
				p1 = sttim + 11;
				p2 = p1 + 8;
			}
		}
	}
	*p2 = '\0';
	printf("%9s",p1);
}

char	*freebase;
int	nleft;

char *
alloc(size)
	int size;
{
	register char *cp;
	register int i;

#ifdef sun
	size = (size+1)&~1;
#endif

	size = ((size + 3) / 4) * 4;  /* align the block on a 4 byte boundary */

	if (size > nleft) {
		freebase = (char *)sbrk((int)(i = size > 2048 ? size : 2048));
		if (freebase == (char *)-1) {
			fprintf(stderr, "ps: ran out of memory\n");
			exit(1);
		}
		nleft = i - size;
	} else
		nleft -= size;
	cp = freebase;
	for (i = size; --i >= 0; )
		*cp++ = 0;
	freebase = cp;
	return (cp - size);
}

char *
savestr(cp)
	char *cp;
{
	register int len;
	register char *dp;

	len = strlen(cp);
	dp = (char *)alloc((len+1+3) & ~3);
	(void) strcpy(dp, cp);
	return (dp);
}
