/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */


#ifndef lint
char copyright[] =
"@(#) Copyright (c) 1980 Regents of the University of California.\n\
 All rights reserved.\n";
#endif not lint

#ifndef lint
static char sccsid[] = "@(#)pstat.c	5.3 (Berkeley) 9/4/85";
#endif not lint


/*
 * Print system stuff
 */

#define mask(x) (x&0377)
#define	clear(x) ((int)x&0x3fffffff)

#include <sys/param.h>
#include <sys/dir.h>
#define	KERNEL
#include <sys/file.h>
#undef	KERNEL
#include <sys/user.h>
#include <sys/proc.h>
#include <sys/text.h>

#include <sys/vnode.h>
#include <ufs/inode.h>

#include <sys/map.h>
#include <sys/ioctl.h>
#include <sys/tty.h>
#include <sys/conf.h>
#include <frame.h>

#include <sys/vm.h>
#include <nlist.h>

#include <ml/pte.h>
#include <ml/psl.h>
#include <stdio.h>



char	*fcore	= "/dev/kmem";
char	*fmem	= "/dev/mem";
char	*fnlist	= "/unix";
int	fc, fm;


struct nlist nl[] = {
#define	SINODE	0
	{ "_inode" },
#define	STEXT	1
	{ "_text" },
#define	SPROC	2
	{ "_proc" },
#define	SVX	3
	{ "_vx_tty" },
#define	SNVX	4
	{ "_nvxports" },
#define	SKL	5
	{ "_cons" },
#define	SFIL	6
	{ "_file" },
#define	SWAPMAP	7
	{ "_swapmap" },
#define	SNPROC	8
	{ "_nproc" },
#define	SNTEXT	9
	{ "_ntext" },
#define	SNFILE	10
	{ "_nfile" },
#define	SNINODE	11
	{ "_ninode" },
#define	SNSWAPMAP 12
	{ "_nswapmap" },
#define	SPTY	13
	{ "_pt_tty" },
#define	SDMMIN	14
	{ "_dmmin" },
#define	SDMMAX	15
	{ "_dmmax" },
#define	SNSWDEV	16
	{ "_nswdev" },
#define	SSWDEVT	17
	{ "_swdevt" },
#define	SNPTY	18
	{ "_npty" },
#define SYSMAP	19
	{ "_Sysmap" },
	{ "" },
};

int	inof;
int	txtf;
int	prcf;
int	ttyf;
int	usrf;
int     USRf;
long	ubase;
int     upid;

int	filf;
int	swpf;
int	totflg;
char	partab[1];
int	tthiwat[16];

struct	cdevsw	cdevsw[1];
struct	bdevsw	bdevsw[1];
int	allflg;
int	kflg;

main(argc, argv)
char **argv;
{
	register char *argp;
	int allflags;

	argc--, argv++;
	while (argc > 0 && **argv == '-') {
		argp = *argv++;
		argp++;
		argc--;
		while (*argp++)
		switch (argp[-1]) {

		case 'T':
			totflg++;
			break;

		case 'a':
			allflg++;
			break;

		case 'i':
			inof++;
			break;

		case 'k':
			kflg++;
			fcore = fmem = "/vmcore";
			break;

		case 'x':
			txtf++;
			break;

		case 'p':
			prcf++;
			break;

		case 't':
			ttyf++;
			break;

		case 'u':
			if (argc == 0)
				break;
			argc--;
			usrf++;
			sscanf( *argv++, "%x", &ubase);
			break;

		case 'U':
			if (argc == 0)
				break;
			argc--;
			USRf++;
			sscanf( *argv++, "%d", &upid);
			break;

		case 'f':
			filf++;
			break;
		case 's':
			swpf++;
			break;
		default:
			usage();
			exit(1);
		}
	}
	if (argc>1)
		fcore = fmem = argv[1];

	if ((fc = open(fcore, 0)) < 0) {
		printf("Can't find %s\n", fcore);
		exit(1);
	}
	if ((fm = open(fmem, 0)) < 0) {
		printf("Can't find %s\n", fmem);
		exit(1);
	}

	if (argc>0)
		fnlist = argv[0];
	nlist(fnlist, nl);
	if (nl[0].n_type == 0 && nl[0].n_value == 0 ) {
		printf("no namelist\n");
		exit(1);
	}

	allflags = filf | totflg | inof | prcf | txtf | ttyf | usrf | USRf | swpf;
	if (allflags == 0) {
		printf("pstat: one or more of -[aixptfsu] is required\n");
		exit(1);
	}
	if (filf||totflg)
		dofile();
	if (inof||totflg)
		doinode();
	if (prcf||totflg)
		doproc();
	if (txtf||totflg)
		dotext();
	if (ttyf)
		dotty();
	if (usrf)
		dousr();
	if (USRf)
		doUSR();
	if (swpf||totflg)
		doswap();
	exit(0);

}

usage()
{

	printf("usage: pstat -[aixptfskT] [-u ubase] [-U pid] [system [core]]\n");
}

doinode()
{
	register struct inode *ip;
	register struct vnode *vp;

	struct inode *xinode, *ainode;
	register int nin;
	int ninode;

	nin = 0;
	ninode = getw(nl[SNINODE].n_value);
	xinode = (struct inode *)calloc(ninode, sizeof (struct inode));
	if ( xinode == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	ainode = (struct inode *)getw(nl[SINODE].n_value);
	lseek(fc, mkphys((int)ainode), 0);

	read(fc, xinode, ninode * sizeof(struct inode));
	for (ip = xinode; ip < &xinode[ninode]; ip++)
		if (ip->i_vnode.v_count)
			nin++;
	if (totflg) {
		printf("%3d/%3d inodes\n", nin, ninode);
		return;
	}
	printf("%d/%d active inodes\n", nin, ninode);
	printf("  ILOC   IFLAG  IDEVICE   INO   MODE NLK  UID  SIZE/DEV VFLAG CNT SHC EXC TYPE\n");

	for (ip = xinode; ip < &xinode[ninode]; ip++) {
		vp = &ip->i_vnode;
		if (vp->v_count == 0)
			continue;
		printf("%8.1x ", ainode + (ip - xinode));
		putf(ip->i_flag&IACC, 'A');
		putf(ip->i_flag&ICHG, 'C');
		putf(ip->i_flag&ILOCKED, 'L');
		putf(ip->i_flag&IREF, 'R');
		putf(ip->i_flag&IUPD, 'U');
		putf(ip->i_flag&IWANT, 'W');
		putf(ip->i_flag&ILWAIT, 'Z');
		printf("%3d,%3d", major(ip->i_dev), minor(ip->i_dev));
		printf("%6d", ip->i_number);
		printf("%7o", ip->i_mode & 0xffff);
		printf("%4d", ip->i_nlink);
		printf("%5d", ip->i_uid);
		if ((ip->i_mode&IFMT)==IFBLK || (ip->i_mode&IFMT)==IFCHR)
			printf("%6d,%3d", major(ip->i_rdev), minor(ip->i_rdev));
		else
			printf("%10ld", ip->i_size);
		printf(" ");
		putf(vp->v_flag&VROOT, 'R');
		putf(vp->v_flag&VSHLOCK, 'S');
		putf(vp->v_flag&VEXLOCK, 'E');
		putf(vp->v_flag&VTEXT, 'T');
		putf(vp->v_flag&VLWAIT, 'Z');
		printf("%4d", vp->v_count&0377);
		printf("%4d", vp->v_shlockc&0377);
		printf("%4d", vp->v_exlockc&0377);
		switch (vp->v_type) {
			case VNON:
				printf(" VNON");
				break;
			case VREG:
				printf(" VREG");
				break;
			case VDIR:
				printf(" VDIR");
				break;
			case VBLK:
				printf(" VBLK");
				break;
			case VCHR:
				printf(" VCHR");
				break;
			case VLNK:
				printf(" VLNK");
				break;
			case VSOCK:
				printf(" VSOC");
				break;
			case VFIFO:
			        printf(" FIFO");
			        break ;
			case VBAD:
				printf(" VBAD");
				break;
			default:
				printf(" ????");
				break;
		}
		printf("\n");
	}
	free(xinode);
}

getw(loc)
	off_t loc;
{
	int word;

	if (kflg)
		loc &= 0x3fffffff;
	lseek(fc, loc, 0);
	read(fc, &word, sizeof (word));
	return (word);
}

putf(v, n)
{
	if (v)
		printf("%c", n);
	else
		printf(" ");
}

dotext()
{
	register struct text *xp;
	int ntext;
	struct text *xtext, *atext;
	int ntx;

	ntx = 0;
	ntext = getw(nl[SNTEXT].n_value);
	xtext = (struct text *)calloc(ntext, sizeof (struct text));
	if ( xtext == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	atext = (struct text *)getw(nl[STEXT].n_value);
	lseek(fc, mkphys((int)atext), 0);
	read(fc, xtext, ntext * sizeof (struct text));
	for (xp = xtext; xp < &xtext[ntext]; xp++)
		if (xp->x_vptr!=NULL)
			ntx++;
	if (totflg) {
		printf("%3d/%3d texts\n", ntx, ntext);
		return;
	}
	printf("%d/%d active texts\n", ntx, ntext);
	printf("   LOC   FLAGS DADDR      CADDR  RSS SIZE      VPTR  CNT CCNT\n");
	for (xp = xtext; xp < &xtext[ntext]; xp++) {
		if (xp->x_vptr == NULL)
			continue;
		printf("%8.1x", atext + (xp - xtext));
		printf(" ");
		putf(xp->x_flag&XPAGV, 'P');
		putf(xp->x_flag&XTRC, 'T');
		putf(xp->x_flag&XWRIT, 'W');
		putf(xp->x_flag&XLOAD, 'L');
		putf(xp->x_flag&XLOCK, 'K');
		putf(xp->x_flag&XWANT, 'w');
		printf("%5x", xp->x_daddr[0]);
		printf("%11x", xp->x_caddr);
		printf("%5d", xp->x_rssize);
		printf("%5d", xp->x_size);
		printf("%10.1x", xp->x_vptr);
		printf("%5d", xp->x_count&0377);
		printf("%5d", xp->x_ccount);
		printf("\n");
	}
	free(xtext);
}

doproc()
{
	struct proc *xproc, *aproc;
	int nproc;
	register struct proc *pp;
	register loc, np;
	struct pte apte;
	struct timeval now;
	struct timezone tz;
	int eslptime, etime;

	nproc = getw(nl[SNPROC].n_value);
	xproc = (struct proc *)calloc(nproc, sizeof (struct proc));
	if ( xproc == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	aproc = (struct proc *)getw(nl[SPROC].n_value);
	lseek(fc, mkphys((int)aproc), 0);
	read(fc, xproc, nproc * sizeof (struct proc));
	np = 0;
	for (pp=xproc; pp < &xproc[nproc]; pp++)
		if (pp->p_stat)
			np++;
	if (totflg) {
		printf("%3d/%3d processes\n", np, nproc);
		return;
	}
	gettimeofday(&now, &tz);
	printf("%d/%d processes\n", np, nproc);
	printf("   LOC    S    F POIP PRI      SIG  UID SLP TIM  CPU  NI   PGRP    PID   PPID    ADDR   RSS SRSS SIZE    WCHAN    LINK   TEXTP\n" );
	for (pp=xproc; pp<&xproc[nproc]; pp++) {
		if (pp->p_stat==0 && allflg==0)
			continue;
		printf("%8x", aproc + (pp - xproc));
		printf(" %2d", pp->p_stat);
		printf(" %4x", pp->p_flag & 0xffff);
		printf(" %4d", pp->p_poip);
		printf(" %3d", pp->p_prior);
		printf(" %8x", pp->p_sig);
		printf(" %4d", pp->p_uid);
/*
		printf(" %3d", pp->p_slptime);
		printf(" %3d", pp->p_time);
		printf(" %4d", pp->p_cpu&0377);
*/
		if (pp->p_eslptime)
			eslptime = now.tv_sec - pp->p_eslptime;
		else
			eslptime = 0;
		printf(" %3d", eslptime);
		if (pp->p_etime)
			etime = now.tv_sec - pp->p_etime;
		else
			etime = 0;
		printf(" %3d", etime);
		printf(" %4d", 0);	/* we do not maintain p_cpu */

		printf(" %3d", pp->p_nice);
		printf(" %6d", pp->p_pgrp);
		printf(" %6d", pp->p_pid);
		printf(" %6d", pp->p_ppid);
		if (pp->p_flag & SLOAD) {
			lseek(fc, mkphys(pp->p_addr), 0);
			read(fc, &apte, sizeof(apte));
			printf(" %8x", apte.pg_pfnum);
		} else
			printf(" %8x", pp->p_swaddr);
		printf(" %4x", pp->p_rssize);
		printf(" %4x", pp->p_swrss);
		printf(" %5x", pp->p_dsize+pp->p_ssize);
		printf(" %8x", pp->p_wchan);
		printf(" %7x", clear(pp->p_link));
		printf(" %7x", clear(pp->p_textp));
		printf("\n");
	}
}

static char mesg[] =
" # RAW CAN OUT IFLG OFLG CFLG LFLG XFLG     ADDR   DEL COL    STATE   PGRP LINE\n";
static int ttyspace = 128;
static struct tty *tty;

dotty()
{
	extern char *malloc();

	if ((tty = (struct tty *)malloc(ttyspace * sizeof(*tty))) == 0) {
		printf("pstat: out of memory\n");
		return;
	}

	if (nl[SKL].n_type != 0 || nl[SKL].n_value != 0 )
		dottytype("console/remote", SKL, -3); /* Aren't constants fun */
	if (nl[SNVX].n_type != 0 || nl[SNVX].n_value != 0 )
		dottytype("vioc", SVX, SNVX);
	if (nl[SNPTY].n_type != 0 || nl[SNPTY].n_value != 0)
		dottytype("pty", SPTY, SNPTY);
}

dottytype(name, type, number)
char *name;
{
	int ntty;
	register struct tty *tp;
	extern char *realloc();

	if (tty == (struct tty *)0)
		return;
	if ( number < 0 ) {
	        ntty = - number ;
	} else {
		lseek(fc, mkphys(nl[number].n_value), 0);
		read(fc, &ntty, sizeof(ntty));
	}
	printf("%d %s lines\n", ntty, name);
	if (ntty > ttyspace) {
		ttyspace = ntty;
		if ((tty = (struct tty *)realloc(tty, ttyspace * sizeof(*tty))) == 0) {
			printf("pstat: out of memory\n");
			return;
		}
	}
	lseek(fc, mkphys(nl[type].n_value), 0);
	read(fc, tty, ntty * sizeof(struct tty));
	printf(mesg);
	for (tp = tty; tp < &tty[ntty]; tp++)
		ttyprt(tp, tp - tty, nl[type].n_value );
}

ttyprt(atp, line, addr)
struct tty *atp;
{
	register struct tty *tp;

	if ( tp -> t_state == 0 )
		return ;
	printf("%2x", line);
	tp = atp;
	printf("%4d", tp->t_rawq.c_cc);
	printf("%4d", tp->t_canq.c_cc);
	printf("%4d", tp->t_outq.c_cc);
	printf("%5x", tp->t_iflag);
	printf("%5x", tp->t_oflag);
	printf("%5x", tp->t_cflag);
	printf("%5x", tp->t_lflag);
	printf("%5x", tp->t_xflag);
	printf( "%9x", addr + line * sizeof( struct tty ) ) ;
	printf( "%6d", tp->t_delct ) ;
	printf( "%4d", tp-> t_col ) ;
	printf( "%9x", tp-> t_state ) ;
	printf( "%7d", tp-> t_pgrp ) ;
	printf( "%5d", tp-> t_line ) ;
	printf( "\n");
}

dousr()
{
	struct user U;
	struct proc P;

	/* This wins only if u_proc is in first CLBYTES of user structure */
	/* Read in first page of U area */
	lseek(fm, ubase * NBPG, 0);
	read(fm, &U, sizeof(U));

	/* read in proc structure for the process */
	lseek(fc, mkphys((int)U.u_procp), 0);
	read(fc, (char*) &P, sizeof (struct proc));
	upid = P.p_pid ;
	doUSR() ;
}

doUSR()
{
	union {
		struct user u;
		char upages[UPAGES*CLBYTES] ;
	} u_union ;
#define U u_union.u
#define UPG u_union.upages
	struct ucred UC;
	register i, j, *ip;
	struct pte uptes[UPAGES] ;
	struct proc *xproc, *aproc;
	int nproc;
	register struct proc *pp;
	register loc, np;
	struct pte apte;
	char pathname[ MAXPATHLEN+1 ] ;


	/* find the proc structure for pid 'upid' */
	nproc = getw(nl[SNPROC].n_value);
	xproc = (struct proc *)calloc(nproc, sizeof (struct proc));
	if ( xproc == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	aproc = (struct proc *)getw(nl[SPROC].n_value);
	lseek(fc, mkphys((int)aproc), 0);
	read(fc, xproc, nproc * sizeof (struct proc));
	for (pp=xproc; pp<&xproc[nproc]; pp++) {
		if (pp->p_stat==0 && allflg==0)
			continue;
		if (pp->p_pid == upid )
			break ;
	}
	if ( pp == &xproc[nproc] ) {
		printf("Pid %d is not running.\n", upid );
		return;
	}
	if ( (pp->p_flag & SLOAD) == 0 ) {
		printf("Pid %d is swapped.\n", upid );
		return;
	}

	/* read in pte's for all pages of U area and kernal stack */
	lseek(fc, mkphys(pp->p_addr), 0);
	read(fc, uptes, sizeof(uptes));

	/* read in each individual page */
	bzero( UPG, CLBYTES*UPAGES ) ;
	for ( i=0 ; i < UPAGES ; i ++ ) {
		lseek(fm, uptes[i].pg_pfnum * NBPG, 0);
		read(fm, &UPG[i*CLBYTES], CLBYTES );
	}
#ifdef NOTDEF
	/* Dump all the UPAGES in raw HEX */
	printf("Upages:\n");
	ip=(int*)&UPG[0];
	for (i=0; i<(CLBYTES*UPAGES)/4; i++) {
		if (i % 8 == 0)
			printf("%9.1x%9.1x",ip+i, ((int*)USRSTACK)+i);
		printf("%9.1x", *(ip+i) );
		if (i % 8 == 7)
			printf("\n");
	}
	if (i % 8)
		printf("\n");
#endif

	/* read in the credentials structure */
	lseek(fc, mkphys((int)U.u_cred), 0);
	read(fc, &UC, sizeof(UC));

	printf("pcb    ");
	ip = (int *)&U.u_pcb;
	for ( i = 0 ; i < sizeof( U.u_pcb )/4 ; i ++) {
		if (i%8 == 0 && i != 0 )
			printf("       ");
		printf("%x ", *ip++);
		if (i%8 == 7 )
			printf("\n");
	}
	if ( i%8 )
		printf("\n");

	printf("arg    ");
	for (i=0; i<sizeof(U.u_arg)/sizeof(U.u_arg[0]); i++) {
		if (i%8==0 && i!=0)
			printf("       ");
		printf(" %.1x", U.u_arg[i]);
		if (i%8==7)
			printf("\n");
	}
	if (i%8)
		printf("\n");
	printf("segflg\t%d\nerror %d\n", U.u_segflg, U.u_error);

	printf("uids\t%d,%d,%d,%d\n", UC.cr_uid,UC.cr_gid,UC.cr_ruid,
	    UC.cr_rgid);
	printf("procp\t%.1x\n", U.u_procp);
	printf("ap\t%.1x\n", U.u_ap);
	printf("r_val?\t%.1x\n", U.u_r.r_val1);

	printf("base, count, offset %.1x %.1x %ld\n", U.u_base,
		U.u_count, U.u_offset);

	if ( U.u_audrootdir.aud_len ) {
	        lseek( fc, mkphys( U.u_audrootdir.aud_buf ), 0 ) ;
	        read( fc, pathname, U.u_audrootdir.aud_len ) ;
	} else {
	        pathname[0] = '\0' ;
	}
	printf("rdir %.1x %s\n", U.u_rdir, pathname ) ;

	if ( U.u_audcwdir.aud_len ) {
	        lseek( fc, mkphys( U.u_audcwdir.aud_buf ), 0 ) ;
	        read( fc, pathname, U.u_audcwdir.aud_len ) ;
	} else {
	        pathname[0] = '\0' ;
	}
	printf("cdir %.1x %s\n", U.u_cdir, pathname ) ;

	printf("file   ");
	for (i=0; i<NOFILE; i++) {
		if (i % 8 == 0 && i != 0 )
			printf("       ");
		printf("%9.1x", U.u_ofile[i]);
		if (i % 8 == 7)
			printf("\n");
	}
	if (i % 8)
		printf("\n");

	printf("pofile ");
	for (i=0; i<NOFILE; i++) {
		if (i % 8 == 0 && i != 0)
			printf("       ");
		printf("%9.1x", U.u_pofile[i]);
		if (i % 8 == 7)
			printf("\n");
	}
	if (i % 8)
		printf("\n");

	printf("ssave  ");
	for (i=0; i<sizeof(label_t)/sizeof(int); i++) {
		if (i%8==0 && i!=0)
			printf("       ");
		printf("%9.1x", U.u_ssave.val[i]);
		if (i%8==7)
			printf("\n");
	}
	if (i%8)
		printf("\n");

	printf("sigs   ");
	for (i=0; i<NSIG; i++) {
		if (i % 8 == 0 && i!=0)
			printf("       ");
		printf("%9.1x", U.u_signal[i]);
		if (i % 8 == 7)
			printf("\n");
	}
	if (i % 8)
		printf("\n");

	printf("code\t%.1x\n", U.u_code);
	printf("ar0\t%.1x\n", U.u_ar0);
	printf("prof\t%X %X %X %X\n", U.u_prof.pr_base, U.u_prof.pr_size,
	    U.u_prof.pr_off, U.u_prof.pr_scale);
	printf("ttyp\t%.1x\n", U.u_ttyp);
	printf("ttyd\t%d,%d\n", major(U.u_ttyd), minor(U.u_ttyd));

	printf("exdata\t");
	ip = (int *)&U.u_exdata;
	for (i = 0; i < 8; i++)
		printf("%.1x ", *ip++);
	printf("\n");
	printf("comm %.14s\n", U.u_comm);
	printf("start\t%x\n", U.u_start.tv_sec);
	printf("acflag\t%x\n", U.u_acflag);
	printf("cmask\t%o\n", U.u_cmask);
	printf("sizes\t%.1x %.1x %.1x\n", U.u_tsize, U.u_dsize, U.u_ssize);
	printf("ru\t");
	ip = (int *)&U.u_ru;
	for (i = 0; i < sizeof(U.u_ru)/sizeof(int); i++)
		printf("%.1d ", ip[i]);
	printf("\n");
	ip = (int *)&U.u_cru;
	printf("cru\t");
	for (i = 0; i < sizeof(U.u_cru)/sizeof(int); i++)
		printf("%.1d ", ip[i]);
	printf("\n\n");

	/* If the process is in kernal mode, walk back the kernal stack. */
	if ( (U.u_pcb . pcb_psl & PSL_CURMOD) == 0 ) {
		struct frame * fp;
		struct frame * fpl;     /* frame pointer into u_union */
		int nargs;              /* number of arguments for frame */

		printf( "\n** Kernal Stack Walkback. **\n" ) ;
		fp = (struct frame *)U.u_pcb.pcb_fp ;
		printf( "Current pc %x Current fp %x\n", U.u_pcb.pcb_pc, fp ) ;

		/* Walk the stack back frame by frame. */
		while ( fp >= (struct frame *) USRSTACK &&
			fp < (struct frame *) (USRSTACK+UPAGES*NBPG) ) {

			fpl = (struct frame*)
			&( UPG[((char*)fp - (char*)USRSTACK - 8 )]) ;

			/* compute number of arguments */
			if ( fpl->fr_mask == 0x1fff && fpl->fr_removed==4 ) {
			        nargs = 9 ; /* trap */
			} else {
				nargs = (fpl->fr_removed-4)/4;
			}

			/* print the arguments */
           		printf( "%x(", fpl->fr_savpc);
           		ip = (int*)(fpl+ 1); /* args are right behind frame */
   		        for ( i = 0; i < nargs; ++ i ) {
   		        	if ( i != 0 ) {
   		        		printf( ", ");
   		        	}
   		        	printf( "%x", *ip++);
   		        }
   			printf( ")\n" );

	                /*
	                 * Print register values when trap occurred.
	                 */
			if ( fpl->fr_mask == 0x1fff && fpl->fr_removed==4 ) {
			        printf( "    regs: " ) ;
           			ip = (int*)fpl; /* regs are right before frame */
			        for ( i = -13 ; i <= -1 ; i ++ ) {
			                if ( i > -13 )
			                        printf( ", " ) ;
			                printf( "%x", *(ip+i) ) ;
			        }
			        printf ( "\n" ) ;
			}
   			fp = (struct frame *) fpl->fr_savfp ;
		}

        }

/*
	i =  U.u_stack - &U;
	while (U[++i] == 0);
	i &= ~07;
	while (i < 512) {
		printf("%x ", 0140000+2*i);
		for (j=0; j<8; j++)
			printf("%9x", U[i++]);
		printf("\n");
	}
*/
}

oatoi(s)
char *s;
{
	register v;

	v = 0;
	while (*s)
		v = (v<<3) + *s++ - '0';
	return(v);
}

dofile()
{
	int nfile;
	struct file *xfile, *afile;
	register struct file *fp;
	register nf;
	int loc;
	static char *dtypes[] = { "???", "inode", "socket" };

	nf = 0;
	nfile = getw(nl[SNFILE].n_value);
	xfile = (struct file *)calloc(nfile, sizeof (struct file));
	if ( xfile == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	afile = (struct file *)getw(nl[SFIL].n_value);
	lseek(fc, mkphys((int)afile), 0);
	read(fc, xfile, nfile * sizeof (struct file));
	for (fp=xfile; fp < &xfile[nfile]; fp++)
		if (fp->f_count)
			nf++;
	if (totflg) {
		printf("%3d/%3d files\n", nf, nfile);
		return;
	}
	printf("%d/%d open files\n", nf, nfile);
	printf("   LOC   TYPE    FLG     CNT  MSG    DATA    OFFSET\n");
	for (fp=xfile,loc=(int)afile; fp < &xfile[nfile]; fp++,loc+=sizeof(xfile[0])) {
		if (fp->f_count==0)
			continue;
		printf("%8x ", loc);
		if (fp->f_type <= DTYPE_SOCKET)
			printf("%-8.8s", dtypes[fp->f_type]);
		else
			printf("8d", fp->f_type);
		putf(fp->f_flag&FREAD, 'R');
		putf(fp->f_flag&FWRITE, 'W');
		putf(fp->f_flag&FAPPEND, 'A');
		putf(fp->f_flag&FSHLOCK, 'S');
		putf(fp->f_flag&FEXLOCK, 'X');
		putf(fp->f_flag&FSYNC, 'I');
		printf("  %3d", mask(fp->f_count));
		printf("  %3d", mask(fp->f_msgcount));
		printf("  %8.1x", fp->f_data);
		if (fp->f_offset < 0)
			printf("  %x\n", fp->f_offset);
		else
			printf("  %ld\n", fp->f_offset);
	}
}

int dmmin, dmmax, nswdev;

doswap()
{
	struct proc *proc;
	int nproc;
	struct text *xtext;
	int ntext;
	struct map *swapmap;
	int nswapmap;
	struct swdevt *swdevt, *sw;
	register struct proc *pp;
	int nswap, used, tused, free, waste;
	int db, sb;
	register struct mapent *me;
	register struct text *xp;
	int i, j;
	int block, dmap[NDMAP];

	nproc = getw(nl[SNPROC].n_value);
	proc = (struct proc *)calloc(nproc, sizeof (struct proc));
	if ( proc == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	ntext = getw(nl[SNTEXT].n_value);
	xtext = (struct text *)calloc(ntext, sizeof (struct text));
	if ( xtext == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	nswapmap = getw(nl[SNSWAPMAP].n_value);
	swapmap = (struct map *)calloc(nswapmap, sizeof (struct map));
	if ( swapmap == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	nswdev = getw(nl[SNSWDEV].n_value);
	swdevt = (struct swdevt *)calloc(nswdev, sizeof (struct swdevt));
	if ( swdevt == 0 ) {
	        fprintf( stderr, "pstat: Out of memory\n" ) ;
	}
	lseek(fc, mkphys( nl[SSWDEVT].n_value), L_SET);
	read(fc, swdevt, nswdev * sizeof (struct swdevt));
	lseek(fc, mkphys( getw(nl[SPROC].n_value)), 0);
	read(fc, proc, nproc * sizeof (struct proc));
	lseek(fc, mkphys( getw(nl[STEXT].n_value)), 0);
	read(fc, xtext, ntext * sizeof (struct text));
	lseek(fc, mkphys( getw(nl[SWAPMAP].n_value)), 0);
	read(fc, swapmap, nswapmap * sizeof (struct map));
	swapmap->m_name = "swap";
	swapmap->m_limit = (struct mapent *)&swapmap[nswapmap];
	dmmin = getw(nl[SDMMIN].n_value);
	dmmax = getw(nl[SDMMAX].n_value);

	nswap = 0;
	for (sw = swdevt; sw < &swdevt[nswdev]; sw++)
		if ( sw->sw_nblks )
			nswap += sw->sw_nblks - 1 ;

	free = 0;
	for (me = (struct mapent *)(swapmap+1);
	    me < (struct mapent *)&swapmap[nswapmap]; me++)
		free += me->m_size;
	used = tused;
	tused = 0;
	for (xp = xtext; xp < &xtext[ntext]; xp++)
		if (xp->x_vptr!=NULL) {
			tused += ctod(clrnd(xp->x_size));
			if (xp->x_flag & XPAGV)
				tused += ctod(clrnd(ctopt(xp->x_size)));
		}
	used = tused;
	waste = 0;
	for (pp = proc; pp < &proc[nproc]; pp++) {
		if (pp->p_stat == 0 || pp->p_stat == SZOMB)
			continue;
		if (pp->p_flag & SSYS)
			continue;
		db = ctod(pp->p_dsize), sb = up(db);
		used += sb;
		waste += sb - db;
		db = ctod(pp->p_ssize), sb = up(db);
		used += sb;
		waste += sb - db;
		if ((pp->p_flag&SLOAD) == 0)
			used += ctod(vusize(pp));
	}
	if (totflg) {
#define	btok(x)	((x) / (1024 / DEV_BSIZE))
		printf("%3d/%3d 00k swap\n",
		    btok(used/100), btok((used+free)/100));
		return;
	}
	printf("%dk used (%dk text), %dk free, %dk wasted, %dk missing\n",
	    btok(used), btok(tused), btok(free), btok(waste),
	/* a dmmax/2-ctod(CLSIZE) block goes to argmap */
	    btok(nswap - (dmmax/2 - (int)(ctod(CLSIZE)-(used + free)))));

	/*
	 * Determine the size of the largest text or stack region.
	 */
	block = dmmin;
	for (i=0, j=0; i<NDMAP; i++) {
		dmap[i] = rmalloc(swapmap, block);
		if (dmap[i] == 0)
			break;
		j += block;
		if (block < dmmax)
			block *= 2;
	}
	printf("max process allocable = %dk\n", j*DEV_BSIZE/1024);
	block = dmmin;
	for (j=0; j<i; j++) {
		rmfree(swapmap, block, dmap[j]);
		if (block < dmmax)
			block *= 2;
	}

	printf("avail: ");
	for (i = dmmax; i >= dmmin; i /= 2) {
		j = 0;
		while (rmalloc(swapmap, i) != 0)
			j++;
		if (j) printf("%d*%dk ", j, btok(i));
	}
	free = 0;
	for (me = (struct mapent *)(swapmap+1);
	    me < (struct mapent *)&swapmap[nswapmap]; me++)
		free += me->m_size;
	printf("%d*1k\n", btok(free));
}

up(size)
	register int size;
{
	register int i, block;

	i = 0;
	block = dmmin;
	while (i < size) {
		i += block;
		if (block < dmmax)
			block *= 2;
	}
	return (i);
}

/*
 * Compute number of pages to be allocated to the u. area
 * and data and stack area page tables, which are stored on the
 * disk immediately after the u. area.
 */
vusize(p)
	register struct proc *p;
{
	register int tsz = p->p_tsize / NPTEPG;

	/*
	 * We do not need page table space on the disk for page
	 * table pages wholly containing text. 
	 */
	return (clrnd(UPAGES +
	    clrnd(ctopt(p->p_tsize+p->p_dsize+p->p_ssize+UPAGES)) - tsz));
}

/*
 * Allocate 'size' units from the given
 * map. Return the base of the allocated space.
 * In a map, the addresses are increasing and the
 * list is terminated by a 0 size.
 *
 * Algorithm is first-fit.
 *
 * This routine knows about the interleaving of the swapmap
 * and handles that.
 */
long
rmalloc(mp, size)
	register struct map *mp;
	long size;
{
	register struct mapent *ep = (struct mapent *)(mp+1);
	register int addr;
	register struct mapent *bp;
	swblk_t first, rest;

	if (size <= 0 || size > dmmax)
		return (0);
	/*
	 * Search for a piece of the resource map which has enough
	 * free space to accomodate the request.
	 */
	for (bp = ep; bp->m_size; bp++) {
		if (bp->m_size >= size) {
			/*
			 * If allocating from swapmap,
			 * then have to respect interleaving
			 * boundaries.
			 */
			if (nswdev > 1 &&
			    (first = dmmax - bp->m_addr%dmmax) < bp->m_size) {
				if (bp->m_size - first < size)
					continue;
				addr = bp->m_addr + first;
				rest = bp->m_size - first - size;
				bp->m_size = first;
				if (rest)
					rmfree(mp, rest, addr+size);
				return (addr);
			}
			/*
			 * Allocate from the map.
			 * If there is no space left of the piece
			 * we allocated from, move the rest of
			 * the pieces to the left.
			 */
			addr = bp->m_addr;
			bp->m_addr += size;
			if ((bp->m_size -= size) == 0) {
				do {
					bp++;
					(bp-1)->m_addr = bp->m_addr;
				} while ((bp-1)->m_size = bp->m_size);
			}
			if (addr % CLSIZE)
				return (0);
			return (addr);
		}
	}
	return (0);
}

/*
 * Free the previously allocated space at addr
 * of size units into the specified map.
 * Sort addr into map and combine on
 * one or both ends if possible.
 */
rmfree(mp, size, addr)
	struct map *mp;
	long size, addr;
{
	struct mapent *firstbp;
	register struct mapent *bp;
	register int t;

	/*
	 * Both address and size must be
	 * positive, or the protocol has broken down.
	 */
	if (addr <= 0 || size <= 0)
		goto badrmfree;
	/*
	 * Locate the piece of the map which starts after the
	 * returned space (or the end of the map).
	 */
	firstbp = bp = (struct mapent *)(mp + 1);
	for (; bp->m_addr <= addr && bp->m_size != 0; bp++)
		continue;
	/*
	 * If the piece on the left abuts us,
	 * then we should combine with it.
	 */
	if (bp > firstbp && (bp-1)->m_addr+(bp-1)->m_size >= addr) {
		/*
		 * Check no overlap (internal error).
		 */
		if ((bp-1)->m_addr+(bp-1)->m_size > addr)
			goto badrmfree;
		/*
		 * Add into piece on the left by increasing its size.
		 */
		(bp-1)->m_size += size;
		/*
		 * If the combined piece abuts the piece on
		 * the right now, compress it in also,
		 * by shifting the remaining pieces of the map over.
		 */
		if (bp->m_addr && addr+size >= bp->m_addr) {
			if (addr+size > bp->m_addr)
				goto badrmfree;
			(bp-1)->m_size += bp->m_size;
			while (bp->m_size) {
				bp++;
				(bp-1)->m_addr = bp->m_addr;
				(bp-1)->m_size = bp->m_size;
			}
		}
		goto done;
	}
	/*
	 * Don't abut on the left, check for abutting on
	 * the right.
	 */
	if (addr+size >= bp->m_addr && bp->m_size) {
		if (addr+size > bp->m_addr)
			goto badrmfree;
		bp->m_addr -= size;
		bp->m_size += size;
		goto done;
	}
	/*
	 * Don't abut at all.  Make a new entry
	 * and check for map overflow.
	 */
	do {
		t = bp->m_addr;
		bp->m_addr = addr;
		addr = t;
		t = bp->m_size;
		bp->m_size = size;
		bp++;
	} while (size = t);
	/*
	 * Segment at bp is to be the delimiter;
	 * If there is not room for it 
	 * then the table is too full
	 * and we must discard something.
	 */
	if (bp+1 > mp->m_limit) {
		/*
		 * Back bp up to last available segment.
		 * which contains a segment already and must
		 * be made into the delimiter.
		 * Discard second to last entry,
		 * since it is presumably smaller than the last
		 * and move the last entry back one.
		 */
		bp--;
		printf("%s: rmap ovflo, lost [%d,%d)\n", mp->m_name,
		    (bp-1)->m_addr, (bp-1)->m_addr+(bp-1)->m_size);
		bp[-1] = bp[0];
		bp[0].m_size = bp[0].m_addr = 0;
	}
done:
	return;
badrmfree:
	printf("bad rmfree\n");
}
/*
 * "addr"  is a kern virt addr and does not correspond
 * To a phys addr after zipping out the high bit..
 * since it was valloc'd in the kernel.
 *
 * We return the phys addr by simulating kernel vm (/dev/kmem)
 * when we are reading a crash dump.
 */
mkphys(addr)
{
	register o;

	if (!kflg)
		return(addr);
	o = addr & PGOFSET;
	addr = clear(addr);
	addr >>= PGSHIFT;
	addr &= PG_PFNUM;
	addr *=  NBPW;
	addr = getw(nl[SYSMAP].n_value + addr);
	addr = ((addr & PG_PFNUM) << PGSHIFT) | o;
	return(addr);
}
