# Make sure the demons know what time it is
TZ=EST5EDT
export TZ

# Execute rc only the first time into multi-user mode
if [ "x$1" != "x-force" ]; then
	set `who -r`
	cur_mode=$7
	no_times=$8
	pre_mode=$9
	if [ ${cur_mode} != 2 -o ${no_times} != 0 ]; then
		echo 'Not first time into multi-user mode'
		echo '/etc/rc not executed'
		exit 0
	fi
fi

##################
#
# General
#
##################

/etc/mount -at 4.2

/usr/etc/savecore /usr/crashfiles
/etc/swapon -a

echo 'Saving EX/VI Editor temporaries...'
(cd /tmp; /usr/lib/ex3.9preserve -a)

echo 'Clearing:\c'
echo ' /tmp\c'
(cd /tmp ; rm -rf .)
echo ' /usr/tmp\c'
(cd /usr/tmp ; rm -rf .)

echo ' /etc/wtmp\c'
/bin/cat /dev/null > /etc/wtmp
chown adm /etc/wtmp
chgrp adm /etc/wtmp

# Clear out the UUCP lock file directory
if [ -d /usr/spool/locks ]; then

	echo ' UUCP_locks\c'
	(cd /usr/spool/locks; rm -f *)

fi
echo '.'

/bin/su sys -c "/usr/lib/sa/sadc /usr/adm/sa/sa`date +%d`"
echo 'Reboot logged to system activity file'

# Set the type of each tape drive. For each tape drive connected, the
# model number of the tape drive should be specified.
/bin/mt -f /dev/rmt/0mn settype 6331
# /bin/mt -f /dev/rmt/1mn settype 6740

echo 'Standard demons:\c'

# The lines below turn process accounting on. They should
# be uncommented only after reading acct(1M). Be sure to
# shut accounting off in /etc/shutdownrc.
#
# /bin/su adm -c /usr/lib/acct/startup
# echo ' Process_accounting\c'

rm -f /usr/lib/cron/FIFO
mv /usr/adm/sulog /usr/adm/OLDsulog
mv /usr/lib/cron/log /usr/lib/cron/OLDlog
echo > /usr/lib/cron/log 
/etc/cron
echo ' cron\c'

rm -f /usr/spool/lp/FIFO /usr/spool/lp/SCHEDLOCK
/usr/lib/lpsched
echo ' lpsched\c'

/usr/lib/errdemon
echo ' errdemon\c'

#
# The lines below initialize the 'Flat Panel Demon' for HCX-7 systems.
# If your system has a 'flat panel', uncomment the following lines.
# The first argument to /etc/flat should be changed to the tty device
# that the flat panel is connected to.
#
# if [ -f /etc/flat ]; then
#	nice --8 /etc/flat /dev/tty03 &
#	echo ' flat\c'
# fi

if [ -f /usr/hapse/bin/a.daemon ]; then
	/usr/hapse/bin/a.daemon
	echo ' hapse/a.daemon\c'
fi

echo '.'


##################
#
# Ethernet/Pronet
#
##################

# Hostname defaults to "node" specification in config file
if [ -f /usr/bin/hostname ]; then
 	hostname=`/usr/bin/hostname`
fi
if [ -f /etc/ifconfig ]; then
 	echo 'Assign local area network addresses...'

# Uncomment the devices which actually exist on your system, and the loopback.
# Use the broadcast option on the call to ifconfig to change the broadcast
# address for an interface.
# The devices en0 and en1 are VERSAbus ethernet controllers.
# 	/etc/ifconfig en0 $hostname up -trailers
# 	/etc/ifconfig en1 $hostname up -trailers
# The devices ex0 and ex1 are HVMEbus ethernet controllers.
# 	/etc/ifconfig ex0 $hostname up -trailers
# 	/etc/ifconfig ex1 $hostname up -trailers
# The devices pn0 and pn1 are HVMEbus pronet-80 controllers.
# 	/etc/ifconfig pn0 $hostname up -trailers
# 	/etc/ifconfig pn1 $hostname up -trailers
# lo0 is the loopback interface
	/etc/ifconfig lo0 127.0.0.1 up
fi

# Uncomment the following lines for en0 and en1 devices on VERSAbus.
# Change the values following the a option to a unique ethernet address.
#if [ -f /etc/enconfig ]; then
# 	/etc/enconfig en0 -a f0.f0.f0.b0.b0.ba
# 	/etc/enconfig en1 -a f0.f0.f0.b0.b0.bb
#fi

if [ -f /etc/inetd ]; then
	echo 'Network demons:\c'
	/etc/inetd
	echo ' inetd\c'
	if [ -f /etc/routed ]; then
	 	/etc/routed
	 	echo ' routed\c'
	fi
	if [ -f /etc/rwhod ]; then
	 	/etc/rwhod
	 	echo ' rwhod\c'
	fi
	echo '.'
fi

##################
#
# NFS
#
##################

if [ -f /bin/domainname ]; then
	# Set the domain name
	/bin/domainname milos-meadow
	echo 'Domain name is \c'
	/bin/domainname

	# Start NFS demons if they exist
	echo 'NFS demons:\c'
	if [ -f /etc/portmap ]; then
		/etc/portmap
		echo ' portmap\c'
	fi
	if [ -f /etc/nfsd ]; then
		/etc/nfsd 4
		echo ' nfsd(4)\c'
	fi
	if [ -f /etc/biod ]; then
		/etc/biod 4
		echo ' biod(4)\c'
	fi
	if [ -f /etc/rpc.statd ]; then
		/etc/rpc.statd
		echo ' statd\c'
	fi
	if [ -f /etc/rpc.lockd ]; then
		/etc/rpc.lockd
		echo ' lockd\c'
	fi

	# The lines below should be uncommented if this
	# machine is configured as a Yellow Page server
	#
#	if [ -f /usr/etc/ypserv ]; then
#		nice --4 /usr/etc/ypserv
#		echo ' ypserv\c'
#	fi

	# The lines below should be uncommented if this
	# machine is configured as the MASTER server for
	# the Yellow Pages passwd file
	#
#	if [ -f /usr/etc/rpc.yppasswdd ]; then
#		/usr/etc/rpc.yppasswdd /etc/passwd -m passwd
#		echo ' yppasswdd\c'
#	fi

	# The lines below should be uncommented if there
	# exists a running Yellow Page server on the net
	#
#	if [ -f /etc/ypbind ]; then
#		nice --4 /etc/ypbind
#		echo ' ypbind\c'
#	fi
	echo '.'
	/etc/mount -at nfs &
fi

##################
#
# More demons: These demons must follow the networking demons if they
# are present
#
##################

echo 'More demons:\c'

/etc/syslogd
echo ' syslogd\c'

if [ -f /usr/lib/sendmail ]; then

	(cd /usr/spool/mqueue; rm -f [lnx]f*)
	nice --4 /usr/lib/sendmail -q30m -bd &
	echo ' sendmail\c'

fi
echo '.'

# Initialize sendmail alias files
if [ ! -f /usr/lib/aliases.pag ]; then
	echo 'Initializing alias dbm files (/usr/lib/aliases.*)...'
	cat /dev/null > /usr/lib/aliases.dir
	cat /dev/null > /usr/lib/aliases.pag
	chown bin /usr/lib/aliases.*
	/usr/bin/newaliases
fi

##################
#
# Disk Quotas
#
##################

# Uncomment the following lines only if disk quotas are to be maintained
# by the kernel. Be advised that 'quotacheck' takes several minutes to
# run.

#echo 'check quotas: \c'
#	/etc/quotacheck -a
#echo 'done.'
#/etc/quotaon -a

##################
#
# MPCC
#
##################

## Uncomment the lines below as part of the MPCC installation.
## If a line begins with two '#' symbols, do not uncomment it.
## download the MPCC boards
#
#	echo ' downloading MPCC boards'
## Wait for board diagnostics to complete
#	sleep 7 
#	/etc/dlmpcc 

##################
#
# X.25
#
##################

## Uncomment the lines below as part of the X.25/DDN installation.
## If a line begins with two '#' symbols, do not uncomment it.
## initialize the X.25 links
#
# if [ -f /etc/x25l2d ]; then
#	/etc/x25l2d
#	echo ' X.25  level 2'
# fi
#
# if [ -f /etc/x25l3d ]; then
#	/etc/x25l3d
#	echo ' X.25  level 3'
# fi
#
## Wait for inititalization to complete
#	sleep 2 
#
# if [ -f /etc/x25conf ]; then
#	/etc/xutil -s config -f  /etc/x25conf 
#	echo ' X.25  inititialization'
# fi

##################
#
# DDN
#
##################

## Uncomment the lines below as part of the DDN installation.
## If a line begins with two '#' symbols, do not uncomment it.
## initialize the DDN connections
# if [ -f /etc/ipxconfig ]; then
#	/etc/ipx_init -1
#	echo ' DDN inititialization'
# fi
#
##################
#
# SNA
#
##################

## Uncomment the lines below as part of the SNA installation.
## If a line begins with two '#' symbols, do not uncomment it.
## initialize SNA 
#
# if [ -f /etc/snad ]; then
#	/etc/snad
#	echo ' sldc  '
# fi
#
## Wait for initialization to complete
#	sleep 2 
#
# if [ -f /usr/bin/sna_init ]; then
#	/usr/bin/sna_init
#	echo ' SNA initialization '
# fi
#
#
