# @(#)Makefile	1.2 86/12/30 NFSSRC
#
# @(#)Makefile 1.1 86/09/24 Copyright Sun Micro 1986
#
# Makefile for rpc.lockd - the network lock manager

.UNIVERSE=ucb

LIB = -lrpcsvc
CFLAGS = -O ${CFL}

ALL = rpc.lockd
HDRS=   prot_lock.h prot_time.h sm_res.h priv_prot.h

SRCS=   prot_main.c prot_lock.c prot_pklm.c prot_pnlm.c prot_msg.c\
	prot_proc.c prot_libr.c prot_alloc.c prot_priv.c\
	tcp.c udp.c xdr_nlm.c xdr_klm.c xdr_sm.c sm_monitor.c\
	svc_udp.c hash.c

OBJS=	prot_main.o prot_lock.o prot_pklm.o prot_pnlm.o prot_msg.o\
	prot_proc.o prot_libr.o prot_alloc.o prot_priv.o\
	tcp.o udp.o xdr_nlm.o xdr_klm.o xdr_sm.o sm_monitor.o \
	svc_udp.o hash.o




all: $(ALL)


rpc.lockd: $(OBJS)
	$(CC) $(CFLAGS) -o rpc.lockd $(OBJS) $(LIB)

.c.o:
	$(CC) $(CFLAGS) -c $*.c

clean:
	rm -f *.o $(OBJS) a.out *.bak

clobber: clean
	rm -f $(ALL)

install: all
	for i in ${ALL}; do \
		(install -r -f ${ROOT}/etc $$i); done
	

depend:
	cat </dev/null >x.c
	for i in ${SRCS} ${TESTSRCS}; do \
		(/bin/grep '^#[ 	]*include' x.c $$i | sed \
			-e '/\.\.\/h/d' \
			-e '/\.\.\/ufs/d' \
			-e 's/\.c:/.o:/' \
			-e 's,<\(.*\)>,"$${INCLDIR}/\1",' \
			-e 's/:[^"]*"\([^"]*\)".*/: \1/' >>makedep); done
	echo '/^# DO NOT DELETE THIS LINE/+2,$$d' >eddep
	echo '$$r makedep' >>eddep
	echo 'w' >>eddep
	cp rpc.lockd.mk rpc.lockd.mk.bak
	ed - rpc.lockd.mk < eddep
	rm eddep makedep x.c
	echo '# DEPENDENCIES MUST END AT END OF FILE' >> rpc.lockd.mk
	echo '# IF YOU PUT STUFF HERE IT WILL GO AWAY' >> rpc.lockd.mk
	echo '# see make depend above' >> rpc.lockd.mk

# DO NOT DELETE THIS LINE -- make depend uses it

prot_main.o: ${INCLDIR}/stdio.h
prot_main.o: ${INCLDIR}/signal.h
prot_main.o: ${INCLDIR}/sys/file.h
prot_main.o: ${INCLDIR}/sys/ioctl.h
prot_main.o: prot_lock.h
prot_main.o: priv_prot.h
prot_main.o: prot_time.h
prot_lock.o: ${INCLDIR}/stdio.h
prot_lock.o: ${INCLDIR}/sys/file.h
prot_lock.o: prot_lock.h
prot_lock.o: priv_prot.h
prot_lock.o: ${INCLDIR}/rpcsvc/sm_inter.h
prot_lock.o: sm_res.h
prot_pklm.o: ${INCLDIR}/stdio.h
prot_pklm.o: prot_lock.h
prot_pnlm.o: ${INCLDIR}/stdio.h
prot_pnlm.o: prot_lock.h
prot_msg.o: prot_lock.h
prot_msg.o: prot_time.h
prot_proc.o: ${INCLDIR}/stdio.h
prot_proc.o: ${INCLDIR}/sys/file.h
prot_proc.o: prot_lock.h
prot_libr.o: ${INCLDIR}/stdio.h
prot_libr.o: ${INCLDIR}/sys/file.h
prot_libr.o: ${INCLDIR}/signal.h
prot_libr.o: prot_lock.h
prot_libr.o: prot_time.h
prot_alloc.o: prot_lock.h
prot_priv.o: ${INCLDIR}/stdio.h
prot_priv.o: prot_lock.h
prot_priv.o: priv_prot.h
prot_priv.o: ${INCLDIR}/rpcsvc/sm_inter.h
tcp.o: ${INCLDIR}/stdio.h
tcp.o: ${INCLDIR}/netdb.h
tcp.o: ${INCLDIR}/rpc/rpc.h
tcp.o: ${INCLDIR}/sys/socket.h
tcp.o: ${INCLDIR}/sys/time.h
udp.o: ${INCLDIR}/stdio.h
udp.o: ${INCLDIR}/rpc/rpc.h
udp.o: ${INCLDIR}/sys/socket.h
udp.o: ${INCLDIR}/sys/time.h
udp.o: ${INCLDIR}/netdb.h
xdr_nlm.o: prot_lock.h
xdr_klm.o: prot_lock.h
xdr_sm.o: ${INCLDIR}/rpc/rpc.h
xdr_sm.o: ${INCLDIR}/rpcsvc/sm_inter.h
sm_monitor.o: prot_lock.h
sm_monitor.o: priv_prot.h
sm_monitor.o: ${INCLDIR}/stdio.h
sm_monitor.o: ${INCLDIR}/netdb.h
sm_monitor.o: ${INCLDIR}/rpc/rpc.h
sm_monitor.o: ${INCLDIR}/rpcsvc/sm_inter.h
sm_monitor.o: sm_res.h
svc_udp.o: ${INCLDIR}/stdio.h
svc_udp.o: ${INCLDIR}/rpc/rpc.h
svc_udp.o: ${INCLDIR}/sys/socket.h
svc_udp.o: ${INCLDIR}/errno.h
hash.o: prot_lock.h
# DEPENDENCIES MUST END AT END OF FILE
# IF YOU PUT STUFF HERE IT WILL GO AWAY
# see make depend above
