# @(#)Makefile	1.2 86/12/30 NFSSRC
#
# @(#)Makefile 1.1 86/09/24 Copyright Sun Micro 1986
#
# Makefile for rpc.statd - the network status monitor

.UNIVERSE=ucb
LIB = -lrpcsvc
CFLAGS = -O ${CFL}

ALL = rpc.statd
HDRS=  sm_statd.h  

SRCS= sm_svc.c sm_proc.c sm_statd.c ../rpc.lockd/tcp.c 

OBJS= sm_svc.o sm_proc.o sm_statd.o tcp.o

all: $(ALL)

rpc.statd: $(OBJS)
	$(CC) $(CFLAGS) -o rpc.statd $(OBJS) $(LIB)

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.c:
	$(CC) $(CFLAGS) $@.c $(LIB) -o $@

tcp.o: ../rpc.lockd/tcp.c
	$(CC) $(CFLAGS) -c ../rpc.lockd/tcp.c

clean:
	rm -f *.o $(OBJS) a.out

clobber: clean
	rm -f $(ALL)

install: all
	for i in $(ALL); do \
		(install -r -f ${ROOT}/etc $$i); done

depend:
	cat </dev/null >x.c
	for i in ${SRCS} ${TESTSRCS}; do \
		(/bin/grep '^#[ 	]*include' x.c $$i | sed \
			-e '/\.\.\/h/d' \
			-e '/\.\.\/ufs/d' \
			-e 's/\.c:/.o:/' \
			-e 's,<\(.*\)>,"$${INCLDIR}/\1",' \
			-e 's/:[^"]*"\([^"]*\)".*/: \1/' >>makedep); done
	echo '/^# DO NOT DELETE THIS LINE/+2,$$d' >eddep
	echo '$$r makedep' >>eddep
	echo 'w' >>eddep
	cp rpc.statd.mk rpc.statd.mk.bak
	ed - rpc.statd.mk < eddep
	rm eddep makedep x.c
	echo '# DEPENDENCIES MUST END AT END OF FILE' >> rpc.statd.mk
	echo '# IF YOU PUT STUFF HERE IT WILL GO AWAY' >> rpc.statd.mk
	echo '# see make depend above' >> rpc.statd.mk

# DO NOT DELETE THIS LINE -- make depend uses it

sm_svc.o: ${INCLDIR}/stdio.h
sm_svc.o: ${INCLDIR}/signal.h
sm_svc.o: ${INCLDIR}/rpc/rpc.h
sm_svc.o: ${INCLDIR}/sys/ioctl.h
sm_svc.o: ${INCLDIR}/rpcsvc/sm_inter.h
sm_svc.o: sm_statd.h
sm_proc.o: ${INCLDIR}/stdio.h
sm_proc.o: ${INCLDIR}/rpc/rpc.h
sm_proc.o: ${INCLDIR}/rpcsvc/sm_inter.h
sm_statd.o: ${INCLDIR}/stdio.h
sm_statd.o: ${INCLDIR}/sys/types.h
sm_statd.o: ${INCLDIR}/sys/file.h
sm_statd.o: ${INCLDIR}/sys/dir.h
sm_statd.o: ${INCLDIR}/rpc/rpc.h
sm_statd.o: ${INCLDIR}/rpcsvc/sm_inter.h
sm_statd.o: ${INCLDIR}/errno.h
sm_statd.o: sm_statd.h
../rpc.lockd/tcp.o: ${INCLDIR}/stdio.h
../rpc.lockd/tcp.o: ${INCLDIR}/netdb.h
../rpc.lockd/tcp.o: ${INCLDIR}/rpc/rpc.h
../rpc.lockd/tcp.o: ${INCLDIR}/sys/socket.h
../rpc.lockd/tcp.o: ${INCLDIR}/sys/time.h
# DEPENDENCIES MUST END AT END OF FILE
# IF YOU PUT STUFF HERE IT WILL GO AWAY
# see make depend above
