/*	sa.h 1.7 of 9/23/83	*/
/*	sa.h contains struct sa and defines variable used 
		in sadc.c and sar.c.
*/

#define NDCTR	16	/* max. # of disk controllers */
#define NDDRV	4	/* # disk drives/controller */
#define NDDEV	64	/* max # disk drives */
#define NCYTCTR 2	/* max # of tapemaster tape controllers */
#define NCYTDRV	8	/* # tape drives/tapemaster controller */
#define NXYTCTR 2	/* max # of xylogics tape controllers */
#define NXYTDRV	8	/* # tape drives/xylogics controller */
#define NDEVS	((NDCTR*NDDRV)+(NCYTCTR*NCYTDRV)+(NXYTCTR*NXYTDRV))

#define	IO_OPS	0  /* number of I /O requests since boot  */
#define	IO_BCNT	1  /* number of blocks transferred since boot */
#define	IO_ACT	2  /* cumulative time in ticks when drive is active  */
#define	IO_RESP	3  /* cumulative I/O response time in ticks since boot  */

struct nlist setup[] = {
#define X_VDSTAT 	0
	{"_vdstat"},
#define X_CYSTAT 	1
	{"_cystat"},
#define X_XYSTAT	2
	{"_xystat"},
#define X_SYSINFO	3
	{"_sysinfo"},
#define X_NDSK		4
	{"_ndsk"},
#define X_NCY		5
	{"_ncy"},
#define X_NXYD		6
	{"_nxyd"},
#define X_NINODE	7
	{"_ninode"},
#define X_NFILE		8
	{"_nfile"},
#define X_NTEXT		9
	{"_ntext"},
#define X_NPROC		10
	{"_nproc"},
#define X_INODE		11
	{"_inode"},
#define X_FILE		12
	{"_file"},
#define X_TEXT		13
	{"_text"},
#define X_PROC		14
	{"_proc"},
#define X_ERR		15
	{"_syserr"},
	{0},
};

char devnm[X_SYSINFO][6] ={
	" disk",
	"   tm",
	"   xy"
};

/*	structure sa defines the data structure of system activity data file
*/
 
struct sa {
	struct	sysinfo si;	/* defined in /usr/include/sys/sysinfo.h  */
	int	szinode;	/* current size of inode table  */
	int	szfile;		/* current size of file table  */
	int	sztext;		/* current size of text table  */
	int	szproc;		/* current size of proc table  */
	int	mszinode;	/* maximum size of inode table  */
	int	mszfile;	/* maximum size of file table  */
	int	msztext;	/* maximum size of text table  */
	int	mszproc;	/* maximum size of proc table  */
	long	inodeovf;	/* cumulative overflows of inode table
					since boot  */
	long	fileovf;	/* cumulative overflows of file table
					since boot  */
	long	textovf;	/* cumulative overflows of text table
					since boot  */
	long	procovf;	/* cumulative overflows of proc table
					since boot  */
	time_t	ts;		/* time stamp  */

	ulong	devio[NDEVS][4]; /* device unit information  */

};
extern struct sa sa;

