#/*	sa.mk 1.3 of 7/15/83	*/
#
# To make sure all files are up to date: make -f sa.mk all
#
# To force recompilation of all files: make -f sa.mk all FRC=FRC 
#
# To test new executables before installing in /usr/lib/sa:
# make -f sa.mk testbi
#
# The sadc and sadp modules must be able to read /dev/kmem,
# which standardly has restricted read permission.
# They must have set-group-ID mode and have the same group as /dev/kmem.

TESTDIR = .
FRC =
INS = /etc/install
CFLAGS = $(CFL)
LDFLAGS = $(LFL)
FFLAG = -f

all:	sadc sar sa1 sa2 timex sag sadp

install: all
	-mkdir $(ROOT)/usr/lib/sa
	-mkdir $(ROOT)/usr/adm/sa
	-chown adm $(ROOT)/usr/adm/sa
	-chmod 775 $(ROOT)/usr/adm/sa
	$(INS) -r -f $(ROOT)/usr/lib/sa $(TESTDIR)/sa2
	$(INS) -r -f $(ROOT)/usr/lib/sa $(TESTDIR)/sa1
	$(INS) -r -f $(ROOT)/usr/lib/sa -m 2755 -u bin -g kmem $(TESTDIR)/sadc
	$(INS) -r -f $(ROOT)/usr/bin $(TESTDIR)/sar
	$(INS) -r -f $(ROOT)/usr/bin $(TESTDIR)/timex
	$(INS) -r -f $(ROOT)/usr/bin $(TESTDIR)/sag
	$(INS) -r -f $(ROOT)/usr/bin -m 2755 -u bin -g kmem $(TESTDIR)/sadp

sadc:	sadc.c sa.h 
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sadc sadc.c 
sadp:	sadp.c 
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sadp sadp.c
sar:	sar.c sa.h
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sar sar.c
timex:	timex.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/timex timex.c 
sag:	saga.o sagb.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(TESTDIR)/sag saga.o sagb.o 
saga.o:	saga.c saghdr.h
	$(CC) -c $(CFLAGS) saga.c
sagb.o:	sagb.c saghdr.h
	$(CC) -c $(CFLAGS) sagb.c
sa1:	sa1.sh
	cp sa1.sh sa1
sa2:	sa2.sh
	cp sa2.sh sa2

test:	testai

testbi:	# test for before installing
	sh $(TESTDIR)/runtest new $(SL)/cmd/sa

testai:	# test for after install
	sh $(TESTDIR)/runtest new

clean:
	-rm -f *.o
 
clobber: clean
	-rm -f sadc sar sa1 sa2 sag timex sadp

FRC:
