#
#	@(#)cmd.mk	6.7
#

STRIP = -strip

HDR = ../hdr
HELPLOC = $(ROOT)/usr/lib/help
BIN = $(ROOT)/usr/bin
UCB = $(ROOT)/usr/ucb

LIBS =	../lib/comobj.a	\
	../lib/mpwlib.a	\
	../lib/cassi.a	\
	../lib/libPW.a

CFLAGS = $(CFL)
LDFLAGS = -n -i $(LFL)

ARGS =

C_CMDS = admin	\
	cdc	\
	comb	\
	delta	\
	get	\
	help	\
	prs	\
	rmdel	\
	sact	\
	unget	\
	val	\
	vc	\
	what	\
	sccs

CMDS = $(C_CMDS) \
	sccsdiff

all:	$(LIBS) $(CMDS) help2

admin:	admin.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) admin.o $(LIBS) -o admin

admin.o:	admin.c
	$(CC) -c $(CFLAGS) $(B12) admin.c

cdc:	rmchg
	-ln	rmchg cdc

comb:	comb.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) comb.o $(LIBS) -o comb

comb.o:	comb.c
	$(CC) -c $(CFLAGS) comb.c

delta:	delta.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) delta.o $(LIBS) -o delta

delta.o:	delta.c
	$(CC) -c $(CFLAGS) delta.c

get:	get.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) get.o $(LIBS) -o get

get.o:	get.c
	$(CC) -c $(CFLAGS) get.c

help:	help.o
	$(CC) $(CFLAGS) $(LDFLAGS) help.o -o help

help.o:	help.c
	$(CC) -c $(CFLAGS) help.c

help2:	help2.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) help2.o $(LIBS) -o help2

help2.o: help2.c
	$(CC) -c $(CFLAGS) help2.c

prs:	prs.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) prs.o $(LIBS) -o prs

prs.o:	prs.c
	$(CC) -c $(CFLAGS) $(B12) prs.c
	
rmdel:	rmchg $(LIBS)
	-ln rmchg rmdel

rmchg:	rmchg.o $(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) rmchg.o $(LIBS) -o rmchg

rmchg.o:	rmchg.c
	$(CC) -c $(CFLAGS) rmchg.c

sact:	unget
	-ln unget sact

sccsdiff:	sccsdiff.sh
	-cp sccsdiff.sh sccsdiff

unget:	unget.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) unget.o $(LIBS) -o unget

unget.o:	unget.c
	$(CC) -c $(CFLAGS) unget.c

val:	val.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) val.o $(LIBS) -o val

val.o:	val.c
	$(CC) -c $(CFLAGS) val.c

vc:	vc.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) vc.o $(LIBS) -o vc

vc.o:	vc.c
	$(CC) -c $(CFLAGS) vc.c

what:	what.o	$(LIBS)
	$(CC) $(CFLAGS) $(LDFLAGS) what.o $(LIBS) -o what

what.o:	what.c
	$(CC) -c $(CFLAGS) what.c

sccs:	sccs.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o sccs sccs.c

$(LIBS):
	cd ../lib; $(MAKE) -f lib.mk

install:	all
	$(STRIP) $(C_CMDS)
	$(STRIP) help2
	-chmod 775 $(CMDS) help2
	-chgrp bin $(CMDS) help2
	-chown bin $(CMDS) help2
	-mv $(CMDS) $(BIN)
	-mv $(BIN)/sccs $(UCB)/sccs
	if [ ! -d $(HELPLOC) ] ; then mkdir $(HELPLOC) ; fi
	if [ ! -d $(HELPLOC)/lib ] ; then mkdir $(HELPLOC)/lib ; fi
	-mv help2 $(HELPLOC)/lib

clean:
	-rm -f *.o
	-rm -f rmchg

clobber:	clean
	-rm -f $(CMDS) help2
