/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*    	"@(#)sdb:com/access.c	1.18"   */

/*
 *	UNIX debugger
 */

#include "head.h"
#define STAR	4
#define ISDSP(X)	((datmap.b1 <= X && X < datmap.e1) || \
			 (datmap.b2 <= X && X < datmap.e2) || \
			 (txtmap.b2 <= X && X < txtmap.e2))
#define ISISP(X)	(txtmap.b1 <= X && X < txtmap.e1)
/*
** #define	ISDSP(X)	( ( datmap.b1 <= X && X < datmap.e1 ) || \
**	 			  ( datmap.b2 <= X && X < datmap.e2 ) )
** #define	ISISP(X)	( ( txtmap.b1 <= X && X < txtmap.e1 ) || \
**				  ( txtmap.b2 <= X && X < txtmap.e2 ) )
*/
#define WITHIN(adr, lbd, ubd) ((adr) >= (lbd) && (adr) < (ubd))

extern int wtflag;	

extern MSG		BADDAT;
extern MSG		BADTXT;
extern MAP		txtmap;
extern MAP		datmap;
extern STRING		errflg;
extern int		errno;

extern INT		pid;


/* file handling and access routines */

int dmask[5] = {0, 0xff, 0xffff, 0xffffff, 0xffffffff};

/*
 * getval and putval can be speeded up
 * by checking to see if only one word has to be access'd
 * (which is always the case in the VAX, and in the 3B for d = 'b' or 'c')
 * and by calling access() themselves
 */

/* get data at loc using descriptor format d */
/* value is returned in a long int, right justified.
 */
long
getval(loc, d, space)
ADDR loc;
char *d;
{
	register int val;
	int len ;

#if DEBUG
	if (debugflag == 1)
		enter1("getval");
	else if (debugflag == 2)
	{
		enter2("getval");
		arg("loc");
		printf("0x%x",loc);
		comma();
		arg("d");
		printf("0x%x",d);
		comma();
		arg("space");
		printf("0x%x",space);
		closeparen();
	}
#endif
	val = get (loc, space);
#ifndef hcx
	val &= dmask[dtol(*d)];
#else
   /*   right justify value        chela */
        len = dtol(*d) ;
        if (len < WORDSIZE) /* If len is 4 or 8 dont need to shift */
           val >>= (WORDSIZE - dtol(*d))*8 ; /* chela */
#endif
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("getval");
		printf("0x%x",val);
		endofline();
	}
#endif
	return (val);

}

/* put value at loc using descriptor format d */
 
putval(loc, d, value)
ADDR loc;
char *d;
long value;
{
	register int val;

#if DEBUG
	if (debugflag == 1)
		enter1("putval");
	else if (debugflag == 2)
	{
		enter2("putval");
		arg("loc");
		printf("0x%x",loc);
		comma();
		arg("d");
		printf("0x%x",d);
		comma();
		arg("value");
		printf("0x%x",value);
		closeparen();
	}
#endif
	val = get (loc,DSP);
	val = (val & !dmask[dtol(*d)]) | (value & dmask[dtol(*d)]);
	put(loc, DSP, val);
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("putval");
		endofline();
	}
#endif
}

/*	get value from named register (r0 is 0) using descriptor format d */
/*	getreg may be called to get a value that is in a register or in
 *	the image of a register on the stack.  ISREGN(reg) is used to
 *	determine whether the address given is a register.  This routine
 *	is important for the 3B, where register data is right justified,
 *	while all other data is left justified.
 *
 *	call getreg if ISREGV(sl_class).
 */
long
getreg(reg, d)
ADDR reg;
char *d;
{
	register long part;

#if DEBUG
	if (debugflag == 1)
		enter1("getreg");
	else if (debugflag == 2)
	{
		enter2("getreg");
		arg("reg");
		printf("0x%x",reg);
		comma();
		arg("d");
		printf("0x%x",d);
		closeparen();
	}
#endif
	if (ISREGN(reg)) 
		part = uw[R0+reg];
	
	part = getval(reg, d, DSP);
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("getreg");
		printf("0x%x",part);
		endofline();
	}
#endif
	return part;
}

putreg(reg, d, value)
ADDR reg;
char *d;
long value;
{
	register long val;

#if DEBUG
	if (debugflag == 1)
		enter1("putreg");
	else if (debugflag == 2)
	{
		enter2("putreg");
		arg("reg");
		printf("0x%x",reg);
		comma();
		arg("d");
		printf("0x%x",d);
		comma();
		arg("value");
		printf("0x%x",value);
		closeparen();
	}
#endif
	if (ISREGN(reg))
	{
		val = uw[R0+reg];
		val = (val & !dmask[dtol(*d)]) | (value & dmask[dtol(*d)]);
		uw[R0+reg] = val;
	}
	else
		put (reg, DSP, value);
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("putreg");
		endofline();
	}
#endif
}

/* get (adr, space) - simply returns the value of a word starting
 *		at adr.  If there is a left justified value, it
 *		is left for the calling routine (getval) to extract it.
 */
POS
get(adr, space)
L_INT	adr;
{
	register long value;

#if DEBUG
	if (debugflag == 1)
		enter1("get");
	else if (debugflag == 2)
	{
		enter2("get");
		arg("adr");
		printf("0x%x",adr);
		comma();
		arg("space");
		printf("0x%x",space);
		closeparen();
	}
#endif
	value = access(RD, adr, space, 0);
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("get");
		printf("0x%x",value);
		endofline();
	}
#endif
	return (value);
}

/* put(adr, space, value) - simply puts the value into the word starting
 *			at address adr.  All shifting, masking, or'ing,
 *			etc. must have already been done.
 */
put(adr,space,value)
L_INT	adr;
{
#if DEBUG
	if (debugflag == 1)
		enter1("put");
	else if (debugflag == 2)
	{
		enter2("put");
		arg("adr");
		printf("0x%x",adr);
		comma();
		arg("space");
		printf("0x%x",space);
		comma();
		arg("value");
		printf("0x%x",value);
		closeparen();
	}
#endif
	access(WT, adr, space, value);
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("put");
		endofline();
	}
#endif
}

static
access(mode,adr,space,value)
L_INT	adr;
{
	REG INT	pmode, rd, file;
	ADDR	w;
	register long sadr = adr;


#if DEBUG
	if (debugflag == 1)
		enter1("access");
	else if (debugflag == 2)
	{
		enter2("access");
		arg("mode");
		printf("0x%x",mode);
		comma();
		arg("adr");
		printf("0x%x",adr);
		comma();
		arg("space");
		printf("0x%x",space);
		comma();
		arg("value");
		printf("0x%x",value);
		closeparen();
	}
#endif
	if (space == NSP) 
	{
#if DEBUG
		if (debugflag == 1)
			exit1();
		else if (debugflag == 2)
		{
			exit2("access");
			printf("0x%x",0);
			endofline();
		}
#endif
		return(0);
	}

	rd = mode==RD;
	errno = 0;
	errflg = (STRING)0;

	if (pid) {		/* tracing on ? */
	     pmode = (space&DSP ? (rd?RDUSER:WDUSER) : (rd?RIUSER:WIUSER));
	     w = ptrace(pmode, pid, adr, value);
	     if (errno && (w == -1)) {
	     	  errflg = (space&DSP ? BADDAT : BADTXT);
		  chkerr();	/*  omit error checking elsewhere now ?? */
	     }
#if DEBUG
		if (debugflag == 1)
			exit1();
		else if (debugflag == 2)
		{
			exit2("access");
			printf("0x%x",w);
			endofline();
		}
#endif
	     return(w);
	}

	/* if address in a.out, write a.out, unless 'core' file is */ 
	/*	really system file					*/
	if (!rd && cmd == '!' && space == DSP && chkmap(&adr,ISP)) {
		if (datmap.ufd < 0) space = ISP;	/* no core */
		else {
			extern int magic;
			if (magic == u.u_exdata.ux_mag)
				space = ISP;	/*  really core file */
		}
	}
	file = (space&DSP ? datmap.ufd : txtmap.ufd);
	adr = sadr;		/* chkmap() overwrites adr */
	if   (!chkmap(&adr,space)) {
		errflg = file > 0 ?		
			(space&DSP ? BADDAT : BADTXT) :
			("No process and/or no file");
		chkerr();	
	}
	w = 0;

	/* need -w flag to write a.out(core ?);  added error message(s) */
	/*  rearranged code to perform checks before writing file	     */
	if(file < 0) {
		errflg = "No process and/or no file.";
	}
	else if (!rd && !wtflag) {
		errflg = "Need -w flag to write a file.";
	}
	else {
		int badflag = 0;
		if (space & DSP) {
			if ((lseek(file, (long)adr, 0) == -1) ||
			    ((rd ?
				read(file,&w,sizeof(w)) :
				write(file,&value,sizeof(w))) < sizeof(w))
			)
				badflag = 1;
		}
		else {	/* ISP */
			extern long curoffs;	/* defined in symt.c */
			if (adr != curoffs &&
				(blseek(&sbuf, (long)adr, 0) == -1))
				badflag = 1;
			else if ((rd ?
				bread(&sbuf,&w,sizeof(w)) :
				write(file,&value,sizeof(w))) < sizeof(w))
					badflag = 1;
			if (badflag || !rd) curoffs = ERROR-1;
			else curoffs = (long)adr + sizeof(w);
		}
		if (badflag) {
			fprintf(FPRT1, "Cannot %s file '%s` [%s].\n",
				rd ? "read" : "write",
				space & DSP ? corfil : symfil,
				(space&DSP ? BADDAT : BADTXT));
			if(!rd && (space & DSP))
				fprintf(FPRT1,
				"Must be stopped at a breakpoint.\n");
		}
	}
	chkerr();	
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("access");
		printf("0x%x",w);
		endofline();
	}
#endif
	return(w);
}

static
chkmap(adr,space)
REG L_INT	*adr;
REG INT		space;
{
	REG MAPPTR amap;

#if DEBUG
	if (debugflag == 1)
		enter1("chkmap");
	else if (debugflag == 2)
	{
		enter2("chkmap");
		arg("*adr");
		printf("0x%x",*adr);
		comma();
		arg("space");
		printf("0x%x",space);
		closeparen();
	}
#endif
	amap=((space&DSP?&datmap:&txtmap));
	if ((space & STAR) || (!WITHIN(*adr, amap->b1, amap->e1))) {
		if (WITHIN(*adr, amap->b2, amap->e2)) {
			*adr += (amap->f2) - (amap->b2);
		}
		else {
#if DEBUG
			if (debugflag == 1)
				exit1();
			else if (debugflag == 2)
			{
				exit2("chkmap");
				printf("0x%x",1);
				endofline();
			}
#endif
			return(0);	/* errflg set in access() */
		}
	}
	else {
		*adr += (amap->f1) - (amap->b1);
	}
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("chkmap");
		printf("0x%x (*adr == %#x)",1,*adr);
		endofline();
	}
#endif
	return(1);
}

POS
chkget(n, space)
L_INT		n;
{
	REG L_INT	w;

#if DEBUG
	if (debugflag == 1)
		enter1("chkget");
	else if (debugflag == 2)
	{
		enter2("chkget");
		arg("n");
		printf("0x%x",n);
		comma();
		arg("space");
		printf("0x%x",space);
		closeparen();
	}
#endif
	w = get(n, space);
	chkerr();
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("chkget");
		printf("0x%x",w);
		endofline();
	}
#endif
	return(w);
}

POS
bchkget(n, space)
L_INT		n;
{
	return (byte (chkget (n, space)));
}

