/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*    	"@(#)sdb:com/setup.c	1.27"   */

/*
 *	UNIX debugger
 *
 * 		Everything here is MACHINE DEPENDENT
 *			and operating system dependent
 */

#include "head.h"
#include "coff.h"

extern MSG		BADMAGN;

INT	wtflag = 0;	/* set to allow writing to a.out, core, ISP */

static L_INT		txtsiz;
static L_INT		datsiz;
static L_INT		datbas;
static L_INT		stksiz;
static L_INT		symbas;		/*  not using ?? */
static L_INT		entrypt;

extern INT		argcount;
extern INT		signo;
extern INT		magic;
extern int		errno;

extern STRING		symfil;
extern STRING		corfil;

#define AOUTHDRSIZ	(filhdr.f_opthdr)

#define	maxfile		(1L<<24)

FILHDR	filhdr;		/* a.out file header */
AOUTHDR	aouthdr;	/* a.out Unix (optional) header */
SCNHDR	*scnhdrp;	/* pointer to first section header (space by sbrk) */
int		hcnt,txt,dat;

setsym()
{
	int	i;
#if DEBUG
	if (debugflag == 1)
		enter1("setsym");
	else if (debugflag == 2)
	{
		enter2("setsym");
		closeparen();
	}
#endif
	fsym = getfile(symfil,1);
	txtmap.ufd = fsym;
	errno = 0;
	if (read(fsym,&filhdr,FILHSZ) == FILHSZ	&&
	   ISMAGIC(filhdr.f_magic)		&&
	   AOUTHDRSIZ == sizeof aouthdr		&&
	   read(fsym, &aouthdr, AOUTHDRSIZ)==AOUTHDRSIZ)
	{
		magic=aouthdr.magic;
		if (magic==OMAGIC   || 	/* Writable text: private */
		    magic==PMAGIC   ||	/* Paging text: private.  */
		    magic==NMAGIC)	/* Readonly text: private */
		{
			txtsiz=aouthdr.tsize;
			datsiz=aouthdr.dsize + aouthdr.bsize;
			symbas=txtsiz+datsiz;
			hcnt = rdschdrs();
			for (i = 0 ; i < hcnt ; i++ )
			{
				if (strcmp(scnhdrp[i].s_name,".text")==0)
				{
					txt = i;
				}
				else if (strcmp(scnhdrp[i].s_name,".data")==0)
				{
					dat = i;
				}
			}

			switch (magic) {
			/*  use to have many more "magic" cases here */
			/*	assuming text is first section */

			case OMAGIC:	/* 0407 */
				txtmap.b1=0;
				txtmap.e1=txtmap.b1 + symbas;
				txtmap.b2=datbas=scnhdrp[0].s_paddr;
				txtmap.f1=scnhdrp[txt].s_scnptr;
				txtmap.e2=symbas;
				txtmap.f2=txtmap.f1;
				break;

			case PMAGIC:	/* 0413 */
			case NMAGIC:	/* 0410 */
				txtmap.b1=0;
				txtmap.e1=txtmap.b1 + txtsiz;
				txtmap.f1=scnhdrp[txt].s_scnptr;
				txtmap.b2=datbas=scnhdrp[dat].s_vaddr;
				txtmap.e2=datbas+datsiz;
				txtmap.f2=txtmap.f1+txtmap.e1;
				break;

			}
			entrypt = aouthdr.entry;
			ststart = filhdr.f_symptr;
		}
		else {
			magic = 0;
			fprintf(FPRT1, "Warn: No magic for %s;\n", symfil);
		}
	}
	else {		/*  may be a ".o" file */
		if (ISMAGIC(filhdr.f_magic))
		{
			magic = filhdr.f_magic;
			hcnt = rdschdrs();
			for (i = 0 ; i < hcnt ; i++ )
			{
				if (strcmp(scnhdrp[i].s_name,".text")==0)
				{
					txt = i;
				}
				else if (strcmp(scnhdrp[i].s_name,".data")==0)
				{
					dat = i;
				}
			}
			txtsiz = scnhdrp[txt].s_size;
			datsiz = scnhdrp[dat].s_size;
			symbas = txtsiz+datsiz;
			txtmap.b1 = 0;
			txtmap.e1 = txtsiz;
			txtmap.f1 = scnhdrp[txt].s_scnptr;
			txtmap.b2 = datbas = scnhdrp[txt].s_paddr;
			txtmap.e2 = txtsiz+datsiz;
			txtmap.f2 = scnhdrp[dat].s_scnptr;
			entrypt = 0;
			ststart = filhdr.f_symptr;
		}
	}
	if (magic == 0)
	{
		txtmap.e1 = maxfile;
	}
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("setsym");
		endofline();
	}
#endif
}

setcor()
{
#if DEBUG
	if (debugflag == 1)
		enter1("setcor");
	else if (debugflag == 2)
	{
		enter2("setcor");
		closeparen();
	}
#endif
	datmap.ufd = fcor = getfile(corfil,2);
	if(fcor < 0)
	{
#if DEBUG
		if (debugflag == 1)
			exit1();
		else if (debugflag == 2)
		{
			exit2("setcor");
			endofline();
		}
#endif
		return;
	}
	   /*  sure a core file */
	if (read(fcor, &u, XTOB(UPAGES))==XTOB(UPAGES)
	   && magic
	   && magic == u.u_exdata.ux_mag
	   )
	{

		signo = u.u_arg[0]&017;
		txtsiz = XTOB(u.u_tsize);
		datsiz = XTOB(u.u_dsize);
		stksiz = XTOB(u.u_ssize);
		if( magic == NMAGIC || magic == PMAGIC )
		{
			datmap.b1=datbas= (magic == PMAGIC ? txtsiz:
				round (txtsiz, PAGSIZ));
		}
		else
		{
			datmap.b1=datbas=0;
		}
		datmap.e1=(magic==OMAGIC?txtsiz:datmap.b1)+datsiz;
		datmap.f1 = XTOB(UPAGES);
		datmap.b2 = MAXSTOR - stksiz;
		datmap.e2 = MAXSTOR;
		if( magic == NMAGIC || magic == PMAGIC )
		{
			datmap.f2 = XTOB( UPAGES ) + datsiz;
		}
		else
		{
			datmap.f2 = XTOB( UPAGES ) + datmap.e1;
		}

	}
	else		/*  e.g. /dev/kmem or any ordinary file */
	{
		datmap.e1 = datmap.e2 = maxfile;
		datmap.b1 = datmap.f1 = 0;
		datmap.b2 = datmap.f2 = 0;
		fprintf(FPRT1, "Warning: `%s' not a core file.\n", corfil);
		fakecor = 1;
	}
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("setcor");
		endofline();
	}
#endif
}

create(f)
STRING	f;
{	int fd;

#if DEBUG
	if (debugflag == 1)
		enter1("create");
	else if (debugflag == 2)
	{
		enter2("create");
		arg("f");
		printf("\"%s\"",f);
		closeparen();
	}
#endif
	if ((fd=creat(f,0644)) >= 0) {
		close(fd);
		fd = open(f,wtflag);
	}
	fd = -1;
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("create");
		printf("0x%x",fd);
		endofline();
	}
#endif
	return (fd);
}

getfile(filnam,cnt)
STRING	filnam;
{
	REG INT		fd;

#if DEBUG
	if (debugflag == 1)
		enter1("getfile");
	else if (debugflag == 2)
	{
		enter2("getfile");
		arg("filnam");
		printf("\"%s\"",filnam);
		comma();
		arg("cnt");
		printf("0x%x",cnt);
		closeparen();
	}
#endif
	if (!eqstr("-",filnam))
	{
		fd=open(filnam,wtflag);
		if (fd<0 && argcount>cnt)
		{
			if (fd < 0)
			{
				fprintf(FPRT1, "cannot open `%s'\n", filnam);
			}
		}
	}
	else
	{
		fd = -1;
	}
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("getfile");
		printf("0x%x",fd);
		endofline();
	}
#endif
	return(fd);
}

/* rdschdrs(): read section headers */
rdschdrs()
{
	register unsigned nb;
	extern FILHDR filhdr;		/* a.out file header */

#if DEBUG
	if (debugflag == 1)
		enter1("rdschdrs");
	else if (debugflag == 2)
	{
		enter2("rdschdrs");
		closeparen();
	}
#endif
	nb = filhdr.f_nscns * SCNHSZ;
	scnhdrp = (SCNHDR *) sbrk(nb);
	if (read(fsym, scnhdrp, nb) != nb)
		fprintf(FPRT1, "Warn: section header read error\n");
#if DEBUG
	if (debugflag == 1)
		exit1();
	else if (debugflag == 2)
	{
		exit2("rdschdrs");
		printf("0x%x",filhdr.f_nscns);
		endofline();
	}
#endif
	return(filhdr.f_nscns);
}
