#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#	"@(#)sdb:sdb.mk	1.20"     

##	makefile for sdb
BINDIR=$(ROOT)/bin
CFLAGS = $(CFL)
LFLAGS = $(LFL)
TESTDIR = .
INSDIR = $(ROOT)/usr/bin
INS = /etc/install -r -f $(INSDIR)
FLEX = -DFLEXNAMES
#		Hardware:	(not using)
#			vaxsdb - sdb for DEC VAX-11 
#			3b20sdb - sdb for BELL 3B20
#		Operating Systems:	(not using)
#			VAX135 - Department 1353; Bell Labs
#			UCBVAX - VM/UNIX 3.x and beyond Berkeley version
#			VFORK - Use vfork call of VM/UNIX Berkeley version
#		---->	STD - UNIX/32V, VM/UNIX 2.n, UNIX/TS, PWB UNIX, U3B
#	VM/UNIX 3.x uses new trap format which is shared with
#		VAX135 systems (head.h, setup.h).
##	-DDEBUG[=1]:	original sdb debugging.
##	-DDEBUG=2:	more robust debugging.
##	-DFLEXNAMES	is put on the cc line for 6.0 flexnames.
##	Now contains dependencies on /usr/include files.


#Depends on make_all, not sdb and libg.a, so that cd and make not done twice
all:	make_all

make_all:
	cd machine ; \
	$(MAKE) -f makefile CFLAGS="$(CFLAGS)" FLEX="$(FLEX)" TESTDIR="$(TESTDIR)" 

sdb:
	cd machine ; \
	$(MAKE) -f makefile CFLAGS="$(CFLAGS)" FLEX="$(FLEX)" TESTDIR="$(TESTDIR)" \
	../sdb 

libg.a:
	cd machine ; \
	$(MAKE) -f makefile CFLAGS="$(CFLAGS)" FLEX="$(FLEX)" TESTDIR="$(TESTDIR)" \
	../libg.a 

install:
	cd machine ; \
	$(MAKE) -f makefile CFLAGS="$(CFLAGS)" FLEX="$(FLEX)" TESTDIR="$(TESTDIR)" \
	INSDIR="$(INSDIR)" install

clean :
	cd machine ; \
	$(MAKE) -f makefile TESTDIR="$(TESTDIR)" clean

clobber:
	cd machine ; \
	$(MAKE) -f makefile TESTDIR="$(TESTDIR)" clobber
