#
#  Sendmail
#  Copyright (c) 1983  Eric P. Allman
#  Berkeley, California
#
#  Copyright (c) 1983 Regents of the University of California.
#  All rights reserved.  The Berkeley software License Agreement
#  specifies the terms and conditions for redistribution.
#
#	@(#)Makefile.m4	5.5 (Berkeley) 8/15/85
#
#
#  SENDMAIL Makefile.

.UNIVERSE=ucb
LIBS=	-ldbm

OBJS1=	conf.o main.o collect.o parseaddr.o alias.o deliver.o \
	savemail.o err.o readcf.o stab.o headers.o recipient.o \
	stats.o daemon.o usersmtp.o srvrsmtp.o queue.o \
	macro.o util.o clock.o trace.o envelope.o
OBJS2=	sysexits.o arpadate.o convtime.o
OBJS=	$(OBJS1) $(OBJS2)

SRCS1=	conf.h sendmail.h \
	conf.c deliver.c main.c parseaddr.c err.c alias.c savemail.c \
	sysexits.c util.c arpadate.c version.c collect.c \
	macro.c headers.c readcf.c stab.c recipient.c stats.c daemon.c \
	usersmtp.c srvrsmtp.c queue.c clock.c trace.c envelope.c
SRCS2=	TODO convtime.c
SRCS=	Version.c $(SRCS1) $(SRCS2)

ALL=	sendmail rmail

CHOWN=	-echo chown
CHMOD=	chmod
O=	-O
COPTS=
CCONFIG= -DVMUNIX
CFLAGS=	$O $(COPTS) $(CCONFIG) $(CFL)
AR=	-ar
ARFLAGS=rvu
LINT=	lint
XREF=	ctags -x
CP=	cp
MV=	mv
INSTALL=install
M4=	m4
TOUCH=	touch
ABORT=	false

OBJMODE=755

.c.o:
	$(CC) -c $(CFLAGS) $*.c

all: $(ALL)

sendmail: $(OBJS1) $(OBJS2) Version.o
	$(CC) $(CFLAGS) $(LFL) -o sendmail Version.o $(OBJS1) $(OBJS2) $(LIBS)
	$(CHMOD) $(OBJMODE) sendmail

rmail: rmail.o
	$(CC) $(CFLAGS) $(LFL) -o rmail rmail.o
	$(CHMOD) $(OBJMODE) rmail

install: all
	$(INSTALL) -m 4755 -u root -f $(ROOT)/usr/lib sendmail
	ln -f $(ROOT)/usr/lib/sendmail $(ROOT)/usr/bin/mailq
	ln -f $(ROOT)/usr/lib/sendmail $(ROOT)/usr/bin/newaliases

	$(INSTALL) -f $(ROOT)/bin rmail

	$(INSTALL) -m  644 -f $(ROOT)/usr/lib sendmail.cf
	$(INSTALL) -m  644 -f $(ROOT)/usr/lib sendmail.cf.sub
	$(INSTALL) -m  644 -f $(ROOT)/usr/lib sendmail.hf

	$(CP) /dev/null $(ROOT)/usr/lib/sendmail.fc
	chgrp bin $(ROOT)/usr/lib/sendmail.fc
	chown bin $(ROOT)/usr/lib/sendmail.fc

	-mkdir $(ROOT)/usr/spool/mqueue
	chmod 777 $(ROOT)/usr/spool/mqueue
	chgrp bin $(ROOT)/usr/spool/mqueue
	chown bin $(ROOT)/usr/spool/mqueue

	$(CP) /dev/null $(ROOT)/usr/spool/mqueue/syslog
	chmod 644 $(ROOT)/usr/spool/mqueue/syslog
	chgrp bin $(ROOT)/usr/spool/mqueue/syslog
	chown bin $(ROOT)/usr/spool/mqueue/syslog

$(OBJS1): sendmail.h
$(OBJS): conf.h

sendmail.h util.o: useful.h

#
#  Auxiliary support entries
#
clean:
	rm -f core a.out
	rm -f *.o

clobber: clean
	rm -f $(ALL)

print: $(SRCS)
	@ls -l | pr -h "sendmail directory"
	@$(XREF) *.c | pr -h "cross reference listing"
	@size *.o | pr -h "object code sizes"
	@pr Makefile *.h *.[cs]

lint:
	$(LINT) $(CCONFIG) $(SRCS1)
