static char ID[] = "@(#) codeout.c: 1.5 3/10/83";
#include <stdio.h>
#include "systems.h"
#include "symbols.h"
#include "codeout.h"
#include "gendefs.h"
#include <sys/types.h>
#include <sys/stat.h>

long	newdot;

FILE	*fdcode;

extern FILE
	*fdsect,
	*fdlist;         /* object listing file */

extern short liston;     /* flag to indicate if object listing is desired */
#define outbuf_size 40   /* size of output line header */
#define repeat_short_space 0x7ff0 / BITSPBY   /* number of repeats in a short */
char *infile;            /* name of source input file */

extern symbol *dot;


extern symbol symtab[];


#if DCODGEN /* direct code generation of arbitrary number of bytes */


codgen(nbits, val)
	register short nbits;
	long val;
{
	if (nbits)
	   {
		if (nbits % BITSPBY)
			aerror("illegal code generation");
		newdot += nbits / BITSPBY;
		val <<= (sizeof(long)-sizeof(int))*BITSPBY;
		fwrite((char *)&val,(nbits/BITSPBY),1,fdsect);
	   }
}

/*   simplify codgen for .space directives                 */

spcodgen(nbits, val)
	register short nbits;
	char *val;
{
		newdot += nbits / BITSPBY;
		fwrite(val,(nbits/BITSPBY),1,fdsect);
}

#else

static short
	poscnt = 0,
	bitpos = 0;

static OUTWTYPE	outword;
static int mask[] = { 0, 1, 3, 7,
		017, 037, 077,
		0177, 0377, 0777,
		01777, 03777, 07777,
		017777, 037777, 077777,
		0177777 };
codgen(nbits, val)
	register short nbits;
	long val;
{
	register short size;
	register long value;

start:	if (nbits)
	{
		value = val;
		if ((size = BITSPOW - poscnt) > nbits)
			size = nbits;
		value >>= nbits - size;
		value &= mask[size];
		value <<= BITSPOW - poscnt - size;
		outword |= (OUTWTYPE)value;
		poscnt += size;
		bitpos += size;
		newdot += bitpos / BITSPBY;
		bitpos %= BITSPBY;
		if (poscnt == BITSPOW)
		{
			poscnt = 0;
			OUT(outword,fdsect);
			outword = 0;
			if (nbits > size)
			{
				nbits -= size;
				goto start;
			}
		}
	}
}
#endif

extern int (*(modes[]))();

extern upsymins *lookup();

extern short sttop;

#define inbuf_size 2048                  /* size of source input line */
char inbuf [inbuf_size];                 /* source input line */
char outbuf[outbuf_size];                /* output line header */
int outbuf_off;                          /* current offset into output buffer */
short output_code_type;	                 /* code type -- TEXT or DATA */
int list_pc;                             /* current program counter for listing */
short multlineflag ;    /* flag to indicate if >1 listing lines for statement */

codout(file,start,type)
	char *file;
	long start;
	short type;
{
	codebuf code;
	register symbol *sym;

        int ii;                          /* loop counter */
	static int first_line;           /* flag to indicate first source line */
	FILE *fdin;                      /* source input file descriptor */
        extern char inbuf [inbuf_size];  /* source input line */
        extern char outbuf[outbuf_size]; /* output line header */
        extern int outbuf_off;           /* current offset into output buffer */
        extern short output_code_type;   /* code type -- TEXT or DATA */
        extern int list_pc;              /* current program counter for listing */
        extern short multlineflag ;      /* flag to indicate >1 output lines */
        long mod;                        /* modulus for .align operand */
        long repeat_count;               /* # of times to repeat output */
	struct stat statbuf;

	dot = (*lookup(".",INSTALL,USRNAME)).stp;
	dot->value = newdot = start;
	dot->styp = type;
	if ((fdcode = fopen(file, "r")) == NULL)
		aerror("Unable to open temporary file");
	stat (file, &statbuf);
  	setvbuf(fdcode, (char *)NULL, _IOFBF, statbuf.st_blksize);

	first_line = 1;       /* indicate first source line is to be read */
	outbuf_off = 0;       /* initialize output buffer offset */
	list_pc = 0;          /* initialize the listing program counter */
#ifndef DCODGEN
	poscnt = 0;
#endif

	while (fread((char *)(&code),sizeof(code),1,fdcode) == 1)
        {

        if (code.crepeat)                   /* if output to be repeated */
           repeat_count = code.crepeat;
        else                                /* output it just once */
           repeat_count = 1;

#if HCX7
		if (code.cindex < 0)
			sym = (symbol*)(-code.cindex);
		else
			sym = (symbol*)(code.cindex);
#else
		sym = code.cindex ? (symtab + (code.cindex-1))
				: (symbol *) NULL;
#endif
		if (code.caction > NACTION)
			aerror("Invalid action routine");
		else if (code.caction != 0)
			(*(modes[code.caction]))(sym,&code);

           	if (liston && (code.caction == NEWSTMT))  /* new statement */
                {
             	   if (first_line)                 /* For first source line, */
	           {
	              fdin = fopen(infile,"r");    /* open the source file,  */
	              stat (infile, &statbuf);
  	              setvbuf(fdin, (char *)NULL, _IOFBF, statbuf.st_blksize);
	              fseek (fdin, 0, 0);          /* and rewind it.         */
                      first_line = 0;              /* Turn off the flag.     */
                      outbuf[0] = ' ';             /* carriage control blank */
                   }
                   else                            /* For successive lines,  */
                   {
                      for (ii=outbuf_off; ii<=39; ii++)  /* blank out the    */
                         outbuf[ii]=' ';           /* remainder of header, & */
                      print_list_line (outbuf, inbuf);   /* output the last line.  */
                   }

                   multlineflag = 0;             /* Turn off >1 output lines */
                   ii = fseek (fdin, (int)code.clineoff+1, 0); /* Find source line */
                   fgets (&inbuf[0], 2048, fdin);   /* Read the source line. */
                   sprintf (&outbuf[1], "%5d", code.cvalue);  /* Put in the  */
                   outbuf[6] = ' ';                           /* line number.*/
                   outbuf[7] = ' ';
                   sprintf (&outbuf[8], "%08x", list_pc);   /* Put in the    */
                   outbuf[16] = ' ';                      /* current program */
                   outbuf[17] = ' ';                      /* counter value.  */
                   outbuf_off = 18;  /* Output memory layout at position 18. */
                }

		if (repeat_count > 1)    /* .space directive                 */
		{
			int i, j, k, l, n;
	    		int o = 0;       /* first group in statement         */
			static char *m;  /* array of repeated values         */
	    		static int first_malloc = 1;
			i = repeat_short_space;  /* number of repeats in a short */
			l = (repeat_count+(i-1)) / i;    /* number of repeat groups  */

			while (l--)      /* go through number of groups      */
			{
			        if (repeat_count < i)
			           j = repeat_count;
			        else
			           j = i;
	    			if (first_malloc)  /* allocate working array */
	    			{
	     				first_malloc = 0;    /* alloc'ed     */
	       				m = (char *) malloc (i*BITSPBY);
	       				if (m == NULL)       /* if problems  */
	      				{             /* go back to old way  */
		   				repeat_count = code.crepeat;
		   				break;
	       				}
	    			}
	    			if (o == 0)  /* if first group in statement  */
	       				for (n = 0; n<i; ++n)   /* initialize working array */
	          				m[n] = (char) code.cvalue;
	     			spcodgen((short)(j*BITSPBY),m); /* generate object code */

             			if (liston && o==0)  /* if listing and first group */
             			{
                			if (code.caction == GENALIGN)  /* .align generates no code */
                			{
                   				mod = list_pc % code.cvalue;  /* so update the listing program counter manually */
	           				if (mod != 0)
		      					for (ii = 0; ii < code.cvalue - mod; ii++)
		 	 					list_pc++;
                			}
                			else      /* use nbits to update p.c. */
                   				list_pc += code.crepeat;       /* Update listing progam counter */

                			outbuf_off = print_memory_layout (outbuf, outbuf_off,
                        			code.cvalue, code.cnbits, inbuf, type, code.crepeat);
             			}    /* Put information in object listing  */
             			o++;
             			repeat_count -= j;
			}
		}

        	while (repeat_count--)      /* repeat remainder of data */
        	{
	     		codgen((short)(code.cnbits),code.cvalue); /* Generate object code */

             		if (liston)
             		{
                		if (code.caction == GENALIGN)  /* .align generates no code */
                		{
                   			mod = list_pc % code.cvalue;  /* so update the listing program counter manually */
	           			if (mod != 0)
		      			for (ii = 0; ii < code.cvalue - mod; ii++)
		 	 			list_pc++;
                		}
                		else      /* use nbits to update p.c. */
                   			list_pc += code.cnbits/BITSPBY;  /* Update listing progam counter */

                		outbuf_off = print_memory_layout (outbuf, outbuf_off,
                                         code.cvalue, code.cnbits, inbuf, type,0);
             		}                      /* Put information in object listing  */
        	}
	}

	if (sttop > 0)
		aerror("Unbalanced Symbol Table Entries-Missing Scope Endings");
	fclose(fdcode);
}

/*    Output a line of object listing    */

print_list_line (outbuf, inbuf)
char outbuf[], *inbuf[];
extern short multlineflag;
{
        int i;
        for (i=0; i<=outbuf_size-1; i++)      /* Write out what object header */
  	   fprintf (fdlist, "%c", outbuf[i]); /* info we have, so far         */
  	if (multlineflag)              /* If this is not the first line for   */
  	   fprintf (fdlist, "\n");     /* the statement, nothing more to list */
  	else
  	   fprintf (fdlist, "%s", inbuf); /* else output the source input line */
}


/* Add the ascii representation of memory layout bytes to the output buffer header */

print_memory_layout (outbuf, outbuf_off, value, nbits, inbuf, codetype, spflag)
char outbuf[], inbuf[];           /* output and input buffers                */
int outbuf_off;                   /* current offset into output buffer       */
long value;                       /* value of bits to be output              */
int nbits;                        /* number of bits in value                 */
short codetype;                   /* Text, Data, or Bss                      */
extern short multlineflag;        /* 1 => output spans lines                 */
int spflag;                       /* number of repetitions of value - .space */
{

        static char sequence1 = 'a'; /* sequence for col. 1 of multiple lines */
        static char sequence2 = 'a'; /* sequence for col. 2 of multiple lines */
        int i;

        if (codetype == DAT) outbuf[16] = '*';     /* flag .data code */

        if ( (outbuf_off + (nbits/4)) >= outbuf_size-2 ) /* If no more room   */
        {                                       /* for the memory bytes      */
           outbuf[outbuf_off] = ' ';            /* remove trailing '\0', and */
           print_list_line (&outbuf[0], &inbuf[0]);  /* print what we have.  */
           if ((outbuf[7] = sequence2++) > 'z')     /* If sequence col. 2 is */
           {                                        /* full, bump up col. 1. */
              outbuf[7] = sequence2 = 'a';
              outbuf[6] = ++sequence1;   /* aa, ab, ..., az, ba, ... bz, ... */
           }
           else                          /* no turnover in sequence col. 2   */
              outbuf[6] = sequence1;
           for (i=8; i<=outbuf_size-1; i++)  /* blank out remainder of header */
              outbuf[i] = ' ';
           if (codetype == DAT) outbuf[16] = '*';       /* flag .data code */
           outbuf_off = 18;         /* Continue output at buffer position 18. */
           multlineflag = 1;        /* Indicate >1 output lines for statement */
        }
        else if (!multlineflag)     /* still room for memory bytes           */
           sequence1 = sequence2 = 'a';  /* first line for this statement    */

	if (spflag > 0)             /* for space directive                   */
	{
	   sprintf (&outbuf[outbuf_off], "%-9.08x(%-2.02x)", spflag, (value >> 24) & 0xffL);
	   outbuf[31] = ' ';
	   return (outbuf_off+outbuf_size-1);
	}

        switch (nbits)   /* output nbits/BITSPBPY symbolic bytes of memory   */
        {
           case 8:
	      sprintf (&outbuf[outbuf_off], "%-3.02x", (value >> 24) & 0xffL);
	      return (outbuf_off+3);
           case 16:
	      sprintf (&outbuf[outbuf_off], "%-5.04x", (value >> 16) & 0xffffL);
	      return (outbuf_off+5);
           case 32:
	      sprintf (&outbuf[outbuf_off], "%-9.08x", value);
	      return (outbuf_off+9);
	   case 0:
	      return (outbuf_off);
           case 24:                    /* Is this case possible ?     */
	      sprintf (&outbuf[outbuf_off], "%-7.06x", (value >> 8) & 0xffffffL);
	      return (outbuf_off+7);
	   default:
	      aerror ("Internal error - print_memory_layout - nbits not 0,8,16,24,32");
	}
}
