static char ID[] = "@(#) expand1.c: 1.4 3/10/83";

#include <stdio.h>
#include "systems.h"
#include "symbols.h"
#include "expand.h"
#include "gendefs.h"

extern rangetag range[];
extern char idelta[];
extern char pcincr[];


int maxss = 0;		/* maximum number of Selection set entries */
#define INCSS 20    	/* allocation increment for Selection set entries */
int maxalgn = 0;	/* maximum number of Align statements */
#define INCALGN 40      /* allocation increment for Align statements */
int maxsdi = 0;		/* maximum number of SDI positions */
#define INCSDI 400    	/* allocation increment for SDI positions */
int maxlab = 0;    	/* max. number of labels whose address depends on SDIs */
#define INCLAB 1000  	/* allocation increment for SDI labels array */

char *islongsdi;        /* array of SDI positions */
ssentry *selset;        /* array of Selection set entries */
algnentry *algnset;     /* array of Align statements */
symbol **labset;        /* array of labels whose address depends on SDIs */

unsigned short sdicnt = 0;
static short ssentctr = -1;
static short labctr = -1;
static short keepcount = -1;
static short algnctr = -1;

static unsigned short PCmax;

extern symbol *dot;
extern long newdot;

update(ssptr,sditype)
	ssentry *ssptr;
	short sditype;
{
	register ssentry *ptr;
	register algnentry *algnptr;
	register short cntr;
	register symbol *lptr;
	register symbol **ptr2;
	register unsigned short delta,
		sdipos;
	long instaddr;

	delta = idelta[ssptr->itype];
	sdipos = ssptr->sdicnt;
	instaddr = ssptr->minaddr;
	PCmax -= delta;
	dot->maxval -= delta;

	if (sditype) {	/* nonzero if short */
		instaddr += ssptr->maxaddr;
		for (cntr = ssentctr, ptr = &selset[0]; cntr-- >= 0; ++ptr) {
			if (ptr->sdicnt > sdipos)
				ptr->maxaddr -= delta;
		}
		for (cntr = labctr, ptr2 = labset; cntr-- >= 0; ) {
			lptr = *ptr2;
			if (lptr->value + lptr->maxval > instaddr) {
				lptr->maxval -= delta;
				if (lptr->maxval == 0) {
					*ptr2 = labset[labctr--];
					continue;
				}
			}
			ptr2++;
		}
          }
	  else {	/* long */
		dot->value += delta;
		newdot += delta;
		islongsdi[sdipos] = (char)delta;
		for (cntr = ssentctr, ptr = &selset[0]; cntr-- >= 0; ++ptr) {
			if (ptr->sdicnt > sdipos) {
				ptr->minaddr += delta;
				ptr->maxaddr -= delta;
			}
		}
		for (cntr = algnctr, algnptr = &algnset[0]; cntr-- >= 0; ++algnptr) {
			if (algnptr->minaddr > instaddr) 
				algnptr->minaddr += delta;
		}
		for (cntr = labctr, ptr2 = labset; cntr-- >= 0; ) {
			lptr = *ptr2;
			if (lptr->value > instaddr) {
				lptr->value += delta;
				lptr->maxval -= delta;
				if (lptr->maxval == 0) {
					*ptr2 = labset[labctr--];
					continue;
				}
			}
			ptr2++;
		}
          }
}

/*
 *	"notdone" is used to indicate when pass 1 has been completed.
 *	This helps to detect undefined externals.
 */

static short notdone = YES;


sdiclass(sdiptr)
	register ssentry *sdiptr;
{
	register symbol *lptr;
	register short itype;
	register short ltype;
	register long span;

	lptr = sdiptr->labptr;
	itype = sdiptr->itype;
	if ((ltype = lptr->styp & TYPE) != UNDEF) {
		if (ltype != TXT)
			return(L_SDI);
		span = lptr->value;
	}
	else {
		if (notdone == NO)
			return(L_SDI);
		span = (dot->value != sdiptr->minaddr) ? dot->value :
			sdiptr->minaddr + pcincr[itype];
	}
	span += sdiptr->constant - (sdiptr->minaddr + pcincr[itype]);
	if ((span < range[itype].lbound) ||
		(span > range[itype].ubound))	/* definitely long */
		return(L_SDI);
	else {
		if (ltype != UNDEF) {
			span += (int)(lptr->maxval) -
				((lptr->value > sdiptr->minaddr) ?
				(sdiptr->maxaddr + idelta[itype]) : sdiptr->maxaddr);
			if ((span >= range[itype].lbound) &&
				(span <= range[itype].ubound))	/* definitely short */
				return(S_SDI);
		}
	}
	return(U_SDI);
}

expand()
{
	register short change = YES;
	register short cntr;
	register ssentry *current;
	register algnentry *onealgn;
	register short sditype;

	while (change) {
		change = NO;
		for (cntr = ssentctr, current = &selset[0]; cntr-- >= 0; ) {
			sditype = sdiclass(current);
			if ((sditype == S_SDI) || (sditype == L_SDI))  {
				change = YES;
				update(current,sditype);
				*current = selset[ssentctr--];
			}
			  else
				current++;
		}
	}

	if (notdone == NO)
	  for (cntr = algnctr, onealgn = &algnset[0]; cntr-- >= 0; ++onealgn ) {
				up_align(onealgn);
	  }
}


newlab(sym)                       /* create a new SDI label entry   */
	register symbol *sym;
{
        char *malloc();
        char *realloc();

	if (++labctr == maxlab)   /* if at end of array             */
	   if (maxlab == 0)       /* if array doesn't yet exist     */
	   {
	      maxlab = INCLAB;    /* allocate the initial increment # of entries */
	      if ((labset = (symbol **) malloc (INCLAB*4)) == NULL)
	    	aerror("Label Table overflow: run assembler without optimization");
	   }
	   else                   /* expand the current array       */
	      if ((labset = (symbol **) realloc(labset,(maxlab += INCLAB)*4)) == NULL)
	    	aerror("Label Table overflow: run assembler without optimization");

	labset[labctr] = sym;     /* add the new sdi label to array */
	keepcount = labctr;       /* remember the current pointer   */
}

deflab(sym)
	register symbol *sym;
{
	sym->maxval = PCmax;
	newlab(sym);
	expand();
}

#if !ONEPROC
extern FILE *fdlong;
#endif

fixsyms()
{
	notdone = NO;
	expand();
#if !ONEPROC
/*
    HCX does not compile the next line.  If ONEPROC ever changes,
    a table overflow test should be included here.
*/
	fwrite(islongsdi,sizeof(*islongsdi),(int)(++sdicnt),fdlong);
#endif
}

sdi(sym,const,itype)
	register symbol *sym;
	long const;
	register short itype;
{
	register long span;

	if (sym) {
		if ((sym->styp & TYPE) == UNDEF)
			return(U_SDI);
		if ((sym->styp & TYPE) != TXT)
			return(L_SDI);
	}
	else
		return(L_SDI);

	span = sym->value + const - (dot->value + pcincr[itype]);
	if ((span < range[itype].lbound) ||
		(span > range[itype].ubound))	/* definitely long */
		return(L_SDI);
	else {
		/*
		 *	Now determine if the instruction is definitely
		 *	short. This calculation is different from the
		 *	similar calculation in "sdiclass" since, as an
		 *	optimization, the long form of the instruction
		 *	is not included in the calculation. This prevents
		 *	determining that the size of an instruction
		 *	is uncertain based on its maximum length. Note
		 *	any previous uncertain instruction lengths
		 *	are reflected by "dot->maxval".
		 */
		span += (long)((int)(sym->maxval) - dot->maxval);
		if ((span >= range[itype].lbound) &&
			(span <= range[itype].ubound))	/* definitely short */
			return(S_SDI);
	}
	return(U_SDI);
}

newsdi(sym,const,itype)
	register symbol *sym;
	long const;
	short itype;
{
	register ssentry *nsdi;
	static short
		sdiwarn = YES,
		selwarn = YES;
        char *malloc();
        char *realloc();
        int i;

	if (++sdicnt == maxsdi)     /* if at end of array             */
      	   if ((islongsdi = realloc(islongsdi,(maxsdi += INCSDI))) == NULL)
	      aerror("SDI Table overflow: run assembler without optimization");
	   else
              for (i=sdicnt; i<maxsdi; ++i)
                 islongsdi[i] = 0;

	if (++ssentctr == maxss)    /* if at end of array             */
	   if (maxss == 0)          /* if array doesn't yet exist     */
	   {
	      maxss = INCSS;    /* allocate the initial increment # of entries */
	      if ((selset = (ssentry *) malloc (INCSS*sizeof(ssentry))) == NULL)
	    	aerror("Selection Set Table overflow: run assembler without optimization");
	   }
	   else                   /* expand the current array       */
      	      if ((selset = (ssentry *) realloc(selset,(maxss += INCSS)*sizeof(ssentry))) == NULL)
	    	aerror("Selection Set Table overflow: run assembler without optimization");

	nsdi = &selset[ssentctr];
	nsdi->sdicnt = sdicnt;
	nsdi->itype = itype;
	nsdi->minaddr = dot->value;
	nsdi->maxaddr = PCmax;
	nsdi->constant = const;
	nsdi->labptr = sym;
}
shortsdi(sym,const,itype)
	register symbol *sym;
	long const;
	register short itype;
{
	register int sditype;

	if (sym && ((sym->styp & TYPE) == UNDEF)) {
		if (dot->styp != TXT)
			return(L_SDI);
			sditype = U_SDI;
		newsdi(sym,const,itype);
		PCmax += idelta[itype];
		dot->maxval = PCmax;
	}
	else {
		if ((sditype = sdi(sym,const,itype)) == U_SDI) {
			if (dot->styp != TXT)
				return(L_SDI);
			if (dot == sym) {
				sditype = S_SDI;
				goto ret;
			}
			newsdi(sym,const,itype);
			PCmax += idelta[itype];
			dot->maxval = PCmax;
		}
	}
ret:	if (ssentctr > 0)
		expand();
	return(sditype);
}


jalign (val)
long val;
{

	newalgn (val);
	PCmax += val;
	dot->maxval = PCmax;
	generate (0, GENALIGN, val, NULLSYM);
} /* jalign */

up_align(algnptr)
	algnentry *algnptr;
{
	register algnentry *ptr;
	register short cntr;
	register symbol *lptr;
	register symbol **ptr2;
	register short delta;
	long instaddr;

	delta = algnptr->constant;
	PCmax -= delta;
	dot->maxval -= delta;

	instaddr = algnptr->minaddr % (unsigned)delta;
	if (instaddr == 0)	/* no virtual displacement */
		delta  = 0;
	else
	{
		delta = delta - instaddr;
	}
	for (cntr = algnctr, ptr = &algnset[0]; cntr-- >= 0; ++ptr) {
		if (ptr != algnptr)
			if (ptr->minaddr >= algnptr->minaddr) 
				ptr->minaddr += delta;
		}
	newdot += delta;
	dot->value += delta;
	for (cntr = keepcount, ptr2 = labset; cntr-- >= 0; ) {
		lptr = *ptr2;
		if (lptr->value >= algnptr->minaddr) {
			lptr->value += delta;
			lptr->maxval -= (algnptr->constant - delta);
			if (lptr->maxval == 0) {
				*ptr2 = labset[keepcount--];
				continue;
			}
		}
		ptr2++;
	}
}

newalgn(const)
	long const;
{
	register algnentry *nalgn;

        char *malloc();
        char *realloc();

	if (++algnctr == maxalgn)  /* if at end of array             */
	   if (maxalgn == 0)      /* if array doesn't yet exist     */
	   {
	      maxalgn = INCALGN;  /* allocate the initial increment # of entries */
	      if ((algnset = (algnentry *) malloc (INCALGN*sizeof(algnentry))) == NULL)
	    	aerror("Align Table overflow: run assembler without optimization");
	   }
	   else                   /* expand the current array       */
	      if ((algnset = (algnentry *) realloc(algnset,(maxalgn += INCALGN)*sizeof(algnentry))) == NULL)
	    	aerror("Align Table overflow: run assembler without optimization");

	nalgn = &algnset[algnctr];
	nalgn->minaddr = dot->value;
	nalgn->constant = const;
}
