/*	@(#)addr2.c	2.3	*/

#include <stdio.h>
#include "systems.h"
#include "symbols.h"
#include "instab.h"
#include "gendefs.h"
#include "codeout.h"
#include "reloc.h"


extern unsigned short
		relent; /* number of relocation entries written to fdrel */

extern long 
		newdot; /* up to date value of "." */

extern symbol
		*dot; /* current location counter */



extern BYTE
		*longsdi;

extern FILE
	*fdrel; /* file of relocation table information */

static short sdijbr = 0;  /* flag to consider the special case jbr sdi */
static short pcrel = 0;   /* flag to indicate pc relative relocation */


extern
	genreloc(),
	genpcrel(),
	sdidst(),
	genalign(),
	sdiinst(),
	diffrel(),
	relocdiff(),
	newstmt(),
	setfile(),
	lineno(),
	linenum(),
	lineval(),
	define(),
	endef(),
	setval(),
	setscl(),
	settyp(),
	settag(),
	setlno(),
	setsiz(),
	setdim1(),
	setdim2(),
	gendisp(),
	genabssym();



int (*(modes[NACTION+2]))() = {

/*0*/	0, 		/* GENVALUE */
/*1*/	genreloc,	/* GENRELOC */
/*2*/	genpcrel,	/* GENPCREL */
/*3*/	sdidst,		/* SDIDST */
/*4*/	genalign,	/* GENALIGN */
/*5*/	sdiinst,	/* SDIINST + 0 */
/*6*/	sdiinst,	/* SDIINST + 1 */
/*7*/	sdiinst,	/* SDIINST + 2 */
/*8*/	sdiinst,	/* SDIINST + 3 */
/*9*/	sdiinst,	/* SDIINST + 4 */
/*10*/	sdiinst,	/* SDIINST + 5 */
/*11*/	sdiinst,	/* SDIINST + 6 */
/*12*/	sdiinst,	/* SDIINST + 7 */
/*13*/	sdiinst,	/* SDIINST + 8 */
/*14*/	sdiinst,	/* SDIINST + 9 */
/*15*/	sdiinst,	/* SDIINST + 10 */
/*16*/	sdiinst,	/* SDIINST + 11 */
/*17*/	sdiinst,	/* SDIINST + 12 */
/*18*/	sdiinst,	/* SDIINST + 13 */
/*19*/	sdiinst,	/* SDIINST + 14 */
/*20*/	sdiinst,	/* SDIINST + 15 */
/*21*/	sdiinst,	/* SDIINST + 16 */
/*22*/	sdiinst,	/* SDIINST + 17 */
/*23*/	sdiinst,	/* SDIINST + 18 */
/*24*/	sdiinst,	/* SDIINST + 19 */
/*25*/	sdiinst,	/* SDIINST + 20 */
/*26*/	sdiinst,	/* SDIINST + 21 */
/*27*/	sdiinst,	/* SDIINST + 22 */
/*28*/	sdiinst,	/* SDIINST + 23 */
/*29*/	diffrel,	/* DIFFREL */
/*30*/	newstmt,	/* NEWSTMT */
/*31*/	setfile,	/* SETFILE */
/*32*/	lineno,		/* LINENBR */
/*33*/	linenum,	/* LINENUM */
/*34*/	lineval,	/* LINEVAL */
/*35*/	define,		/* DEFINE */
/*36*/	endef,		/* ENDEF */
/*37*/	setval,		/* SETVAL */
/*38*/	setscl,		/* SETSCL */
/*39*/	settyp,		/* SETTYP */
/*40*/	settag,		/* SETTAG */
/*41*/	setlno,		/* SETLNO */
/*42*/	setsiz,		/* SETSIZ */
/*43*/	setdim1,	/* SETDIM1 */
/*44*/	setdim2,	/* SETDIM2 */
/*45*/	gendisp,	/* GENDISP */
/*46*/	genabssym,	/* GENABSSYM */
	0 };


/* code generation action routines */

genreloc(sym,code) /* simple relocation with no frills */

register symbol *sym;
register codebuf *code;

	{ char *rsym;
	  unsigned short stype, rtype;
	  prelent trelent;

	  if (sym == NULLSYM)
		stype = ABS;
	  else {
		code->cvalue += ((code->cindex > 0) ?
				sym->value : (-sym->value));
		stype = (sym->styp & TYPE);
		};
	  switch (stype) {

		case ABS: if (pcrel)
				rsym = "=";
			  else
				return; /* no relocation is needed */
			  break;

		case TXT: rsym = ".text";
			  break;

		case DAT: rsym = ".data";
			  break;

		case BSS: rsym = ".bss";
			  break;
		
		case UNDEF: sym->styp = sym->styp | EXTERN;
			    rsym = sym->_name.name;
			    /* in case the symbol is common (it has a value) */
			    code->cvalue = code->cvalue - ((code->cindex > 0) ?
				 sym->value : (-sym->value));
			    break;

		default: aerror("attempt to relocate weird symbol");
		};
	switch (code->cnbits) { /* determine kind of relocation */
		 case 8: rtype = pcrel ? R_PCRBYTE : R_RELBYTE;
			 code->cvalue <<= 24;
			 break;
		case 16: rtype = pcrel ? R_PCRWORD : R_RELWORD;
			 code->cvalue <<= 16;
			 break;
		case 32: rtype = pcrel ? R_PCRLONG : R_RELLONG;
			 break;
		default: werror("attempt to relocate weird sized symbol");
		};
	/* generate relocation table entry */
	trelent.relval = newdot;
	trelent.relname = rsym;
	trelent.reltype = rtype;
	fwrite(&trelent,sizeof(prelent),1,fdrel);
	relent++;
	}



relocdiff(sym,code) /* simple relocation with no frills */

register symbol *sym;
register codebuf *code;

	{ char *rsym;
	  unsigned short stype, rtype;
	  prelent trelent;
	  symbol *dummy;

	  dummy = (symbol *)code->cvalue;
	  code->cvalue = dummy->value - ((code->cindex > 0) ?
		 sym->value : (-sym->value));
	  code->cvalue -=  newdot + (code->cnbits/BITSPBY);
	  stype = (sym->styp & TYPE);
	  switch (stype) {

		case ABS: if (pcrel)
				rsym = "=";
			  else
				return; /* no relocation is needed */
			  break;

		case TXT: rsym = ".text";
			  break;

		case DAT: rsym = ".data";
			  break;

		case BSS: rsym = ".bss";
			  break;
		
		case UNDEF: sym->styp = sym->styp | EXTERN;
			    rsym = sym->_name.name;
			    /* in case the symbol is common (it has a value) */
			    code->cvalue = code->cvalue - ((code->cindex > 0) ?
				 sym->value : (-sym->value));
			    break;

		default: aerror("attempt to relocate weird symbol");
		};
	switch (code->cnbits) { /* determine kind of relocation */
		 case 8: rtype = pcrel ? R_PCRBYTE : R_RELBYTE;
			 code->cvalue <<= 24;
			 break;
		case 16: rtype = pcrel ? R_PCRWORD : R_RELWORD;
			 code->cvalue <<= 16;
			 break;
		case 32: rtype = pcrel ? R_PCRLONG : R_RELLONG;
			 break;
		default: werror("attempt to relocate weird sized symbol");
		};
	/* generate relocation table entry */
	trelent.relval = newdot;
	rsym = "=";
	trelent.relname = rsym;
	trelent.reltype = rtype;
	fwrite(&trelent,sizeof(prelent),1,fdrel);
	relent++;
	}



genpcrel(sym,code)

register symbol *sym;
register codebuf *code;

	{
	code->cvalue -=  newdot + (code->cnbits/BITSPBY);
	pcrel = 1; /* toggle pc relative relocation flag on */
	genreloc(sym,code);
	pcrel = 0; /* toggle pc relative relocation flag off */
	}





diffrel(sym,code)

register symbol *sym;
register codebuf *code;

	{
	pcrel = 1; /* toggle pc relative relocation flag on */
	relocdiff(sym,code);
	pcrel = 0; /* toggle pc relative relocation flag off */
	}




unsigned short negops[19] = {

0xe1, /* bcc dest / bcs .+6; jmp dest */
0xf1, /* bcs dest / bcc .+6; jmp dest */
0x21, /* beql dest / bneq .+6; jmp dest */
0x21, /* beqlu dest / bnequ .+6; jmp dest */
0x91, /* bgeq dest / blss .+6; jmp dest */
0xf1, /* bgequ dest / blssu .+6; jmp dest */
0x51, /* bgtr dest / bleq .+6; jmp dest */
0xb1, /* bgtru dest / blequ .+6; jmp dest */
0x41, /* bleq dest / bgtr .+6; jmp dest */
0xa1, /* blequ dest / bgtru .+6; jmp dest */
0x81, /* blss dest / bgeq .+6; jmp dest */
0xe1, /* blssu dest / bgequ .+6; jmp dest */
0x31, /* bneq dest / beql .+6; jmp dest */
0x31, /* bnequ dest / beqlu .+6; jmp dest */
0xd1, /* bvc dest / bvs .+6; jmp dest */
0xc1, /* bvs dest / bvc .+6; jmp dest */
0x71, /* brb dest / jmp dest */
0x0e, /* bbc dest / bbs .+6; jmp dest */
0x1e, /* bbs dest / bbc .+6; jmp dest */
};

#define outbuf_size 40                   /* size of output line header */
#define inbuf_size 2048                  /* size of source input line */
        extern char inbuf [inbuf_size];  /* source input line */
        extern char outbuf[outbuf_size]; /* output line header */
        extern int outbuf_off;           /* current offset into output buffer */
        extern short output_code_type;   /* code type -- TEXT or DATA */
        extern int list_pc;              /* current program counter for listing */

sdidst(sym,code)

register symbol *sym;
register codebuf *code;

{
          extern short liston;

	  if (*longsdi) { /* was previous instruction set as a long sdi
			     if so, make the operands follow suit */
		if (!sdijbr) /* generate the .+6 dest following
				the long instruction sequence */
		{
			codgen(BITSPBY,6L << 24); /* .+6 dest */
			if (liston)
			{
                        list_pc ++;  /* Update listing progam counter */
                        outbuf_off = print_memory_layout (outbuf, outbuf_off,
                                    6L << 24, BITSPBY, inbuf, output_code_type, 0);
                                         /* Put information in object listing  */
                        }
                }
		if (!sdijbr) /* generate the brw sequence */
		{
			codgen(BITSPBY,0x71L << 24);
			if (liston)
			{
                        list_pc ++;  /* Update listing progam counter */
                        outbuf_off = print_memory_layout (outbuf, outbuf_off,
                                 0x71L << 24, BITSPBY, inbuf, output_code_type, 0);
                                         /* Put information in object listing  */
                        }
                }
		/* generate the operand specifier saying that the next operand
		   is actually a long */
		codgen(BITSPBY,0xef << 24);
		if (liston)
		{
                list_pc ++;  /* Update listing progam counter */
                outbuf_off = print_memory_layout (outbuf, outbuf_off,
                         0xefL << 24, BITSPBY, inbuf, output_code_type, 0);
                                 /* Put information in object listing  */
                }
		code->cnbits = 4*BITSPBY; /* dest is now a long, the routine
					     which called sdidst will output
					     the destination operand */
		};
	  gendisp(sym,code); /* add the finishing touches */
	  if (sdijbr) /* toggle the special case flag */
		sdijbr = 0;
	}



genalign(sym,code)

register symbol *sym;
register codebuf *code;

{
	register i, mod;

	mod = newdot % code->cvalue;
	if (mod != 0)
		for (i = 0; i < code->cvalue - mod; i++)
			codgen(BITSPBY,0L); 
}


sdiinst(sym,code)

register symbol *sym;
register codebuf *code;

	{ if (*++longsdi)
		code->cvalue = (long)negops[code->caction-SDIINST] << 24;
	  if (code->caction==SDIINST+16) /* jbr special case, set flag */
		sdijbr++;
	}


gendisp(sym,code)

register symbol *sym;
register codebuf *code;

	{
	  if (sym != NULLSYM)
		code->cvalue += ((code->cindex > 0) ? 
				sym->value : (-sym->value));
	  code->cvalue -= newdot + (code->cnbits/BITSPBY); /* adjust offset */

	  /* check to see that we do not have a jump displacement overflow */

	  if (((code->cnbits == BITSPBY) &&
	      (code->cvalue < -128 || code->cvalue > 127)) ||
	      ((code->cnbits == (2*BITSPBY)) &&
	      (code->cvalue < -32768 || code->cvalue > 32767)))
		aerror("jmp displacement overflow, please call UNIX hotline");
	  if (code->cnbits == BITSPBY)
	      code->cvalue <<= 24;
	  else if (code->cnbits == (2*BITSPBY))
	      code->cvalue <<= 16;
	}


genabssym(sym,code)

register symbol *sym;
register codebuf *code;

{ /* handle symbol - symbol special case, the parser stuck the ptr
	     to the left symbol in the code->cvalue parameter, see parse.y */

	  symbol *dummy;

	  dummy = (symbol *)code->cvalue;
	  code->cvalue = dummy->value - ((code->cindex > 0) ?
			 sym->value : (-sym->value));
	  if (code->cnbits == 16)
		code->cvalue <<= 16;
	  else if (code->cnbits == 8)
		code->cvalue <<= 24;
}
