/*	@(#)gencode.c	2.4	*/

#include <stdio.h>
#include <string.h>
#include "symbols.h"
#include "instab.h"
#include "parse.h"
#include "gendefs.h"
#include "expand.h"
#include "expand2.h"

extern unsigned short line;
extern long
	newdot;		/* up-to-date value of "." */
extern symbol
	*dot;		/* current location counter */
extern short
	transvec,	/* indicates active transfer vector option */
	opt;	/* no optimize flag */



/* flags */

int	defdisp = 4; /* default number of bytes displacement for externals 
		        as ... -l ...  change by -[bwl] flags              */

short	readonly = 0;/* convert .data segment into .text for readonly and
   			shareable access				    */


static int warnbad = 0;
static char noshort = 0; /* flag set to prohibit generation of short literals
			    within the processing of a span dependent instr.
			    the generation of the short literals royally
			    screws up the sdi logic of the common assembler */

flags(flag)
char flag;
{
	char errmsg[28];
	switch(flag) {


	case 'r':	readonly = 1; /* put .data stuff into .text segment */
			break;


	case 'l':	defdisp = 4; /* displace externals with 4 bytes=long */
			break;

	case 'w':	defdisp = 2; /* displace externals with 2 bytes=word */
			break;

	case 'b':	defdisp = 1; /* displace externals with 1 byte */
			break;


	default:
		sprintf(errmsg,"Illegal flag (%c) - ignored",flag);
		werror(errmsg);
		break;
	} /* switch */
} /* flags */


typedef struct { BYTE mode[6]; } contab;

contab context[47] = {
{INSTW,A_TYPL,0,0,0,0}, 		/* ILU00 */
{A_TYPB,0,0,0,0,0},			/* ILU01 */
{A_TYPW,0,0,0,0,0},			/* ILU02 */
{A_TYPL,0,0,0,0,0},			/* ILU03 */
{A_TYPL,A_TYPL,0,0,0,0},		/* ILU04 */
{INSTB,A_TYPB,0,0,0,0},			/* ILU05 */
{INSTL,W_TYPB,0,0,0,0}, 		/* ILU06 */
{INSTL,W_TYPW,0,0,0,0}, 		/* ILU07 */
{INSTL,W_TYPL,0,0,0,0}, 		/* ILU08 */
{INSTW,W_TYPB,0,0,0,0}, 		/* ILU09 */
{INSTL,INSTB,INSTJB,0,0,0}, 		/* ILU10 */
{INSTW,W_TYPW,0,0,0,0}, 		/* ILU11 */
{INSTW,W_TYPL,0,0,0,0}, 		/* ILU12 */
{INSTB,W_TYPB,0,0,0,0}, 		/* ILU13 */
{INSTB,W_TYPW,0,0,0,0}, 		/* ILU14 */
{INSTB,W_TYPL,0,0,0,0}, 		/* ILU15 */
{W_TYPB,0,0,0,0,0}, 			/* ILU16 */
{W_TYPW,0,0,0,0,0}, 			/* ILU17 */
{W_TYPL,0,0,0,0,0}, 			/* ILU18 */
{INSTB,INSTB,W_TYPB,0,0,0}, 		/* ILU19 */
{INSTW,INSTW,W_TYPW,0,0,0}, 		/* ILU20 */
{INSTL,INSTL,W_TYPL,0,0,0}, 		/* ILU21 */
{INSTF,INSTD,0,0,0,0}, 			/* ILU22 */
{INSTF,INSTL,0,0,0,0},	 		/* ILU23 */
{INSTF,INSTW,0,0,0,0},			/* ILU24 */
{INSTL,INSTD,0,0,0,0},	 		/* ILU25 */
{INSTL,INSTF,0,0,0,0},	 		/* ILU26 */
{INSTL,INSTW,INSTL,0,0,0}, 		/* ILU27 */
{INSTW,INSTL,INSTL,0,0,0}, 		/* ILU28 */
{INSTL,INSTL,INSTL,W_TYPQ,0,0},		/* ILU29 */
{INSTL,INSTQ,W_TYPL,W_TYPL,0,0},	/* ILU30 */
{INSTB,INSTL,W_TYPL,0,0,0},		/* ILU31 */
{INSTB,INSTQ,W_TYPQ,0,0,0},		/* ILU32 */
{A_TYPB,W_TYPL,0,0,0,0},		/* ILU33 */
{A_TYPW,W_TYPL,0,0,0,0},		/* ILU34 */
{A_TYPL,W_TYPL,0,0,0,0},		/* ILU35 */
{INSTL,W_TYPL,INSTJW,0,0,0}, 		/* ILU36 */
{INSTL,INSTL,INSTJW,0,0,0}, 		/* ILU37 */
{INSTL,INSTL,INSTB,INSTB,0,0}, 		/* ILU38 */
{INSTB,INSTW,INSTL,0,0,0}, 		/* ILU39 */
{W_TYPF,0,0,0,0,0},			/* ILU40 */
{W_TYPD,0,0,0,0,0},			/* ILU41 */
{INSTF,INSTW,INSTL,0,0,0}, 		/* ILU42 */
{INSTB,INSTW,INSTL,0,0,0}, 		/* ILU43 */
{INSTB,A_TYPB,INSTB,0,0,0}, 		/* ILU44 */
{INSTW,INSTL,INSTL,INSTB,0,0}, 		/* ILU45 */
{INSTL,INSTJB,0,0,0,0} 			/* ILU46 */
};

char *opernum_str[7] =	{"no operand",
		  "operand #1 - ", "operand #2 - ", "operand #3 - ",
		  "operand #4 - ", "operand #5 - ", "operand #6 - "
		};

genopr(op,oppos,type,operm) /* generate preliminary code for an instr operand */

addrmode op;
BYTE oppos, type;
char operm[5];
	{ register int field;
	  register BYTE opmode;	
	  BYTE usage;
	  register char *opernum = opernum_str[oppos];

	  opmode = op.admode;

	  if (opmode & AINDX) {			/* ...[%r] */
		field = op.adreg2 | 0x40;
		generate(BITSPBY,GENVALUE,field,NULLSYM);
		opmode = opmode & ~AINDX;
		};

	  if (opmode & ASTAR) {			/* * ... */
		op.adreg1 = op.adreg1 | 0x10;
		opmode = opmode & ~ASTAR;
		};

	  
	  switch (opmode) {
		
		case AREG: 
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			   if (usage <= A_TYPD && usage >= A_TYPB)
				_yyerror (opernum, "addressing a register");
			   if (usage == INSTD || usage == INSTQ)
			       if (op.adreg1 & 0x01)
				_yyerror (opernum, "register must be even");
			   if (((operm[oppos-1]=='R')||(operm[oppos-1]=='M'))
	                       &&(op.adreg1==14))
	                   _yyerror (opernum, "SP cannot be a source register");
			   field = op.adreg1 | 0x50;	/* %r */
			   generate(BITSPBY,GENVALUE,field,NULLSYM);
			   break;

		case ABASE: field = op.adreg1 | 0x60;	/* (%r) */
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case ADECR:                         	/* -(%r) */
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == INSTD || usage == INSTQ)
				_yyerror (opernum, "double/quad opernad cant be autodecrement");
			    if (usage > W_TYPD || usage < W_TYPB)
			    	_yyerror (opernum, "cant read an autodecrement operand");
			    field = op.adreg1 | 0x70;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case AINCR:                         	/* (%r)+ */
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == INSTD || usage == INSTQ)
				_yyerror (opernum, "double/quad operand cant be autoincrement");
			    if (usage <= W_TYPD && usage >= W_TYPB)
			    	_yyerror (opernum, "modifying an autoincrement operand");
			    field = op.adreg1 | 0x80;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case AEXP:  if (type < ILU00)		/* <expr> */
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == 0)
				aerror("cannot determine operand context");
			    if (usage == INSTJB) {
				field = op.adexpr.expval.lngval - newdot - 1;
			        if ((field < -128 || field > 127) &&
				    (op.adexpr.exptype != TSYM))
					_yyerror(opernum, "branch error (byte disp)");
				generate(BITSPBY,GENDISP,
				      op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    if (usage == INSTJW) {
				field = op.adexpr.expval.lngval - newdot - 2;
				if ((field < -32768 || field > 32767) &&
				    (op.adexpr.exptype != TSYM))
					_yyerror(opernum, "branch error (word disp)");
				generate((2*BITSPBY),GENDISP,
				      op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    /* assume expr(pc) mode */
			    if (defdisp == 1)      /* byte disp */	
				field = op.adreg1 | 0xaf;
			    else if (defdisp == 2) /* word disp */
				field = op.adreg1 | 0xcf;
			    else if (defdisp == 4) /* long disp */
				field = op.adreg1 | 0xef;
			    else /* uh oh! */
				aerror("cannot determine operand displacement");
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			       generate((defdisp*BITSPBY),GENPCREL,
				     op.adexpr.expval.lngval,op.adexpr.symptr);
			    break;

		case ADISP: if (op.adexpr.exptype==TSYM) {/* <expr> (%r) */
				if (defdisp == 1)      /* byte disp */
					field = op.adreg1 | 0xa0;
				else if (defdisp == 2) /* word disp */
					field = op.adreg1 | 0xc0;
				else if (defdisp == 4) /* long disp */
					field = op.adreg1 | 0xe0;
				else /* uh oh! */
					aerror("cannot determine operand displacement");
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				generate((defdisp*BITSPBY),GENRELOC,
				    op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    if (op.adexpr.expval.lngval==0 && !(op.admode&ASTAR)) {
				field = op.adreg1 | 0x60; /* (%r) equivalent */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				break;
				};
			    if (op.adexpr.expval.lngval>=-128&&op.adexpr.expval.lngval<=127) {
				field = op.adreg1 | 0xa0; /* byte disp */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				generate(BITSPBY,GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				};
			    if (op.adexpr.expval.lngval >= -32768 &&
				op.adexpr.expval.lngval <= 32767) {
				field = op.adreg1 | 0xc0; /* word disp */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				generate((2*BITSPBY),GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				};
			    /* assume long displacement */
			    field = op.adreg1 | 0xe0;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    generate((4*BITSPBY),GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
			    break;

		case AIMM:  if (type < ILU00) 			/* $ <expr> */
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == 0)
				aerror("cannot determine operand context");
			    if (op.admode&ASTAR)
			    {
				usage = INSTL;
				field = op.adreg1 | 0x8f;
			    }
			    /* see if we have a short literal */
			    if (!(op.admode&ASTAR) &&
				(op.adexpr.exptype!=TSYM) &&
				(!noshort) &&
				((op.adexpr.exptype&TINT)!=0))
				{
				if (usage <= A_TYPD && usage >= A_TYPB)
				   _yyerror (opernum, "addressing a constant");
				if (usage <= W_TYPD && usage >= W_TYPB)
				   _yyerror (opernum, "modifying a constant");
/*
     Why is INSTF        	  	   if (usage == INSTD)
     allowed?	 	                   _yyerror(opernum, "double operand cant be a constant");
*/
				if ((op.adexpr.expval.lngval >= 0) &&
				(op.adexpr.expval.lngval <= 63)) {
				generate(BITSPBY,GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				}
		      	   	else
					if ((op.adexpr.expval.lngval >= -128) &&
					(op.adexpr.expval.lngval <= 127)) {
						field = op.adreg1 | 0x88;
						usage = INSTB;
					}
					else
					if ((op.adexpr.expval.lngval >= -32768) &&
					(op.adexpr.expval.lngval <= 32767)) {
						field = op.adreg1 | 0x89;
						usage = INSTW;
					}
					else
					{
						field = op.adreg1 | 0x8f;
						usage = INSTL;
					}
			      }
				   else
				   {
/*
      Why is INSTF 	 			if (usage == INSTD)
      allowed?				   	  _yyerror(opernum, "double operand cant be a constant");
*/
					field = op.adreg1 | 0x8f;
					usage = INSTL;
					if (op.adexpr.exptype&TFLT)
						usage = INSTF;
				   }
			    if (warnbad)
				aerror("displacement overflow, try cc -Wa,-j option to invoke ljas instead of as");
			    switch (usage) {
				case INSTD:  /* double precision */
				case INSTF:  /* single precision */ {
					register int *ptrl, *ptrr;
					if ((op.adexpr.exptype&TFLT)==0)
						_yyerror(opernum, "illegal operand");
/*
     Why is INSTF				if (usage == INSTD)
     allowed ?				     	  _yyerror (opernum, "double operand cant be a constant");
*/
					ptrl = (int *)&op.adexpr.expval.dblval;
					ptrr = ptrl + 1;
					if ((*ptrr == 0) && /* look for 
						     short floating literal */
					     (*ptrl&0x00004000) &&
					    ((*ptrl&0x000043f0)==*ptrl)) {
						field = *ptrl>>4;
						generate(BITSPBY,GENVALUE,
							  field,NULLSYM);
						break;
						};
					generate(BITSPBY,GENVALUE,field,
								NULLSYM);
					if (usage == INSTF)
					     generate((4*BITSPBY),GENVALUE,
					      op.adexpr.expval.fltval,NULLSYM);
					else {
					     generate((4*BITSPBY),GENVALUE,
					      *ptrl,NULLSYM);
					     generate((4*BITSPBY),GENVALUE,
					      *ptrr,NULLSYM);
					};

					break;
					};
				case INSTJB:
				case INSTB: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate(BITSPBY,GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate(BITSPBY,GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTJW:
				case INSTW: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate((2*BITSPBY),GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate((2*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTL: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate((4*BITSPBY),GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate((4*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTQ: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					generate((4*BITSPBY),GENVALUE,0L,NULLSYM);
					generate((4*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				default:
					aerror("operand context confusion");
				};
			    break;
		default: /* uh oh! */
			aerror("attempt to assemble weird operand");
			break;
			};
	}




genoprdff(op,oppos,type,operm) /* generate preliminary code for ins. operand */

addrmode op;
BYTE oppos, type;
char operm[5];

	{ register int field;
	  register BYTE opmode;	
	  BYTE usage;
	  register char *opernum = opernum_str[oppos];

	  opmode = op.admode;

	  if (opmode & AINDX) {			/* ...[%r] */
		field = op.adreg2 | 0x40;
		generate(BITSPBY,GENVALUE,field,NULLSYM);
		opmode = opmode & ~AINDX;
		};

	  if (opmode & ASTAR) {			/* * ... */
		op.adreg1 = op.adreg1 | 0x10;
		opmode = opmode & ~ASTAR;
		};

	  
	  switch (opmode) {
		
		case AREG: 
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			   if (usage <= A_TYPD && usage >= A_TYPB)
				_yyerror (opernum, "addressing a register");
			   if (usage == INSTD || usage == INSTQ)
			       if (op.adreg1 & 0x01)
				_yyerror (opernum, "register must be even");
			   if (((operm[oppos-1]=='R')||(operm[oppos-1]=='M'))
	                       &&(op.adreg1==14))
	                   _yyerror (opernum, "SP cannot be a source register");
			   field = op.adreg1 | 0x50;	/* %r */
			   generate(BITSPBY,GENVALUE,field,NULLSYM);
			   break;

		case ABASE: field = op.adreg1 | 0x60;	/* (%r) */
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case ADECR:                         	/* -(%r) */
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == INSTD || usage == INSTQ)
				_yyerror (opernum, "double/quad operand cant be autodecrement");
			    if (usage > W_TYPD || usage < W_TYPB)
			    	_yyerror (opernum, "cant read an autodecrement operand");
			    field = op.adreg1 | 0x70;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case AINCR:                         	/* (%r)+ */
			    if (type < ILU00)	
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == INSTD || usage == INSTQ)
				_yyerror (opernum, "double/quad operand cant be autoincrement");
			    if (usage <= W_TYPD && usage >= W_TYPB)
			    	_yyerror (opernum, "modifying an autoincrement operand");
			    field = op.adreg1 | 0x80;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    break;

		case AEXP:  if (type < ILU00)		/* <expr> */
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == 0)
				aerror("cannot determine operand context");
			    if (usage == INSTJB) {
				field = op.adexpr.expval.lngval - newdot - 1;
			        if ((field < -128 || field > 127) &&
				    (op.adexpr.exptype != TSYM))
					_yyerror(opernum, "branch error (byte disp)");
				generate(BITSPBY,GENDISP,
				      op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    if (usage == INSTJW) {
				field = op.adexpr.expval.lngval - newdot - 2;
				if ((field < -32768 || field > 32767) &&
				    (op.adexpr.exptype != TSYM))
					_yyerror(opernum, "branch error (word disp)");
				generate((2*BITSPBY),GENDISP,
				      op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    /* assume expr(pc) mode */
			    if (defdisp == 1)      /* byte disp */	
				field = op.adreg1 | 0xaf;
			    else if (defdisp == 2) /* word disp */
				field = op.adreg1 | 0xcf;
			    else if (defdisp == 4) /* long disp */
				field = op.adreg1 | 0xef;
			    else /* uh oh! */
				aerror("cannot determine operand displacement");
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			       generate((defdisp*BITSPBY),DIFFREL,
				     op.adexpr.expval.lngval,op.adexpr.symptr);
			    break;

		case ADISP: if (op.adexpr.exptype&TSYM) {/* <expr> (%r) */
				if (defdisp == 1)      /* byte disp */
					field = op.adreg1 | 0xa0;
				else if (defdisp == 2) /* word disp */
					field = op.adreg1 | 0xc0;
				else if (defdisp == 4) /* long disp */
					field = op.adreg1 | 0xe0;
				else /* uh oh! */
					aerror("cannot determine operand displacement");
				generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate((defdisp*BITSPBY),GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
				generate((defdisp*BITSPBY),GENRELOC,
				    op.adexpr.expval.lngval,op.adexpr.symptr);
				break;
				};
			    if (op.adexpr.expval.lngval==0 && !(op.admode&ASTAR)) {
				field = op.adreg1 | 0x60; /* (%r) equivalent */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				break;
				};
			    if (op.adexpr.expval.lngval>=-128&&op.adexpr.expval.lngval<=127) {
				field = op.adreg1 | 0xa0; /* byte disp */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				generate(BITSPBY,GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				};
			    if (op.adexpr.expval.lngval >= -32768 &&
				op.adexpr.expval.lngval <= 32767) {
				field = op.adreg1 | 0xc0; /* word disp */
				generate(BITSPBY,GENVALUE,field,NULLSYM);
				generate((2*BITSPBY),GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				};
			    /* assume long displacement */
			    field = op.adreg1 | 0xe0;
			    generate(BITSPBY,GENVALUE,field,NULLSYM);
			    generate((4*BITSPBY),GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
			    break;

		case AIMM:  if (type < ILU00) 			/* $ <expr> */
				usage = type;
			    else
				usage = context[type-ILU00].mode[oppos-1];
			    if (usage == 0)
				aerror("cannot determine operand context");
			    if (op.admode&ASTAR)
			    {
				usage = INSTL;
				field = op.adreg1 | 0x8f;
			    }
			    /* see if we have a short literal */
			    if (!(op.admode&ASTAR) &&
				(op.adexpr.exptype!=TSYM) &&
				(!noshort) &&
				((op.adexpr.exptype&TINT)!=0))
				{
				if (usage <= A_TYPD && usage >= A_TYPB)
				   _yyerror (opernum, "addressing a constant");
				if (usage <= W_TYPD && usage >= W_TYPB)
				   _yyerror (opernum, "modifying a constant");
/*
      Why is INSTF			if (usage == INSTD)
      allowed?				   _yyerror(opernum, "double operand cant be a constant");
*/
				if ((op.adexpr.expval.lngval >= 0) &&
				(op.adexpr.expval.lngval <= 63)) {
				generate(BITSPBY,GENVALUE,op.adexpr.expval.lngval,
							NULLSYM);
				break;
				}
		      	   	else
					if ((op.adexpr.expval.lngval >= -128) &&
					(op.adexpr.expval.lngval <= 127)) {
						field = op.adreg1 | 0x88;
						usage = INSTB;
					}
					else
					if ((op.adexpr.expval.lngval >= -32768) &&
					(op.adexpr.expval.lngval <= 32767)) {
						field = op.adreg1 | 0x89;
						usage = INSTW;
					}
					else
					{
						field = op.adreg1 | 0x8f;
						usage = INSTL;
					}
			      }
				   else
				   {
/*
      Why is INSTF				if (usage == INSTD)
      allowed?				   	  _yyerror(opernum, "double operand cant be a constant");
*/
					field = op.adreg1 | 0x8f;
					usage = INSTL;
					if (op.adexpr.exptype&TFLT)
						usage = INSTF;
				   }
			    if (warnbad)
				aerror("displacement overflow, try cc -Wa,-j option to invoke ljas instead of as");
			    switch (usage) {
				case INSTD:  /* double precision */
				case INSTF:  /* single precision */ {
					register int *ptrl, *ptrr;
					if ((op.adexpr.exptype&TFLT)==0)
						_yyerror(opernum, "illegal operand");
/*
     Why is INSTF				if (usage == INSTD)
     allowed?				     	  _yyerror (opernum, "double operand cant be a constant");
*/
					ptrl = (int *)&op.adexpr.expval.dblval;
					ptrr = ptrl + 1;
					if ((*ptrr == 0) && /* look for 
						     short floating literal */
					     (*ptrl&0x00004000) &&
					    ((*ptrl&0x000043f0)==*ptrl)) {
						field = *ptrl>>4;
						generate(BITSPBY,GENVALUE,
							  field,NULLSYM);
						break;
						};
					generate(BITSPBY,GENVALUE,field,
								NULLSYM);
					if (usage == INSTF)
					     generate((4*BITSPBY),GENVALUE,
					      op.adexpr.expval.fltval,NULLSYM);
					else {
					     generate((4*BITSPBY),GENVALUE,
					      *ptrl,NULLSYM);
					     generate((4*BITSPBY),GENVALUE,
					      *ptrr,NULLSYM);
					};

					break;
					};
				case INSTJB:
				case INSTB: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate(BITSPBY,GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate(BITSPBY,GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTJW:
				case INSTW: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate((2*BITSPBY),GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate((2*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTL: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					if (op.adexpr.exptype&TDIFF)
					generate((4*BITSPBY),GENABSSYM,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					else
					generate((4*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				case INSTQ: {
					generate(BITSPBY,GENVALUE,field,NULLSYM);
					generate((4*BITSPBY),GENVALUE,0L,NULLSYM);
					generate((4*BITSPBY),GENRELOC,
						op.adexpr.expval.lngval,
						op.adexpr.symptr);
					break;
					};
				default:
					aerror("operand context confusion");
				};
			    break;
		default: /* uh oh! */
			aerror("attempt to assemble weird operand");
			break;
			};
	}



typedef struct { char name[9];
		 unsigned short nopcode; } sditab;

sditab nsdiop[20] = {

/* ops.out contains the information needed to generate the short form of these
   instructions.  this table contains the information needed to generate the
   long form of these instructions.  this table is searched linearly. */

/*      opcode of negated instruction */

{"jcc",		0xe1}, /* bcc dest / bcs .+3; brw dest */
{"jcs",		0xf1}, /* bcs dest / bcc .+3; brw dest */
{"jeql",	0x21}, /* beql dest / bneq .+3; brw dest */
{"jeqlu",	0x21}, /* beqlu dest / bnequ .+3; brw dest */
{"jgeq",	0x91}, /* bgeq dest / blss .+3; brw dest */
{"jgequ",	0xf1}, /* bgequ dest / blssu .+3; brw dest */
{"jgtr",	0x51}, /* bgtr dest / bleq .+3; brw dest */
{"jgtru",	0xb1}, /* bgtru dest / blequ .+3; brw dest */
{"jleq",	0x41}, /* bleq dest / bgtr .+3; brw dest */
{"jlequ",	0xa1}, /* blequ dest / bgtru .+3; brw dest */
{"jlss",	0x81}, /* blss dest / bgeq .+3; brw dest */
{"jlssu",	0xe1}, /* blssu dest / bgequ .+3; brw dest */
{"jneq",	0x31}, /* bneq dest / beql .+3; brw dest */
{"jnequ",	0x31}, /* bnequ dest / beqlu .+3; brw dest */
{"jvc",		0xd1}, /* bvc dest / bvs .+3; brw dest */
{"jvs",		0xc1}, /* bvs dest / bvc .+3; brw dest */
{"jbr",		0x13}, /* brb dest / jmp dest */
{"jbc",		0x0e}, /* bbc dest / bbs .+3; brw dest */
{"jbs",		0x1e}, /* bbs dest / bbc .+3; brw dest */
{"jbr",		0x71}, /* brb dest / jmp dest */
};


gensdi(inst,op1,op2,op3,operm) /* generate span dependent instruction */

register instr *inst;
addrmode op1,op2,op3;
char operm[5];

{ register short iptr;
	 
  switch (inst->tag) {

	case EXTIN1: {  /* short = 2 bytes; long = 5 bytes */
			/* operands = dest */
			if (opt) {

				switch(shortsdi(op1.adexpr.symptr,
					op1.adexpr.expval.lngval,SDIBR1)) {
				case S_SDI: /* short form guaranteed to fit */
					generate(inst->nbits,GENVALUE,
						 inst->opcode,NULLSYM);
					genopr(op1,1,INSTJB,operm);
					return;
				case U_SDI: /* don't know, put in short form
					       temporarily and check later */
					iptr = 0;
					while (strcmp(inst->name,
						  nsdiop[iptr].name) &&
						  iptr <= 15) iptr++;
					if (iptr == 16) /* uh oh! */
						aerror("cannot find sdi name");
					generate(inst->nbits,SDIINST+iptr,
						 inst->opcode,NULLSYM);
					generate(BITSPBY,SDIDST,
						 op1.adexpr.expval.lngval,
						 op1.adexpr.symptr);
					return;
				case L_SDI: /* fall thru to no optimize case */
					break;
				}
			}
			/* dont optimize, generate long form */
			iptr = 0;
			while (strcmp(inst->name, nsdiop[iptr].name) &&
					iptr <= 15) iptr++;
			if (iptr == 16) /* uh oh! */
				aerror("cannot find sdi name");
			/* generate logically negated instruction */
			generate(BITSPBY,GENVALUE,(long)nsdiop[iptr].nopcode,
								NULLSYM);
			generate(BITSPBY,GENVALUE,3L,NULLSYM); /* .+3 operand */
			generate(BITSPBY,GENVALUE,0x13L,NULLSYM); /* brw inst */
			genopr(op1,1,INSTJW,operm); /* dest operand */
			break;
		     };

	case EXTIN2: {  /* short = 2 bytes; long = 3 bytes */
			/* operands = dest */
			if (opt) {
				switch(shortsdi(op1.adexpr.symptr,
					op1.adexpr.expval.lngval,SDIBR2)) {
				case S_SDI: /* short form guaranteed to fit */
					generate(inst->nbits,GENVALUE,
						 inst->opcode,NULLSYM);
					genopr(op1,1,INSTJB,operm);
					return;
				case U_SDI: /* don't know, put in short form
					       temporarily and check later */
					iptr = 16;
					while (strcmp(inst->name,
						  nsdiop[iptr].name) &&
						  iptr <= 16) iptr++;
					if (iptr == 17) /* uh oh! */
						aerror("cannot find sdi name");
					generate(inst->nbits,SDIINST+iptr,
						 inst->opcode,NULLSYM);
					generate(BITSPBY,SDIDST,
						op1.adexpr.expval.lngval,
						op1.adexpr.symptr);
					return;
				case L_SDI: /* fall thru to no optimize case */
					break;
				}
			}
			/* dont optimize, generate long form */
			iptr = 16;
			while (strcmp(inst->name, nsdiop[iptr].name) &&
					iptr <= 16) iptr++;
			if (iptr == 17) /* uh oh! */
				aerror("cannot find sdi name");
			if ( (op1.admode >= AREG && op1.admode <= AIMM &&
			      op1.admode != AEXP) ||
			    op1.admode & ASTAR || op1.admode & AINDX )
			        iptr = 19;
			/* generate logically negated instruction */


			generate(BITSPBY,GENVALUE,(long)nsdiop[iptr].nopcode,
								NULLSYM);
			genopr(op1,1,INSTJW,operm); /* dest operand */
			break;
		     };

	default: aerror("cannot determine sdi type"); /* uh oh! */
		};
}

