/*      Based on ATT 5.3 Version */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	"@(#)sh:fault.c	1.8"   */
/*
 * UNIX shell
 */

#include	"defs.h"

extern done();

char	*trapcom[MAXTRAP];
BOOL	trapflg[MAXTRAP] =
{
	0,
	0,	/* hangup */
	0,	/* interrupt */
	0,	/* quit */
	0,	/* illegal instr */
	0,	/* trace trap */
	0,	/* IOT */
	0,	/* EMT */
	0,	/* float pt. exp */
	0,	/* kill */
	0, 	/* bus error */
	0,	/* memory faults */
	0,	/* bad sys call */
	0,	/* bad pipe call */
	0,	/* alarm */
	0, 	/* software termination */
	0, 	/* signal 16 */
	0, 	/* signal 17 */
	0, 	/* signal 18 */
	0, 	/* signal 19 */
	0,	/* death of child */
	0, 	/* signal 21 */
	0, 	/* signal 22 */
	0, 	/* signal 23 */
	0, 	/* signal 24 */
	0, 	/* signal 25 */
	0, 	/* signal 26 */
	0, 	/* signal 27 */
	0,	/* user 1 */
	0,	/* user 2 */
	0,	/* power fail */
};

(*(sigval[]))() = 
{
	0,	/* 0 */
	done,	/* 1 */
	fault,	/* 2 */
	fault,	/* 3 */
	done,	/* 4 */
	done,	/* 5 */
	done,	/* 6 */
	done,	/* 7 */
	done,	/* 8 */
	0,	/* 9 */
	done,	/* 10 */
	done,	/* 11 */
	done,	/* 12 */
	done,	/* 13 */
	fault,	/* 14 */
	fault,	/* 15 */
	done,	/* user defined signals 16 */
	done,	/* user defined signal 17 */
	0,	/* child death signal 18 */
	done,	/* power fail signal 19 */
	fault,	/* urgent condition on IO channel signal 20 */
	0,	/* SIGSTOP signals 21 */
	0,	/* SIGSTP signals 22 */
	0,	/* SIGCONT signals 23 */
	fault,	/* SIGTTIN signals 24 */
	fault,	/* SIGTTOU signals 25 */
	fault,	/* SIGIO signals 26 */
	fault,	/* SIGXCUP signals 27 */
	fault,	/* SIGXFSZ signals 28*/
	fault,	/* SIGVTALARM 29 */
	fault	/* SIGPROF signals 30 */
};

/* ========	fault handling routines	   ======== */


fault(sig)
register int	sig;
{
	register int	flag;

#ifdef SIGDEBUG
	printf ("fault: signal %d\n", sig);
#endif

	signal(sig, fault);
	if (sig == SIGSEGV)
	{
		if (setbrk(brkincr) == -1)
			error(nospace);
	}
	else if (sig == SIGALRM)
	{
		if (flags & waiting)
			done();
	}
	else
	{
		flag = (trapcom[sig] ? TRAPSET : SIGSET);
		trapnote |= flag;
		trapflg[sig] |= flag;
		if (sig == SIGINT)
			wasintr++;
	}
}

stdsigs()
{
	setsig(SIGHUP);
	setsig(SIGINT);
	ignsig(SIGQUIT);
	setsig(SIGILL);
	setsig(SIGTRAP);
	setsig(SIGIOT);
	setsig(SIGEMT);
	setsig(SIGFPE);
	setsig(SIGBUS);
	signal(SIGSEGV, fault);
	setsig(SIGSYS);
	setsig(SIGPIPE);
	setsig(SIGALRM);
	setsig(SIGTERM);
	signal(SIGCLD, SIG_DFL);
	ignsig(SIGURG);		/* new signal */
	ignsig(SIGSTOP);	/* new signal */
	ignsig(SIGCONT);	/* new signal */
	ignsig(SIGTTIN);	/* new signal */
	ignsig(SIGTTOU);	/* new signal */
	ignsig(SIGIO);		/* new signal */
	ignsig(SIGXCPU);	/* new signal */
	ignsig(SIGXFSZ);	/* new signal */
	ignsig(SIGVTALRM);	/* new signal */
	ignsig(SIGPROF);	/* new signal */
	setsig(SIGUSR1);
	setsig(SIGUSR2);
}

ignsig(n)
{
	register int	s, i;

	if ((i = n) == SIGSEGV)
	{
		clrsig(i);
		failed(badtrap, "cannot trap 11");
	}
	else if ((s = (signal(i, SIG_IGN) == SIG_IGN)) == 0)
	{
		trapflg[i] |= SIGMOD;
	}
	return(s);
}

getsig(n)
{
	register int	i;

	if (trapflg[i = n] & SIGMOD || ignsig(i) == 0)
		signal(i, fault);
}


setsig(n)
{
	register int	i;

	if (ignsig(i = n) == 0)
		signal(i, sigval[i]);
}

oldsigs()
{
	register int	i;
	register char	*t;

	i = MAXTRAP;
	while (i--)
	{
		t = trapcom[i];
		if (t == 0 || *t)
			clrsig(i);
		trapflg[i] = 0;
	}
	trapnote = 0;
}

clrsig(i)
int	i;
{
	free(trapcom[i]);
	trapcom[i] = 0;
	if (trapflg[i] & SIGMOD)
	{
		trapflg[i] &= ~SIGMOD;
		signal(i, sigval[i]);
	}
}

/*
 * check for traps
 */
chktrap()
{
	register int	i = MAXTRAP;
	register char	*t;

	trapnote &= ~TRAPSET;
	while (--i)
	{
		if (trapflg[i] & TRAPSET)
		{
			trapflg[i] &= ~TRAPSET;
			if (t = trapcom[i])
			{
				int	savxit = exitval;

				execexp(t, 0);
				exitval = savxit;
				exitset();
			}
		}
	}
}
