#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#    	"@(#)sh:sh.mk	1.14"   

TESTDIR	= .
FRC	=
INS	= /etc/install
INC	= $(INCLDIR)
CFLAGS	= -DNICE -DACCT -DNICEVAL=4 $(CFL)
LDFLAGS	= -n $(LFL)
SH	= /bin/sh

OFILES = setbrk.o blok.o stak.o cmd.o fault.o main.o word.o string.o\
name.o args.o xec.o service.o error.o io.o print.o macro.o expand.o\
ctype.o msg.o test.o defs.o echo.o hash.o hashserv.o pwd.o func.o

all:		sh

sh:		$(OFILES)
	$(CC) $(CFLAGS) $(LDFLAGS) $(OFILES) -o $(TESTDIR)/sh

$(OFILES):	defs.h $(FRC)

ctype.o:	ctype.h
		CC=$(CC) $(SH) ./:fix ctype;

xec.o:		xec.c
	set +e;
	$(CC) $(CFLAGS) $(LDFLAGS) -c xec.c;

service.o:	service.c
	$(CC) $(CFLAGS) $(LDFLAGS) -I$(SL)/usr/src/cmd/acct -c service.c

blok.o fault.o main.o stak.o:			brkincr.h
io.o main.o:					dup.h
xec.o hash.o hashserv.o:			hash.h
cwd.o:						mac.h
cmd.o macro.o main.o msg.o word.o xec.o:	sym.h
main.o:						timeout.h


msg.o:		msg.c $(FRC)
		CC=$(CC) $(SH) ./:fix msg;

test:
	  rtest $(TESTDIR)/sh

install:	all
	  $(INS) -r -f $(ROOT)/bin $(TESTDIR)/sh
	  @if [ -f $(ROOT)/bin/rsh ]; \
	  then \
		mv $(ROOT)/bin/rsh $(ROOT)/bin/OLDrsh; \
	  fi
	  ln $(ROOT)/bin/sh $(ROOT)/bin/rsh
	  sync

clean:
	  -rm -f *.o

clobber:  clean
	  -rm -f $(TESTDIR)/sh
	  -rm -f $(ROOT)/bin/OLDrsh

FRC:
