#ifndef lint
static char sccsid[] = "@(#)iostat.c 1.1 85/05/31 SMI"; /* from UCB 4.9 83/09/25 */
#endif
/*
 * iostat
 */
#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <nlist.h>
#include <term.h>
#include <sys/types.h>
#include <sys/buf.h>
#include <sys/dk.h>
#include <sys/vbavar.h>
#include <sys/sysmacros.h>
#include <sys/dsk.h>
#include <sys/vddc.h>

struct nlist nli[] = {
	{ "_dk_busy" },
#define	X_DK_BUSY	0
	{ "_dk_time" },
#define	X_DK_TIME	1
	{ "_dk_xfer" },
#define	X_DK_XFER	2
	{ "_dk_wds" },
#define	X_DK_WDS	3
	{ "_tk_nin" },
#define	X_TK_NIN	4
	{ "_tk_nout" },
#define	X_TK_NOUT	5
	{ "_dk_seek" },
#define	X_DK_SEEK	6
	{ "_cp_time" },
#define	X_CP_TIME	7
	{ "_dk_bps" },
#define	X_DK_BPS	8
	{ "_hz" },
#define	X_HZ		9
	{ "_vbdinit" },
#define X_VBDINIT	10
	{ 0 },
};

char dr_name[DK_NDRIVE][10];

long	name;

struct
{
	int	dk_busy;
	long	cp_time[CPUSTATES];
	long	dk_time[DK_NDRIVE];
	long	dk_wds[DK_NDRIVE];
	long	dk_seek[DK_NDRIVE];
	long	dk_xfer[DK_NDRIVE];
	long 	dk_bps[DK_NDRIVE];
	long	tk_nin;
	long	tk_nout;
} s, s1;

#define	CPUSTE	4
#define	NCOLS	80
#define	NLINES	24
#define	MAXRPT 	4
#define	UNIX	"/unix"

struct
{
	float	tin;
	float	tout;
	float	syste[CPUSTE];
	float	bps[DK_NDRIVE];
	float	tps[DK_NDRIVE];
	float	msps[DK_NDRIVE];
} rec[MAXRPT];

int	mf;
int	hz;
int 	count,repcnt, iter;

double	etime;
extern  void _outch();

main(argc, argv)
char *argv[];
{
	extern char *ctime();
	register  i;
	int iter;
	int	j, totrep;
	double f1, f2;
	long t;
	int	beg_i, end_i,head,hd;
	int tohdr = 1;
	int die();
	int dietty();
	int ptoutput();
	int shiftarray();
	int	TERM;
	
	TERM = isatty(1);
	nlist(UNIX, nli);
	if(nli[X_DK_BUSY].n_value == 0) {
		printf("dk_busy not found in %s namelist\n",UNIX);
		exit(1);
	}
	mf = open("/dev/kmem", 0);
	if(mf < 0) {
		printf("cannot open /dev/kmem\n");
		exit(1);
	}
	while (argc>1&&argv[1][0]=='-') {
		argc--;
		argv++;
	}
	lseek(mf, (long)nli[X_DK_BPS].n_value, 0);
	read(mf, s.dk_bps, sizeof s.dk_bps);
	for (i = 0; i < DK_NDRIVE; i++)
		sprintf (dr_name[i],"??%x",i);

	read_names();  

	totrep = 1;
	if(argc > 2)
		totrep = atoi(argv[2]);
	if (argc ==2)
		totrep = -1;
	iter = 0;
	if ((totrep < 0) || (totrep > MAXRPT))
		repcnt = MAXRPT;
	else
		repcnt = totrep;
	if (TERM){
		initscr();
		signal(SIGINT,dietty);
		nonl();
		crmode();
		noecho();
		leaveok(stdscr, TRUE);
		scrollok(stdscr,FALSE);
		tputs(cursor_invisible, 1, _outch);
	}
	else
		signal(SIGINT,die);
loop:
	head = 4;
	end_i = 0;
	hd=0;
	lseek(mf, (long)nli[X_DK_BUSY].n_value, 0);
 	read(mf, &s.dk_busy, sizeof s.dk_busy);
 	lseek(mf, (long)nli[X_DK_TIME].n_value, 0);
 	read(mf, s.dk_time, sizeof s.dk_time);
 	lseek(mf, (long)nli[X_DK_XFER].n_value, 0);
 	read(mf, s.dk_xfer, sizeof s.dk_xfer);
 	lseek(mf, (long)nli[X_DK_WDS].n_value, 0);
 	read(mf, s.dk_wds, sizeof s.dk_wds);
 	lseek(mf, (long)nli[X_TK_NIN].n_value, 0);
 	read(mf, &s.tk_nin, sizeof s.tk_nin);
 	lseek(mf, (long)nli[X_TK_NOUT].n_value, 0);
 	read(mf, &s.tk_nout, sizeof s.tk_nout);
	lseek(mf, (long)nli[X_DK_SEEK].n_value, 0);
	read(mf, s.dk_seek, sizeof s.dk_seek);
	lseek(mf, (long)nli[X_CP_TIME].n_value, 0);
	read(mf, s.cp_time, sizeof s.cp_time);
	lseek(mf, (long)nli[X_DK_BPS].n_value, 0);
	read(mf, s.dk_bps, sizeof s.dk_bps);
	lseek(mf, (long)nli[X_HZ].n_value, 0);
	read(mf, &hz, sizeof hz);
	for (i = 0; i < DK_NDRIVE; i++) {
#define X(fld)	t = s.fld[i]; s.fld[i] -= s1.fld[i]; s1.fld[i] = t
		X(dk_xfer); X(dk_seek); X(dk_wds); X(dk_time);
	}
	t = s.tk_nin; s.tk_nin -= s1.tk_nin; s1.tk_nin = t;
	t = s.tk_nout; s.tk_nout -= s1.tk_nout; s1.tk_nout = t;
	etime = 0;
	for(i=0; i<CPUSTATES; i++) {
		X(cp_time);
		etime += s.cp_time[i];
	}
	if (etime == 0.0)
		etime = 1.0;
	etime /= hz;
	rec[iter].tin = s.tk_nin/etime;
	rec[iter].tout = s.tk_nout/etime;
	for (i=0; i<DK_NDRIVE; i++){
		if(dr_name[i][0] != '?'){
			stats(i,iter);
		}
	}
	for (i=0; i<CPUSTATES; i++)
		stat1(i,iter);
	count++;
prt_loop:
	beg_i = hd;
	if (TERM) {
		if (head == 4)
			printw(" tty  tin tout     cpu    us ni sy id    ");
		for (i = hd; i < DK_NDRIVE; i++){ 
			if (dr_name[i][0] != '?'){
				printw("      %3.3s      ",dr_name[i]);
				head++;
				if ((head % 5 )== 0)
					break;
			}
		}
		if (head !=5 )
			printw ("\n");
		if (i == DK_NDRIVE)
			i--;
		end_i = i;
		for (i = beg_i; i <= end_i; i++)
			if(dr_name[i][0] != '?')
				printw(" kbps tps msps ");
		printw ("\n");
		for(i = 0; i < (iter+1); i++){
			if (hd == 0){
			  	printw("     %4.0f%5.0f           ",rec[i].tin,rec[i].tout);
				for (j = 0; j < CPUSTE; j++)
					printw("%3.0f",rec[i].syste[j]);
			   	printw("                   ");
			}	
			for (j = beg_i; j <= end_i; j++)
				if (dr_name[j][0] != '?')
			      	printw("%4.0f%4.0f%6.1f ",
				  rec[i].bps[j], rec[i].tps[j],
				  rec[i].msps[j]);
			printw ("\n");
		}
		for(i=(iter+1); i<repcnt; i++)
			printw("\n");
		if (end_i < (DK_NDRIVE-1) ){
			hd = end_i+1;
			goto prt_loop;
		}
		refresh();
		move(0,0);     
	}
	else
	     if ((count >= MAXRPT) &&( (count % MAXRPT ) == 0))
			ptoutput(iter+1);

	if (totrep > 0 )
		totrep--;
	iter++;

	if (count >=  MAXRPT ){
		for(i=0; i < (MAXRPT -1); i++){
			shiftarray(i,1);
		}
		iter = MAXRPT-1;
		if ( ! TERM )
			printf("\n");
	}
/*

	if (count >= MAXRPT) {
		for(i = 0; i < (MAXRPT-1); i ++){
			rec[i].tin = rec[i+1].tin;
			rec[i].tout = rec[i+1].tout;
			for(j=0; j < CPUSTATES; j++)
				rec[i].syste[j] = rec[i+1].syste[j];
			for(j=0; j< DK_NDRIVE; j++){
				rec[i].bps[j] =rec[i+1].bps[j];
				rec[i].tps[j] =rec[i+1].tps[j];
				rec[i].msps[j] =rec[i+1].msps[j];
			}
		}
	iter = MAXRPT -1;
	}
*/

	if (totrep != 0 ){
		if(argc > 1) {
			sleep(atoi(argv[1]));     
			goto loop;
		}
	}
	if(TERM)
		dietty();
	else
		die();
}

stats(dn,cnt)
{
	register i;
	double atime, bytes, xtime, itime;
/*
	if (s.dk_bps[dn] == 0.0) {
		rec[cnt].bps[dn] = 0.0;
		rec[cnt].tps[dn] = 0.0; 
		rec[cnt].msps[dn] = 0.0;
		return;
	}
*/
	atime = s.dk_time[dn];
	atime /= hz;
	bytes = s.dk_wds[dn]*32.0;      /* number of bytes transferred */
	xtime = bytes/s.dk_bps[dn];	/* transfer time */
	itime = atime - xtime;		/* time not transferring */
	if (xtime < 0)
		itime += xtime, xtime = 0;
	if (itime < 0)
		xtime += itime, itime = 0;
	rec[cnt].bps[dn] = bytes/1024/etime;
	rec[cnt].tps[dn] = s.dk_xfer[dn]/etime; 
	rec[cnt].msps[dn] = s.dk_seek[dn] ? itime*1000./s.dk_seek[dn] : 0.0;
}

stat1(o,ict)
{
	register i;
	double time;

	time = 0;
	for(i=0; i<CPUSTATES; i++)
		time += s.cp_time[i];
	if (time == 0.0)
		time = 1.0;
	rec[ict].syste[o] = 100*s.cp_time[o]/time;
}

#define steal(where, var) lseek(mf, where, 0); read(mf, &var, sizeof var);

read_names()
{
	struct vba_device udev, *up;
	int	unit ;

	up = (struct vba_device *) nli[X_VBDINIT].n_value;
	if (up == 0)
	{
		fprintf(stderr, "iostat: Disk init info not in namelist\n");
		exit(1);
	}

	for (;;) {

		steal(up++, udev);

		if (udev.ui_driver == 0)
			break;
		if (udev.ui_dk <= 0 || udev.ui_alive == 0)
			continue;
		unit = udev.ui_unit ;
		if (unit > DK_NDRIVE)
			continue ;

		dr_name[unit][0] = 'd' ;
		dr_name[unit][1] = 's' ;

	}
}
die()
{
	int	i,j,k;
	iter--;
	signal(SIGINT,SIG_IGN);
	i = count % MAXRPT;
	if (count >= MAXRPT){
		k = MAXRPT - i;
		for (j=0; j <i; j++)
			shiftarray(0,k);
	}
	ptoutput(i);
	exit(0);
}
dietty()
{
	signal(SIGINT, SIG_IGN);
	mvcur(0,COLS-1, LINES-1,0);
	endwin();
	exit(0);
}
ptoutput(reptot)
	int reptot;
{
register	i,j;
int	doneflg,head,end_i,beg_i;
	head = 4;
	beg_i = 0;
	doneflg=0;
	printf(" tty  tin tout     cpu    us ni sy id    ");
	while (!doneflg){
	  for (i = beg_i; i < DK_NDRIVE; i++){ 
		if (dr_name[i][0] != '?'){
			printf("      %3.3s      ",dr_name[i]);
			head++;
			if ((head % 5 )== 0)
				break;
		}
	  }
	  if (head !=5 )
			printf ("\n");
	  if (i == DK_NDRIVE){
		i--;
		doneflg++;
		}
	  end_i = i;
	  for (i = beg_i; i <= end_i; i++)
		if(dr_name[i][0] != '?')
			printf(" kbps tps msps ");
	  printf ("\n");
	  for(i = 0; i < reptot; i++){
		if (head == 5){
		        printf("     %4.0f%5.0f           ",
			       rec[i].tin,rec[i].tout);
			for (j = 0; j < CPUSTE; j++)
				printf("%3.0f",rec[i].syste[j]);
			printf("                   ");
		}
		for (j = beg_i; j <= end_i; j++)
			if (dr_name[j][0] != '?'){
			      printf("%4.0f%4.0f%6.1f ", rec[i].bps[j],
			      rec[i].tps[j],rec[i].msps[j]);
			}
		printf ("\n");
	  }
	  for(i=reptot; i<repcnt; i++)
			printf("\n");
	beg_i = end_i+1;
	}
}
shiftarray(srtary,offset)
	int	srtary; /* starting array to be shifted	*/
	int	offset;	/* offset to be skip in shifting array  */ 
{
register	j;
	rec[srtary].tin = rec[srtary+offset].tin;
	rec[srtary].tout = rec[srtary+offset].tout;
	for(j=0; j < CPUSTATES; j++)
		rec[srtary].syste[j] = rec[srtary+offset].syste[j];
	for(j=0; j< DK_NDRIVE; j++){
		rec[srtary].bps[j] =rec[srtary+offset].bps[j];
		rec[srtary].tps[j] =rec[srtary+offset].tps[j];
		rec[srtary].msps[j] =rec[srtary+offset].msps[j];
	}
}
