#ifndef lint
static	char *sccsid = "@(#)vmstat.c	4.11 (Berkeley) 9/25/83";
#endif

#include <curses.h>
#include <term.h>
#include <signal.h>
#include <dsktyp.h>
#include <stdio.h>
#include <sys/param.h>
#include <sys/vm.h>
#include <sys/dk.h>
#include <nlist.h>
#include <sys/buf.h>
#include <sys/vbavar.h>
/*
#include "vddc.h"
*/
#include <sys/dsk.h>
#include <sys/vddc.h>

struct nlist nli[] = {
#define	X_CPTIME	0
	{ "_cp_time" },
#define	X_RATE		1
	{ "_rate" },
#define X_TOTAL		2
	{ "_total" },
#define	X_DEFICIT	3
	{ "_deficit" },
#define	X_FORKSTAT	4
	{ "_forkstat" },
#define X_SUM		5
	{ "_sum" },
#define	X_FIRSTFREE	6
	{ "_firstfree" },
#define	X_MAXFREE	7
	{ "_maxfree" },
#define	X_BOOTTIME	8
	{ "_boottime" },
#define	X_DKXFER	9
	{ "_dk_xfer" },
#define X_VBDINIT	10
	{ "_vbdinit" },
#define X_REC		11
	{ "_rectime" },
#define X_PGIN		12
	{ "_pgintime" },
#define X_HZ		13
	{ "_hz" },
	{ "" },
};

#define	UNIX	"/unix"
char dr_name[DK_NDRIVE][10];
double	stat1();
int	firstfree, maxfree;
int	hz;
struct
{
	int	busy;
	long	time[CPUSTATES];
	long	xfer[DK_NDRIVE];
	struct	vmmeter Rate;
	struct	vmtotal	Total;
	struct	vmmeter Sum;
	struct	forkstat Forkstat;
	unsigned rectime;
	unsigned pgintime;
} s, s1, z;
#define	rate		s.Rate
#define	total		s.Total
#define	sum		s.Sum
#define	forkstat	s.Forkstat
#define	MAXRPT	10
#define	NCOLS	80
#define	NLINES	24

struct	vmmeter osum;
int	zero;
int	deficit;
double	etime;
int 	mf;
int	swflag;
float	f; 
int	iter,count,repcnt;
long 	name;

struct
{
int	r;
int	b;
int	w;
int	avm;
int	fre;
int	pgre;
int	pgat;
int	pi;
int	po;
int	fr;
int	de;
int	sr;
float	dk[DK_NDRIVE];
int	in;
int	sy;
int	cs;
float	syste[(CPUSTATES-1)];
/*
int	us;
int	sy;
int	id;
*/
} rec[MAXRPT];

main(argc, argv)
	int argc;
	char **argv;
{
	extern char *ctime();
	register i,j;
	int nintv;
	int totrep;
	time_t boottime;
	double f1, f2;
	long t;
	extern char _sobuf[];
	int die();
	int ptoutput();
	int shiftarray();
	int dietty();
	int	TERM;
	time_t now;

	TERM = isatty(1);
	setbuf(stdout, _sobuf);
	nlist(UNIX, nli);
	if(nli[0].n_value == 0) {
		printf("no %s namelist\n",UNIX);
		exit(1);
	}
	mf = open("/dev/kmem", 0);
	if(mf < 0) {
		printf("cannot open /dev/kmem\n");
		exit(1);
	}
	iter = 0;
	argc--, argv++;
	while (argc>0 && argv[0][0]=='-') {
		char *cp = *argv++;
		argc--;
		while (*++cp) switch (*cp) {

		case 'S':
			swflag = 1 - swflag;
			break;


		case 't':
			dotimes();
			exit(0);

		case 'z':
			close(mf);
			mf = open("/dev/kmem", 2);
			lseek(mf, (long)nli[X_SUM].n_value, 0);
			write(mf, &z.Sum, sizeof z.Sum);
			exit(0);

		case 'f':
			doforkst();
			exit(0);
		
		case 's':
			dosum();
			exit(0);

		default:
			fprintf(stderr, "usage: vmstat [ -fs ] [ interval ] [ count]\n");
			exit(1);
		}
	}
	totrep = 1;
	if(argc > 1)
		totrep = atoi(argv[1]);
	if(argc ==1)
		totrep = -1;
	iter = 0;
	if ((totrep <0 ) || (totrep > MAXRPT))
		repcnt = MAXRPT;
	else
		repcnt = totrep;
	lseek(mf, (long)nli[X_FIRSTFREE].n_value, 0);
	read(mf, &firstfree, sizeof firstfree);
	lseek(mf, (long)nli[X_MAXFREE].n_value, 0);
	read(mf, &maxfree, sizeof maxfree);
	lseek(mf, (long)nli[X_BOOTTIME].n_value, 0);
	read(mf, &boottime, sizeof boottime);
	lseek(mf, (long)nli[X_HZ].n_value, 0);
	read(mf, &hz, sizeof hz);
	for (i = 0; i < DK_NDRIVE; i++) 
		sprintf(dr_name[i],"??%x",i);

	read_names();

	time(&now);
	nintv = now - boottime;
	if (nintv <= 0 || nintv > 60*60*24*365*10) {
		printf("Time makes no sense... namelist must be wrong.\n");
		exit(1);
	}
	if (TERM){
		initscr();
		signal(SIGINT,dietty);
		nonl();
		crmode();
		noecho();
		leaveok(stdscr,TRUE);
		scrollok(stdscr,FALSE);
	}
	else
		signal(SIGINT,die);
reprint:
loop:
	lseek(mf, (long)nli[X_CPTIME].n_value, 0);
 	read(mf, s.time, sizeof s.time);
	lseek(mf, (long)nli[X_DKXFER].n_value, 0);
	read(mf, s.xfer, sizeof s.xfer);
	if (nintv != 1) {
		lseek(mf, (long)nli[X_SUM].n_value, 0);
		read(mf, &rate, sizeof rate);
	} else {
		lseek(mf, (long)nli[X_RATE].n_value, 0);
		read(mf, &rate, sizeof rate);
	}
	lseek(mf, (long)nli[X_TOTAL].n_value, 0);
	read(mf, &total, sizeof total);
	osum = sum;
	lseek(mf, (long)nli[X_SUM].n_value, 0);
	read(mf, &sum, sizeof sum);
	lseek(mf, (long)nli[X_DEFICIT].n_value, 0);
	read(mf, &deficit, sizeof deficit);
	etime = 0;
	for (i=0; i < DK_NDRIVE; i++) {
		t = s.xfer[i];
		s.xfer[i] -= s1.xfer[i];
		s1.xfer[i] = t;
	}
	for (i=0; i < CPUSTATES; i++) {
		t = s.time[i];
		s.time[i] -= s1.time[i];
		s1.time[i] = t;
		etime += s.time[i];
	}
	if(etime == 0.)
		etime = 1.;
	rec[iter].r = total.t_rq;
	rec[iter].b = total.t_dw+total.t_pw;
	rec[iter].w = total.t_sw;
	rec[iter].avm= total.t_avm;
	rec[iter].fre = total.t_free;
	if(swflag){
	        rec[iter].pgre= sum.v_swpin-osum.v_swpin ;
		rec[iter].pgat = sum.v_swpout-osum.v_swpout ;
	}
	else {

	        rec[iter].pgre = (rate.v_pgrec - (rate.v_xsfrec+rate.v_xifrec))/nintv;
	        rec[iter].pgat = (rate.v_xsfrec+rate.v_xifrec)/nintv;
	}
	rec[iter].pi = rate.v_pgpgin/nintv;
	rec[iter].po= rate.v_pgpgout/nintv;
	rec[iter].fr= rate.v_dfree/nintv;
	rec[iter].de = deficit;
	rec[iter].sr = rate.v_scan/nintv;
	etime /= (float) hz;
	for(i=0; i < DK_NDRIVE; i++){
		rec[iter].dk[i] =  s.xfer[i]/etime;
	}
	rec[iter].in= (rate.v_intr/nintv) - hz; 
	rec[iter].sy = rate.v_syscall/nintv;
	rec[iter].cs = rate.v_swtch/nintv;
	for(i=0; i<CPUSTATES; i++) {
		f = stat1(i);
		if (i == 0) {		/* US+NI */
			i++;
			f += stat1(i);
		}
		rec[iter].syste[i-1] = f;
	}
	nintv = 1;
	count++;
	if (count >= MAXRPT)
		if ( (count % MAXRPT) ==  0)
	    		if(TERM == 0)
				ptoutput(iter+1);
	if(TERM)
	{
	  printw("mem[avm  fre] pag[%5s  pi  po  fr  de  sr] fault[in  sy  cs] cpu[us sy id]\n", swflag ? "si so" : "re at");
	for(i=0; i < (iter+1); i++){
	     printw("%7d%7d  %4d%3d%4d%4d%4d%4d%4d     %5d%4d%4d     ",
  		  rec[i].avm,rec[i].fre, rec[i].pgre,rec[i].pgat,
		  rec[i].pi,rec[i].po,rec[i].fr, rec[i].de,rec[i].sr,
		  rec[i].in,rec[i].sy,rec[i].cs);
    	   for(j=0; j<( CPUSTATES -1); j++)
			  printw("%3.0f",rec[i].syste[j]);
		  printw("\n");
	}
	for(i=(iter+1); i<repcnt; i++)
		  printw("\n");
	  printw("proc[r b w]Dsk["); 
	for (i=0; i < DK_NDRIVE; i++)
		if(dr_name[i][0] !='?')
			  printw("%3.3s ",dr_name[i]);
	  printw("]\n");
	for(i=0; i < (iter+1); i++){
		  printw("    %2d%2d%2d    ",rec[i].r,rec[i].b,rec[i].w);
		for(j=0; j<DK_NDRIVE; j++)
			if(dr_name[j][0] !='?')
				  printw("%3.0f ",rec[i].dk[j]);
	  printw("\n");
	}
	for (i=(iter+1); i< repcnt; i++)
		  printw("\n");
	  refresh();
	  move(0,0);
	}
	if (totrep > 0)
		totrep--;
	iter++;
	if (count >=  MAXRPT ){
		for(i=0; i < (MAXRPT -1); i++){
			shiftarray(i,1);
		}
		iter = MAXRPT-1;
	}

	if (totrep != 0){
		if(argc > 0) {
			sleep(atoi(argv[0]));
			goto loop;
		}
	}
	if(TERM)
		dietty();
	else {
		die();
	}
}

dotimes()
{

	lseek(mf, (long)nli[X_REC].n_value, 0);
	read(mf, &s.rectime, sizeof s.rectime);
	lseek(mf, (long)nli[X_PGIN].n_value, 0);
	read(mf, &s.pgintime, sizeof s.pgintime);
	lseek(mf, (long)nli[X_SUM].n_value, 0);
	read(mf, &sum, sizeof sum);
	printf("%d reclaims, %d total time (usec)\n", sum.v_pgrec, s.rectime);
	printf("average: %d usec / reclaim\n", s.rectime/sum.v_pgrec);
	printf("\n");
	printf("%d page ins, %d total time (msec)\n",sum.v_pgin, s.pgintime/10);
	printf("average: %8.1f msec / page in\n", s.pgintime/(sum.v_pgin*10.0));
}

dosum()
{

	lseek(mf, (long)nli[X_SUM].n_value, 0);
	read(mf, &sum, sizeof sum);
	printf("%9d swap ins\n", sum.v_swpin);
	printf("%9d swap outs\n", sum.v_swpout);
	printf("%9d pages swapped in\n", sum.v_pswpin / CLSIZE);
	printf("%9d pages swapped out\n", sum.v_pswpout / CLSIZE);
	printf("%9d total address trans. faults taken\n", sum.v_faults);
	printf("%9d page ins\n", sum.v_pgin);
	printf("%9d page outs\n", sum.v_pgout);
	printf("%9d pages paged in\n", sum.v_pgpgin);
	printf("%9d pages paged out\n", sum.v_pgpgout);
	printf("%9d sequential process pages freed\n", sum.v_seqfree);
	printf("%9d total reclaims (%d%% fast)\n", sum.v_pgrec,
	    (sum.v_fastpgrec * 100) / (sum.v_pgrec == 0 ? 1 : sum.v_pgrec));
	printf("%9d reclaims from free list\n", sum.v_pgfrec);
	printf("%9d intransit blocking page faults\n", sum.v_intrans);
	printf("%9d zero fill pages created\n", sum.v_nzfod / CLSIZE);
	printf("%9d zero fill page faults\n", sum.v_zfod / CLSIZE);
	printf("%9d executable fill pages created\n", sum.v_nexfod / CLSIZE);
	printf("%9d executable fill page faults\n", sum.v_exfod / CLSIZE);
	printf("%9d swap text pages found in free list\n", sum.v_xsfrec);
	printf("%9d inode text pages found in free list\n", sum.v_xifrec);
	printf("%9d file fill pages created\n", sum.v_nvrfod / CLSIZE);
	printf("%9d file fill page faults\n", sum.v_vrfod / CLSIZE);
	printf("%9d pages examined by the clock daemon\n", sum.v_scan);
	printf("%9d revolutions of the clock hand\n", sum.v_rev);
	printf("%9d pages freed by the clock daemon\n", sum.v_dfree / CLSIZE);
	printf("%9d cpu context switches\n", sum.v_swtch);
	printf("%9d device interrupts\n", sum.v_intr);
	printf("%9d pseduo-dma dz interrupts\n", sum.v_pdma);
	printf("%9d traps\n", sum.v_trap);
	printf("%9d system calls\n", sum.v_syscall);
}

doforkst()
{

	lseek(mf, (long)nli[X_FORKSTAT].n_value, 0);
	read(mf, &forkstat, sizeof forkstat);
	printf("%d forks, %d pages, average=%.2f\n",
		forkstat.cntfork, forkstat.sizfork,
		(float) forkstat.sizfork / forkstat.cntfork);
	printf("%d vforks, %d pages, average=%.2f\n",
		forkstat.cntvfork, forkstat.sizvfork,
		(float)forkstat.sizvfork / forkstat.cntvfork);
}

stats(dn)
{

	if (dn >= DK_NDRIVE) {
		printf("  0");
		return;
	}
	printf("%3.0f", s.xfer[dn]/etime);
}

double
stat1(row)
{
	double t;
	register i;

	t = 0;
	for(i=0; i<CPUSTATES; i++)
		t += s.time[i];
	if(t == 0.)
		t = 1.;
	return(s.time[row]*100./t);
}

pct(top, bot)
{

	if (bot == 0)
		return (0);
	return ((top * 100) / bot);
}

#define steal(where, var) lseek(mf, where, 0); read(mf, &var, sizeof var);

read_names()
{
	struct vba_device udev, *up;
	int	unit ;

	up = (struct vba_device *) nli[X_VBDINIT].n_value;
	if (up == 0)
	{
		fprintf(stderr, "vmstat: Disk init info not in namelist\n");
		exit(1);
	}

	for (;;) {

		steal(up++, udev);

		if (udev.ui_driver == 0)
			break;
		if (udev.ui_dk <= 0 || udev.ui_alive == 0)
			continue;
		unit = udev.ui_unit ;
		if (unit > DK_NDRIVE)
			continue ;

		dr_name[unit][0] = 'd' ;
		dr_name[unit][1] = 's' ;

	}
}
die()
{
	int	i,j,k;
	iter--;
	signal(SIGINT,SIG_IGN);
	i = count % MAXRPT;
	if (count >= MAXRPT){
		k = MAXRPT - i;
		for (j=0; j <i; j++)
			shiftarray(0,k);
	}
	ptoutput(i);
	exit(0);
}
dietty()
{
	signal(SIGINT,SIG_IGN);
	mvcur(0,COLS-1, LINES-1,0);
	endwin();
	exit(0);
}
ptoutput(reptot)
	int	reptot;
{
register 	i,j;
	  printf("mem[avm  fre] pag[%5s  pi  po  fr  de  sr] fault[in  sy  cs] cpu[us sy id]\n", swflag ? "si so" : "re at");
	for(i=0; i < (reptot); i++){
	     printf(" %6d%5d    %4d%3d%4d%4d%4d%4d%4d      %4d%4d%4d     ",
  		  rec[i].avm,rec[i].fre, rec[i].pgre,rec[i].pgat,
		  rec[i].pi,rec[i].po,rec[i].fr, rec[i].de,rec[i].sr,
		  rec[i].in,rec[i].sy,rec[i].cs);
    	   for(j=0; j<( CPUSTATES -1); j++)
			  printf("%3.0f",rec[i].syste[j]);
		  printf("\n");
	}
	for(i=(reptot); i<repcnt; i++)
		  printf("\n");

	printf("proc[r b w]Dsk["); 

	for (i=0; i < DK_NDRIVE; i++)
		if(dr_name[i][0] !='?')
			  printf("%3.3s ",dr_name[i]);
	  printf("]\n");
	for(i=0; i < (reptot); i++){
		  printf("    %2d%2d%2d    ",rec[i].r,rec[i].b,rec[i].w);
		for(j=0; j<DK_NDRIVE; j++)
			if(dr_name[j][0] !='?')
				  printf("%3.0f ",rec[i].dk[j]);
	  printf("\n");
	}
	for (i=(reptot); i< repcnt; i++)
		  printf("\n");
}
shiftarray(srtary,offset)
	int	srtary; /* starting array to be shifted	*/
	int	offset;	/* offset to be skip in shifting array  */ 
{
register	j;
	rec[srtary].r = rec[srtary+offset].r;
	rec[srtary].b = rec[srtary+offset].b;
	rec[srtary].w = rec[srtary+offset].w;
	rec[srtary].avm = rec[srtary+offset].avm;
	rec[srtary].fre = rec[srtary+offset].fre;
	rec[srtary].pgre = rec[srtary+offset].pgre;
	rec[srtary].pgat = rec[srtary+offset].pgat;
	rec[srtary].pi = rec[srtary+offset].pi;
	rec[srtary].po = rec[srtary+offset].po;
	rec[srtary].fr = rec[srtary+offset].fr;
	rec[srtary].de = rec[srtary+offset].de;
	rec[srtary].sr = rec[srtary+offset].sr;
	for(j=0; j < DK_NDRIVE; j++)
		rec[srtary].dk[j] = rec[srtary+offset].dk[j];
	rec[srtary].in = rec[srtary+offset].in;
	rec[srtary].sy = rec[srtary+offset].sy;
	rec[srtary].cs = rec[srtary+offset].cs;
	for(j=0; j < (CPUSTATES-1); j++)
		rec[srtary].syste[j] = rec[srtary+offset].syste[j];
}
