/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */

#ifndef lint
char copyright[] =
"@(#) Copyright (c) 1983 Regents of the University of California.\n\
 All rights reserved.\n";
#endif not lint

#ifndef lint
static char sccsid[] = "@(#)talkd.c	5.1 (Berkeley) 6/6/85";
#endif not lint

/*
 * The top level of the daemon, the format is heavily borrowed
 * from rwhod.c. Basically: find out who and where you are; 
 * disconnect all descriptors and ttys, and then endless
 * loop on waiting for and processing requests
 */
#include <stdio.h>
#include <errno.h>
#include <signal.h>

#include "ctl.h"

struct	sockaddr_in sin = { AF_INET };

CTL_MSG		request;
CTL_RESPONSE	response;

int	sockt;
int	debug = 0;
FILE	*debugout;
int	timeout();
long	lastmsgtime;

char	hostname[32];

#define TIMEOUT 30
#define MAXIDLE 120

main(argc, argv)
	int argc;
	char *argv[];
{
	struct sockaddr_in from;
	int fromlen, cc;
	char netbuf[sizeof(CTL_RESPONSE)]; /* for sending a ctl_response struct */
	
	if (debug)
		debugout = (FILE *)fopen ("/usr/tmp/talkd.msgs", "w");

	if (getuid()) {
		fprintf(stderr, "Talkd : not super user\n");
		exit(1);
	}
	gethostname(hostname, sizeof (hostname));
	(void) chdir("/dev");
	signal(SIGALRM, timeout);
	alarm(TIMEOUT);
	for (;;) {
		extern int errno;

		fromlen = sizeof(from);
		cc = recvfrom(0, (char *)&request, sizeof (request), 0,
		    &from, &fromlen);
		if (cc != sizeof(request)) {
			if (cc < 0 && errno != EINTR)
			perror("recvfrom");
			continue;
		}
		lastmsgtime = time(0);
		swapmsg(&request);
		if (debug) print_request(&request);
		process_request(&request, &response);

		/* Before sending the response, compress the
		 * ctl_response struct values into a character buffer.
		 */
		response_out(&response, &netbuf[0]);

		/* can block here, is this what I want? */
		cc = sendto(sockt, &netbuf[0],
		    sizeof (response), 0, &request.ctl_addr,
		    sizeof (request.ctl_addr));
		if (cc != sizeof(response))
			perror("sendto");
	}
}

timeout()
{

	if (time(0) - lastmsgtime >= MAXIDLE)
		exit(0);
	alarm(TIMEOUT);
}

/*  
 * heuristic to detect if need to swap bytes
 */

swapmsg(req)
	CTL_MSG *req;
{
	if (req->ctl_addr.sin_family == ntohs(AF_INET)) {
		req->id_num = ntohl(req->id_num);
		req->pid = ntohl(req->pid);
		req->addr.sin_family = ntohs(req->addr.sin_family);
		req->ctl_addr.sin_family =
			ntohs(req->ctl_addr.sin_family);
	}
}

/*
 * This routine compresses the contents of a ctl_response struct
 * into a character buffer.  This is done since our ctl_response
 * struct has a hole in it due to word alignment of the id_num field.
 *
 * The HCX sends responses which look just like 'sun' responses.
 * A VAX may not be able to read the respsonse unless it is running
 * BSD4.3 which solves that entire problem.
 */
response_out(response, buffer)
        CTL_RESPONSE *response;
        char *buffer;
{
        char *resp;
        int i;
        resp = (char *)response;

        /* move the type and answer fields into the char buffer. */
        *(buffer) = response->type;
        *(buffer+1) = response->answer;

        /* Now move the id_num field.  This is where a 2 byte hole
         * is located in the ctl_response struct.
         */
        for (i=0; i < sizeof(int); i++) {
                *(buffer+2+i) = *(resp+4+i);
        }

        /* Now move the addr field into the character buffer. */
        for (i=0; i < sizeof(struct sockaddr_in); i++) {
                *(buffer+6+i) = *(resp+8+i);
        }
}
