# @(#)yp.mk	1.2 86/11/21 NFSSRC
#
# @(#)yp.mk 1.1 86/09/25 (C) 1985 SMI
#
SRCS = makedbm.c stdhosts.c yppush.c ypset.c ypxfr.c yppoll.c 
SUBDIR = revnetgroup
CFLAGS = -O ${CFL}
TOUCH =	touch -cf
SCRIPT= ypinit ypxfr_1perday ypxfr_2perday ypxfr_1perhour
LIBS = -ldbm

all: makedbm yppush stdhosts ypset ypxfr yppoll 

makedbm: makedbm.o
	${CC} $(CFLAGS) makedbm.o -o makedbm $(LIBS)

yppush: yppush.o
	${CC} $(CFLAGS) yppush.o -o yppush

ypset: ypset.o
	${CC} $(CFLAGS) ypset.o -o ypset

ypxfr: ypxfr.o
	${CC} $(CFLAGS) ypxfr.o -o ypxfr $(LIBS)

yppoll: yppoll.o
	${CC} $(CFLAGS) yppoll.o -o yppoll

stdhosts: stdhosts.o
	${CC} $(CFLAGS) stdhosts.o -o stdhosts

install: all
	-mkdir ${ROOT}/usr/etc/yp && chown bin ${ROOT}/usr/etc/yp && \
		chmod 755 ${ROOT}/usr/etc/yp
	install -r -f $(ROOT)/usr/etc/yp makedbm
	install -r -f $(ROOT)/usr/etc/yp yppush
	install -r -f $(ROOT)/usr/etc/yp ypset
	install -r -f $(ROOT)/usr/etc/yp ypxfr
	install -r -f $(ROOT)/usr/etc/yp yppoll
	install -r -f $(ROOT)/usr/etc/yp stdhosts
	for i in ${SCRIPT}; \
		do (cp $$i.sh $$i ; \
		install -r -f ${ROOT}/usr/etc/yp $$i ; \
		rm $$i ; ); done
	for i in $(SUBDIR); do \
		(cd $$i; make $(MFLAGS) install); done

	cp make.script ${ROOT}/usr/etc/yp/Makefile
	rm -rf ${ROOT}/etc/yp
	ln -s /usr/etc/yp ${ROOT}/etc/yp

clean:
	rm -f *.o
	for i in $(SUBDIR); do (cd $$i; make $(MFLAGS) clean); done

clobber:
	rm -f *.o makedbm yppush stdhosts ypset ypxfr yppoll
	for i in $(SUBDIR); do (cd $$i; make $(MFLAGS) clobber); done

lint:
	lint $(SRCS)

print:
	pr $(SRCS) | lpr

depend:
	cp /dev/null x.c
	for i in $(SRCS) ; do \
		(/bin/grep '^#[ 	]*include' x.c $$i | sed \
			-e '/\.\.\/h/d' \
			-e '/\.\.\/ufs/d' \
			-e 's,<\(.*\)>,"$$(SL)\/usr\/include/\1",' \
			-e 's/:[^"]*"\([^"]*\)".*/: \1/' \
			-e 's/\.c/\.o/' >>makedep); done
	echo '/^# DO NOT DELETE THIS LINE/+2,$$d' >eddep
	echo '$$r makedep' >>eddep
	echo 'w' >>eddep
	cp yp.mk yp.mk.bak
	ed - yp.mk < eddep
	rm eddep makedep x.c
	echo '# DEPENDENCIES MUST END AT END OF FILE' >> yp.mk
	echo '# IF YOU PUT STUFF HERE IT WILL GO AWAY' >> yp.mk
	echo '# see make depend above' >> yp.mk

# DO NOT DELETE THIS LINE -- make depend uses it

makedbm.o: $(SL)/usr/include/dbm.h
makedbm.o: $(SL)/usr/include/stdio.h
makedbm.o: $(SL)/usr/include/sys/file.h
makedbm.o: $(SL)/usr/include/sys/param.h
makedbm.o: $(SL)/usr/include/sys/stat.h
stdhosts.o: $(SL)/usr/include/stdio.h
yppush.o: $(SL)/usr/include/stdio.h
yppush.o: $(SL)/usr/include/errno.h
yppush.o: $(SL)/usr/include/signal.h
yppush.o: $(SL)/usr/include/sys/time.h
yppush.o: $(SL)/usr/include/sys/wait.h
yppush.o: $(SL)/usr/include/ctype.h
yppush.o: $(SL)/usr/include/netdb.h
yppush.o: $(SL)/usr/include/rpc/rpc.h
yppush.o: $(SL)/usr/include/sys/socket.h
yppush.o: $(SL)/usr/include/rpc/pmap_clnt.h
yppush.o: $(SL)/usr/include/rpcsvc/ypclnt.h
yppush.o: $(SL)/usr/include/rpcsvc/yp_prot.h
yppush.o: $(SL)/usr/include/rpcsvc/ypv1_prot.h
ypset.o: $(SL)/usr/include/stdio.h
ypset.o: $(SL)/usr/include/sys/time.h
ypset.o: $(SL)/usr/include/ctype.h
ypset.o: $(SL)/usr/include/rpc/rpc.h
ypset.o: $(SL)/usr/include/sys/socket.h
ypset.o: $(SL)/usr/include/rpcsvc/ypclnt.h
ypset.o: $(SL)/usr/include/rpcsvc/yp_prot.h
ypset.o: $(SL)/usr/include/rpcsvc/ypv1_prot.h
ypxfr.o: $(SL)/usr/include/dbm.h
ypxfr.o: $(SL)/usr/include/stdio.h
ypxfr.o: $(SL)/usr/include/errno.h
ypxfr.o: $(SL)/usr/include/sys/time.h
ypxfr.o: $(SL)/usr/include/ctype.h
ypxfr.o: $(SL)/usr/include/netdb.h
ypxfr.o: $(SL)/usr/include/rpc/rpc.h
ypxfr.o: $(SL)/usr/include/sys/socket.h
ypxfr.o: $(SL)/usr/include/sys/dir.h
ypxfr.o: $(SL)/usr/include/sys/file.h
ypxfr.o: $(SL)/usr/include/sys/stat.h
ypxfr.o: $(SL)/usr/include/rpcsvc/ypclnt.h
ypxfr.o: $(SL)/usr/include/rpcsvc/yp_prot.h
ypxfr.o: $(SL)/usr/include/rpcsvc/ypv1_prot.h
yppoll.o: $(SL)/usr/include/stdio.h
yppoll.o: $(SL)/usr/include/sys/time.h
yppoll.o: $(SL)/usr/include/ctype.h
yppoll.o: $(SL)/usr/include/netdb.h
yppoll.o: $(SL)/usr/include/rpc/rpc.h
yppoll.o: $(SL)/usr/include/sys/socket.h
yppoll.o: $(SL)/usr/include/rpcsvc/ypclnt.h
yppoll.o: $(SL)/usr/include/rpcsvc/yp_prot.h
yppoll.o: $(SL)/usr/include/rpcsvc/ypv1_prot.h
# DEPENDENCIES MUST END AT END OF FILE
# IF YOU PUT STUFF HERE IT WILL GO AWAY
# see make depend above
