static char Sccsid[]="@(#)setsig.c	3.3";
# include	"signal.h"
# include	"sys/types.h"
# include	"macros.h"

#define ONSIG	31

/*
	General-purpose signal setting routine.
	All non-ignored, non-caught signals are caught.
	If a signal other than hangup, interrupt, or quit is caught,
	a "user-oriented" message is printed on file descriptor 2 with
	a number for help(I).
	If hangup, interrupt or quit is caught, that signal	
	is set to ignore.
	Termination is like that of "fatal",
	via "clean_up(sig)" (sig is the signal number)
	and "exit(userexit(1))".
 
	If the file "dump.core" exists in the current directory
	the function commits
	suicide to produce a core dump
	(after calling clean_up, but before calling userexit).
*/


char	*Mesg[ONSIG]={
	0,
	0,	/* Hangup */
	0,	/* Interrupt */
	0,	/* Quit */
	"Illegal instruction",
	"Trace/BPT trap",
	"IOT trap",
	"EMT trap",
	"Floating exception",
	"Killed",
	"Bus error",
	"Memory fault",
	"Bad system call",
	"Broken pipe",
	"Alarm clock",
	"signal 15",
	"signal 16",
	"signal 17",
	"signal 18",
	"signal 19",
	"signal 20",
	"signal 21",
	"signal 22",
	"signal 23",
	"signal 24",
	"signal 25",
	"signal 26",
	"signal 27",
	"signal 28",
	"signal 29",
	"signal 30"
};


setsig()
{
	extern int setsig1();
	register int j, n;

	for (j=1; j<ONSIG; j++) {
		switch (j) {
		case SIGKILL:	/* cannot be caught */
		case SIGCHLD:
		case SIGUSR1:
		case SIGUSR2:
		case SIGPWR:
		case SIGSTOP:	/* cannot be caught, blocked or ignored */
		case SIGCONT:	/* cannot be blocked */
			break;
		default:
			if ((n = (int)signal (j, setsig1)) >= 0 )
				signal(j, n);
			else {
				perror ("setsig");
				exit (1);
			}
		}
	}
}


static char preface[]="SIGNAL: ";
static char endmsg[]=" (ut12)\n";

setsig1(sig)
int sig;
{

	if (Mesg[sig]) {
		write(2,preface,length(preface));
		write(2,Mesg[sig],length(Mesg[sig]));
		write(2,endmsg,length(endmsg));
	}
	else
		signal(sig,1);
	clean_up(sig);
	if(open("dump.core",0) > 0) {
		signal(SIGIOT,0);
		abort();
	}
	exit(userexit(1));
}
