/*	_setjmp.s	4.2	83/07/02	*/
/*	_setjmp.s in 4.2 is equivalent to setjmp.s in sys5 --bijan */

/*
 * C library -- setjmp, longjmp
 *
 *	longjmp(a,v)
 * will generate a "return(v)" from
 * the last call to
 *	setjmp(a)
 * by restoring registers from the stack,
 * The previous signal state is NOT restored.
 *
 * 10/22/84
 * if the v argument in longjmp is 0, setjmp will return 1
 * (for sys5 compatibility).
 */

#include "../DEFS.h"

ENTRY(setjmp)
	movl	4(fp),r0
	movl	(fp),(r0)		# save frame pointer of caller
	movl	-8(fp),4(r0)		# save pc of caller
	clrl	r0
	ret

ENTRY(longjmp)
	movl	8(fp),r0		# return(v)
	movl	4(fp),r1		# fetch buffer
	tstl	(r1)
	beql	.botch
	tstl	r0			#if (v = 0) setjmp will return 1
	bnequ	.loop
	movzbl	$1,r0
.loop:
	cmpl	(r1),(fp)
	beql	.done
	blssu	.botch
	movl	$.loop,-8(fp)
	ret				# pop another frame

.done:
	cmpb	*-8(fp),reiins		# returning to an "rei"?
	bneq	.L1
	movab	.L3,-8(fp)		# do return w/ psl-pc pop
	brw	.L2
.L1:
	movab	.L4,-8(fp)		# do standard return
.L2:
	ret				# unwind stack before signals enabled
.L3:
	movab	8(sp),sp		# compensate for PSL-PC push
.L4:
	jmp	*4(r1)			# done, return....

.botch:
	pushl	$msgend-msg
	pushl	$msg
	pushl	$2
	calls	$16,_write
	halt

	.data
msg:
	.byte	'_, 'l, 'o, 'n, 'g, 'j, 'm, 'p, ' , 'b, 'o, 't, 'c, 'h, 0x0a
msgend:
reiins: rei
