/*	@(#)disktab.c	4.2 (Berkeley) 2/8/83	*/

#include <sys/types.h>
#include <sys/ioctl.h>
#include <disktab.h>
#include <fcntl.h>
#include <sys/param.h>
#include <sys/dsk.h>
#include <sys/dskio.h>
#include <stdio.h>
#include <string.h>

#define BLOCKSIZE 8192 
#define FRAGSIZE 1024
#define SECTORSIZE 512
#define DISKNAME "dsk"
#define DISKTYPE NULL
#define TRUE 1
#define FALSE 0

struct disktab *
getdiskbyname(name)
	char *name;
{
	static struct disktab disk;
	static char localbuf[100], *cp = localbuf;
	register struct	disktab *dp = &disk;
	dsk_status disk_stat ;
	geometry_status disk_geo ;
	int diskfd ;
	int i ;
	int retval ;

	diskfd = open( name, O_RDONLY, 0 ) ;
	if ( diskfd < 0 )
	{
		perror("getdiskbyname cannot open disk." ) ;
		return( NULL ) ;
	}

	retval = ioctl( diskfd, DSKIOCSTATUS, &disk_stat, 0 ) ;
	if ( retval < 0 )
	{
		perror("DSKIOCSTATUS failed") ;
		return( NULL ) ;
	}

	retval = ioctl( diskfd, DSKIOCGEOMETRY, &disk_geo, 0 ) ; 
	if ( retval < 0 )
	{
		perror("DSKIOCGEOMETRY failed") ;
		return( NULL ) ;
	}

	
	dp->d_name = cp ;
	strcpy( dp->d_name, DISKNAME ) ;
	dp->d_type = cp + strlen( dp->d_name) + 1 ;
	strcpy( dp->d_type, DISKTYPE ) ;
	dp->d_secsize = SECTORSIZE ;
	dp->d_ntracks = disk_stat.heads ;
	dp->d_nsectors = disk_stat.sectors ;
	dp->d_ncylinders = disk_stat.cylinders ;
	dp->d_rpm = disk_stat.rpm ;
	for ( i=0; i<GB_MAXPART; i++ )
	{
		dp->d_partitions[i].p_size = disk_geo.partition[i].length ;
		dp->d_partitions[i].p_bsize = BLOCKSIZE ;
		dp->d_partitions[i].p_fsize = FRAGSIZE ;
	}

	return( dp ) ;
}
