#ifndef lint
static	char sccsid[] = "@(#)errlst.c 1.1 85/05/30 SMI"; /* from UCB 4.6 82/12/19 */
#endif

char	*sys_errlist[] = {
	"Error 0",
	"Not owner",				/*   1 - EPERM */
	"No such file or directory",		/*   2 - ENOENT */
	"No such process",			/*   3 - ESRCH */
	"Interrupted system call",		/*   4 - EINTR */
	"I/O error",				/*   5 - EIO */
	"No such device or address",		/*   6 - ENXIO */
	"Arg list too long",			/*   7 - E2BIG */
	"Exec format error",			/*   8 - ENOEXEC */
	"Bad file number",			/*   9 - EBADF */
	"No children",				/*  10 - ECHILD */
	"No more processes",			/*  11 - EAGAIN */
	"Not enough memory",			/*  12 - ENOMEM */
	"Permission denied",			/*  13 - EACCES */
	"Bad address",				/*  14 - EFAULT */
	"Block device required",		/*  15 - ENOTBLK */
	"Device busy",				/*  16 - EBUSY */
	"File exists",				/*  17 - EEXIST */
	"Cross-device link",			/*  18 - EXDEV */
	"No such device",			/*  19 - ENODEV */
	"Not a directory",			/*  20 - ENOTDIR */
	"Is a directory",			/*  21 - EISDIR */
	"Invalid argument",			/*  22 - EINVAL */
	"File table overflow",			/*  23 - ENFILE */
	"Too many open files",			/*  24 - EMFILE */
	"Inappropriate ioctl for device",	/*  25 - ENOTTY */
	"Text file busy",			/*  26 - ETXTBSY */
	"File too large",			/*  27 - EFBIG */
	"No space left on device",		/*  28 - ENOSPC */
	"Illegal seek",				/*  29 - ESPIPE */
	"Read-only file system",		/*  30 - EROFS */
	"Too many links",			/*  31 - EMLINK */
	"Broken pipe",				/*  32 - EPIPE */

/* math software */
	"Argument too large",			/*  33 - EDOM */
	"Result too large",			/*  34 - ERANGE */

/* IPC mechanism */
	"No message of desired type",		/*  35 - ENOMSG */
	"Identifier removed",			/*  36 - EIDRM */

/* non-blocking and interrupt i/o */
	"Operation would block",		/*  37 - EWOULDBLOCK */
	"Operation now in progress",		/*  38 - EINPROGRESS */
	"Operation already in progress",	/*  39 - EALREADY */

/* ipc/network software */

	/* argument errors */
	"Socket operation on non-socket",	/*  40 - ENOTSOCK */
	"Destination address required",		/*  41 - EDESTADDRREQ */
	"Message too long",			/*  42 - EMSGSIZE */
	"Protocol wrong type for socket",	/*  43 - EPROTOTYPE */
	"Option not supported by protocol",	/*  44 - ENOPROTOOPT */
	"Protocol not supported",		/*  45 - EPROTONOSUPPORT */
	"Socket type not supported",		/*  46 - ESOCKTNOSUPPORT */
	"Operation not supported on socket",	/*  47 - EOPNOTSUPP */
	"Protocol family not supported",	/*  48 - EPFNOSUPPORT */
	"Address family not supported by protocol family",
						/*  49 - EAFNOSUPPORT */
	"Address already in use",		/*  50 - EADDRINUSE */
	"Can't assign requested address",	/*  51 - EADDRNOTAVAIL */

	/* operational errors */
	"Network is down",			/*  52 - ENETDOWN */
	"Network is unreachable",		/*  53 - ENETUNREACH */
	"Network dropped connection on reset",	/*  54 - ENETRESET */
	"Software caused connection abort",	/*  55 - ECONNABORTED */
	"Connection reset by peer",		/*  56 - ECONNRESET */
	"No buffer space available",		/*  57 - ENOBUFS */
	"Socket is already connected",		/*  58 - EISCONN */
	"Socket is not connected",		/*  59 - ENOTCONN */
	"Can't send after socket shutdown",	/*  60 - ESHUTDOWN */
	"Too many references: can't splice",	/*  61 - ETOOMANYREFS */
	"Connection timed out",			/*  62 - ETIMEDOUT */
	"Connection refused",			/*  63 - EREFUSED */
	"Too many levels of symbolic links",	/*  64 - ELOOP */
	"File name too long",			/*  65 - ENAMETOOLONG */
	"Host is down",				/*  66 - EHOSTDOWN */
	"Host is unreachable",			/*  67 - EHOSTUNREACH */
	"Directory not empty",			/*  68 - ENOTEMPTY */
	"Too many processes",			/*  69 - EPROCLIM */
	"Too many users",			/*  70 - EUSERS */
	"Disc quota exceeded",			/*  71 - EDQUOT */
	"Deadlock condition if locked",		/*  72 - EDEADLK */

/* No errors 73 - 78 */

	"Error 73",				/*  73 - NOERROR */
	"Error 74",				/*  74 - NOERROR */
	"Error 75",				/*  75 - NOERROR */
	"Error 76",				/*  76 - NOERROR */
	"Error 77",				/*  77 - NOERROR */
	"Error 78",				/*  78 - NOERROR */

/*  X.25 & vioc-BOP board  */

	"Channel is reset",			/*  79 - ECHNRST */
 	"Link error",				/*  80 - EXLNERR */
 	"Fast select incorrectly used",		/*  81 - EXNFST */
 	"No read/write on channel # 0",		/*  82 - EXFORBID */
 	"Get next call request is cancelled",	/*  83 - EXCANCEL */
 	"Call collision",			/*  84 - EXCOLLIN */
 	"Circuit not exist",			/*  85 - EXNONE */
 	"The circuit is already attached",	/*  86 - EXARATT  */
 	"Level 2 is not operational",		/*  87 - EXBADCOM */
 	"Bad packet size specified ",		/*  88 - EXBADPAC */
 	"Bad parameters ",			/*  89 - EXBADPAR */
 	"The x25 in the wrong state",		/*  90 - EXBADSTATE */
 	"Bad window size specified ",		/*  91 - EXBADWIN */
 	"The circuit is already detached",	/*  92 - EXDWAS  */
 	"Circuit not available",		/*  93 - EXEXMAX  */
 	"Link is not configured",		/*  94 - EXLNCON  */
 	"Link is not opened",			/*  95 - EXLNOP   */
 	"Link # is out of bond",		/*  96 - EXLOBND  */
 	"Multiple requests for same pid",	/*  97 - EXMULRQ */
 	"Circuit is not attached",		/*  98 - EXNATT   */
 	"Invalid facility",			/*  99 - EXNOFAC  */
 	"Buffer resources are not available",	/* 100 - EXNRES   */
 	"Read threshold exceeds maximum",	/* 101 - EXRDEXCD */
 	"The command is timed out",		/* 102 - EXTMOUT  */
 	"Window overflow",			/* 103 - EXWOVER  */
 	"No circuit is being set up",		/* 104 - EXCACLR  */
 	"The index number is out of range",	/* 105 - EXRANGE  */
 	"Vioc-BOP link is down" ,		/* 106 - ELNKDWN */
 	"To open an already opened port",	/* 107 - EREOPEN */
 	"To close an already closed port",	/* 108 - ERECLOS */
 	"Retry exceed",				/* 109 - ERTRYEX */
 	"Link or circuit being reset",		/* 110 - ELNKRST */
 	"Link idle",				/* 111 - ELIDLE */
 	"Link is no more idle",			/* 112 - EIDLESTOP */
 	"Buffer congestion relieved",		/* 113 - EBUFOK */
 	"X.25 release buffer (reset)",		/* 114 - XNERST */
 	"X.25 level 2 error detected",		/* 115 - XNIL2E */
 	"Remote station busy",			/* 116 - EREMBSY */
 	"Link or channel not active",		/* 117 - EXNOACT */
 	"Bad facility specified",		/* 118 - EXBADFAC */
 	"Vioc-BOP low on buffers",		/* 119 - EBUFLOW */
 	"Vioc-BOP is broken",			/* 120 - EVERR */
 	"Vioc-BOP xmit error",			/* 121 - EXMIT */
 	"Vioc-BOP overflow",			/* 122 - EVOVRFL */
 	"Bad component",			/* 123 - EBADCMP */

/* network file system */

	"Stale NFS file handle",		/* 124 - ESTALE */
	"Too many levels of remote in path",	/* 125 - EREMOTE */
	"No record locks available",            /* 126 - ENOLCK */

/* Harris SNA */

	"Open not complete",			/* 127 - ESDOPEN */
	"Write kernel buffer error",		/* 128 - ESDKBUF */
	"Invalid PU number",			/* 129 - ESDPU */
	"Invalid SDLC address",			/* 130 - ESDADDR */
	"Invalid SDLC frame size",		/* 131 - ESDFRSIZE */
	"Invalid SDLC encoding",		/* 132 - ESDENCODE */
	"Bad PU buffer format",			/* 133 - EPUBUF */
	"Bad application id in PU buffer",	/* 134 - EPUAPPL */
	"Associated LU is down",		/* 135 - EPULUDOWN */
	"LU not initialized",			/* 136 - ELUINIT */
	"Associated PU is down",		/* 137 - ELUPUDOWN */
	"Invalid LU buffer format",		/* 138 - ELUBUF */
	"PU given in ioctl is invalid",		/* 139 - ELUPUBAD */
};
int	sys_nerr = { sizeof sys_errlist/sizeof sys_errlist[0] };
