/*	@(#)nlist.c	1.9	*/
/*	3.0 SID #	1.4	*/
/*LINTLIBRARY*/
#define ISMAGIC(x)	((((unsigned short)x)==(unsigned short)HCXROMAGIC) || \
			  (((unsigned short)x)==(unsigned short)HCXWRMAGIC))
#define BADMAGIC(x)	(!ISMAGIC(x))

#include <a.out.h>

#define BUFSIZE (100*AUXESZ)
#if AUXESZ != SYMESZ
ERROR: We need AUXESZ == SYMESZ
#endif

#ifndef FLEXNAMES
#	define FLEXNAMES 1
#endif
#undef n_name		/* this patch causes problems here */

extern long	lseek() ;
extern int	open(), read(), close(), strncmp(), strcmp() ;
extern char *	malloc() ;
extern void	free() ;

int
nlist( name, list )
char *	name ;
struct nlist * list ;
{
	struct filehdr buf ;
	struct syment sym ;
	long	n ;
	int	bufsiz = FILHSZ ;
#if FLEXNAMES
	char *	strtab = (char *) 0 ;
	long	strtablen ;
#endif
	register struct nlist * p ;
	register struct syment * q ;
	char	fd_buf[ BUFSIZE ] ;
	long	fd_inx = BUFSIZE ;
	int	fd ;
	int	sym_count = 0 ;

	for ( p = list ; p->n_name && p->n_name[ 0 ] ; p ++ ) {
		p->n_type = 0 ;
		p->n_value = 0L ;
		p->n_scnum = 0 ;
		p->n_sclass = 0 ;
		sym_count ++ ;
	}

	if ( (fd = open( name, 0 )) < 0 ) {
		return( -1 ) ;
	}
	(void) read( fd, (char *) & buf, bufsiz ) ;
	if ( BADMAGIC( buf.f_magic ) ) {
		(void) close( fd ) ;
		return( -1 ) ;
	}
	lseek( fd, (long) buf.f_symptr, 0 ) ;
	q = & sym ;
	n = buf.f_nsyms ;	/* num. of sym tab entries */

	while ( n ) {
		if ( sym_count == 0 ) {
			goto out ;
		}
		if ( fd_inx >= BUFSIZE ) {
			read( fd, (char *) fd_buf, BUFSIZE ) ;
		fd_inx -= BUFSIZE ;
		}
		sym = * (struct syment *) & (fd_buf[ fd_inx ] ) ;
		fd_inx += SYMESZ ;
		n -= (q->n_numaux + 1L) ;
		/* skip past aux ent, if there is one */
		if ( q->n_numaux != 0 ) {
			fd_inx += AUXESZ ;
		}

		for ( p = list ; p->n_name && p->n_name[ 0 ] ; p ++ ) {
			if (p->n_value != 0L) {	/* got one already */
				continue ;
			}
			/*
			* For 6.0, the name in an object file is
			* either stored in the eight long character
			* array, or in a string table at the end
			* of the object file.  If the name is in the
			* string table, the eight characters are
			* thought of as a pair of longs, (n_zeroes
			* and n_offset) the first of which is zero
			* and the second is the offset of the name
			* in the string table.
			*/
#if FLEXNAMES
			if ( q->n_zeroes == 0L ) {	/* in string table */
				if ( strtab == (char *) 0 ) { /* need it */
					long	home = lseek( fd, 0L, 1 ) ;

					if (lseek (fd, buf.f_symptr + buf.f_nsyms * SYMESZ, 0) == -1 ||
					    read (fd, (char *) &strtablen, sizeof(long)) != sizeof(long) || 
					    (strtab = malloc ((unsigned) strtablen)) == (char *) 0 || 
					    read (fd, strtab + sizeof(long), strtablen - sizeof(long)) != strtablen - sizeof(long) || 
					     strtab [strtablen - 1] != '\0' ) {

						(void) lseek( fd, home, 0 ) ;
						(void) close( fd ) ;
						if (strtab != (char *) 0 ) {
							free( strtab ) ;
						}
						return( -1 ) ;

					} else {
						lseek( fd, home, 0 ) ;
					}
				}
				if ( q->n_offset < sizeof( long ) || 
				     q->n_offset >= strtablen ) {
					(void) close( fd ) ;
					if ( strtab != (char *) 0 ) {
						free( strtab ) ;
					}
					return( -1 ) ;
				}
				if ( strcmp( & strtab[ q->n_offset ],
				    p->n_name ) ) {
					continue ;
				}
			} else {
#endif /*FLEXNAMES*/
				if ( strncmp( q->_n._n_name,
				    p->n_name, SYMNMLEN ) ) {
					continue ;
				}
			}
			p->n_value = q->n_value ;
			p->n_type = q->n_type ;
			p->n_scnum = q->n_scnum ;
			p->n_sclass = q->n_sclass ;
			-- sym_count ;
			break ;
		}
	}

out:
	(void) close( fd ) ;
#if FLEXNAMES
	if ( strtab != (char *) 0 ) {
		free( strtab ) ;
	}
#endif
	return( 0 ) ;
}
