/*	@(#)ttyname.c	1.2	*/
/*	3.0 SID #	1.2	*/
/*LINTLIBRARY*/

/*
 * ttyname(f): returns "/dev/ttyXX" which is the name of the
 * tty belonging to file f.
 *
 * This program reads the /dev directory and works in two passes:
 * the first pass tries to find the device by matching device and
 * inode numbers; if that doesn't work, it tries a second time,
 * this time doing a stat on every file in /dev and trying to match
 * device numbers only. If that fails too, NULL is returned.
 */

#define	NULL	0
#include <sys/param.h>
#include <sys/dir.h>
#include <sys/stat.h>

static	char	dev[]	= "/dev/";
char	*strcpy();
char	*strcat();

char *
ttyname(f)
{
	struct stat fsb;
	struct stat tsb;
	register struct direct *db;
	register DIR *df;
	static char rbuf[32];
	int pass1;

	if (isatty(f)==0)
		return(NULL);
	if (fstat(f, &fsb) < 0)
		return(NULL);
	if ((fsb.st_mode&S_IFMT) != S_IFCHR)
		return(NULL);
	if ((df = opendir(dev)) == NULL)
		return(NULL);
	pass1 = 1;
	do {
		while ((db = readdir(df)) != NULL) {
			if(db->d_ino == 0)
				continue;
			if (pass1 && db->d_ino != fsb.st_ino)
				continue;
			strcpy(rbuf, dev);
			strcat(rbuf, db->d_name);
			if (stat(rbuf, &tsb) < 0)
				continue;
			if(tsb.st_rdev == fsb.st_rdev &&
				(tsb.st_mode&S_IFMT) == S_IFCHR &&
				(!pass1 || tsb.st_ino == fsb.st_ino)) {
				closedir(df);
				return(rbuf);
			}
		}
		(void) lseek(df, 0L, 0);
	} while(pass1--);
	closedir(df);
	return(NULL);
}
