/*	@(#)ttyslot.c	1.4	*/
/*	@(#)ttyslot.c	1.2	*/
/*LINTLIBRARY*/

/*
 * ttyslot -- Returns the number of the slot in the
 * utmp file corresponding to the current user. Try
 * for file 0, 1, 2.  Returns -1 if slot not found.
 * 
 * 4.2BSD definition of this routine says that it
 * returns the number of the slot in the /etc/ttys
 * file. Since we don't have a ttys file in HCX/UX,
 * we defer to the SYSV.2 definition above, regardless
 * of the universe.
 */

#include <sys/types.h>
#include <utmp.h>

extern char *ttyname(), *strrchr();
extern int strncmp(), open(), read(), close();

#define	NULL	0

int ttyslot()
{
	struct utmp ubuf;
	register char *tp, *p;
	register int s, fd;

	if ((tp=ttyname(0))==NULL && (tp=ttyname(1))==NULL && (tp=ttyname(2))==NULL)
		return(-1);

	if ((p = strrchr(tp, '/')) == NULL)
		p = tp;
	else
		p++;

	if ((fd=open(UTMP_FILE, 0)) < 0)
		return(-1);

	s = 0;
	while (read(fd, (char*)&ubuf, sizeof(ubuf)) == sizeof(ubuf)) {

		if (   (ubuf.ut_type == INIT_PROCESS ||
			ubuf.ut_type == LOGIN_PROCESS ||
			ubuf.ut_type == USER_PROCESS ||
			ubuf.ut_type == DEAD_PROCESS ) &&
			strncmp(p, ubuf.ut_line, sizeof(ubuf.ut_line)) == 0) {

			(void) close(fd);
			return(s);
		}
		s++;

	}

	(void) close(fd);
	return(-1);
}
