/*	@(#)setvbuf.c	1.2			*/

/*
** Setvbuf, a SYSV.2 routine, was added to the 4.2BSD standard I/O library
** by the universe switch project in order to improve software portability.
*/

#include <stdio.h>

setvbuf (iop, type, buf, size)
register FILE *iop;
register int type;
register char *buf;
register int size;
{
	char *malloc ();

	if (iop->_base != NULL && iop->_flag & _IOMYBUF)
		free ((char*)iop->_base);
	iop->_flag &= ~(_IOMYBUF | _IONBF | _IOLBF);
	switch (type)  {
	    /*note that the flags are the same as the possible values for type*/
	    case _IONBF:
		/* file is unbuffered */
		iop->_flag |= _IONBF;
		iop->_base = NULL;
		iop->_bufsiz = NULL;
		break;
	    case _IOLBF:
	    case _IOFBF:
		iop->_flag |= type;
		if (buf && size) {
			iop->_base = (unsigned char *) buf;
			iop->_bufsiz = size;
		}
		else {
			size = (size == 0) ? BUFSIZ : size;
			iop->_base = (unsigned char *) malloc ((unsigned) size);
			iop->_bufsiz = size;
		}
		break;
	    default:
		return (-1);
	}
	iop->_ptr = iop->_base;
	iop->_cnt = 0;
	return (0);
}
