#	Copyright (c) 1984 AT&T
#	  All Rights Reserved

#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.

#ident	"@(#)curses:libcurses.mk	1.11"
#
#	Curses Library High Level Makefile.
#
#	To INSTALL libcurses.a, the tic compiler and the tools type:
#
#		"make install"
#
#
#	To COMPILE libcurses.a, the tic compiler and the tools, type:
#
#		"make all"
#
#
#	To compile a particular file with normal compilation type:
#
#		"make FILES='<particular .o files>"
#
#
#	If debugging is desired then type:
#
#		"make O=debug FILES='<particular .o files>"
#
#
#	If tracing is desired then type:
#
#		"make O=trace FILES='<particular .o files>"
#
#
#	If profiling is desired then type:
#
#		"make O=profile FILES='<particular .o files>"
#
#
#	To compile only the tic compiler type:
#
#		"make tic"
#
#
#	To create cpio files for all directories type:
#		"make cpio"
#
#
# SHELL=/bin/sh
# MAKE=make
# ROOT=
USRLIB = $(ROOT)/usr/lib

all:	libcurses.a tools tdc

libcurses.a:
	@cd ./screen ; $(MAKE) rmhdrs
	@cd ./screen ; $(MAKE) cktmp
	@cd ./screen ; $(MAKE) libcurses.a
	@echo
	@echo "Libcurses.a has been made."
	@echo

tools:
	@cd ./screen ; $(MAKE) tools
	@cd ./screen ; $(MAKE) llib-lcurses.ln
	@echo
	@echo "Libcurses/Terminfo tools have been made."
	@echo

tic:
	@cd ./screen ; $(MAKE) tic
	@echo
	@echo "The tic compiler has been made."
	@echo

tdc:
	@cd ./tdc ; $(MAKE) tdc
	@echo
	@echo "The terminal definition compiler (tdc) has been made."
	@echo
	
install:
	# make and install libcurses.a and tic
	-mkdir $(ROOT)/usr/lib/terminfo
	@cd ./screen ; $(MAKE) cktmp
	@cd ./screen ; $(MAKE) install USRLIB=$(USRLIB) CC2=$(CC) ROOT2=""
	@cd ./tdc    ; $(MAKE) install USRLIB=$(USRLIB) CC2=$(CC) ROOT2=""
	@echo It will take 20 minutes or more to generate $(ROOT)/usr/lib/terminfo/*/*.
	(cd ./terminfo ; $(MAKE) all 2>&1 > errs ; echo "tdc done" )
	@echo
	@echo libcurses.a, the tic compiler, tdc, and associated tools have
	@echo been installed.
	@echo

clean:
	@cd ./screen ; $(MAKE) clean
	@cd ./tdc    ; $(MAKE) clean
	@cd ./terminfo ; $(MAKE) clean

clobber:
	@cd ./screen ; $(MAKE) clobber
	@cd ./tdc    ; $(MAKE) clobber
	@cd ./terminfo ; $(MAKE) clean

cpio:
	@echo
	@echo "\n\tBuilding cpio files in ${HOME}\n\n\t\c"
	@find . -print|cpio -ocud|split -10000 - ${HOME}/crs.`date +%m%d`.
	@echo "\n\tcpio files have been built\n"

bsd:
	@echo
	cd screen; mv makefile makefile.sysv; cp makefile.bsd makefile
	cd screen; make rmident
	@echo "Curses has been converted for BSD"
# this has only been tested on 4.2BSD, but we assume libc has getopt.
