#include "define.h"

#if DEBUG
#include <stdio.h>
#endif


/******************************************************************************
 *                                                                            *
 *  stoi - converts a string of characters representing an array of byte-     *
 *         reversed two-byte integers into an array of short integers.        *
 *                                                                            *
 *  calling syntax: stoi (char string, short array, integer)                  *
 *                                                                            *
 *  returns: void                                                             *
 *                                                                            *
 *  globals used: none                                                        *
 *                                                                            *
 ******************************************************************************/

stoi (string, iarray, count)
unsigned char *string;
short *iarray;
int count;
{
   int i;                           /* index integer                          */

   for (i = 0; i < count; i++) {    /* convert count elements                 */
      iarray[i] = (int)((*(string+1) << 8) | *(string));
      string+=2;                    /* move string pointer up two bytes       */
   }

} /* end stoi */



/******************************************************************************
 *                                                                            *
 *  itos - convert an array of short integers into a character string repre-  *
 *         senting byte-reversed two-byte integers.                           *
 *                                                                            *
 *  calling syntax: itos (array of short ints, char string, int count)        *
 *                                                                            *
 *  returns: void                                                             *
 *                                                                            *
 *  globals used: none                                                        *
 *                                                                            *
 ******************************************************************************/

itos (iarray, string, count)
short *iarray;
unsigned char *string;
int count;
{
   int i;                           /* index integer                          */

   for (i=0; i < count; i++) {                      /* convert count # of ints*/
      *(string+2*i) = *(iarray+i) & LOW8;           /* grab low byte          */
      *(string+2*i+1) = (*(iarray+i) & MID8)>>8;    /* grab high byte; shift  */
   }
} /* end itos */
