/******************************************************************************
 *                                                                            *
 *  Constants: define global constants usefull to program.                    *
 *                                                                            *
 ******************************************************************************/

#include <tlib.h>

#define DEF_LIST_FILE      "def_list"		/* definition file   */
#define OBJECT_QUAL        "/usr/lib/terminfo"  /* object file qualifier      */
#define DEFAULT_NAME       "terminfo.src"       /* default use= location      */

#define FALSE              0                    /* false and true values      */
#define TRUE               1
 
#define TABLE_SIZE         377              /* # of buckets in hash table     */
#define NAME_LENGTH        128              /* length of terminal name        */
#define STRING_LENGTH      1024             /* length of capability value     */
#define NUM_LENGTH         10               /* length of string for numeric   */
#define OCT_LENGTH         3                /* length of string rep for octal */
#define CAP_LENGTH         12               /* length of capability name      */
#define FILE_LENGTH        64               /* length of object file name     */
#define MAX_LINE_LENGTH    132              /* maximum length of a line       */
#define HEADER_SIZE        6                /* size of header_section         */
#define CHEAD              12               /* char size of header_section    */
#define CNUM               NUM_OF_NUM*2     /* char size of numeric_section   */
#define CSTRING            NUM_OF_STR*2     /* char size of string_section    */
#define STRING_LIST_LENGTH 2048             /* length of object string list   */
#define PARSE_BUF_SIZE     4096             /* size of buffer to parse out of */
#define VEC_SIZE           5                /* size of multiple use= vector   */

#define DEBUG              0                /* debugging switch               */
#define H6024              0                /* HARRIS 6024 cpu switch = off   */
#define WS                 2                /* short int size = 2 bytes       */

                                            /* characters usefull for trans-  */
#define BACKSLASH          '\\'             /* lation routines                */
#define BACKSPACE          '\010'
#define ESCAPE             '\033'
#define FAKENULL           '\200'
#define FORMFEED           '\014'
#define RETURN             '\015'
#define TAB                '\011'

#define BOOL_TYPE          "bool"           /* capability types for matching  */
#define NUM_TYPE           "num"            /* against types in the defintion */
#define STR_TYPE           "str"            /* file                           */
#define BOOL               0                /* integer form for use in        */
#define NUM                1                /* read_def_val                   */
#define STR                3

#define MAGIC              0432             /* magic number for start of file */
#define UNDEFINED          -1               /* undefined value                */
#define LOW5               037              /* low 5 bits for ^ - control     */
#define LOW8               0377             /* low 8 bits                     */
#define MID8               0177400          /* mid 8 bits                     */
