#	@(#)libm.mk	1.8
#
# Makefile for libm
#
# Note that the object list given in FILES is in the order in which the files
# should be added to the archive when it is created.  

LIB=$(ROOT)/lib
LIBP=$(ROOT)/lib/libp
INC=$(SL)/usr/include

VARIANT =
LIBNAME = lib$(VARIANT)m.a
ALTLIBNAME = lib$(VARIANT)M.a

CFLAGS=$(CFL)

FILES	= asin.o atan.o exp.o erf.o fabs.o floor.o fmod.o gamma.o hypot.o \
	  j0.o j1.o jn.o log.o matherr.o pow.o sin.o sinh.o sqrt.o tan.o tanh.o

all: $(LIBNAME) profiledlib

$(LIBNAME): $(FILES)
	$(AR) cr $(LIBNAME) `lorder $(FILES) | tsort`
	rm $(FILES)

$(FILES): $(INC)/math.h $(INC)/values.h $(INC)/errno.h $(INC)/sys/errno.h

atan.o:		atan.c atan.h
		$(CC) $(CFLAGS) -c atan.c

exp.o: 		exp.c exp.tab.c
		$(CC) $(CFLAGS) -c exp.c
		$(CC) $(CFLAGS) -c exp.tab.c
		-$(LD) -r exp.o exp.tab.o
		mv a.out exp.o
		rm exp.tab.o

log.o: 		log.c log.h
		$(CC) $(CFLAGS) -c log.c

profiledlib:
	$(MAKE) -f libm.mk libp.$(LIBNAME) LIBNAME=libp.$(LIBNAME) CFLAGS="-p $(CFLAGS)"

install: all
	cp $(LIBNAME) $(LIB)/$(LIBNAME)
	chmod 644     $(LIB)/$(LIBNAME)
	chgrp bin     $(LIB)/$(LIBNAME)
	chown bin     $(LIB)/$(LIBNAME)

	cp libp.$(LIBNAME) $(LIBP)/$(LIBNAME)
	chmod 644          $(LIBP)/$(LIBNAME)
	chgrp bin          $(LIBP)/$(LIBNAME)
	chown bin          $(LIBP)/$(LIBNAME)

	ln -f $(LIB)/$(LIBNAME)  $(LIB)/$(ALTLIBNAME)
	ln -f $(LIBP)/$(LIBNAME) $(LIBP)/$(ALTLIBNAME)

clean:
	-rm -f *.o 

clobber:	clean
	-rm -f $(LIBNAME) libp.$(LIBNAME)
