#	@(#)libmalloc.mk	1.7
#
# makefile for libmalloc

.SUFFIXES: .p

ARFLAGS=r
CFLAGS=$(CFL)
SPFLAGS=-r
LINTFLAGS=-p

CP=cp
LINT=lint
MV=mv
RM=rm
STRIP=strip

INC=$(SL)/usr/include
LIB=$(ROOT)/usr/lib
PROFDIR=$(ROOT)/usr/lib/libp

OBJECTS=malloc.o
POBJECTS=malloc.p

all: noprof prof llib-lmalloc.l

noprof: $(OBJECTS)
	$(RM) -rf objects
	mkdir objects
	$(CP) $(OBJECTS) objects
	cd objects; $(AR) $(ARFLAGS) libmalloc.a *

prof: $(POBJECTS)
	$(RM) -rf pobjects
	mkdir pobjects
	for i in $(POBJECTS); do \
		$(CP) $$i pobjects/`basename $$i .p`.o; \
	done
	cd pobjects; $(AR) $(ARFLAGS) libmalloc.a *

malloc.o malloc.p: $(INC)/malloc.h mallint.h

.c.o .c.p:
	@echo $*.c:
	$(PRF)$(CC) -p $(CFLAGS) -c $*.c && $(MV) $(*F).o $*.p
	$(CC) $(CFLAGS) -c $*.c

llib-lmalloc.l:  llib-lmall.c
	cp llib-lmall.c llib-lmalloc.c
	lint -c -I${INCLDIR} llib-lmalloc.c
	rm llib-lmalloc.c

install: all
	if [ ! -d $(PROFDIR) ]; then \
		mkdir $(PROFDIR); \
	fi
	(cd objects;  /etc/install -f $(LIB)     libmalloc.a)
	(cd pobjects; /etc/install -f $(PROFDIR) libmalloc.a)
	if pdp11; then \
		$(STRIP) $(LIB)/libmalloc.a; \
		$(STRIP) $(PROFDIR)/libmalloc.a; \
	else \
		$(STRIP) $(SPFLAGS) $(LIB)/libmalloc.a; \
		$(STRIP) $(SPFLAGS) $(PROFDIR)/libmalloc.a; \
		$(AR) ts $(LIB)/libmalloc.a; \
		$(AR) ts $(PROFDIR)/libmalloc.a; \
	fi
	$(CP) llib-lmalloc.ln $(ROOT)/usr/lib/llib-lmalloc.l

clean: 
	$(RM) -rf pobjects objects

clobber: clean
	$(RM) -f $(POBJECTS) $(OBJECTS)
