
#ifndef   VOS
#include "all.h"
#endif

/*
    #title Get Boolean attribute
*/

/*----------------------------------------------------------------------*
 *                                                                      *
 *         P R O P R I E T A R Y  AND  C O N F I D E N T I A L          *
 *                                                                      *
 *                                                                      *
 *       HARRIS COMPUTER SYSTEMS DIVISION OF HARRIS CORPORATION         *
 *                                                                      *
 *    The software contained herein is furnished pursuant a license     *
 *    agreement for use with a single HCSD computer and cannot be       *
 *    copied except as provided in the license agreement.               *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*
 *                                                                      *
 * get_boolean_attrib -- get value of boolean attribute from termdef    *
 *                       heap.                                          *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*
 *                                                                      *
 *  This routine is called to get the TRUE or FALSE value of a boolean  *
 *  attribute from a given termdef entry string. A boolean attribute is *
 *  FALSE if it is not specified, or if it is specified with an @       *
 *  following it in the original terminal definition string.  It is     *
 *  TRUE if it appears in the definition string with no @ after it.     *
 *                                                                      *
 *----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*
 *                                                                      *
 * Value returned:                                                      *
 * ---------------                                                      *
 *                                                                      *
 * TRUE                   attrib is TRUE for this terminal definition   *
 *                                                                      *
 * FALSE                  attrib is FALSE for this terminal definition  *
 *                                                                      *
 * Parameter definitions:                                               *
 * ----------------------                                               *
 *                                                                      *
 * terminal_def (input)struct tdef_heap *                               *
 *              structure of pointers into heap[ containing the terminal*
 *              definition.                                             *
 *                                                                      *
 * bool_attrib  (input) int                                             *
 *             offset into boolean section corresponding to the desired *
 *             attribute.                                               *
 *                                                                      *
 *                                                                      *
 *----------------------------------------------------------------------*/


int  get_boolean_attrib ( terminal_def, bool_attrib )
struct tdef_heap  *terminal_def;
int            bool_attrib;
{

if ((terminal_def->boolean_section + bool_attrib) <
     (unsigned char *)terminal_def->numbers_section )
   return(*(terminal_def->boolean_section + bool_attrib));
else
   return('\0');
}
