/*-------------------------------------*
 *   terminal configuration defines    *
 *-------------------------------------*/

/* defines for conversion of short int(PDP-11) format
                               to host machine format */
/* defines for byte swap routine */
#define  LOW5    037      /* low 5 bits */
#define  LOW8    0377     /* low 8 bits */
#define  MID8    0177400  /* mid 8 bits */

#define  INT_SIZE_6024        3                  /* bytes per int */
#define  INT_SIZE_HCX         4                  /* bytes per int */
#define  SHORT_INT_SIZE       2                  /* bytes per int */
#define  NEGATIVE_ONE         0xFFFF
#ifdef   VOS
#define  HOST_INT_SIZE        INT_SIZE_6024      /* bytes per int */
#define B23      040000000
#define I 0                              /* I register  */
#define J 1                              /* J register  */
#define K 2                              /* K register  */
#define E 3                              /* E register  */
#define A 4                              /* A register  */
#define NUM_REGS 5                       /* number of registers  */
#define PLIST_MAX 5                      /* max param list size */
#else
#define  HOST_INT_SIZE        INT_SIZE_HCX       /* bytes per int */
#endif

/*----------------------*
 *  key return defines  *
 *----------------------*/

#define  INVALID_SEQUENCE  -2
#define  UNDETERMINED      -1
#define  ASCII              0

/*---------------------*
 *  FSA table defines  *
 *---------------------*/

#define START_TABLE_SIZE         15  /* initial start table size */
   /* 25 */
#define START_TABLE_SIZE_INCR    5   /* # to increment by */
#define START_TABLE_SPACE        START_TABLE_SIZE * sizeof( struct START_TABLE )
                                     /* actual space to alloc (bytes) */
#define START_TABLE_SPACE_INCR 													\
                            START_TABLE_SIZE_INCR * sizeof( struct START_TABLE )
                                     /* actual space to alloc (bytes) */

#define NEXT_TABLE_SIZE   90         /* initial next table size */
   /* 105 */
#define NEXT_TABLE_SIZE_INCR     5   /* # to increment by */
#define NEXT_TABLE_SPACE         NEXT_TABLE_SIZE * sizeof( struct NEXT_TABLE )
                                     /* actual space to alloc (bytes) */
#define NEXT_TABLE_SPACE_INCR    											\
                              NEXT_TABLE_SIZE_INCR * sizeof( struct NEXT_TABLE )
                                     /* actual space to alloc (bytes) */
   /*------------------------*
    * key recognition tables *
    *------------------------*/

#define TERMINAL -1    /* terminal next state for next_table */



/* misc defines */
#define KEY_SEQUENCE_SIZE     15
#define ATTRIBUTE_NAME_LENGTH 15

#define  FALSE          0
#define  TRUE           1

#define GOOD   0
#define BAD    -1


/* padding recognition defines */
#define  NOT_DONE 0
#define  DONE     1
#define  NORMAL        0
#define  DOLLAR_SIGN   NORMAL+1
#define  L_BRACKET     DOLLAR_SIGN+1
#define  DIGIT         L_BRACKET+1
#define  DEC_POINT     DIGIT+1
#define  FRACTION      DEC_POINT+1
#define  STAR          FRACTION+1
#define  END_OF_STRING STAR+1

/* defines for stack operations */

#define  MYSTACK_SIZE   30
#define  IF_STACK_SIZE  30

#define JCL_REG_BUF 7              /* size of buffer for GTREG/STREG calls */

/* defines for other things used when NOIO is used */
#ifdef USE_NOIO

#define NULL 0

#define SYM_WRITE 2                /* symbolic write */
#define SYM_READ  1                /* symbolic read */
#define REWIND    022              /* rewind */
#define OPEN      013              /* open */
#define CLOSE     014              /* close */
#define SCREEN 3                   /* lfn of the terminal */
#define SKIP_SIZE 18               /* number bytes to skip if using IOW    */
                                   /* instead of fread                     */
#endif
