
#ifndef   VOS
#include "all.h"
/* #include <termlib/padmap.h> */
#endif

/*
    #title Fill in terminal definition structure
*/

/*----------------------------------------------------------------------*
 *                                                                      *
 *         P R O P R I E T A R Y  AND  C O N F I D E N T I A L          *
 *                                                                      *
 *                                                                      *
 *       HARRIS COMPUTER SYSTEMS DIVISION OF HARRIS CORPORATION         *
 *                                                                      *
 *    The software contained herein is furnished pursuant a license     *
 *    agreement for use with a single HCSD computer and cannot be       *
 *    copied except as provided in the license agreement.               *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*************************************************************************
 *                                                                       *
 *  fill_term_struct   -  fill in the terminal definition  structure     *
 * by repeatedly accesssing the heap created by get_term_def.            *
 *                                                                       *
 *************************************************************************/

/*************************************************************************
 *                                                                       *
 *  INPUT - struct tdef_heap *terminal_def                               *
 *        - structure of pointers to the terminal definition on the heap.*
 *                                                                       *
 *  RETURNS - struct termdef_struct *                                    *
 *          _ a structure which contains the entire terminal definition. *
 *                                                                       *
 *************************************************************************/





unsigned char    *string_ptr      ;


struct termdef_struct *fill_term_struct(terminal_def)
struct tdef_heap  *terminal_def;

{
struct  termdef_struct *term;
int              ii,ll,struct_size,max_len,*str_offset;             /*<TKW-07>*/
unsigned char    *stripped_string ;


struct_size = sizeof(*term);
term = (struct termdef_struct *)malloc(struct_size);


                      /* BOOLEANS */

/*  for (ii = 0; ii < NUM_OF_BOOL; ii++ )  */
for (ii = 0; ii < terminal_def->header_section [BOOLEAN_SECTION_SIZE]; ii++ )
      if ((terminal_def->boolean_section + ii) <
          (unsigned char *)terminal_def->numbers_section)
         term->bool_attr[ii] = *(terminal_def->boolean_section + ii);
      else
         term->bool_attr[ii] = '\0';

                      /* NUMBERS */
/*  for (ii = 0; ii < NUM_OF_NUM; ii++ )  */
for (ii = 0; ii < terminal_def->header_section [NUMERIC_SECTION_SIZE]; ii++ )
      {
      if ((terminal_def->numbers_section + ii) <
           terminal_def->string_offsets_section)
         term->num_attr[ii] = *(terminal_def->numbers_section + ii);
      else
         term->num_attr[ii] = -1;
      }

                      /* STRING POINTERS */
max_len = *(terminal_def->header_section + STRING_SECTION_SIZE);
stripped_string = (unsigned char *)malloc(max_len);

for (ii = 0; ii <
     terminal_def->header_section [STRING_OFFSETS_SECTION_SIZE]; ii++ )
   {
   str_offset = terminal_def->string_offsets_section + ii;          /*<TKW-07>*/
   if ((*str_offset == -1) ||                                       /*<TKW-07>*/
      (str_offset >= (int *)terminal_def->strings_section))         /*<TKW-07>*/

      {
      term->str_attr[ii] = NULL;
      term->pad[ii] = NULL;
      term->pad_lines[ii] = NULL;
      }
   else
      {
   /* Now we assume all string allow padding per ATT 5.3 */
   /* if (can_pad_string[ii])
    *    {
    */
         ll = get_string_attrib(terminal_def,ii,stripped_string,max_len,
                                 &term->pad[ii],&term->pad_lines[ii]);
         term->str_attr[ii] = stripped_string;
         ++ll;                                 /* for terminal null character */
         stripped_string += ll;
         max_len = max_len - ll;
 /*      }
  *   else
  *      {
  *      term->pad[ii] = NULL;
  *      term->pad_lines[ii] = NULL;
  *      term->str_attr[ii] = terminal_def->strings_section + *str_offset;
  *      }
  */
      }
   }
   return(term);
}
