#	@(#)libterm.mk	1.2

AR=ar
RANLIB=ranlib
LORDER=lorder
CFLAGS=$(CFL)
ULIBDIR=$(ROOT)/usr/lib
UINCDIR=$(SL)/usr/include

LIBOBJS=alloc.o bool.o fillst.o getkey.o gettd.o getter.o \
	global.o num.o parstr.o sort.o stacks.o string.o swap.o tables.o

all:		libterm.a

libterm.a:	$(LIBOBJS)
		$(AR) rv libterm.a `$(LORDER) *.o | tsort`
		$(RANLIB) libterm.a

alloc.o:	alloc.c
		$(CC) -c $(CFLAGS) alloc.c

bool.o:		bool.c
		$(CC) -c $(CFLAGS) bool.c

fillst.o:	fillst.c
		$(CC) -c $(CFLAGS) fillst.c

getkey.o:	getkey.c
		$(CC) -c $(CFLAGS) getkey.c

gettd.o:	gettd.c
		$(CC) -c $(CFLAGS) gettd.c

getter.o:	getter.c
		$(CC) -c $(CFLAGS) getter.c

global.o:	global.c
		$(CC) -c $(CFLAGS) global.c

num.o:		num.c
		$(CC) -c $(CFLAGS) num.c

parstr.o:	parstr.c
		$(CC) -c $(CFLAGS) parstr.c

sort.o:		sort.c
		$(CC) -c $(CFLAGS) sort.c

stacks.o:	stacks.c
		$(CC) -c $(CFLAGS) stacks.c

string.o:	string.c
		$(CC) -c $(CFLAGS) string.c

tables.o:	tables.c
		$(CC) -c $(CFLAGS) tables.c

swap.o:		swap.c
		$(CC) -c $(CFLAGS) swap.c

install:	all
		/etc/install -f $(ULIBDIR) libterm.a

clean:
		-rm -f *.o

clobber:	clean
		-rm -f libterm.a 
