
#ifndef   VOS
#include "all.h"
#endif

/*
   #title Get Numeric attribute
*/


/*----------------------------------------------------------------------*
 *                                                                      *
 *         P R O P R I E T A R Y  AND  C O N F I D E N T I A L          *
 *                                                                      *
 *                                                                      *
 *       HARRIS COMPUTER SYSTEMS DIVISION OF HARRIS CORPORATION         *
 *                                                                      *
 *    The software contained herein is furnished pursuant a license     *
 *    agreement for use with a single HCSD computer and cannot be       *
 *    copied except as provided in the license agreement.               *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*
 *                                                                      *
 *   get_numeric_attrib -- get numeric attribute from termdef heap      *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*
 *                                                                      *
 * This routine is called to get the value of a numeric attribute from  *
 * the termdef entry heap.   It returns negative one if the attribute   *
 * is not there or is not a properly formed numeric attribute.          *
 *                                                                      *
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*
*                                                                       *
* Value returned:                                                       *
* ---------------                                                       *
*                                                                       *
* int         The numeric value for the attribute (-1 may be an         *
*             error)                                                    *
*                                                                       *
* Parameter definitions:                                                *
* ----------------------                                                *
*                                                                       *
* terminal_def (input)struct tdef_heap *                                *
*              structure of pointers into heap[ containing the terminal *
*              definition.                                              *
*                                                                       *
* num_attrib  (input) int                                               *
*             offset into numeric section corresponding to the desired  *
*             attribute.                                                *
*                                                                       *
* ----------------------------------------------------------------------*/


int  get_numeric_attrib (terminal_def, num_attrib )
struct tdef_heap   *terminal_def;
int                 num_attrib ;

{
if ((terminal_def->numbers_section + num_attrib) <
     terminal_def->string_offsets_section )
    return( *(terminal_def->numbers_section + num_attrib));
else
   return((int)-1  );
}


