/*	conf.c	6.1	83/07/29	*/

#include "../uts/machine/ml/pte.h"

#define KERNEL
#include "../uts/machine/sys/param.h"
#undef  KERNEL
#include "../uts/machine/sys/time.h"
#include "../uts/machine/sys/vnode.h"
#include "../uts/machine/ufs/inode.h"
#include "../uts/machine/ufs/fs.h"


#include "../stand/saio.h"

devread(io)
	register struct iob *io;
{
	int cc;

	io->i_flgs |= F_RDDATA;
	io->i_error = 0;
	cc = (*devsw[io->i_ino.i_dev].dv_strategy)(io, READ);
	io->i_flgs &= ~F_TYPEMASK;
	return (cc);
}

devwrite(io)
	register struct iob *io;
{
	int cc;

	io->i_flgs |= F_WRDATA;
	io->i_error = 0;
	cc = (*devsw[io->i_ino.i_dev].dv_strategy)(io, WRITE);
	io->i_flgs &= ~F_TYPEMASK;
	return (cc);
}

devioctl(io,command,param)
	register struct iob *io;
	int command,param;
{
	int cc;

	io->i_error = 0;
	cc = (*devsw[io->i_ino.i_dev].dv_ioctl)(io, command, param);
	return (cc);
}

devopen(io)
	register struct iob *io;
{
	int err;

	err = (*devsw[io->i_ino.i_dev].dv_open)(io) ;
	if (err < 0) err = -err;
	return (err);
}

devclose(io)
	register struct iob *io;
{

	(*devsw[io->i_ino.i_dev].dv_close)(io);
}

/*ARGSUSED*/
nullsys(io)
	struct iob *io;
{

	;
}


int	nullsys();


int		vdstrategy(),	vdopen() ;
int		cystrategy(),	cyopen(),	cyclose();
int		xystrategy(),	xyopen(),	xyclose();
int		hdstrategy(),	hdopen(),	hdioctl() ;
int	   qtstrategy(),	qtopen(),	qtclose();

int
dskopen( io )
	register struct iob *io;
{
	int err,default_ctlr;

	default_ctlr = io->i_ctlr == DEFAULT_CTLR ?  true : false;
        if ( default_ctlr )
                io -> i_ctlr = DEFAULT_HVME_CTLR ;
	err = hdopen( io );
	if ( err >= 0 ) {
		io->i_ino.i_dev = 6 ;
		return( true ) ;
	}
        if ( default_ctlr )
                io -> i_ctlr = DEFAULT_VERSA_CTLR ;
	err = vdopen( io );
	if ( err ) {
		io->i_ino.i_dev = 7 ;
		return( true ) ;
	}
	return( false ) ;
}

int
mtopen( io )
	register struct iob *io;
{
	if ( cyopen( io ) ) {
		io->i_ino.i_dev = 0 ;
		return( true ) ;
	}
	if ( xyopen( io ) ) {
		io->i_ino.i_dev = 8 ;
		return( true ) ;
	} 
	if ( qtopen( io ) ) {
		io->i_ino.i_dev = 9 ;
		return( true ) ;
	} 
	return( false ) ;
}

struct devsw devsw[] = {
/*cyp*/	"tm",	cystrategy,	cyopen,		cyclose,	nullsys,
/*egl*/	"dsk",  nullsys,	dskopen,	nullsys,	nullsys,
/*fsd*/	"dsk",  nullsys,	dskopen,	nullsys,	nullsys,
/*smd*/	"dsk",	nullsys,	dskopen,	nullsys,	nullsys,
	"dsk",	nullsys,	dskopen,	nullsys,	nullsys,
	"mt",	nullsys,	mtopen,		nullsys,	nullsys,
	"hdc",	hdstrategy,	hdopen,		nullsys,	hdioctl,
	"vddc",	vdstrategy,	vdopen,		nullsys,	nullsys,
	"xy",	xystrategy,	xyopen,		xyclose,	nullsys, 
	"qt",   qtstrategy,	qtopen,		qtclose, nullsys,
	0,	0,		0,		0,		0
};
