/*	ls.c	6.1	83/07/29	*/

#define KERNEL
#include "../uts/machine/sys/param.h"
#undef  KERNEL
#include "../uts/machine/sys/time.h"
#include "../uts/machine/sys/vnode.h"
#include "../uts/machine/ufs/inode.h"
#include "../uts/machine/ufs/fsdir.h"
#include "../uts/machine/ufs/fs.h"
#include "../stand/saio.h"
#include "../uts/machine/sys/reboot.h"

int	boot_device ;
int	version ;
int     buses[ 2 ] ;

char line[100];

main()
{
	register int	r12 ;
	register int	r11 ;
	register int	r10 ;

	int io;
	register char	*ptr;
	struct inode	*ip;

	boot_device = r10 ;
	version = (boot_device & 0xf000000) >> 24 ;
	buses[ 0 ] = RB_PRIMARY_IO( boot_device ) ;
	if ( buses[ 0 ] == RB_NO_BUS )
		buses[ 0 ] = RB_VERSA_BUS ;
	buses[ 1 ] = RB_SECONDARY_IO( boot_device ) ;

	for(;;) {
		line[0] = 0;
		printf("\n\nls: ");
		gets(line);
		/* scan to end of line */
		for(ptr=line; *ptr; ptr++)
			;
		/* check to see if a file was specified */
		if(ptr == line) {
			printf("usage: dev(ctlr,drive,partition,bus)/directory\n");
			continue;
		}
		/* do one correction first so the raw dev is not opened */
		if(*(--ptr) == ')') {
			*(++ptr) = '/';
			*(++ptr) = '.';
			*(++ptr) = (char)0;
		}
		if(*ptr == '/') {
			*(++ptr) = '.';
			*(++ptr) = (char)0;
		}
		if((io = open(line, 0)) >= 0)
			break;
	}
	if((io >= NFILES+3) || (io < 3))
		_stop("open returned corrupt file index!");
	ip = &iob[io-3].i_ino;
	if ((ip->i_mode & IFMT) != IFDIR) {
		printf("%s is not a directory!\n", line);
		_stop("");
	}
	if (ip->i_size == 0) {
		printf("%s is a zero length directory!\n", line);
		_stop("");
	}
	
	ls(io);
}

ls(io)
register io;
{

	register int	i, size;
	register char	*dp;
	static char	dirbuf[DIRBLKSIZ];

	printf ("\nName -> Inode\n");
	while ((size = read(io, dirbuf, DIRBLKSIZ)) > 0 ) {
		for(dp = dirbuf; (dp < (dirbuf + size)) &&
		    (dp + ((struct direct *)dp)->d_reclen) < (dirbuf + size);
		    dp += ((struct direct *)dp)->d_reclen) {
			if(((struct direct *)dp)->d_ino == 0)
				continue;
			if(((struct direct *)dp)->d_reclen > 
			    DIRSIZ(((struct direct *)dp)))
				continue;
			if(((struct direct *)dp)->d_namlen > MAXNAMLEN+1)
				_stop("Corrupt file name length!  Run fsck soon!\n");
			printf("%s -> %d\n", ((struct direct *)dp)->d_name,
			    ((struct direct *)dp)->d_ino);
		}
	}
}
