/*	machdep.s	4.2	23-Aug-85 */

	.set	_scb, 0x0	# mask for total disable
	.set	HIGH, 0x1f	# mask for total disable
	.set	BERVEC, 0x80	# offset into scb of the bus error vector 
	.set	RESTVEC, 0x8	# offset into scb of the restart vector 

	.set	IPL, 0x8	# Interupt Priority Level register
	.set	SCBB, 0x12	# SCB Block pointer register
	
/* MER bits */

	.set	FATALBUSERR, 0x72400000	# Fatal HVIB error mask
	.set	ERRCD, 0x07	# Error code (mask)
	.set    APE, 1		# Address parity error
	.set    DPE, 2		# Data parity error
	.set    DCE, 3		# Data check error
	.set    VTO, 4		# Versabus timeout
	.set    VBE, 5		# Versabus error
	.set    NEM, 6		# Non-existent memory
	.set	HES, 7		# HVIB extended status


	.globl	_mtpr
_mtpr:
	.word	0x00		# don't keep anything
	mtpr	4(fp),8(fp)
	ret
	

	.globl	_mfpr
_mfpr:
	.word	0x00		# don't keep anything
	mfpr	4(fp),r0
	ret

/*  Copy bytes within kernel */
	
	.globl	_bcopy
_bcopy:
	.word	0x07		# Keep r2,r1,r0
	movl	4(fp),r0
	movl	8(fp),r1
	movl	12(fp),r2
	movblk
	ret


/*
 * badaddr(addr, len, value)
 *	see if access addr with a len type instruction causes a machine check
 *	len is length of access (1=byte, 2=short, 4=long)
 *	value determines whether to read or write:
 *		if value=0, read.
 *		if value!=0, write (appropriate bytes of) value to addr.
 *	r0 = 0 means good(exists); r0 =1 means does not exist.
 */
	.globl	_badaddr
_badaddr:
	.word	0xfc	# Keep r7,r6,r5,r4,r3,r2
	mfpr	$IPL,r1
	mtpr	$HIGH,$IPL
	mfpr	$SCBB,r2
	mtpr	0,$SCBB
	movl	*$BERVEC,r7
	movab	.FOR9,*$BERVEC
	movl	4(fp),r3
	movl	8(fp),r4
	movl	0xc(fp),r5
	jneq	.wrtit
/* 
 * Test address by reading.
*/
.rdit:	bbc	$0,r4,.RD1; tstb	(r3)
.RD1:	bbc	$1,r4,.RD2; tstw	(r3)
.RD2:	bbc	$2,r4,.OK; tstl	(r3)
	jmp	.OK			# made it w/o machine checks
/*
 * Test address by writing.
*/
.wrtit:	bbc	$0,r4,.WR1; 
	movob	r5,(r3)
	clrl	r6
.loop1:	aobleq	$1000,r6,.loop1
.WR1:	bbc	$1,r4,.WR2; 
	movow	r5,(r3)
	clrl	r6
.loop2:	aobleq	$1000,r6,.loop2
.WR2:	bbc	$2,r4,.OK; 
	movl	r5,(r3)
	clrl	r6
.loop3:	aobleq	$1000,r6,.loop3
.OK:	clrl	r0			# made it w/o machine checks
.FOR6:	movl	r7,*$BERVEC
	mtpr	r1,$IPL
	mtpr	r2,$SCBB
	ret

	.align	4
.FOR9:			# Here we catch bus error (if it comes)
	andl3	4(sp),$ERRCD,r0
	cmpl	r0,$HES
	jneq	.VIB
.HVIB:	andl2	$FATALBUSERR,4(sp) # This destroys item on stack!
	beql	.FOR5
	halt			# Fatal Bus Error (not timeout)
.VIB:	cmpl	r0,$APE
	jneq	.FOR4
	halt			# Address parity error !!!
.FOR4:	cmpl	r0,$VBE
	jneq	.FOR5
	halt			# Versabus error
.FOR5:
	movl	$1,r0		# Anything else = bad address
	movab	8(sp),sp	# discard buss error trash
	movab	.FOR6,(sp)		# new program counter on stack.
	rei
