#define INXYHANDLER

#include "../uts/machine/sys/types.h"
#define KERNEL
#include "../uts/machine/sys/param.h"
#undef KERNEL
#include "../uts/machine/sys/time.h"
#include "../uts/machine/sys/vnode.h"
#include "../uts/machine/ufs/inode.h"
#include "../uts/machine/ufs/fs.h"
#include "../uts/machine/ml/pte.h"
#include "../uts/machine/ml/mtpr.h"
#include "../stand/saio.h"
#include "../uts/machine/ml/vmparam.h"
#include "../uts/machine/sys/mtio.h"
#include "../uts/machine/sys/xymacro.h"
#include "../uts/machine/sys/xydata.h"
#define BPI1600 0x1
#define SLOWSPEED 0

struct iopb iopb_struct ;
struct iopb *iopb = &iopb_struct ;
int xyblock = 0 ;
int xyblksiz = MAX_BLOCKSIZE ; 
char junkbuf[MAX_BLOCKSIZE] ; /* used when determining block size on read */

unsigned int iobase[] =
{
	0xff000000,
	0xbf000000,
} ;

xyopen( io )
register struct iob *io ;
{
	struct xylogics_registers *controller = 
		(struct xylogics_registers *)(xyaddr[io->i_ctlr] |
				iobase[io->i_bus]) ;
	unsigned char ctlr_status ;
	int waitmore ;
	static struct ctlr_parms_iopb xy_ctlr_setup_struct ;
	struct ctlr_parms_iopb *xy_ctlr_setup = &xy_ctlr_setup_struct ;
	int slave = io->i_drive ;
	int drivetype = io->i_dev_type ;
	int i ;
	static struct drive_parms_iopb drive_parms_iopb_struct ;
	struct drive_parms_iopb *xy_drive_setup = 
		&drive_parms_iopb_struct ;

	io->i_ctlr_addr = (int)controller ;
	if ( badaddr(&controller->csr_reg, sizeof(controller->csr_reg), 0 ) )
	{
		printf("xylogics board not at address %x\n", controller ) ;
		return( false ) ;
	}

	/* 
	** Make sure this is a xylogics board.
	*/
	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;
	SET_CONTROL_REG(controller,  XYCONTROLLER_RESET) ;
	waitmore = POLLEDWAITCOUNT ;
	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;
	while( ( ctlr_status & XYCONTROLLER_RESET ) && --waitmore )
	{
		DELAY(1000);
		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;
	}


	if ( waitmore == 0 )
	{
		printf("xylogics controller timed out during soft reset.\n") ;
		return( false ) ;
	}

	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;

	if ( ctlr_status != XYREG_BUSY_SEM )
	{
		/* ??? WAITING FOR CONTROLLER FIX 
		printf("	xylogics soft reset failed.  value=%x\n", 
			ctlr_status);
		return( false ) ;
		??? */
	}



	/* 
	** Form controller initialization iopb.
	*/
	xy_ctlr_setup->cmd = XYWRITE_PARAMS ;
	xy_ctlr_setup->scat_gath = 0 ;
	xy_ctlr_setup->chain = 0 ;
	xy_ctlr_setup->done = 0 ;
	xy_ctlr_setup->error_detect = 0 ;
	xy_ctlr_setup->completion_code = 0 ;
	xy_ctlr_setup->status = 0 ;
	xy_ctlr_setup->current_state = 0 ;
	xy_ctlr_setup->subfunction = XYWRITE_CTLR_PARMS ;
	xy_ctlr_setup->interrupt_level = 0 ;
	xy_ctlr_setup->interrupt_vector = 0 ;
	xy_ctlr_setup->AIO_response_time = 0 ; /* TUNABLE */
	xy_ctlr_setup->non_priv_reg = 1 ; /* TRUE */
	xy_ctlr_setup->iopb_cksum = 0 ; /* FALSE */ 
	xy_ctlr_setup->overlapped_rewind = 0 ;
	xy_ctlr_setup->transfer_mode = 0 ; 
	xy_ctlr_setup->auto_update = 1 ; /* TRUE */
	xy_ctlr_setup->release_on_request = 0 ; /* FALSE */
	xy_ctlr_setup->throttle_dead_time = 0 ;
	xy_ctlr_setup->throttle = 0 ;
	xy_ctlr_setup->next_iopb_addrs_mod = 0 ;
	xy_ctlr_setup->priority = 0 ;
	xy_ctlr_setup->next_iopb_addrs = 0 ;
	xy_ctlr_setup->iopb_chksum = 0 ;

	/* 
	** Initialize controller.
	*/
	SET_IOPB_ADDRS(controller,xy_ctlr_setup) ;
	SET_IOPB_ADDRS_MOD(controller, XYADDRS_MOD) ;
	SET_CONTROL_REG(controller, XYAIO) ;

	/*
	** Poll till completion.
	*/
	waitmore = POLLEDWAITCOUNT ;
	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;
	while ( ((ctlr_status & XYBUSY) || 
		!(ctlr_status & XYREMOVE_IOPB)) && 
		--waitmore )
	{
		DELAY(1000);
		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;
	}
	
	if ( waitmore )
	{
		SET_CONTROL_REG(controller, XYREMOVE_IOPB);
	}
	else
	{
		printf("xylogics controller reset failed (polled command timeout)\n") ;
		return( false ) ;
	}
	
	if ( xy_ctlr_setup->completion_code != 0 )
	{
		printf("xylogics controller reset failed (bad completion code)\n") ;
		return( false ) ;
	}




	xy_drive_setup->cmd = XYWRITE_PARAMS ;
	xy_drive_setup->scat_gath = 0 ;
	xy_drive_setup->chain = 0 ;
	xy_drive_setup->done = 0 ;
	xy_drive_setup->error_detect = 0 ;
	xy_drive_setup->completion_code = 0 ;
	xy_drive_setup->status = 0 ;
	xy_drive_setup->current_state = 0 ;
	xy_drive_setup->subfunction = XYWRITE_DRIVE_PARMS ;
	xy_drive_setup->slave_num = slave ;
	xy_drive_setup->interrupt_level = 0 ;
	xy_drive_setup->interrupt_vector = 0 ;
	xy_drive_setup->swap_bytes = 0 ;
	xy_drive_setup->swap_words = 0 ;
	/* Since we don't know what type of drive this is, don't try
		to play with density -- use the default. */
	xy_drive_setup->density_select = 1 ;  
	xy_drive_setup->gap_retry = 0 ;
	xy_drive_setup->write_retry = 0 ;
	xy_drive_setup->read_retry = 0 ;
	xy_drive_setup->ignore_write_error = 0 ;
	xy_drive_setup->ignore_read_error = 0 ;
	xy_drive_setup->density = DENSITY_DEFAULT ;
	xy_drive_setup->speed = SLOWSPEED ;
	xy_drive_setup->inhibit_parity_on_write = 1 ; 
	xy_drive_setup->extended_gap = 0 ;
	xy_drive_setup->data_busy_timeout = DATA_BUSY_TIMEOUT ;
	xy_drive_setup->variable_gaps = 0 ;
	xy_drive_setup->next_iopb_addrs_mod = 0 ;
	xy_drive_setup->priority = 0 ;
	xy_drive_setup->next_iopb_addrs = 0 ;
	xy_drive_setup->iopb_chksum = 0 ;


	/* 
	** Wait till controller is ready.
	*/
	waitmore = POLLEDWAITCOUNT ;
	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;
	while ( (ctlr_status & XYBUSY)  && --waitmore ) 
	{
		DELAY(1000);
		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;
	}

	if ( waitmore == 0 )
	{
		printf("xylogics drive %d on controller at %x reset failed (controller timeout)\n", slave, controller ) ;
		return( false ) ;
	}


	/* 
	** Initialize drive.
	*/
	SET_IOPB_ADDRS(controller,xy_drive_setup) ;
	SET_IOPB_ADDRS_MOD(controller, XYADDRS_MOD) ;
	SET_CONTROL_REG(controller, XYAIO) ;

	/*
	** Poll till completion.
	*/
	waitmore = POLLEDWAITCOUNT ;
	volatile(controller) ;
	UNCACHE_STATUS_REG(controller) ;
	ctlr_status = GET_STATUS_REG(controller) ;
	while ( ((ctlr_status & XYBUSY) || 
		!(ctlr_status & XYREMOVE_IOPB)) && 
		--waitmore )
	{
		DELAY(1000);
		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;
	}
	
	if ( waitmore )
	{
		SET_CONTROL_REG(controller, XYREMOVE_IOPB);
	}
	else
	{
		printf("xylogics drive reset failed (polled command timeout)\n") ;
		return( false ) ;
	}


	if ( xy_drive_setup->completion_code != 0 )
	{
		printf("xylogics drive %d on controller at %x reset failed (completion code)\n", slave, controller ) ;
		return( false ) ;
	}



	if ( xycmd( DO_RWTA, 1, io->i_drive, io->i_ctlr_addr, 0) < 0 )
	{
		printf("xylogics: Rewind failed!\n") ;
		return( false ) ;
	}
	if ( io->i_part > 0 )
	{
		if ( xycmd( DO_SFMF, io->i_part, io->i_drive, 
			io->i_ctlr_addr, 0) < 0 )
		{
			printf("xylogics: file seek failure!\n") ;
			return( false ) ;
		}
	}

	xyblock =0  ;
	iopb->chain = 0 ;
	iopb->interrupt_level = 0 ;
	iopb->next_iopb_addrs = NULL ;
	iopb->data_addrs_mod = XYADDRS_MOD ;
	iopb->next_iopb_addrs_mod = NULL ;
	iopb->priority = FALSE ;
	iopb->iopb_chksum = FALSE ;

	/*
	** We are done if we are opening a file.
	** Continue if we are opening the raw device.
	*/
	if (io->i_flgs & F_FILE) {
		xyblksiz = 0x400 ; /* Default block size */
		return;
	}

	if ( io->i_flgs & F_READ )
	{
		if ( (xyblksiz = xycmd( DO_BRD, MAX_BLOCKSIZE, io->i_drive, 
			io->i_ctlr_addr, junkbuf )) < 0 )
		{
			printf("xylogics: Failed to determine block size./n") ;
			return( false ) ;
		}
		xycmd( DO_SPB, 1, io->i_drive, io->i_ctlr_addr, 0) ;
	}
}


xyclose( io )
struct iob *io ;
{
	if ( io->i_flgs & F_WRITE )
		xycmd( DO_W_FM, 1, io->i_drive, io->i_ctlr_addr, 0 ) ;
	xycmd( DO_RWTA, 1, io->i_drive, io->i_ctlr_addr, 0 ) ;
	xyblock = 0 ;

}



xystrategy( io, func )
struct iob *io ;
long func ;
{
	long mtfunc ;
	long count ;
	long done ;
	char *dataaddr ;


	if ( func == READ )
		mtfunc = DO_BRD ;
	else
		mtfunc = DO_BWT ;

	if ( (io->i_flgs & F_FILE) || (mtfunc == DO_BWT) )
	{
		/* if blocked device, seek to correct block.*/
		if (io->i_flgs & F_FILE)  
		{
			if ( io->i_bn > xyblock )
			{
				xycmd(DO_SPF, io->i_bn-xyblock, io->i_drive, 
					io->i_ctlr_addr,0);
			}
			else if ( xyblock > io->i_bn )
			{
				xycmd(DO_SPB, xyblock-io->i_bn, io->i_drive, 
					io->i_ctlr_addr,0);
			}
		}

		count = io->i_cc ;
		dataaddr = io->i_ma ;
		while ( count > 0 )
		{
			done = xycmd(mtfunc, (count>xyblksiz)?xyblksiz : count, 
				io->i_drive, io->i_ctlr_addr, dataaddr) ;
			if ( done < 0 )
				break ;
			count -= done ;
			dataaddr += done ;
		}
		return( io->i_cc - count ) ;
	}
	else /* raw device, read command */
	{
		return( xycmd(mtfunc, io->i_cc, io->i_drive,
			io->i_ctlr_addr,io->i_ma));
	}
}


xycmd( func, count, drive, controller, dataaddr )
long func ;
long count ;
long drive ;
caddr_t controller ;
char *dataaddr ;
{
	unsigned char ctlr_status ;
	/* 
	** Fill in iopb.
	*/
	iopb->cmd = logical_to_xycmd[func] ; 
	iopb->subfunction = logical_to_xysub[func] ;
	iopb->scat_gath = 0 ;
	iopb->list_length = 0 ;
	iopb->data_addrs = (unsigned int)dataaddr ;
	iopb->slave_num = drive ;
	iopb->done = 0 ;
	iopb->error_detect = 0 ;
	iopb->completion_code = 0 ;
	iopb->status = 0 ;
	iopb->current_state = 0 ;
	iopb->interrupt_vector = 0 ;
	if ((iopb->cmd == XYREAD) && (count > xyblksiz))
		iopb->byte_count = xyblksiz ;
	else
		iopb->byte_count = count ;
	iopb->last_error = 0 ;
	iopb->error_count = 0 ;
	iopb->actual_count = 0 ;



	/* 
	** Wait till controller is ready.
	*/
	{
		int waitmore = POLLEDWAITCOUNT ;

		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;
		while ( (ctlr_status &  XYAIO) && waitmore-- )
		{
			DELAY(1000) ;
			volatile(controller) ;
			UNCACHE_STATUS_REG(controller) ;
			ctlr_status = GET_STATUS_REG(controller) ;
		}

		if ( ! waitmore )
		{
			printf("xylogics: Controller at %x timed out -- cannot add command.\n", controller ) ;
			return( false ) ;
		}
	}

	/* 
	** Send a command to controller.
	*/
	SET_IOPB_ADDRS(controller, iopb) ;
	SET_IOPB_ADDRS_MOD(controller,XYADDRS_MOD) ;
	SET_CONTROL_REG(controller,XYAIO) ;

	/* 
	** Wait till controller is done.
	*/
	{
		int waitmore = POLLEDWAITCOUNT ;

		volatile(controller) ;
		UNCACHE_STATUS_REG(controller) ;
		ctlr_status = GET_STATUS_REG(controller) ;

		while ( ((ctlr_status & XYBUSY) || 
			!(ctlr_status & XYREMOVE_IOPB)) &&
			--waitmore ) 
		{
			DELAY(1000);
			volatile( controller ) ;
			UNCACHE_STATUS_REG(controller) ;
			ctlr_status = GET_STATUS_REG(controller) ;
		}


		if ( waitmore )
		{
			SET_CONTROL_REG(controller, XYREMOVE_IOPB);
		}
		else
		{
			printf("xylogics: Controller at %x timed out during polled command.\n", controller ) ;
			return( false ) ;
		}
	}



	uncache( &iopb->actual_count ) ;
	uncache( &iopb->completion_code ) ;
	if ( iopb->completion_code && (iopb->completion_code != SHORT_RECORD) &&
		(iopb->completion_code != LONG_RECORD) &&
		(iopb->completion_code != FM_ON_READ) )
	{
		printf("xylogics: completion code %x received.\n", 
			iopb->completion_code ) ;
	}
	/*
	** Update status.
	*/
	switch( func )
	{
		case DO_BRD:
		{
			mtpr(0, PADC) ;
			xyblock++ ;
			break ;
		}
		case DO_BWT:
			xyblock++ ;
			break ;
		case DO_RWTA:
			xyblock = 0 ;
			break ;
		case DO_SPF:
			xyblock += iopb->actual_count ;
			break ;
		case DO_SPB:
			xyblock -= iopb->actual_count ;
			break ;
	}
			
		
	return( iopb->actual_count ) ;
}







/*
	This is a dummy procedure which is called whenever there is danger
	of the optimizer optimizing out loop invariants that are actually
	volatile (that is, memory-mapped locations on controller boards).
*/
/* void */
volatile(address)
caddr_t address ;
{} ;

#undef INXYANDLER
