# @(#)ml.mk	6.6

LIBNAME = 	../lib_fpe
CFLAGS = 	-DKERNEL $(CFL)

FPFILES = \
	$(LIBNAME)(Kaddd.o) \
	$(LIBNAME)(Kaddf.o) \
	$(LIBNAME)(Katanf.o) \
	$(LIBNAME)(Kcvtdl.o) \
	$(LIBNAME)(Kcvtfl.o) \
	$(LIBNAME)(Kcvtld.o) \
	$(LIBNAME)(Kcvtlf.o) \
	$(LIBNAME)(Kdivd.o) \
	$(LIBNAME)(Kdivf.o) \
	$(LIBNAME)(Kexpf.o) \
	$(LIBNAME)(Kfnorm.o) \
	$(LIBNAME)(Kfp_exp.o) \
	$(LIBNAME)(Kfp_mvtoacc.o) \
	$(LIBNAME)(Kfrexpd.o) \
	$(LIBNAME)(Kfrexpf.o) \
	$(LIBNAME)(Kldexpf.o) \
	$(LIBNAME)(Klogf.o) \
	$(LIBNAME)(Kmodf.o) \
	$(LIBNAME)(Kmuld.o) \
	$(LIBNAME)(Kmulf.o) \
	$(LIBNAME)(Knegd.o) \
	$(LIBNAME)(Knegf.o) \
	$(LIBNAME)(Ksfnorm.o) \
	$(LIBNAME)(Ksfp_exp.o) \
	$(LIBNAME)(Ksinfcosf.o) \
	$(LIBNAME)(Ksqrtf.o) \
	$(LIBNAME)(Ksubd.o) \
	$(LIBNAME)(Ksubf.o) \
	$(LIBNAME)(addd.o) \
	$(LIBNAME)(cmpd.o) \
	$(LIBNAME)(cmpf.o) \
	$(LIBNAME)(cvtdl.o) \
	$(LIBNAME)(cvtld.o) \
	$(LIBNAME)(cvtlf.o) \
	$(LIBNAME)(cvtfl.o) \
	$(LIBNAME)(divd.o) \
	$(LIBNAME)(udiv.o) \
	$(LIBNAME)(fp_exp.o) \
	$(LIBNAME)(fnorm.o) \
	$(LIBNAME)(muld.o) \
	$(LIBNAME)(negd.o) \
	$(LIBNAME)(subd.o) \
	$(LIBNAME)(fpemulate.o) 

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FPFILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@-case $< in \
	fpemulate.c)\
		$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		../inline/inline $*.s $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
			if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
				$(C2) $*.i $*.s ; \
				if [ $$? != 0 ] ; then \
					exit 1 ; \
				fi ; \
				mv $*.s $*.i ; \
			fi ; \
		fi ; \
		$(AS) -o $*.o $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		ar r $@ $*.o ; \
		rm $*.i ; \
		;; \
	*) \
		/lib/cpp $*.c > $*.s ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		$(AS) -o $*.o $*.s ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		$(LD) -x -r $*.o ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		mv a.out $*.o ; \
		ar r $@ $*.o ; \
		;; \
	esac
	@-rm -f $*.o $*.s

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:

depend:
	@../cf/osdep "$(FPFILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp fpe.mk fpe.mk.bak
	@ed - fpe.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_fpe(Kaddd.o): ../fpe/fp.h 

../lib_fpe(Kaddf.o): ../fpe/fp.h 


../lib_fpe(Kcvtdl.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kcvtfl.o): ../fpe/fp.h 

../lib_fpe(Kcvtld.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kcvtlf.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kdivd.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kdivf.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 


../lib_fpe(Kfnorm.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kfp_exp.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kfp_mvtoacc.o): ../fpe/fp.h 



../lib_fpe(Kldexpf.o): ../fpe/fp_in_krnl.h 


../lib_fpe(Kmodf.o): ../fpe/fp.h 

../lib_fpe(Kmuld.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Kmulf.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Knegd.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Knegf.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Ksfnorm.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 

../lib_fpe(Ksfp_exp.o): ../fpe/fp.h ../fpe/fp_in_krnl.h 





../lib_fpe(addd.o): ../fpe/fp.h 



../lib_fpe(cvtdl.o): ../fpe/fp.h 

../lib_fpe(cvtld.o): ../fpe/fp.h 

../lib_fpe(cvtlf.o): ../fpe/fp.h 

../lib_fpe(cvtfl.o): ../fpe/fp.h 

../lib_fpe(divd.o): ../fpe/fp.h 


../lib_fpe(fp_exp.o): ../fpe/fp.h 

../lib_fpe(fnorm.o): ../fpe/fp.h 

../lib_fpe(muld.o): ../fpe/fp.h 

../lib_fpe(negd.o): ../fpe/fp.h 


../lib_fpe(fpemulate.o): ../fpe/fp_in_krnl.h ../ml/param.h \
	../ml/pcb.h ../ml/psl.h ../ml/reg.h ../sys/dmap.h \
	../sys/errno.h ../sys/param.h ../sys/resource.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/user.h 
