# @(#)hcxif.mk	6.6

LIBNAME = 	../lib_hcxif
CFLAGS = 	-DKERNEL -DINET $(CFL)

FILES = \
	$(LIBNAME)(if_en.o) \
	$(LIBNAME)(if_ex.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp hcxif.mk hcxif.mk.bak
	@ed - hcxif.mk < eddep
	@rm eddep makedep
 
# DO NOT DELETE THIS LINE - make depend uses it

../lib_hcxif(if_en.o): ../hcxif/if_com.h ../hcxif/if_en.h \
	../ml/mtpr.h ../ml/param.h ../ml/pte.h ../net/if.h \
	../net/if_arp.h ../net/netisr.h ../net/route.h \
	../netinet/if_ether.h ../netinet/in.h ../netinet/in_systm.h \
	../netinet/in_var.h ../netinet/ip.h ../netinet/ip_var.h \
	../sys/buf.h ../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/systm.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/vbavar.h ../sys/vmmac.h 

../lib_hcxif(if_ex.o): ../hcxif/if_com.h ../hcxif/if_ex.h \
	../ml/mtpr.h ../ml/param.h ../ml/pte.h ../net/if.h \
	../net/if_arp.h ../net/netisr.h ../net/route.h \
	../netinet/if_ether.h ../netinet/in.h ../netinet/in_systm.h \
	../netinet/in_var.h ../netinet/ip.h ../netinet/ip_var.h \
	../sys/buf.h ../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/reboot.h \
	../sys/signal.h ../sys/socket.h ../sys/systm.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/vbavar.h ../sys/vmmac.h 
