/* @(#)clist.c	6.1 */
#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/tty.h"

getc(p)
register struct clist *p;
{
	register struct cblock *bp;
	register int c, s;

	s = spl8();
	if (p->c_cc > 0) {
		p->c_cc--;
		bp = p->c_cf;
		c = bp->c_data[bp->c_first++]&0377;
		if (bp->c_first == bp->c_last) {
			/*
			 * Emptied the block, have to release it.
			 */
			if ((p->c_cf = bp->c_next) == NULL)
				p->c_cl = NULL;
			bp->c_next = cfreelist.c_next;
			cfreelist.c_next = bp;
			if (cfreelist.c_flag) {
				cfreelist.c_flag = 0;
				wakeup((caddr_t)&cfreelist);
			}
		}
	} else
		c = -1;
	splx(s);
	return(c);
}

putc(c, p)
register struct clist *p;
{
	register struct cblock *bp, *obp;
	register s;

	s = spl8();
	if ((bp = p->c_cl) == NULL || bp->c_last == cfreelist.c_size) {
		obp = bp;
		if ((bp = cfreelist.c_next) == NULL) {
			splx(s);
			return(-1);
		}
		cfreelist.c_next = bp->c_next;
		bp->c_next = NULL;
		bp->c_first = bp->c_last = 0;
		if (obp == NULL)
			p->c_cf = bp;
		else
			obp->c_next = bp;
		p->c_cl = bp;
	}
	bp->c_data[bp->c_last++] = c;
	p->c_cc++;
	splx(s);
	return(0);
}


/*
 * This routine will set the cur_clist structure pointed to by
 * "ccl" to point at the beginning of the clist "p".
 */
setcclist(ccl, p)
	register struct cur_clist *ccl;
	register struct clist *p;
{
	register struct cblock *bp = p->c_cf;

	if ((ccl->cr_cb = bp) == NULL)
		ccl->cr_ndx = 0;
	else
		ccl->cr_ndx = bp->c_first;
}

/*
 * This routine will return the next character from the clist queue
 * pointed into by "ccl".
 *
 * Callers must not allow getc's to happen between nextc's so that the
 * pointer becomes invalid.  Note that interrupts are NOT masked.
 */
nextc(ccl)
	register struct cur_clist *ccl;
{
	register struct cblock *bp;
	register int c;

	if ((bp = ccl->cr_cb) == NULL)
		return(-1);

	c = bp->c_data[ccl->cr_ndx++]&0377;
	if (ccl->cr_ndx >= bp->c_last) {
		bp = bp->c_next;
		if ((ccl->cr_cb = bp) == NULL)
			ccl->cr_ndx = 0;
		else
			ccl->cr_ndx = bp->c_first;
	}
	return(c);
}

/*
 * Remove the last character in the list and return it.
 */
unputc(p)
	register struct clist *p;
{
	register struct cblock *bp, *obp;
	register int c, s;

	s = spl8();
	if (p->c_cc > 0 && (bp = p->c_cl) != NULL) {
		c = bp->c_data[--bp->c_last];
		p->c_cc--;
		if (bp->c_last <= 0) {
			/*
			 * Emptied the block, have to release it.
			 */
			bp->c_next = cfreelist.c_next;
			cfreelist.c_next = bp;
			if (cfreelist.c_flag) {
				cfreelist.c_flag = 0;
				wakeup((caddr_t)&cfreelist);
			}

			if (bp == p->c_cf) {
				/*
				 * Emptied the whole clist.
				 */
				p->c_cf = p->c_cl = NULL;
				p->c_cc = 0;
			} else {
				/*
				 * Have to find the guy pointing to bp.
				 */
				for (obp = p->c_cf;; obp = obp->c_next) {
					if (obp->c_next == bp) {
						obp->c_next = NULL;
						p->c_cl = obp;
						break;
					} else if (obp->c_next == NULL) {
						printf("unputc: bad clist\n");
						p->c_cl = obp;
						break;
					}
				}
			}
		}
	} else
		c = -1;
	splx(s);
	return(c);
}


struct cblock *
getcf()
{
	register struct cblock *bp;
	register int s;

	s = spl8();
	if ((bp = cfreelist.c_next) != NULL) {
		cfreelist.c_next = bp->c_next;
		bp->c_next = NULL;
		bp->c_first = 0;
		bp->c_last = cfreelist.c_size;
	}
	splx(s);
	return(bp);
}

putcf(bp)
register struct cblock *bp;
{
	register int s;

	s = spl8();
	bp->c_next = cfreelist.c_next;
	cfreelist.c_next = bp;
	if (cfreelist.c_flag) {
		cfreelist.c_flag = 0;
		wakeup((caddr_t)&cfreelist);
	}
	splx(s);
}

struct cblock *
getcb(p)
register struct clist *p;
{
	register struct cblock *bp;
	register int s;

	s = spl8();
	if ((bp = p->c_cf) != NULL) {
		p->c_cc -= bp->c_last - bp->c_first;
		if ((p->c_cf = bp->c_next) == NULL)
			p->c_cl = NULL;
	}
	splx(s);
	return(bp);
}

putcb(bp, p)
register struct cblock *bp;
register struct clist *p;
{
	register struct cblock *obp;
	register int s;

	s = spl8();
	if ((obp = p->c_cl) == NULL)
		p->c_cf = bp;
	else
		obp->c_next = bp;
	p->c_cl = bp;
	bp->c_next = NULL;
	p->c_cc += bp->c_last - bp->c_first;
	splx(s);
}

getcbp(p, cp, n)
struct clist *p;
register char *cp;
register n;
{
	register struct cblock *bp;
	register char *op;
	register on;
	register char *acp = cp;

	while (n) {
		if ((bp = p->c_cf) == NULL)
			break;
		op = &bp->c_data[bp->c_first];
		on = bp->c_last - bp->c_first;
		if (n >= on) {
			bcopy(op, cp, (unsigned)on);
			cp += on;
			n -= on;
			if ((p->c_cf = bp->c_next) == NULL)
				p->c_cl = NULL;
			bp->c_next = cfreelist.c_next;
			cfreelist.c_next = bp;
		} else {
			bcopy(op, cp, (unsigned)n);
			bp->c_first += n;
			cp += n;
			n = 0;
			break;
		}
	}
	n = cp - acp;
	p->c_cc -= n;
	return(n);
}

putcbp(p, cp, n)
struct clist *p;
register char *cp;
register n;
{
	register struct cblock *bp, *obp;
	register char *op;
	register on;
	register char *acp = cp;

	while (n) {
		if ((bp = p->c_cl) == NULL || bp->c_last == cfreelist.c_size) {
			obp = bp;
			if ((bp = cfreelist.c_next) == NULL)
				break;
			cfreelist.c_next = bp->c_next;
			bp->c_next = NULL;
			bp->c_first = bp->c_last = 0;
			if (obp == NULL)
				p->c_cf = bp;
			else
				obp->c_next = bp;
			p->c_cl = bp;
		}
		op = &bp->c_data[bp->c_last];
		on = cfreelist.c_size - bp->c_last;
		if (n >= on) {
			bcopy(cp, op, (unsigned)on);
			cp += on;
			bp->c_last += on;
			n -= on;
		} else {
			bcopy(cp, op, (unsigned)n);
			cp += n;
			bp->c_last += n;
			n = 0;
			break;
		}
	}
	n = cp - acp;
	p->c_cc += n;
	return(n);
}
