#include "../ml/pte.h"

#include "../sys/param.h"
#include "../sys/buf.h"
#include "../sys/uio.h"
#include "../sys/user.h"
#include "../sys/file.h"
#include "../sys/utsname.h"
#include "../sys/elog.h"
#include "../sys/erec.h"

static	short	logging;

erropen(dev, flg)
	dev_t dev;
{
	if(logging) {
		return(EBUSY);
	}
	if((flg&FWRITE) || minor(dev) != 0) {
		return(ENXIO);
	}
	if(suser()) {
		logstart();
		logging++;
		return(0);
	}
	return(EPERM);
}

/*ARGSUSED*/
errclose(dev, flg)
	dev_t dev;
{
	logging = 0;
	return(0);
}

/*ARGSUSED*/
errread(dev, uio)
	dev_t dev;
	register struct uio *uio;
{
	register struct errhdr *eup;
	struct errhdr	*geterec();
	register int error;

	if(logging == 0)
		return(0);
	eup = geterec();
	if (error = uiomove((caddr_t) eup, eup->e_len, UIO_READ, uio))
		return(error);
	freeslot(eup);
	return(0);
}
