# @(#)io.mk	6.6

LIBNAME = 	../lib_io
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(iosubr.o) \
	$(LIBNAME)(dsort.o) \
	$(LIBNAME)(qt.o) \
	$(LIBNAME)(sc.o) \
	$(LIBNAME)(cy.o) \
	$(LIBNAME)(xylogics.o) \
	$(LIBNAME)(drivename.o) \
	$(LIBNAME)(vcc.o) \
	$(LIBNAME)(vcm.o) \
	$(LIBNAME)(vcx.o) \
	$(LIBNAME)(vddc.o) \
	$(LIBNAME)(hdc.o) \
	$(LIBNAME)(tty.o) \
	$(LIBNAME)(tt1.o) \
	$(LIBNAME)(clist.o) \
	$(LIBNAME)(tty_pty.o) \
	$(LIBNAME)(sys.o) \
	$(LIBNAME)(err.o) \
	$(LIBNAME)(vp.o) \
	$(LIBNAME)(sxt.o) \
	$(LIBNAME)(alm.o) \
	$(LIBNAME)(rtc.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp io.mk io.mk.bak
	@ed - io.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_io(iosubr.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/conf.h ../sys/dk.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/map.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vbavar.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_io(dsort.o): ../ml/param.h ../sys/buf.h ../sys/param.h \
	../sys/signal.h ../sys/systm.h ../sys/types.h 

../lib_io(cy.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cipher.h ../sys/cmap.h ../sys/dmap.h \
	../sys/elog.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/iobuf.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/mtio.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vbavar.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_io(xylogics.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/elog.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/iobuf.h \
	../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h \
	../sys/mtio.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vbavar.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/xydata.h ../sys/xymacro.h 

../lib_io(drivename.o): ../sys/mtio.h ../sys/types.h 

../lib_io(vcc.o): ../ml/param.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/kernel.h \
	../sys/param.h ../sys/signal.h ../sys/termio.h ../sys/time.h \
	../sys/tty.h ../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/vioc.h 

../lib_io(vcm.o): ../ml/param.h ../sys/bsc/bsc.h \
	../sys/bsc/bscio.h ../sys/conf.h ../sys/fcntl.h ../sys/file.h \
	../sys/ioctl.h ../sys/ioctlp.h ../sys/kernel.h ../sys/param.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/termio.h ../sys/time.h \
	../sys/tty.h ../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/vioc.h 

../lib_io(vcx.o): ../bop/sdlcbuf.h ../bop/vcbop.h ../hsp/local.h \
	../ml/param.h ../ml/pcb.h ../ml/pte.h ../sys/bsc/bsc.h \
	../sys/bsc/bscio.h ../sys/buf.h ../sys/conf.h ../sys/dk.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ioctl.h ../sys/ioctlp.h ../sys/kernel.h ../sys/map.h \
	../sys/param.h ../sys/resource.h ../sys/signal.h \
	../sys/sysinfo.h ../sys/termio.h ../sys/time.h ../sys/tty.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vbavar.h ../sys/vioc.h 

../lib_io(vddc.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/cmap.h ../sys/conf.h ../sys/dk.h ../sys/dmap.h \
	../sys/dsk.h ../sys/dskio.h ../sys/elog.h ../sys/errno.h \
	../sys/iobuf.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/map.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vbavar.h \
	../sys/vddc.h ../sys/vmmac.h 

../lib_io(hdc.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/conf.h \
	../sys/dir.h ../sys/dk.h ../sys/dmap.h ../sys/dsk.h \
	../sys/dskio.h ../sys/elog.h ../sys/errno.h ../sys/hdc.h \
	../sys/iobuf.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/reboot.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vbavar.h \
	../sys/vmmac.h /usr/include/ctype.h /usr/include/sys/types.h 

../lib_io(tty.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/conf.h ../sys/dk.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/sysinfo.h ../sys/systm.h \
	../sys/termio.h ../sys/time.h ../sys/tty.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_io(tt1.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/conf.h ../sys/dk.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/sysinfo.h ../sys/systm.h \
	../sys/termio.h ../sys/time.h ../sys/tty.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_io(clist.o): ../ml/param.h ../sys/param.h ../sys/signal.h \
	../sys/systm.h ../sys/tty.h ../sys/types.h 

../lib_io(tty_pty.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/termio.h ../sys/time.h ../sys/tty.h \
	../sys/tty_pty.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_io(sys.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/ipc.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/tty.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_io(err.o): ../ml/param.h ../ml/pcb.h ../ml/pte.h \
	../sys/buf.h ../sys/dmap.h ../sys/elog.h ../sys/erec.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/param.h \
	../sys/resource.h ../sys/signal.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/utsname.h 

../lib_io(vp.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/ipc.h ../sys/kernel.h ../sys/mtio.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vbavar.h ../sys/vcmd.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h ../sys/vp.h 

../lib_io(sxt.o): ../ml/param.h ../ml/pcb.h ../ml/pte.h \
	../sys/async.h ../sys/bsem.h ../sys/conf.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ioctlp.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/sxt.h ../sys/systm.h ../sys/termio.h ../sys/time.h \
	../sys/ttold.h ../sys/tty.h ../sys/ttydev.h ../sys/types.h \
	../sys/uio.h ../sys/user.h 

../lib_io(alm.o): ../bop/bopdebug.h ../ml/param.h ../ml/pcb.h \
	../sys/alm.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/conf.h ../sys/dir.h ../sys/dk.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h ../sys/map.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/tty.h ../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/uio.h ../sys/user.h 

../lib_io(rtc.o): ../ml/param.h ../ml/pcb.h ../sys/buf.h \
	../sys/dir.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctlp.h ../sys/kernel.h ../sys/param.h \
	../sys/resource.h ../sys/rtc.h ../sys/rtcmacros.h \
	../sys/signal.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vbavar.h 
