/*
 *	VIOC-X driver
 */

#include "../sys/param.h"
#include "../sys/termio.h"
#include "../sys/ioctl.h"
#include "../sys/tty.h"
#include "../sys/user.h"
#include "../sys/map.h"
#include "../ml/pte.h"
#include "../sys/buf.h"
#include "../sys/vbavar.h"
#include "../sys/conf.h"
#include "../sys/file.h"
#include "../sys/uio.h"
#include "../sys/dk.h"
#include "../sys/sysinfo.h"
#include "../sys/kernel.h"
#include "../sys/vioc.h"

#include "../bop/sdlcbuf.h"
#include "../bop/vcbop.h"
/*
	BSC header
*/
#include "../sys/bsc/bscio.h"
#include "../sys/bsc/bsc.h"
extern int nvbsc;
extern	char bscport[];
extern struct bsc bsc[];

/*
 *	HSP header
 */
#include "../hsp/local.h"
extern int nhsp;


extern	caddr_t		VIOCBAS[];
extern	struct	vcx	vcx[] ;
extern	struct	tty	vx_tty[];
extern 	struct 	vcmds 	v_cmds[];
extern	struct	vba_device *vxinfo[];
extern	struct	vba_ctlr *vxminfo[];
extern	int		nvxports;
extern	int		vx_break[];
extern  char 	bscno;


/*
 * Fill ahead save buffer
 */
static char *sav_cb[16*16];

int	vxproc() ;
int	ttrstrt() ;
caddr_t vtoph();
struct	vxcmd	*vobtain();

int	vxpanic = 0;

/*
 * Driver information for auto-configuration stuff.
 * (not tested and probably should be changed)
 */
int	vxprobe(), vxslave(), vxattach(), vxrint();

struct	vba_driver vxdriver = {
	vxprobe, vxslave, vxattach, 0, 0, "VIOC ",
	vxinfo, "VIOC ",vxminfo, HID_HVIOC
};

extern long nvx;
extern char vxtype[];	/* 0: viox-x/vioc-b; 1: vioc-bop */
extern char vxbopno[];	/* BOP board no. if indicated by vxtype[] */
char vxbbno = -1;
short vbtbl = -1;
extern vbrall();

vxprobe( um )
	struct vba_ctlr * um ;
{
	register int br, cvec;
	register struct vblok *vp ;

#ifdef lint
	br = 0; cvec = br; br = cvec;
#endif

	vp = (struct vblok *) um -> um_addr ;
	if(badaddr(vp, 1, 0))
		return(0);
	vp->v_fault = 0 ;
	vp->v_vioc = V_BSY ;
	vp->v_hdwre = V_RESET ;		/* reset interrupt */

	DELAY(4000000);
	if (vp->v_fault != VREADY)
		return(0);

	/* allocate the interrupt vectors */
	return( vx_get_ivct( um ) ) ;
}

int
vx_get_ivct( um )
	struct vba_ctlr * um ;
{
	int             ack_ivct, cmdrsp_ivct, unsol_ivct ;
	extern	int	Xvackint0,	Xvcmdrsp0,	Xvunsol0,
	           	Xvackint1,	Xvcmdrsp1,	Xvunsol1,
                    	Xvackint2,	Xvcmdrsp2,	Xvunsol2,
                   	Xvackint3,	Xvcmdrsp3,	Xvunsol3,
                    	Xvackint4,	Xvcmdrsp4,	Xvunsol4,
                    	Xvackint5,	Xvcmdrsp5,	Xvunsol5,
                     	Xvackint6,	Xvcmdrsp6,	Xvunsol6,
                    	Xvackint7,	Xvcmdrsp7,	Xvunsol7,
                    	Xvackint8,	Xvcmdrsp8,	Xvunsol8,
                    	Xvackint9,	Xvcmdrsp9,	Xvunsol9,
                     	Xvackint10,	Xvcmdrsp10,	Xvunsol10,
                     	Xvackint11,	Xvcmdrsp11,	Xvunsol11,
                    	Xvackint12,	Xvcmdrsp12,	Xvunsol12,
			Xvackint13,	Xvcmdrsp13,	Xvunsol13,
			Xvackint14,	Xvcmdrsp14,	Xvunsol14 ;

	static	int	vx_proc[] = {
	            	(int)& Xvackint0,  (int)& Xvcmdrsp0,  (int)& Xvunsol0,
	           	(int)& Xvackint1,  (int)& Xvcmdrsp1,  (int)& Xvunsol1,
                    	(int)& Xvackint2,  (int)& Xvcmdrsp2,  (int)& Xvunsol2,
                   	(int)& Xvackint3,  (int)& Xvcmdrsp3,  (int)& Xvunsol3,
	            	(int)& Xvackint4,  (int)& Xvcmdrsp4,  (int)& Xvunsol4,
	           	(int)& Xvackint5,  (int)& Xvcmdrsp5,  (int)& Xvunsol5,
                    	(int)& Xvackint6,  (int)& Xvcmdrsp6,  (int)& Xvunsol6,
                   	(int)& Xvackint7,  (int)& Xvcmdrsp7,  (int)& Xvunsol7,
	            	(int)& Xvackint8,  (int)& Xvcmdrsp8,  (int)& Xvunsol8,
	           	(int)& Xvackint9,  (int)& Xvcmdrsp9,  (int)& Xvunsol9,
                    	(int)& Xvackint10, (int)& Xvcmdrsp10, (int)& Xvunsol10,
                   	(int)& Xvackint11, (int)& Xvcmdrsp11, (int)& Xvunsol11,
	            	(int)& Xvackint12, (int)& Xvcmdrsp12, (int)& Xvunsol12,
	           	(int)& Xvackint13, (int)& Xvcmdrsp13, (int)& Xvunsol13,
                    	(int)& Xvackint14, (int)& Xvcmdrsp14, (int)& Xvunsol14,
	} ;

	ack_ivct = get_ivct( 0, 1 ) ;
	cmdrsp_ivct = get_ivct( 0, 1 ) ;
	unsol_ivct = get_ivct( 0, 1 ) ;
	if ( (ack_ivct==(-1)) || (cmdrsp_ivct==(-1))||(unsol_ivct == (-1)) ) {
	        return_ivct( ack_ivct ) ;
	        return_ivct( cmdrsp_ivct ) ;
	        return_ivct( unsol_ivct ) ;
	        return(0) ;
	}
	init_ivct( ack_ivct,    vx_proc[ (um -> um_ctlr * 3) + 0 ] ) ;
	init_ivct( cmdrsp_ivct, vx_proc[ (um -> um_ctlr * 3) + 1 ] ) ;
	init_ivct( unsol_ivct,  vx_proc[ (um -> um_ctlr * 3) + 2 ] ) ;

	um -> um_ivct = ack_ivct | (cmdrsp_ivct << 8) | (unsol_ivct << 16) ;
	return(1);
}

vxslave( ui, reg )
	struct vba_device *	ui ;
	caddr_t			reg ;
{
	return( 1 ) ;
}

vxattach(ui)
	register struct vba_device *ui;
{
	VIOCBAS[ui->ui_unit] = ui->ui_addr;
	set_up_pte( (ui -> ui_physaddr + 1024) , 15 ) ;
	vxinit(ui, 1);
}

/*
 * Called from timeout to wakeup processes sleeping on DTR drop.
 */
vxtimeout (tp)
struct tty *tp;
{
	tp->t_state &= ~DTRTOUT;
	wakeup (tp);
}

/*
 * Open a VX line.
 */
vxopen(dev, flag)
{
	register struct tty *tp;	/* pointer to tty struct for port */
	register struct vcx *xp;	/* pointer to VIOC-X info/cmd buffer */
	register d;			/* minor device number */
	register error;


	d = minor(dev);			/* get minor device number */
	if (d >= nvxports)		/* validate minor device number */
		return ENXIO;		/* set errno to indicate bad port # */
	tp = &vx_tty[d];		/* index the tty structure for port */

	xp = &vcx[d>>4];			/* index VIOC-X info/cmd area */
	d &= 017;

 	/*
	 * If we are resetting the VIOC, wait until the LIDENT has
 	 * completed.
 	 */
 	while (xp->v_state&V_RESETTING)
 		slumber((caddr_t)&xp->v_state, INTERRUPTABLE, devcntrlboost);

	if (xp->v_hiport == xp->v_loport ||	  /* no ports on this board */
	   d < xp->v_loport || d > xp->v_hiport) /* not in the range of ports */
		return ENXIO;		/* bad minor device number */

	/*
	 * If DTR has been lowered, delay before raising it so that
	 * the device has the time to recognize it has been lowered.
	 */
	if ((tp->t_state&DTRON) == 0) {
		tp->t_state |= DTRTOUT;
		timeout (vxtimeout, tp, hz);
		while (tp->t_state&DTRTOUT)
	 		slumber(tp, INTERRUPTABLE, devcntrlboost);
	}

	if ((tp->t_state&(ISOPEN|WOPEN)) == 0)	/* is device already open? */
	{				/*  no, open it */
		ttinit(tp);
		tp->t_iflag |= ICRNL|IXON|ISTRIP;
		tp->t_oflag |= OPOST|ONLCR;
		tp->t_lflag |= ISIG|ICANON|ECHO|ECHOK;
		tp->t_cflag = CS8|CREAD|HUPCL|SSPEED;
		tp->t_proc = vxproc;	/* store address of startup routine */
		tp->t_dev = dev;	/* store major/minor device numbers */
		vxparam(dev);		/* set parameters for this port */
	} else if (tp->t_state&XCLUDE && u.u_uid!=0)
		return EBUSY;	/* device is busy, sorry */

	d = spl8();
	tp->t_state |= WOPEN;	/* mark device as waiting for open */

 	/*
 	 * Raise DTR and check for carrier.
 	 */
	if (tp->t_cflag&CLOCAL || vcmodem(dev,VMOD_ON))
		tp->t_state |= CARR_ON;
	else
		tp->t_state &= ~CARR_ON;

	/* wait for data carrier detect to go high */
	if (!(flag&FNDELAY)) {
		tp->t_open_cnt++;	/* someone is waiting for carrier */
		while( (tp->t_state&CARR_ON) == 0 ) {
			tp->t_state |= WOPEN;
 			slumber(&tp->t_canq, INTERRUPTABLE, devcntrlboost);
		}
		tp->t_open_cnt--;	/* got carrier */
	}
	error=(*linesw[tp->t_line].l_open)(tp);	/* let tty.c finish the open */
	splx(d);
	return(error);
}

/*
 * Close a VX line.
 */
vxclose(dev, flag)
dev_t dev;
int  flag;
{
	register struct tty *tp = &vx_tty[minor(dev)&0xff];
	register d = spl8();
	register error;

	error = (*linesw[tp->t_line].l_close)(tp);

	/*
	 * If HUPCL is set, hang up the port.  If a another process
	 * is already sleeping in open() waiting for carrier to come
	 * up on this port, it already expects DTR to be raised.  So
	 * DTR must both be dropped and raised here in that case.
	 */
	if (tp->t_cflag&HUPCL && !(tp->t_state&ISOPEN)) {
		vcmodem(dev,VMOD_OFF);		/* drop DTR on the line     */
		if (tp->t_open_cnt) {		/* if someone is waiting    */
			tp->t_state |= DTRTOUT; /* in open, keep it lowered */
			timeout (vxtimeout, tp, hz);
			while (tp->t_state&DTRTOUT)
		 		slumber(tp, INTERRUPTABLE, devcntrlboost);
			vcmodem(dev,VMOD_ON);	/* and then raise DTR again */
			tp->t_state |= WOPEN;	/* set WOPEN flag */
		}
	}
	splx(d);
	return(error);
}

/*
 * Read from a VX line.
 */
vxread(dev, uio)
	dev_t dev;
	struct uio *uio;
{
	register struct tty *tp = &vx_tty[minor(dev) & 0377];
	return (*linesw[tp->t_line].l_read)(tp, uio);
}

/*
 * write on a VX line
 */
vxwrite(dev, uio)
	dev_t dev;
	struct uio *uio;
{
	register struct tty *tp = &vx_tty[minor(dev) & 0377];
	return (*linesw[tp->t_line].l_write)(tp, uio);
}

/*
 * VIOCX unsolicited interrupt.
 */
vxrint(n)
int n;					/* mux number */
{
	register struct tty *tp;
	register struct vcx *xp;
	register struct ccblock *rbuf;
	register short *sp;
	register int i;
	register unsigned int c;
	register int mask;
	register int flg;
	register int gotchars = 0;
	register int port;
	struct tty *tp0;
	struct vblok *kp;
	short *savsilo;
	struct silo {
		char	data;
		unsigned char port;
	};
	char lbuf[3];
	short lcnt;

	sysinfo.rcvint++;
	kp = VBAS(n);
	xp = &vcx[n];
#if VX_TESTING
	c = kp->v_uqual&037;
	if (vx_test&VX_PROC_ERR_DEBUG)
		c = 2;
	else if (vx_test&VX_UQUAL_ERR_DEBUG)
		c = 5;
	switch(c) {
#else
	switch(kp->v_uqual&037) {
#endif
	case 0:
		break;
	case 2:
		printf(" ERR NBR %x\n",kp->v_ustat);
 		if (kp->v_ustat == 0x40) {
 			printf("VIOC %x lost some read data\n", n);
 			return(0);
		}
		vpanic("vc: VC PROC ERR");
		vxstreset(n);
		return(0);
	case 3:
		vcmintr(n);
		return(1);
	case 4:
		return(1);
	default:
		printf(" ERR NBR %x\n",kp->v_uqual);
		vpanic("vc: VC UQUAL ERR");
		vxstreset(n);
		return(0);
	}

	/*
	 * Get the address of the silo in VIOC common memory.
	 */
	sp = (short *)((char *)kp + *(short *)kp->v_usdata);

	/*
	 * See if the number of characters is reasonable.
	 */
	i = *(savsilo = sp);
	if (i > xp->v_silosiz) {
		printf("vx: %d exceeds silo size\n",i) ;
		i = xp->v_silosiz;
	}

	/*
	 * Drain the silo.
	 */
	tp0 = &vx_tty[n<<4];
	for (sp++; i > 0; i--, sp++) {
		port = ((struct silo *)sp)->port&017;
		if (port < xp->v_loport || port > xp->v_hiport)
			/*
			 * Not a valid port.
			 */
			continue;

		tp = tp0 + port;
		if ((tp->t_state&ISOPEN) == 0)
			/*
			 * Nobody is listening.
			 */
			continue;

		rbuf = &tp->t_rbuf;
		/*
		 * Mark this port as having received a character and
		 * fetch the character from vioc memory.
		 */
		mask = 1<<port;
		c = ((struct silo *)sp)->data;

		/*
		 * Check for errors.
		 */
		lcnt = 1;
		flg = tp->t_iflag;
		if (((struct silo *)sp)->port&(VPERROR|FERROR) ||
		    c == 0 && vx_break[n]&mask) {
			/*
			 * We got a framing error or we're trying to
			 * correlate the "break" interrupt with the
			 * actual break character.
			 */
			if (c == 0) {
				vx_break[n] &= ~mask;
				if (flg&IGNBRK)
					continue;
				if (flg&BRKINT) {
					if (rbuf->c_count != rbuf->c_size) {
						rbuf->c_ptr -=
							rbuf->c_size - rbuf->c_count;
						(*linesw[tp->t_line].l_input)(tp, L_BUF);
					}
					(*linesw[tp->t_line].l_input)
							(tp, L_BREAK);
					continue;
				}
			} else {
				if (flg&IGNPAR)
					continue;
			}
			if (flg&PARMRK) {
				lbuf[2] = 0377;
				lbuf[1] = 0;
				lcnt = 3;
				sysinfo.rawch += 2;
			} else
				c = 0;
		} else {
			if (flg&ISTRIP)
				c &= 0177;
			else {
				c &= 0377;
				if (c == 0377 && flg&PARMRK) {
					lbuf[1] = 0377;
					lcnt = 2;
				}
			}
		}

		/*	======= BSC code ========
		*/
		if (nvbsc && (tp->t_line == LDISP)) {
			(*linesw[tp->t_line].l_input)(c,tp);
			continue;
		}
		/*	=========================
		*/

		/*
 		 *	======= HSP code ========
 		 */
		if (nhsp && (tp->t_line == HASPDISP)) {
			(*linesw[tp->t_line].l_input)(c,tp);
			continue;
		}
		/*
		 *	=========================
		 */

		lbuf[0] = c;
		if (rbuf->c_ptr == NULL)
			continue;

		/*
		 * Stash the characters in t_rbuf, marking the
		 * line so the buffer will be passed to the line
		 * discipline after we've drained the silo.
		 */
		gotchars |= mask;
		while (lcnt) {
			*rbuf->c_ptr++ = lbuf[--lcnt];
			if (--rbuf->c_count == 0) { 
				rbuf->c_ptr -=
					rbuf->c_size - rbuf->c_count;
				(*linesw[tp->t_line].l_input)(tp, L_BUF);
			} 
		}
	}

	/*
	 * Tell the vioc we're done with this silo.
	 */
	*savsilo = 0;

	/*
	 * Pass the characters gathered from the silo up to the line
	 * discipline.
	 */
	for (i = 0, mask = 1; gotchars != 0; i++, mask <<= 1) {
		if (gotchars&mask) {
			tp = tp0 + i;
			rbuf = &tp->t_rbuf;
			if (rbuf->c_count != rbuf->c_size) {
				rbuf->c_ptr -=
					rbuf->c_size - rbuf->c_count;
				(*linesw[tp->t_line].l_input)(tp, L_BUF);
			}
			gotchars &= ~mask;
		}
	}
	return(1);
}

/*
 * stty/gtty for VX
 */
vxioctl(dev, cmd, data, flag)
int	dev;			/* major, minor device numbers */
int	cmd;			/* command */
caddr_t	data;
int	flag;
{
	register struct tty	*tp;
	register struct vxcmd	*cp ;
	register struct vcx	*xp ;
	register error, port;
	register s;
	int setparms;
	int clocal_state;	/* state of the clocal bit */

	port = minor(dev);
	tp = &vx_tty[port];
	xp = (struct vcx *)&vcx[port>>4];
	port &= 017 ;
	clocal_state = tp->t_cflag & CLOCAL;
	/*
	 * setparms is set by the terminal driver when
	 * the changes to the state of the terminal
	 * affect the state of the port on the vioc.
	 * i.e.  changing the baud.	
	 */
	error = ttiocom(tp, cmd, data, flag, &setparms);
	if (setparms)
		vxparam(dev);

	if (cmd == TIOCSDTR || cmd == TIOCCDTR ||
	    cmd == TIOCSBRK || cmd == TIOCCBRK) {
		/*
		 *  The ioctl cmds processed below handle modem control and
		 *  are dependent upon the hardware device the terminal is
		 *  connected to.  You must be root or have read permission on
		 *  the terminal to perform the following ioctls.
		 */
		if (u.u_uid && (flag & FREAD) == 0)
			return (EPERM);

		s = spl8();

		switch (cmd) {			
	
			case TIOCSDTR:		/* raise DTR on the port */
				error = 0;
				cp = vobtain(xp) ;
				cp->cmd = MDMCTL ;
				cp->par[0] = V_ENAB;
				cp->par[1] = port;
				vcmd(xp->v_nbr, &cp->cmd);
				break;
	
			case TIOCCDTR:		/* lower DTR */
				error = 0;
				cp = vobtain(xp) ;
				cp->cmd = MDMCTL ;
				cp->par[0] = V_DISAB;
				cp->par[1] = port;
				vcmd(xp->v_nbr, &cp->cmd);
				break;
	
			case TIOCSBRK:
				error = 0;
				cp = vobtain(xp) ;
				cp->cmd = SNDBRKX;
				cp->par[0] = 0xF;
				cp->par[1] = port;
				vcmd(xp->v_nbr,&cp->cmd);
				break;
	
			case TIOCCBRK:
				error = 0;
				cp = vobtain(xp) ;
				cp->cmd = SNDBRKX;
				cp->par[0] = 0;
				cp->par[1] = port;
				vcmd(xp->v_nbr,&cp->cmd);
				break;

			default:
                                break;
		}
		splx(s);
	}

	if (cmd == TCSETAW) {
		error = 0;
		/* change vioc state if clocal has changed */
		if (clocal_state != (tp->t_cflag&CLOCAL)) {
			s = spl8();
			vcmodem (dev, VMOD_ON);
			splx(s);
		} /* if */
	} /* if */

	return(error);
}

vxparam(dev)
dev_t	dev;
{
	vxcparam(dev, 1);
}

/*
 * Set parameters from open or stty into the VX hardware
 * registers.
 */
vxcparam(dev, wait)
dev_t	dev;			/* major, minor device numbers */
int wait;			/* nonzero if we should wait for finish */
{
	register struct tty	*tp;
	register struct vcx	*xp;
	register struct vxcmd	*cp;
	register s = spl8();
	register flags;

	tp = &vx_tty[minor(dev)];	/* pointer to tty structure for port */
	xp = (struct vcx *)&vcx[minor(dev)>>4];	/* pointer to VIOCX info/cmd buffer */

	flags = tp->t_cflag;
	/*
	 * flags&CBAUD == 0 implies we should drop DTR.
	 */
	if ((flags&CBAUD) == 0) {
		vcmodem(dev, VMOD_OFF);
		goto out;
	}
	/*
	 * Make sure DTR is raised.
	 */
	if ((tp->t_state&DTRON) == 0)
		vcmodem (dev, VMOD_ON);

	cp = vobtain(xp);
	cp->cmd = LPARAX;		/* set command to "load parameters" */
	cp->par[1] = minor(dev)&017;	/* port number */


	/*
	 * Check for XON/XOFF flow control.
	 */
	if (tp->t_iflag&IXON) {
		cp->par[3] = tp->t_cc[VSTOP];
		if (tp->t_iflag&IXANY)
			cp->par[2] = 0xff;	/* Any char. will turn on */
		else cp->par[2] = tp->t_cc[VSTART];
	} else {
		cp->par[2] = 0;
		cp->par[3] = 0;
	}

	/*
	 * Number of data bits per character.
	 */
	switch (flags & CSIZE) {
	case CS5:
		cp->par[4] = 0x00;
		break;
	case CS6:
		cp->par[4] = 0x80;
		break;
	case CS7:
		cp->par[4] = 0x40;
		break;
	default:
		cp->par[4] = 0xc0;
		break;
	}

	/*
	 * Number of stop bits.
	 */
	if (flags & CSTOPB)
		cp->par[5] = 0xc;
	else
		cp->par[5] = 0x4;

	/*
	 * Baud rate.  For 19.2K baud, the proper value passed to the VIOC
	 * should be 19 instead of 14.  The VIOC uses this value to look
	 * up the baud rate in a table.  Normally, 19.2K baud is located
	 * where EXTA is (index value 14) but in the VIOC, it is at index
	 * value 19.  Since the CBAUD field of t_cflag field is only 4 bits
	 * wide, the explicit check has to be made and the hardcoded value
	 * has to be assigned.
	 *
	 * Note:  If the table in the Proms of the VIOC ever changes,
	 *        this code will have to be updated.
	 */

	if ((flags&CBAUD) == B19200)
	        cp->par[6] = 19;
	else cp->par[6] = flags & CBAUD;

	if ((flags&CREAD) == 0)
		/*
		 * Disable the reader -- the closest we can
		 * come to this is setting the baud rate to
		 * zero.
		 */
		cp->par[6] = 0;

	if (flags & PARENB)
		if (flags & PARODD) 
			cp->par[7] = 1;
		else
			cp->par[7] = 3;
	else
		cp->par[7] = 0;

	if (flags&CLOCAL) {
		/*
		 * As of now, carrier has come on.
		 */
		if (tp->t_state&WOPEN)
			wakeup((caddr_t)&tp->t_canq);
		tp->t_state |= CARR_ON;
	}

	if (vcmd(xp->v_nbr, &cp->cmd) && wait)
 		slumber(cp, INTERRUPTABLE, devcntrlboost);
out:
	splx(s);
}

/*
 * VIOCX command response interrupt.
 * For transmission, restart output to any active port.
 * For all other commands, just clean up.
 * This routine is called with spl8 from vcmdrsp()
 */
vxxint(n,cp)
register int n;			/* VIOC number */
register struct vxcmd	*cp;	/* command structure */
{
	register struct	vxmit	*vp;
	register struct	tty	*tp;
	register struct	vcx	*xp;
	register int port;
	register struct ccblock *tbuf;

	sysinfo.xmtint++;
	xp = &vcx[n];
	cp = (struct vxcmd *)((long *)cp-1);

	/*	====== BSC code ======
	*/
	switch(cp->cmd) {
	case MDMCTL1: case HUNTMD1: case LPARAX1:
		vrelease(xp,cp);
		wakeup(cp);
		return;
	}
	/*	======================
	*/

	switch(cp->cmd&0xff00) {
	case LIDENT:	/* initialization complete */
		if (xp->v_state&V_RESETTING)
			vxfnreset(n, cp);
		cp->cmd++;
		return;
	case XMITDTA: case XMITIMM:
		break;
	case LPARAX:
		wakeup(cp);
	case FDTATOX:
	default:	/* MDMCTL or FDTATOX */
		vrelease(xp, cp);
		return;
	}

	/*
	 * The output command for a port has completed; figure out
	 * what port it was, flush any data and restart output.
	 */
	vp = (struct vxmit *)cp->par;
	port = vp->line & 017 ;

	tp = &vx_tty[(n<<4)+port];

	/*
	tp = &vx_tty[n<<4];
	tp = tp + port;
	*/

/*	======= BSC & HASP code ================
*/
	if (tp->t_line == LDISP) {
		vrelease(xp, cp) ;
		/* Call bsctxd with logical bscport no; 0,1..4,5 */
		/* v_xmtcnt was set to BISYNC ctlr no in vxinit() */
		bsctxd((xp->v_xmtcnt*NBSC)+(vp->line & 017));
		return ;
	}
	else if (tp->t_line == HASPDISP) {
		vrelease(xp, cp) ;
		(*linesw[tp->t_line].l_output) ((xp->v_xmtcnt*nhsp)+(vp->line & 017));
		return ;
	}
	if (bscport[(n<<4)+port] == BISYNC) {
		printf("\nvxxint: int. after line closed. (cmd:%lx)",
			cp->cmd&0xff);
		vrelease(xp, cp) ;
		return ;
	}
/*	==================================
*/
	/*
	 * NTBUF implies the data being sent was not from the
	 * transmit buffer, thus we must not flush data from
	 * the transmit buffer when it is set.
	 */
	if (((tp->t_state&(BUSY|NTBUF)) == BUSY) &&
		(tp->t_oflag & OPOST)) 	{
		/*
		 * Data was from transmit buffer, flush it.
		 */
		if (sav_cb[(n<<4)+port])  {
			/*
			 * This tty was not in OPOST mode.
			 * Free completed cblock that saved in sav_cb.
			 */
			putcf(CMATCH((struct cblock *)sav_cb[(n<<4)+port]));
			sav_cb[(n<<4)+port] = 0;
		}
		else {
			if (tp->t_tbuf.c_ptr) {
				tp->t_tbuf.c_ptr += vp->bcount + 1;
				tp->t_tbuf.c_count -= vp->bcount + 1;
			}
		}
	}
	vrelease(xp, cp);

	/*
	 * See if we owe anybody any XON/XOFF characters and
	 * restart output on this line.
	 */
	if (tp->t_state&TTXOFF) {
		/*
		 * Must send an xoff character to stop sender.
		 * We set NTBUF so the queue is not flushed when
		 * the transmit completes above.
		 */
		tp->t_state = tp->t_state&~TTXOFF | NTBUF|BUSY;
		vsend(xp, port, &tp->t_cc[VSTOP], 1);
		return;
	} else if (tp->t_state&TTXON) {
		/*
		 * Must send an xon character to restart sender.
		 */
		tp->t_state = tp->t_state&~TTXON | NTBUF|BUSY;
		vsend(xp, port, &tp->t_cc[VSTART], 1);
		return;
	} else if (tp->t_proc) {
		tbuf = &tp->t_tbuf;
		/*
		 * Restart output.
		 */
		if (!(tp->t_oflag & OPOST)) {
			/* Free completed cblock that saved in sav_cb */
			if (sav_cb[(n<<4)+port])  {
			      putcf(CMATCH((struct cblock *)sav_cb[(n<<4)+port]));
			      sav_cb[(n<<4)+port] = (char *)0;
			}

			if (tbuf->c_ptr) {
				/* Send cblock currently in tp->t_buf */
				tp->t_state |= BUSY;
       				vsend(xp, port, tbuf->c_ptr, tbuf->c_count);
				/* save current cblock pointer */
				sav_cb[(n<<4)+port] = (char *)tbuf->c_ptr;
				tbuf->c_ptr = 0;
				tbuf->c_count = 0;
				tbuf->c_size = 0;

			}
			else {
				if (!(CPRES & 
				     (*linesw[tp->t_line].l_output)(tp)))
					tp->t_state &= ~(BUSY|NTBUF);
				else  {
				   tp->t_state |= BUSY;
			  	   vsend(xp,port,tbuf->c_ptr,tbuf->c_count);

					/* save current cblock pointer */
					sav_cb[(n<<4)+port] = (char *)tbuf->c_ptr;
					tbuf->c_ptr = 0;
					tbuf->c_count = 0;
					tbuf->c_size = 0;
				}
			}
			return;
		}

		if (tbuf->c_count == 0) {
			if (tbuf->c_ptr)
				tbuf->c_ptr -= tbuf->c_size - tbuf->c_count;
			if (!(CPRES & (*linesw[tp->t_line].l_output)(tp))) {
				tp->t_state &= ~(BUSY|NTBUF);
				return;
			}
		} 
		tp->t_state |= BUSY;
		vsend(xp, port, tbuf->c_ptr, tbuf->c_count);
		return;
		/*vxproc(tp, T_OUTPUT);*/
	}
	/*tp->t_state &= ~(BUSY|NTBUF);
	return;*/
}

/*
 * Process device specific functions for the vioc.
 */
vxproc(tp, cmd)
	register struct tty *tp;
{
	register struct vcx *xp;
	register struct vxcmd *cp;
	register dev;
	register port;
	register struct ccblock *tbuf;
	register int s, n;

	dev = tp->t_dev;
	port = minor(dev) & 017;
	n = minor(dev)>>4;
	xp = (struct vcx *)&vcx[minor(dev)>>4];

	s = spl8();

 	/*
 	 * If we are resetting the VIOC, wait until the LIDENT has
 	 * completed.
	 */
	while (xp->v_state&V_RESETTING)
		slumber((caddr_t)&xp->v_state, INTERRUPTABLE, devcntrlboost);

	switch(cmd) {
	case T_TIME:
		tp->t_state &= ~TIMEOUT;
		cp = vobtain(xp);
		cp->cmd = SNDBRKX;
		cp->par[1] = port;
		cp->par[0] = 0;
		vcmd(xp->v_nbr,&cp->cmd);
		goto start;

	case T_WFLUSH:
		if (!(tp->t_state&BUSY)) {
			tp->t_tbuf.c_size -= tp->t_tbuf.c_count;
			tp->t_tbuf.c_count = 0;
		}

	case T_RESUME:
		tp->t_state &= ~TTSTOP;
		goto start;

	case T_OUTPUT:
	start:
		tbuf = &tp->t_tbuf;
		if ((tp->t_state & BUSY) && (!(tp->t_oflag & OPOST))) {
			/* Is cblock ptr is already filled ahead */
			if (!tbuf->c_ptr) {
				/* Fill another cblock ahead into t_buf.c_ptr */
				(*linesw[tp->t_line].l_output)(tp);
			}
			break;
		}
		if (tp->t_state&(TIMEOUT|TTSTOP|BUSY))
			break;
		if (tbuf->c_ptr == NULL || tbuf->c_count == 0) {
			if (tbuf->c_ptr) 
				tbuf->c_ptr -= tbuf->c_size - tbuf->c_count;
			if (!(CPRES & (*linesw[tp->t_line].l_output)(tp)))
				break;
		}
		tp->t_state |= BUSY;
		vsend(xp, port, tbuf->c_ptr, tbuf->c_count);
		if (!(tp->t_oflag & OPOST)) {
			/* save current cblock pointer */
			sav_cb[(n<<4)+port] = (char *)tbuf->c_ptr;
			tbuf->c_ptr = 0;
			tbuf->c_count = 0;
			tbuf->c_size = 0;

			/*
			 * If there are characters pending in the output queue,
			 * fill another cblock ahead into tp->t_buf.c_ptr.
			 */
			if (tp->t_outq.c_cc != 0)
				(*linesw[tp->t_line].l_output)(tp);
		}
		break;

	case T_SUSPEND:
		tp->t_state |= TTSTOP;
		break;

	case T_BLOCK:
		/*
		 * IXOFF mode with more than TTXOHI characters;
		 * need to send an XOFF.
		 */
		tp->t_state = tp->t_state&~TTXON | TBLOCK;
		if (tp->t_state&BUSY) {
			tp->t_state |= TTXOFF;
		} else {
			tp->t_state |= BUSY|NTBUF;
			vsend(xp, port, &tp->t_cc[VSTOP], 1);
		}
		break;

	case T_RFLUSH:
		if (!(tp->t_state&TBLOCK))
			break;
	case T_UNBLOCK:
		/*
		 * IXOFF mode, blocked with less then TTXOLO characters;
		 * need to send an XON.
		 */
		tp->t_state &= ~(TTXOFF|TBLOCK);
		if (tp->t_state&BUSY) {
			tp->t_state |= TTXON;
		} else {
			tp->t_state |= BUSY|NTBUF;
			vsend(xp, port, &tp->t_cc[VSTART], 1);
		}
		break;

	case T_BREAK:
		/* send break */
		tp->t_state |= TIMEOUT;
		cp = vobtain(xp);
		cp->cmd = SNDBRKX;
		cp->par[1] = port;
		cp->par[0] = 0x80;
		vcmd(xp->v_nbr, &cp->cmd);
		timeout(ttrstrt, (char *)tp, hz/4);
		break;

	case T_PARM:
		vxparam(dev);
		break;
	}
	splx(s);
}

/*
 * VIOCX Initialization.  Makes free lists of command buffers.
 * Resets all viocx's.  Issues a LIDENT command to each
 * viocx which establishes interrupt vectors and logical
 * port numbers
 */
vxinit(ui, wait)
	struct vba_device	*ui;
	int			wait;
{
	register int		i = ui -> ui_unit ;
	struct	vba_ctlr 	*um = ui -> ui_mi ;
	register struct	vcx	*xp;	/* ptr to VIOC-X info/cmd buffer */
	register struct	vblok	*kp;	/* pointer to VIOC-X control block */
	register struct	vxcmd	*cp;	/* pointer to a command buffer */
	register char		*resp;	/* pointer to response buffer */
	register int		j, ix;
	register struct	vcmds	*cpp;
	char			type;
	register struct	bsc	*bp;	/* bsc change */

	kp = VBAS(i);		/* get base adr of cntl blok for VIOC */
	xp = &vcx[i];		/* index info/command buffers */

	cpp = &v_cmds[i];
	type = kp->v_ident;
	switch(type) {
	case PVIOCX:
	case VIOCX:
		printf("WARNING:  Old vioc no longer supported.\n");
		xp->v_loport = xp->v_hiport = 0;
		return;

	case NWVIOCX:
		xp->v_vers = V_NEW ;
		xp->v_silosiz = kp->v_maxsilo ;
		/* set DCD for printer ports */
		for(j = 0;j < 16;j++)
			if (kp->v_portyp[j] == 4 )
				kp->v_dcd |= 1 << j ;
		break ;

	case NPVIOCX:
		xp->v_vers = V_NEW ;
		xp->v_silosiz = kp->v_maxsilo ;
		break ;

	case VIOCB:	/* old f/w, Bisync board */
		if (wait)  {		/* Just boot up */
			if (bscno >= nvbsc) {
			        printf("\nVIOCB no%ld is not configured in software.\n",bscno);
				break;
			}
			if (bscno >= MXVIOC_B) {
				printf("\nvxinit: exceed max no of VIOC-B:%ld",
					MXVIOC_B);
				break;
			}
		}
		printf("(kp:%lx)(xp:%lx): %lx---%x OLD VIOC-B, ",
					(long)kp, (long)xp,(int)kp->v_ident,
					(int)kp->v_fault);
		xp->v_vers = V_OLD ;
		/* save device specific info */
		/*for(bp = &bsc[0]; bp <= &bsc[NBSC-1]; bp++)
			bp->b_devregs = (caddr_t)xp ;
		*/

		if (wait) 				/* Use v_xmtcnt to */
			xp->v_xmtcnt = (char)bscno;	/* save VIOC-B ctlrno */
		else bscno = (long)xp->v_xmtcnt & 0x7f;

		bp = &bsc[0+(bscno*4)];
		for(ix=0;ix<4;ix++,bp++)
			bp->b_devregs = (caddr_t)xp ;
		bscno++;
		bscport[(i*16)+0] = BISYNC;
		bscport[(i*16)+1] = BISYNC;
		bscport[(i*16)+2] = BISYNC;
		bscport[(i*16)+3] = BISYNC;
		printf(",BSC no %d initialized.\n",bscno-1);
		break ;

	case NWVIOCB:	/* new f/w, Bisync board */
		if (wait)	{	/* Just boot up */
			if (bscno >= nvbsc) {
			        printf("\nVIOCB no%ld is not configured in software.\n",bscno);
				break;
			}
			if (bscno >= MXVIOC_B) {
				printf("\nvxinit: exceed max no of VIOC-B:%ld",
					MXVIOC_B);
				break;
			}
		}
		printf("(kp:%lx)(xp:%lx): %lx---%x 16K VIOC-B",
					(long)kp, (long)xp,(int)kp->v_ident,
					(int)kp->v_fault);
		xp->v_vers = V_NEW ;
		xp->v_silosiz = kp->v_maxsilo ;
		/* save device specific info */

		if (wait) 				/* Use v_xmtcnt to */
			xp->v_xmtcnt = (char)bscno;	/* save VIOC-B ctlrno */
		else bscno = (long)xp->v_xmtcnt & 0x7f;

		bp = &bsc[bscno*4];
		for(ix=0;ix<4;ix++,bp++)
			bp->b_devregs = (caddr_t)xp ;
		bscno++;
		bscport[(i*16)+0] = BISYNC;
		bscport[(i*16)+1] = BISYNC;
		bscport[(i*16)+2] = BISYNC;
		bscport[(i*16)+3] = BISYNC;
		printf(",BSC no %d initialized.\n",bscno-1);
		if(CBSIZE > kp->v_maxxmt)
			printf("vxinit: Warning CBSIZE > maxxmt\n") ;
		break ;

	case VBOPID:		/* VIOC-BOP */
		vxbbno++;
		vxtype[i] = 1;
		vxbopno[i] = vxbbno;
		printf("        VIOC-BOP %d\n", vxbopno[i] );
	        /* return 2 of the 3 interrupt vectors reserved */
		return_ivct ( (um -> um_ivct & 0x00ff00) >>  8 );
		return_ivct ( (um -> um_ivct & 0xff0000) >> 16 );
		um -> um_ivct &= 0xff;

	default:
		return ;	/* Not a viocx type */
	}
	xp->v_nbr = -1;		/* no number for it yet */
	xp->v_maxcmd = xp->v_vers == V_NEW ? 23 : 3;

	for(j=0; j<NVCXBUFS; j++)	/* init all cmd buffers */
	{
		cp = &xp->vx_lst[j];	/* index a buffer */
		cp->c_fwd = &xp->vx_lst[j+1];	/* point to next buf */
	}
	xp->vx_avail = &xp->vx_lst[0];	/* set idx to 1st free buf */
	cp->c_fwd = (struct vxcmd *)0;	/* mark last buf in free list */

	cpp->v_cmdsem = cpp->v_curcnt = cpp->v_fill = 0;
	cpp->v_empty = cpp->v_itrfill = cpp->v_itrempt = 0;

	cp = vobtain(xp);	/* grap the control block */
	cp->cmd = LIDENT;	/* set command type */
	cp->par[0] = (um -> um_ivct & 0x0000ff) ;	/* ack vector */
	cp->par[1] = (um -> um_ivct & 0x00ff00) >>  8 ;	/* cmd resp vector */
	cp->par[3] = (um -> um_ivct & 0xff0000) >> 16 ;	/* unsol intr vector */
	cp->par[4] = 15;	/* max ports, no longer used */
	cp->par[5] = 0;		/* set 1st port number */
	vcmd(i, &cp->cmd);	/* initialize the VIOC-X */
	if (!wait)
		return;

	while(cp->cmd == LIDENT);	/* wait for command completion */

	/* calculate address of response buffer */
	resp = (char *)kp;
	resp += kp->v_rspoff & 0x3FFF;

	if(resp[0] != 0 && (resp[0]&0177) != 3)	/* did init work? */
	{
		vrelease(xp,cp);/* init failed */
		return;	/* try next VIOC-X */
	}

	xp->v_loport = cp->par[5];	/* save low port number */
	xp->v_hiport = cp->par[7];/* VIOC knows high port numbr */
	vrelease(xp,cp);	/* done with this control block */
	xp->v_nbr = i;		/* assign VIOC-X board number */
}

/*
 * Obtain a command buffer
 * The caller is responsible to do spl8
 * before calling this routine.
 */
struct	vxcmd *
vobtain(xp)
register struct	vcx	*xp;
{
	register struct	vxcmd	*p;
	register s;

	p = xp->vx_avail;
	if(p == (struct vxcmd *)0) {
		vpanic("vx: no buffs");
		s = spl8();
		vxstreset(xp - vcx);
		splx(s);
		return(vobtain(xp));	/* gauranteed to work this time */
	}
	xp->vx_avail = (xp->vx_avail)->c_fwd;
	return( (struct vxcmd *)p);
}

/*
 * Release a command buffer
 */
vrelease(xp,cp)
register struct	vcx	*xp;
register struct	vxcmd	*cp;
{
	register s = spl8();

	cp->c_fwd = xp->vx_avail;
	xp->vx_avail = cp;
	splx(s);
}

/*
 * Arrange for "cnt" bytes from "addr" to be written to port number
 * "port" on VIOC described by "xp".
 */
vsend(xp, port, addr, cnt)
register struct vcx *xp;/* points to vioc control structure for this port */
register int port;	/* port number to get the data */
char *addr;		/* beginning address of the block */
register int cnt;	/* size of the block of characters */
{
	register struct vxcmd *cp;
	register struct vxmit *mp;
	register int i;
	register char *src, *dst;

	/*
	 * Get a command.
	 */
	/* Donot need to check this, vobtain() will reset VIOC
	   if the list is empty */
	/*
	if ((cp = vobtain(xp)) == (struct vxcmd *)0)
		return(0);
	*/
	cp = vobtain(xp);

	/*
	 * Fill out the port information.
	 */
	mp = (struct vxmit *)cp->par;
	mp->bcount = cnt-1;
	mp->line = port;

	if (cnt <= 6) {
		/*
		 * If small enough, we can give the data directly to
		 * the vioc, eliminating the need for DMA.
		 */
		cp->cmd = XMITIMM;
		src = addr;
		i = cnt;
	} else {
		/*
		 * Get the physical address of the block to DMA.
		 */
		cp->cmd = XMITDTA;
		addr = vtoph(0, (caddr_t)addr);
		src = (char *)&addr;
		i = sizeof(addr);
	}

	/*
	 * Copy the data or address into the command.
	 */
	dst = mp->ostream;
	while (--i >= 0)
		*dst++ = *src++;

	vcmd(xp->v_nbr, (char *)&cp->cmd);
	return;
	/*return(1);*/
}
