# @(#)krpc.mk	6.6

LIBNAME = 	../lib_krpc
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(klm_kprot.o) \
	$(LIBNAME)(klm_lockmgr.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp krpc.mk krpc.mk.bak
	@ed - krpc.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_krpc(klm_kprot.o): ../krpc/klm_prot.h ../netinet/in.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h \
	../rpc/rpc_msg.h ../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h \
	../rpc/xdr.h ../sys/types.h 

../lib_krpc(klm_lockmgr.o): ../krpc/klm_prot.h ../krpc/lockmgr.h \
	../ml/param.h ../ml/pcb.h ../net/if.h ../net/if_arp.h \
	../netinet/in.h ../nfs/nfs.h ../nfs/nfs_clnt.h ../nfs/rnode.h \
	../rpc/auth.h ../rpc/clnt.h ../rpc/types.h ../rpc/xdr.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/ucbstat.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h 
