/*	machdep.c	6.2	83/10/02	*/

#include "../ml/reg.h"
#include "../ml/pte.h"
#include "../ml/psl.h"

#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/user.h"
#include "../sys/kernel.h"
#include "../sys/map.h"
#include "../sys/vm.h"
#include "../sys/proc.h"
#include "../sys/buf.h"
#include "../sys/reboot.h"
#include "../sys/conf.h"
#include "../sys/vnode.h"
#include "../ufs/inode.h"
#include "../sys/file.h"
#include "../sys/text.h"
#include "../sys/tty.h"
#include "../sys/callout.h"
#include "../sys/cmap.h"
#include "../sys/mbuf.h"
#include "../ufs/quota.h"
#include "../sys/msg.h"
#include "../sys/utsname.h"
#include "../sys/dnlc.h"
#include "../cf/ipcconfig.h"

#include "../ml/mem.h"
#include "../ml/mtpr.h"
#include "../ml/cp.h"
#include "../sys/vbavar.h"


int	icode[] =
/*		pushab	argp		*/
/*		pushab	file		*/
/*		pushl	$2		*/
/*		movab	(sp),fp		*/
/*		kcall	$exec		*/
/*	here:	brb	here		*/
/*	.file:	.ascii	"/etc/"		*/
/*	args:	.ascii	"init\0"	*/
/*		.align	4		*/
/*	argp:	.long	args		*/
/*              .long   boot            */
/*		.long	0		*/
/*      boot:   .ascii  "    "		This ascii sequence is filled in with */
/*              .ascii  "    "		the hex of 'boothowto'. */
/*              .ascii  "    "		../os/init_main.c depends on this */
/*              .ascii  "   \0"		sequence being at the end of icode. */
{
	0xf9af19f9,
	0xaf09dd02,
	0xe96e5dcf,
	0x0b11fe2f,
	0x6574632f,
	0x696e6974,
	0x00000000,
	0x00000014,
	0x00000028,
	0x00000000,
	0x20202020,
	0x20202020,
	0x20202020,
	0x20202000,
};
int	szicode = sizeof(icode);
 
/*
 * Declare these as initialized data so we can patch them.
 */
int	nswbuf = 0;
int	bufpages = 0;

/*
 * Machine-dependent startup code
 */
startup(firstaddr)
	int firstaddr;
{
	register int unixsize;
	register unsigned i;
	register int mapaddr, j;
	register caddr_t v;
	register int maxbufs, base, residual;
	extern char etext;
	extern int sysptsize;
	extern int max_areq;
	extern int nbuf;
	extern int maxpmem;
	extern struct msginfo msginfo ; /* message parameters */
	extern int shm;
	extern int fpp_hdw ;
 	extern int genulockp, sulockp; /* plock percentage limits */

	mtpr(1,TBIA);

	/*
	 * Good {morning,afternoon,evening,night}.
	 */
	printf("Machine: %s\n", utsname.machine);
	printf("System: %s\n", utsname.sysname);
	printf("Version: %s\n", utsname.version);
	printf("Release: %s\n", utsname.release);
	printf("Node name: %s\n", utsname.nodename);
	printf("real mem  = %d\n", ctob(maxmem));
	
	/* Force physical memory to be no more that the
	 * configured amount.  We do this since sysptsize is
	 * based on maxpmem.
	 */
	if (maxmem > maxpmem) {
	        maxmem = physmem = maxpmem;
	        printf("*** only using %d real mem ***\n", maxmem);
	        printf("*** check 'maxpmem' config parameter ***\n");
	}

	/*
	 * Determine how many buffers to allocate.
	 * Use 10% of memory, with min of 16.
	 * We allocate 1/2 as many swap buffer headers as file i/o buffers.
	 */
	maxbufs = ((sysptsize * NBPG) - (5 * (int)(&etext - 0xc0000000))) /
	    MAXBSIZE;
	if (bufpages == 0)
		bufpages = (physmem * NBPG) / 10 / CLBYTES;
	if (nbuf == 0) {
		nbuf = bufpages / 2;
		if (nbuf < 16)
			nbuf = 16;
		if (nbuf > maxbufs)
			nbuf = maxbufs;
	}
	if (bufpages > nbuf * (MAXBSIZE / CLBYTES))
		bufpages = nbuf * (MAXBSIZE / CLBYTES);
	if (nswbuf == 0) {
		nswbuf = (nbuf / 2) &~ 1;	/* force even */
		if (nswbuf > 256)
			nswbuf = 256;		/* sanity */
	}

	/*
	 * Allocate space for system data structures.
	 * The first available real memory address is in "firstaddr".
	 * As pages of memory are allocated, "firstaddr" is incremented.
	 * The first available kernel virtual address is in "v".
	 * As pages of kernel virtual memory are allocated, "v" is incremented.
	 * An index into the kernel page table corresponding to the
	 * virtual memory address maintained in "v" is kept in "mapaddr".
	 */
	mapaddr = firstaddr;
	v = (caddr_t)(0xc0000000 | (firstaddr * NBPG));
#define	valloc(name, type, num) \
	{ \
	    (name) = (type *)(v); (v) = (caddr_t)((name)+(num)); \
	}
#define	valloclim(name, type, num, lim) \
	{ \
	    (name) = (type *)(v); (v) = (caddr_t)((lim) = ((name)+(num))); \
	}
	valloc(buffers, char, MAXBSIZE * nbuf);
	base = bufpages / nbuf;
	residual = bufpages % nbuf;
	for (i = 0; i < residual; i++) {
		for (j = 0; j < (base + 1) * CLSIZE; j++) {
			*(int *)(&Sysmap[mapaddr+j]) = PG_V | PG_KW | firstaddr;
			clearseg((unsigned)firstaddr);
			firstaddr++;
		}
		mapaddr += MAXBSIZE / NBPG;
	}
	for (i = residual; i < nbuf; i++) {
		for (j = 0; j < base * CLSIZE; j++) {
			*(int *)(&Sysmap[mapaddr+j]) = PG_V | PG_KW | firstaddr;
			clearseg((unsigned)firstaddr);
			firstaddr++;
		}
		mapaddr += MAXBSIZE / NBPG;
	}
	valloc(buf, struct buf, nbuf);
	valloc(swbuf, struct buf, nswbuf);
	valloclim(inode, struct inode, ninode, inodeNINODE);
	valloclim(file, struct file, nfile, fileNFILE);
	valloclim(proc, struct proc, nproc, procNPROC);
	valloclim(text, struct text, ntext, textNTEXT);
	if (shm)
		valloclim(shmem, struct shmid_ds, shminfo.shmmni, shmemNSHMEM);
	valloc(cfree, struct cblock, nclist);
	valloc(callout, struct callout, ncallout);
	valloc(swapmap, struct map, nswapmap = nproc * 2);
	valloc(argmap, struct map, ARGMAPSIZE);
	valloc(kernelmap, struct map, nproc);
	valloc(bsemlocal_tbl, struct bsemid_ds, BSEMMAP);
	valloc(areq_pool, struct areq, max_areq);
	if (shm)
		valloc(swapkmap, struct map, nproc);
	valloc(msgmap, struct map, msginfo.msgmap);
	valloc(ncache, struct ncache, ncsize);
	valloclim(dquot, struct dquot, ndquot, dquotNDQUOT);
	/*
	 * Now allocate space for core map
	 * Allow space for all of phsical memory minus the amount 
	 * dedicated to the system. The amount of physical memory
	 * dedicated to the system is the total virtual memory of
	 * the system minus the space in the buffers which is not
	 * allocated real memory.
	 *
	 * The value 1 is added below to adjust for rounding. (Cliff 9/86)
	 */
	ncmap = 1 + (physmem*NBPG - ((int)v &~ 0xc0000000) +
		(nbuf * MAXBSIZE - bufpages * CLBYTES)) /
		    (NBPG*CLSIZE + sizeof (struct cmap));
	valloclim(cmap, struct cmap, ncmap, ecmap);

	if ((((int)(ecmap+1))&~0xc0000000) > sysptsize*NBPG) {
		printf("system page table too small\n");
		printf("check 'maxpmem' config parameter\n");
		panic("sys pt too small");
	}
	/*
 	** set u_limit, and s_limit as percentages of ncmap
 	*/
 	u_limit = (ncmap * genulockp) / 100;
 	s_limit = (ncmap * sulockp) / 100;
 	plocked = 0;

 	/*
	 * Clear allocated space, and make r/w entries
	 * for the space in the kernel map.
	 */
	unixsize = btoc((int)(ecmap+1) &~ 0xc0000000);
	for (i = mapaddr; i < unixsize; i++) {
		*(int *)(&Sysmap[i]) = PG_V | PG_KW | firstaddr;
		clearseg((unsigned)firstaddr);
		firstaddr++;
	}
	if (firstaddr >= physmem - 8*UPAGES)
		panic("no memory");
	mtpr(1,TBIA);

	/*
	 * Initialize callouts
	 */
	callfree = callout;
	for (i = 1; i < ncallout; i++)
		callout[i-1].c_next = &callout[i];

	/*
	 * Initialize memory allocator and swap
	 * and user page table maps.
	 *
	 * THE USER PAGE TABLE MAP IS CALLED ``kernelmap''
	 * WHICH IS A VERY UNDESCRIPTIVE AND INCONSISTENT NAME.
	 */
	meminit(firstaddr, maxmem);
	maxmem = freemem;
	printf("avail mem = %d\n", ctob(maxmem));
	printf("using %d buffers containing %d bytes of memory\n",
		nbuf, bufpages * CLBYTES);
	rminit(kernelmap, (long)USRPTSIZE, (long)1,
	    "usrpt", nproc);
	if (shm)
	        rminit(swapkmap, (long)(ctopt(shminfo.shmall)), (long)1,
	                "swappt", nproc);
	rminit(msgmap,(long)msginfo.msgseg,(long)1,"msgmap",msginfo.msgmap );
	intenable = 1;		/* Enable interrupts from now on */

	/*
	** Identify optional CPU hardware: 
	** Floating Point Processor
	*/
	fpp_hdw = fpphdw() ;

	/*
	 * Configure the system.
	 */
	configure();
}

#ifdef PGINPROF
/*
 * Return the difference (in microseconds)
 * between the  current time and a previous
 * time as represented  by the arguments.
 * If there is a pending clock interrupt
 * which has not been serviced due to high
 * ipl, return error code.
 */
vmtime(otime, olbolt, oicr)
	register int otime, olbolt, oicr;
{
	return(((time.tv_sec-otime)*60 + lbolt-olbolt)*16667);
}
#endif

/*
 * Send an interrupt to process.
 *
 * Stack is set up to allow sigcode stored
 * in u. to call routine, followed by chmk
 * to sigcleanup routine below.  After sigcleanup
 * resets the signal mask and the stack, it
 * returns to user who then unwinds with the
 * rei at the bottom of sigcode.
 */
sendsig(p, sig, mask)
	int (*p)(), sig, mask;
{
	register struct sigcontext *scp;	/* know to be r12 */
	register int *regs;
	register struct sigframe {
		int	sf_signum;
		int	sf_code;
		struct	sigcontext *sf_scp;
		int	(*sf_handler)();
		int	r1;
		int 	r0;
		struct	sigcontext *sf_scpcopy;
	} *fp;					/* known to be r10 */
	int oonstack;
	int spval;

	regs = u.u_ar0;
	oonstack = u.u_onstack;
	spval = mfpr(USP);
	scp = (struct sigcontext *)spval - 1;
	if (!u.u_onstack && (u.u_sigonstack & sigmask(sig))) {
		fp = (struct sigframe *)u.u_sigsp - 1;
		u.u_onstack = 1;
	} else
		fp = (struct sigframe *)scp - 1;
	/*
	 * Must build signal handler context on stack to be returned to
	 * so that rei instruction in sigcode will pop ps and pc
	 * off correct stack.  The remainder of the signal state
	 * used in calling the handler must be placed on the stack
	 * on which the handler is to operate so that the calls
	 * in sigcode will save the registers and such correctly.
	 */
	if (!oonstack && (int)fp <= USRSTACK - ctob(u.u_ssize)) 
		grow((unsigned)fp);
	;
#ifndef lint
	asm("probew $1,(r10),$1");
	asm("jeql bad");
	asm("probew $1,7*4-1(r10),$1");
	asm("jeql bad");
#else
	if (useracc((caddr_t)fp, sizeof (struct sigframe), 1))
		goto bad;
#endif
	if (!u.u_onstack && (int)scp <= USRSTACK - ctob(u.u_ssize))
		grow((unsigned)scp);
	;			/* Avoid asm() label botch */
#ifndef lint
	asm("probew $1,(r12),$1");
	asm("jeql bad");
	asm("probew $1,5*4-1(r12),$1");
	asm("jeql bad");
#else
	if (useracc((caddr_t)scp, sizeof (struct sigcontext), 1))
		goto bad;
#endif
	fp->sf_signum = sig;
	if (sig == SIGILL || sig == SIGFPE) {
		fp->sf_code = u.u_code;
		u.u_code = 0;
	} else if (sig == SIGIO) {
		if (NO_PENDING_USRAREQ(u.u_procp)) {
			fp->sf_code = -1;
		} else {
			register struct areq *areq = u.u_procp->p_usrareq_head;
			remque(areq);
			fp->sf_code = areq->id;
			FREE_AREQ(areq);
		}
	} else
		fp->sf_code = 0;
	fp->sf_scp = scp;
	fp->sf_handler = p;
	fp->r1 = regs[R1];	/* These are not saved by the C compiler */
	fp->r0 = regs[R0];
	/*
	 * Duplicate the pointer to the sigcontext structure.
	 * This one doesn't get popped by the ret, and is used 
	 * by sigcleanup to reset the signal state on inward return.
	 */
	fp->sf_scpcopy = scp;
	/* sigcontext goes on previous stack */
	scp->sc_onstack = oonstack;
	scp->sc_mask = mask;
	/* setup rei */
	scp->sc_sp = (int)&scp->sc_pc;
	scp->sc_pc = regs[PC];
	scp->sc_ps = regs[PS];
	mtpr(fp, USP);
	regs[PC] = (int)u.u_pcb.pcb_sigc;
	if (regs[PS] & PSL_DBL) {
		save_d_acc(&u.u_saveacc[0]);
		u.u_acc_double = 1;
	} else {
		save_s_acc(&u.u_saveacc[0]);
		u.u_acc_double = 0;
	}
	return;

asm("bad:");
bad:
	/*
	 * Process has trashed its stack; give it an illegal
	 * instruction to halt it in its tracks.
	 */
	u.u_signal[SIGILL] = SIG_DFL;
	sig = sigmask(SIGILL);
	u.u_procp->p_sigignore &= ~sig;
	u.u_procp->p_sigcatch &= ~sig;
	u.u_procp->p_sigmask &= ~sig;
	psignal(u.u_procp, SIGILL);
}

/*
 * Routine to cleanup state after a signal
 * has been taken.  Reset signal mask and
 * stack state from context left by sendsig (above).
 * Pop these values in preparation for rei which
 * follows return from this routine.
 */
sigcleanup()
{
	register struct sigcontext *scp;	/* known as R12 */
	int spval;

	spval = mfpr(USP);
	scp = (struct sigcontext *)fuword((caddr_t)spval);
	if ((int)scp == -1)
		return;
#ifndef lint
	;			/* Avoid asm() label botch */
	/* only probe 12 here because that's all we need */
	asm("prober $1,(r12),$1");
	asm("bnequ .f1; ret; .f1:");
	asm("prober $1,11(r12),$1");
	asm("bnequ .f2; ret; .f2:");
#else
	if (useracc((caddr_t)scp, sizeof (*scp), 0))
		return;
#endif
	u.u_onstack = scp->sc_onstack & 01;
	u.u_procp->p_sigmask =
	    scp->sc_mask &~ (sigmask(SIGKILL)|sigmask(SIGCONT)|sigmask(SIGSTOP));
	mtpr(scp->sc_sp, USP);
	if (u.u_acc_double) {
		rest_d_acc(&u.u_saveacc[0]);
		u.u_ar0[PS] |= PSL_DBL;
	} else {
		rest_s_acc(&u.u_saveacc[0]);
		u.u_ar0[PS] &= ~PSL_DBL;
	}
	if (! NO_PENDING_USRAREQ(u.u_procp))
		psignal(u.u_procp, SIGIO);
	u.u_error = EJUSTRETURN;
}

int	waittime = -1;
int     rebooting ;

boot(paniced, arghowto)
	int paniced, arghowto;
{
	register long dummy;
	register int howto;		/* r11 == how to boot */
	register int devtype;		/* r10 == major of root dev */

#ifdef lint
	dummy = 0 ;
	dummy = dummy ;
	howto = 0; devtype = 0;
	printf("howto %d, devtype %d\n", arghowto, devtype);
#endif
	rebooting = 1;
	if (paniced == RB_PANIC) {
		register unsigned *fp, pc;
		register int i,n ;
		fp = (unsigned *)&paniced - 1;
		while(((int)fp&03)==0 &&
		((pc = fp[-2])&0xc0000000)==(unsigned)0xc0000000) {
			printf("%x (", fp);
			if(fp[-1] == 0x1fff0004)	/* trap */
				n = 10;
			else
				n = (fp[-1]&0xffff)/4;
			for(i=1; i<n; i++) {
				if(i > 1)
					printf(",");
				printf("%x", fp[i]);
			}
			printf(") from %x\n", pc);
			if(fp[-1] == 0x1fff0004) {	/* trap */
				printf("regs: ");
				for(i= -15; i<=-3; i++) {
					if(i > -15)
						printf(",");
					printf("%x", fp[i]);
				}
				printf("\n");
			}
			fp = *(unsigned **)fp;
			if (fp == NULL)
				break;
		}
	}
	(void) spl1();
	howto = arghowto;
	if ((howto&RB_NOSYNC)==0 && waittime < 0 && bfreelist[0].b_forw) {
		waittime = 0;
		update();
		printf("syncing disks... ");
#ifdef notdef
		DELAY(10000000);
#else
		{ register struct buf *bp;
		  int iter, nbusy, oldnbusy;

		  printf ("        Blocks to sync : ");
		  oldnbusy = 0;
		  for (;;) {
			DELAY(1000);
			nbusy = 0;
			for (bp = &buf[nbuf]; --bp >= buf; )
				if ((bp->b_flags & (B_BUSY|B_INVAL)) == B_BUSY)
					nbusy++;
			if (nbusy == 0)
				break;
			if (nbusy != oldnbusy) {
				iter = 0;
				printf("%d ", nbusy);
				oldnbusy = nbusy;
			} else {
				if (++iter >= 100) {
				  printf(" - disk I/O stopped (?), giving up\n");
				  DELAY(10000);
				  break;
				}
			}
		  }
		}
#endif
		printf("done\n\n");
	}
	splx(0x1f);			/* extreme priority */
	devtype = major(rootdev);
	if (howto&RB_HALT) {
		printf("halting (in tight loop); hit <return>~h\n\n");
		mtpr(0x1f,IPL);
		for (;;)
			;
	} else {
		if (paniced == RB_PANIC) {
			doadump();		/* TXDB_BOOT's itsself */
			/*NOTREACHED*/
		}
		tocons(CPBOOT);
	}
	for (;;)
		asm("halt");
	/*NOTREACHED*/
}



/*
 * Send the given comand ('c') to the console processor.
 * Assumed to be one of the last things the OS does before
 *  halting or rebooting.
 */

struct cphdr *lasthdr;	/* Available in "dev/cons.c" */

struct	cpdcb_o cpcontrol;

tocons(command)
int command;
{

	int timeout;

	cpcontrol.cp_hdr.cp_unit = CPUNIT;
	cpcontrol.cp_hdr.cp_comm =  (char) command;
	if (command != CPBOOT) 
		cpcontrol.cp_hdr.cp_count = 1;	/* Just for sanity */
	else {
		cpcontrol.cp_hdr.cp_count = 4;
		*(int *)cpcontrol.cp_buf = 0;	/* r11 value for reboot */
	}
	timeout = 100000;				/* Delay loop */
	while (timeout-- && !(lasthdr->cp_unit & CPDONE))
		uncache(&lasthdr->cp_unit);
					/* Give up, force it to listen */
	mtpr ( vtoph(0, &cpcontrol), CPMDCB);
}

struct cpdcb_t cptocctrl;

/*
	Read or write console's TOCC (time of
	century clock). Status returned is 0
	on success, 1 for no clock (old cp),
	2 for low battery , 3 for a bad command.
	On reads, we poll till
	completion, and therefore don't return
	until request is satisfied. Callers beware!
	Note: TOCC stores time in GMT.
*/
int
constocc(command,buf)
int command;
char *buf;
{
	char *lbuf = &cptocctrl.cpt_buf[0];
	int   timeout,i;

	if ( !(command == CPTOCR || command == CPTOCW))
	  {
	        buf[13] = 3;		/* bad command */
	        return(3);
	  }
	cptocctrl.cp_hdr.cp_unit = CPUNIT;
	cptocctrl.cp_hdr.cp_count = 14;
	cptocctrl.cp_hdr.cp_comm = command;
	if (command == CPTOCW)
	        for (i=0;i<13;i++)
			lbuf[i] = buf[i];
	lbuf[13] = 1;                   /* no clock? */

	/* Try to let a prior request complete */
        if (lasthdr != (struct cphdr*)0)
          {
                timeout = 10000;
                uncache((char *)&lasthdr->cp_unit);
                while ((lasthdr->cp_unit & CPTAKE) == 0 && --timeout)
                        uncache((char *)&lasthdr->cp_unit);
          }

	mtpr( vtoph(0,&cptocctrl), CPMDCB);	/* make request */

	if (command == CPTOCR)
	  {
	        uncache((char *)&cptocctrl.cp_hdr.cp_unit);
		while ((cptocctrl.cp_hdr.cp_unit & CPDONE) == 0)
			uncache((char *)&cptocctrl.cp_hdr.cp_unit);		
		for (i=0; i<14; i++)
		  {
		        uncache((char *)&lbuf[i]);
			buf[i] = lbuf[i];
		  }
	  }
	else
	        lasthdr = &cptocctrl.cp_hdr;

	return(lbuf[13]);
}

/* define number of elapsed days at beginning of each month. */
static int dmtotl[13] = {0,31,59,90,120,151,181,212,243,273,304,334,365};

#define lpyr(_year)     ((_year & 3)==0)

#define yrdays(_year)   (lpyr(_year)?366:365)

/*
	Time of Century Clock sends/receives time as:
	byte   0  1  2  3  4  5  6  7  8  9  10 11 12 13
	      +--+--+--+--+--+--+--+--+--+--+--+--+--+--+
	field |Yd|Yu|Md|Mu|Dd|Du|WD|hd|hu|md|mu|sd|su|ST|
	      +--+--+--+--+--+--+--+--+--+--+--+--+--+--+
	where: Y = Year, M = Month, D = Day, WD = weekday,
	       h = hour, m = minute, s = second, ST = status.
	'd' & 'u' suffices are decades and units (BCD).
	The Year is relative to 1970, and time is in GMT.
*/
/*
	Read the Time of Century Clock on the Console.
	Returns: success or error, and clock value
	in GMT (as stored on console) via argument
	input. Error is either no clock (old console)
	or low battery. The time is relative to 
	jan 1, 1970 GMT.
*/
int
readtocc( tsecs )
int *tsecs;
{
	char lbuf[16];
	int  year, month, day, wday, hour, minute, second;
	int  status,cvalue,dayofyr;

	/* Read and convert tocc to GMT seconds */
	if ((status = constocc(CPTOCR,lbuf)) == 0)    /* No error	*/ 	
	  {
		year = lbuf[0] * 10 + lbuf[1];
		month = lbuf[2] * 10 + lbuf[3];
		day  = lbuf[4] * 10 + lbuf[5];
		wday = lbuf[6];
		hour = lbuf[7] * 10 + lbuf[8];
		minute = lbuf[9] * 10 + lbuf[10];
		second = lbuf[11] * 10 + lbuf[12];

		dayofyr = dmtotl[month-1] + (day-1);

		cvalue = (year - 70) * 365 + dayofyr + (year - 69) / 4;
		/* adjust a current leap year */
		cvalue += (lpyr(year) && month > 2) ? 1 : 0;

		cvalue = cvalue * 24 + hour;
		cvalue = cvalue * 60 + minute;
		cvalue = cvalue * 60 + second;
		*tsecs = cvalue;
	  }	
	return(status);
}

/*
	Write the console's TOCC.
	Status byte is ignored.
	The value to write is first converted to the
	format required by the TOCC.
*/
writetocc( tsecs )
int *tsecs;
{
	char lbuf[16];
	int  cvalue = *tsecs;
	int  year,month,day,wday,hour,minute,second;
	int  leapday;
	/* Convert value to local time in TOCCs BCD format */
	
	second = cvalue % 60;
	cvalue /= 60;		/* total elapsed minutes */
	minute = cvalue % 60;
	cvalue /= 60;		/* total elapsed hours	*/
	hour   = cvalue % 24;
	cvalue /= 24;		/* total elapsed days	*/
	wday   = (cvalue + 4) % 7;	/* Jan 1, 1970 was Thursday, wday 4 */

	for (year = 70; cvalue > yrdays(year); year++)
	  {
		cvalue -= yrdays(year);
	  }	

	leapday = lpyr(year) ? 1 : 0;		/* leap year */
	for (month=1; month <= 11; month++)
	  {
		if (cvalue < (dmtotl[month]+((month > 1) ? leapday : 0)))break;
	  }

	cvalue -= dmtotl[month-1] + ((month > 2) ? leapday : 0);
	day   = cvalue + 1;   	/* 1st day is '1', not '0' */

	/* pack information as required	*/
	lbuf[0] = year / 10;
	lbuf[1] = year % 10;
	lbuf[2] = month / 10;
	lbuf[3] = month % 10;
	lbuf[4] = day / 10;
	lbuf[5] = day % 10;
	lbuf[6] = wday;
	lbuf[7] = hour / 10;
	lbuf[8] = hour % 10;
	lbuf[9] = minute / 10;
	lbuf[10]= minute % 10;
	lbuf[11]= second / 10;
	lbuf[12]= second % 10;
	
	constocc(CPTOCW,lbuf);  
	return;
}

/*
 * Invalidate single all pte's in a cluster
 */
tbiscl(v)
	unsigned v;
{
	register caddr_t addr;		/* must be first reg var */
	register int i;

	addr = ptob(v);
	for (i = 0; i < CLSIZE; i++) {
		mtpr(addr, TBIS);
		addr += NBPG;
	}
}

int	dumpmag = 0x8fca0101;	/* magic number for savecore */
/*
 * Doadump comes here after turning off memory management and
 * getting on the dump stack, either when called above, or by
 * the auto-restart code.
 */
dumpsys()
{

#ifdef notdef
	if ((minor(dumpdev)&07) != 1)
		return;
#endif
	dumpsize = maxfree;
	printf("\ndumping to dev %x, offset %d\n", dumpdev, dumplo);
	printf("dump ");
	switch ((*bdevsw[major(dumpdev)].d_dump)(dumpdev)) {

	case ENXIO:
		printf("device bad\n");
		break;

	case EFAULT:
		printf("device not ready\n");
		break;

	case EINVAL:
		printf("area improper\n");
		break;

	case EIO:
		printf("i/o error\n");
		break;

	default:
		printf("succeeded\n");
		break;
	}
	printf("Rebooting the system ...\n\n");
	tocons(CPBOOT);
}


/*
 * Bus error 'recovery' code.
 * Print out the buss frame and then give up.
 * (More information from special registers can be printed here.)
 * 
 */

/*
 * Frame for bus error.  
 * On a VIB error, hardware pushes the MEAR, IVV, BT, ERM, AXE, and ERRCD fields
 * followed by a second longword with the MCBR (see architecture manual).
 * On an HVIB error, hardware pushes the low 16 bits of the Diagnostic Bus 
 * Error Flags register, the BT field, and an ERRCD field of HES followed by 
 * a second longword with the Diagnostic Address register.
 */
struct buserframe 
{
	int	which_bus;		/* primary or secondary */
#define diag_address which_bus
	int	memerreg;		/* memory error register */
#define diag_flags memerreg
	int	trp_pc;			/* trapped pc */
	int	trp_psl;		/* trapped psl */
};

#define NUMFLAGBITS 11

struct hvib_errs
{
	unsigned int bits ;
	char *msg ;
} flagreg[NUMFLAGBITS] =
{
	{ 0x00200000, "MIB Cable Data Parity Error" },
	{ 0x00400000, "MIB Cable Address Parity Error" },
	{ 0x00800000, "WRITE signal status" },
	{ 0x01000000, "HVME Arbiter Timeout" },
	{ 0x02000000, "Memory Bus Error" },
	{ 0x04000000, "HVME Data Transfer Timeout" },
	{ 0x08000000, "MIB Master of HVME" },
	{ 0x10000000, "HVME Data Parity Error" },
	{ 0x20000000, "HVME Addr Parity Error" },
	{ 0x40000000, "HVME Addr Modifier Parity Error" },
	{ 0x80000000, "HVME Sysfail signal status" },
} ;
	

buserror(busef)
caddr_t busef;
{
	register struct buserframe *frameptr;
	register long 	hardreg;


	frameptr = (struct buserframe *)busef;
	printf("bus error at address %x, psl=%x param1=%x param2=%x\n",
		frameptr->trp_pc,frameptr->trp_psl,
		frameptr->memerreg,frameptr->which_bus);
	hardreg = frameptr->memerreg;
	if ( (hardreg & ERRCD) == HES )
	/*
	** HVIB Extended Status indicates HVIB (as opposed to VIB) errors.
	*/
	{
		register unsigned int diagnostic_flags = frameptr->diag_flags ;
		register int i ;

		printf("	HVIB Diagnostic Bus Error Flags register indicates:\n") ;
		printf("	bus master slot number = %d\n", 
			((0x18-((diagnostic_flags & SLOTNOMASK) >> 16)) % 
				0x15) + 1 ) ;

		for ( i=0; i < NUMFLAGBITS; i++ )
		{
			if ( diagnostic_flags & flagreg[i].bits )
				printf("	%s\n", flagreg[i].msg ) ;
		}
		printf("	Diagnostic Address register = %x\n", 
			frameptr->diag_address ) ;

		if (hardreg&AXE) 
			printf("        Adapter external error\n");

		printf ("        Error master : ");
		if (hardreg&ERM) 
			printf("%s bus\n",
				(hardreg&BT) ? "Secondary" : "Primary" ) ;
		else 
			printf ("HCX\n");

		logmemory(frameptr->diag_flags, frameptr->diag_address);

		if ( diagnostic_flags & FATALBUSERR )
			panic("buserror (HVIB)") ;
	}
	else
	/*
	** VIB error OR MIB (possibly with HVIB) error.
	*/
	{
		printf("        MEAR = %x\n",((hardreg&MEAR)>>16)&0xffff);
		switch (hardreg & ERRCD){
			case (APE): 	printf("        Adress parity error.Should not reach this point!! \n");
					break;
			case (DPE): 	printf("        Data parity error.\n");
					break;
			case (DCE):	printf("        Data check error.\n");
					break;
			case (VTO):	printf("        Versabus timeout.\n");
					break;
			case (VBE):	printf("        Versabus error.Should not reach this point!! \n");
					break;
			case (NEM):	printf("        Non existent memory.\n");
					break;
		}
		if (hardreg&AXE) 
			printf("        Adapter external error\n");

		printf ("        Error master : ");
		if (hardreg&ERM) 
			printf("%s bus\n",
				(hardreg&BT) ? "Secondary" : "Primary" ) ;
		else 
			printf ("HCX\n");

		if (hardreg&IVV) 
			printf("        Illegal interrupt vector\n");
	
		hardreg = frameptr->which_bus;
		printf("        MCBR = %x\n", hardreg&MCBR);
	
		logmemory(frameptr->memerreg & ERRCD, frameptr->which_bus);
		if (frameptr->memerreg&IVV) return;
		panic("buserror");
	}
	return ;
}


/*ARGSUSED*/
physstrat(bp, strat, prio)
	struct buf *bp;
	int (*strat)(), prio;
{
	int s;

	(*strat)(bp);
	/* pageout daemon doesn't wait for pushed pages */
	if (bp->b_flags & B_DIRTY)
		return;
	s = spl8();
	while ((bp->b_flags & B_DONE) == 0)
		slumber((caddr_t)bp, 0, resboost);
	splx(s);
}


#ifdef notdef
/*ARGSUSED*/
mtpr (value, regno)
{
	asm("mtpr 4(fp), 8(fp)");
}

/*ARGSUSED*/
int
mfpr (regno)
{
	asm("mfpr 4(fp),r0");
#ifdef lint
	return(0);
#endif
}
#endif
