# @(#)ml.mk	6.6

LIBNAME = 	../lib_ml
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(autoconf.o) \
	$(LIBNAME)(cons.o) \
	$(LIBNAME)(dkbad.o) \
	$(LIBNAME)(machdep.o) \
	$(LIBNAME)(mem.o) \
	$(LIBNAME)(trap.o) \
	$(LIBNAME)(vm_machdep.o) \
	$(LIBNAME)(swapgeneric.o)

all:	$(LIBNAME) assym.s

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

assym.s:
	@echo "          "genassym.c
	@${CC} $(CFLAGS) genassym.c
	@./a.out >assym.s
	@rm -f a.out

.c.a:
	@echo "          "$*.c
	@-$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c ; \
	if [ $$? != 0 ] ; then \
		exit 1 ; \
	fi ; \
	../inline/inline $*.s $*.i ; \
	if [ $$? != 0 ] ; then \
		exit 1 ; \
	fi ; \
	if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi ; \
	$(AS) -o $*.o $*.i ; \
	if [ $$? != 0 ] ; then \
		exit 1 ; \
	fi ; \
	ar r $@ $*.o ; \
	rm $*.i ; \
	rm -f $*.o $*.s

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@../cf/osdep -s genassym.c assym.s >> makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp ml.mk ml.mk.bak
	@ed - ml.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_ml(autoconf.o): ../ml/mem.h ../ml/mtpr.h ../ml/param.h \
	../ml/pte.h ../ml/vmparam.h ../sys/buf.h ../sys/conf.h \
	../sys/dk.h ../sys/dmap.h ../sys/map.h ../sys/param.h \
	../sys/reboot.h ../sys/signal.h ../sys/systm.h ../sys/types.h \
	../sys/vbavar.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h 

../lib_ml(cons.o): ../ml/cp.h ../ml/mtpr.h ../ml/param.h \
	../ml/pcb.h ../sys/callout.h ../sys/conf.h ../sys/dk.h \
	../sys/dmap.h ../sys/errno.h ../sys/ioctlp.h ../sys/kernel.h \
	../sys/msgbuf.h ../sys/param.h ../sys/reboot.h \
	../sys/resource.h ../sys/signal.h ../sys/sysinfo.h \
	../sys/systm.h ../sys/termio.h ../sys/time.h ../sys/tty.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_ml(dkbad.o): ../ml/param.h ../sys/buf.h ../sys/dkbad.h \
	../sys/param.h ../sys/signal.h ../sys/types.h 

../lib_ml(machdep.o): ../cf/ipcconfig.h ../ml/cp.h ../ml/mem.h \
	../ml/mtpr.h ../ml/param.h ../ml/pcb.h ../ml/psl.h ../ml/pte.h \
	../ml/reg.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/callout.h ../sys/cmap.h ../sys/conf.h \
	../sys/dmap.h ../sys/dnlc.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ipc.h ../sys/kernel.h ../sys/map.h \
	../sys/mbuf.h ../sys/msg.h ../sys/param.h ../sys/proc.h \
	../sys/reboot.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/text.h ../sys/time.h \
	../sys/tty.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/utsname.h ../sys/vbavar.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h \
	../sys/vnode.h ../ufs/inode.h ../ufs/quota.h 

../lib_ml(mem.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/buf.h ../sys/cmap.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/param.h \
	../sys/resource.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_ml(trap.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/trap.h ../sys/acct.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/seg.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_ml(vm_machdep.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/cmap.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/text.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vfs.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../ufs/mount.h 

../lib_ml(swapgeneric.o): ../ml/cp.h ../ml/mtpr.h ../ml/param.h \
	../ml/pte.h ../ml/vmparam.h ../sys/buf.h ../sys/conf.h \
	../sys/param.h ../sys/reboot.h ../sys/signal.h ../sys/systm.h \
	../sys/types.h ../sys/vbavar.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h 

assym.s: ../ml/mtpr.h ../ml/param.h ../ml/pcb.h ../ml/pte.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/cmap.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/map.h ../sys/mbuf.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/sysinfo.h ../sys/text.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vmmeter.h ../sys/vmparam.h \
	genassym.c 
