#include "../ml/pte.h"

#include "../sys/param.h"
#include "../sys/conf.h"
#include "../sys/buf.h"
#include "../sys/vm.h"
#include "../sys/systm.h"
#include "../sys/reboot.h"
#include "../ml/cp.h"
#include "../ml/mtpr.h"
#include "../sys/vbavar.h"

#define MAX_DISKS 32
#define false   0
#define true    1

int	nswap;
int	dmmin, dmmax, dmtext;

int
get_number( str_ptr )
	char *	str_ptr ;
{
	int	num = 0 ;
	while ( *str_ptr == ' ' )
		str_ptr ++ ;
	if ( (*str_ptr < '0') || (*str_ptr > '9') )
		return( -1 ) ;
	while ( (*str_ptr >= '0') && (*str_ptr <= '9') ) {
		num = (num * 10) + (*str_ptr - '0') ;
		str_ptr ++ ;
	}
	return( num ) ;
}

setconf( )
{
	register struct vba_device *ui;
	int	root_unit ;
	int	root_part = 0;
	int     root_major ;
	int	swap_unit ;
	int	swap_part = 1;
	int     swap_major ;
	char	disks[ MAX_DISKS ] ;
	char	name[ 128 ] ;
	int	ask ;

	for ( root_unit = 0 ; root_unit < MAX_DISKS ; root_unit ++ )
		disks[ root_unit ] = false ;

	ask = boothowto & RB_ASKNAME ;
	for ( ; ; ) {
		if ( ask ) {
			printf(
		"\nGeneric Unix Option\ntype unit: ctlr drive bus\n" ) ;
			for (ui = vbdinit; ui->ui_driver; ui++) {
				if ( ui->ui_alive && ui->ui_dk ) {
					disks[ ui -> ui_unit ] = true ;
  					if ( ui->ui_dk == DK_HDC )
					        printf( " hd " ) ;
					else
					        printf( " vd " ) ;
					printf("  %d     %x    %x    %x\n",
				    		ui->ui_unit,
						ui->ui_flags,
						ui->ui_slave,
						ui->ui_vbanum ) ;
				}
			}
			printf( "enter root unit number: " ) ;
			gets( name ) ;
			root_unit = get_number( name ) ;
			if ( (root_unit < 0) ||
			     (root_unit > (MAX_DISKS - 1)) ||
			     (disks[ root_unit ] != true) ) {
				printf("invalid unit number\n");
				continue ;
			}
			printf( "enter root partition number: " ) ;
			gets( name ) ;
			root_part = get_number( name ) ;
			if ( (root_part < 0) ||
			     (root_part > 7) ) {
				printf( "invalid root partition number\n" ) ;
				continue ;
			}
			printf( "enter swap unit number: " ) ;
			gets( name ) ;
			swap_unit = get_number( name ) ;
			if ( (swap_unit < 0) ||
			     (swap_unit > (MAX_DISKS - 1)) ||
			     (disks[ swap_unit ] != true) ) {
				printf("invalid unit number\n");
				continue ;
			}
			printf( "enter swap partition number: " ) ;
			gets( name ) ;
			swap_part = get_number( name ) ;
			if ( (swap_part < 0) ||
			     (swap_part > 7) ) {
				printf( "invalid swap partition number\n" ) ;
				continue ;
			}
			break ;
		} else {
			root_unit = -1 ;
			for (ui = vbdinit; ui->ui_driver; ui++) {
  				if ( (ui->ui_alive ) &&
  				     (ui->ui_unit == 0) &&
  				     (ui->ui_dk) ) {
					root_unit = 0;
					swap_unit = 0;
					printf("root on unit 0, partition 0\n");
					printf("swap on unit 0, partition 1\n");
					break ;
				}
			}
			if ( root_unit == 0 )
				break ;
			else
			        ask = true ;
		}
        }

	/* At this time we have a good root and swap partition. */
	root_major = get_dsk_major( root_unit ) ;
	rootdev = makedev( root_major, (root_unit * 8) + root_part ) ;
	swap_major = get_dsk_major( swap_unit ) ;
	swdevt[0].sw_dev = argdev = dumpdev =
	    makedev( swap_major, (swap_unit * 8) + swap_part ) ;
	/* swap size and dumplo set during autoconfigure */
}

int
defaultconf()
{
        int	version = (boot_device & 0x0f000000) >> 24 ;
        int	drive ;
        int	ctlr ;
        int	bus ;
        int	local_major ;
        int     unit ;

	drive   = (boot_device & 0x0003) ;
        if ( version < 2 ) {
		ctlr     =  (boot_device & 0x00000040) >>  4 ;
		bus      =  (boot_device & 0x00000400) >>  8 ;
	} else {
		ctlr     =  (boot_device & 0x000003f0) >>  4 ;
		bus      =  (boot_device & 0x00000c00) >> 10 ;
	}
	/*
	 * Set up root device based on boot_device.
	 */
	unit = get_dsk_unit( bus, ctlr, drive ) ;
	local_major = get_dsk_major( unit ) ;
	if ( local_major == -1 ) {
	 	printf( "rootdev does not exist\n" ) ;
	 	return( 0 ) ;
	 }
	rootdev = makedev( local_major, unit << 3 ) ;

	/*
	 * Verify that swdevt[0].sw_dev exists.
	 */
	 local_major = get_dsk_major( minor( swdevt[0].sw_dev ) >> 3 ) ;
	 if ( (local_major == -1) ||
	      (local_major != major( swdevt[0].sw_dev )) ) {
	 	printf( "swapdev does not exist\n" ) ;
	 	return( 0 ) ;
	 }

	/*
	 * Verify that dumpdev exists.
	 */
	 local_major = get_dsk_major( minor( dumpdev ) >> 3 ) ;
	 if ( (local_major == -1) || (local_major != major( dumpdev )) ) {
	 	printf( "dumpdev does not exist\n" ) ;
	 	return( 0 ) ;
	 }

	/*
	 * Verify that argdev exists.
	 */
	 local_major = get_dsk_major( minor( argdev ) >> 3 ) ;
	 if ( (local_major == -1) || (local_major != major( argdev )) ) {
	 	printf( "argdev does not exist\n" ) ;
	 	return( 0 ) ;
	 }

	/*
	 * All's well.
	 */
	return( 1 ) ;
}

getchar()
{
	char	c;
	int timo;
	extern struct	cpdcb_i consin[];
	extern struct	cphdr *lasthdr;
#define cpin consin[CPCONS]

	timo = 10000;
	uncache((char *)&lasthdr->cp_unit);
	while ((lasthdr->cp_unit & CPTAKE)==0 && --timo )
		uncache((char *)&lasthdr->cp_unit);
	cpin.cp_hdr.cp_unit = CPCONS;	/* Resets done bit */
	cpin.cp_hdr.cp_comm = CPREAD;
	cpin.cp_hdr.cp_count = 1;
	mtpr(&cpin, CPMDCB);
	while ((cpin.cp_hdr.cp_unit & CPDONE) == 0) 
		uncache (&cpin.cp_hdr.cp_unit);
	uncache (&cpin.cpi_buf[0]);
	c = cpin.cpi_buf[0] & 0x7f;
	lasthdr = (struct cphdr *)&cpin;
	if (c == '\r')
		c = '\n';
	printf("%c", c);	/* takes care of interrupts & parity */
	return (c);
}

gets(cp)
	char *cp;
{
	register char *lp;
	register c;

	lp = cp;
	for (;;) {
		c = getchar() & 0177;
		switch (c) {
		case '\n':
		case '\r':
			*lp++ = '\0';
			return;
		case '\b':
		case '#':
			lp--;
			if (lp < cp)
				lp = cp;
			continue;
		case '@':
		case 'u'&037:
			lp = cp;
			printf("%c", '\n');
			continue;
		default:
			*lp++ = c;
		}
	}
}
