#include "../sys/param.h"
#include "../sys/termio.h"
#include "../sys/ioctl.h"
#include "../sys/tty.h"
#include "../sys/errno.h"
#include "../sys/uio.h"
#include "../sys/conf.h"
#include "../sys/file.h"
#include "../sys/dir.h"
#include "../sys/user.h"
#include "../sys/kernel.h"
#include "../sys/mp_host.h"
#include "../sys/mp_dl.h"
#include "../sys/mp_ahst.h"
#include "../sys/mp_adef.h"
#include "../sys/pool.h"

#ifdef DEBUG
int mpatrace = 0;
#endif
extern int mpahis;
extern struct vbmem vbmpcc;
extern ttrstrt();

extern struct tty mpa_16tty[];
extern struct tty mpa_32tty[];
extern HXMTL hxl[];			/* host transmit list */
extern unsigned char a_brkinp[];	/* break char in process */ 
extern struct clist xclist[];		/* clist for xmts in process */

short nolevel1 = 0;

mpaproc(tp,cmd)	
register struct tty *tp;
int cmd;
{
	register MPCCPRT *mprt;
	register HXMTL *hxp;
	register struct cblock *cbp;
	register MPCCINENT *inadr;
	char *ptr;
	struct ccblock *tbuf;
	short prtidx,i,s,port,board,maj,sel;
	unsigned short flags,ret,xcnt;
	MPCCINENT *mpa_in();
	extern ttrstrt();
	MBLOK *mblk;
	
	/* sel - board # in bits 4-7, port # in bits 0-3     */

	maj = major(tp->t_dev);
	sel = minor(tp->t_dev);
	if((maj == A_MAJ16) || (maj == LP_MAJ16)) {  /* First sixteen ports */
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
	}
	else if((maj == A_MAJ32) || (maj == LP_MAJ32)) {  /* Ports 16 thru 32 */
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
	}
	else
		panic("mpaproc:bad dev\n");

	prtidx = (board*MAXASYPRT)+port;

#ifdef DEBUG
	mplog(32);
	if(mpatrace)
		printf("mpaproc port #%x cmd %d maj %d\n",prtidx,cmd,maj);
#endif

	mblk = vbmpcc.mbloks[board];
	mprt = &mblk->mpccport[port];
	
	s = spl8();
	switch(cmd) {
	case T_TIME:	/*# timeout has completed */
		tp->t_state &= ~TIMEOUT;
		if (a_brkinp[prtidx] == ON) {
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("T_TIME:No MPCC inbound entries for dev %x\n",tp->t_dev);
				splx(s);
				return(ENOBUFS);
			}
			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_IOCTL,						(long)A_BRKOFF,(long)T_TIME);
			mpa_sndevt(inadr,MP_IOCTL,A_BRKOFF,mblk,port);
			a_brkinp[prtidx]--;
		}
		goto start;
	case T_WFLUSH:	/*# flush output queue */
		if (!(tp->t_state&BUSY)) {
			tp->t_tbuf.c_size -= tp->t_tbuf.c_count;
			tp->t_tbuf.c_count = 0;
		}
	case T_RESUME:	/*# resume output after being suspended */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("T_RESUME:No MPCC inbound entries for dev %x\n",tp->t_dev);
			splx(s);
			return(ENOBUFS);
		}
		tp->t_state &= ~TTSTOP;
		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_IOCTL,						(long)A_ENABLX,(long)T_RESUME);
		mpa_sndevt(inadr,MP_IOCTL,A_ENABLX,mblk,port);
		goto start;
	case T_OUTPUT:	/*# start output */
start:
		hxp = &hxl[prtidx];
		xcnt = 0;
		tbuf = &tp->t_tbuf;

		/*# while we still have xmt ptrs to use */
		for (i=0;i<A_HSTXMT;i++) {
			if ((tp->t_state&BUSY) && (!(tp->t_oflag&OPOST))) {
				if (!tbuf->c_ptr) {
					/*# fill another cblock ahead */
					(*linesw[tp->t_line].l_output)(tp);
				}
				splx(s);
				/*# return */
				return(0);
			}
			if (tp->t_state&(TIMEOUT|BUSY)) {
				splx(s);
				/*# return */
				return(0);
			}
			if (tp->t_state&TTSTOP)	
			/* don't send any new data if we're suspended */
			/* but allow unblock to go out if there is one */
				break;
			if (tbuf->c_ptr == NULL || tbuf->c_count == 0) {
				if (tbuf->c_ptr) 
					tbuf->c_ptr -= tbuf->c_size - tbuf->c_count;
				if (!(CPRES & (*linesw[tp->t_line].l_output)(tp)))
					break;
			}
			/*# if we're not currently busy outputting, */
			/*# and there is data to be output, set up  */
			/*# port transmit structure to send to mpcc */
			hxp->dblock[i] = (unsigned char *)vtoph(0,(int)tbuf->c_ptr);
			hxp->size[i] = tbuf->c_count;

			/*# bump count of xmts to send */
			xcnt++;

			/*# move cblock to xmt-in-process clist */
			putcb(CMATCH((struct cblock *)tbuf->c_ptr),&xclist[prtidx]);
			/*
			printf("ptr %x clist %x hdr %x ",tbuf->c_ptr, 
				xclist[prtidx].c_cf,&xclist[prtidx]);
			printf("cnt %d data %s\n",tbuf->c_count,tbuf->c_ptr);
			*/

			/*# clear cblock from tty struct */
			tbuf->c_ptr = (char *)0;
			tbuf->c_count = 0;
			tbuf->c_size = 0;

			/*# if next char in output queue is for delay */
			if (tp->t_state & TIMEOUT) 
				/*# break out of for loop */
				break;
		}
		/* we must not be BUSY if we got here */
		/*# if we have transmits to send, or    */
		/*# we must transmit a ctl-s or a ctl-q */
		if (xcnt || (tp->t_state & TTXOFF) || (tp->t_state & TTXON)) {
			/*# if no available mpcc inbound entries */
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("T_OUTPUT:No MPCC inbound entries for dev %x\n",tp->t_dev);
				/*# show no timeout or output in process */
				tp->t_state &= ~(BUSY|TIMEOUT);

				/*# return any queued xmt cblocks to free list */
				while ((cbp = getcb(&xclist[prtidx])) != (struct cblock *)0)
					putcf(cbp);
				splx(s);
printf("MPCC Toutput no buffes \n");
				/*# return no buffers available error */
				return(ENOBUFS);
			}
			/*# show port busy outputting */
			tp->t_state |= BUSY;

			/*# move count of xmt ptrs used to inbound entry */
			inadr->un.async.count = xcnt;

			/*# if we must send a ctl-s before any xmt data */
			if (tp->t_state & TTXOFF) {
				/*# indicate it in write flags */
				flags = A_SSTOP;
				tp->t_state &= ~TTXOFF;	/* turn off flag */
			}
			/*# else if we must send a ctl-q before any xmt data */
			else if (tp->t_state & TTXON) {
				/*# indicate it in write flags */
				flags = A_SSTART;
				tp->t_state &= ~TTXON;	/* turn off flag */
			}
			/*# else */
			else
				/*# clear write flags */
				flags = 0;

			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_WRITE,(long)flags,(long)inadr);
			/*# send MP_WRITE event (w/write flags) to mpcc */
			mpa_sndevt(inadr,MP_WRITE,flags,mblk,port);
		}
		splx(s);
		/*# return */
		return(0);
	case T_SUSPEND:	/*# suspend output via ctl-s */
		/*# if output not currently suspended via ctl-s */
		if (!(tp->t_state & TTSTOP)) {
			/*# if no available mpcc inbound event */
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("T_SUSPEND:No MPCC inbound entries for dev %x\n",tp->t_dev);
				splx(s);
				/*# return no more buffers error to caller */
				return(ENOBUFS);
			}

			/*# show output suspended in tty state */
			tp->t_state |= TTSTOP;

			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)A_DISABX,(long)T_SUSPEND);
			/*# send a disable transmitter event */
			mpa_sndevt(inadr,MP_IOCTL,A_DISABX,mblk,port); 

		}
		/*# break */ 
		break;
	case T_BLOCK:	/*# block input chars (transmit a ctl-s) */
		/*# show input blocked via a transmitted ctl-s */
		tp->t_state |= TBLOCK;
		tp->t_state &= ~TTXON;

		/*# if a transmit is currently in process */	
		if (tp->t_state & BUSY) 
			/*# show to send a ctl-s when xmt completes */
			tp->t_state |= TTXOFF;
		/*# else */
		else {
			/*# if no available mpcc inbound event */
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("T_BLOCK:No MPCC inbound entries for dev %x\n",tp->t_dev);
				splx(s);
				/*# return no more buffers error to caller */
				return(ENOBUFS);
			}
			/*# show port busy outputting */
			tp->t_state |= BUSY;
			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_WRITE,(long)A_SSTOP,(long)T_BLOCK);
			/*# transmit a ctl-s */
			mpa_sndevt(inadr,MP_WRITE,A_SSTOP,mblk,port);
		}
		/*# break */
		break;
	case T_RFLUSH:	/*# flush input queue */
		/*# if input is not currently blocked */
		if (!(tp->t_state & TBLOCK))
			/*# break out of switch */
			break;
		/*# else - fall into T_UNBLOCK code */
	case T_UNBLOCK:	/*# resume input of chars (transmit a ctl-q) */
		/*# show input no longer blocked */
		tp->t_state &= ~(TTXOFF|TBLOCK);

		/*# if a transmit is currently in process */
		if (tp->t_state & BUSY)
			/*# show to send a ctl-q with next transmit */
			tp->t_state |= TTXON;
		/*# else */
		else {
			/*# if no available mpcc inbound event */
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("T_UNBLOCK:No MPCC inbound entries for dev %x\n",tp->t_dev);
				splx(s);
				/*# return no more buffers error to caller */
				return(ENOBUFS);
			}
			/*# show port busy outputting */
			tp->t_state |= BUSY;
			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_WRITE,(long)A_SSTART,(long)T_UNBLOCK);
			/*# transmit a ctl-q now */
			mpa_sndevt(inadr,MP_WRITE,A_SSTART,mblk,port);
		}
		/*# break */
		break;
	case T_BREAK:	/*# send a break */
		/*# if no available mpcc inbound event */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("T_BREAK:No MPCC inbound entries for dev %x\n",tp->t_dev);
			splx(s);
			/*# return no more buffers error to caller */
			return(ENOBUFS);
		}

		/*# show timeout in process */
		tp->t_state |= TIMEOUT;

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)A_BRKON,(long)T_BREAK);
		/*# send a start break event */
		mpa_sndevt(inadr,MP_IOCTL,A_BRKON,mblk,port);

		/*# break lasts for 1/4 sec, so sleep for that long */
		timeout(ttrstrt,(char *)tp, hz/4);

		/*# show timeout in process for a break on this port */
		a_brkinp[prtidx]++;
		break;

	case T_PARM:		/*# called on "slconfig -a" user command */
#ifdef DEBUG
		if(mpatrace)
			printf("T_PARM port #%x \n",port);
#endif
		/*# if port # is not a valid mpcc async port number */
	    	if(mblk->protoport[port] != MP_ASYNC) {
		/*# return not a tty dev error to caller */
			splx(s);
			return(ENXIO);
		}

		/*# if there is a close in process on this port */
		/*# wait for it to complete before */
		/*# continuing port initialization */
		while (mprt->flags & MP_PROGRESS)
		   slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);


		/*# init to no break condition in process */
		a_brkinp[prtidx] = OFF;

		/*# init host mpcc struct */
		mprt->protocol = MP_ASYNC;
		mprt->on = mprt->off = mprt->nextrcv = mprt->flags = 0;

		/*# init mpcc inbound queue */
		for (i=0;i<MP_INSET;i++) {
			mprt->Inents[i].go_stat = MP_FREE;
			mprt->Inents[i].op_code = 0;
			mprt->Inents[i].flags   = 0;
			mprt->Inents[i].un.async.error = 0;
			mprt->Inents[i].un.async.flags = 0;
			mprt->Inents[i].un.async.count = 0;
			/*# set up ptr to transmit list struct */
			mprt->Inents[i].un.async.un.hxl = &hxl[prtidx];
		}
	
		/*# if no available mpcc inbound event */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("T_PARM:No MPCC inbound entries for dev %x\n",tp->t_dev);
			/*# return no more buffers error to caller */
			splx(s);
			return(ENOBUFS);
		}

		/*# init mpcc outbound queue */
		for (i=0;i<MP_OUTSET;i++) {
			/*# init so that L2 can't send any events */
			/*# to host until open has completed      */
			mprt->Outents[i].go_stat = MP_FREE;
			mprt->Outents[i].op_code = 0;
			mprt->Outents[i].un.async.error = 0;
			mprt->Outents[i].un.async.flags = 0;
			mprt->Outents[i].un.async.count = 0;
			/*# set up ptr to port params - assume MP_INSET == OUTSET */
			if((ptr = (char *)pool_alloc(PL_ASYPRT)) == (char *)0) {
				while(--i > 0) {
					ptr = mprt->Outents[i].un.async.params;
					putcf(CMATCH((struct cblock *)ptr));
 					mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)0;
					mprt->Outents[i].un.async.params = (char *)0;
 					pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
					mprt->Inents[i].un.async.params = (char *)0;
				}
printf("MPCC init outbound queue\n");
				splx(s);
				return(ENOBUFS);
			}
			mprt->Inents[i].un.async.params = ptr;
 			if((ptr = (char *) (getcf()->c_data)) ==
				(char *)((struct cblock *)NULL)->c_data) {
 				pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
				mprt->Inents[i].un.async.params = (char *)0;
				while(--i > 0) {
					ptr = mprt->Outents[i].un.async.params;
					putcf(CMATCH((struct cblock *)ptr));
 					mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)0;
					mprt->Outents[i].un.async.params = (char *)0;
 					pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
					mprt->Inents[i].un.async.params = (char *)0;
				}
printf("MPCC init outbound queue 2\n");
				splx(s);
				return(ENOBUFS);
			}
 			mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)vtoph(0,ptr);
			mprt->Outents[i].un.async.params = ptr;
		}
	
		/*# set up xon/xoff config in inbound entry params area */
		setx(tp,&((ALLPRAM *)inadr->un.async.params)->xcnfg);
	
		/*# set up port config in inbound entry params area */
		setp(tp,&((ALLPRAM *)inadr->un.async.params)->pcnfg);

		/*# if we are in local mode */
		if (tp->t_cflag & CLOCAL )
			/*# set up DTR & RTS in inbound entry params area */
			setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,ASSERT);
		/*# else */
		else
			/*# configure for auto modem control in params */
			setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,AUTO);

		/*# set up to allow host events on changes in carrier */
		seti(&((ALLPRAM *)inadr->un.async.params)->intena,A_DCD);

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_OPEN,(long)T_PARM,(long)inadr);
		/*# send event to mpcc */
		mpa_sndevt(inadr,MP_OPEN,0,mblk,port);

		if (nolevel1)
			tp->t_state |= CARR_ON;
		else
			/*# if we are in local mode */
			if (tp->t_cflag & CLOCAL)
				/*# show carrier present */
				tp->t_state |= CARR_ON;

		/*# wakeup anyone waiting for open to complete */
		wakeup((caddr_t)&tp->t_canq);
		break;

	case T_DETACH:		/*# called on "slconfig -d" user command */
		mpaclose(tp->t_dev,0);
	}
	splx(s);
	return(0);
}

mpaopen(dev,flag)
dev_t dev;
int flag;
{
	register struct tty *tp;
	register MPCCPRT *mprt;
	register MPCCINENT *inadr;
	short prtidx,error,s,i,flags,port,board,sel,maj;
	MPCCINENT *mpa_in();
	MBLOK	*mblk;
	char *ptr;
	label_t lqsave;


	maj = major(dev);
	sel = minor(dev);
	/* minor of t_dev contains the mpcc board # in bits */
	/* 4-7 and the port number in bits 0-3     */
	if(maj == A_MAJ16) {	/* First sixteen ports */
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
		tp = &mpa_16tty[sel];
	}
	else if(maj == A_MAJ32) {	/* Ports 16 thru 32 */
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
		tp = &mpa_32tty[sel];
	}
	else
		panic("mpaopen:bad dev\n");

#ifdef DEBUG
	mplog(33);
	if(mpatrace)
		printf("mpaopen port #%x \n",sel);
#endif

	mblk = vbmpcc.mbloks[board];
	/*# if port is not a valid mpcc async port */
	if((mblk->protoport[port] != MP_ASYNC) ||
	   (mblk->status != MP_OPOPEN))
		/*# return not a tty dev error to caller */
		return(ENXIO);

	/*# init pointers to host structs */
	prtidx = (board*MAXASYPRT)+port;
	mprt = &mblk->mpccport[port]; /* host mpcc struct */

	/*# inhibit mpcc INTR's */
	s = spl8();

	/*# if there is a close in process on this port */
	/*# wait for it to complete before */
	/*# continuing port initialization */
	while (mprt->flags & MP_PROGRESS)
	   slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);

	/*# if an open is waiting to complete */
	while (tp->t_state & WOPEN) 
		/*# sleep until complete */
	   slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);
	
	/*# if port is now open */
	if (tp->t_state & ISOPEN) {
		/*# skip mpcc & tty initialization code   */
		splx(s);
		return(0);
	}

	/*# mark port as waiting for open */
	tp->t_state |= WOPEN;

	/*# init to no break condition in process */
	a_brkinp[prtidx] = OFF;

	/*# init tty struct */
	tp->t_dev = dev;	/* mpcc board & port #'s  */
	tp->t_proc = mpaproc;
	tp->t_tbuf.c_ptr = (char *)0; /* no transmit of cblock in process */
	ttinit(tp);	   	/* default ctl chars */
	/* init remaining tty control flags */
	tp->t_iflag |= ICRNL|IXON|ISTRIP; /* map cr to nl; enable */
			   	          /* xon/xoff processing; */
					  /* strip 8th data bit   */
	tp->t_oflag |= OPOST|ONLCR;  /* post-process output chars */
				     /* transmitting the NL char  */
				     /* as the CR-NL char pair    */
	tp->t_lflag |= ISIG|ICANON|ECHO|ECHOK; /* enable signals;     */
					       /* canonicalize input; */
					       /* enable echo; echo   */
					       /* NL after kill char  */

	/*# init host mpcc struct */
	mprt->protocol = MP_ASYNC;
	mprt->on = mprt->off = mprt->nextrcv = mprt->flags = 0;

	/*# init mpcc inbound queue */
	for (i=0;i<MP_INSET;i++) {
		mprt->Inents[i].go_stat = MP_FREE;
		mprt->Inents[i].op_code = 0;
		mprt->Inents[i].flags   = 0;
		mprt->Inents[i].un.async.error = 0;
		mprt->Inents[i].un.async.flags = 0;
		mprt->Inents[i].un.async.count = 0;
		/*# set up ptr to transmit list struct */
		mprt->Inents[i].un.async.un.hxl = &hxl[prtidx];
	}

	/*# if no available mpcc inbound event */
	if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
		printf("mpaopen:No MPCC inbound entries for dev %x\n",tp->t_dev);
		tp->t_state &= ~WOPEN;
		/*# return no more buffers error to caller */
printf("MPCC no pool alloc \n");
		splx(s);
		return(ENOBUFS);
	}

	/*# init mpcc outbound queue */
	for (i=0;i<MP_OUTSET;i++) {
		/*# init so that L2 can't send any events */
		/*# to host until open has completed      */
		mprt->Outents[i].go_stat = MP_FREE;
		mprt->Outents[i].op_code = 0;
		mprt->Outents[i].un.async.error = 0;
		mprt->Outents[i].un.async.flags = 0;
		mprt->Outents[i].un.async.count = 0;
		/*# set up ptr to port params - assume MP_INSET == OUTSET */
		if((ptr = (char *)pool_alloc(PL_ASYPRT)) == (char *)0) {
			while(--i > 0) {
				ptr = mprt->Outents[i].un.async.params;
				putcf(CMATCH((struct cblock *)ptr));
 				mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)0;
				mprt->Outents[i].un.async.params = (char *)0;
 				pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
				mprt->Inents[i].un.async.params = (char *)0;
			}
			tp->t_state &= ~WOPEN;
printf("MPCC no pool alloc 2\n");
			splx(s);
			return(ENOBUFS);
		}
		mprt->Inents[i].un.async.params = ptr;
 		if((ptr = (char *) (getcf()->c_data)) ==
			(char *)((struct cblock *)NULL)->c_data) {
 			pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
			mprt->Inents[i].un.async.params = (char *)0;
			while(--i > 0) {
				ptr = mprt->Outents[i].un.async.params;
				putcf(CMATCH((struct cblock *)ptr));
 				mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)0;
				mprt->Outents[i].un.async.params = (char *)0;
 				pool_dealloc(PL_ASYPRT,mprt->Inents[i].un.async.params);
				mprt->Inents[i].un.async.params = (char *)0;
			}
			tp->t_state &= ~WOPEN;
printf("MPCC no pool alloc 3\n");
			splx(s);
			return(ENOBUFS);
		}
 		mprt->Outents[i].un.async.un.rcvblk = (unsigned char *)vtoph(0,ptr);
		mprt->Outents[i].un.async.params = ptr;
	}

	/*# set up xon/xoff config in inbound entry params area */
	setx(tp,&((ALLPRAM *)inadr->un.async.params)->xcnfg);

	/*# set up port config in inbound entry params area */
	setp(tp,&((ALLPRAM *)inadr->un.async.params)->pcnfg);

	/*# if we are in local mode */
	if (tp->t_cflag & CLOCAL )
		/*# set up DTR & RTS in inbound entry params area */
		setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,ASSERT);
	/*# else */
	else
		/*# configure for auto modem control in params */
		setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,AUTO);

	/*# set up to allow host events on changes in carrier */
	seti(&((ALLPRAM *)inadr->un.async.params)->intena,A_DCD);

	if(mpahis >= 0)
		mpccrecord((long)tp->t_dev,(long)MP_OPEN,(long)0,(long)inadr);
	/*# send event to mpcc */
	mpa_sndevt(inadr,MP_OPEN,0,mblk,port);

	/*# restore mpcc INTR's */
	splx(s);

		/*# if we are in local mode */
	if ((tp->t_cflag & CLOCAL) || nolevel1)
		/*# show carrier present */
		tp->t_state |= CARR_ON;

	/*# if caller wants to wait for carrier before returning from the open */
	if (!(flag & FNDELAY)) {
		/*# save proc context so that we */
		/*# return here hit by a signal  */
		lqsave = u.u_qsave;
		if(setjmp(&u.u_qsave)) {
			s=spl8();
			/*# only get here if hit by signal */
			tp->t_state &= ~WOPEN;

			/*# if port not yet open then we must be sure to  */
			/*# close it on the mpcc so that it can reset its */
			/*# portstat field indexes into the in/out queue  */
			if(mprt->protocol == MP_ASYNC) {
				/* Force cleanup for close */
				ttyflush(tp, (FREAD|FWRITE));
/*				tp->t_state &= ~(WTCLOSE|NBIO);	CCI	*/
				tp->t_state &= ~(NBIO);
				if (tp->t_rbuf.c_ptr) {
					putcf(CMATCH((struct cblock *)tp->t_rbuf.c_ptr));
					tp->t_rbuf.c_ptr = NULL;
					tp->t_rbuf.c_count = 0;
					tp->t_rbuf.c_size = 0;
				}

				/*# issue a close port event to mpcc & let */
				/*# the close completion routine reset the */
				/*# host port fields & do any wakeups	   */
				if ((inadr = mpa_in(mprt,1)) != (MPCCINENT *)0) {

					/*# show a close is in progress */
					mprt->flags = MP_PROGRESS;

					/*# if user wants to hang up on last close */
					if (tp->t_cflag & HUPCL)
						/*# show to drop modem ctl lines */
						setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,0,DROP);
					else
						/*# leave modem lines as local/non-local mode indicates */
						if (tp->t_cflag &CLOCAL)
							setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,ASSERT);
						else
							setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,AUTO);
					/*# disable future host events on changes in carrier */
					seti(&((ALLPRAM *)inadr->un.async.params)->intena,0);
					if(mpahis >= 0)
						mpccrecord((long)tp->t_dev,(long)MP_CLOSE,(long)1,(long)inadr);
					/*# send mpcc close port event */
					mpa_sndevt(inadr,MP_CLOSE,0,mblk,port);
				}
				else {
					printf("mpaopen interupt:No MPCC inbound entries for dev %x\n",tp->t_dev);
				}
				
			}
			/*# wake up those waiting for open to complete */
			wakeup((caddr_t)&tp->t_canq);

			u.u_qsave = lqsave;
			splx(s);
			longjmp(&u.u_qsave);
		}

		/*# wait until data carrier detect asserted */
		while ((tp->t_state & CARR_ON) == 0)
		   slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);

	}
	/*# inhibit mpcc INTR's */
	s = spl8();

	/*# call linesw open routine */
	sel = (*linesw[tp->t_line].l_open)(tp);

	/*# restore mpcc INTR's */
	splx(s);

	/*# wakeup anyone waiting for open to complete */
	wakeup((caddr_t)&tp->t_canq);

	/*# return w/out error to caller */
	return(sel);
}
mpaclose(dev,flag)  	/*# Close Async Port */
dev_t dev;		/*# mpcc board & port #'s */
int flag;
/*
*#	handles closing an ASYNC port which is open on an MPCC 
*#	board. It will only be called when the last proc open 
*#	on a port closes. It also calls the linesw close routine 
*#	(ttclose) via the (*l_close)() table entry.
*#
*#	Process:
*#
*/
{
	register struct tty *tp;
	register MPCCPRT *mprt;
	register MPCCINENT *inadr;
	short s,port,board,sel,maj;
	int err;
	MPCCINENT *mpa_in();
	MBLOK *mblk;
	label_t lqsave;

	maj = major(dev);
	sel = minor(dev);

	if(maj == A_MAJ16) {
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
		tp = &mpa_16tty[sel];
	}
	else if(maj == A_MAJ32) {
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
		tp = &mpa_32tty[sel];
	}
	else
		panic("mpaclose:bad dev\n");

#ifdef DEBUG
	mplog(34);
	if(mpatrace)
		printf("mpaclose port #%x \n",sel);
#endif

	mblk = vbmpcc.mbloks[board];
	mprt = &mblk->mpccport[port];
	s = spl8();

	/*# if this is not an open async port */
	if((mprt->protocol!=MP_ASYNC) ||
		!(tp->t_state&(ISOPEN|WOPEN))) {
		splx(s);
		return(EBADF);
	}

	/*# if there is a close in process on this port */
	if(mprt->flags & MP_PROGRESS) {
		if (mprt->flags & MP_REMBSY) {
			mprt->flags &= ~MP_REMBSY;
			splx(s);
			return(0);
		}
		while (mprt->flags & MP_PROGRESS)
		   slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);
	}

	err = 0;
	mprt->flags |= MP_PROGRESS;

	/*# save proc context so that we return here if hit by a signal */
	lqsave = u.u_qsave;
	if(setjmp(&u.u_qsave)) {
		s=spl8();

		/* Force cleanup for close */
		ttyflush(tp, (FREAD|FWRITE));
/*		tp->t_state &= ~(WTCLOSE|NBIO);	CCI	*/
		tp->t_state &= ~(NBIO);
		if (tp->t_rbuf.c_ptr) {
			putcf(CMATCH((struct cblock *)tp->t_rbuf.c_ptr));
			tp->t_rbuf.c_ptr = NULL;
			tp->t_rbuf.c_count = 0;
			tp->t_rbuf.c_size = 0;
		}

		if ((inadr = mpa_in(mprt,1)) == (MPCCINENT *)0) {
			printf("mpaclose interupt:No MPCC inbound entries for dev %x\n",tp->t_dev);
			mprt->flags &= ~MP_PROGRESS;
			u.u_qsave = lqsave;
			splx(s);
			longjmp(&u.u_qsave);
		}

		/*# if user wants to hang up on last close */
			/*# show to drop modem control lines */
		/*# else */
			/*# leave modem lines as local/non-local indicates */

		if (tp->t_cflag & HUPCL) 
			setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,									0,DROP);
		else {
			if (tp->t_cflag & CLOCAL)
			     setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,							A_DTR,ASSERT);
			else
			     setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,							A_DTR,AUTO);
		}

		/*# disable future host events on changes in carrier */
		seti(&((ALLPRAM *)inadr->un.async.params)->intena,0);

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_CLOSE,(long)2,(long)inadr);
		mpa_sndevt(inadr,MP_CLOSE,0,mblk,port);
		u.u_qsave = lqsave;
		splx(s);
		longjmp(&u.u_qsave);
	}

	/*# first call the linesw close routine */
	err = (*linesw[tp->t_line].l_close)(tp);

	/*# if no available mpcc inbound event */
	if ((inadr = mpa_in(mprt,1)) == (MPCCINENT *)0) {
		printf("mpaclose:No MPCC inbound entries for dev %x\n",tp->t_dev);
		err = ENOBUFS;
		mprt->flags &= ~MP_PROGRESS;
		goto out;
	}

	/*# if user wants to hang up on last close */
	if (tp->t_cflag & HUPCL) 
		/*# show to drop modem control lines */
		setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,0,DROP);
	/*# else */
	else {
		/*# leave modem lines as local/non-local mode indicates */
		if (tp->t_cflag & CLOCAL)
			setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,ASSERT);
		else
			setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,AUTO);
	}

	/*# disable future host events on changes in carrier */
	seti(&((ALLPRAM *)inadr->un.async.params)->intena,0);

	if(mpahis >= 0)
		mpccrecord((long)tp->t_dev,(long)MP_CLOSE,(long)0,(long)0);
	/*# send mpcc close port event */
	mpa_sndevt(inadr,MP_CLOSE,0,mblk,port);

out:
	if(mblk->mpccport[port].flags & MP_REMBSY)
		a3_closeprt(mblk,port);

	/*# restore mpcc INTR's */
	splx(s);

	/* Wait for close completion */
	while (mprt->flags & MP_PROGRESS)
		slumber((caddr_t)&tp->t_canq,INTERRUPTABLE,devcntrlboost);

	/*# return w/out error to caller */
	return(err);
}

/*
 * Read from a MPCC line.
 */
mparead(dev, uio)
dev_t dev;
struct uio *uio;
{
	register struct tty *tp;
	short sel, maj, board, port;

	maj = major(dev);
	sel = minor(dev);
	/* minor of t_dev contains the mpcc board # in bits */
	/* 4-7 and the port number in bits 0-3     */
	if(maj == A_MAJ16) {	/* First sixteen ports */
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
		tp = &mpa_16tty[sel];
	}
	else if(maj == A_MAJ32) {	/* Ports 16 thru 32 */
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
		tp = &mpa_32tty[sel];
	}
	else
		panic("mparead:bad dev\n");

#ifdef DEBUG
	mplog(35);
	if(mpatrace)
		printf("mparead port #%x \n",minor(dev));
#endif
	return (*linesw[tp->t_line].l_read)(tp, uio);
}

/*
 * Write on a MPCC line
 */
mpawrite(dev, uio)
dev_t dev;
struct uio *uio;
{
	register struct tty *tp;
	short sel, maj, board, port;

	maj = major(dev);
	sel = minor(dev);
	/* minor of t_dev contains the mpcc board # in bits */
	/* 4-7 and the port number in bits 0-3     */
	if(maj == A_MAJ16) {	/* First sixteen ports */
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
		tp = &mpa_16tty[sel];
	}
	else if(maj == A_MAJ32) {	/* Ports 16 thru 32 */
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
		tp = &mpa_32tty[sel];
	}
	else
		panic("mpawrite:bad dev\n");
#ifdef DEBUG
	mplog(36);
	if(mpatrace)
		printf("mpawrite port #%x \n",minor(dev));
#endif
	return (*linesw[tp->t_line].l_write)(tp, uio);
}

mpaioctl(dev,cmd,data,flag)	/*# MPCC Async Ioctl */
dev_t dev;			/*# mpcc board & port #'s */
int cmd;			/*# ioctl command */
register caddr_t data;		/*# argument data */
int flag;
/*
*#	This routine is called from the operating system via the
*#	majdevsw ioctl routine (ttyioctl) via the (*d_ioctl)() 
*#	cdevsw table entry.  It handles any ioctl commands which 
*#	require the sending of an event to the mpcc. This routine
*#	calls the common ioctl processing routine ttiocom, which
*#	will return a value of 0 if something changed in the
*#	port termio struct requiring an event to the mpcc (except
*#	for TIOCGETC which returns 0 w/out changing anything).
*#	The ttiocom routine may call mpaproc to process special
*#	device requests.
*#
*#	Process:
*#
*/
{
	register struct tty *tp;
	register MPCCINENT *inadr;
	register MPCCPRT *mprt;
	register struct mdmctl *mdm;
	short result,port,board,sel,maj;
	int setparam;
	MPCCINENT *mpa_in();
	MBLOK *mblk;

	maj = major(dev);
	sel = minor(dev);
	/* minor of t_dev contains the mpcc board # in bits */
	/* 4-7 and the port number in bits 0-3     */
	if(maj == A_MAJ16) {	/* First sixteen ports */
		board = sel / (MAXASYPRT/2);
		port = sel % (MAXASYPRT/2);
		tp = &mpa_16tty[sel];
	}
	else if(maj == A_MAJ32) {	/* Ports 16 thru 32 */
		board = sel / (MAXASYPRT/2);
		port = (sel % (MAXASYPRT/2)) + (MAXASYPRT/2);
		tp = &mpa_32tty[sel];
	}
	else
		panic("mpaioctl:bad dev\n");

	mblk = vbmpcc.mbloks[board];
	/*# if dev is not an open mpcc async port */
	if(mblk->mpccport[port].protocol != MP_ASYNC) 
		/*# return error - not a tty device */
		return(ENXIO);
	
#ifdef DEBUG
	mplog(37);
	if(mpatrace)
		printf("mpaioctl port #%x cmd #%x\n",port,cmd);
#endif
	mprt = &mblk->mpccport[port];

	/*# switch on mpcc-specific ioctls */
	switch(cmd) {

	case TCSMAL:	/*# set mpcc async loopback enable */
		/*# if no available mpcc inbound event */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("TCSMAL:No MPCC inbound entries for dev %x\n",tp->t_dev);
			/*# return no more buffers error to caller */
			return(ENOBUFS);
		}

		/*# set up port config in inbound entry params area */
		setp(tp,&((ALLPRAM *)inadr->un.async.params)->pcnfg);

		/*# enable loopback functionality */
		((ALLPRAM *)inadr->un.async.params)->pcnfg.loopen = ON;

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)A_CHGL1P,(long)TCSMAL);
		/*# send event to mpcc to change Level 1 params */
		mpa_sndevt(inadr,MP_IOCTL,A_CHGL1P,mblk,port);

		/*# return no error to caller */
		return(0);
	case TCCMAL:	/*# clear mpcc async loopback enable */
		/*# if no available mpcc inbound event */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("TCCMAL:No MPCC inbound entries for dev %x\n",tp->t_dev);
			/*# return no more buffers error to caller */
			return(ENOBUFS);
		}

		/*# set up port config in inbound entry params area */
		setp(tp,&((ALLPRAM *)inadr->un.async.params)->pcnfg);

		/*# disable loopback functionality */
		((ALLPRAM *)inadr->un.async.params)->pcnfg.loopen = OFF;

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)A_CHGL1P,(long)TCCMAL);
		/*# send event to mpcc to change Level 1 params */
		mpa_sndevt(inadr,MP_IOCTL,A_CHGL1P,mblk,port);

		/*# return no error to caller */
		return(0);
	case TCFLSHX:	/*# flush a 'hung' transmit event   */
		/*# if no available mpcc inbound event */
		if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
			printf("TCFLSHX:No MPCC inbound entries for dev %x\n",tp->t_dev);
			/*# return no more buffers error to caller */
			return(ENOBUFS);
		}

		if(mpahis >= 0)
			mpccrecord((long)tp->t_dev,(long)MP_WRITE,(long)A_FLUSH,(long)TCFLSHX);
		/*# send a flush pending xmts event to mpcc */
		mpa_sndevt(inadr,MP_WRITE,A_FLUSH,mblk,port);

		/*# return showing no error */
		return(0);
	default: /*# tty must process this ioctl first */
		/*# if the call to the common tty ioctl code did not */
		/*# not result in a change to the port termio struct */
		if (result = ttiocom(tp,cmd,data,flag,&setparam)) 
			/*# return the result */
			return(result);
	
/****************  Special ioctl to support WANG terminals ****
 **** CCI only ****
		if	(cmd == TIOCKCMLSET)
		{
			/*# if no available mpcc inbound event ***
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("mpaioctl:No MPCC inbound entries for dev %x\n",tp->t_dev);
				/*# return no more buffers error to caller ****
				return(ENOBUFS);
			}

			/*# set up Wang Mode information ****
			setparam = (data ? A_KCMLS : A_KCMLU);

			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)setparam,(long)0);
		
			/*# send event to mpcc ****
			mpa_sndevt(inadr,MP_IOCTL,setparam,mblk,port);
		}
/**************** End of WANG support *****/

		if(setparam) {
	
			/*# set termio struct params */
			/*# if no available mpcc inbound event */
			if ((inadr = mpa_in(mprt,0)) == (MPCCINENT *)0) {
				printf("mpaioctl:No MPCC inbound entries for dev %x\n",tp->t_dev);
				/*# return no more buffers error to caller */
				return(ENOBUFS);
			}

			/*# set up xon/xoff config in inbound entry params area */
			setx(tp,&((ALLPRAM *)inadr->un.async.params)->xcnfg);

			/*# set up port config in inbound entry params area */
			setp(tp,&((ALLPRAM *)inadr->un.async.params)->pcnfg);

			/*# if we are in local mode */
			if (tp->t_cflag & CLOCAL )
				/*# set up DTR & RTS in inbound entry params area */
				setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,ASSERT);
			/*# else */
			else
				/*# configure for auto modem control in params */
				setm(&((ALLPRAM *)inadr->un.async.params)->mdmctls,A_DTR,AUTO);

			/*# set up to allow host events on changes in carrier */
			seti(&((ALLPRAM *)inadr->un.async.params)->intena,A_DCD);

			if(mpahis >= 0)
				mpccrecord((long)tp->t_dev,(long)MP_IOCTL,(long)A_CHGALL,(long)0);
			/*# send event to mpcc */
			mpa_sndevt(inadr,MP_IOCTL,A_CHGALL,mblk,port);

			/*# return no error to caller */
			return(0);
		}
	}
	return(result);
}
mpa_sndevt(inadr,evt,flags,mblk,port)	/*# send mpcc event */
register MPCCINENT *inadr;	/*# host inbound event */
char evt;			/*# host event type */
short flags;			/*# flags for async level 2 */
MBLOK *mblk;			/*# pointer to mblok */
short port;			/*# port number */
/*
*#	This routine is called from within the mpcc async driver to
*#	handle sending events to the MPCC.
*#
*#	Process:
*#
*/
{	
	short s;

#ifdef DEBUG
	mplog(38);
	if(mpatrace)
		printf("mpasndevt port #%x evt%d\n",port,evt);
#endif
	s = spl8();
	/*# move host values to inbound entry */
	inadr->op_code = evt;
	inadr->flags = flags;
	/*# show event ready for mpcc */
	inadr->go_stat = MP_GO;
	mp_intmpcc(mblk,port);
	splx(s);
}
MPCCINENT *mpa_in(mprt,flg)	/*# Get Next Inbound Entry */
register MPCCPRT *mprt;	/*# pointer to Host Port MPCC struct */
int flg;		/*# Close request (1) or not (0) */
/*
*#	This routine is called from within the mpcc async driver to
*#	get the next available MPCC Inbound Queue entry.  If an entry 
*#	is currently unavailable, an address of 0 will be returned,
*#	otherwise the available inbound entry address will be returned.
*#
*#	Process:
*#
*/
{
	register MPCCINENT *inadr;
	register MPCCINENT *nxtinadr;
	short s;
	int nxton;

	/*# inhibit mpcc INTR's */
	s = spl8();

	inadr = &mprt->Inents[mprt->on];
	/*# if there is no entry available */
	if ((inadr->go_stat) != (char)MP_FREE) {
		splx(s);
		return((MPCCINENT *)0);
	}
	/* This is not a close request */
	if(!(flg)) {
		if((nxton = mprt->on + 1) >= MP_INSET)
			nxton = 0;
		nxtinadr = &mprt->Inents[nxton];
		/*# There should always be an empty slot ready for close */
		if ((nxtinadr->go_stat) != (char)MP_FREE) {
			splx(s);
			return((MPCCINENT *)0);
		}
	}
	
	/*# init inbound fields marking this entry as busy */
	inadr->un.async.error = 0;
	inadr->un.async.flags = 0;
	inadr->un.async.count = 0;
	inadr->go_stat = MP_BUSY;

	/*# adjust pointer to next available inbound entry */
	adjptr(mprt->on,MP_INSET);

	/*# restore mpcc INTR's */
	splx(s);

	/*# return the entry address */
	return(inadr);
}
setx(tp,xcnfg)	/*# set up xcnfg params */
register struct tty *tp; /*# pointer to port tty struct */	
register XCNFG *xcnfg;   /*# pointer to where to set up xon/xoff config */
{
	/*# set up default start/stop chars on mpcc */
	xcnfg->xon = CSTART;
	xcnfg->xoff = CSTOP;

	/*# if xon/xoff processing is enabled */
	if (tp->t_iflag & IXON)
		/* enable it on mpcc */
		xcnfg->xenbl = ON;
	/*# else */
	else
		/*# disable it on mpcc */
		xcnfg->xenbl = OFF;

	/*# if any received char can be the xon char */
	if (tp->t_iflag & IXANY)
		/*# enable it on mpcc */
		xcnfg->xany = ON;
	/*# else */
	else
		/*# disable it on mpcc */
		xcnfg->xany = OFF;
}
setp(tp,pcnfg)	/*# set up pcnfg params */
register struct tty *tp; /*# pointer to port tty struct */	
register ACONFG *pcnfg;	 /*# pointer to where config data should be stored */
{
	unsigned short flags;

	flags = tp->t_cflag;

	/*# set up number of data bits */
	switch(flags & CSIZE) {
		case CS5: pcnfg->ndata = CHAR5; break; /* 5 data bits */
		case CS6: pcnfg->ndata = CHAR6; break; /* 6 data bits */
		case CS7: pcnfg->ndata = CHAR7; break; /* 7 data bits */
		case CS8: pcnfg->ndata = CHAR8; break; /* 8 data bits */
	}
	/*# set up number of stop bits */
	if (flags & CSTOPB)
		pcnfg->nstop = STOP2;
	else
		pcnfg->nstop = STOP1;
	
	/*# set up baud - Perpos baud defines same as mpcc defines */
	pcnfg->baud = flags & CBAUD;

	/*# set up parity */
	if (flags & PARENB) {	/* parity enabled */
		if (flags & PARODD)
			pcnfg->parity = A_ODDP;  /* odd parity */
		else
			pcnfg->parity = A_EVENP;  /* even parity */
	}
	else
		pcnfg->parity = A_NOPTY;

	/*# set up loopen & rcvtim to default values */
	pcnfg->loopen = OFF;
	pcnfg->rcvtim = A_RCVTIM;
}
setm(mdmctls,mdmsk,rts)	/*# set modem line states */
register struct mdmctl *mdmctls;  /*# pointer to modem control line struct */
int mdmsk,		   /*# modem line states mask */
    rts;		   /*# value of rts - ASSERT | DROP | AUTO */
/*
*#	This routine is used to set up the modem contol line
*#	structure pointed at by 'mdmctls' from the mask found
*#	in 'mdmsk' and from 'rts'.  Each set bit in the mask
*#	will mean to assert the corresponding modem control 
*#	line, otherwise, it will be dropped. RTS is special
*#	since it can either be asserted, dropped or put in
*#	auto mode for auto modem control, so we must send a
*#	separate value for it.
*#
*/
{
	mdmctls->rngdsr = (mdmsk & A_RNGDSR) ? ASSERT : DROP;
	mdmctls->rate = (mdmsk & A_RATE) ? ASSERT : DROP;
	mdmctls->dcd = (mdmsk & A_DCD) ? ASSERT : DROP;
	mdmctls->sectx = (mdmsk & A_SECTX) ? ASSERT : DROP;
	mdmctls->cts = (mdmsk & A_CTS) ? ASSERT : DROP;
	mdmctls->secrx = (mdmsk & A_SECRX) ? ASSERT : DROP;
	mdmctls->dtr = (mdmsk & A_DTR) ? ASSERT : DROP;
	mdmctls->rts = rts;
}
seti(intena,mdmsk) /*# set interrupt enables to host */
register struct mdmctl *intena;  /*# interrupt enable structure ptr */
int mdmsk;	          /*# interrupt enables mask */
/*
*#	This routine sets up the intena field from the mask
*#	found in 'mdmsk'.  When this field is sent to the
*#	mpcc as part of an event, and a change in state on 
*#	a modem control line occurs on a line with its 
*#	corresponding mask bit set, Level 2 will be allowed 
*#	to send a status change event to the Host. Otherwise, 
*#	the host will not be informed of the change.
*#
*/
{
	intena->rngdsr = (mdmsk & A_RNGDSR) ? MDM_ON : MDM_OFF;
	intena->rate = (mdmsk & A_RATE) ? MDM_ON : MDM_OFF;
	intena->dcd = (mdmsk & A_DCD) ? MDM_ON : MDM_OFF;
	intena->sectx = (mdmsk & A_SECTX) ? MDM_ON : MDM_OFF;
	intena->cts = (mdmsk & A_CTS) ? MDM_ON : MDM_OFF;
	intena->secrx = (mdmsk & A_SECRX) ? MDM_ON : MDM_OFF;
	intena->dtr = (mdmsk & A_DTR) ? MDM_ON : MDM_OFF;
	intena->rts = (mdmsk & A_RTS) ? MDM_ON : MDM_OFF;
}
a3_cleanprt(mblk,port)
register MBLOK *mblk;
int port;
{
	register int i;
	register MPCCPRT *mp;
	register struct tty *tp;
	short maj,board;

	/*# First Simulate a call to mpaclose */
	/*# if this is not an open async port */
	mp = &mblk->mpccport[port];
	board = mblk->mpcc_num;
	if(port < MAXASYPRT/2)
		tp = &mpa_16tty[(board*MAXASYPRT/2) + port];
	else
		tp = &mpa_32tty[(board*MAXASYPRT/2) + (port-(MAXASYPRT/2))];
	maj = major(tp->t_dev);

	if(mp->protocol != MP_ASYNC) 
		return;
	

	/*# show mpcc close in process */
	mblk->mpccport[port].flags = MP_REMBSY;

	/*# flush I/O queues and send hangup signals */
	tp->t_state &= ~CARR_ON;
/****	tp->w_state = 0;  CCI	* Added for WANG terminal support */
	ttyflush(tp,(FREAD|FWRITE));
	gsignal(tp->t_pgrp, SIGHUP); /* First kill gracefully */
	gsignal(tp->t_pgrp, SIGKILL); /* If that doesn't work, brute force */
	if(port >= (MAXASYPRT/2))
		port -= (MAXASYPRT/2);
	mpaclose(makedev(maj,port),0);
}

a3_closeprt(mblk,port)
register MBLOK *mblk;
int port;
{
	register int i;
	register MPCCPRT *mp;
	register MPCCINENT *in;
	register MPCCOUTENT *out;
	char list[2];
	register struct tty *tp;
	short board;
	char *ptr;

	/*# First Simulate a call to mpaclose */
	/*# if this is not an open async port */
	mp = &mblk->mpccport[port];
	board = mblk->mpcc_num;
	if(port < MAXASYPRT/2)
		tp = &mpa_16tty[(board*MAXASYPRT/2) + port];
	else
		tp = &mpa_32tty[(board*MAXASYPRT/2) + (port-(MAXASYPRT/2))];

	i = mp->off;
	while(i != mp->on) {
		/**= Get pointer to MPCC Inbound Queue */
		in = &mp->Inents[i];
		in->un.async.error = ENXIO;
		in->go_stat = MP_DONE;
		/**= Bump off index */
		if(++i == MP_INSET)
			i = 0;
	}
	list[0] = port;
	list[1] = EOL;
	mpaoutcmp((short)board,list);
	mpaincmp((short)board,list);

	/** Clear async for port */
	mp->protocol = MP_UNUSED;
	mp->flags = 0;
	mp->on = 0;
	mp->off = 0;
	mp->nextrcv = 0;

	tp->t_state = 0;
/****	tp->w_state = 0;  CCI	* Added for WANG terminal support */

	for(i=0;i<MP_OUTSET;i++) {
		out = &mp->Outents[i];
		out->go_stat = MP_FREE;
		out->op_code = 0;
		out->un.async.error = 0;
 		if(out->un.async.un.rcvblk != (unsigned char *)0) {
			ptr = out->un.async.params;
			putcf(CMATCH((struct cblock *)ptr));
 			out->un.async.un.rcvblk = (unsigned char *)0;
			out->un.async.params = (char *)0;
		}
	}
	for(i=0;i<MP_INSET;i++) {
		in = &mp->Inents[i];
		in->go_stat = MP_FREE;
		in->op_code = 0;
		in->un.async.error = 0;
		if(in->un.async.params != (char *)0) {
 			pool_dealloc(PL_ASYPRT,in->un.async.params);
			in->un.async.params = (char *)0;
		}
	}
}

#ifdef DEBUG
int mpcnt = 0;
char mparray[2000];
mplog(code)
int code;
{
	mparray[mpcnt] = (char)code;
	if(++mpcnt >= 2000)
		mpcnt = 0;
}
#endif
