# @(#)mpcc.mk	1.0

LIBNAME = 	../lib_mpcc
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(mpacmp.o) \
	$(LIBNAME)(mpahst.o) \
	$(LIBNAME)(mpcclun.o) \
	$(LIBNAME)(mpdl.o) \
	$(LIBNAME)(mpint.o) \
	$(LIBNAME)(mpl.o) \
	$(LIBNAME)(pool.o)


all:	$(LIBNAME)

.PRECIOUS: $(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp mpcc.mk mpcc.mk.bak
	@ed - mpcc.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_mpcc(mpacmp.o): ../ml/param.h ../sys/conf.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/mp_adef.h ../sys/mp_ahst.h \
	../sys/mp_dl.h ../sys/mp_host.h ../sys/param.h ../sys/pool.h \
	../sys/signal.h ../sys/tty.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h 

../lib_mpcc(mpahst.o): ../ml/param.h ../ml/pcb.h ../sys/conf.h \
	../sys/dir.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/kernel.h \
	../sys/mp_adef.h ../sys/mp_ahst.h ../sys/mp_dl.h \
	../sys/mp_host.h ../sys/param.h ../sys/pool.h ../sys/resource.h \
	../sys/signal.h ../sys/termio.h ../sys/time.h ../sys/tty.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h ../sys/uio.h \
	../sys/user.h 

../lib_mpcc(mpcclun.o): ../ml/param.h ../sys/buf.h \
	../sys/errno.h ../sys/mp_dl.h ../sys/mp_host.h ../sys/param.h \
	../sys/signal.h ../sys/types.h ../sys/uio.h ../sys/vbavar.h 

../lib_mpcc(mpdl.o): ../bop/sdlcbuf.h ../ml/param.h ../ml/pcb.h \
	../sys/alm.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/dir.h ../sys/dmap.h ../sys/errno.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h ../sys/mp_adef.h \
	../sys/mp_ahst.h ../sys/mp_dl.h ../sys/mp_host.h ../sys/param.h \
	../sys/pool.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/time.h ../sys/tty.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vbavar.h ../sys/x25conf.h 

../lib_mpcc(mpint.o): ../ml/mtpr.h ../ml/param.h ../sys/alm.h \
	../sys/mp_host.h ../sys/param.h ../sys/signal.h ../sys/types.h \
	../sys/vmmeter.h 

../lib_mpcc(mpl.o): ../ml/param.h ../ml/pcb.h ../ml/pte.h \
	../sys/buf.h ../sys/conf.h ../sys/dir.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/map.h ../sys/mp_host.h ../sys/param.h \
	../sys/pool.h ../sys/resource.h ../sys/signal.h ../sys/time.h \
	../sys/tty.h ../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vbavar.h 

../lib_mpcc(pool.o): ../bop/qmgmt.h ../bop/sdlcbuf.h \
	../ml/param.h ../sys/kernel.h ../sys/param.h ../sys/pool.h \
	../sys/signal.h ../sys/time.h ../sys/types.h 
