#include "../sys/param.h"
#include "../sys/errno.h"
#include "../sys/uio.h"
#include "../sys/buf.h"
#include "../sys/vbavar.h"
#include "../sys/mp_host.h"
#include "../sys/mp_dl.h"


struct vbmem vbmpcc =
	{'T','h','I','s',' ','I','s',' ','M','p','C','c',
	{ 0, }, 0};

extern struct mpccsw mprototbl[]; 
extern short *mpbrdaddr[];
extern struct vba_ctlr *mpminfo[];

extern int xl_mpcmpl(), xl_mpframe();
extern int sl_mpcmpl(), sl_mpframe();
extern int mpaincmp(), mpaoutcmp();
extern int bsccmpl(), bsc_mpframe();

/*
 * the following variables are used by the routine 'mpccrecord'
 */
struct mphisdata {
	long m_port;
	long m_func;
	long m_bp;
	long m_other;
};
int mphiscnt = 0;			/* array offset */
struct mphisdata mphisarray[200];	/* history data */
int mphis = -1;				/* port to trace */
int mpahis = -1;			/* port to trace */

int mpccerr();

/*
#page
#doc mpccclose - close a mpcc port
*/
mpccclose(dev)
dev_t dev;
/*
#edoc
*/
{
	int port, board, slot, proto;

	port = minor(dev);
	board = port / MAXSYNCPRT;
	slot  = port % MAXSYNCPRT;
	proto = vbmpcc.mbloks[board]->protoport[slot];
	return((*mprototbl[proto].m_close) (dev));
}
/*
#page
#doc mpccerr - protocol is not defined for port
*/
mpccerr()
{
	return(EINVAL);
}
/*
#page
#doc mpccwrite -  write to a mpcc port
*/
mpccwrite(dev, uio)
dev_t dev;
register struct uio *uio;
/*
#edoc
*/
{
	int port, board, slot, proto;

	port = minor(dev);
	board = port / MAXSYNCPRT;
	slot  = port % MAXSYNCPRT;
	proto = vbmpcc.mbloks[board]->protoport[slot];
	return((*mprototbl[proto].m_write) (dev, uio));
}
/*
#page
#doc mpccread - read from a mpcc port
*/
mpccread(dev, uio)
dev_t dev;
register struct uio *uio;
/*
#edoc
*/
{
	int port, board, slot, proto;

	port = minor(dev);
	board = port / MAXSYNCPRT;
	slot  = port % MAXSYNCPRT;
	proto = vbmpcc.mbloks[board]->protoport[slot];
	return((*mprototbl[proto].m_read) (dev, uio));
}
/*
#page
#doc mpccioctl - ioctl for a mpcc port
*/
mpccioctl(dev, cmd, cmarg, flag)
dev_t dev;
caddr_t cmarg;
int  cmd, flag;
/*
#edoc
*/
{
	int port, board, slot, proto;

	port = minor(dev);
	board = port / MAXSYNCPRT;
	slot  = port % MAXSYNCPRT;
	proto = vbmpcc.mbloks[board]->protoport[slot];
	return((*mprototbl[proto].m_ioctl) (dev, cmd, cmarg, flag));
}
/*
#page
#doc mpccopen - open/download a mpcc port
*/
mpccopen(dev)
dev_t dev;
/*
#edoc
*/
{
	int port, board, slot, proto;

	port = minor(dev);
	board = port / MAXSYNCPRT;
	slot  = port % MAXSYNCPRT;
	proto = vbmpcc.mbloks[board]->protoport[slot];
	return((*mprototbl[proto].m_open) (dev));
}

mpccinit(board)
register int board;
{
	register struct mblok *mp;
	register struct his *his;
	register int i, j;

	mp = vbmpcc.mbloks[board];
	mp->status = MP_DLDONE;
	mp->ivect = (mpminfo[board]->um_ivct & 0x00ff00) >> 8; /* interrupt */
	mp->magic  = MPMAGIC;
	/* Init host interface structure */
	his = &mp->hostint;
	his->semaphore = MP_AVAILABLE;
	for(i=0;i<MAXPROTOCOL;i++) {
		for(j=0;j<MAXMPCCPRT;j++) {
			his->proto[i].inbdone[j] = EOL;
			his->proto[i].outbdone[j] = EOL;
		}
		his->proto[i].incmpl = mprototbl[i].m_incmpl ;
		his->proto[i].outcmpl = mprototbl[i].m_outcmpl ;
	}
	mp->mpcc_num = board;
}

short MPHOSTINT = 1;
mp_timeint(mb)
register MBLOK *mb;
{
	mb->mpintcnt = 0;
	mb->mpintclk = (char *)0;
	*(mpbrdaddr[mb->mpcc_num]) = 2;
}
/*
#page
#doc mp_intmpcc  /**= Interupt mpcc */
mp_intmpcc(mb,port)
register MBLOK *mb;
unsigned short port;
{

	mb->intport[port] |= MP_WORK;
	if(++mb->mpintcnt == MPHOSTINT) {
		mb->mpintcnt = 0;
		*(mpbrdaddr[mb->mpcc_num]) = 2;
		if(mb->mpintclk) {
			untimeout(mp_timeint,mb);
			mb->mpintclk = (char *)0;
		}
	}
	else {
		if(mb->mpintclk == (char *)0) {
			timeout(mp_timeint,mb,4);
			mb->mpintclk = (char *)1;
		}
	}
}

/*
 *  mpcc trace routine
 */
mpccrecord(port,func,bp,other)
long port;
long func;
long bp;
long other;
{
	register struct mphisdata *hisptr;

	if((mpahis>0) && (mpahis!=128) && (port!=mpahis))
		return;
	if((mphis>0) && (mphis!=128) && (port!=mphis))
		return;
	hisptr = &mphisarray[mphiscnt];
	hisptr->m_port = port;
	hisptr->m_func = func;
	hisptr->m_bp = bp;
	hisptr->m_other = other;
	if(++mphiscnt == 200)
		mphiscnt = 0;
}
