# @(#)net.mk	6.6

LIBNAME = 	../lib_net
INET =
CFLAGS = 	-DKERNEL -DINET $(CFL)

FILES = \
	$(LIBNAME)(af.o) \
	$(LIBNAME)(if.o) \
	$(LIBNAME)(if_loop.o) \
	$(LIBNAME)(if_sl.o) \
	$(LIBNAME)(raw_cb.o) \
	$(LIBNAME)(raw_usrreq.o) \
	$(LIBNAME)(route.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp net.mk net.mk.bak
	@ed - net.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_net(af.o): ../ml/param.h ../net/af.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/types.h 

../lib_net(if.o): ../ml/param.h ../ml/pcb.h ../net/af.h \
	../net/if.h ../net/if_arp.h ../sys/dir.h ../sys/dmap.h \
	../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/kernel.h \
	../sys/param.h ../sys/protosw.h ../sys/resource.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/user.h 

../lib_net(if_loop.o): ../ml/mtpr.h ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/netisr.h ../net/route.h ../netinet/in.h \
	../netinet/in_systm.h ../netinet/in_var.h ../netinet/ip.h \
	../sys/errno.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/mbuf.h ../sys/param.h ../sys/signal.h \
	../sys/socket.h ../sys/systm.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h 

../lib_net(if_sl.o): ../ml/mtpr.h ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/netisr.h ../net/route.h ../netinet/in.h \
	../netinet/in_systm.h ../netinet/in_var.h ../netinet/ip.h \
	../sys/buf.h ../sys/dk.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/mbuf.h \
	../sys/param.h ../sys/signal.h ../sys/socket.h ../sys/tty.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h 

../lib_net(raw_cb.o): ../ml/mtpr.h ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/raw_cb.h ../net/route.h ../netinet/in.h \
	../sys/domain.h ../sys/errno.h ../sys/mbuf.h ../sys/param.h \
	../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/types.h 

../lib_net(raw_usrreq.o): ../ml/mtpr.h ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/netisr.h ../net/raw_cb.h ../net/route.h \
	../sys/domain.h ../sys/errno.h ../sys/mbuf.h ../sys/param.h \
	../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/types.h 

../lib_net(route.o): ../ml/param.h ../ml/pcb.h ../net/af.h \
	../net/if.h ../net/if_arp.h ../net/route.h ../sys/dir.h \
	../sys/dmap.h ../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/resource.h \
	../sys/signal.h ../sys/socket.h ../sys/systm.h ../sys/time.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h ../sys/user.h 
