# @(#)netinet.mk	6.6

LIBNAME = 	../lib_netinet
CFLAGS = 	-DKERNEL -DINET $(CFL)
FILES = \
	$(LIBNAME)(ip_output.o) \
	$(LIBNAME)(tcp_usrreq.o) \
	$(LIBNAME)(if_ether.o) \
	$(LIBNAME)(tcp_input.o) \
	$(LIBNAME)(tcp_output.o) \
	$(LIBNAME)(raw_ip.o) \
	$(LIBNAME)(in.o) \
	$(LIBNAME)(ip_icmp.o) \
	$(LIBNAME)(tcp_subr.o) \
	$(LIBNAME)(udp_usrreq.o) \
	$(LIBNAME)(tcp_debug.o) \
	$(LIBNAME)(tcp_timer.o) \
	$(LIBNAME)(in_pcb.o) \
	$(LIBNAME)(ip_input.o) \
	$(LIBNAME)(in_cksum.o) \
	$(LIBNAME)(in_proto.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp netinet.mk netinet.mk.bak
	@ed - netinet.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_netinet(ip_output.o): ../ml/mtpr.h ../ml/param.h \
	../net/if.h ../net/if_arp.h ../net/route.h ../sys/errno.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/types.h in.h in_pcb.h \
	in_systm.h in_var.h ip.h ip_var.h 

../lib_netinet(tcp_usrreq.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/errno.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/ucbstat.h ../sys/systm.h ../sys/types.h \
	in.h in_pcb.h in_systm.h ip.h ip_var.h tcp.h tcp_debug.h \
	tcp_fsm.h tcp_seq.h tcp_timer.h tcp_var.h tcpip.h 

../lib_netinet(if_ether.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/signal.h \
	../sys/socket.h ../sys/syslog.h ../sys/systm.h ../sys/time.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h if_ether.h \
	in.h in_systm.h ip.h 

../lib_netinet(tcp_input.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/errno.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/types.h in.h in_pcb.h \
	in_systm.h ip.h ip_var.h tcp.h tcp_debug.h tcp_fsm.h tcp_seq.h \
	tcp_timer.h tcp_var.h tcpip.h 

../lib_netinet(tcp_output.o): ../ml/param.h ../net/route.h \
	../sys/errno.h ../sys/mbuf.h ../sys/param.h ../sys/protosw.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/types.h in.h in_pcb.h in_systm.h ip.h \
	ip_var.h tcp.h tcp_debug.h tcp_fsm.h tcp_seq.h tcp_timer.h \
	tcp_var.h tcpip.h 

../lib_netinet(raw_ip.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/raw_cb.h ../net/route.h ../sys/errno.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/types.h in.h \
	in_systm.h ip.h ip_var.h 

../lib_netinet(in.o): ../ml/param.h ../ml/pcb.h ../net/af.h \
	../net/if.h ../net/if_arp.h ../net/route.h ../sys/dir.h \
	../sys/dmap.h ../sys/domain.h ../sys/errno.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/mbuf.h ../sys/param.h ../sys/protosw.h \
	../sys/resource.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/time.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/uio.h ../sys/user.h in.h \
	in_systm.h in_var.h 

../lib_netinet(ip_icmp.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/kernel.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/systm.h ../sys/time.h ../sys/types.h icmp_var.h in.h \
	in_systm.h in_var.h ip.h ip_icmp.h 

../lib_netinet(tcp_subr.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/errno.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/types.h in.h in_pcb.h \
	in_systm.h ip.h ip_icmp.h ip_var.h tcp.h tcp_fsm.h tcp_seq.h \
	tcp_timer.h tcp_var.h tcpip.h 

../lib_netinet(udp_usrreq.o): ../ml/param.h ../ml/pcb.h \
	../net/if.h ../net/if_arp.h ../net/route.h ../sys/dir.h \
	../sys/dmap.h ../sys/errno.h ../sys/mbuf.h ../sys/param.h \
	../sys/protosw.h ../sys/resource.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/ucbstat.h ../sys/time.h \
	../sys/types.h ../sys/user.h in.h in_pcb.h in_systm.h ip.h \
	ip_icmp.h ip_var.h udp.h udp_var.h 

../lib_netinet(tcp_debug.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/errno.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/types.h in.h in_pcb.h \
	in_systm.h ip.h ip_var.h tcp.h tcp_debug.h tcp_fsm.h tcp_seq.h \
	tcp_timer.h tcp_var.h tcpip.h 

../lib_netinet(tcp_timer.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/errno.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/types.h in.h in_pcb.h \
	in_systm.h ip.h ip_var.h tcp.h tcp_fsm.h tcp_seq.h tcp_timer.h \
	tcp_var.h tcpip.h 

../lib_netinet(in_pcb.o): ../ml/param.h ../ml/pcb.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/dir.h ../sys/dmap.h \
	../sys/errno.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/mbuf.h \
	../sys/param.h ../sys/protosw.h ../sys/resource.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/user.h in.h in_pcb.h in_systm.h in_var.h 

../lib_netinet(ip_input.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../sys/domain.h ../sys/errno.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/protosw.h \
	../sys/signal.h ../sys/socket.h ../sys/systm.h ../sys/time.h \
	../sys/types.h in.h in_pcb.h in_systm.h in_var.h ip.h ip_icmp.h \
	ip_var.h tcp.h 

../lib_netinet(in_cksum.o): ../netinet/in.h \
	../netinet/in_systm.h ../sys/mbuf.h ../sys/types.h 

../lib_netinet(in_proto.o): ../ml/param.h ../sys/domain.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/types.h in.h in_systm.h 
