# @(#)nfs.mk	6.6

LIBNAME = 	../lib_nfs
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(nfs_server.o) \
	$(LIBNAME)(nfs_subr.o) \
	$(LIBNAME)(nfs_vfsops.o) \
	$(LIBNAME)(nfs_vnodeops.o) \
	$(LIBNAME)(nfs_xdr.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp nfs.mk nfs.mk.bak
	@ed - nfs.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_nfs(nfs_server.o): ../ml/param.h ../ml/pcb.h \
	../netinet/in.h ../nfs/nfs.h ../rpc/auth.h ../rpc/auth_unix.h \
	../rpc/svc.h ../rpc/types.h ../rpc/xdr.h ../sys/buf.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/mbuf.h ../sys/param.h ../sys/pathname.h \
	../sys/resource.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/ucbstat.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h ../ufs/fsdir.h 

../lib_nfs(nfs_subr.o): ../ml/cp.h ../ml/param.h ../ml/pcb.h \
	../net/if.h ../net/if_arp.h ../netinet/in.h ../nfs/nfs.h \
	../nfs/nfs_clnt.h ../nfs/rnode.h ../rpc/auth.h ../rpc/clnt.h \
	../rpc/types.h ../rpc/xdr.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/ucbstat.h ../sys/systm.h ../sys/time.h \
	../sys/tty.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vfs.h ../sys/vnode.h 

../lib_nfs(nfs_vfsops.o): ../ml/param.h ../ml/pcb.h ../net/if.h \
	../net/if_arp.h ../netinet/in.h ../nfs/nfs.h ../nfs/nfs_clnt.h \
	../nfs/rnode.h ../rpc/auth.h ../rpc/clnt.h ../rpc/types.h \
	../rpc/xdr.h ../sys/dmap.h ../sys/errno.h ../sys/mount.h \
	../sys/param.h ../sys/pathname.h ../sys/resource.h \
	../sys/signal.h ../sys/socket.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 

../lib_nfs(nfs_vnodeops.o): ../krpc/lockmgr.h ../ml/mtpr.h \
	../ml/param.h ../ml/pcb.h ../ml/pte.h ../ml/vmparam.h \
	../netinet/in.h ../nfs/nfs.h ../nfs/nfs_clnt.h ../nfs/rnode.h \
	../rpc/auth.h ../rpc/clnt.h ../rpc/types.h ../rpc/xdr.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/cmap.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 

../lib_nfs(nfs_xdr.o): ../ml/param.h ../ml/pcb.h ../netinet/in.h \
	../nfs/nfs.h ../rpc/types.h ../rpc/xdr.h ../sys/dir.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/user.h ../sys/vfs.h ../sys/vnode.h 
