/*	kern_mman.c	6.1	83/07/29	*/

#include "../ml/reg.h"
#include "../ml/psl.h"
#include "../ml/pte.h"

#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/map.h"
#include "../sys/user.h"
#include "../sys/proc.h"
#include "../sys/buf.h"
#include "../sys/vnode.h"
#include "../sys/seg.h"
#include "../sys/acct.h"
#include "../sys/wait.h"
#include "../sys/vm.h"
#include "../sys/text.h"
#include "../sys/file.h"
#include "../sys/vadvise.h"
#include "../sys/cmap.h"
#include "../sys/trace.h"
#include "../sys/mman.h"
#include "../sys/conf.h"
#include "../sys/lock.h"
#include "../sys/kernel.h"

sbrk()
{

}

sstk()
{

}

getpagesize()
{

	u.u_r.r_val1 = NBPG * CLSIZE;
}

smmap()
{
}

mremap()
{

}

munmap()
{
}

munmapfd(fd)
{
	u.u_pofile[fd] &= ~UF_MAPPED;
	
}

mprotect()
{

}

madvise()
{

}

mincore()
{

}

/* BEGIN DEFUNCT */
sbreak()
{
	struct a {
		char	*nsiz;
	};
 	register struct proc 	*p = u.u_procp;
	register int n, d;
	u_int limit;
	struct pte proto;

	/*
	 * set n to new data size
	 * set d to new-old
	 */

	n = btoc(((struct a *)u.u_ap)->nsiz) - ctos(u.u_tsize) * stoc(1);
	if (n < 0)
		n = 0;
	if ((d = clrnd(n - u.u_dsize)) == 0)
		return;
	if (ctob(u.u_dsize+d) > u.u_rlimit[RLIMIT_DATA].rlim_cur) {
		u.u_error = ENOMEM;
		return;
	}
 	/*
	** if process has its data/stack region locked, check against appropriate
 	** limit and return error if they are exceeded
 	*/
 	if ((p->p_lock & DATLOCK) && (d > 0)) {
 		limit = (u.u_uid == 0) ? s_limit : u_limit;
 		if ((plocked += d) > limit) {
 			plocked -= d;
 			u.u_error = ENOMEM;
 			return;
 		}
 	}

	if (u.u_procp->p_smbeg) {

 		register struct pte 	*pte, *ptmark;
		register 		count;

		pte = p->p_p0br + u.u_tsize + u.u_dsize;
		if (d < 0 ) {
			p->p_rssize -= vmemfree(pte + d, -d);
			p->p_dsize += d;
			u.u_dsize += d;
 			if (p->p_lock & DATLOCK)
 				plocked += d;
			return;
		}
		if (pte + d > p->p_smbeg) {
			u.u_error = ENOMEM;
			return;
		}

		if (chksize((u_int)u.u_tsize,(u_int)u.u_dsize+d,(u_int)u.u_ssize))
			return;
		if (swpexpand(u.u_dsize+d, u.u_ssize, &u.u_dmap, &u.u_smap)==0)
			return;

		n = p->p_dsize;
		p->p_dsize += d;
		u.u_dsize += d;

		*(int *)&proto = PG_UW;
		proto.pg_fod = 1;
		((struct fpte *)&proto)->pg_fileno = PG_FZERO;
		cnt.v_nzfod += d;

		count = d;
 		ptmark = pte;
		while (d--)
			*pte++ = proto;
 		/*
 		** if data region locked, page in the expansion pages; this
 		** will set the c_noswap bit in the corresponding cmap entries
 		*/
 		if (p->p_lock & DATLOCK) {
 			d = count;
 			pte = ptmark;
 			while(d--) {
 				while ( ! pte->pg_v )
 					pagein(ctob(dptov(p,
 							  ptetodp(p, pte))), 0);
 				pte++;
 			}
 		}

		newptes(dptov(p, n), count);
		return;
	}
	if (chksize((u_int)u.u_tsize, (u_int)u.u_dsize+d, (u_int)u.u_ssize))
		return;
	if (swpexpand(u.u_dsize+d, u.u_ssize, &u.u_dmap, &u.u_smap)==0)
		return;
	expand(d, 0);
 	if ((p->p_lock & DATLOCK) && (d < 0))
 		plocked += d;
}

#include "../ml/mtpr.h"
int	both;

ovadvise()
{
	register struct a {
		int	anom;
	} *uap;
	register struct proc *rp = u.u_procp;
	int oanom = rp->p_flag & SUANOM;
	register struct pte *pte;
	register struct cmap *c;
	register int i;

#ifdef lint
	both = 0;
#endif
	uap = (struct a *)u.u_ap;
	trace(TR_VADVISE, uap->anom, u.u_procp->p_pid);
	rp->p_flag &= ~(SSEQL|SUANOM);
	switch (uap->anom) {

	case VA_ANOM:
		rp->p_flag |= SUANOM;
		break;

	case VA_SEQL:
		rp->p_flag |= SSEQL;
		break;
	}
	if ((oanom && (rp->p_flag & SUANOM) == 0) || uap->anom == VA_FLUSH) {
		for (i = 0; i < rp->p_dsize; i += CLSIZE) {
			pte = dptopte(rp, i);
			if (pte->pg_v) {
				uncache (pte);
				if (pte->pg_u) {
					c = &cmap[pgtocm(pte->pg_pfnum)];
					if (c->c_lock)
						continue;
					pte->pg_u = 0;
					if (anycl(pte, pg_m))
						pte->pg_m = 1;
					distcl(pte);
				}
			}
		}
	}
	if (uap->anom == VA_FLUSH) {	/* invalidate all pages */
		for (i = 1; i < rp->p_ssize; i += CLSIZE) {
			pte = sptopte(rp, i);
			if (pte->pg_v) {
				uncache (pte);
				if (pte->pg_u) {
					c = &cmap[pgtocm(pte->pg_pfnum)];
					if (c->c_lock)
						continue;
					pte->pg_u = 0;
					if (anycl(pte, pg_m))
						pte->pg_m = 1;
					distcl(pte);
				}
			}
		}
		for (i = 0; i < rp->p_tsize; i += CLSIZE) {
			pte = tptopte(rp, i);
			if (pte->pg_v) {
				uncache (pte);
				if (pte->pg_u) {
					c = &cmap[pgtocm(pte->pg_pfnum)];
					if (c->c_lock)
						continue;
					pte->pg_u = 0;
					if (anycl(pte, pg_m))
						pte->pg_m = 1;
					distcl(pte);
					distpte(rp->p_textp, i, pte);
				}
			}
		}
	}
	mtpr(0, TBIA);
}
/* END DEFUNCT */

/*
 * grow the stack to include the SP
 * true return if successful.
 */
grow(sp)
	unsigned sp;
{
	register int si;
 	register struct proc 	*p = u.u_procp;
 	u_int limit;

	if (sp >= USRSTACK-ctob(u.u_ssize))
		return (0);
	si = clrnd(btoc((USRSTACK-sp)) - u.u_ssize + SINCR);
	if (ctob(u.u_ssize+si) > u.u_rlimit[RLIMIT_STACK].rlim_cur)
		return (0);
 	/*
 	** if process has its data/stack region locked check, against appropriate
 	** limit and return zero if they are exceeded
 	*/
 	if ((p->p_lock & DATLOCK) && (si > 0)) {
 		limit = (u.u_uid == 0) ? s_limit : u_limit;
 		if ((plocked += si) > limit) {
 			plocked -= si;
			uprintf("locked page limit exceeded\n");
 			return(0);
 		}
 	}

	if (chksize((u_int)u.u_tsize, (u_int)u.u_dsize, (u_int)u.u_ssize+si))
		return (0);
	if (swpexpand(u.u_dsize, u.u_ssize+si, &u.u_dmap, &u.u_smap)==0)
		return (0);
	
	expand(si, 1);
 	/*
 	** if proc has data/stack locked and we shrunk stack update plocked
 	*/
 	if ((p->p_lock & DATLOCK) && (si < 0))
 		plocked += si;

	return (1);
}
