# @(#)os.mk	6.6

LIBNAME1 = 	../lib_os1
LIBNAME2 = 	../lib_os2
LIBNAME3 = 	../lib_os3
CFLAGS = 	-DKERNEL -XT5000 $(CFL)
MCFLAGS = 	-DKERNEL $(CFLMCOUNT)

FILES1 = \
	$(LIBNAME1)(audit_sys.o) \
	$(LIBNAME1)(async.o) \
	$(LIBNAME1)(bitmasks.o) \
	$(LIBNAME1)(bsem.o) \
	$(LIBNAME1)(heap_kmem.o) \
	$(LIBNAME1)(init_main.o) \
	$(LIBNAME1)(kern_acct.o) \
	$(LIBNAME1)(kern_clock.o) \
	$(LIBNAME1)(kern_descrip.o) \
	$(LIBNAME1)(kern_exec.o) \
	$(LIBNAME1)(kern_exit.o) \
	$(LIBNAME1)(kern_fork.o) \
	$(LIBNAME1)(kern_mman.o) \
	$(LIBNAME1)(kern_proc.o) \
	$(LIBNAME1)(kern_prot.o) \
	$(LIBNAME1)(kern_resourc.o) \
	$(LIBNAME1)(kern_sig.o) \
	$(LIBNAME1)(kern_subr.o) \
	$(LIBNAME1)(kern_synch.o) \
	$(LIBNAME1)(kern_time.o) \
	$(LIBNAME1)(kern_xxx.o) \
	$(LIBNAME1)(subr_mcount.o) \
	$(LIBNAME1)(subr_prf.o) \
	$(LIBNAME1)(subr_rmap.o) \
	$(LIBNAME1)(subr_xxx.o)

FILES2 = \
	$(LIBNAME2)(raw.o) \
	$(LIBNAME2)(sys_errlog.o) \
	$(LIBNAME2)(sys_flock.o) \
	$(LIBNAME2)(sys_ipc.o) \
	$(LIBNAME2)(sys_lock.o) \
	$(LIBNAME2)(sys_msg.o) \
	$(LIBNAME2)(sys_prof.o) \
	$(LIBNAME2)(sys_sem.o) \
	$(LIBNAME2)(sys_shm.o) \
	$(LIBNAME2)(sys_uts.o) \
	$(LIBNAME2)(sys_generic.o) \
	$(LIBNAME2)(sys_process.o) \
	$(LIBNAME2)(sys_socket.o) \
	$(LIBNAME2)(sys_machdep.o) \
	$(LIBNAME2)(vfs.o) \
	$(LIBNAME2)(vfs_bio.o) \
	$(LIBNAME2)(vfs_dnlc.o) \
	$(LIBNAME2)(vfs_io.o) \
	$(LIBNAME2)(vfs_lookup.o) \
	$(LIBNAME2)(vfs_machdep.o) \
	$(LIBNAME2)(vfs_pathname.o) \
	$(LIBNAME2)(vfs_syscalls.o) \
	$(LIBNAME2)(vfs_vnode.o) \
	$(LIBNAME2)(vfs_xxx.o)

FILES3 = \
	$(LIBNAME3)(uipc_domain.o) \
	$(LIBNAME3)(uipc_mbuf.o) \
	$(LIBNAME3)(uipc_pipe.o) \
	$(LIBNAME3)(uipc_proto.o) \
	$(LIBNAME3)(uipc_socket.o) \
	$(LIBNAME3)(uipc_socket2.o) \
	$(LIBNAME3)(uipc_syscall.o) \
	$(LIBNAME3)(uipc_usrreq.o) \
	$(LIBNAME3)(vm_drum.o) \
	$(LIBNAME3)(vm_fast.o) \
	$(LIBNAME3)(vm_mem.o) \
	$(LIBNAME3)(vm_mon.o) \
	$(LIBNAME3)(vm_page.o) \
	$(LIBNAME3)(vm_proc.o) \
	$(LIBNAME3)(vm_pt.o) \
	$(LIBNAME3)(vm_sched.o) \
	$(LIBNAME3)(vm_subr.o) \
	$(LIBNAME3)(vm_sw.o) \
	$(LIBNAME3)(vm_swap.o) \
	$(LIBNAME3)(vm_swp.o) \
	$(LIBNAME3)(vm_text.o)

all:	$(LIBNAME1) $(LIBNAME2) $(LIBNAME3)

.PRECIOUS:	$(LIBNAME1) $(LIBNAME2) $(LIBNAME3)

$(LIBNAME1):	$(FILES1)

$(LIBNAME2):	$(FILES2)

$(LIBNAME3):	$(FILES3)

install:
	-chmod 664 $(LIBNAME1)
	-chgrp bin $(LIBNAME1)
	-chown bin $(LIBNAME1)
	-chmod 664 $(LIBNAME2)
	-chgrp bin $(LIBNAME2)
	-chown bin $(LIBNAME2)
	-chmod 664 $(LIBNAME3)
	-chgrp bin $(LIBNAME3)
	-chown bin $(LIBNAME3)

.c.a:
	@-case $< in \
	subr_mcount.c) \
		if ( expr "$(MCFLAGS)" : '.*-DGPROF' ) > /dev/null ; then \
			echo "        "$< ; \
			$(CC) -S `echo $(MCFLAGS) | sed 's/-O//'` $*.c ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			ex - $*.s < mon.ex ; \
			../inline/inline $*.s $*.i ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			if ( expr "$(MCFLAGS)" : '.*-O' ) > /dev/null ; then \
				if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
					$(C2) $*.i $*.s ; \
					if [ $$? != 0 ] ; then \
						exit 1 ; \
					fi ; \
					mv $*.s $*.i ; \
				fi; \
			fi ; \
			$(AS) -o $*.o $*.i ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			ar r $@ $*.o ; \
		fi ; \
		;; \
	*) \
		echo "        "$< ; \
		$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		../inline/inline $*.s $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
			if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
				$(C2) $*.i $*.s ; \
				if [ $$? != 0 ] ; then \
					exit 1 ; \
				fi ; \
				mv $*.s $*.i ; \
			fi ; \
		fi ; \
		$(AS) -o $*.o $*.i ; \
		if [ $$? != 0 ] ; then \
			exit 1 ; \
		fi ; \
		ar r $@ $*.o ; \
		;; \
	esac
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME1)
	-rm -f $(LIBNAME2)
	-rm -f $(LIBNAME3)

lint:
	@echo ' $(FILES1) $(FILES2) $(FILES3)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES1) $(FILES2) $(FILES3)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp os.mk os.mk.bak
	@ed - os.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_os1(audit_sys.o): ../ml/param.h ../ml/pcb.h \
	../sys/audit.h ../sys/buf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/kernel.h ../sys/param.h \
	../sys/pathname.h ../sys/resource.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vnode.h ../ufs/inode.h 

../lib_os1(async.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 


../lib_os1(bsem.o): ../cf/ipcconfig.h ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h 

../lib_os1(heap_kmem.o): ../ml/mtpr.h ../ml/param.h ../ml/pte.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/cmap.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os1(init_main.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/reg.h ../ml/vmparam.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/cmap.h ../sys/conf.h \
	../sys/dmap.h ../sys/errno.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/map.h ../sys/param.h ../sys/proc.h \
	../sys/reboot.h ../sys/resource.h ../sys/seg.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/termio.h \
	../sys/text.h ../sys/time.h ../sys/tty.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h ../ufs/inode.h ../ufs/quota.h 

../lib_os1(kern_acct.o): ../ml/param.h ../ml/pcb.h ../sys/acct.h \
	../sys/dmap.h ../sys/errno.h ../sys/kernel.h ../sys/param.h \
	../sys/resource.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 

../lib_os1(kern_clock.o): ../ml/clock.h ../ml/mtpr.h \
	../ml/param.h ../ml/pcb.h ../ml/psl.h ../ml/reg.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/callout.h \
	../sys/dk.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/sysinfo.h \
	../sys/systm.h ../sys/text.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h 

../lib_os1(kern_descrip.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/flock.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/sema.h \
	../sys/shm.h ../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/sysinfo.h ../sys/systm.h ../sys/time.h ../sys/ttychars.h \
	../sys/ttydev.h ../sys/types.h ../sys/ucbstat.h ../sys/uio.h \
	../sys/user.h ../sys/vfs.h ../sys/vnode.h 

../lib_os1(kern_exec.o): ../fpe/fp_in_krnl.h ../ml/mtpr.h \
	../ml/param.h ../ml/pcb.h ../ml/psl.h ../ml/pte.h ../ml/reg.h \
	../ml/vmparam.h ../sys/acct.h ../sys/async.h ../sys/audit.h \
	../sys/bsem.h ../sys/buf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/map.h ../sys/param.h ../sys/pathname.h ../sys/proc.h \
	../sys/resource.h ../sys/seg.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/text.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vfs.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os1(kern_exit.o): ../fpe/fp_in_krnl.h ../ml/mtpr.h \
	../ml/param.h ../ml/pcb.h ../ml/psl.h ../ml/reg.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/mbuf.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/tty.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h ../sys/wait.h 

../lib_os1(kern_fork.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/vmparam.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ipc.h \
	../sys/kernel.h ../sys/map.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/seg.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/text.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 

../lib_os1(kern_mman.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/vmparam.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/cmap.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/lock.h ../sys/map.h ../sys/mman.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/seg.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/text.h \
	../sys/time.h ../sys/trace.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vadvise.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h \
	../sys/vnode.h ../sys/wait.h 

../lib_os1(kern_proc.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/vmparam.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/mbuf.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/seg.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/text.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h ../sys/wait.h 

../lib_os1(kern_prot.o): ../ml/param.h ../ml/pcb.h ../ml/reg.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/param.h ../sys/proc.h ../sys/reboot.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/timeb.h ../sys/times.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h 

../lib_os1(kern_resourc.o): ../ml/mtpr.h ../ml/param.h \
	../ml/pcb.h ../ml/psl.h ../ml/vmparam.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/seg.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os1(kern_sig.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/vmparam.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/pathname.h ../sys/proc.h \
	../sys/resource.h ../sys/seg.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/text.h ../sys/time.h \
	../sys/timeb.h ../sys/times.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vfs.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h \
	../sys/vnode.h 

../lib_os1(kern_subr.o): ../ml/param.h ../ml/pcb.h ../sys/dmap.h \
	../sys/errno.h ../sys/param.h ../sys/resource.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h 

../lib_os1(kern_synch.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/psl.h ../ml/pte.h ../ml/vmparam.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/sysinfo.h ../sys/systm.h \
	../sys/time.h ../sys/tty.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os1(kern_time.o): ../ml/clock.h ../ml/param.h ../ml/pcb.h \
	../ml/reg.h ../sys/async.h ../sys/bsem.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vnode.h 

../lib_os1(kern_xxx.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/reboot.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/times.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vtimes.h 


../lib_os1(subr_prf.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/msgbuf.h ../sys/param.h ../sys/prf.h ../sys/proc.h \
	../sys/reboot.h ../sys/resource.h ../sys/seg.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/tty.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os1(subr_rmap.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/text.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_os1(subr_xxx.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/conf.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os2(raw.o): ../ml/clock.h ../ml/param.h ../ml/pcb.h \
	../specfs/snode.h ../sys/async.h ../sys/bsem.h ../sys/conf.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/tty.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h 

../lib_os2(sys_errlog.o): ../ml/mem.h ../ml/mtpr.h ../ml/param.h \
	../ml/pte.h ../sys/buf.h ../sys/conf.h ../sys/elog.h \
	../sys/erec.h ../sys/err.h ../sys/iobuf.h ../sys/kernel.h \
	../sys/map.h ../sys/param.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/utsname.h 

../lib_os2(sys_flock.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dir.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/flock.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/sema.h ../sys/shm.h \
	../sys/signal.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vnode.h ../ufs/inode.h 

../lib_os2(sys_ipc.o): ../ml/param.h ../ml/pcb.h ../ml/pte.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_os2(sys_lock.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/cmap.h ../sys/dir.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/lock.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/text.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h 

../lib_os2(sys_msg.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/msg.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_os2(sys_prof.o): ../ml/param.h ../ml/pcb.h ../ml/psl.h \
	../sys/buf.h ../sys/dmap.h ../sys/errno.h ../sys/param.h \
	../sys/resource.h ../sys/signal.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h 

../lib_os2(sys_sem.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/map.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_os2(sys_shm.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dir.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/kernel.h ../sys/lock.h \
	../sys/map.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os2(sys_uts.o): ../ml/param.h ../ml/pcb.h ../ml/vmparam.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/utsname.h ../sys/vfs.h ../ufs/fs.h ../ufs/mount.h 

../lib_os2(sys_generic.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dk.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ioctl.h \
	../sys/ioctlp.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/time.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/ucbstat.h ../sys/uio.h ../sys/user.h 

../lib_os2(sys_process.o): ../ml/mtpr.h ../ml/param.h \
	../ml/pcb.h ../ml/psl.h ../ml/pte.h ../ml/reg.h ../ml/vmparam.h \
	../sys/acct.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/seg.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/text.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os2(sys_socket.o): ../ml/param.h ../ml/pcb.h \
	../net/route.h ../sys/dir.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/protosw.h \
	../sys/resource.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/systm.h ../sys/time.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/ucbstat.h ../sys/uio.h ../sys/user.h 

../lib_os2(sys_machdep.o): ../ml/dkio.h ../ml/param.h \
	../ml/pcb.h ../ml/pte.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/mtio.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_os2(vfs.o): ../ml/param.h ../ml/pcb.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/mount.h \
	../sys/param.h ../sys/pathname.h ../sys/resource.h \
	../sys/signal.h ../sys/socket.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h ../ufs/inode.h 

../lib_os2(vfs_bio.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/seg.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/time.h \
	../sys/trace.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 

../lib_os2(vfs_dnlc.o): ../ml/param.h ../ml/pcb.h ../sys/dmap.h \
	../sys/dnlc.h ../sys/errno.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/user.h ../sys/vnode.h 

../lib_os2(vfs_io.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h ../sys/ipc.h \
	../sys/kernel.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/time.h \
	../sys/ttychars.h ../sys/ttydev.h ../sys/types.h \
	../sys/ucbstat.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 

../lib_os2(vfs_lookup.o): ../ml/param.h ../ml/pcb.h ../sys/dir.h \
	../sys/dmap.h ../sys/errno.h ../sys/kernel.h ../sys/param.h \
	../sys/pathname.h ../sys/resource.h ../sys/signal.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vfs.h ../sys/vnode.h 

../lib_os2(vfs_machdep.o): ../ml/mtpr.h ../ml/param.h \
	../ml/pcb.h ../ml/pte.h ../ml/vmparam.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/conf.h ../sys/dir.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/seg.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os2(vfs_pathname.o): ../ml/param.h ../sys/dir.h \
	../sys/errno.h ../sys/param.h ../sys/pathname.h ../sys/signal.h \
	../sys/types.h ../sys/uio.h 

../lib_os2(vfs_syscalls.o): ../ml/param.h ../ml/pcb.h \
	../specfs/snode.h ../sys/audit.h ../sys/conf.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/param.h \
	../sys/pathname.h ../sys/resource.h ../sys/signal.h \
	../sys/time.h ../sys/tty.h ../sys/types.h ../sys/ucbstat.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/inode.h 

../lib_os2(vfs_vnode.o): ../ml/param.h ../ml/pcb.h \
	../sys/audit.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/param.h ../sys/pathname.h \
	../sys/resource.h ../sys/signal.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h 

../lib_os2(vfs_xxx.o): ../ml/param.h ../ml/pcb.h \
	../sys/attstat.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/kernel.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vnode.h 

../lib_os3(uipc_domain.o): ../ml/param.h ../sys/domain.h \
	../sys/kernel.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/time.h ../sys/types.h 

../lib_os3(uipc_mbuf.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/cmap.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/map.h ../sys/mbuf.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h 

../lib_os3(uipc_pipe.o): ../ml/param.h ../ml/pcb.h ../ml/reg.h \
	../sys/audit.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/kernel.h ../sys/mbuf.h ../sys/param.h \
	../sys/protosw.h ../sys/resource.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/time.h ../sys/types.h \
	../sys/unpcb.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h 

../lib_os3(uipc_proto.o): ../ml/param.h ../sys/domain.h \
	../sys/mbuf.h ../sys/param.h ../sys/protosw.h ../sys/signal.h \
	../sys/socket.h ../sys/types.h 

../lib_os3(uipc_socket.o): ../ml/param.h ../ml/pcb.h \
	../net/route.h ../netinet/in.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/dmap.h ../sys/domain.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ioctl.h ../sys/ioctlp.h \
	../sys/ipc.h ../sys/kernel.h ../sys/mbuf.h ../sys/param.h \
	../sys/proc.h ../sys/protosw.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/ttychars.h ../sys/ttydev.h \
	../sys/types.h ../sys/ucbstat.h ../sys/uio.h ../sys/un.h \
	../sys/user.h 

../lib_os3(uipc_socket2.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ipc.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/proc.h \
	../sys/protosw.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h 

../lib_os3(uipc_syscall.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ipc.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/proc.h \
	../sys/protosw.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vnode.h 

../lib_os3(uipc_usrreq.o): ../ml/param.h ../ml/pcb.h \
	../sys/dmap.h ../sys/domain.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/mbuf.h ../sys/param.h ../sys/pathname.h \
	../sys/protosw.h ../sys/resource.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/time.h ../sys/types.h \
	../sys/ucbstat.h ../sys/uio.h ../sys/un.h ../sys/unpcb.h \
	../sys/user.h ../sys/vnode.h 

../lib_os3(vm_drum.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/text.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os3(vm_fast.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/cmap.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/text.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os3(vm_mem.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/lock.h ../sys/map.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/text.h ../sys/time.h ../sys/trace.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h ../ufs/mount.h 

../lib_os3(vm_mon.o): ../ml/param.h ../ml/pcb.h ../sys/dmap.h \
	../sys/errno.h ../sys/param.h ../sys/resource.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/trace.h ../sys/types.h \
	../sys/user.h ../sys/vmmeter.h 

../lib_os3(vm_page.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/reg.h ../ml/vmparam.h ../sys/async.h \
	../sys/bsem.h ../sys/buf.h ../sys/cmap.h ../sys/dmap.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/ipc.h \
	../sys/kernel.h ../sys/lock.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/text.h ../sys/time.h ../sys/trace.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 

../lib_os3(vm_proc.o): ../fpe/fp_in_krnl.h ../ml/mtpr.h \
	../ml/param.h ../ml/pcb.h ../ml/pte.h ../ml/vmparam.h \
	../sys/async.h ../sys/bsem.h ../sys/cmap.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/kernel.h ../sys/lock.h \
	../sys/map.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/text.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h 

../lib_os3(vm_pt.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/text.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 

../lib_os3(vm_sched.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/vmparam.h ../sys/async.h ../sys/bsem.h ../sys/cmap.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/seg.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/sysinfo.h \
	../sys/systm.h ../sys/text.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h 

../lib_os3(vm_subr.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/text.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vfs.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h \
	../sys/vnode.h 

../lib_os3(vm_sw.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/vmparam.h ../sys/buf.h ../sys/conf.h ../sys/dmap.h \
	../sys/dsk.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/map.h ../sys/param.h ../sys/reboot.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vm.h ../sys/vmmac.h \
	../sys/vmmeter.h ../sys/vmparam.h ../sys/vmsystm.h \
	../sys/vnode.h 

../lib_os3(vm_swap.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/lock.h ../sys/map.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/text.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h 

../lib_os3(vm_swp.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/map.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/seg.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/sysinfo.h ../sys/systm.h \
	../sys/time.h ../sys/trace.h ../sys/types.h ../sys/uio.h \
	../sys/user.h ../sys/vm.h ../sys/vmmac.h ../sys/vmmeter.h \
	../sys/vmparam.h ../sys/vmsystm.h ../sys/vnode.h 

../lib_os3(vm_text.o): ../ml/mtpr.h ../ml/param.h ../ml/pcb.h \
	../ml/pte.h ../ml/vmparam.h ../sys/async.h ../sys/bsem.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/lock.h ../sys/map.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/seg.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/sysinfo.h \
	../sys/systm.h ../sys/text.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vm.h \
	../sys/vmmac.h ../sys/vmmeter.h ../sys/vmparam.h \
	../sys/vmsystm.h ../sys/vnode.h 
