/*	sys_generic.c	6.1	83/07/29	*/

#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/user.h"
#include "../sys/dk.h"
#include "../sys/ioctl.h"
#include "../sys/file.h"
#include "../sys/proc.h"
#include "../sys/uio.h"
#include "../sys/kernel.h"
#include "../sys/ucbstat.h"
#include "../sys/sysinfo.h"

/*
 * Read system call.
 */
read()
{
	register struct a {
		int	fdes;
		char	*cbuf;
		unsigned count;
	} *uap = (struct a *)u.u_ap;
	struct uio auio;
	struct iovec aiov;
	register struct file *fp;
	label_t lqsave;

#ifndef HCXRT
	sysinfo.sysread++;
#endif
	aiov.iov_base = (caddr_t)uap->cbuf;
	auio.uio_resid = aiov.iov_len = uap->count;
	auio.uio_iov = &aiov;
	auio.uio_iovcnt = 1;
	if (aiov.iov_len < 0) {
		u.u_error = EINVAL;
		return;
	}

	GETF(fp, uap->fdes);
	if ((fp->f_flag&FREAD) == 0) {
		u.u_error = EBADF;
		return;
	}
	u.u_fmode = fp->f_flag;
	auio.uio_segflg = UIO_USERSPACE;
	auio.uio_offset = fp->f_offset;
	if ((u.u_procp->p_flag&SOUSIG) == 0) {
		lqsave = u.u_qsave;
		if (setjmp(&u.u_qsave)) {
			if (auio.uio_resid == uap->count)
				u.u_error = ERESTARTSYS;
		} else
			u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_READ, &auio);
		u.u_qsave = lqsave;
	} else
		u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_READ, &auio);
	u.u_r.r_val1 = uap->count - auio.uio_resid;
	fp->f_offset += u.u_r.r_val1;
	u.u_ru.ru_iochr += u.u_r.r_val1;
#ifndef HCXRT
	sysinfo.readch += (unsigned)u.u_r.r_val1;
#endif
}

readv()
{
	register struct a {
		int	fdes;
		struct	iovec *iovp;
		int	iovcnt;
	} *uap = (struct a *)u.u_ap;
	struct uio auio;
	struct iovec aiov[16];		/* XXX */
	register struct iovec * iov;
	register int i;
	register struct file *fp;
	register int count;
	label_t lqsave;

	if (uap->iovcnt <= 0 || uap->iovcnt > sizeof(aiov)/sizeof(aiov[0])) {
		u.u_error = EINVAL;
		return;
	}

#ifndef HCXRT
	sysinfo.sysread++;
#endif
	auio.uio_iov = aiov;
	auio.uio_iovcnt = uap->iovcnt;
	iov = aiov;
	u.u_error = copyin((caddr_t)uap->iovp, iov,
	    (unsigned)(uap->iovcnt * sizeof (struct iovec)));
	if (u.u_error)
		return;

	auio.uio_resid = 0;
	for (i = 0; i < auio.uio_iovcnt; i++) {
		if (iov->iov_len < 0) {
			u.u_error = EINVAL;
			return;
		}
		auio.uio_resid += iov->iov_len;
		if (auio.uio_resid < 0) {
			u.u_error = EINVAL;
			return;
		}
		iov++;
	}

	GETF(fp, uap->fdes);
	if ((fp->f_flag&FREAD) == 0) {
		u.u_error = EBADF;
		return;
	}
	u.u_fmode = fp->f_flag;
	auio.uio_segflg = UIO_USERSPACE;
	count = auio.uio_resid;
	auio.uio_offset = fp->f_offset;
	if ((u.u_procp->p_flag&SOUSIG) == 0) {
		lqsave = u.u_qsave;
		if (setjmp(&u.u_qsave)) {
			if (auio.uio_resid == count)
				u.u_error = ERESTARTSYS;
		} else
			u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_READ, &auio);
		u.u_qsave = lqsave;
	} else
		u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_READ, &auio);
	u.u_r.r_val1 = count - auio.uio_resid;
	fp->f_offset += u.u_r.r_val1;
	u.u_ru.ru_iochr += u.u_r.r_val1;
#ifndef HCXRT
	sysinfo.readch += (unsigned)u.u_r.r_val1;
#endif
}

/*
 * Write system call
 */
write()
{
	register struct a {
		int	fdes;
		char	*cbuf;
		int	count;
	} *uap = (struct a *)u.u_ap;
	struct uio auio;
	struct iovec aiov;
	register struct file *fp;
	label_t lqsave;

#ifndef HCXRT
	sysinfo.syswrite++;
#endif
	aiov.iov_base = uap->cbuf;
	auio.uio_resid = aiov.iov_len = uap->count;
	auio.uio_iov = &aiov;
	auio.uio_iovcnt = 1;
	if (aiov.iov_len < 0) {
		u.u_error = EINVAL;
		return;
	}

	GETF(fp, uap->fdes);
	if ((fp->f_flag&FWRITE) == 0) {
		u.u_error = EBADF;
		return;
	}
	u.u_fmode = fp->f_flag;
	auio.uio_segflg = UIO_USERSPACE;
	auio.uio_offset = fp->f_offset;
	if ((u.u_procp->p_flag&SOUSIG) == 0) {
		lqsave = u.u_qsave;
		if (setjmp(&u.u_qsave)) {
			if (auio.uio_resid == uap->count)
				u.u_error = ERESTARTSYS;
		} else
			u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_WRITE, &auio);
		u.u_qsave = lqsave;
	} else
		u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_WRITE, &auio);
	u.u_r.r_val1 = uap->count - auio.uio_resid;
	fp->f_offset += u.u_r.r_val1;
	u.u_ru.ru_iochr += u.u_r.r_val1;
#ifndef HCXRT
	sysinfo.writech += (unsigned)u.u_r.r_val1;
#endif
}

writev()
{
	register struct a {
		int	fdes;
		struct	iovec *iovp;
		int	iovcnt;
	} *uap = (struct a *)u.u_ap;
	struct uio auio;
	struct iovec aiov[16];		/* XXX */
	register struct iovec * iov;
	register int i;
	register struct file *fp;
	register int count;
	label_t lqsave;

	if (uap->iovcnt <= 0 || uap->iovcnt > sizeof(aiov)/sizeof(aiov[0])) {
		u.u_error = EINVAL;
		return;
	}

#ifndef HCXRT
	sysinfo.syswrite++;
#endif
	auio.uio_iov = aiov;
	auio.uio_iovcnt = uap->iovcnt;
	iov = aiov;
	u.u_error = copyin((caddr_t)uap->iovp, iov,
	    (unsigned)(uap->iovcnt * sizeof (struct iovec)));
	if (u.u_error)
		return;

	auio.uio_resid = 0;
	for (i = 0; i < auio.uio_iovcnt; i++) {
		if (iov->iov_len < 0) {
			u.u_error = EINVAL;
			return;
		}
		auio.uio_resid += iov->iov_len;
		if (auio.uio_resid < 0) {
			u.u_error = EINVAL;
			return;
		}
		iov++;
	}

	GETF(fp, uap->fdes);
	if ((fp->f_flag&FWRITE) == 0) {
		u.u_error = EBADF;
		return;
	}
	u.u_fmode = fp->f_flag;
	auio.uio_segflg = UIO_USERSPACE;
	count = auio.uio_resid;
	auio.uio_offset = fp->f_offset;
	if ((u.u_procp->p_flag&SOUSIG) == 0) {
		lqsave = u.u_qsave;
		if (setjmp(&u.u_qsave)) {
			if (auio.uio_resid == count)
				u.u_error = ERESTARTSYS;
		} else
			u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_WRITE, &auio);
		u.u_qsave = lqsave;
	} else
		u.u_error = (*fp->f_ops->fo_rw)(fp, UIO_WRITE, &auio);
	u.u_r.r_val1 = count - auio.uio_resid;
	fp->f_offset += u.u_r.r_val1;
	u.u_ru.ru_iochr += u.u_r.r_val1;
#ifndef HCXRT
	sysinfo.writech += (unsigned)u.u_r.r_val1;
#endif
}

/*
 * Ioctl system call
 */
ioctl()
{
	register struct file *fp;
	struct a {
		int	fdes;
		int	cmd;
		caddr_t	cmarg;
	} *uap;
	register int com;
	register u_int size;
	char data[IOCPARM_MASK+1];

	uap = (struct a *)u.u_ap;
	GETF(fp, uap->fdes);
	if ((fp->f_flag & (FREAD|FWRITE)) == 0) {
		u.u_error = EBADF;
		return;
	}
	com = uap->cmd;

	/*
	 * Old style ioctl's just return error status.
	 */
	if ((com&~0xffff) == 0) {
		u.u_error = EINVAL;
		return;
	}
	if (com == FIOCLEX) {
		u.u_pofile[uap->fdes] |= UF_EXCLOSE;
		return;
	}
	if (com == FIONCLEX) {
		u.u_pofile[uap->fdes] &= ~UF_EXCLOSE;
		return;
	}

	/*
	 * Interpret high order word to find
	 * amount of data to be copied to/from the
	 * user's address space.
	 */
	size = (com &~ (IOC_INOUT|IOC_VOID)) >> 16;
	if (size > sizeof (data)) {
		u.u_error = EINVAL;
		return;
	}
	if (com&IOC_IN) {
		if (size == sizeof (int) && uap->cmarg == NULL)
			*(int *)data = 0;
		else if (size != 0) {
			u.u_error =
			    copyin(uap->cmarg, (caddr_t)data, (u_int)size);
			if (u.u_error)
				return;
		} else
			*(caddr_t *)data = uap->cmarg;
	} else if ((com&IOC_OUT) && size)
		/*
		 * Zero the buffer on the stack so the user
		 * always gets back something deterministic.
		 */
		bzero((caddr_t)data, size);
	else if (com&IOC_VOID)
		*(caddr_t *)data = uap->cmarg;

	switch (com) {

	case FIOSETOWN:
		u.u_error = fsetown(fp, *(int *)data);
		return;

	case FIOGETOWN:
		u.u_error = fgetown(fp, (int *)data);
		return;
	}
	u.u_error = (*fp->f_ops->fo_ioctl)(fp, com, data);
	/*
	 * Copy any data to user, size was
	 * already set and checked above.
	 */
	if (u.u_error == 0 && (com&IOC_OUT) && size)
		u.u_error = copyout(data, uap->cmarg, (u_int)size);
}

/*
 * old stty and gtty
 */
stty()
{
	register struct a {
		int	fdes;
		int	arg;
		int	narg;
	} *uap;

	uap = (struct a *)u.u_ap;
	uap->narg = uap->arg;
	uap->arg = TIOCSETP;
	ioctl();
}

gtty()
{
	register struct a {
		int	fdes;
		int	arg;
		int	narg;
	} *uap;

	uap = (struct a *)u.u_ap;
	uap->narg = uap->arg;
	uap->arg = TIOCGETP;
	ioctl();
}

int	unselect();
int	nselcoll;

/*
 * Select system call.
 */
select()
{
	register struct uap  {
		unsigned	nd;
		long	*in, *ou, *ex;
		struct	timeval *tv;
	} *uap = (struct uap *)u.u_ap;
	int ibits[3], obits[3];
	struct timeval atv;
	int s, ncoll;
	register int mask;
	label_t lqsave;
	int polling;

	if (uap->nd > 31)
		mask = 0xFFFFFFFF;	/* forgiving, if slightly wrong */
	else
		mask = sbittab[uap->nd] - 1;

#define	getbits(name, x) \
	if (uap->name) { \
		ibits[x] = fuword((caddr_t)uap->name); \
		if (u.u_error) { \
			obits[0] = obits[1] = obits[2] = 0; \
			goto done; \
		} \
		ibits[x] &= mask; \
	} else \
		ibits[x] = 0;
	getbits(in, 0);
	getbits(ou, 1);
	getbits(ex, 2);
#undef	getbits

	polling = 0;
	if (uap->tv) {
		u.u_error = copyin((caddr_t)uap->tv, (caddr_t)&atv,
			sizeof (atv));
		if (u.u_error) {
			obits[0] = obits[1] = obits[2] = 0;
			goto done;
		}
		if (atv.tv_sec || atv.tv_usec) {
			if (itimerfix(&atv)) {
				obits[0] = obits[1] = obits[2] = 0;
				u.u_error = EINVAL;
				goto done;
			}
			s = spl8(); timevaladd(&atv, &time); splx(s);
		} else
			polling = 1;
	}
retry:
	ncoll = nselcoll;
	u.u_procp->p_flag |= SSEL;
	u.u_r.r_val1 = selscan(ibits, obits);
	if (u.u_r.r_val1 || polling || u.u_error)
		goto done;
	s = spl8();
	/* this should be timercmp(&time, &atv, >=) */
	if (uap->tv && (time.tv_sec > atv.tv_sec ||
	    time.tv_sec == atv.tv_sec && time.tv_usec >= atv.tv_usec)) {
		splx(s);
		goto done;
	}
	if ((u.u_procp->p_flag & SSEL) == 0 || nselcoll != ncoll) {
		u.u_procp->p_flag &= ~SSEL;
		splx(s);
		goto retry;
	}
	u.u_procp->p_flag &= ~SSEL;
	if (uap->tv) {
		lqsave = u.u_qsave;
		if (setjmp(&u.u_qsave)) {
			u.u_qsave = lqsave;
			untimeout(unselect, (caddr_t)u.u_procp);
			u.u_error = EINTR;
			splx(s);
			goto done;
		}
		timeout(unselect, (caddr_t)u.u_procp, hzto(&atv));
		slumber((caddr_t)&selwait, INTERRUPTABLE, selboost);
		u.u_qsave = lqsave;
		untimeout(unselect, (caddr_t)u.u_procp);
	} else
		slumber((caddr_t)&selwait, INTERRUPTABLE, selboost);
	splx(s);
	goto retry;
done:
#define	putbits(name, x) \
	if (uap->name && ibits[x] != obits[x]) { \
		int error = suword((caddr_t)uap->name, obits[x]); \
		if (error == -1) \
			u.u_error = EFAULT; \
	}
	putbits(in, 0);
	putbits(ou, 1);
	putbits(ex, 2);
#undef putbits
}

unselect(p)
	register struct proc *p;
{
	register int s = spl8();

	switch (p->p_stat) {

	case SSLEEP:
		setrun(p);
		break;

	case SSTOP:
		if (p->p_wchan)
			unsleep(p);
		break;
	}
	splx(s);
}

selscan(ibits, obits)
	register int *ibits, *obits;
{
	register int bits, i;
	register struct file *fp;
	register int n = 0;

	bits = ibits[0];
	obits[0] = 0;
	if (bits) {
		while (i = ffs(bits)) {
			bits &= cbittab[i-1];
			fp = u.u_ofile[i-1];
			if (fp == NULL) {
				u.u_error = EBADF;
				break;
			}
			if ((*fp->f_ops->fo_select)(fp, FREAD)) {
				obits[0] |= sbittab[i-1];
				n++;
			}
		}
	}

	bits = ibits[1];
	obits[1] = 0;
	if (bits) {
		while (i = ffs(bits)) {
			bits &= cbittab[i-1];
			fp = u.u_ofile[i-1];
			if (fp == NULL) {
				u.u_error = EBADF;
				break;
			}
			if ((*fp->f_ops->fo_select)(fp, FWRITE)) {
				obits[1] |= sbittab[i-1];
				n++;
			}
		}
	}

	bits = ibits[2];
	obits[2] = 0;
	if (bits) {
		while (i = ffs(bits)) {
			bits &= cbittab[i-1];
			fp = u.u_ofile[i-1];
			if (fp == NULL) {
				u.u_error = EBADF;
				break;
			}
			if ((*fp->f_ops->fo_select)(fp, 0)) {
				obits[2] |= sbittab[i-1];
				n++;
			}
		}
	}

	return (n);
}

/*ARGSUSED*/
seltrue(dev, flag)
	dev_t dev;
	int flag;
{

	return (1);
}

selwakeup(p, coll)
	register struct proc *p;
	int coll;
{

	if (coll) {
		nselcoll++;
		wakeup((caddr_t)&selwait);
	}
	if (p) {
		int s = spl8();

		if (p->p_wchan == (caddr_t)&selwait) {
			if (p->p_stat == SSLEEP)
				setrun(p);
			else if (p->p_wchan)
				unsleep(p);
		}
		else if (p->p_flag & SSEL)
			p->p_flag &= ~SSEL;
		splx(s);
	}
}
