/* @(#)sys5_uts.c	6.1 */

#include "../sys/param.h"
#include "../sys/buf.h"
#include "../sys/user.h"
#include "../sys/proc.h"
#include "../sys/errno.h"
#include "../sys/utsname.h"
#include "../sys/vfs.h"
#include "../ufs/fs.h"
#include "../ufs/mount.h"

#include "../ml/vmparam.h"


ulimit()
{
	register struct a {
		int	cmd;
		long	arg;
	} *uap;

	uap = (struct a *)u.u_ap;
	switch(uap->cmd) {

/* Set file limit size */
	case 2:
		if (uap->arg > u.u_limit && !suser())
			return;
		u.u_limit = uap->arg;	/* ULIMIT ASSUMES NBPG = 512 */
/* Get file size limit */
	case 1:
		u.u_r.r_val1 = u.u_limit;	/* ULIMIT ASSSUMES NBPG = 512 */
		break;
/* Get maximum possibe break value */
	case 3:
		u.u_r.r_val1 = ctob(MAXDSIZ + u.u_tsize);
		break;

	default:
		u.u_error = EINVAL;
	}
}


utssys()
{
	register struct a {
		char	*cbuf;
		int	dev;
		int	type;
	} *uap = (struct a *)u.u_ap;

	switch(uap->type) {

	case 0:		/* uname */
		u.u_error = copyout((caddr_t)&utsname, (caddr_t)uap->cbuf, 
			sizeof(struct utsname));
		return;

/* case 1 was umask */

	case 2:		/* ustat */
	{
		struct vfs *vfs;
		struct statfs sb;
		struct {
			daddr_t	f_tfree;
			ino_t	f_tinode;
			char	f_fname[6];
			char	f_fpack[6];
		} usb;

		/*
		 * The most likely source of the "dev" here is a "stat" structure.
		 * It's a "short" there.  Unfortunately, it's a "long" before
		 * it gets there, and has its sign bit set when it's an NFS
		 * file system.  Turning it into a "short" and back to a "int"/"long"
		 * smears the sign bit through the upper 16 bits; we have to get
		 * rid of the sign bit.  Yuk.
		 */
		u.u_error = vafsidtovfs((long)(uap->dev & 0xffff), &vfs);
		if (u.u_error)
			return;
		u.u_error = VFS_STATFS(vfs, &sb);
		if (u.u_error)
			return;
		bzero((caddr_t)&usb, sizeof(usb));
		/*
		 * System V defines a block as 512 bytes.
		 */
		usb.f_tfree = sb.f_bavail * (sb.f_bsize/512);
		usb.f_tinode = sb.f_ffree;
		u.u_error = copyout((caddr_t)&usb, (caddr_t)uap->cbuf, sizeof(usb));
		return;
	}

	default:
		u.u_error = EFAULT;
	} /* switch */
}
