/*	ufs_xxx.c	6.1	83/07/29	*/

#include "../sys/param.h"
#include "../sys/systm.h"
#include "../sys/user.h"
#include "../sys/kernel.h"
#include "../sys/vnode.h"
#include "../sys/file.h"
#include "../sys/uio.h"

/*
 * Oh, how backwards compatibility is ugly!!! Need to get
 * the AT&T version of the stat structure.
 */
#include "../sys/attstat.h"

/*
 * The old fstat system call.
 */
fstat()
{
	struct file *fp;
	register struct a {
		int	fd;
		struct stat *sb;
	} *uap = (struct a *)u.u_ap;

	/* u.u_error = getvnodefp(uap->fd, &fp); Can't handle SOCKETS */
	fp = getf(uap->fd);
	if (fp == (struct file *)0) {
		u.u_error = EBADF ;
		return ;
	}
	if (fp->f_type == DTYPE_SOCKET) {
		struct stat ds;
		bzero((caddr_t)&ds, sizeof(ds)); /* someday? */
		copyout((caddr_t)&ds, (caddr_t)uap->sb, sizeof(ds));
		return;
	}
	if (fp->f_type != DTYPE_VNODE) {
	        u.u_error = EINVAL ;
	        return ;
	}
	stat1((struct vnode *)fp->f_data, uap->sb);
}

/*
 * Old stat system call.  This version follows links.
 */
stat()
{
	struct vnode *vp;
	register struct a {
		char	*fname;
		struct stat *sb;
	} *uap;

	uap = (struct a *)u.u_ap;
	u.u_error =
	    lookupname(uap->fname, UIO_USERSPACE, FOLLOW_LINK,
		(struct vnode **)0, &vp);
	if (u.u_error)
		return;
	stat1(vp, uap->sb);
	VN_RELE(vp);
}

stat1(vp, ub)
	register struct vnode *vp;
	struct stat *ub;
{
	struct stat ds;
	struct vattr vattr;

	u.u_error = VOP_GETATTR(vp, &vattr, u.u_cred);
	if (u.u_error)
		return;

	/*
	 * Copy from inode table
	 */
	ds.st_dev = vattr.va_fsid;
	ds.st_ino = vattr.va_nodeid;
	ds.st_mode = vattr.va_mode;
	ds.st_nlink = vattr.va_nlink;
	ds.st_uid = vattr.va_uid;
	ds.st_gid = vattr.va_gid;
	ds.st_rdev = (dev_t)vattr.va_rdev;
	ds.st_size = (int)vattr.va_size;
	ds.st_atime = (int)vattr.va_atime.tv_sec;
	ds.st_mtime = (int)vattr.va_mtime.tv_sec;
	ds.st_ctime = (int)vattr.va_atime.tv_sec;
	u.u_error = copyout((caddr_t)&ds, (caddr_t)ub, sizeof(ds));
}

/*
 * Set IUPD and IACC times on file.
 * Can't set ICHG.
 */
utime()
{
	register struct a {
		char	*fname;
		time_t	*tptr;
	} *uap = (struct a *)u.u_ap;
	struct vattr vattr;
	time_t tv[2];

	if (uap->tptr != NULL) {
		u.u_error = copyin((caddr_t)uap->tptr, (caddr_t)tv, sizeof (tv));
		if (u.u_error)
			return;
	} else {
		tv[0] = time.tv_sec;
		tv[1] = time.tv_sec;
	}

	vattr_null(&vattr);
	vattr.va_atime.tv_sec = tv[0];
	vattr.va_atime.tv_usec = 0;
	vattr.va_mtime.tv_sec = tv[1];
	vattr.va_mtime.tv_usec = 0;
	u.u_error = namesetattr(uap->fname, FOLLOW_LINK, &vattr);
	if ((u.u_error == EPERM) && (uap->tptr == NULL))
		u.u_error = EACCES;
}
