#include "../sys/param.h"
#include "../sys/user.h"
#include "../sys/proc.h"
#include "../sys/text.h"
#include "../sys/vm.h"
#include "../sys/cmap.h"
#include "../ml/pte.h"

/*
 * Extracted and unrolled most common case of pagein (hopefully):
 *	resident and not on free list (reclaim of page is purely
 *	for the purpose of simulating a reference bit)
 */
fastreclaim(virtaddr)
	unsigned virtaddr;
{
	register struct proc *p;
	register struct pte *pte, *tpte;
	register unsigned v;
	register int type;
#if CLSIZE > 1
	register int i;
#endif
	struct cmap c;

	v = clbase(btop(virtaddr));
	p = u.u_procp;
	if (isatsv(p, v)) {
		pte = tptopte(p, vtotp(p, v));
		type = CTEXT;
	}
	else if (isadsv(p, v)) {
		pte = dptopte(p, vtodp(p, v));
		type = CDATA;
		if(*(int *)pte & PG_N)
			type = CSHMEM;
	}
	else {
		pte = sptopte(p, vtosp(p, v));
	 	type = CSTACK;
	}
	if (pte->pg_v || pte->pg_fod)
		return 0; 		/* let pagein handle it */
	if (pte->pg_pfnum == 0)
		return 0; 		/* let pagein handle it */
	c = cmap[pgtocm(pte->pg_pfnum)];
	if (type == CTEXT && c.c_intrans)
		return 0; 		/* let pagein handle it */
	if (type == CSHMEM && c.c_intrans)
		return 0; 		/* let pagein handle it */
	if (c.c_free)
		return 0; 		/* let pagein handle it */

	pte->pg_v = 1;
	uncache (pte);
	if (anycl(pte, pg_m))
		pte->pg_m = 1;
	distcl(pte);
	tbiscl(v);
	if (type == CTEXT)
		for (p = p->p_textp->x_caddr; p; ) {
			tpte = tptopte(p, vtotp(p, v));
			p->p_flag |= SPTECHG;
#if CLSIZE > 1
			for (i = 0; i < CLSIZE; i++)
				tpte[i] = pte[i];
#else
			*tpte = *pte;
#endif
			p = p->p_xlink;
		 }
	else if (type == CSHMEM)
		dishmpte(&shmem[c.c_ndx], c.c_page, pte);
	/* collect a few statistics... */
	u.u_ru.ru_minflt++;
	cnt.v_faults++;
	cnt.v_pgrec++;
	cnt.v_fastpgrec++;
	cnt.v_trap++;
	return 1;
}
