# @(#)rpc.mk	6.6

LIBNAME = 	../lib_rpc
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(auth_kern.o) \
	$(LIBNAME)(authunix_prot.o) \
	$(LIBNAME)(clnt_kudp.o) \
	$(LIBNAME)(clnt_perror.o) \
	$(LIBNAME)(kudp_fastsend.o) \
	$(LIBNAME)(pmap_kgetport.o) \
	$(LIBNAME)(pmap_prot.o) \
	$(LIBNAME)(rpc_prot.o) \
	$(LIBNAME)(rpc_callmsg.o) \
	$(LIBNAME)(subr_kudp.o) \
	$(LIBNAME)(svc.o) \
	$(LIBNAME)(svc_auth.o) \
	$(LIBNAME)(svc_auth_unix.o) \
	$(LIBNAME)(svc_kudp.o) \
	$(LIBNAME)(xdr.o) \
	$(LIBNAME)(xdr_array.o) \
	$(LIBNAME)(xdr_mbuf.o) \
	$(LIBNAME)(xdr_mem.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp rpc.mk rpc.mk.bak
	@ed - rpc.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_rpc(auth_kern.o): ../ml/param.h ../ml/pcb.h \
	../netinet/in.h ../rpc/auth.h ../rpc/auth_unix.h ../rpc/types.h \
	../rpc/xdr.h ../sys/async.h ../sys/bsem.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h 

../lib_rpc(authunix_prot.o): ../ml/param.h ../ml/pcb.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/types.h ../rpc/xdr.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/kernel.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/systm.h ../sys/time.h ../sys/types.h ../sys/uio.h \
	../sys/user.h 

../lib_rpc(clnt_kudp.o): ../ml/param.h ../ml/pcb.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../netinet/in.h \
	../netinet/in_pcb.h ../rpc/auth.h ../rpc/clnt.h \
	../rpc/rpc_msg.h ../rpc/types.h ../rpc/xdr.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/kernel.h ../sys/mbuf.h ../sys/param.h ../sys/proc.h \
	../sys/resource.h ../sys/sem.h ../sys/shm.h ../sys/signal.h \
	../sys/socket.h ../sys/socketvar.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h 

../lib_rpc(clnt_perror.o): ../rpc/auth.h ../rpc/clnt.h \
	../rpc/types.h ../sys/types.h 

../lib_rpc(kudp_fastsend.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../netinet/if_ether.h \
	../netinet/in.h ../netinet/in_pcb.h ../netinet/in_systm.h \
	../netinet/ip.h ../netinet/ip_var.h ../netinet/udp.h \
	../sys/errno.h ../sys/fcntl.h ../sys/file.h ../sys/mbuf.h \
	../sys/param.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/types.h 

../lib_rpc(pmap_kgetport.o): ../ml/param.h ../ml/pcb.h \
	../net/if.h ../net/if_arp.h ../netinet/in.h ../rpc/auth.h \
	../rpc/clnt.h ../rpc/pmap_prot.h ../rpc/rpc_msg.h \
	../rpc/types.h ../rpc/xdr.h ../sys/async.h ../sys/bsem.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/socket.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h 

../lib_rpc(pmap_prot.o): ../rpc/pmap_prot.h ../rpc/types.h \
	../rpc/xdr.h ../sys/types.h 

../lib_rpc(rpc_prot.o): ../ml/param.h ../netinet/in.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h \
	../rpc/rpc_msg.h ../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h \
	../rpc/xdr.h ../sys/param.h ../sys/signal.h ../sys/types.h 

../lib_rpc(rpc_callmsg.o): ../ml/param.h ../netinet/in.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h \
	../rpc/rpc_msg.h ../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h \
	../rpc/xdr.h ../sys/param.h ../sys/signal.h ../sys/types.h 

../lib_rpc(subr_kudp.o): ../ml/param.h ../net/if.h \
	../net/if_arp.h ../net/route.h ../netinet/in.h \
	../netinet/in_pcb.h ../rpc/auth.h ../rpc/clnt.h ../rpc/types.h \
	../rpc/xdr.h ../sys/kernel.h ../sys/mbuf.h ../sys/param.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/time.h ../sys/types.h 

../lib_rpc(svc.o): ../ml/param.h ../netinet/in.h ../rpc/auth.h \
	../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h ../rpc/rpc_msg.h \
	../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h ../rpc/xdr.h \
	../sys/param.h ../sys/signal.h ../sys/socket.h \
	../sys/socketvar.h ../sys/time.h ../sys/types.h 

../lib_rpc(svc_auth.o): ../ml/param.h ../netinet/in.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h \
	../rpc/rpc_msg.h ../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h \
	../rpc/xdr.h ../sys/param.h ../sys/signal.h ../sys/types.h 

../lib_rpc(svc_auth_unix.o): ../ml/param.h ../netinet/in.h \
	../rpc/auth.h ../rpc/auth_unix.h ../rpc/clnt.h ../rpc/rpc.h \
	../rpc/rpc_msg.h ../rpc/svc.h ../rpc/svc_auth.h ../rpc/types.h \
	../rpc/xdr.h ../sys/kernel.h ../sys/param.h ../sys/signal.h \
	../sys/time.h ../sys/types.h 

../lib_rpc(svc_kudp.o): ../ml/param.h ../netinet/in.h \
	../rpc/auth.h ../rpc/clnt.h ../rpc/rpc_msg.h ../rpc/svc.h \
	../rpc/types.h ../rpc/xdr.h ../sys/mbuf.h ../sys/param.h \
	../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/types.h 

../lib_rpc(xdr.o): ../ml/param.h ../rpc/types.h ../rpc/xdr.h \
	../sys/param.h ../sys/signal.h ../sys/systm.h ../sys/types.h 

../lib_rpc(xdr_array.o): ../ml/param.h ../rpc/types.h \
	../rpc/xdr.h ../sys/param.h ../sys/signal.h ../sys/systm.h \
	../sys/types.h 

../lib_rpc(xdr_mbuf.o): ../ml/param.h ../netinet/in.h \
	../rpc/types.h ../rpc/xdr.h ../sys/mbuf.h ../sys/param.h \
	../sys/signal.h ../sys/types.h ../sys/uio.h 

../lib_rpc(xdr_mem.o): ../ml/param.h ../netinet/in.h \
	../rpc/types.h ../rpc/xdr.h ../sys/param.h ../sys/signal.h \
	../sys/types.h 
