# @(#)nfs.mk	6.6

LIBNAME = 	../lib_specfs
CFLAGS = 	-DKERNEL $(CFL)

FILES = \
	$(LIBNAME)(bdev_vnodeops.o) \
	$(LIBNAME)(spec_subr.o) \
	$(LIBNAME)(spec_vnodeops.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp specfs.mk specfs.mk.bak
	@ed - specfs.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_specfs(bdev_vnodeops.o): ../ml/param.h ../ml/pcb.h \
	../sys/buf.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/param.h ../sys/resource.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 

../lib_specfs(spec_subr.o): ../ml/clock.h ../ml/param.h \
	../ml/pcb.h ../specfs/snode.h ../sys/dmap.h ../sys/errno.h \
	../sys/kernel.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/user.h ../sys/vfs.h ../sys/vnode.h 

../lib_specfs(spec_vnodeops.o): ../krpc/lockmgr.h ../ml/param.h \
	../ml/pcb.h ../specfs/snode.h ../sys/buf.h ../sys/cmap.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/fcntl.h \
	../sys/file.h ../sys/kernel.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/tty.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 
