# @(#)ufs.mk	6.6

LIBNAME = 	../lib_ufs

CFLAGS = 	-DKERNEL -DQUOTA $(CFL)

FILES = \
	$(LIBNAME)(quota.o) \
	$(LIBNAME)(quota_syscalls.o) \
	$(LIBNAME)(quota_ufs.o) \
	$(LIBNAME)(ufs_alloc.o) \
	$(LIBNAME)(ufs_bmap.o) \
	$(LIBNAME)(ufs_dir.o) \
	$(LIBNAME)(ufs_inode.o) \
	$(LIBNAME)(ufs_lockctl.o) \
	$(LIBNAME)(ufs_subr.o) \
	$(LIBNAME)(ufs_tables.o) \
	$(LIBNAME)(ufs_vfsops.o) \
	$(LIBNAME)(ufs_vnodeops.o)

all:	$(LIBNAME)

.PRECIOUS:	$(LIBNAME)

$(LIBNAME):	$(FILES)

install:
	-chmod 664 $(LIBNAME)
	-chgrp bin $(LIBNAME)
	-chown bin $(LIBNAME)

.c.a:
	@echo "          "$*.c
	@$(CC) -S `echo $(CFLAGS) | sed 's/-O//'` $*.c
	@../inline/inline $*.s $*.i
	@if ( expr "$(CFLAGS)" : '.*-O' ) > /dev/null ; then \
		if ( expr "$(CFLAGS)" : '.*-g' ) > /dev/null ; then : ; else \
			$(C2) $*.i $*.s ; \
			if [ $$? != 0 ] ; then \
				exit 1 ; \
			fi ; \
			mv $*.s $*.i ; \
		fi ; \
	fi
	@$(AS) -o $*.o $*.i
	@ar r $@ $*.o
	@-rm -f $*.o $*.s $*.i

clean:
	-rm -f *.o lintfiles

clobber:	clean
	-rm -f $(LIBNAME)

lint:
	@echo ' $(FILES)' | \
	sed -e 's/ [^(]*(\([^)]*\)\.o)/ \1.c/g' > lintfiles

depend:
	@../cf/osdep "$(FILES)" > makedep
	@echo '/^# DO NOT DELETE THIS LINE/+1,$$d' >eddep
	@echo '$$r makedep' >>eddep
	@echo 'w' >>eddep
	@cp ufs.mk ufs.mk.bak
	@ed - ufs.mk < eddep
	@rm eddep makedep

# DO NOT DELETE THIS LINE - make depend uses it

../lib_ufs(quota.o): ../ml/param.h ../ml/pcb.h ../sys/async.h \
	../sys/bsem.h ../sys/dmap.h ../sys/errno.h ../sys/ipc.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h ../ufs/fs.h ../ufs/inode.h ../ufs/mount.h \
	../ufs/quota.h 

../lib_ufs(quota_syscalls.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/dmap.h ../sys/errno.h \
	../sys/ipc.h ../sys/param.h ../sys/proc.h ../sys/resource.h \
	../sys/sem.h ../sys/shm.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/uio.h ../sys/user.h \
	../sys/vfs.h ../sys/vnode.h ../ufs/fs.h ../ufs/inode.h \
	../ufs/mount.h ../ufs/quota.h 

../lib_ufs(quota_ufs.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/dmap.h \
	../sys/errno.h ../sys/ipc.h ../sys/kernel.h ../sys/param.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h ../ufs/mount.h ../ufs/quota.h 

../lib_ufs(ufs_alloc.o): ../ml/param.h ../ml/pcb.h ../sys/buf.h \
	../sys/conf.h ../sys/dmap.h ../sys/errno.h ../sys/kernel.h \
	../sys/param.h ../sys/resource.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h ../ufs/fs.h ../ufs/inode.h ../ufs/mount.h 

../lib_ufs(ufs_bmap.o): ../ml/clock.h ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/conf.h \
	../sys/dmap.h ../sys/errno.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/uio.h ../sys/user.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h 

../lib_ufs(ufs_dir.o): ../ml/param.h ../ml/pcb.h ../sys/buf.h \
	../sys/dmap.h ../sys/dnlc.h ../sys/errno.h ../sys/kernel.h \
	../sys/param.h ../sys/resource.h ../sys/signal.h \
	../sys/sysinfo.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/fsdir.h ../ufs/inode.h ../ufs/mount.h \
	../ufs/quota.h 

../lib_ufs(ufs_inode.o): ../ml/clock.h ../ml/param.h ../ml/pcb.h \
	../sys/buf.h ../sys/cmap.h ../sys/dmap.h ../sys/errno.h \
	../sys/kernel.h ../sys/param.h ../sys/resource.h \
	../sys/signal.h ../sys/sysinfo.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h ../ufs/mount.h ../ufs/quota.h 

../lib_ufs(ufs_lockctl.o): ../krpc/lockmgr.h ../ml/param.h \
	../ml/pcb.h ../sys/dmap.h ../sys/errno.h ../sys/kernel.h \
	../sys/param.h ../sys/resource.h ../sys/signal.h ../sys/systm.h \
	../sys/time.h ../sys/types.h ../sys/user.h ../sys/vfs.h \
	../sys/vnode.h 

../lib_ufs(ufs_subr.o): ../ml/param.h ../ml/pcb.h ../sys/buf.h \
	../sys/dmap.h ../sys/errno.h ../sys/kernel.h ../sys/param.h \
	../sys/resource.h ../sys/signal.h ../sys/systm.h ../sys/time.h \
	../sys/types.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h ../ufs/mount.h 

../lib_ufs(ufs_tables.o): ../ml/param.h ../sys/param.h \
	../sys/signal.h ../sys/types.h 

../lib_ufs(ufs_vfsops.o): ../ml/param.h ../ml/pcb.h \
	../sys/async.h ../sys/bsem.h ../sys/buf.h ../sys/conf.h \
	../sys/dmap.h ../sys/errno.h ../sys/fcntl.h ../sys/file.h \
	../sys/ipc.h ../sys/mount.h ../sys/param.h ../sys/pathname.h \
	../sys/proc.h ../sys/resource.h ../sys/sem.h ../sys/shm.h \
	../sys/signal.h ../sys/systm.h ../sys/time.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/inode.h ../ufs/mount.h 

../lib_ufs(ufs_vnodeops.o): ../ml/clock.h ../ml/param.h \
	../ml/pcb.h ../sys/async.h ../sys/bsem.h ../sys/buf.h \
	../sys/cmap.h ../sys/conf.h ../sys/dmap.h ../sys/errno.h \
	../sys/fcntl.h ../sys/file.h ../sys/ipc.h ../sys/kernel.h \
	../sys/param.h ../sys/proc.h ../sys/resource.h ../sys/sem.h \
	../sys/shm.h ../sys/signal.h ../sys/socket.h ../sys/socketvar.h \
	../sys/systm.h ../sys/time.h ../sys/tty.h ../sys/types.h \
	../sys/uio.h ../sys/user.h ../sys/vfs.h ../sys/vnode.h \
	../ufs/fs.h ../ufs/fsdir.h ../ufs/inode.h ../ufs/mount.h \
	../ufs/quota.h 
